#include <stdio.h>
#include "flib/rta.h"
#include "test_common.h"

enum rta_sec_era rta_sec_era;

int test_op_proto(uint32_t *buff)
{
	struct program prg;
	struct program *program = &prg;
	int size;

	PROGRAM_CNTXT_INIT(buff, 0);

	/* RSA */

	/* Decrypt, no key encryption, no secret encryption */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC |
		      OP_PCL_RSAPROT_FMT_PKCSV15));

	/* Decrypt, no key encryption, secret encryption nrm */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_FFF_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_FFF_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_FFF_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_FFF_ENC |
		      OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_FFF_ENC |
		      OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_FFF_ENC |
		      OP_PCL_RSAPROT_FMT_PKCSV15));

	/* Decrypt, no key encryption, secret encryption ekt */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_FFF_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_FFF_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_FFF_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_FFF_EKT |
		      OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_FFF_EKT |
		      OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_FFF_EKT |
		      OP_PCL_RSAPROT_FMT_PKCSV15));

	/* Decrypt, no key encryption, secret encryption nrm-tk */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_FFF_TK_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_FFF_TK_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC |
		      OP_PCL_RSAPROT_FFF_TK_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_FFF_TK_ENC |
		      OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_FFF_TK_ENC |
		      OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_FFF_TK_ENC
		      | OP_PCL_RSAPROT_FMT_PKCSV15));

	/* Decrypt, no key encryption, secret encryption ekt-tk */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_FFF_TK_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_FFF_TK_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC |
		      OP_PCL_RSAPROT_FFF_TK_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_FFF_TK_EKT |
		      OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_FFF_TK_EKT |
		      OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_FFF_TK_EKT
		      | OP_PCL_RSAPROT_FMT_PKCSV15));

	/* Decrypt, key(nrm), no secret encryption */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_ENC |
		      OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_ENC |
		      OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_ENC |
		      OP_PCL_RSAPROT_FMT_PKCSV15));

	/* Decrypt, key(nrm), secret(nrm) */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_ENC |
		      OP_PCL_RSAPROT_FFF_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_ENC |
		      OP_PCL_RSAPROT_FFF_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_ENC |
		      OP_PCL_RSAPROT_FFF_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_ENC |
		      OP_PCL_RSAPROT_FFF_ENC | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_ENC |
		      OP_PCL_RSAPROT_FFF_ENC | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_ENC |
		      OP_PCL_RSAPROT_FFF_ENC | OP_PCL_RSAPROT_FMT_PKCSV15));

	/* Decrypt, key(nrm), secret(ekt) */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_ENC |
		      OP_PCL_RSAPROT_FFF_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_ENC |
		      OP_PCL_RSAPROT_FFF_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_ENC |
		      OP_PCL_RSAPROT_FFF_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_ENC |
		      OP_PCL_RSAPROT_FFF_EKT | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_ENC |
		      OP_PCL_RSAPROT_FFF_EKT | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_ENC |
		      OP_PCL_RSAPROT_FFF_EKT | OP_PCL_RSAPROT_FMT_PKCSV15));

	/* Decrypt, key(nrm), secret(nrm-tk) */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_ENC |
		      OP_PCL_RSAPROT_FFF_TK_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_ENC |
		      OP_PCL_RSAPROT_FFF_TK_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_ENC |
		      OP_PCL_RSAPROT_FFF_TK_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_ENC |
		      OP_PCL_RSAPROT_FFF_TK_ENC | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_ENC |
		      OP_PCL_RSAPROT_FFF_TK_ENC | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_ENC |
		      OP_PCL_RSAPROT_FFF_TK_ENC | OP_PCL_RSAPROT_FMT_PKCSV15));

	/* Decrypt, key(nrm), secret(ekt-tk) */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_ENC |
		      OP_PCL_RSAPROT_FFF_TK_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_ENC |
		      OP_PCL_RSAPROT_FFF_TK_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_ENC |
		      OP_PCL_RSAPROT_FFF_TK_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_ENC |
		      OP_PCL_RSAPROT_FFF_TK_EKT | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_ENC |
		      OP_PCL_RSAPROT_FFF_TK_EKT | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_ENC |
		      OP_PCL_RSAPROT_FFF_TK_EKT | OP_PCL_RSAPROT_FMT_PKCSV15));

	/* Decrypt, key(ekt), no secret encryption */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_EKT |
		      OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_EKT |
		      OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_EKT |
		      OP_PCL_RSAPROT_FMT_PKCSV15));

	/* Decrypt, key(ekt), secret(nrm) */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_EKT |
		      OP_PCL_RSAPROT_FFF_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_EKT |
		      OP_PCL_RSAPROT_FFF_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_EKT |
		      OP_PCL_RSAPROT_FFF_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_EKT |
		      OP_PCL_RSAPROT_FFF_ENC | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_EKT |
		      OP_PCL_RSAPROT_FFF_ENC | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_EKT |
		      OP_PCL_RSAPROT_FFF_ENC | OP_PCL_RSAPROT_FMT_PKCSV15));

	/* Decrypt, key(ekt), secret(ekt) */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_EKT |
		      OP_PCL_RSAPROT_FFF_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_EKT |
		      OP_PCL_RSAPROT_FFF_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_EKT |
		      OP_PCL_RSAPROT_FFF_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_EKT |
		      OP_PCL_RSAPROT_FFF_EKT | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_EKT |
		      OP_PCL_RSAPROT_FFF_EKT | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_EKT |
		      OP_PCL_RSAPROT_FFF_EKT | OP_PCL_RSAPROT_FMT_PKCSV15));

	/* Decrypt, key(ekt), secret(nrm-tk) */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_EKT |
		      OP_PCL_RSAPROT_FFF_TK_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_EKT |
		      OP_PCL_RSAPROT_FFF_TK_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_EKT |
		      OP_PCL_RSAPROT_FFF_TK_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_EKT |
		      OP_PCL_RSAPROT_FFF_TK_ENC | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_EKT |
		      OP_PCL_RSAPROT_FFF_TK_ENC | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_EKT |
		      OP_PCL_RSAPROT_FFF_TK_ENC | OP_PCL_RSAPROT_FMT_PKCSV15));

	/* Decrypt, key(ekt), secret(ekt-tk) */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_EKT |
		      OP_PCL_RSAPROT_FFF_TK_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_EKT |
		      OP_PCL_RSAPROT_FFF_TK_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_EKT |
		      OP_PCL_RSAPROT_FFF_TK_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_EKT |
		      OP_PCL_RSAPROT_FFF_TK_EKT | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_EKT |
		      OP_PCL_RSAPROT_FFF_TK_EKT | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_EKT |
		      OP_PCL_RSAPROT_FFF_TK_EKT | OP_PCL_RSAPROT_FMT_PKCSV15));

	/* Decrypt, key(nrm-tk), no secret encryption */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_TK_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_TK_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC |
		      OP_PCL_RSAPROT_PPP_TK_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_TK_ENC |
		      OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_TK_ENC |
		      OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_TK_ENC
		      | OP_PCL_RSAPROT_FMT_PKCSV15));

	/* Decrypt, key(nrm-tk), secret(nrm) */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_TK_ENC |
		      OP_PCL_RSAPROT_FFF_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_TK_ENC |
		      OP_PCL_RSAPROT_FFF_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_TK_ENC
		      | OP_PCL_RSAPROT_FFF_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_TK_ENC |
		      OP_PCL_RSAPROT_FFF_ENC | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_TK_ENC |
		      OP_PCL_RSAPROT_FFF_ENC | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_TK_ENC
		      | OP_PCL_RSAPROT_FFF_ENC | OP_PCL_RSAPROT_FMT_PKCSV15));

	/* Decrypt, key(nrm-tk), secret(ekt) */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_TK_ENC |
		      OP_PCL_RSAPROT_FFF_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_TK_ENC |
		      OP_PCL_RSAPROT_FFF_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_TK_ENC
		      | OP_PCL_RSAPROT_FFF_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_TK_ENC |
		      OP_PCL_RSAPROT_FFF_EKT | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_TK_ENC |
		      OP_PCL_RSAPROT_FFF_EKT | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_TK_ENC
		      | OP_PCL_RSAPROT_FFF_EKT | OP_PCL_RSAPROT_FMT_PKCSV15));

	/* Decrypt, key(nrm-tk), secret(nrm-tk) */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_TK_ENC |
		      OP_PCL_RSAPROT_FFF_TK_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_TK_ENC |
		      OP_PCL_RSAPROT_FFF_TK_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_TK_ENC
		      | OP_PCL_RSAPROT_FFF_TK_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_TK_ENC |
		      OP_PCL_RSAPROT_FFF_TK_ENC | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_TK_ENC |
		      OP_PCL_RSAPROT_FFF_TK_ENC | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_TK_ENC
		      | OP_PCL_RSAPROT_FFF_TK_ENC |
		      OP_PCL_RSAPROT_FMT_PKCSV15));

	/* Decrypt, key(nrm-tk), secret(ekt-tk) */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_TK_ENC |
		      OP_PCL_RSAPROT_FFF_TK_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_TK_ENC |
		      OP_PCL_RSAPROT_FFF_TK_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_TK_ENC
		      | OP_PCL_RSAPROT_FFF_TK_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_TK_ENC |
		      OP_PCL_RSAPROT_FFF_TK_EKT | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_TK_ENC |
		      OP_PCL_RSAPROT_FFF_TK_EKT | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_TK_ENC
		      | OP_PCL_RSAPROT_FFF_TK_EKT |
		      OP_PCL_RSAPROT_FMT_PKCSV15));

	/* Decrypt, key(ekt-tk), no secret encryption */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_TK_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_TK_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC |
		      OP_PCL_RSAPROT_PPP_TK_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_TK_EKT |
		      OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_TK_EKT |
		      OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_TK_EKT
		      | OP_PCL_RSAPROT_FMT_PKCSV15));

	/* Decrypt, key(ekt-tk), secret(nrm) */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_TK_EKT |
		      OP_PCL_RSAPROT_FFF_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_TK_EKT |
		      OP_PCL_RSAPROT_FFF_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_TK_EKT
		      | OP_PCL_RSAPROT_FFF_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_TK_EKT |
		      OP_PCL_RSAPROT_FFF_ENC | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_TK_EKT |
		      OP_PCL_RSAPROT_FFF_ENC | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_TK_EKT
		      | OP_PCL_RSAPROT_FFF_ENC | OP_PCL_RSAPROT_FMT_PKCSV15));

	/* Decrypt, key(ekt-tk), secret(ekt) */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_TK_EKT |
		      OP_PCL_RSAPROT_FFF_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_TK_EKT |
		      OP_PCL_RSAPROT_FFF_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_TK_EKT
		      | OP_PCL_RSAPROT_FFF_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_TK_EKT |
		      OP_PCL_RSAPROT_FFF_EKT | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_TK_EKT |
		      OP_PCL_RSAPROT_FFF_EKT | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_TK_EKT
		      | OP_PCL_RSAPROT_FFF_EKT | OP_PCL_RSAPROT_FMT_PKCSV15));

	/* Decrypt, key(ekt-tk), secret(nrm-tk) */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_TK_EKT |
		      OP_PCL_RSAPROT_FFF_TK_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_TK_EKT |
		      OP_PCL_RSAPROT_FFF_TK_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_TK_EKT
		      | OP_PCL_RSAPROT_FFF_TK_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_TK_EKT |
		      OP_PCL_RSAPROT_FFF_TK_ENC | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_TK_EKT |
		      OP_PCL_RSAPROT_FFF_TK_ENC | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_TK_EKT
		      | OP_PCL_RSAPROT_FFF_TK_ENC |
		      OP_PCL_RSAPROT_FMT_PKCSV15));

	/* Decrypt, key(ekt-tk), secret(ekt-tk) */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_TK_EKT |
		      OP_PCL_RSAPROT_FFF_TK_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_TK_EKT |
		      OP_PCL_RSAPROT_FFF_TK_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_TK_EKT
		      | OP_PCL_RSAPROT_FFF_TK_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_ND | OP_PCL_RSAPROT_PPP_TK_EKT |
		      OP_PCL_RSAPROT_FFF_TK_EKT | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQD | OP_PCL_RSAPROT_PPP_TK_EKT |
		      OP_PCL_RSAPROT_FFF_TK_EKT | OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSADECRYPT,
		 WITH(OP_PCL_RSAPROT_OP_DEC_PQDPDQC | OP_PCL_RSAPROT_PPP_TK_EKT
		      | OP_PCL_RSAPROT_FFF_TK_EKT |
		      OP_PCL_RSAPROT_FMT_PKCSV15));

	/* Encrypt, F in */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSAENCRYPT,
		 WITH(OP_PCL_RSAPROT_OP_ENC_F_IN));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSAENCRYPT,
		 WITH(OP_PCL_RSAPROT_OP_ENC_F_IN | OP_PCL_RSAPROT_FMT_PKCSV15));
	/* Encrypt, F out */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSAENCRYPT,
		 WITH(OP_PCL_RSAPROT_OP_ENC_F_OUT | OP_PCL_RSAPROT_PPP_RED));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSAENCRYPT,
		 WITH(OP_PCL_RSAPROT_OP_ENC_F_OUT |
		      OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSAENCRYPT,
		 WITH(OP_PCL_RSAPROT_OP_ENC_F_OUT | OP_PCL_RSAPROT_FFF_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSAENCRYPT,
		 WITH(OP_PCL_RSAPROT_OP_ENC_F_OUT | OP_PCL_RSAPROT_FFF_ENC |
		      OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSAENCRYPT,
		 WITH(OP_PCL_RSAPROT_OP_ENC_F_OUT | OP_PCL_RSAPROT_FFF_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSAENCRYPT,
		 WITH(OP_PCL_RSAPROT_OP_ENC_F_OUT | OP_PCL_RSAPROT_FFF_EKT |
		      OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSAENCRYPT,
		 WITH(OP_PCL_RSAPROT_OP_ENC_F_OUT | OP_PCL_RSAPROT_FFF_TK_ENC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSAENCRYPT,
		 WITH(OP_PCL_RSAPROT_OP_ENC_F_OUT | OP_PCL_RSAPROT_FFF_TK_ENC |
		      OP_PCL_RSAPROT_FMT_PKCSV15));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSAENCRYPT,
		 WITH(OP_PCL_RSAPROT_OP_ENC_F_OUT | OP_PCL_RSAPROT_FFF_TK_EKT));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_RSAENCRYPT,
		 WITH(OP_PCL_RSAPROT_OP_ENC_F_OUT | OP_PCL_RSAPROT_FFF_TK_EKT |
		      OP_PCL_RSAPROT_FMT_PKCSV15));

	/* Diffie-Hellman */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN, 0);
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_DECRYPT_Z));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_DECRYPT_Z | OP_PCL_PKPROT_EKT_Z));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_DECRYPT_Z));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_DECRYPT_Z |
		      OP_PCL_PKPROT_EKT_Z));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI |
		      OP_PCL_PKPROT_DECRYPT_Z));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI |
		      OP_PCL_PKPROT_DECRYPT_Z | OP_PCL_PKPROT_EKT_Z));

	/* F2m -- rare */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_F2M));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DECRYPT_Z));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DECRYPT_Z |
		      OP_PCL_PKPROT_EKT_Z));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DECRYPT_PRI |
		      OP_PCL_PKPROT_DECRYPT_Z));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DECRYPT_PRI |
		      OP_PCL_PKPROT_DECRYPT_Z | OP_PCL_PKPROT_EKT_Z));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DECRYPT_PRI |
		      OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DECRYPT_PRI |
		      OP_PCL_PKPROT_EKT_PRI | OP_PCL_PKPROT_DECRYPT_Z));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DECRYPT_PRI |
		      OP_PCL_PKPROT_EKT_PRI | OP_PCL_PKPROT_DECRYPT_Z |
		      OP_PCL_PKPROT_EKT_Z));

	/* ECC Diffie-Hellman  */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_ECC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DECRYPT_Z));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DECRYPT_Z |
		      OP_PCL_PKPROT_EKT_Z));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DECRYPT_PRI |
		      OP_PCL_PKPROT_DECRYPT_Z));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DECRYPT_PRI |
		      OP_PCL_PKPROT_DECRYPT_Z | OP_PCL_PKPROT_EKT_Z));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DECRYPT_PRI |
		      OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DECRYPT_PRI |
		      OP_PCL_PKPROT_EKT_PRI | OP_PCL_PKPROT_DECRYPT_Z));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DECRYPT_PRI |
		      OP_PCL_PKPROT_EKT_PRI | OP_PCL_PKPROT_DECRYPT_Z |
		      OP_PCL_PKPROT_EKT_Z));
	/* F2m */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DECRYPT_Z));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DECRYPT_Z | OP_PCL_PKPROT_EKT_Z));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_DECRYPT_Z));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_DECRYPT_Z |
		      OP_PCL_PKPROT_EKT_Z));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI |
		      OP_PCL_PKPROT_DECRYPT_Z));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DIFFIEHELLMAN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI |
		      OP_PCL_PKPROT_DECRYPT_Z | OP_PCL_PKPROT_EKT_Z));

	/* DLC / ECC Keypair Generation */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_PUBLICKEYPAIR, 0);
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_PUBLICKEYPAIR,
		 WITH(OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_PUBLICKEYPAIR,
		 WITH(OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));

	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_PUBLICKEYPAIR,
		 WITH(OP_PCL_PKPROT_F2M));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_PUBLICKEYPAIR,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_PUBLICKEYPAIR,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DECRYPT_PRI |
		      OP_PCL_PKPROT_EKT_PRI));

	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_PUBLICKEYPAIR,
		 WITH(OP_PCL_PKPROT_ECC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_PUBLICKEYPAIR,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_PUBLICKEYPAIR,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DECRYPT_PRI |
		      OP_PCL_PKPROT_EKT_PRI));

	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_PUBLICKEYPAIR,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_ECC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_PUBLICKEYPAIR,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_ECC |
		      OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_PUBLICKEYPAIR,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_ECC |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));

	/* DSA SIGN and ECDSA SIGN */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN, 0);
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_MD5));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_MD5 |
		      OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_MD5 |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA1));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA1 |
		      OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA1 |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA256));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA256 |
		      OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA256 |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA384));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA384 |
		      OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA384 |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA512));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA512 |
		      OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA512 |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));

	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_F2M));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DECRYPT_PRI |
		      OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_MD5));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_MD5 | OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_MD5 | OP_PCL_PKPROT_DECRYPT_PRI |
		      OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA1));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA1 | OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA1 | OP_PCL_PKPROT_DECRYPT_PRI |
		      OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA256));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA256 | OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA256 | OP_PCL_PKPROT_DECRYPT_PRI |
		      OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA384));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA384 | OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA384 | OP_PCL_PKPROT_DECRYPT_PRI |
		      OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA512));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA512 | OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA512 | OP_PCL_PKPROT_DECRYPT_PRI |
		      OP_PCL_PKPROT_EKT_PRI));

	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DECRYPT_PRI |
		      OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_MD5));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_MD5 | OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_MD5 | OP_PCL_PKPROT_DECRYPT_PRI |
		      OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA1));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA1 | OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA1 | OP_PCL_PKPROT_DECRYPT_PRI |
		      OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA256));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA256 | OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA256 | OP_PCL_PKPROT_DECRYPT_PRI |
		      OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA384));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA384 | OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA384 | OP_PCL_PKPROT_DECRYPT_PRI |
		      OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA512));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA512 | OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA512 | OP_PCL_PKPROT_DECRYPT_PRI |
		      OP_PCL_PKPROT_EKT_PRI));

	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_MD5));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_MD5 |
		      OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_MD5 |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA1));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA1 |
		      OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA1 |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA256));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA256 |
		      OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA256 |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA384));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA384 |
		      OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA384 |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA512));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA512 |
		      OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA512 |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));

	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_DECRYPT_PRI |
		      OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_MD5));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_MD5 | OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_MD5 | OP_PCL_PKPROT_DECRYPT_PRI |
		      OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA1));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA1 | OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA1 | OP_PCL_PKPROT_DECRYPT_PRI |
		      OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA256));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA256 | OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA256 | OP_PCL_PKPROT_DECRYPT_PRI |
		      OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA384));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA384 | OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA384 | OP_PCL_PKPROT_DECRYPT_PRI |
		      OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA512));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA512 | OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA512 | OP_PCL_PKPROT_DECRYPT_PRI |
		      OP_PCL_PKPROT_EKT_PRI));

	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_F2M));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_MD5));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_MD5 |
		      OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_MD5 |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA1));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA1 |
		      OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA1 |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA256));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA256 |
		      OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA256 |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA384));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA384 |
		      OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA384 |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA512));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA512 |
		      OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA512 |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));

	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC |
		      OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_MD5));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_MD5 |
		      OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_MD5 |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA1));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA1 |
		      OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA1 |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA256));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA256 |
		      OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA256 |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA384));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA384 |
		      OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA384 |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA512));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA512 |
		      OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA512 |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));

	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC |
		      OP_PCL_PKPROT_F2M));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M
		      | OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M
		      | OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M
		      | OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_MD5));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M
		      | OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_MD5 |
		      OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M
		      | OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_MD5 |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M
		      | OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA1));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M
		      | OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA1 |
		      OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M
		      | OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA1 |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M
		      | OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA256));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M
		      | OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA256 |
		      OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M
		      | OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA256 |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M
		      | OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA384));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M
		      | OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA384 |
		      OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M
		      | OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA384 |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M
		      | OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA512));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M
		      | OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA512 |
		      OP_PCL_PKPROT_DECRYPT_PRI));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSASIGN,
		 WITH(OP_PCL_PKPROT_TEST | OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M
		      | OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA512 |
		      OP_PCL_PKPROT_DECRYPT_PRI | OP_PCL_PKPROT_EKT_PRI));

	/* DSA VERIFY and ECDSA VERIFY */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSAVERIFY, 0);
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSAVERIFY,
		 WITH(OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_MD5));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSAVERIFY,
		 WITH(OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA1));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSAVERIFY,
		 WITH(OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA256));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSAVERIFY,
		 WITH(OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA384));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSAVERIFY,
		 WITH(OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA512));

	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSAVERIFY,
		 WITH(OP_PCL_PKPROT_F2M));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSAVERIFY,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_MD5));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSAVERIFY,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA1));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSAVERIFY,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA256));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSAVERIFY,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA384));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSAVERIFY,
		 WITH(OP_PCL_PKPROT_F2M | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA512));

	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSAVERIFY,
		 WITH(OP_PCL_PKPROT_ECC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSAVERIFY,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_MD5));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSAVERIFY,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA1));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSAVERIFY,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA256));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSAVERIFY,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA384));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSAVERIFY,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_DSA_MSG |
		      OP_PCL_PKPROT_HASH_SHA512));

	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSAVERIFY,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSAVERIFY,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_MD5));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSAVERIFY,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA1));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSAVERIFY,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA256));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSAVERIFY,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA384));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DSAVERIFY,
		 WITH(OP_PCL_PKPROT_ECC | OP_PCL_PKPROT_F2M |
		      OP_PCL_PKPROT_DSA_MSG | OP_PCL_PKPROT_HASH_SHA512));

	/* IKE PRF */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_IKEV1_PRF,
		 WITH(OP_PCL_IKE_HMAC_MD5));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_IKEV1_PRF,
		 WITH(OP_PCL_IKE_HMAC_MD5));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_IKEV1_PRF,
		 WITH(OP_PCL_IKE_HMAC_SHA1));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_IKEV1_PRF,
		 WITH(OP_PCL_IKE_HMAC_AES128_CBC));

	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_IKEV2_PRF,
		 WITH(OP_PCL_IKE_HMAC_MD5));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_IKEV2_PRF,
		 WITH(OP_PCL_IKE_HMAC_SHA1));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_IKEV2_PRF,
		 WITH(OP_PCL_IKE_HMAC_AES128_CBC));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_IKEV2_PRF,
		 WITH(OP_PCL_IKE_HMAC_SHA256));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_IKEV2_PRF,
		 WITH(OP_PCL_IKE_HMAC_SHA384));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_IKEV2_PRF,
		 WITH(OP_PCL_IKE_HMAC_SHA512));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_IKEV2_PRF,
		 WITH(OP_PCL_IKE_HMAC_AES128_CMAC));

	/* SSL/TLS/dtls PRF */
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_SSL30_PRF,
		 WITH(OP_PCL_TLS10_3DES_EDE_CBC_MD5));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_TLS10_PRF,
		 WITH(OP_PCL_TLS10_3DES_EDE_CBC_MD5));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_TLS11_PRF,
		 WITH(OP_PCL_TLS10_3DES_EDE_CBC_MD5));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_TLS12_PRF,
		 WITH(OP_PCL_TLS10_3DES_EDE_CBC_MD5));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DTLS10_PRF,
		 WITH(OP_PCL_TLS10_3DES_EDE_CBC_MD5));

	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_SSL30_PRF,
		 WITH(OP_PCL_TLS_PVT_MASTER_SECRET_PRF_FF));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_TLS10_PRF,
		 WITH(OP_PCL_TLS_PVT_MASTER_SECRET_PRF_FF));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_TLS11_PRF,
		 WITH(OP_PCL_TLS_PVT_MASTER_SECRET_PRF_FF));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_TLS12_PRF,
		 WITH(OP_PCL_TLS_PVT_MASTER_SECRET_PRF_FE));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_TLS12_PRF,
		 WITH(OP_PCL_TLS_PVT_MASTER_SECRET_PRF_FF));
	PROTOCOL(OP_TYPE_UNI_PROTOCOL, OP_PCLID_DTLS10_PRF,
		 WITH(OP_PCL_TLS_PVT_MASTER_SECRET_PRF_FF));

	/* Blob */
	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_BLOB, 0);
	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_FORMAT_NORMAL));
	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_MEMORY));
	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_MEMORY | OP_PCL_BLOB_FORMAT_NORMAL));
	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_MEMORY | OP_PCL_BLOB_SEC_MEM));
	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_MEMORY | OP_PCL_BLOB_SEC_MEM |
		      OP_PCL_BLOB_FORMAT_NORMAL));

	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_MEMORY | OP_PCL_BLOB_TKEK |
		      OP_PCL_BLOB_BLACK));
	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_MEMORY | OP_PCL_BLOB_TKEK |
		      OP_PCL_BLOB_BLACK));
	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_MEMORY | OP_PCL_BLOB_EKT |
		      OP_PCL_BLOB_BLACK));
	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_MEMORY | OP_PCL_BLOB_EKT |
		      OP_PCL_BLOB_TKEK | OP_PCL_BLOB_BLACK));
	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_MEMORY | OP_PCL_BLOB_SEC_MEM |
		      OP_PCL_BLOB_BLACK));

	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_FORMAT_TEST));
	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_FORMAT_TEST | OP_PCL_BLOB_REG_MEMORY |
		      OP_PCL_BLOB_SEC_MEM));
	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_FORMAT_MASTER_VER));
	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_FORMAT_MASTER_VER | OP_PCL_BLOB_SEC_MEM));
	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_FORMAT_MASTER_VER | OP_PCL_BLOB_BLACK));
	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_FORMAT_MASTER_VER | OP_PCL_BLOB_BLACK |
		      OP_PCL_BLOB_TKEK));
	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_FORMAT_MASTER_VER | OP_PCL_BLOB_BLACK |
		      OP_PCL_BLOB_EKT));
	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_FORMAT_MASTER_VER | OP_PCL_BLOB_BLACK |
		      OP_PCL_BLOB_EKT | OP_PCL_BLOB_TKEK));
	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_FORMAT_MASTER_VER | OP_PCL_BLOB_BLACK |
		      OP_PCL_BLOB_SEC_MEM | OP_PCL_BLOB_EKT));

	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB, 0);
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_MEMORY));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_MEMORY | OP_PCL_BLOB_FORMAT_NORMAL));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_MEMORY | OP_PCL_BLOB_BLACK));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_MEMORY | OP_PCL_BLOB_BLACK |
		      OP_PCL_BLOB_TKEK));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_MEMORY | OP_PCL_BLOB_BLACK |
		      OP_PCL_BLOB_TKEK));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_MEMORY | OP_PCL_BLOB_SEC_MEM));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_KEY1 | OP_PCL_BLOB_FORMAT_NORMAL));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_KEY1 | OP_PCL_BLOB_BLACK |
		      OP_PCL_BLOB_FORMAT_NORMAL));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_KEY1 | OP_PCL_BLOB_BLACK));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_KEY1 | OP_PCL_BLOB_BLACK |
		      OP_PCL_BLOB_TKEK));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_KEY1 | OP_PCL_BLOB_BLACK |
		      OP_PCL_BLOB_EKT));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_KEY1 | OP_PCL_BLOB_BLACK | OP_PCL_BLOB_EKT
		      | OP_PCL_BLOB_TKEK));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_KEY2 | OP_PCL_BLOB_FORMAT_NORMAL));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_KEY2 | OP_PCL_BLOB_BLACK));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_KEY2 | OP_PCL_BLOB_BLACK |
		      OP_PCL_BLOB_TKEK));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_KEY2 | OP_PCL_BLOB_BLACK |
		      OP_PCL_BLOB_EKT));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_KEY2 | OP_PCL_BLOB_BLACK | OP_PCL_BLOB_EKT
		      | OP_PCL_BLOB_TKEK));

	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_PKE));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_PKE | OP_PCL_BLOB_BLACK));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_PKE | OP_PCL_BLOB_BLACK |
		      OP_PCL_BLOB_TKEK));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_PKE | OP_PCL_BLOB_BLACK |
		      OP_PCL_BLOB_EKT));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_PKE | OP_PCL_BLOB_BLACK | OP_PCL_BLOB_EKT
		      | OP_PCL_BLOB_TKEK));

	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_SPLIT));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_SPLIT | OP_PCL_BLOB_BLACK));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_SPLIT | OP_PCL_BLOB_BLACK |
		      OP_PCL_BLOB_SEC_MEM | OP_PCL_BLOB_TKEK));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_SPLIT | OP_PCL_BLOB_BLACK |
		      OP_PCL_BLOB_EKT | OP_PCL_BLOB_TKEK));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_SPLIT | OP_PCL_BLOB_BLACK |
		      OP_PCL_BLOB_EKT | OP_PCL_BLOB_TKEK));

	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_MEMORY | OP_PCL_BLOB_FORMAT_TEST));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_MEMORY | OP_PCL_BLOB_FORMAT_TEST |
		      OP_PCL_BLOB_BLACK));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_MEMORY | OP_PCL_BLOB_FORMAT_TEST |
		      OP_PCL_BLOB_BLACK | OP_PCL_BLOB_TKEK));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_MEMORY | OP_PCL_BLOB_FORMAT_TEST |
		      OP_PCL_BLOB_BLACK | OP_PCL_BLOB_EKT));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_MEMORY | OP_PCL_BLOB_FORMAT_TEST |
		      OP_PCL_BLOB_BLACK | OP_PCL_BLOB_TKEK | OP_PCL_BLOB_EKT));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_SPLIT | OP_PCL_BLOB_FORMAT_TEST |
		      OP_PCL_BLOB_BLACK | OP_PCL_BLOB_SEC_MEM));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_BLOB,
		 WITH(OP_PCL_BLOB_REG_MEMORY | OP_PCL_BLOB_FORMAT_TEST));

	/* packet/frame processing */
	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_IPSEC,
		 WITH(OP_PCL_IPSEC_AES_CBC | OP_PCL_IPSEC_HMAC_SHA1_96));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_IPSEC,
		 WITH(OP_PCL_IPSEC_3DES | OP_PCL_IPSEC_HMAC_MD5_96));
	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_SRTP,
		 WITH(OP_PCL_SRTP_AES_CTR | OP_PCL_SRTP_HMAC_SHA1_160));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_SRTP,
		 WITH(OP_PCL_SRTP_AES_CTR | OP_PCL_SRTP_HMAC_SHA1_160));

	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_WIMAX,
		 WITH(OP_PCL_WIMAX_OFDM));
	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_WIMAX,
		 WITH(OP_PCL_WIMAX_OFDMA));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_WIMAX,
		 WITH(OP_PCL_WIMAX_OFDMA));

	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_WIFI, WITH(OP_PCL_WIFI));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_WIFI, WITH(OP_PCL_WIFI));

	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_MACSEC, WITH(OP_PCL_MACSEC));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_MACSEC, WITH(OP_PCL_MACSEC));

	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_SSL30,
		 WITH(OP_PCL_TLS10_RC4_128_SHA_5));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_SSL30,
		 WITH(OP_PCL_TLS10_RC4_128_SHA_5));

	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_TLS10,
		 WITH(OP_PCL_TLS10_AES_128_CBC_SHA_12));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_TLS10,
		 WITH(OP_PCL_TLS10_AES_128_CBC_SHA_12));

	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_TLS11,
		 WITH(OP_PCL_TLS10_AES_128_CBC_SHA_12));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_TLS11,
		 WITH(OP_PCL_TLS10_AES_128_CBC_SHA_12));

	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_TLS12,
		 WITH(OP_PCL_TLS10_AES_128_CBC_SHA_12));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_TLS12,
		 WITH(OP_PCL_TLS10_AES_128_CBC_SHA_12));

	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_DTLS10,
		 WITH(OP_PCL_TLS10_AES_128_CBC_SHA_12));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_DTLS10,
		 WITH(OP_PCL_TLS10_AES_128_CBC_SHA_12));

	if (rta_sec_era > RTA_SEC_ERA_5) {
		PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_3G_RLC_PDU,
			 WITH(OP_PCL_3G_RLC_NULL));
		PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_3G_RLC_PDU,
			 WITH(OP_PCL_3G_RLC_NULL));
	}
	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_3G_RLC_PDU,
		 WITH(OP_PCL_3G_RLC_KASUMI));
	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_3G_RLC_PDU,
		 WITH(OP_PCL_3G_RLC_SNOW));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_3G_RLC_PDU,
		 WITH(OP_PCL_3G_RLC_KASUMI));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_3G_RLC_PDU,
		 WITH(OP_PCL_3G_RLC_SNOW));

	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_LTE_PDCP_USER,
		 WITH(OP_PCL_LTE_NULL));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_LTE_PDCP_USER,
		 WITH(OP_PCL_LTE_NULL));
	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_LTE_PDCP_USER,
		 WITH(OP_PCL_LTE_SNOW));
	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_LTE_PDCP_USER,
		 WITH(OP_PCL_LTE_AES));

	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_LTE_PDCP_USER,
		 WITH(OP_PCL_LTE_SNOW));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_LTE_PDCP_USER,
		 WITH(OP_PCL_LTE_AES));

	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_LTE_PDCP_CTRL,
		 WITH(OP_PCL_LTE_NULL));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_LTE_PDCP_CTRL,
		 WITH(OP_PCL_LTE_NULL));
	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_LTE_PDCP_CTRL,
		 WITH(OP_PCL_LTE_SNOW));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_LTE_PDCP_CTRL,
		 WITH(OP_PCL_LTE_SNOW));
	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_LTE_PDCP_CTRL,
		 WITH(OP_PCL_LTE_AES));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_LTE_PDCP_CTRL,
		 WITH(OP_PCL_LTE_AES));

	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_3G_DCRC,
		 WITH(OP_PCL_3G_DCRC_CRC7));
	PROTOCOL(OP_TYPE_ENCAP_PROTOCOL, OP_PCLID_3G_DCRC,
		 WITH(OP_PCL_3G_DCRC_CRC11));

	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_3G_DCRC,
		 WITH(OP_PCL_3G_DCRC_CRC7));
	PROTOCOL(OP_TYPE_DECAP_PROTOCOL, OP_PCLID_3G_DCRC,
		 WITH(OP_PCL_3G_DCRC_CRC11));

	size = PROGRAM_FINALIZE();
	return size;
}

int prg_buff[1000];

int main(int argc, char **argv)
{
	int size;

	pr_debug("OPERATION PROTOCOL program\n");
	rta_set_sec_era(RTA_SEC_ERA_5);
	size = test_op_proto((uint32_t *) prg_buff);
	pr_debug("size = %d\n", size);
	print_prog((uint32_t *) prg_buff, size);

	return 0;
}
