#include <stdio.h>
#include "flib/rta.h"
#include "test_common.h"

enum rta_sec_era rta_sec_era;

int math_test(uint32_t *buff)
{
	struct program prg;
	struct program *program = &prg;
	int size;
	uint32_t smallnum = 393615378ULL;
	uint64_t bignum = 0x19261959fedcba01ULL;

	PROGRAM_CNTXT_INIT(buff, 0);
	/* ADD Operation: MATH0 Destination register */
	MATHB(MATH0, ADD, MATH0, MATH0, SIZE(4), 0);
	MATHB(MATH0, ADD, MATH1, MATH0, SIZE(1), WITH(STL));
	MATHB(MATH0, ADD, MATH2, MATH0, SIZE(1), WITH(STL));
	MATHB(MATH0, ADD, MATH3, MATH0, SIZE(4), 0);
	MATHB(MATH0, ADD, IMM(smallnum), MATH0, SIZE(1), 0);
	MATHB(MATH0, ADD, DPOVRD, MATH0, SIZE(8), WITH(NFU));
	MATHB(MATH0, ADD, VSEQINSZ, MATH0, SIZE(2), 0);
	MATHB(MATH0, ADD, VSEQOUTSZ, MATH0, SIZE(2), WITH(STL));
	MATHB(MATH0, ADD, ABD, MATH0, SIZE(8), WITH(NFU));
	MATHB(MATH0, ADD, OFIFO, MATH0, SIZE(1), WITH(STL));
	MATHB(MATH0, ADD, ONE, MATH0, SIZE(1), 0);
	MATHB(MATH0, ADD, ZERO, MATH0, SIZE(8), 0);
	MATHB(MATH1, ADD, MATH0, MATH0, SIZE(8), 0);
	MATHB(MATH1, ADD, MATH1, MATH0, SIZE(1), 0);
	MATHB(MATH1, ADD, MATH2, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(MATH1, ADD, MATH3, MATH0, SIZE(8), WITH(NFU | STL));
	MATHB(MATH1, ADD, IMM(393615378), MATH0, SIZE(8), WITH(IFB | STL));
	MATHB(MATH1, ADD, DPOVRD, MATH0, SIZE(1), 0);
	MATHB(MATH1, ADD, VSEQINSZ, MATH0, SIZE(4), WITH(STL));
	MATHB(MATH1, ADD, VSEQOUTSZ, MATH0, SIZE(8), WITH(STL));
	MATHB(MATH1, ADD, ABD, MATH0, SIZE(4), 0);
	MATHB(MATH1, ADD, OFIFO, MATH0, SIZE(4), 0);
	MATHB(MATH1, ADD, ONE, MATH0, SIZE(1), WITH(NFU));
	MATHB(MATH1, ADD, ZERO, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, ADD, MATH0, MATH0, SIZE(8), WITH(STL));
	MATHB(MATH2, ADD, MATH1, MATH0, SIZE(2), 0);
	MATHB(MATH2, ADD, MATH2, MATH0, SIZE(2), WITH(STL));
	MATHB(MATH2, ADD, MATH3, MATH0, SIZE(1), 0);
	MATHB(MATH2, ADD, IMM(bignum), MATH0, SIZE(8), 0);
	MATHB(MATH2, ADD, DPOVRD, MATH0, SIZE(2), 0);
	MATHB(MATH2, ADD, VSEQINSZ, MATH0, SIZE(2), 0);
	MATHB(MATH2, ADD, VSEQOUTSZ, MATH0, SIZE(4), 0);
	MATHB(MATH2, ADD, ABD, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, ADD, OFIFO, MATH0, SIZE(2), 0);
	MATHB(MATH2, ADD, ONE, MATH0, SIZE(8), 0);
	MATHB(MATH2, ADD, ZERO, MATH0, SIZE(1), WITH(NFU));
	MATHB(MATH3, ADD, MATH0, MATH0, SIZE(2), 0);
	MATHB(MATH3, ADD, MATH1, MATH0, SIZE(8), 0);
	MATHB(MATH3, ADD, MATH2, MATH0, SIZE(8), 0);
	MATHB(MATH3, ADD, MATH3, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, ADD, IMM(smallnum), MATH0, SIZE(1), WITH(STL));
	MATHB(MATH3, ADD, DPOVRD, MATH0, SIZE(2), WITH(STL));
	MATHB(MATH3, ADD, VSEQINSZ, MATH0, SIZE(4), WITH(STL));
	MATHB(MATH3, ADD, VSEQOUTSZ, MATH0, SIZE(2), 0);
	MATHB(MATH3, ADD, ABD, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, ADD, OFIFO, MATH0, SIZE(1), 0);
	MATHB(MATH3, ADD, ONE, MATH0, SIZE(1), 0);
	MATHB(MATH3, ADD, ZERO, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(275128321), ADD, MATH0, MATH0, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), ADD, MATH1, MATH0, SIZE(2), 0);
	MATHB(IMM(275128321), ADD, MATH2, MATH0, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), ADD, MATH3, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(275128321), ADD, IMM(smallnum), MATH0, SIZE(1), 0);
	MATHB(IMM(275128321), ADD, DPOVRD, MATH0, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), ADD, VSEQINSZ, MATH0, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), ADD, VSEQOUTSZ, MATH0, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), ADD, ABD, MATH0, SIZE(1), 0);
	MATHB(IMM(275128321), ADD, OFIFO, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(275128321), ADD, ONE, MATH0, SIZE(4), 0);
	MATHB(IMM(bignum), ADD, ZERO, MATH0, SIZE(8), 0);
	MATHB(DPOVRD, ADD, MATH0, MATH0, SIZE(1), 0);
	MATHB(DPOVRD, ADD, MATH1, MATH0, SIZE(2), 0);
	MATHB(DPOVRD, ADD, MATH2, MATH0, SIZE(1), 0);
	MATHB(DPOVRD, ADD, MATH3, MATH0, SIZE(8), 0);
	MATHB(DPOVRD, ADD, IMM(0x17761812), MATH0, SIZE(1), 0);
	MATHB(DPOVRD, ADD, DPOVRD, MATH0, SIZE(8), 0);
	MATHB(DPOVRD, ADD, VSEQINSZ, MATH0, SIZE(8), 0);
	MATHB(DPOVRD, ADD, VSEQOUTSZ, MATH0, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, ADD, ABD, MATH0, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, ADD, OFIFO, MATH0, SIZE(1), WITH(STL));
	MATHB(DPOVRD, ADD, ONE, MATH0, SIZE(4), 0);
	MATHB(DPOVRD, ADD, ZERO, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, ADD, MATH0, MATH0, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, ADD, MATH1, MATH0, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, ADD, MATH2, MATH0, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, ADD, MATH3, MATH0, SIZE(2), 0);
	MATHB(SEQINSZ, ADD, IMM(393615378), MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, ADD, DPOVRD, MATH0, SIZE(1), 0);
	MATHB(SEQINSZ, ADD, VSEQINSZ, MATH0, SIZE(4), 0);
	MATHB(SEQINSZ, ADD, VSEQOUTSZ, MATH0, SIZE(8), 0);
	MATHB(SEQINSZ, ADD, ABD, MATH0, SIZE(1), 0);
	MATHB(SEQINSZ, ADD, OFIFO, MATH0, SIZE(2), 0);
	MATHB(SEQINSZ, ADD, ONE, MATH0, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, ADD, ZERO, MATH0, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADD, MATH0, MATH0, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADD, MATH1, MATH0, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, ADD, MATH2, MATH0, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, ADD, MATH3, MATH0, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADD, IMM(393615378), MATH0, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADD, DPOVRD, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADD, VSEQINSZ, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADD, VSEQOUTSZ, MATH0, SIZE(8), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADD, ABD, MATH0, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, ADD, OFIFO, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADD, ONE, MATH0, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, ADD, ZERO, MATH0, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, ADD, MATH0, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, ADD, MATH1, MATH0, SIZE(2), 0);
	MATHB(VSEQINSZ, ADD, MATH2, MATH0, SIZE(4), 0);
	MATHB(VSEQINSZ, ADD, MATH3, MATH0, SIZE(8), 0);
	MATHB(VSEQINSZ, ADD, IMM(393615378), MATH0, SIZE(8), WITH(IFB | STL));
	MATHB(VSEQINSZ, ADD, DPOVRD, MATH0, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, ADD, VSEQINSZ, MATH0, SIZE(8), 0);
	MATHB(VSEQINSZ, ADD, VSEQOUTSZ, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, ADD, ABD, MATH0, SIZE(4), 0);
	MATHB(VSEQINSZ, ADD, OFIFO, MATH0, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, ADD, ONE, MATH0, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, ADD, ZERO, MATH0, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADD, MATH0, MATH0, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADD, MATH1, MATH0, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADD, MATH2, MATH0, SIZE(8), 0);
	MATHB(VSEQOUTSZ, ADD, MATH3, MATH0, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, ADD, IMM(393615378), MATH0, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADD, DPOVRD, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADD, VSEQINSZ, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADD, VSEQOUTSZ, MATH0, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADD, ABD, MATH0, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, ADD, OFIFO, MATH0, SIZE(8), 0);
	MATHB(VSEQOUTSZ, ADD, ONE, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADD, ZERO, MATH0, SIZE(1), 0);
	MATHB(ZERO, ADD, MATH0, MATH0, SIZE(2), WITH(NFU));
	MATHB(ZERO, ADD, MATH1, MATH0, SIZE(4), 0);
	MATHB(ZERO, ADD, MATH2, MATH0, SIZE(2), 0);
	MATHB(ZERO, ADD, MATH3, MATH0, SIZE(8), 0);
	MATHB(ZERO, ADD, IMM(smallnum), MATH0, SIZE(4), 0);
	MATHB(ZERO, ADD, DPOVRD, MATH0, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, ADD, VSEQINSZ, MATH0, SIZE(1), 0);
	MATHB(ZERO, ADD, VSEQOUTSZ, MATH0, SIZE(8), 0);
	MATHB(ZERO, ADD, ABD, MATH0, SIZE(1), 0);
	MATHB(ZERO, ADD, OFIFO, MATH0, SIZE(4), 0);
	MATHB(ZERO, ADD, ONE, MATH0, SIZE(4), WITH(STL));
	MATHB(ZERO, ADD, ZERO, MATH0, SIZE(4), 0);
	MATHB(ONE, ADD, MATH0, MATH0, SIZE(1), WITH(STL));
	MATHB(ONE, ADD, MATH1, MATH0, SIZE(4), WITH(STL));
	MATHB(ONE, ADD, MATH2, MATH0, SIZE(8), WITH(NFU));
	MATHB(ONE, ADD, MATH3, MATH0, SIZE(1), WITH(STL));
	MATHB(ONE, ADD, IMM(393615378), MATH0, SIZE(1), WITH(NFU));
	MATHB(ONE, ADD, DPOVRD, MATH0, SIZE(8), 0);
	MATHB(ONE, ADD, VSEQINSZ, MATH0, SIZE(1), 0);
	MATHB(ONE, ADD, VSEQOUTSZ, MATH0, SIZE(4), WITH(STL));
	MATHB(ONE, ADD, ABD, MATH0, SIZE(2), 0);
	MATHB(ONE, ADD, OFIFO, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, ADD, ONE, MATH0, SIZE(2), 0);
	MATHB(ONE, ADD, ZERO, MATH0, SIZE(4), WITH(NFU));
	/* ADD Operation: MATH1 Destination register */
	MATHB(MATH0, ADD, MATH0, MATH1, SIZE(4), 0);
	MATHB(MATH0, ADD, MATH1, MATH1, SIZE(2), 0);
	MATHB(MATH0, ADD, MATH2, MATH1, SIZE(8), 0);
	MATHB(MATH0, ADD, MATH3, MATH1, SIZE(4), 0);
	MATHB(MATH0, ADD, IMM(393615378), MATH1, SIZE(2), WITH(STL));
	MATHB(MATH0, ADD, DPOVRD, MATH1, SIZE(8), 0);
	MATHB(MATH0, ADD, VSEQINSZ, MATH1, SIZE(2), 0);
	MATHB(MATH0, ADD, VSEQOUTSZ, MATH1, SIZE(8), 0);
	MATHB(MATH0, ADD, ABD, MATH1, SIZE(2), 0);
	MATHB(MATH0, ADD, OFIFO, MATH1, SIZE(4), WITH(STL));
	MATHB(MATH0, ADD, ONE, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(MATH0, ADD, ZERO, MATH1, SIZE(4), 0);
	MATHB(MATH1, ADD, MATH0, MATH1, SIZE(1), 0);
	MATHB(MATH1, ADD, MATH1, MATH1, SIZE(4), 0);
	MATHB(MATH1, ADD, MATH2, MATH1, SIZE(2), WITH(NFU));
	MATHB(MATH1, ADD, MATH3, MATH1, SIZE(8), 0);
	MATHB(MATH1, ADD, IMM(393615378), MATH1, SIZE(2), 0);
	MATHB(MATH1, ADD, DPOVRD, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(MATH1, ADD, VSEQINSZ, MATH1, SIZE(8), 0);
	MATHB(MATH1, ADD, VSEQOUTSZ, MATH1, SIZE(8), 0);
	MATHB(MATH1, ADD, ABD, MATH1, SIZE(2), 0);
	MATHB(MATH1, ADD, OFIFO, MATH1, SIZE(8), WITH(STL));
	MATHB(MATH1, ADD, ONE, MATH1, SIZE(1), 0);
	MATHB(MATH1, ADD, ZERO, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, ADD, MATH0, MATH1, SIZE(2), 0);
	MATHB(MATH2, ADD, MATH1, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, ADD, MATH2, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, ADD, MATH3, MATH1, SIZE(1), 0);
	MATHB(MATH2, ADD, IMM(393615378), MATH1, SIZE(1), 0);
	MATHB(MATH2, ADD, DPOVRD, MATH1, SIZE(2), 0);
	MATHB(MATH2, ADD, VSEQINSZ, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, ADD, VSEQOUTSZ, MATH1, SIZE(4), 0);
	MATHB(MATH2, ADD, ABD, MATH1, SIZE(4), 0);
	MATHB(MATH2, ADD, OFIFO, MATH1, SIZE(1), 0);
	MATHB(MATH2, ADD, ONE, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, ADD, ZERO, MATH1, SIZE(2), 0);
	MATHB(MATH3, ADD, MATH0, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, ADD, MATH1, MATH1, SIZE(2), WITH(NFU));
	MATHB(MATH3, ADD, MATH2, MATH1, SIZE(2), 0);
	MATHB(MATH3, ADD, MATH3, MATH1, SIZE(1), 0);
	MATHB(MATH3, ADD, IMM(393615378), MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, ADD, DPOVRD, MATH1, SIZE(8), 0);
	MATHB(MATH3, ADD, VSEQINSZ, MATH1, SIZE(1), 0);
	MATHB(MATH3, ADD, VSEQOUTSZ, MATH1, SIZE(1), WITH(NFU));
	MATHB(MATH3, ADD, ABD, MATH1, SIZE(1), 0);
	MATHB(MATH3, ADD, OFIFO, MATH1, SIZE(8), 0);
	MATHB(MATH3, ADD, ONE, MATH1, SIZE(1), 0);
	MATHB(MATH3, ADD, ZERO, MATH1, SIZE(2), WITH(NFU));
	MATHB(IMM(275128321), ADD, MATH0, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(275128321), ADD, MATH1, MATH1, SIZE(8),
	      WITH(IFB | NFU | STL));
	MATHB(IMM(275128321), ADD, MATH2, MATH1, SIZE(2), 0);
	MATHB(IMM(275128321), ADD, MATH3, MATH1, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), ADD, IMM(393615378), MATH1, SIZE(2), 0);
	MATHB(IMM(275128321), ADD, DPOVRD, MATH1, SIZE(4), 0);
	MATHB(IMM(275128321), ADD, VSEQINSZ, MATH1, SIZE(4), WITH(STL));
	MATHB(IMM(bignum), ADD, VSEQOUTSZ, MATH1, SIZE(8), 0);
	MATHB(IMM(0x19261959fedcba01), ADD, ABD, MATH1, SIZE(8), 0);
	MATHB(IMM(275128321), ADD, OFIFO, MATH1, SIZE(1), 0);
	MATHB(IMM(0x19261959fedcba01), ADD, ONE, MATH1, SIZE(8),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), ADD, ZERO, MATH1, SIZE(4), WITH(STL));
	MATHB(DPOVRD, ADD, MATH0, MATH1, SIZE(1), 0);
	MATHB(DPOVRD, ADD, MATH1, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, ADD, MATH2, MATH1, SIZE(8), 0);
	MATHB(DPOVRD, ADD, MATH3, MATH1, SIZE(4), WITH(STL));
	MATHB(DPOVRD, ADD, IMM(393615378), MATH1, SIZE(2), 0);
	MATHB(DPOVRD, ADD, DPOVRD, MATH1, SIZE(2), 0);
	MATHB(DPOVRD, ADD, VSEQINSZ, MATH1, SIZE(2), 0);
	MATHB(DPOVRD, ADD, VSEQOUTSZ, MATH1, SIZE(2), 0);
	MATHB(DPOVRD, ADD, ABD, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(DPOVRD, ADD, OFIFO, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, ADD, ONE, MATH1, SIZE(8), 0);
	MATHB(DPOVRD, ADD, ZERO, MATH1, SIZE(8), 0);
	MATHB(SEQINSZ, ADD, MATH0, MATH1, SIZE(1), 0);
	MATHB(SEQINSZ, ADD, MATH1, MATH1, SIZE(2), 0);
	MATHB(SEQINSZ, ADD, MATH2, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, ADD, MATH3, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, ADD, IMM(393615378), MATH1, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, ADD, DPOVRD, MATH1, SIZE(1), 0);
	MATHB(SEQINSZ, ADD, VSEQINSZ, MATH1, SIZE(8), 0);
	MATHB(SEQINSZ, ADD, VSEQOUTSZ, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, ADD, ABD, MATH1, SIZE(2), 0);
	MATHB(SEQINSZ, ADD, OFIFO, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, ADD, ONE, MATH1, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, ADD, ZERO, MATH1, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADD, MATH0, MATH1, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADD, MATH1, MATH1, SIZE(8), 0);
	MATHB(SEQOUTSZ, ADD, MATH2, MATH1, SIZE(2), 0);
	MATHB(SEQOUTSZ, ADD, MATH3, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADD, IMM(393615378), MATH1, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, ADD, DPOVRD, MATH1, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, ADD, VSEQINSZ, MATH1, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, ADD, VSEQOUTSZ, MATH1, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, ADD, ABD, MATH1, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADD, OFIFO, MATH1, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADD, ONE, MATH1, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, ADD, ZERO, MATH1, SIZE(2), 0);
	MATHB(VSEQINSZ, ADD, MATH0, MATH1, SIZE(1), 0);
	MATHB(VSEQINSZ, ADD, MATH1, MATH1, SIZE(8), 0);
	MATHB(VSEQINSZ, ADD, MATH2, MATH1, SIZE(8), 0);
	MATHB(VSEQINSZ, ADD, MATH3, MATH1, SIZE(2), 0);
	MATHB(VSEQINSZ, ADD, IMM(0x19261959fedcba01), MATH1, SIZE(8), 0);
	MATHB(VSEQINSZ, ADD, DPOVRD, MATH1, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, ADD, VSEQINSZ, MATH1, SIZE(8), 0);
	MATHB(VSEQINSZ, ADD, VSEQOUTSZ, MATH1, SIZE(4), 0);
	MATHB(VSEQINSZ, ADD, ABD, MATH1, SIZE(2), 0);
	MATHB(VSEQINSZ, ADD, OFIFO, MATH1, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, ADD, ONE, MATH1, SIZE(8), 0);
	MATHB(VSEQINSZ, ADD, ZERO, MATH1, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADD, MATH0, MATH1, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADD, MATH1, MATH1, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADD, MATH2, MATH1, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, ADD, MATH3, MATH1, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADD, IMM(393615378), MATH1, SIZE(2), 0);
	MATHB(VSEQOUTSZ, ADD, DPOVRD, MATH1, SIZE(2), 0);
	MATHB(VSEQOUTSZ, ADD, VSEQINSZ, MATH1, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADD, VSEQOUTSZ, MATH1, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, ADD, ABD, MATH1, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADD, OFIFO, MATH1, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADD, ONE, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADD, ZERO, MATH1, SIZE(8), WITH(STL));
	MATHB(ZERO, ADD, MATH0, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, ADD, MATH1, MATH1, SIZE(1), WITH(STL));
	MATHB(ZERO, ADD, MATH2, MATH1, SIZE(4), 0);
	MATHB(ZERO, ADD, MATH3, MATH1, SIZE(8), WITH(NFU));
	MATHB(ZERO, ADD, IMM(0x19261959fedcba01), MATH1, SIZE(8), WITH(STL));
	MATHB(ZERO, ADD, DPOVRD, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, ADD, VSEQINSZ, MATH1, SIZE(4), 0);
	MATHB(ZERO, ADD, VSEQOUTSZ, MATH1, SIZE(8), WITH(NFU));
	MATHB(ZERO, ADD, ABD, MATH1, SIZE(4), 0);
	MATHB(ZERO, ADD, OFIFO, MATH1, SIZE(1), 0);
	MATHB(ZERO, ADD, ONE, MATH1, SIZE(1), 0);
	MATHB(ZERO, ADD, ZERO, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, ADD, MATH0, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, ADD, MATH1, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, ADD, MATH2, MATH1, SIZE(1), 0);
	MATHB(ONE, ADD, MATH3, MATH1, SIZE(8), 0);
	MATHB(ONE, ADD, IMM(393615378), MATH1, SIZE(2), WITH(NFU));
	MATHB(ONE, ADD, DPOVRD, MATH1, SIZE(1), 0);
	MATHB(ONE, ADD, VSEQINSZ, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, ADD, VSEQOUTSZ, MATH1, SIZE(2), 0);
	MATHB(ONE, ADD, ABD, MATH1, SIZE(4), WITH(NFU));
	MATHB(ONE, ADD, OFIFO, MATH1, SIZE(1), 0);
	MATHB(ONE, ADD, ONE, MATH1, SIZE(4), 0);
	MATHB(ONE, ADD, ZERO, MATH1, SIZE(4), 0);
	/* ADD Operation: MATH2 Destination register */
	MATHB(MATH0, ADD, MATH0, MATH2, SIZE(2), WITH(STL));
	MATHB(MATH0, ADD, MATH1, MATH2, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, ADD, MATH2, MATH2, SIZE(2), 0);
	MATHB(MATH0, ADD, MATH3, MATH2, SIZE(8), 0);
	MATHB(MATH0, ADD, IMM(393615378), MATH2, SIZE(1), WITH(STL));
	MATHB(MATH0, ADD, DPOVRD, MATH2, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, ADD, VSEQINSZ, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, ADD, VSEQOUTSZ, MATH2, SIZE(1), 0);
	MATHB(MATH0, ADD, ABD, MATH2, SIZE(8), 0);
	MATHB(MATH0, ADD, OFIFO, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(MATH0, ADD, ONE, MATH2, SIZE(4), WITH(NFU));
	MATHB(MATH0, ADD, ZERO, MATH2, SIZE(8), 0);
	MATHB(MATH1, ADD, MATH0, MATH2, SIZE(1), WITH(STL));
	MATHB(MATH1, ADD, MATH1, MATH2, SIZE(1), WITH(NFU));
	MATHB(MATH1, ADD, MATH2, MATH2, SIZE(4), WITH(STL));
	MATHB(MATH1, ADD, MATH3, MATH2, SIZE(1), WITH(STL));
	MATHB(MATH1, ADD, IMM(393615378), MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, ADD, DPOVRD, MATH2, SIZE(8), WITH(STL));
	MATHB(MATH1, ADD, VSEQINSZ, MATH2, SIZE(2), WITH(STL));
	MATHB(MATH1, ADD, VSEQOUTSZ, MATH2, SIZE(1), 0);
	MATHB(MATH1, ADD, ABD, MATH2, SIZE(8), 0);
	MATHB(MATH1, ADD, OFIFO, MATH2, SIZE(2), 0);
	MATHB(MATH1, ADD, ONE, MATH2, SIZE(4), 0);
	MATHB(MATH1, ADD, ZERO, MATH2, SIZE(1), WITH(NFU));
	MATHB(MATH2, ADD, MATH0, MATH2, SIZE(1), WITH(NFU));
	MATHB(MATH2, ADD, MATH1, MATH2, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, ADD, MATH2, MATH2, SIZE(2), 0);
	MATHB(MATH2, ADD, MATH3, MATH2, SIZE(4), 0);
	MATHB(MATH2, ADD, IMM(393615378), MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, ADD, DPOVRD, MATH2, SIZE(8), 0);
	MATHB(MATH2, ADD, VSEQINSZ, MATH2, SIZE(1), 0);
	MATHB(MATH2, ADD, VSEQOUTSZ, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, ADD, ABD, MATH2, SIZE(8), WITH(NFU));
	MATHB(MATH2, ADD, OFIFO, MATH2, SIZE(4), 0);
	MATHB(MATH2, ADD, ONE, MATH2, SIZE(4), 0);
	MATHB(MATH2, ADD, ZERO, MATH2, SIZE(2), 0);
	MATHB(MATH3, ADD, MATH0, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(MATH3, ADD, MATH1, MATH2, SIZE(1), 0);
	MATHB(MATH3, ADD, MATH2, MATH2, SIZE(4), 0);
	MATHB(MATH3, ADD, MATH3, MATH2, SIZE(2), 0);
	MATHB(MATH3, ADD, IMM(393615378), MATH2, SIZE(2), WITH(NFU));
	MATHB(MATH3, ADD, DPOVRD, MATH2, SIZE(8), WITH(STL));
	MATHB(MATH3, ADD, VSEQINSZ, MATH2, SIZE(1), 0);
	MATHB(MATH3, ADD, VSEQOUTSZ, MATH2, SIZE(2), 0);
	MATHB(MATH3, ADD, ABD, MATH2, SIZE(1), 0);
	MATHB(MATH3, ADD, OFIFO, MATH2, SIZE(8), 0);
	MATHB(MATH3, ADD, ONE, MATH2, SIZE(1), WITH(NFU));
	MATHB(MATH3, ADD, ZERO, MATH2, SIZE(2), 0);
	MATHB(IMM(275128321), ADD, MATH0, MATH2, SIZE(8), WITH(IFB | STL));
	MATHB(IMM(275128321), ADD, MATH1, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(275128321), ADD, MATH2, MATH2, SIZE(2), 0);
	MATHB(IMM(275128321), ADD, MATH3, MATH2, SIZE(2), 0);
	MATHB(IMM(275128321), ADD, IMM(393615378), MATH2, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), ADD, DPOVRD, MATH2, SIZE(4), 0);
	MATHB(IMM(275128321), ADD, VSEQINSZ, MATH2, SIZE(2), 0);
	MATHB(IMM(0x19261959fedcba01), ADD, VSEQOUTSZ, MATH2, SIZE(8),
	      WITH(STL));
	MATHB(IMM(275128321), ADD, ABD, MATH2, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), ADD, OFIFO, MATH2, SIZE(2), WITH(STL));
	MATHB(IMM(275128321), ADD, ONE, MATH2, SIZE(2), WITH(NFU));
	MATHB(IMM(275128321), ADD, ZERO, MATH2, SIZE(1), 0);
	MATHB(DPOVRD, ADD, MATH0, MATH2, SIZE(4), 0);
	MATHB(DPOVRD, ADD, MATH1, MATH2, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, ADD, MATH2, MATH2, SIZE(4), 0);
	MATHB(DPOVRD, ADD, MATH3, MATH2, SIZE(4), 0);
	MATHB(DPOVRD, ADD, IMM(393615378), MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, ADD, DPOVRD, MATH2, SIZE(4), WITH(STL));
	MATHB(DPOVRD, ADD, VSEQINSZ, MATH2, SIZE(1), WITH(NFU));
	MATHB(DPOVRD, ADD, VSEQOUTSZ, MATH2, SIZE(1), WITH(STL));
	MATHB(DPOVRD, ADD, ABD, MATH2, SIZE(4), 0);
	MATHB(DPOVRD, ADD, OFIFO, MATH2, SIZE(4), WITH(STL));
	MATHB(DPOVRD, ADD, ONE, MATH2, SIZE(2), WITH(STL));
	MATHB(DPOVRD, ADD, ZERO, MATH2, SIZE(4), 0);
	MATHB(SEQINSZ, ADD, MATH0, MATH2, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, ADD, MATH1, MATH2, SIZE(4), 0);
	MATHB(SEQINSZ, ADD, MATH2, MATH2, SIZE(8), 0);
	MATHB(SEQINSZ, ADD, MATH3, MATH2, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, ADD, IMM(393615378), MATH2, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, ADD, DPOVRD, MATH2, SIZE(4), 0);
	MATHB(SEQINSZ, ADD, VSEQINSZ, MATH2, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, ADD, VSEQOUTSZ, MATH2, SIZE(8), 0);
	MATHB(SEQINSZ, ADD, ABD, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, ADD, OFIFO, MATH2, SIZE(1), 0);
	MATHB(SEQINSZ, ADD, ONE, MATH2, SIZE(8), 0);
	MATHB(SEQINSZ, ADD, ZERO, MATH2, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADD, MATH0, MATH2, SIZE(8), 0);
	MATHB(SEQOUTSZ, ADD, MATH1, MATH2, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, ADD, MATH2, MATH2, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADD, MATH3, MATH2, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADD, IMM(393615378), MATH2, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, ADD, DPOVRD, MATH2, SIZE(8), 0);
	MATHB(SEQOUTSZ, ADD, VSEQINSZ, MATH2, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADD, VSEQOUTSZ, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADD, ABD, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADD, OFIFO, MATH2, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, ADD, ONE, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADD, ZERO, MATH2, SIZE(8), 0);
	MATHB(VSEQINSZ, ADD, MATH0, MATH2, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, ADD, MATH1, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, ADD, MATH2, MATH2, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, ADD, MATH3, MATH2, SIZE(4), WITH(STL));
	MATHB(VSEQINSZ, ADD, IMM(393615378), MATH2, SIZE(8), WITH(IFB));
	MATHB(VSEQINSZ, ADD, DPOVRD, MATH2, SIZE(2), 0);
	MATHB(VSEQINSZ, ADD, VSEQINSZ, MATH2, SIZE(1), 0);
	MATHB(VSEQINSZ, ADD, VSEQOUTSZ, MATH2, SIZE(4), 0);
	MATHB(VSEQINSZ, ADD, ABD, MATH2, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, ADD, OFIFO, MATH2, SIZE(2), 0);
	MATHB(VSEQINSZ, ADD, ONE, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, ADD, ZERO, MATH2, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADD, MATH0, MATH2, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, ADD, MATH1, MATH2, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADD, MATH2, MATH2, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, ADD, MATH3, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADD, IMM(393615378), MATH2, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, ADD, DPOVRD, MATH2, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADD, VSEQINSZ, MATH2, SIZE(8), 0);
	MATHB(VSEQOUTSZ, ADD, VSEQOUTSZ, MATH2, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADD, ABD, MATH2, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, ADD, OFIFO, MATH2, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADD, ONE, MATH2, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, ADD, ZERO, MATH2, SIZE(1), 0);
	MATHB(ZERO, ADD, MATH0, MATH2, SIZE(1), 0);
	MATHB(ZERO, ADD, MATH1, MATH2, SIZE(1), 0);
	MATHB(ZERO, ADD, MATH2, MATH2, SIZE(2), WITH(STL));
	MATHB(ZERO, ADD, MATH3, MATH2, SIZE(1), 0);
	MATHB(ZERO, ADD, IMM(393615378), MATH2, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, ADD, DPOVRD, MATH2, SIZE(1), 0);
	MATHB(ZERO, ADD, VSEQINSZ, MATH2, SIZE(1), 0);
	MATHB(ZERO, ADD, VSEQOUTSZ, MATH2, SIZE(4), 0);
	MATHB(ZERO, ADD, ABD, MATH2, SIZE(4), 0);
	MATHB(ZERO, ADD, OFIFO, MATH2, SIZE(4), 0);
	MATHB(ZERO, ADD, ONE, MATH2, SIZE(8), 0);
	MATHB(ZERO, ADD, ZERO, MATH2, SIZE(2), 0);
	MATHB(ONE, ADD, MATH0, MATH2, SIZE(8), 0);
	MATHB(ONE, ADD, MATH1, MATH2, SIZE(1), WITH(STL));
	MATHB(ONE, ADD, MATH2, MATH2, SIZE(8), 0);
	MATHB(ONE, ADD, MATH3, MATH2, SIZE(2), 0);
	MATHB(ONE, ADD, IMM(393615378), MATH2, SIZE(2), WITH(STL));
	MATHB(ONE, ADD, DPOVRD, MATH2, SIZE(1), 0);
	MATHB(ONE, ADD, VSEQINSZ, MATH2, SIZE(2), 0);
	MATHB(ONE, ADD, VSEQOUTSZ, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, ADD, ABD, MATH2, SIZE(1), 0);
	MATHB(ONE, ADD, OFIFO, MATH2, SIZE(2), 0);
	MATHB(ONE, ADD, ONE, MATH2, SIZE(4), WITH(STL));
	MATHB(ONE, ADD, ZERO, MATH2, SIZE(1), 0);
	/* ADD Operation: MATH3 Destination register */
	MATHB(MATH0, ADD, MATH0, MATH3, SIZE(8), 0);
	MATHB(MATH0, ADD, MATH1, MATH3, SIZE(4), WITH(STL));
	MATHB(MATH0, ADD, MATH2, MATH3, SIZE(2), 0);
	MATHB(MATH0, ADD, MATH3, MATH3, SIZE(4), WITH(STL));
	MATHB(MATH0, ADD, IMM(393615378), MATH3, SIZE(1), 0);
	MATHB(MATH0, ADD, DPOVRD, MATH3, SIZE(4), 0);
	MATHB(MATH0, ADD, VSEQINSZ, MATH3, SIZE(2), 0);
	MATHB(MATH0, ADD, VSEQOUTSZ, MATH3, SIZE(8), 0);
	MATHB(MATH0, ADD, ABD, MATH3, SIZE(4), 0);
	MATHB(MATH0, ADD, OFIFO, MATH3, SIZE(1), 0);
	MATHB(MATH0, ADD, ONE, MATH3, SIZE(4), WITH(STL));
	MATHB(MATH0, ADD, ZERO, MATH3, SIZE(1), 0);
	MATHB(MATH1, ADD, MATH0, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(MATH1, ADD, MATH1, MATH3, SIZE(1), WITH(STL));
	MATHB(MATH1, ADD, MATH2, MATH3, SIZE(2), 0);
	MATHB(MATH1, ADD, MATH3, MATH3, SIZE(1), 0);
	MATHB(MATH1, ADD, IMM(393615378), MATH3, SIZE(4), 0);
	MATHB(MATH1, ADD, DPOVRD, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, ADD, VSEQINSZ, MATH3, SIZE(2), 0);
	MATHB(MATH1, ADD, VSEQOUTSZ, MATH3, SIZE(1), 0);
	MATHB(MATH1, ADD, ABD, MATH3, SIZE(1), WITH(NFU));
	MATHB(MATH1, ADD, OFIFO, MATH3, SIZE(1), 0);
	MATHB(MATH1, ADD, ONE, MATH3, SIZE(4), 0);
	MATHB(MATH1, ADD, ZERO, MATH3, SIZE(1), 0);
	MATHB(MATH2, ADD, MATH0, MATH3, SIZE(1), 0);
	MATHB(MATH2, ADD, MATH1, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, ADD, MATH2, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, ADD, MATH3, MATH3, SIZE(8), WITH(STL));
	MATHB(MATH2, ADD, IMM(393615378), MATH3, SIZE(1), 0);
	MATHB(MATH2, ADD, DPOVRD, MATH3, SIZE(1), 0);
	MATHB(MATH2, ADD, VSEQINSZ, MATH3, SIZE(8), 0);
	MATHB(MATH2, ADD, VSEQOUTSZ, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, ADD, ABD, MATH3, SIZE(4), 0);
	MATHB(MATH2, ADD, OFIFO, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, ADD, ONE, MATH3, SIZE(4), 0);
	MATHB(MATH2, ADD, ZERO, MATH3, SIZE(2), 0);
	MATHB(MATH3, ADD, MATH0, MATH3, SIZE(4), WITH(STL));
	MATHB(MATH3, ADD, MATH1, MATH3, SIZE(1), WITH(NFU));
	MATHB(MATH3, ADD, MATH2, MATH3, SIZE(8), 0);
	MATHB(MATH3, ADD, MATH3, MATH3, SIZE(4), 0);
	MATHB(MATH3, ADD, IMM(393615378), MATH3, SIZE(2), WITH(STL));
	MATHB(MATH3, ADD, DPOVRD, MATH3, SIZE(2), WITH(STL));
	MATHB(MATH3, ADD, VSEQINSZ, MATH3, SIZE(8), 0);
	MATHB(MATH3, ADD, VSEQOUTSZ, MATH3, SIZE(2), 0);
	MATHB(MATH3, ADD, ABD, MATH3, SIZE(2), 0);
	MATHB(MATH3, ADD, OFIFO, MATH3, SIZE(8), 0);
	MATHB(MATH3, ADD, ONE, MATH3, SIZE(2), 0);
	MATHB(MATH3, ADD, ZERO, MATH3, SIZE(8), WITH(STL));
	MATHB(IMM(275128321), ADD, MATH0, MATH3, SIZE(2), 0);
	MATHB(IMM(275128321), ADD, MATH1, MATH3, SIZE(4), WITH(NFU));
	MATHB(IMM(0x19261959fedcba01), ADD, MATH2, MATH3, SIZE(8), 0);
	MATHB(IMM(275128321), ADD, MATH3, MATH3, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), ADD, IMM(393615378), MATH3, SIZE(4), 0);
	MATHB(IMM(275128321), ADD, DPOVRD, MATH3, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), ADD, VSEQINSZ, MATH3, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), ADD, VSEQOUTSZ, MATH3, SIZE(4), 0);
	MATHB(IMM(275128321), ADD, ABD, MATH3, SIZE(2), 0);
	MATHB(IMM(275128321), ADD, OFIFO, MATH3, SIZE(2), 0);
	MATHB(IMM(275128321), ADD, ONE, MATH3, SIZE(2), 0);
	MATHB(IMM(275128321), ADD, ZERO, MATH3, SIZE(4), 0);
	MATHB(DPOVRD, ADD, MATH0, MATH3, SIZE(2), 0);
	MATHB(DPOVRD, ADD, MATH1, MATH3, SIZE(1), 0);
	MATHB(DPOVRD, ADD, MATH2, MATH3, SIZE(1), 0);
	MATHB(DPOVRD, ADD, MATH3, MATH3, SIZE(1), 0);
	MATHB(DPOVRD, ADD, IMM(393615378), MATH3, SIZE(1), WITH(NFU));
	MATHB(DPOVRD, ADD, DPOVRD, MATH3, SIZE(1), WITH(STL));
	MATHB(DPOVRD, ADD, VSEQINSZ, MATH3, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, ADD, VSEQOUTSZ, MATH3, SIZE(8), 0);
	MATHB(DPOVRD, ADD, ABD, MATH3, SIZE(8), 0);
	MATHB(DPOVRD, ADD, OFIFO, MATH3, SIZE(8), 0);
	MATHB(DPOVRD, ADD, ONE, MATH3, SIZE(1), 0);
	MATHB(DPOVRD, ADD, ZERO, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, ADD, MATH0, MATH3, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, ADD, MATH1, MATH3, SIZE(1), 0);
	MATHB(SEQINSZ, ADD, MATH2, MATH3, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, ADD, MATH3, MATH3, SIZE(1), 0);
	MATHB(SEQINSZ, ADD, IMM(393615378), MATH3, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, ADD, DPOVRD, MATH3, SIZE(8), 0);
	MATHB(SEQINSZ, ADD, VSEQINSZ, MATH3, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, ADD, VSEQOUTSZ, MATH3, SIZE(4), 0);
	MATHB(SEQINSZ, ADD, ABD, MATH3, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, ADD, OFIFO, MATH3, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, ADD, ONE, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, ADD, ZERO, MATH3, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, ADD, MATH0, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADD, MATH1, MATH3, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADD, MATH2, MATH3, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADD, MATH3, MATH3, SIZE(8), 0);
	MATHB(SEQOUTSZ, ADD, IMM(393615378), MATH3, SIZE(2), 0);
	MATHB(SEQOUTSZ, ADD, DPOVRD, MATH3, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADD, VSEQINSZ, MATH3, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, ADD, VSEQOUTSZ, MATH3, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADD, ABD, MATH3, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADD, OFIFO, MATH3, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, ADD, ONE, MATH3, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, ADD, ZERO, MATH3, SIZE(1), 0);
	MATHB(VSEQINSZ, ADD, MATH0, MATH3, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, ADD, MATH1, MATH3, SIZE(2), 0);
	MATHB(VSEQINSZ, ADD, MATH2, MATH3, SIZE(4), WITH(STL));
	MATHB(VSEQINSZ, ADD, MATH3, MATH3, SIZE(4), WITH(STL));
	MATHB(VSEQINSZ, ADD, IMM(393615378), MATH3, SIZE(4), 0);
	MATHB(VSEQINSZ, ADD, DPOVRD, MATH3, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, ADD, VSEQINSZ, MATH3, SIZE(4), 0);
	MATHB(VSEQINSZ, ADD, VSEQOUTSZ, MATH3, SIZE(4), 0);
	MATHB(VSEQINSZ, ADD, ABD, MATH3, SIZE(2), 0);
	MATHB(VSEQINSZ, ADD, OFIFO, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, ADD, ONE, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, ADD, ZERO, MATH3, SIZE(8), 0);
	MATHB(VSEQOUTSZ, ADD, MATH0, MATH3, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADD, MATH1, MATH3, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, ADD, MATH2, MATH3, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, ADD, MATH3, MATH3, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADD, IMM(393615378), MATH3, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADD, DPOVRD, MATH3, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADD, VSEQINSZ, MATH3, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADD, VSEQOUTSZ, MATH3, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, ADD, ABD, MATH3, SIZE(8), 0);
	MATHB(VSEQOUTSZ, ADD, OFIFO, MATH3, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, ADD, ONE, MATH3, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADD, ZERO, MATH3, SIZE(8), WITH(STL));
	MATHB(ZERO, ADD, MATH0, MATH3, SIZE(4), 0);
	MATHB(ZERO, ADD, MATH1, MATH3, SIZE(4), 0);
	MATHB(ZERO, ADD, MATH2, MATH3, SIZE(4), 0);
	MATHB(ZERO, ADD, MATH3, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, ADD, IMM(393615378), MATH3, SIZE(2), 0);
	MATHB(ZERO, ADD, DPOVRD, MATH3, SIZE(2), WITH(NFU));
	MATHB(ZERO, ADD, VSEQINSZ, MATH3, SIZE(8), WITH(NFU));
	MATHB(ZERO, ADD, VSEQOUTSZ, MATH3, SIZE(1), 0);
	MATHB(ZERO, ADD, ABD, MATH3, SIZE(1), 0);
	MATHB(ZERO, ADD, OFIFO, MATH3, SIZE(2), 0);
	MATHB(ZERO, ADD, ONE, MATH3, SIZE(8), WITH(STL));
	MATHB(ZERO, ADD, ZERO, MATH3, SIZE(4), WITH(NFU));
	MATHB(ONE, ADD, MATH0, MATH3, SIZE(8), WITH(NFU));
	MATHB(ONE, ADD, MATH1, MATH3, SIZE(4), WITH(NFU));
	MATHB(ONE, ADD, MATH2, MATH3, SIZE(1), 0);
	MATHB(ONE, ADD, MATH3, MATH3, SIZE(1), 0);
	MATHB(ONE, ADD, IMM(393615378), MATH3, SIZE(2), WITH(STL));
	MATHB(ONE, ADD, DPOVRD, MATH3, SIZE(1), 0);
	MATHB(ONE, ADD, VSEQINSZ, MATH3, SIZE(1), 0);
	MATHB(ONE, ADD, VSEQOUTSZ, MATH3, SIZE(1), 0);
	MATHB(ONE, ADD, ABD, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, ADD, OFIFO, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, ADD, ONE, MATH3, SIZE(4), WITH(STL));
	MATHB(ONE, ADD, ZERO, MATH3, SIZE(2), 0);
	/* ADD Operation: DPOVRD Destination register */
	MATHB(MATH0, ADD, MATH0, DPOVRD, SIZE(2), 0);
	MATHB(MATH0, ADD, MATH1, DPOVRD, SIZE(8), 0);
	MATHB(MATH0, ADD, MATH2, DPOVRD, SIZE(8), 0);
	MATHB(MATH0, ADD, MATH3, DPOVRD, SIZE(2), 0);
	MATHB(MATH0, ADD, IMM(393615378), DPOVRD, SIZE(4), WITH(NFU));
	MATHB(MATH0, ADD, DPOVRD, DPOVRD, SIZE(2), 0);
	MATHB(MATH0, ADD, VSEQINSZ, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, ADD, VSEQOUTSZ, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, ADD, ABD, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, ADD, OFIFO, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, ADD, ONE, DPOVRD, SIZE(1), 0);
	MATHB(MATH0, ADD, ZERO, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, ADD, MATH0, DPOVRD, SIZE(4), 0);
	MATHB(MATH1, ADD, MATH1, DPOVRD, SIZE(4), 0);
	MATHB(MATH1, ADD, MATH2, DPOVRD, SIZE(8), 0);
	MATHB(MATH1, ADD, MATH3, DPOVRD, SIZE(1), 0);
	MATHB(MATH1, ADD, IMM(393615378), DPOVRD, SIZE(8), WITH(IFB | STL));
	MATHB(MATH1, ADD, DPOVRD, DPOVRD, SIZE(1), WITH(STL));
	MATHB(MATH1, ADD, VSEQINSZ, DPOVRD, SIZE(4), 0);
	MATHB(MATH1, ADD, VSEQOUTSZ, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(MATH1, ADD, ABD, DPOVRD, SIZE(4), 0);
	MATHB(MATH1, ADD, OFIFO, DPOVRD, SIZE(1), 0);
	MATHB(MATH1, ADD, ONE, DPOVRD, SIZE(4), 0);
	MATHB(MATH1, ADD, ZERO, DPOVRD, SIZE(2), 0);
	MATHB(MATH2, ADD, MATH0, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(MATH2, ADD, MATH1, DPOVRD, SIZE(1), 0);
	MATHB(MATH2, ADD, MATH2, DPOVRD, SIZE(8), 0);
	MATHB(MATH2, ADD, MATH3, DPOVRD, SIZE(2), 0);
	MATHB(MATH2, ADD, IMM(393615378), DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, ADD, DPOVRD, DPOVRD, SIZE(8), WITH(STL));
	MATHB(MATH2, ADD, VSEQINSZ, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, ADD, VSEQOUTSZ, DPOVRD, SIZE(4), 0);
	MATHB(MATH2, ADD, ABD, DPOVRD, SIZE(4), 0);
	MATHB(MATH2, ADD, OFIFO, DPOVRD, SIZE(4), 0);
	MATHB(MATH2, ADD, ONE, DPOVRD, SIZE(8), 0);
	MATHB(MATH2, ADD, ZERO, DPOVRD, SIZE(1), 0);
	MATHB(MATH3, ADD, MATH0, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, ADD, MATH1, DPOVRD, SIZE(2), WITH(STL));
	MATHB(MATH3, ADD, MATH2, DPOVRD, SIZE(4), 0);
	MATHB(MATH3, ADD, MATH3, DPOVRD, SIZE(1), 0);
	MATHB(MATH3, ADD, IMM(393615378), DPOVRD, SIZE(1), 0);
	MATHB(MATH3, ADD, DPOVRD, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(MATH3, ADD, VSEQINSZ, DPOVRD, SIZE(2), 0);
	MATHB(MATH3, ADD, VSEQOUTSZ, DPOVRD, SIZE(2), 0);
	MATHB(MATH3, ADD, ABD, DPOVRD, SIZE(2), 0);
	MATHB(MATH3, ADD, OFIFO, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, ADD, ONE, DPOVRD, SIZE(2), 0);
	MATHB(MATH3, ADD, ZERO, DPOVRD, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), ADD, MATH0, DPOVRD, SIZE(1), 0);
	MATHB(IMM(275128321), ADD, MATH1, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), ADD, MATH2, DPOVRD, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), ADD, MATH3, DPOVRD, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), ADD, IMM(393615378), DPOVRD, SIZE(2),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), ADD, DPOVRD, DPOVRD, SIZE(8), WITH(IFB | STL));
	MATHB(IMM(275128321), ADD, VSEQINSZ, DPOVRD, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), ADD, VSEQOUTSZ, DPOVRD, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), ADD, ABD, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(0x19261959fedcba01), ADD, OFIFO, DPOVRD, SIZE(8), 0);
	MATHB(IMM(275128321), ADD, ONE, DPOVRD, SIZE(1), 0);
	MATHB(IMM(275128321), ADD, ZERO, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, ADD, MATH0, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, ADD, MATH1, DPOVRD, SIZE(8), 0);
	MATHB(DPOVRD, ADD, MATH2, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, ADD, MATH3, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, ADD, IMM(393615378), DPOVRD, SIZE(8), WITH(IFB | STL));
	MATHB(DPOVRD, ADD, DPOVRD, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, ADD, VSEQINSZ, DPOVRD, SIZE(4), WITH(STL));
	MATHB(DPOVRD, ADD, VSEQOUTSZ, DPOVRD, SIZE(4), 0);
	MATHB(DPOVRD, ADD, ABD, DPOVRD, SIZE(8), WITH(STL));
	MATHB(DPOVRD, ADD, OFIFO, DPOVRD, SIZE(1), 0);
	MATHB(DPOVRD, ADD, ONE, DPOVRD, SIZE(4), 0);
	MATHB(DPOVRD, ADD, ZERO, DPOVRD, SIZE(1), 0);
	MATHB(SEQINSZ, ADD, MATH0, DPOVRD, SIZE(2), 0);
	MATHB(SEQINSZ, ADD, MATH1, DPOVRD, SIZE(2), 0);
	MATHB(SEQINSZ, ADD, MATH2, DPOVRD, SIZE(4), 0);
	MATHB(SEQINSZ, ADD, MATH3, DPOVRD, SIZE(4), 0);
	MATHB(SEQINSZ, ADD, IMM(393615378), DPOVRD, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, ADD, DPOVRD, DPOVRD, SIZE(4), 0);
	MATHB(SEQINSZ, ADD, VSEQINSZ, DPOVRD, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, ADD, VSEQOUTSZ, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, ADD, ABD, DPOVRD, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, ADD, OFIFO, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, ADD, ONE, DPOVRD, SIZE(4), 0);
	MATHB(SEQINSZ, ADD, ZERO, DPOVRD, SIZE(8), 0);
	MATHB(SEQOUTSZ, ADD, MATH0, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADD, MATH1, DPOVRD, SIZE(8), 0);
	MATHB(SEQOUTSZ, ADD, MATH2, DPOVRD, SIZE(8), 0);
	MATHB(SEQOUTSZ, ADD, MATH3, DPOVRD, SIZE(2), 0);
	MATHB(SEQOUTSZ, ADD, IMM(393615378), DPOVRD, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, ADD, DPOVRD, DPOVRD, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, ADD, VSEQINSZ, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, ADD, VSEQOUTSZ, DPOVRD, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADD, ABD, DPOVRD, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, ADD, OFIFO, DPOVRD, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADD, ONE, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADD, ZERO, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, ADD, MATH0, DPOVRD, SIZE(4), 0);
	MATHB(VSEQINSZ, ADD, MATH1, DPOVRD, SIZE(4), 0);
	MATHB(VSEQINSZ, ADD, MATH2, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, ADD, MATH3, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, ADD, IMM(393615378), DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, ADD, DPOVRD, DPOVRD, SIZE(4), 0);
	MATHB(VSEQINSZ, ADD, VSEQINSZ, DPOVRD, SIZE(2), 0);
	MATHB(VSEQINSZ, ADD, VSEQOUTSZ, DPOVRD, SIZE(4), 0);
	MATHB(VSEQINSZ, ADD, ABD, DPOVRD, SIZE(4), 0);
	MATHB(VSEQINSZ, ADD, OFIFO, DPOVRD, SIZE(8), 0);
	MATHB(VSEQINSZ, ADD, ONE, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, ADD, ZERO, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADD, MATH0, DPOVRD, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, ADD, MATH1, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, ADD, MATH2, DPOVRD, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, ADD, MATH3, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADD, IMM(393615378), DPOVRD, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADD, DPOVRD, DPOVRD, SIZE(8), 0);
	MATHB(VSEQOUTSZ, ADD, VSEQINSZ, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADD, VSEQOUTSZ, DPOVRD, SIZE(8), 0);
	MATHB(VSEQOUTSZ, ADD, ABD, DPOVRD, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, ADD, OFIFO, DPOVRD, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADD, ONE, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, ADD, ZERO, DPOVRD, SIZE(1), 0);
	MATHB(ZERO, ADD, MATH0, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(ZERO, ADD, MATH1, DPOVRD, SIZE(1), 0);
	MATHB(ZERO, ADD, MATH2, DPOVRD, SIZE(1), 0);
	MATHB(ZERO, ADD, MATH3, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, ADD, IMM(393615378), DPOVRD, SIZE(8), WITH(IFB));
	MATHB(ZERO, ADD, DPOVRD, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, ADD, VSEQINSZ, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, ADD, VSEQOUTSZ, DPOVRD, SIZE(8), WITH(STL));
	MATHB(ZERO, ADD, ABD, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(ZERO, ADD, OFIFO, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(ZERO, ADD, ONE, DPOVRD, SIZE(4), 0);
	MATHB(ZERO, ADD, ZERO, DPOVRD, SIZE(2), 0);
	MATHB(ONE, ADD, MATH0, DPOVRD, SIZE(1), 0);
	MATHB(ONE, ADD, MATH1, DPOVRD, SIZE(8), WITH(STL));
	MATHB(ONE, ADD, MATH2, DPOVRD, SIZE(4), 0);
	MATHB(ONE, ADD, MATH3, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(ONE, ADD, IMM(393615378), DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, ADD, DPOVRD, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(ONE, ADD, VSEQINSZ, DPOVRD, SIZE(8), 0);
	MATHB(ONE, ADD, VSEQOUTSZ, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(ONE, ADD, ABD, DPOVRD, SIZE(2), 0);
	MATHB(ONE, ADD, OFIFO, DPOVRD, SIZE(8), WITH(STL));
	MATHB(ONE, ADD, ONE, DPOVRD, SIZE(1), 0);
	MATHB(ONE, ADD, ZERO, DPOVRD, SIZE(2), WITH(NFU));
	/* ADD Operation: SEQINSZ Destination register */
	MATHB(MATH0, ADD, MATH0, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, ADD, MATH1, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, ADD, MATH2, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, ADD, MATH3, SEQINSZ, SIZE(8), 0);
	MATHB(MATH0, ADD, IMM(393615378), SEQINSZ, SIZE(4), 0);
	MATHB(MATH0, ADD, DPOVRD, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH0, ADD, VSEQINSZ, SEQINSZ, SIZE(4), 0);
	MATHB(MATH0, ADD, VSEQOUTSZ, SEQINSZ, SIZE(2), 0);
	MATHB(MATH0, ADD, ABD, SEQINSZ, SIZE(1), 0);
	MATHB(MATH0, ADD, OFIFO, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH0, ADD, ONE, SEQINSZ, SIZE(1), 0);
	MATHB(MATH0, ADD, ZERO, SEQINSZ, SIZE(4), 0);
	MATHB(MATH1, ADD, MATH0, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH1, ADD, MATH1, SEQINSZ, SIZE(2), 0);
	MATHB(MATH1, ADD, MATH2, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH1, ADD, MATH3, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(MATH1, ADD, IMM(393615378), SEQINSZ, SIZE(4), 0);
	MATHB(MATH1, ADD, DPOVRD, SEQINSZ, SIZE(8), 0);
	MATHB(MATH1, ADD, VSEQINSZ, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH1, ADD, VSEQOUTSZ, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(MATH1, ADD, ABD, SEQINSZ, SIZE(1), 0);
	MATHB(MATH1, ADD, OFIFO, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(MATH1, ADD, ONE, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH1, ADD, ZERO, SEQINSZ, SIZE(2), 0);
	MATHB(MATH2, ADD, MATH0, SEQINSZ, SIZE(8), 0);
	MATHB(MATH2, ADD, MATH1, SEQINSZ, SIZE(2), 0);
	MATHB(MATH2, ADD, MATH2, SEQINSZ, SIZE(4), 0);
	MATHB(MATH2, ADD, MATH3, SEQINSZ, SIZE(8), 0);
	MATHB(MATH2, ADD, IMM(393615378), SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH2, ADD, DPOVRD, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, ADD, VSEQINSZ, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, ADD, VSEQOUTSZ, SEQINSZ, SIZE(4), 0);
	MATHB(MATH2, ADD, ABD, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, ADD, OFIFO, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, ADD, ONE, SEQINSZ, SIZE(8), 0);
	MATHB(MATH2, ADD, ZERO, SEQINSZ, SIZE(4), 0);
	MATHB(MATH3, ADD, MATH0, SEQINSZ, SIZE(4), 0);
	MATHB(MATH3, ADD, MATH1, SEQINSZ, SIZE(1), 0);
	MATHB(MATH3, ADD, MATH2, SEQINSZ, SIZE(2), 0);
	MATHB(MATH3, ADD, MATH3, SEQINSZ, SIZE(1), 0);
	MATHB(MATH3, ADD, IMM(393615378), SEQINSZ, SIZE(2), 0);
	MATHB(MATH3, ADD, DPOVRD, SEQINSZ, SIZE(1), 0);
	MATHB(MATH3, ADD, VSEQINSZ, SEQINSZ, SIZE(2), 0);
	MATHB(MATH3, ADD, VSEQOUTSZ, SEQINSZ, SIZE(8), 0);
	MATHB(MATH3, ADD, ABD, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH3, ADD, OFIFO, SEQINSZ, SIZE(8), 0);
	MATHB(MATH3, ADD, ONE, SEQINSZ, SIZE(1), 0);
	MATHB(MATH3, ADD, ZERO, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(IMM(275128321), ADD, MATH0, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), ADD, MATH1, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), ADD, MATH2, SEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), ADD, MATH3, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), ADD, IMM(393615378), SEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), ADD, DPOVRD, SEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), ADD, VSEQINSZ, SEQINSZ, SIZE(4), 0);
	MATHB(IMM(275128321), ADD, VSEQOUTSZ, SEQINSZ, SIZE(4), 0);
	MATHB(IMM(275128321), ADD, ABD, SEQINSZ, SIZE(1), 0);
	MATHB(IMM(0x19261959fedcba01), ADD, OFIFO, SEQINSZ, SIZE(8), 0);
	MATHB(IMM(275128321), ADD, ONE, SEQINSZ, SIZE(4), 0);
	MATHB(IMM(275128321), ADD, ZERO, SEQINSZ, SIZE(8), WITH(IFB | STL));
	MATHB(DPOVRD, ADD, MATH0, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(DPOVRD, ADD, MATH1, SEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, ADD, MATH2, SEQINSZ, SIZE(4), 0);
	MATHB(DPOVRD, ADD, MATH3, SEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, ADD, IMM(393615378), SEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, ADD, DPOVRD, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, ADD, VSEQINSZ, SEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, ADD, VSEQOUTSZ, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(DPOVRD, ADD, ABD, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(DPOVRD, ADD, OFIFO, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, ADD, ONE, SEQINSZ, SIZE(1), 0);
	MATHB(DPOVRD, ADD, ZERO, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, ADD, MATH0, SEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, ADD, MATH1, SEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, ADD, MATH2, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, ADD, MATH3, SEQINSZ, SIZE(4), 0);
	MATHB(SEQINSZ, ADD, IMM(0x19261959fedcba01), SEQINSZ, SIZE(8), 0);
	MATHB(SEQINSZ, ADD, DPOVRD, SEQINSZ, SIZE(1), 0);
	MATHB(SEQINSZ, ADD, VSEQINSZ, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, ADD, VSEQOUTSZ, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, ADD, ABD, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, ADD, OFIFO, SEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, ADD, ONE, SEQINSZ, SIZE(1), 0);
	MATHB(SEQINSZ, ADD, ZERO, SEQINSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADD, MATH0, SEQINSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADD, MATH1, SEQINSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADD, MATH2, SEQINSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADD, MATH3, SEQINSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADD, IMM(393615378), SEQINSZ, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, ADD, DPOVRD, SEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, ADD, VSEQINSZ, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADD, VSEQOUTSZ, SEQINSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADD, ABD, SEQINSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADD, OFIFO, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, ADD, ONE, SEQINSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADD, ZERO, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, ADD, MATH0, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, ADD, MATH1, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, ADD, MATH2, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, ADD, MATH3, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQINSZ, ADD, IMM(393615378), SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, ADD, DPOVRD, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, ADD, VSEQINSZ, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, ADD, VSEQOUTSZ, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, ADD, ABD, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, ADD, OFIFO, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQINSZ, ADD, ONE, SEQINSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, ADD, ZERO, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, ADD, MATH0, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, ADD, MATH1, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, ADD, MATH2, SEQINSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADD, MATH3, SEQINSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADD, IMM(393615378), SEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, ADD, DPOVRD, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, ADD, VSEQINSZ, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, ADD, VSEQOUTSZ, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADD, ABD, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADD, OFIFO, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, ADD, ONE, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADD, ZERO, SEQINSZ, SIZE(4), 0);
	MATHB(ZERO, ADD, MATH0, SEQINSZ, SIZE(8), 0);
	MATHB(ZERO, ADD, MATH1, SEQINSZ, SIZE(4), 0);
	MATHB(ZERO, ADD, MATH2, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(ZERO, ADD, MATH3, SEQINSZ, SIZE(8), 0);
	MATHB(ZERO, ADD, IMM(393615378), SEQINSZ, SIZE(1), 0);
	MATHB(ZERO, ADD, DPOVRD, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(ZERO, ADD, VSEQINSZ, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, ADD, VSEQOUTSZ, SEQINSZ, SIZE(8), 0);
	MATHB(ZERO, ADD, ABD, SEQINSZ, SIZE(8), 0);
	MATHB(ZERO, ADD, OFIFO, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, ADD, ONE, SEQINSZ, SIZE(2), 0);
	MATHB(ZERO, ADD, ZERO, SEQINSZ, SIZE(4), 0);
	MATHB(ONE, ADD, MATH0, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(ONE, ADD, MATH1, SEQINSZ, SIZE(1), 0);
	MATHB(ONE, ADD, MATH2, SEQINSZ, SIZE(1), 0);
	MATHB(ONE, ADD, MATH3, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, ADD, IMM(393615378), SEQINSZ, SIZE(2), 0);
	MATHB(ONE, ADD, DPOVRD, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(ONE, ADD, VSEQINSZ, SEQINSZ, SIZE(8), 0);
	MATHB(ONE, ADD, VSEQOUTSZ, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(ONE, ADD, ABD, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(ONE, ADD, OFIFO, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(ONE, ADD, ONE, SEQINSZ, SIZE(2), 0);
	MATHB(ONE, ADD, ZERO, SEQINSZ, SIZE(4), WITH(STL));
	/* ADD Operation: SEQOUTSZ Destination register */
	MATHB(MATH0, ADD, MATH0, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH0, ADD, MATH1, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH0, ADD, MATH2, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH0, ADD, MATH3, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, ADD, IMM(393615378), SEQOUTSZ, SIZE(8), WITH(IFB | STL));
	MATHB(MATH0, ADD, DPOVRD, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, ADD, VSEQINSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH0, ADD, VSEQOUTSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, ADD, ABD, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(MATH0, ADD, OFIFO, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, ADD, ONE, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH0, ADD, ZERO, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, ADD, MATH0, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH1, ADD, MATH1, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH1, ADD, MATH2, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH1, ADD, MATH3, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(MATH1, ADD, IMM(393615378), SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH1, ADD, DPOVRD, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(MATH1, ADD, VSEQINSZ, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH1, ADD, VSEQOUTSZ, SEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(MATH1, ADD, ABD, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH1, ADD, OFIFO, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, ADD, ONE, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH1, ADD, ZERO, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH2, ADD, MATH0, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH2, ADD, MATH1, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH2, ADD, MATH2, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH2, ADD, MATH3, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, ADD, IMM(393615378), SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH2, ADD, DPOVRD, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, ADD, VSEQINSZ, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(MATH2, ADD, VSEQOUTSZ, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, ADD, ABD, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH2, ADD, OFIFO, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, ADD, ONE, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH2, ADD, ZERO, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(MATH3, ADD, MATH0, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, ADD, MATH1, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, ADD, MATH2, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH3, ADD, MATH3, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, ADD, IMM(393615378), SEQOUTSZ, SIZE(8), WITH(IFB));
	MATHB(MATH3, ADD, DPOVRD, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, ADD, VSEQINSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH3, ADD, VSEQOUTSZ, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, ADD, ABD, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, ADD, OFIFO, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH3, ADD, ONE, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, ADD, ZERO, SEQOUTSZ, SIZE(1), 0);
	MATHB(IMM(0x19261959fedcba01), ADD, MATH0, SEQOUTSZ, SIZE(8),
	      WITH(NFU | STL));
	MATHB(IMM(0x19261959fedcba01), ADD, MATH1, SEQOUTSZ, SIZE(8),
	      WITH(STL));
	MATHB(IMM(275128321), ADD, MATH2, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), ADD, MATH3, SEQOUTSZ, SIZE(1), 0);
	MATHB(IMM(275128321), ADD, IMM(393615378), SEQOUTSZ, SIZE(1),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), ADD, DPOVRD, SEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(0x19261959fedcba01), ADD, VSEQINSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(IMM(275128321), ADD, VSEQOUTSZ, SEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), ADD, ABD, SEQOUTSZ, SIZE(1), 0);
	MATHB(IMM(275128321), ADD, OFIFO, SEQOUTSZ, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), ADD, ONE, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), ADD, ZERO, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(DPOVRD, ADD, MATH0, SEQOUTSZ, SIZE(4), 0);
	MATHB(DPOVRD, ADD, MATH1, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(DPOVRD, ADD, MATH2, SEQOUTSZ, SIZE(4), 0);
	MATHB(DPOVRD, ADD, MATH3, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, ADD, IMM(393615378), SEQOUTSZ, SIZE(8),
	      WITH(IFB | NFU | STL));
	MATHB(DPOVRD, ADD, DPOVRD, SEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, ADD, VSEQINSZ, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(DPOVRD, ADD, VSEQOUTSZ, SEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(DPOVRD, ADD, ABD, SEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, ADD, OFIFO, SEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, ADD, ONE, SEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, ADD, ZERO, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, ADD, MATH0, SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQINSZ, ADD, MATH1, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, ADD, MATH2, SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, ADD, MATH3, SEQOUTSZ, SIZE(8), 0);
	MATHB(SEQINSZ, ADD, IMM(393615378), SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, ADD, DPOVRD, SEQOUTSZ, SIZE(8), 0);
	MATHB(SEQINSZ, ADD, VSEQINSZ, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, ADD, VSEQOUTSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(SEQINSZ, ADD, ABD, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, ADD, OFIFO, SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQINSZ, ADD, ONE, SEQOUTSZ, SIZE(8), 0);
	MATHB(SEQINSZ, ADD, ZERO, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADD, MATH0, SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADD, MATH1, SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADD, MATH2, SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, ADD, MATH3, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADD, IMM(393615378), SEQOUTSZ, SIZE(8),
	      WITH(IFB | STL));
	MATHB(SEQOUTSZ, ADD, DPOVRD, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, ADD, VSEQINSZ, SEQOUTSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADD, VSEQOUTSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, ADD, ABD, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, ADD, OFIFO, SEQOUTSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, ADD, ONE, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADD, ZERO, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, ADD, MATH0, SEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, ADD, MATH1, SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, ADD, MATH2, SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, ADD, MATH3, SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, ADD, IMM(393615378), SEQOUTSZ, SIZE(8), WITH(IFB));
	MATHB(VSEQINSZ, ADD, DPOVRD, SEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, ADD, VSEQINSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, ADD, VSEQOUTSZ, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, ADD, ABD, SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, ADD, OFIFO, SEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, ADD, ONE, SEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, ADD, ZERO, SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADD, MATH0, SEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, ADD, MATH1, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, ADD, MATH2, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, ADD, MATH3, SEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, ADD, IMM(393615378), SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADD, DPOVRD, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADD, VSEQINSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, ADD, VSEQOUTSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, ADD, ABD, SEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, ADD, OFIFO, SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADD, ONE, SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADD, ZERO, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, ADD, MATH0, SEQOUTSZ, SIZE(8), 0);
	MATHB(ZERO, ADD, MATH1, SEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, ADD, MATH2, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, ADD, MATH3, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(ZERO, ADD, IMM(0x19261959fedcba01), SEQOUTSZ, SIZE(8), 0);
	MATHB(ZERO, ADD, DPOVRD, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(ZERO, ADD, VSEQINSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(ZERO, ADD, VSEQOUTSZ, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(ZERO, ADD, ABD, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, ADD, OFIFO, SEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(ZERO, ADD, ONE, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(ZERO, ADD, ZERO, SEQOUTSZ, SIZE(8), 0);
	MATHB(ONE, ADD, MATH0, SEQOUTSZ, SIZE(2), 0);
	MATHB(ONE, ADD, MATH1, SEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, ADD, MATH2, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(ONE, ADD, MATH3, SEQOUTSZ, SIZE(8), 0);
	MATHB(ONE, ADD, IMM(393615378), SEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, ADD, DPOVRD, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, ADD, VSEQINSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(ONE, ADD, VSEQOUTSZ, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(ONE, ADD, ABD, SEQOUTSZ, SIZE(8), 0);
	MATHB(ONE, ADD, OFIFO, SEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, ADD, ONE, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(ONE, ADD, ZERO, SEQOUTSZ, SIZE(2), WITH(NFU));
	/* ADD Operation: VSEQINSZ Destination register */
	MATHB(MATH0, ADD, MATH0, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, ADD, MATH1, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH0, ADD, MATH2, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH0, ADD, MATH3, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH0, ADD, IMM(393615378), VSEQINSZ, SIZE(2), 0);
	MATHB(MATH0, ADD, DPOVRD, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH0, ADD, VSEQINSZ, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH0, ADD, VSEQOUTSZ, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(MATH0, ADD, ABD, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH0, ADD, OFIFO, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH0, ADD, ONE, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH0, ADD, ZERO, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, ADD, MATH0, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH1, ADD, MATH1, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH1, ADD, MATH2, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH1, ADD, MATH3, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH1, ADD, IMM(0x19261959fedcba01), VSEQINSZ, SIZE(8), 0);
	MATHB(MATH1, ADD, DPOVRD, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH1, ADD, VSEQINSZ, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, ADD, VSEQOUTSZ, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, ADD, ABD, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH1, ADD, OFIFO, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH1, ADD, ONE, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH1, ADD, ZERO, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH2, ADD, MATH0, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH2, ADD, MATH1, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, ADD, MATH2, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(MATH2, ADD, MATH3, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH2, ADD, IMM(393615378), VSEQINSZ, SIZE(4), 0);
	MATHB(MATH2, ADD, DPOVRD, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH2, ADD, VSEQINSZ, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH2, ADD, VSEQOUTSZ, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH2, ADD, ABD, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH2, ADD, OFIFO, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH2, ADD, ONE, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH2, ADD, ZERO, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH3, ADD, MATH0, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(MATH3, ADD, MATH1, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH3, ADD, MATH2, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH3, ADD, MATH3, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH3, ADD, IMM(393615378), VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(MATH3, ADD, DPOVRD, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, ADD, VSEQINSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH3, ADD, VSEQOUTSZ, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH3, ADD, ABD, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH3, ADD, OFIFO, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH3, ADD, ONE, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH3, ADD, ZERO, VSEQINSZ, SIZE(8), 0);
	MATHB(IMM(275128321), ADD, MATH0, VSEQINSZ, SIZE(4), 0);
	MATHB(IMM(275128321), ADD, MATH1, VSEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), ADD, MATH2, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(IMM(0x19261959fedcba01), ADD, MATH3, VSEQINSZ, SIZE(8), 0);
	MATHB(IMM(275128321), ADD, IMM(393615378), VSEQINSZ, SIZE(4),
	      WITH(NFU | STL));
	MATHB(IMM(0x19261959fedcba01), ADD, DPOVRD, VSEQINSZ, SIZE(8), 0);
	MATHB(IMM(275128321), ADD, VSEQINSZ, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(IMM(275128321), ADD, VSEQOUTSZ, VSEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), ADD, ABD, VSEQINSZ, SIZE(4), 0);
	MATHB(IMM(0x19261959fedcba01), ADD, OFIFO, VSEQINSZ, SIZE(8), 0);
	MATHB(IMM(275128321), ADD, ONE, VSEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), ADD, ZERO, VSEQINSZ, SIZE(1), 0);
	MATHB(DPOVRD, ADD, MATH0, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, ADD, MATH1, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(DPOVRD, ADD, MATH2, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(DPOVRD, ADD, MATH3, VSEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, ADD, IMM(393615378), VSEQINSZ, SIZE(1), 0);
	MATHB(DPOVRD, ADD, DPOVRD, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(DPOVRD, ADD, VSEQINSZ, VSEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, ADD, VSEQOUTSZ, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(DPOVRD, ADD, ABD, VSEQINSZ, SIZE(4), 0);
	MATHB(DPOVRD, ADD, OFIFO, VSEQINSZ, SIZE(1), 0);
	MATHB(DPOVRD, ADD, ONE, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, ADD, ZERO, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, ADD, MATH0, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, ADD, MATH1, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, ADD, MATH2, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, ADD, MATH3, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQINSZ, ADD, IMM(393615378), VSEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, ADD, DPOVRD, VSEQINSZ, SIZE(4), 0);
	MATHB(SEQINSZ, ADD, VSEQINSZ, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQINSZ, ADD, VSEQOUTSZ, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, ADD, ABD, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, ADD, OFIFO, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, ADD, ONE, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQINSZ, ADD, ZERO, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADD, MATH0, VSEQINSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADD, MATH1, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, ADD, MATH2, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADD, MATH3, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADD, IMM(393615378), VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, ADD, DPOVRD, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADD, VSEQINSZ, VSEQINSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADD, VSEQOUTSZ, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, ADD, ABD, VSEQINSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADD, OFIFO, VSEQINSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADD, ONE, VSEQINSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADD, ZERO, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, ADD, MATH0, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, ADD, MATH1, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, ADD, MATH2, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, ADD, MATH3, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, ADD, IMM(393615378), VSEQINSZ, SIZE(8), WITH(IFB));
	MATHB(VSEQINSZ, ADD, DPOVRD, VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, ADD, VSEQINSZ, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, ADD, VSEQOUTSZ, VSEQINSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, ADD, ABD, VSEQINSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, ADD, OFIFO, VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, ADD, ONE, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, ADD, ZERO, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, ADD, MATH0, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADD, MATH1, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADD, MATH2, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADD, MATH3, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADD, IMM(393615378), VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, ADD, DPOVRD, VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, ADD, VSEQINSZ, VSEQINSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, ADD, VSEQOUTSZ, VSEQINSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, ADD, ABD, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, ADD, OFIFO, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADD, ONE, VSEQINSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, ADD, ZERO, VSEQINSZ, SIZE(1), 0);
	MATHB(ZERO, ADD, MATH0, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, ADD, MATH1, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(ZERO, ADD, MATH2, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, ADD, MATH3, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(ZERO, ADD, IMM(393615378), VSEQINSZ, SIZE(4), 0);
	MATHB(ZERO, ADD, DPOVRD, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(ZERO, ADD, VSEQINSZ, VSEQINSZ, SIZE(8), 0);
	MATHB(ZERO, ADD, VSEQOUTSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(ZERO, ADD, ABD, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(ZERO, ADD, OFIFO, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, ADD, ONE, VSEQINSZ, SIZE(4), 0);
	MATHB(ZERO, ADD, ZERO, VSEQINSZ, SIZE(2), 0);
	MATHB(ONE, ADD, MATH0, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(ONE, ADD, MATH1, VSEQINSZ, SIZE(8), 0);
	MATHB(ONE, ADD, MATH2, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(ONE, ADD, MATH3, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(ONE, ADD, IMM(393615378), VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, ADD, DPOVRD, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, ADD, VSEQINSZ, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(ONE, ADD, VSEQOUTSZ, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(ONE, ADD, ABD, VSEQINSZ, SIZE(1), 0);
	MATHB(ONE, ADD, OFIFO, VSEQINSZ, SIZE(2), 0);
	MATHB(ONE, ADD, ONE, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, ADD, ZERO, VSEQINSZ, SIZE(4), 0);
	/* ADD operation: VSEQOUTSZ Destination register */
	MATHB(MATH0, ADD, MATH0, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, ADD, MATH1, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(MATH0, ADD, MATH2, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, ADD, MATH3, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, ADD, IMM(393615378), VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(MATH0, ADD, DPOVRD, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(MATH0, ADD, VSEQINSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, ADD, VSEQOUTSZ, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(MATH0, ADD, ABD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, ADD, OFIFO, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(MATH0, ADD, ONE, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, ADD, ZERO, VSEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH1, ADD, MATH0, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, ADD, MATH1, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH1, ADD, MATH2, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(MATH1, ADD, MATH3, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH1, ADD, IMM(393615378), VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH1, ADD, DPOVRD, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH1, ADD, VSEQINSZ, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, ADD, VSEQOUTSZ, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH1, ADD, ABD, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH1, ADD, OFIFO, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, ADD, ONE, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH1, ADD, ZERO, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH2, ADD, MATH0, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, ADD, MATH1, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH2, ADD, MATH2, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH2, ADD, MATH3, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, ADD, IMM(393615378), VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH2, ADD, DPOVRD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH2, ADD, VSEQINSZ, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, ADD, VSEQOUTSZ, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(MATH2, ADD, ABD, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH2, ADD, OFIFO, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH2, ADD, ONE, VSEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, ADD, ZERO, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, ADD, MATH0, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, ADD, MATH1, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, ADD, MATH2, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, ADD, MATH3, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, ADD, IMM(393615378), VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, ADD, DPOVRD, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, ADD, VSEQINSZ, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(MATH3, ADD, VSEQOUTSZ, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, ADD, ABD, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH3, ADD, OFIFO, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, ADD, ONE, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, ADD, ZERO, VSEQOUTSZ, SIZE(1), 0);
	MATHB(IMM(275128321), ADD, MATH0, VSEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), ADD, MATH1, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(IMM(275128321), ADD, MATH2, VSEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), ADD, MATH3, VSEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(275128321), ADD, IMM(393615378), VSEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), ADD, DPOVRD, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(0x19261959fedcba01), ADD, VSEQINSZ, VSEQOUTSZ, SIZE(8), 0);
	MATHB(IMM(275128321), ADD, VSEQOUTSZ, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), ADD, ABD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(0x19261959fedcba01), ADD, OFIFO, VSEQOUTSZ, SIZE(8),
	      WITH(STL));
	MATHB(IMM(275128321), ADD, ONE, VSEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), ADD, ZERO, VSEQOUTSZ, SIZE(8), WITH(IFB | STL));
	MATHB(DPOVRD, ADD, MATH0, VSEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, ADD, MATH1, VSEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, ADD, MATH2, VSEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, ADD, MATH3, VSEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, ADD, IMM(393615378), VSEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, ADD, DPOVRD, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, ADD, VSEQINSZ, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, ADD, VSEQOUTSZ, VSEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, ADD, ABD, VSEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, ADD, OFIFO, VSEQOUTSZ, SIZE(4), 0);
	MATHB(DPOVRD, ADD, ONE, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(DPOVRD, ADD, ZERO, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, ADD, MATH0, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQINSZ, ADD, MATH1, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, ADD, MATH2, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQINSZ, ADD, MATH3, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, ADD, IMM(393615378), VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQINSZ, ADD, DPOVRD, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, ADD, VSEQINSZ, VSEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, ADD, VSEQOUTSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQINSZ, ADD, ABD, VSEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, ADD, OFIFO, VSEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, ADD, ONE, VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQINSZ, ADD, ZERO, VSEQOUTSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADD, MATH0, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADD, MATH1, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, ADD, MATH2, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADD, MATH3, VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, ADD, IMM(393615378), VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, ADD, DPOVRD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADD, VSEQINSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, ADD, VSEQOUTSZ, VSEQOUTSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, ADD, ABD, VSEQOUTSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, ADD, OFIFO, VSEQOUTSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, ADD, ONE, VSEQOUTSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADD, ZERO, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, ADD, MATH0, VSEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, ADD, MATH1, VSEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, ADD, MATH2, VSEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, ADD, MATH3, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, ADD, IMM(393615378), VSEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, ADD, DPOVRD, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, ADD, VSEQINSZ, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, ADD, VSEQOUTSZ, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, ADD, ABD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, ADD, OFIFO, VSEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQINSZ, ADD, ONE, VSEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, ADD, ZERO, VSEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADD, MATH0, VSEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, ADD, MATH1, VSEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADD, MATH2, VSEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, ADD, MATH3, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, ADD, IMM(393615378), VSEQOUTSZ, SIZE(8),
	      WITH(IFB | NFU | STL));
	MATHB(VSEQOUTSZ, ADD, DPOVRD, VSEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, ADD, VSEQINSZ, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, ADD, VSEQOUTSZ, VSEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADD, ABD, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, ADD, OFIFO, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, ADD, ONE, VSEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, ADD, ZERO, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, ADD, MATH0, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, ADD, MATH1, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(ZERO, ADD, MATH2, VSEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, ADD, MATH3, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, ADD, IMM(393615378), VSEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, ADD, DPOVRD, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(ZERO, ADD, VSEQINSZ, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(ZERO, ADD, VSEQOUTSZ, VSEQOUTSZ, SIZE(4), 0);
	MATHB(ZERO, ADD, ABD, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(ZERO, ADD, OFIFO, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(ZERO, ADD, ONE, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, ADD, ZERO, VSEQOUTSZ, SIZE(2), 0);
	MATHB(ONE, ADD, MATH0, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, ADD, MATH1, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, ADD, MATH2, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, ADD, MATH3, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(ONE, ADD, IMM(393615378), VSEQOUTSZ, SIZE(8), WITH(IFB));
	MATHB(ONE, ADD, DPOVRD, VSEQOUTSZ, SIZE(8), 0);
	MATHB(ONE, ADD, VSEQINSZ, VSEQOUTSZ, SIZE(8), 0);
	MATHB(ONE, ADD, VSEQOUTSZ, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(ONE, ADD, ABD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, ADD, OFIFO, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(ONE, ADD, ONE, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(ONE, ADD, ZERO, VSEQOUTSZ, SIZE(1), WITH(NFU));
	/* ADD operation: NONE Destination register */
	MATHB(MATH0, ADD, MATH0, NONE, SIZE(1), 0);
	MATHB(MATH0, ADD, MATH1, NONE, SIZE(4), 0);
	MATHB(MATH0, ADD, MATH2, NONE, SIZE(2), 0);
	MATHB(MATH0, ADD, MATH3, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, ADD, IMM(393615378), NONE, SIZE(4), 0);
	MATHB(MATH0, ADD, DPOVRD, NONE, SIZE(4), WITH(NFU));
	MATHB(MATH0, ADD, VSEQINSZ, NONE, SIZE(2), WITH(NFU));
	MATHB(MATH0, ADD, VSEQOUTSZ, NONE, SIZE(1), 0);
	MATHB(MATH0, ADD, ABD, NONE, SIZE(8), 0);
	MATHB(MATH0, ADD, OFIFO, NONE, SIZE(8), 0);
	MATHB(MATH0, ADD, ONE, NONE, SIZE(8), WITH(STL));
	MATHB(MATH0, ADD, ZERO, NONE, SIZE(1), 0);
	MATHB(MATH1, ADD, MATH0, NONE, SIZE(2), 0);
	MATHB(MATH1, ADD, MATH1, NONE, SIZE(8), WITH(NFU));
	MATHB(MATH1, ADD, MATH2, NONE, SIZE(8), WITH(STL));
	MATHB(MATH1, ADD, MATH3, NONE, SIZE(2), WITH(STL));
	MATHB(MATH1, ADD, IMM(393615378), NONE, SIZE(1), WITH(STL));
	MATHB(MATH1, ADD, DPOVRD, NONE, SIZE(8), 0);
	MATHB(MATH1, ADD, VSEQINSZ, NONE, SIZE(2), WITH(STL));
	MATHB(MATH1, ADD, VSEQOUTSZ, NONE, SIZE(2), 0);
	MATHB(MATH1, ADD, ABD, NONE, SIZE(8), 0);
	MATHB(MATH1, ADD, OFIFO, NONE, SIZE(2), WITH(STL));
	MATHB(MATH1, ADD, ONE, NONE, SIZE(4), 0);
	MATHB(MATH1, ADD, ZERO, NONE, SIZE(2), WITH(NFU));
	MATHB(MATH2, ADD, MATH0, NONE, SIZE(4), WITH(STL));
	MATHB(MATH2, ADD, MATH1, NONE, SIZE(4), 0);
	MATHB(MATH2, ADD, MATH2, NONE, SIZE(8), 0);
	MATHB(MATH2, ADD, MATH3, NONE, SIZE(1), 0);
	MATHB(MATH2, ADD, IMM(393615378), NONE, SIZE(1), 0);
	MATHB(MATH2, ADD, DPOVRD, NONE, SIZE(1), 0);
	MATHB(MATH2, ADD, VSEQINSZ, NONE, SIZE(8), 0);
	MATHB(MATH2, ADD, VSEQOUTSZ, NONE, SIZE(8), 0);
	MATHB(MATH2, ADD, ABD, NONE, SIZE(4), WITH(STL));
	MATHB(MATH2, ADD, OFIFO, NONE, SIZE(4), WITH(STL));
	MATHB(MATH2, ADD, ONE, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, ADD, ZERO, NONE, SIZE(2), 0);
	MATHB(MATH3, ADD, MATH0, NONE, SIZE(2), WITH(NFU));
	MATHB(MATH3, ADD, MATH1, NONE, SIZE(8), WITH(NFU));
	MATHB(MATH3, ADD, MATH2, NONE, SIZE(8), WITH(STL));
	MATHB(MATH3, ADD, MATH3, NONE, SIZE(8), 0);
	MATHB(MATH3, ADD, IMM(393615378), NONE, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, ADD, DPOVRD, NONE, SIZE(1), 0);
	MATHB(MATH3, ADD, VSEQINSZ, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, ADD, VSEQOUTSZ, NONE, SIZE(8), WITH(NFU));
	MATHB(MATH3, ADD, ABD, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, ADD, OFIFO, NONE, SIZE(2), WITH(STL));
	MATHB(MATH3, ADD, ONE, NONE, SIZE(4), 0);
	MATHB(MATH3, ADD, ZERO, NONE, SIZE(2), 0);
	MATHB(IMM(275128321), ADD, MATH0, NONE, SIZE(4), 0);
	MATHB(IMM(275128321), ADD, MATH1, NONE, SIZE(2), 0);
	MATHB(IMM(0x19261959fedcba01), ADD, MATH2, NONE, SIZE(8), 0);
	MATHB(IMM(0x19261959fedcba01), ADD, MATH3, NONE, SIZE(8), 0);
	MATHB(IMM(275128321), ADD, IMM(393615378), NONE, SIZE(2), WITH(STL));
	MATHB(IMM(275128321), ADD, DPOVRD, NONE, SIZE(2), 0);
	MATHB(IMM(275128321), ADD, VSEQINSZ, NONE, SIZE(8), WITH(IFB | NFU));
	MATHB(IMM(275128321), ADD, VSEQOUTSZ, NONE, SIZE(2), 0);
	MATHB(IMM(275128321), ADD, ABD, NONE, SIZE(8), WITH(IFB));
	MATHB(IMM(0x19261959fedcba01), ADD, OFIFO, NONE, SIZE(8), 0);
	MATHB(IMM(275128321), ADD, ONE, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(275128321), ADD, ZERO, NONE, SIZE(4), 0);
	MATHB(DPOVRD, ADD, MATH0, NONE, SIZE(1), 0);
	MATHB(DPOVRD, ADD, MATH1, NONE, SIZE(4), 0);
	MATHB(DPOVRD, ADD, MATH2, NONE, SIZE(2), 0);
	MATHB(DPOVRD, ADD, MATH3, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, ADD, IMM(0x19261959fedcba01), NONE, SIZE(8), 0);
	MATHB(DPOVRD, ADD, DPOVRD, NONE, SIZE(1), 0);
	MATHB(DPOVRD, ADD, VSEQINSZ, NONE, SIZE(4), WITH(STL));
	MATHB(DPOVRD, ADD, VSEQOUTSZ, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(DPOVRD, ADD, ABD, NONE, SIZE(1), 0);
	MATHB(DPOVRD, ADD, OFIFO, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, ADD, ONE, NONE, SIZE(1), 0);
	MATHB(DPOVRD, ADD, ZERO, NONE, SIZE(8), 0);
	MATHB(SEQINSZ, ADD, MATH0, NONE, SIZE(8), 0);
	MATHB(SEQINSZ, ADD, MATH1, NONE, SIZE(4), 0);
	MATHB(SEQINSZ, ADD, MATH2, NONE, SIZE(1), 0);
	MATHB(SEQINSZ, ADD, MATH3, NONE, SIZE(8), 0);
	MATHB(SEQINSZ, ADD, IMM(393615378), NONE, SIZE(8),
	      WITH(IFB | NFU | STL));
	MATHB(SEQINSZ, ADD, DPOVRD, NONE, SIZE(1), 0);
	MATHB(SEQINSZ, ADD, VSEQINSZ, NONE, SIZE(4), 0);
	MATHB(SEQINSZ, ADD, VSEQOUTSZ, NONE, SIZE(1), 0);
	MATHB(SEQINSZ, ADD, ABD, NONE, SIZE(2), 0);
	MATHB(SEQINSZ, ADD, OFIFO, NONE, SIZE(2), 0);
	MATHB(SEQINSZ, ADD, ONE, NONE, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, ADD, ZERO, NONE, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, ADD, MATH0, NONE, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, ADD, MATH1, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADD, MATH2, NONE, SIZE(2), 0);
	MATHB(SEQOUTSZ, ADD, MATH3, NONE, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, ADD, IMM(393615378), NONE, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADD, DPOVRD, NONE, SIZE(8), 0);
	MATHB(SEQOUTSZ, ADD, VSEQINSZ, NONE, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, ADD, VSEQOUTSZ, NONE, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADD, ABD, NONE, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADD, OFIFO, NONE, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, ADD, ONE, NONE, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADD, ZERO, NONE, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, ADD, MATH0, NONE, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, ADD, MATH1, NONE, SIZE(1), 0);
	MATHB(VSEQINSZ, ADD, MATH2, NONE, SIZE(2), 0);
	MATHB(VSEQINSZ, ADD, MATH3, NONE, SIZE(1), 0);
	MATHB(VSEQINSZ, ADD, IMM(393615378), NONE, SIZE(1), 0);
	MATHB(VSEQINSZ, ADD, DPOVRD, NONE, SIZE(1), 0);
	MATHB(VSEQINSZ, ADD, VSEQINSZ, NONE, SIZE(2), 0);
	MATHB(VSEQINSZ, ADD, VSEQOUTSZ, NONE, SIZE(8), 0);
	MATHB(VSEQINSZ, ADD, ABD, NONE, SIZE(1), 0);
	MATHB(VSEQINSZ, ADD, OFIFO, NONE, SIZE(4), 0);
	MATHB(VSEQINSZ, ADD, ONE, NONE, SIZE(4), WITH(STL));
	MATHB(VSEQINSZ, ADD, ZERO, NONE, SIZE(8), 0);
	MATHB(VSEQOUTSZ, ADD, MATH0, NONE, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADD, MATH1, NONE, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADD, MATH2, NONE, SIZE(8), 0);
	MATHB(VSEQOUTSZ, ADD, MATH3, NONE, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADD, IMM(393615378), NONE, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADD, DPOVRD, NONE, SIZE(8), 0);
	MATHB(VSEQOUTSZ, ADD, VSEQINSZ, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADD, VSEQOUTSZ, NONE, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, ADD, ABD, NONE, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADD, OFIFO, NONE, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADD, ONE, NONE, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADD, ZERO, NONE, SIZE(8), WITH(STL));
	MATHB(ZERO, ADD, MATH0, NONE, SIZE(2), WITH(STL));
	MATHB(ZERO, ADD, MATH1, NONE, SIZE(1), WITH(NFU));
	MATHB(ZERO, ADD, MATH2, NONE, SIZE(2), 0);
	MATHB(ZERO, ADD, MATH3, NONE, SIZE(4), 0);
	MATHB(ZERO, ADD, IMM(393615378), NONE, SIZE(2), 0);
	MATHB(ZERO, ADD, DPOVRD, NONE, SIZE(1), 0);
	MATHB(ZERO, ADD, VSEQINSZ, NONE, SIZE(2), 0);
	MATHB(ZERO, ADD, VSEQOUTSZ, NONE, SIZE(8), 0);
	MATHB(ZERO, ADD, ABD, NONE, SIZE(1), 0);
	MATHB(ZERO, ADD, OFIFO, NONE, SIZE(1), WITH(STL));
	MATHB(ZERO, ADD, ONE, NONE, SIZE(2), 0);
	MATHB(ZERO, ADD, ZERO, NONE, SIZE(8), WITH(STL));
	MATHB(ONE, ADD, MATH0, NONE, SIZE(4), 0);
	MATHB(ONE, ADD, MATH1, NONE, SIZE(1), 0);
	MATHB(ONE, ADD, MATH2, NONE, SIZE(4), 0);
	MATHB(ONE, ADD, MATH3, NONE, SIZE(2), 0);
	MATHB(ONE, ADD, IMM(393615378), NONE, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, ADD, DPOVRD, NONE, SIZE(4), 0);
	MATHB(ONE, ADD, VSEQINSZ, NONE, SIZE(4), 0);
	MATHB(ONE, ADD, VSEQOUTSZ, NONE, SIZE(8), 0);
	MATHB(ONE, ADD, ABD, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, ADD, OFIFO, NONE, SIZE(8), WITH(STL));
	MATHB(ONE, ADD, ONE, NONE, SIZE(2), 0);
	MATHB(ONE, ADD, ZERO, NONE, SIZE(2), WITH(STL));
	/* ADDC operation: MATH0 Destination register */
	MATHB(MATH0, ADDC, MATH0, MATH0, SIZE(8), 0);
	MATHB(MATH0, ADDC, MATH1, MATH0, SIZE(8), 0);
	MATHB(MATH0, ADDC, MATH2, MATH0, SIZE(1), 0);
	MATHB(MATH0, ADDC, MATH3, MATH0, SIZE(1), 0);
	MATHB(MATH0, ADDC, IMM(393615378), MATH0, SIZE(8), WITH(IFB));
	MATHB(MATH0, ADDC, DPOVRD, MATH0, SIZE(8), WITH(STL));
	MATHB(MATH0, ADDC, VSEQINSZ, MATH0, SIZE(2), 0);
	MATHB(MATH0, ADDC, VSEQOUTSZ, MATH0, SIZE(2), 0);
	MATHB(MATH0, ADDC, ABD, MATH0, SIZE(8), 0);
	MATHB(MATH0, ADDC, OFIFO, MATH0, SIZE(1), WITH(STL));
	MATHB(MATH0, ADDC, ONE, MATH0, SIZE(8), WITH(NFU));
	MATHB(MATH0, ADDC, ZERO, MATH0, SIZE(8), 0);
	MATHB(MATH1, ADDC, MATH0, MATH0, SIZE(4), WITH(STL));
	MATHB(MATH1, ADDC, MATH1, MATH0, SIZE(2), 0);
	MATHB(MATH1, ADDC, MATH2, MATH0, SIZE(8), 0);
	MATHB(MATH1, ADDC, MATH3, MATH0, SIZE(4), 0);
	MATHB(MATH1, ADDC, IMM(393615378), MATH0, SIZE(2), 0);
	MATHB(MATH1, ADDC, DPOVRD, MATH0, SIZE(8), 0);
	MATHB(MATH1, ADDC, VSEQINSZ, MATH0, SIZE(8), 0);
	MATHB(MATH1, ADDC, VSEQOUTSZ, MATH0, SIZE(4), WITH(STL));
	MATHB(MATH1, ADDC, ABD, MATH0, SIZE(2), 0);
	MATHB(MATH1, ADDC, OFIFO, MATH0, SIZE(1), 0);
	MATHB(MATH1, ADDC, ONE, MATH0, SIZE(8), WITH(NFU));
	MATHB(MATH1, ADDC, ZERO, MATH0, SIZE(8), 0);
	MATHB(MATH2, ADDC, MATH0, MATH0, SIZE(1), WITH(STL));
	MATHB(MATH2, ADDC, MATH1, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, ADDC, MATH2, MATH0, SIZE(8), 0);
	MATHB(MATH2, ADDC, MATH3, MATH0, SIZE(1), WITH(NFU));
	MATHB(MATH2, ADDC, IMM(393615378), MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, ADDC, DPOVRD, MATH0, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, ADDC, VSEQINSZ, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, ADDC, VSEQOUTSZ, MATH0, SIZE(2), 0);
	MATHB(MATH2, ADDC, ABD, MATH0, SIZE(1), 0);
	MATHB(MATH2, ADDC, OFIFO, MATH0, SIZE(2), 0);
	MATHB(MATH2, ADDC, ONE, MATH0, SIZE(8), 0);
	MATHB(MATH2, ADDC, ZERO, MATH0, SIZE(8), 0);
	MATHB(MATH3, ADDC, MATH0, MATH0, SIZE(1), WITH(STL));
	MATHB(MATH3, ADDC, MATH1, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, ADDC, MATH2, MATH0, SIZE(8), 0);
	MATHB(MATH3, ADDC, MATH3, MATH0, SIZE(8), 0);
	MATHB(MATH3, ADDC, IMM(393615378), MATH0, SIZE(4), 0);
	MATHB(MATH3, ADDC, DPOVRD, MATH0, SIZE(1), WITH(STL));
	MATHB(MATH3, ADDC, VSEQINSZ, MATH0, SIZE(2), 0);
	MATHB(MATH3, ADDC, VSEQOUTSZ, MATH0, SIZE(1), WITH(STL));
	MATHB(MATH3, ADDC, ABD, MATH0, SIZE(4), 0);
	MATHB(MATH3, ADDC, OFIFO, MATH0, SIZE(4), 0);
	MATHB(MATH3, ADDC, ONE, MATH0, SIZE(8), WITH(NFU));
	MATHB(MATH3, ADDC, ZERO, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), ADDC, MATH0, MATH0, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), ADDC, MATH1, MATH0, SIZE(8), WITH(IFB | STL));
	MATHB(IMM(275128321), ADDC, MATH2, MATH0, SIZE(2), WITH(NFU));
	MATHB(IMM(275128321), ADDC, MATH3, MATH0, SIZE(2), 0);
	MATHB(IMM(275128321), ADDC, IMM(393615378), MATH0, SIZE(1), 0);
	MATHB(IMM(275128321), ADDC, DPOVRD, MATH0, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), ADDC, VSEQINSZ, MATH0, SIZE(2), 0);
	MATHB(IMM(275128321), ADDC, VSEQOUTSZ, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(275128321), ADDC, ABD, MATH0, SIZE(1), 0);
	MATHB(IMM(275128321), ADDC, OFIFO, MATH0, SIZE(2), 0);
	MATHB(IMM(275128321), ADDC, ONE, MATH0, SIZE(4), 0);
	MATHB(IMM(275128321), ADDC, ZERO, MATH0, SIZE(2), 0);
	MATHB(DPOVRD, ADDC, MATH0, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, ADDC, MATH1, MATH0, SIZE(8), 0);
	MATHB(DPOVRD, ADDC, MATH2, MATH0, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, ADDC, MATH3, MATH0, SIZE(1), WITH(NFU));
	MATHB(DPOVRD, ADDC, IMM(0x19261959fedcba01), MATH0, SIZE(8), 0);
	MATHB(DPOVRD, ADDC, DPOVRD, MATH0, SIZE(1), WITH(NFU));
	MATHB(DPOVRD, ADDC, VSEQINSZ, MATH0, SIZE(1), 0);
	MATHB(DPOVRD, ADDC, VSEQOUTSZ, MATH0, SIZE(8), 0);
	MATHB(DPOVRD, ADDC, ABD, MATH0, SIZE(8), WITH(STL));
	MATHB(DPOVRD, ADDC, OFIFO, MATH0, SIZE(2), 0);
	MATHB(DPOVRD, ADDC, ONE, MATH0, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, ADDC, ZERO, MATH0, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, ADDC, MATH0, MATH0, SIZE(8), 0);
	MATHB(SEQINSZ, ADDC, MATH1, MATH0, SIZE(2), 0);
	MATHB(SEQINSZ, ADDC, MATH2, MATH0, SIZE(4), 0);
	MATHB(SEQINSZ, ADDC, MATH3, MATH0, SIZE(1), 0);
	MATHB(SEQINSZ, ADDC, IMM(393615378), MATH0, SIZE(4), 0);
	MATHB(SEQINSZ, ADDC, DPOVRD, MATH0, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, ADDC, VSEQINSZ, MATH0, SIZE(2), 0);
	MATHB(SEQINSZ, ADDC, VSEQOUTSZ, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(SEQINSZ, ADDC, ABD, MATH0, SIZE(1), 0);
	MATHB(SEQINSZ, ADDC, OFIFO, MATH0, SIZE(8), 0);
	MATHB(SEQINSZ, ADDC, ONE, MATH0, SIZE(2), 0);
	MATHB(SEQINSZ, ADDC, ZERO, MATH0, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADDC, MATH0, MATH0, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADDC, MATH1, MATH0, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADDC, MATH2, MATH0, SIZE(8), 0);
	MATHB(SEQOUTSZ, ADDC, MATH3, MATH0, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, ADDC, IMM(393615378), MATH0, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADDC, DPOVRD, MATH0, SIZE(8), WITH(NFU));
	MATHB(SEQOUTSZ, ADDC, VSEQINSZ, MATH0, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, ADDC, VSEQOUTSZ, MATH0, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADDC, ABD, MATH0, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, ADDC, OFIFO, MATH0, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, ADDC, ONE, MATH0, SIZE(8), 0);
	MATHB(SEQOUTSZ, ADDC, ZERO, MATH0, SIZE(4), 0);
	MATHB(VSEQINSZ, ADDC, MATH0, MATH0, SIZE(1), 0);
	MATHB(VSEQINSZ, ADDC, MATH1, MATH0, SIZE(4), 0);
	MATHB(VSEQINSZ, ADDC, MATH2, MATH0, SIZE(1), 0);
	MATHB(VSEQINSZ, ADDC, MATH3, MATH0, SIZE(4), 0);
	MATHB(VSEQINSZ, ADDC, IMM(0x19261959fedcba01), MATH0, SIZE(8),
	      WITH(STL));
	MATHB(VSEQINSZ, ADDC, DPOVRD, MATH0, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, ADDC, VSEQINSZ, MATH0, SIZE(4), 0);
	MATHB(VSEQINSZ, ADDC, VSEQOUTSZ, MATH0, SIZE(4), 0);
	MATHB(VSEQINSZ, ADDC, ABD, MATH0, SIZE(2), 0);
	MATHB(VSEQINSZ, ADDC, OFIFO, MATH0, SIZE(2), 0);
	MATHB(VSEQINSZ, ADDC, ONE, MATH0, SIZE(2), 0);
	MATHB(VSEQINSZ, ADDC, ZERO, MATH0, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, ADDC, MATH0, MATH0, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADDC, MATH1, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADDC, MATH2, MATH0, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, ADDC, MATH3, MATH0, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADDC, IMM(393615378), MATH0, SIZE(8), WITH(IFB));
	MATHB(VSEQOUTSZ, ADDC, DPOVRD, MATH0, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, ADDC, VSEQINSZ, MATH0, SIZE(8), 0);
	MATHB(VSEQOUTSZ, ADDC, VSEQOUTSZ, MATH0, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADDC, ABD, MATH0, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, ADDC, OFIFO, MATH0, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, ADDC, ONE, MATH0, SIZE(2), 0);
	MATHB(VSEQOUTSZ, ADDC, ZERO, MATH0, SIZE(2), 0);
	MATHB(ZERO, ADDC, MATH0, MATH0, SIZE(2), 0);
	MATHB(ZERO, ADDC, MATH1, MATH0, SIZE(2), 0);
	MATHB(ZERO, ADDC, MATH2, MATH0, SIZE(4), 0);
	MATHB(ZERO, ADDC, MATH3, MATH0, SIZE(8), WITH(NFU));
	MATHB(ZERO, ADDC, IMM(393615378), MATH0, SIZE(2), 0);
	MATHB(ZERO, ADDC, DPOVRD, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, ADDC, VSEQINSZ, MATH0, SIZE(2), 0);
	MATHB(ZERO, ADDC, VSEQOUTSZ, MATH0, SIZE(2), WITH(STL));
	MATHB(ZERO, ADDC, ABD, MATH0, SIZE(1), 0);
	MATHB(ZERO, ADDC, OFIFO, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, ADDC, ONE, MATH0, SIZE(2), 0);
	MATHB(ZERO, ADDC, ZERO, MATH0, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, ADDC, MATH0, MATH0, SIZE(8), WITH(NFU));
	MATHB(ONE, ADDC, MATH1, MATH0, SIZE(4), 0);
	MATHB(ONE, ADDC, MATH2, MATH0, SIZE(1), WITH(STL));
	MATHB(ONE, ADDC, MATH3, MATH0, SIZE(4), 0);
	MATHB(ONE, ADDC, IMM(393615378), MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, ADDC, DPOVRD, MATH0, SIZE(2), 0);
	MATHB(ONE, ADDC, VSEQINSZ, MATH0, SIZE(8), WITH(STL));
	MATHB(ONE, ADDC, VSEQOUTSZ, MATH0, SIZE(2), 0);
	MATHB(ONE, ADDC, ABD, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, ADDC, OFIFO, MATH0, SIZE(4), 0);
	MATHB(ONE, ADDC, ONE, MATH0, SIZE(1), 0);
	MATHB(ONE, ADDC, ZERO, MATH0, SIZE(2), WITH(NFU));
	/* ADDC operation: MATH1 Destination register */
	MATHB(MATH0, ADDC, MATH0, MATH1, SIZE(2), WITH(STL));
	MATHB(MATH0, ADDC, MATH1, MATH1, SIZE(1), WITH(STL));
	MATHB(MATH0, ADDC, MATH2, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, ADDC, MATH3, MATH1, SIZE(2), 0);
	MATHB(MATH0, ADDC, IMM(393615378), MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, ADDC, DPOVRD, MATH1, SIZE(1), 0);
	MATHB(MATH0, ADDC, VSEQINSZ, MATH1, SIZE(2), 0);
	MATHB(MATH0, ADDC, VSEQOUTSZ, MATH1, SIZE(2), WITH(STL));
	MATHB(MATH0, ADDC, ABD, MATH1, SIZE(1), 0);
	MATHB(MATH0, ADDC, OFIFO, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, ADDC, ONE, MATH1, SIZE(1), 0);
	MATHB(MATH0, ADDC, ZERO, MATH1, SIZE(8), 0);
	MATHB(MATH1, ADDC, MATH0, MATH1, SIZE(1), 0);
	MATHB(MATH1, ADDC, MATH1, MATH1, SIZE(4), WITH(NFU));
	MATHB(MATH1, ADDC, MATH2, MATH1, SIZE(2), WITH(STL));
	MATHB(MATH1, ADDC, MATH3, MATH1, SIZE(8), 0);
	MATHB(MATH1, ADDC, IMM(393615378), MATH1, SIZE(2), 0);
	MATHB(MATH1, ADDC, DPOVRD, MATH1, SIZE(1), 0);
	MATHB(MATH1, ADDC, VSEQINSZ, MATH1, SIZE(8), 0);
	MATHB(MATH1, ADDC, VSEQOUTSZ, MATH1, SIZE(8), WITH(STL));
	MATHB(MATH1, ADDC, ABD, MATH1, SIZE(2), 0);
	MATHB(MATH1, ADDC, OFIFO, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, ADDC, ONE, MATH1, SIZE(2), 0);
	MATHB(MATH1, ADDC, ZERO, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, ADDC, MATH0, MATH1, SIZE(4), WITH(NFU));
	MATHB(MATH2, ADDC, MATH1, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, ADDC, MATH2, MATH1, SIZE(2), 0);
	MATHB(MATH2, ADDC, MATH3, MATH1, SIZE(8), 0);
	MATHB(MATH2, ADDC, IMM(393615378), MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, ADDC, DPOVRD, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, ADDC, VSEQINSZ, MATH1, SIZE(8), 0);
	MATHB(MATH2, ADDC, VSEQOUTSZ, MATH1, SIZE(1), 0);
	MATHB(MATH2, ADDC, ABD, MATH1, SIZE(4), 0);
	MATHB(MATH2, ADDC, OFIFO, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, ADDC, ONE, MATH1, SIZE(2), WITH(NFU));
	MATHB(MATH2, ADDC, ZERO, MATH1, SIZE(2), WITH(STL));
	MATHB(MATH3, ADDC, MATH0, MATH1, SIZE(2), 0);
	MATHB(MATH3, ADDC, MATH1, MATH1, SIZE(8), 0);
	MATHB(MATH3, ADDC, MATH2, MATH1, SIZE(1), 0);
	MATHB(MATH3, ADDC, MATH3, MATH1, SIZE(2), WITH(STL));
	MATHB(MATH3, ADDC, IMM(393615378), MATH1, SIZE(2), WITH(STL));
	MATHB(MATH3, ADDC, DPOVRD, MATH1, SIZE(8), WITH(STL));
	MATHB(MATH3, ADDC, VSEQINSZ, MATH1, SIZE(1), WITH(STL));
	MATHB(MATH3, ADDC, VSEQOUTSZ, MATH1, SIZE(8), 0);
	MATHB(MATH3, ADDC, ABD, MATH1, SIZE(4), WITH(NFU));
	MATHB(MATH3, ADDC, OFIFO, MATH1, SIZE(2), 0);
	MATHB(MATH3, ADDC, ONE, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, ADDC, ZERO, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(275128321), ADDC, MATH0, MATH1, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), ADDC, MATH1, MATH1, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), ADDC, MATH2, MATH1, SIZE(4), 0);
	MATHB(IMM(275128321), ADDC, MATH3, MATH1, SIZE(2), WITH(STL));
	MATHB(IMM(275128321), ADDC, IMM(393615378), MATH1, SIZE(2), WITH(STL));
	MATHB(IMM(0x19261959fedcba01), ADDC, DPOVRD, MATH1, SIZE(8), 0);
	MATHB(IMM(275128321), ADDC, VSEQINSZ, MATH1, SIZE(1), 0);
	MATHB(IMM(275128321), ADDC, VSEQOUTSZ, MATH1, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), ADDC, ABD, MATH1, SIZE(1), 0);
	MATHB(IMM(275128321), ADDC, OFIFO, MATH1, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), ADDC, ONE, MATH1, SIZE(1), 0);
	MATHB(IMM(275128321), ADDC, ZERO, MATH1, SIZE(8), WITH(IFB));
	MATHB(DPOVRD, ADDC, MATH0, MATH1, SIZE(2), 0);
	MATHB(DPOVRD, ADDC, MATH1, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(DPOVRD, ADDC, MATH2, MATH1, SIZE(2), 0);
	MATHB(DPOVRD, ADDC, MATH3, MATH1, SIZE(4), WITH(STL));
	MATHB(DPOVRD, ADDC, IMM(393615378), MATH1, SIZE(4), 0);
	MATHB(DPOVRD, ADDC, DPOVRD, MATH1, SIZE(1), WITH(STL));
	MATHB(DPOVRD, ADDC, VSEQINSZ, MATH1, SIZE(8), 0);
	MATHB(DPOVRD, ADDC, VSEQOUTSZ, MATH1, SIZE(1), 0);
	MATHB(DPOVRD, ADDC, ABD, MATH1, SIZE(4), 0);
	MATHB(DPOVRD, ADDC, OFIFO, MATH1, SIZE(4), WITH(STL));
	MATHB(DPOVRD, ADDC, ONE, MATH1, SIZE(1), WITH(NFU));
	MATHB(DPOVRD, ADDC, ZERO, MATH1, SIZE(8), 0);
	MATHB(SEQINSZ, ADDC, MATH0, MATH1, SIZE(1), 0);
	MATHB(SEQINSZ, ADDC, MATH1, MATH1, SIZE(8), 0);
	MATHB(SEQINSZ, ADDC, MATH2, MATH1, SIZE(4), 0);
	MATHB(SEQINSZ, ADDC, MATH3, MATH1, SIZE(4), 0);
	MATHB(SEQINSZ, ADDC, IMM(393615378), MATH1, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, ADDC, DPOVRD, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(SEQINSZ, ADDC, VSEQINSZ, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, ADDC, VSEQOUTSZ, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(SEQINSZ, ADDC, ABD, MATH1, SIZE(8), 0);
	MATHB(SEQINSZ, ADDC, OFIFO, MATH1, SIZE(1), 0);
	MATHB(SEQINSZ, ADDC, ONE, MATH1, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, ADDC, ZERO, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADDC, MATH0, MATH1, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADDC, MATH1, MATH1, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, ADDC, MATH2, MATH1, SIZE(2), 0);
	MATHB(SEQOUTSZ, ADDC, MATH3, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADDC, IMM(393615378), MATH1, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, ADDC, DPOVRD, MATH1, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADDC, VSEQINSZ, MATH1, SIZE(2), 0);
	MATHB(SEQOUTSZ, ADDC, VSEQOUTSZ, MATH1, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADDC, ABD, MATH1, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, ADDC, OFIFO, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADDC, ONE, MATH1, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADDC, ZERO, MATH1, SIZE(8), 0);
	MATHB(VSEQINSZ, ADDC, MATH0, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQINSZ, ADDC, MATH1, MATH1, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, ADDC, MATH2, MATH1, SIZE(4), 0);
	MATHB(VSEQINSZ, ADDC, MATH3, MATH1, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, ADDC, IMM(0x19261959fedcba01), MATH1, SIZE(8),
	      WITH(NFU | STL));
	MATHB(VSEQINSZ, ADDC, DPOVRD, MATH1, SIZE(1), 0);
	MATHB(VSEQINSZ, ADDC, VSEQINSZ, MATH1, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, ADDC, VSEQOUTSZ, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, ADDC, ABD, MATH1, SIZE(1), 0);
	MATHB(VSEQINSZ, ADDC, OFIFO, MATH1, SIZE(2), 0);
	MATHB(VSEQINSZ, ADDC, ONE, MATH1, SIZE(4), 0);
	MATHB(VSEQINSZ, ADDC, ZERO, MATH1, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, ADDC, MATH0, MATH1, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADDC, MATH1, MATH1, SIZE(2), 0);
	MATHB(VSEQOUTSZ, ADDC, MATH2, MATH1, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, ADDC, MATH3, MATH1, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADDC, IMM(393615378), MATH1, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADDC, DPOVRD, MATH1, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, ADDC, VSEQINSZ, MATH1, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADDC, VSEQOUTSZ, MATH1, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, ADDC, ABD, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADDC, OFIFO, MATH1, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, ADDC, ONE, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADDC, ZERO, MATH1, SIZE(2), WITH(NFU));
	MATHB(ZERO, ADDC, MATH0, MATH1, SIZE(2), WITH(STL));
	MATHB(ZERO, ADDC, MATH1, MATH1, SIZE(1), 0);
	MATHB(ZERO, ADDC, MATH2, MATH1, SIZE(1), 0);
	MATHB(ZERO, ADDC, MATH3, MATH1, SIZE(1), 0);
	MATHB(ZERO, ADDC, IMM(393615378), MATH1, SIZE(8), WITH(IFB));
	MATHB(ZERO, ADDC, DPOVRD, MATH1, SIZE(4), 0);
	MATHB(ZERO, ADDC, VSEQINSZ, MATH1, SIZE(4), 0);
	MATHB(ZERO, ADDC, VSEQOUTSZ, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, ADDC, ABD, MATH1, SIZE(1), WITH(STL));
	MATHB(ZERO, ADDC, OFIFO, MATH1, SIZE(2), 0);
	MATHB(ZERO, ADDC, ONE, MATH1, SIZE(4), 0);
	MATHB(ZERO, ADDC, ZERO, MATH1, SIZE(2), WITH(STL));
	MATHB(ONE, ADDC, MATH0, MATH1, SIZE(8), WITH(NFU));
	MATHB(ONE, ADDC, MATH1, MATH1, SIZE(4), 0);
	MATHB(ONE, ADDC, MATH2, MATH1, SIZE(4), 0);
	MATHB(ONE, ADDC, MATH3, MATH1, SIZE(8), 0);
	MATHB(ONE, ADDC, IMM(393615378), MATH1, SIZE(1), WITH(NFU));
	MATHB(ONE, ADDC, DPOVRD, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, ADDC, VSEQINSZ, MATH1, SIZE(1), 0);
	MATHB(ONE, ADDC, VSEQOUTSZ, MATH1, SIZE(2), WITH(NFU));
	MATHB(ONE, ADDC, ABD, MATH1, SIZE(2), 0);
	MATHB(ONE, ADDC, OFIFO, MATH1, SIZE(4), 0);
	MATHB(ONE, ADDC, ONE, MATH1, SIZE(4), 0);
	MATHB(ONE, ADDC, ZERO, MATH1, SIZE(1), 0);
	/* ADDC operation: MATH2 Destination register */
	MATHB(MATH0, ADDC, MATH0, MATH2, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, ADDC, MATH1, MATH2, SIZE(2), 0);
	MATHB(MATH0, ADDC, MATH2, MATH2, SIZE(2), 0);
	MATHB(MATH0, ADDC, MATH3, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, ADDC, IMM(393615378), MATH2, SIZE(4), 0);
	MATHB(MATH0, ADDC, DPOVRD, MATH2, SIZE(8), 0);
	MATHB(MATH0, ADDC, VSEQINSZ, MATH2, SIZE(4), WITH(NFU));
	MATHB(MATH0, ADDC, VSEQOUTSZ, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, ADDC, ABD, MATH2, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, ADDC, OFIFO, MATH2, SIZE(4), 0);
	MATHB(MATH0, ADDC, ONE, MATH2, SIZE(2), WITH(NFU));
	MATHB(MATH0, ADDC, ZERO, MATH2, SIZE(1), WITH(STL));
	MATHB(MATH1, ADDC, MATH0, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(MATH1, ADDC, MATH1, MATH2, SIZE(2), WITH(STL));
	MATHB(MATH1, ADDC, MATH2, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(MATH1, ADDC, MATH3, MATH2, SIZE(4), 0);
	MATHB(MATH1, ADDC, IMM(393615378), MATH2, SIZE(1), WITH(NFU | STL));
	MATHB(MATH1, ADDC, DPOVRD, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, ADDC, VSEQINSZ, MATH2, SIZE(2), 0);
	MATHB(MATH1, ADDC, VSEQOUTSZ, MATH2, SIZE(4), WITH(STL));
	MATHB(MATH1, ADDC, ABD, MATH2, SIZE(1), 0);
	MATHB(MATH1, ADDC, OFIFO, MATH2, SIZE(4), 0);
	MATHB(MATH1, ADDC, ONE, MATH2, SIZE(4), WITH(NFU));
	MATHB(MATH1, ADDC, ZERO, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, ADDC, MATH0, MATH2, SIZE(8), 0);
	MATHB(MATH2, ADDC, MATH1, MATH2, SIZE(8), 0);
	MATHB(MATH2, ADDC, MATH2, MATH2, SIZE(4), WITH(NFU));
	MATHB(MATH2, ADDC, MATH3, MATH2, SIZE(4), WITH(NFU));
	MATHB(MATH2, ADDC, IMM(393615378), MATH2, SIZE(1), 0);
	MATHB(MATH2, ADDC, DPOVRD, MATH2, SIZE(8), 0);
	MATHB(MATH2, ADDC, VSEQINSZ, MATH2, SIZE(2), 0);
	MATHB(MATH2, ADDC, VSEQOUTSZ, MATH2, SIZE(8), WITH(NFU));
	MATHB(MATH2, ADDC, ABD, MATH2, SIZE(1), WITH(NFU));
	MATHB(MATH2, ADDC, OFIFO, MATH2, SIZE(8), 0);
	MATHB(MATH2, ADDC, ONE, MATH2, SIZE(1), 0);
	MATHB(MATH2, ADDC, ZERO, MATH2, SIZE(8), 0);
	MATHB(MATH3, ADDC, MATH0, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, ADDC, MATH1, MATH2, SIZE(4), 0);
	MATHB(MATH3, ADDC, MATH2, MATH2, SIZE(8), 0);
	MATHB(MATH3, ADDC, MATH3, MATH2, SIZE(1), WITH(STL));
	MATHB(MATH3, ADDC, IMM(393615378), MATH2, SIZE(1), 0);
	MATHB(MATH3, ADDC, DPOVRD, MATH2, SIZE(4), 0);
	MATHB(MATH3, ADDC, VSEQINSZ, MATH2, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, ADDC, VSEQOUTSZ, MATH2, SIZE(2), 0);
	MATHB(MATH3, ADDC, ABD, MATH2, SIZE(4), WITH(STL));
	MATHB(MATH3, ADDC, OFIFO, MATH2, SIZE(4), WITH(NFU));
	MATHB(MATH3, ADDC, ONE, MATH2, SIZE(8), 0);
	MATHB(MATH3, ADDC, ZERO, MATH2, SIZE(8), WITH(STL));
	MATHB(IMM(275128321), ADDC, MATH0, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), ADDC, MATH1, MATH2, SIZE(1), 0);
	MATHB(IMM(275128321), ADDC, MATH2, MATH2, SIZE(2), WITH(NFU));
	MATHB(IMM(275128321), ADDC, MATH3, MATH2, SIZE(2), 0);
	MATHB(IMM(275128321), ADDC, IMM(393615378), MATH2, SIZE(1), 0);
	MATHB(IMM(275128321), ADDC, DPOVRD, MATH2, SIZE(4), 0);
	MATHB(IMM(275128321), ADDC, VSEQINSZ, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(275128321), ADDC, VSEQOUTSZ, MATH2, SIZE(2), 0);
	MATHB(IMM(275128321), ADDC, ABD, MATH2, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), ADDC, OFIFO, MATH2, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), ADDC, ONE, MATH2, SIZE(2), 0);
	MATHB(IMM(275128321), ADDC, ZERO, MATH2, SIZE(1), WITH(NFU));
	MATHB(DPOVRD, ADDC, MATH0, MATH2, SIZE(1), WITH(NFU));
	MATHB(DPOVRD, ADDC, MATH1, MATH2, SIZE(1), WITH(NFU));
	MATHB(DPOVRD, ADDC, MATH2, MATH2, SIZE(4), 0);
	MATHB(DPOVRD, ADDC, MATH3, MATH2, SIZE(2), 0);
	MATHB(DPOVRD, ADDC, IMM(393615378), MATH2, SIZE(8), WITH(IFB | STL));
	MATHB(DPOVRD, ADDC, DPOVRD, MATH2, SIZE(1), WITH(NFU));
	MATHB(DPOVRD, ADDC, VSEQINSZ, MATH2, SIZE(2), 0);
	MATHB(DPOVRD, ADDC, VSEQOUTSZ, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, ADDC, ABD, MATH2, SIZE(4), WITH(STL));
	MATHB(DPOVRD, ADDC, OFIFO, MATH2, SIZE(4), 0);
	MATHB(DPOVRD, ADDC, ONE, MATH2, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, ADDC, ZERO, MATH2, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, ADDC, MATH0, MATH2, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, ADDC, MATH1, MATH2, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, ADDC, MATH2, MATH2, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, ADDC, MATH3, MATH2, SIZE(1), 0);
	MATHB(SEQINSZ, ADDC, IMM(393615378), MATH2, SIZE(1), 0);
	MATHB(SEQINSZ, ADDC, DPOVRD, MATH2, SIZE(1), 0);
	MATHB(SEQINSZ, ADDC, VSEQINSZ, MATH2, SIZE(8), 0);
	MATHB(SEQINSZ, ADDC, VSEQOUTSZ, MATH2, SIZE(4), 0);
	MATHB(SEQINSZ, ADDC, ABD, MATH2, SIZE(1), 0);
	MATHB(SEQINSZ, ADDC, OFIFO, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, ADDC, ONE, MATH2, SIZE(4), 0);
	MATHB(SEQINSZ, ADDC, ZERO, MATH2, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADDC, MATH0, MATH2, SIZE(8), 0);
	MATHB(SEQOUTSZ, ADDC, MATH1, MATH2, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADDC, MATH2, MATH2, SIZE(8), 0);
	MATHB(SEQOUTSZ, ADDC, MATH3, MATH2, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADDC, IMM(393615378), MATH2, SIZE(8), WITH(IFB));
	MATHB(SEQOUTSZ, ADDC, DPOVRD, MATH2, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, ADDC, VSEQINSZ, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADDC, VSEQOUTSZ, MATH2, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, ADDC, ABD, MATH2, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADDC, OFIFO, MATH2, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, ADDC, ONE, MATH2, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, ADDC, ZERO, MATH2, SIZE(2), 0);
	MATHB(VSEQINSZ, ADDC, MATH0, MATH2, SIZE(2), 0);
	MATHB(VSEQINSZ, ADDC, MATH1, MATH2, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, ADDC, MATH2, MATH2, SIZE(8), 0);
	MATHB(VSEQINSZ, ADDC, MATH3, MATH2, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, ADDC, IMM(393615378), MATH2, SIZE(8),
	      WITH(IFB | NFU | STL));
	MATHB(VSEQINSZ, ADDC, DPOVRD, MATH2, SIZE(2), 0);
	MATHB(VSEQINSZ, ADDC, VSEQINSZ, MATH2, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQINSZ, ADDC, VSEQOUTSZ, MATH2, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, ADDC, ABD, MATH2, SIZE(4), 0);
	MATHB(VSEQINSZ, ADDC, OFIFO, MATH2, SIZE(2), 0);
	MATHB(VSEQINSZ, ADDC, ONE, MATH2, SIZE(2), 0);
	MATHB(VSEQINSZ, ADDC, ZERO, MATH2, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, ADDC, MATH0, MATH2, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADDC, MATH1, MATH2, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, ADDC, MATH2, MATH2, SIZE(2), 0);
	MATHB(VSEQOUTSZ, ADDC, MATH3, MATH2, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, ADDC, IMM(393615378), MATH2, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADDC, DPOVRD, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADDC, VSEQINSZ, MATH2, SIZE(2), 0);
	MATHB(VSEQOUTSZ, ADDC, VSEQOUTSZ, MATH2, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, ADDC, ABD, MATH2, SIZE(2), 0);
	MATHB(VSEQOUTSZ, ADDC, OFIFO, MATH2, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, ADDC, ONE, MATH2, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, ADDC, ZERO, MATH2, SIZE(4), WITH(NFU));
	MATHB(ZERO, ADDC, MATH0, MATH2, SIZE(2), 0);
	MATHB(ZERO, ADDC, MATH1, MATH2, SIZE(1), 0);
	MATHB(ZERO, ADDC, MATH2, MATH2, SIZE(1), WITH(NFU));
	MATHB(ZERO, ADDC, MATH3, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, ADDC, IMM(393615378), MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, ADDC, DPOVRD, MATH2, SIZE(2), 0);
	MATHB(ZERO, ADDC, VSEQINSZ, MATH2, SIZE(8), 0);
	MATHB(ZERO, ADDC, VSEQOUTSZ, MATH2, SIZE(2), 0);
	MATHB(ZERO, ADDC, ABD, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, ADDC, OFIFO, MATH2, SIZE(4), 0);
	MATHB(ZERO, ADDC, ONE, MATH2, SIZE(2), 0);
	MATHB(ZERO, ADDC, ZERO, MATH2, SIZE(4), 0);
	MATHB(ONE, ADDC, MATH0, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, ADDC, MATH1, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, ADDC, MATH2, MATH2, SIZE(1), 0);
	MATHB(ONE, ADDC, MATH3, MATH2, SIZE(1), 0);
	MATHB(ONE, ADDC, IMM(0x19261959fedcba01), MATH2, SIZE(8), 0);
	MATHB(ONE, ADDC, DPOVRD, MATH2, SIZE(4), 0);
	MATHB(ONE, ADDC, VSEQINSZ, MATH2, SIZE(4), WITH(STL));
	MATHB(ONE, ADDC, VSEQOUTSZ, MATH2, SIZE(8), 0);
	MATHB(ONE, ADDC, ABD, MATH2, SIZE(2), 0);
	MATHB(ONE, ADDC, OFIFO, MATH2, SIZE(8), 0);
	MATHB(ONE, ADDC, ONE, MATH2, SIZE(8), WITH(NFU));
	MATHB(ONE, ADDC, ZERO, MATH2, SIZE(4), 0);
	/* ADDC operation: MATH3 Destination register */
	MATHB(MATH0, ADDC, MATH0, MATH3, SIZE(1), WITH(NFU));
	MATHB(MATH0, ADDC, MATH1, MATH3, SIZE(8), 0);
	MATHB(MATH0, ADDC, MATH2, MATH3, SIZE(2), WITH(NFU));
	MATHB(MATH0, ADDC, MATH3, MATH3, SIZE(1), WITH(STL));
	MATHB(MATH0, ADDC, IMM(393615378), MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, ADDC, DPOVRD, MATH3, SIZE(2), 0);
	MATHB(MATH0, ADDC, VSEQINSZ, MATH3, SIZE(4), 0);
	MATHB(MATH0, ADDC, VSEQOUTSZ, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, ADDC, ABD, MATH3, SIZE(2), WITH(STL));
	MATHB(MATH0, ADDC, OFIFO, MATH3, SIZE(4), WITH(NFU));
	MATHB(MATH0, ADDC, ONE, MATH3, SIZE(8), 0);
	MATHB(MATH0, ADDC, ZERO, MATH3, SIZE(8), 0);
	MATHB(MATH1, ADDC, MATH0, MATH3, SIZE(1), 0);
	MATHB(MATH1, ADDC, MATH1, MATH3, SIZE(4), 0);
	MATHB(MATH1, ADDC, MATH2, MATH3, SIZE(8), 0);
	MATHB(MATH1, ADDC, MATH3, MATH3, SIZE(4), WITH(STL));
	MATHB(MATH1, ADDC, IMM(393615378), MATH3, SIZE(4), WITH(NFU));
	MATHB(MATH1, ADDC, DPOVRD, MATH3, SIZE(2), 0);
	MATHB(MATH1, ADDC, VSEQINSZ, MATH3, SIZE(4), 0);
	MATHB(MATH1, ADDC, VSEQOUTSZ, MATH3, SIZE(2), 0);
	MATHB(MATH1, ADDC, ABD, MATH3, SIZE(4), WITH(STL));
	MATHB(MATH1, ADDC, OFIFO, MATH3, SIZE(2), 0);
	MATHB(MATH1, ADDC, ONE, MATH3, SIZE(2), 0);
	MATHB(MATH1, ADDC, ZERO, MATH3, SIZE(2), WITH(STL));
	MATHB(MATH2, ADDC, MATH0, MATH3, SIZE(8), WITH(STL));
	MATHB(MATH2, ADDC, MATH1, MATH3, SIZE(1), 0);
	MATHB(MATH2, ADDC, MATH2, MATH3, SIZE(2), WITH(NFU));
	MATHB(MATH2, ADDC, MATH3, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, ADDC, IMM(393615378), MATH3, SIZE(2), 0);
	MATHB(MATH2, ADDC, DPOVRD, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, ADDC, VSEQINSZ, MATH3, SIZE(1), 0);
	MATHB(MATH2, ADDC, VSEQOUTSZ, MATH3, SIZE(1), 0);
	MATHB(MATH2, ADDC, ABD, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, ADDC, OFIFO, MATH3, SIZE(1), 0);
	MATHB(MATH2, ADDC, ONE, MATH3, SIZE(2), 0);
	MATHB(MATH2, ADDC, ZERO, MATH3, SIZE(4), 0);
	MATHB(MATH3, ADDC, MATH0, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, ADDC, MATH1, MATH3, SIZE(2), 0);
	MATHB(MATH3, ADDC, MATH2, MATH3, SIZE(2), 0);
	MATHB(MATH3, ADDC, MATH3, MATH3, SIZE(2), 0);
	MATHB(MATH3, ADDC, IMM(393615378), MATH3, SIZE(1), 0);
	MATHB(MATH3, ADDC, DPOVRD, MATH3, SIZE(8), 0);
	MATHB(MATH3, ADDC, VSEQINSZ, MATH3, SIZE(4), 0);
	MATHB(MATH3, ADDC, VSEQOUTSZ, MATH3, SIZE(2), WITH(NFU));
	MATHB(MATH3, ADDC, ABD, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, ADDC, OFIFO, MATH3, SIZE(8), 0);
	MATHB(MATH3, ADDC, ONE, MATH3, SIZE(4), 0);
	MATHB(MATH3, ADDC, ZERO, MATH3, SIZE(8), 0);
	MATHB(IMM(275128321), ADDC, MATH0, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), ADDC, MATH1, MATH3, SIZE(2), 0);
	MATHB(IMM(275128321), ADDC, MATH2, MATH3, SIZE(4), 0);
	MATHB(IMM(275128321), ADDC, MATH3, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(275128321), ADDC, IMM(393615378), MATH3, SIZE(4), 0);
	MATHB(IMM(275128321), ADDC, DPOVRD, MATH3, SIZE(2), WITH(NFU));
	MATHB(IMM(275128321), ADDC, VSEQINSZ, MATH3, SIZE(2), 0);
	MATHB(IMM(275128321), ADDC, VSEQOUTSZ, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), ADDC, ABD, MATH3, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), ADDC, OFIFO, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(275128321), ADDC, ONE, MATH3, SIZE(2), 0);
	MATHB(IMM(275128321), ADDC, ZERO, MATH3, SIZE(4), 0);
	MATHB(DPOVRD, ADDC, MATH0, MATH3, SIZE(1), 0);
	MATHB(DPOVRD, ADDC, MATH1, MATH3, SIZE(4), 0);
	MATHB(DPOVRD, ADDC, MATH2, MATH3, SIZE(1), 0);
	MATHB(DPOVRD, ADDC, MATH3, MATH3, SIZE(1), WITH(NFU));
	MATHB(DPOVRD, ADDC, IMM(393615378), MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, ADDC, DPOVRD, MATH3, SIZE(2), WITH(STL));
	MATHB(DPOVRD, ADDC, VSEQINSZ, MATH3, SIZE(4), 0);
	MATHB(DPOVRD, ADDC, VSEQOUTSZ, MATH3, SIZE(4), 0);
	MATHB(DPOVRD, ADDC, ABD, MATH3, SIZE(1), 0);
	MATHB(DPOVRD, ADDC, OFIFO, MATH3, SIZE(4), 0);
	MATHB(DPOVRD, ADDC, ONE, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, ADDC, ZERO, MATH3, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, ADDC, MATH0, MATH3, SIZE(4), 0);
	MATHB(SEQINSZ, ADDC, MATH1, MATH3, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, ADDC, MATH2, MATH3, SIZE(1), 0);
	MATHB(SEQINSZ, ADDC, MATH3, MATH3, SIZE(8), 0);
	MATHB(SEQINSZ, ADDC, IMM(0x19261959fedcba01), MATH3, SIZE(8), 0);
	MATHB(SEQINSZ, ADDC, DPOVRD, MATH3, SIZE(8), 0);
	MATHB(SEQINSZ, ADDC, VSEQINSZ, MATH3, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, ADDC, VSEQOUTSZ, MATH3, SIZE(1), 0);
	MATHB(SEQINSZ, ADDC, ABD, MATH3, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, ADDC, OFIFO, MATH3, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, ADDC, ONE, MATH3, SIZE(4), 0);
	MATHB(SEQINSZ, ADDC, ZERO, MATH3, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADDC, MATH0, MATH3, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, ADDC, MATH1, MATH3, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADDC, MATH2, MATH3, SIZE(8), 0);
	MATHB(SEQOUTSZ, ADDC, MATH3, MATH3, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADDC, IMM(393615378), MATH3, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADDC, DPOVRD, MATH3, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, ADDC, VSEQINSZ, MATH3, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADDC, VSEQOUTSZ, MATH3, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, ADDC, ABD, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADDC, OFIFO, MATH3, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, ADDC, ONE, MATH3, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, ADDC, ZERO, MATH3, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, ADDC, MATH0, MATH3, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, ADDC, MATH1, MATH3, SIZE(2), 0);
	MATHB(VSEQINSZ, ADDC, MATH2, MATH3, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, ADDC, MATH3, MATH3, SIZE(1), 0);
	MATHB(VSEQINSZ, ADDC, IMM(393615378), MATH3, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, ADDC, DPOVRD, MATH3, SIZE(4), 0);
	MATHB(VSEQINSZ, ADDC, VSEQINSZ, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, ADDC, VSEQOUTSZ, MATH3, SIZE(2), 0);
	MATHB(VSEQINSZ, ADDC, ABD, MATH3, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, ADDC, OFIFO, MATH3, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, ADDC, ONE, MATH3, SIZE(1), 0);
	MATHB(VSEQINSZ, ADDC, ZERO, MATH3, SIZE(8), 0);
	MATHB(VSEQOUTSZ, ADDC, MATH0, MATH3, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, ADDC, MATH1, MATH3, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADDC, MATH2, MATH3, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, ADDC, MATH3, MATH3, SIZE(2), 0);
	MATHB(VSEQOUTSZ, ADDC, IMM(393615378), MATH3, SIZE(8), WITH(IFB));
	MATHB(VSEQOUTSZ, ADDC, DPOVRD, MATH3, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADDC, VSEQINSZ, MATH3, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, ADDC, VSEQOUTSZ, MATH3, SIZE(8), 0);
	MATHB(VSEQOUTSZ, ADDC, ABD, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADDC, OFIFO, MATH3, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, ADDC, ONE, MATH3, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, ADDC, ZERO, MATH3, SIZE(1), WITH(STL));
	MATHB(ZERO, ADDC, MATH0, MATH3, SIZE(8), WITH(NFU));
	MATHB(ZERO, ADDC, MATH1, MATH3, SIZE(2), 0);
	MATHB(ZERO, ADDC, MATH2, MATH3, SIZE(2), 0);
	MATHB(ZERO, ADDC, MATH3, MATH3, SIZE(8), 0);
	MATHB(ZERO, ADDC, IMM(393615378), MATH3, SIZE(1), 0);
	MATHB(ZERO, ADDC, DPOVRD, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, ADDC, VSEQINSZ, MATH3, SIZE(1), 0);
	MATHB(ZERO, ADDC, VSEQOUTSZ, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, ADDC, ABD, MATH3, SIZE(1), 0);
	MATHB(ZERO, ADDC, OFIFO, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, ADDC, ONE, MATH3, SIZE(1), 0);
	MATHB(ZERO, ADDC, ZERO, MATH3, SIZE(4), 0);
	MATHB(ONE, ADDC, MATH0, MATH3, SIZE(1), 0);
	MATHB(ONE, ADDC, MATH1, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, ADDC, MATH2, MATH3, SIZE(8), WITH(STL));
	MATHB(ONE, ADDC, MATH3, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, ADDC, IMM(393615378), MATH3, SIZE(2), 0);
	MATHB(ONE, ADDC, DPOVRD, MATH3, SIZE(1), 0);
	MATHB(ONE, ADDC, VSEQINSZ, MATH3, SIZE(2), WITH(NFU));
	MATHB(ONE, ADDC, VSEQOUTSZ, MATH3, SIZE(8), 0);
	MATHB(ONE, ADDC, ABD, MATH3, SIZE(1), 0);
	MATHB(ONE, ADDC, OFIFO, MATH3, SIZE(8), 0);
	MATHB(ONE, ADDC, ONE, MATH3, SIZE(4), WITH(STL));
	MATHB(ONE, ADDC, ZERO, MATH3, SIZE(4), 0);
	/* ADDC operation: DPOVRD Destination register */
	MATHB(MATH0, ADDC, MATH0, DPOVRD, SIZE(4), WITH(STL));
	MATHB(MATH0, ADDC, MATH1, DPOVRD, SIZE(4), WITH(STL));
	MATHB(MATH0, ADDC, MATH2, DPOVRD, SIZE(4), 0);
	MATHB(MATH0, ADDC, MATH3, DPOVRD, SIZE(2), WITH(STL));
	MATHB(MATH0, ADDC, IMM(0x19261959fedcba01), DPOVRD, SIZE(8),
	      WITH(NFU | STL));
	MATHB(MATH0, ADDC, DPOVRD, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, ADDC, VSEQINSZ, DPOVRD, SIZE(1), 0);
	MATHB(MATH0, ADDC, VSEQOUTSZ, DPOVRD, SIZE(8), 0);
	MATHB(MATH0, ADDC, ABD, DPOVRD, SIZE(4), 0);
	MATHB(MATH0, ADDC, OFIFO, DPOVRD, SIZE(2), WITH(STL));
	MATHB(MATH0, ADDC, ONE, DPOVRD, SIZE(4), 0);
	MATHB(MATH0, ADDC, ZERO, DPOVRD, SIZE(1), WITH(STL));
	MATHB(MATH1, ADDC, MATH0, DPOVRD, SIZE(4), 0);
	MATHB(MATH1, ADDC, MATH1, DPOVRD, SIZE(1), 0);
	MATHB(MATH1, ADDC, MATH2, DPOVRD, SIZE(2), WITH(STL));
	MATHB(MATH1, ADDC, MATH3, DPOVRD, SIZE(8), WITH(STL));
	MATHB(MATH1, ADDC, IMM(393615378), DPOVRD, SIZE(2), 0);
	MATHB(MATH1, ADDC, DPOVRD, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(MATH1, ADDC, VSEQINSZ, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(MATH1, ADDC, VSEQOUTSZ, DPOVRD, SIZE(1), 0);
	MATHB(MATH1, ADDC, ABD, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(MATH1, ADDC, OFIFO, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, ADDC, ONE, DPOVRD, SIZE(1), 0);
	MATHB(MATH1, ADDC, ZERO, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(MATH2, ADDC, MATH0, DPOVRD, SIZE(1), WITH(STL));
	MATHB(MATH2, ADDC, MATH1, DPOVRD, SIZE(4), 0);
	MATHB(MATH2, ADDC, MATH2, DPOVRD, SIZE(1), 0);
	MATHB(MATH2, ADDC, MATH3, DPOVRD, SIZE(2), WITH(STL));
	MATHB(MATH2, ADDC, IMM(393615378), DPOVRD, SIZE(8), WITH(IFB | NFU));
	MATHB(MATH2, ADDC, DPOVRD, DPOVRD, SIZE(1), 0);
	MATHB(MATH2, ADDC, VSEQINSZ, DPOVRD, SIZE(8), WITH(STL));
	MATHB(MATH2, ADDC, VSEQOUTSZ, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, ADDC, ABD, DPOVRD, SIZE(1), 0);
	MATHB(MATH2, ADDC, OFIFO, DPOVRD, SIZE(2), 0);
	MATHB(MATH2, ADDC, ONE, DPOVRD, SIZE(8), 0);
	MATHB(MATH2, ADDC, ZERO, DPOVRD, SIZE(4), WITH(STL));
	MATHB(MATH3, ADDC, MATH0, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, ADDC, MATH1, DPOVRD, SIZE(4), 0);
	MATHB(MATH3, ADDC, MATH2, DPOVRD, SIZE(8), 0);
	MATHB(MATH3, ADDC, MATH3, DPOVRD, SIZE(4), WITH(STL));
	MATHB(MATH3, ADDC, IMM(393615378), DPOVRD, SIZE(1), 0);
	MATHB(MATH3, ADDC, DPOVRD, DPOVRD, SIZE(8), WITH(STL));
	MATHB(MATH3, ADDC, VSEQINSZ, DPOVRD, SIZE(4), 0);
	MATHB(MATH3, ADDC, VSEQOUTSZ, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, ADDC, ABD, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, ADDC, OFIFO, DPOVRD, SIZE(2), 0);
	MATHB(MATH3, ADDC, ONE, DPOVRD, SIZE(1), 0);
	MATHB(MATH3, ADDC, ZERO, DPOVRD, SIZE(8), 0);
	MATHB(IMM(275128321), ADDC, MATH0, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), ADDC, MATH1, DPOVRD, SIZE(4), 0);
	MATHB(IMM(275128321), ADDC, MATH2, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), ADDC, MATH3, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(275128321), ADDC, IMM(393615378), DPOVRD, SIZE(1), 0);
	MATHB(IMM(275128321), ADDC, DPOVRD, DPOVRD, SIZE(1), 0);
	MATHB(IMM(275128321), ADDC, VSEQINSZ, DPOVRD, SIZE(2), WITH(STL));
	MATHB(IMM(275128321), ADDC, VSEQOUTSZ, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), ADDC, ABD, DPOVRD, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), ADDC, OFIFO, DPOVRD, SIZE(1), 0);
	MATHB(IMM(275128321), ADDC, ONE, DPOVRD, SIZE(4), 0);
	MATHB(IMM(275128321), ADDC, ZERO, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, ADDC, MATH0, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, ADDC, MATH1, DPOVRD, SIZE(8), 0);
	MATHB(DPOVRD, ADDC, MATH2, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, ADDC, MATH3, DPOVRD, SIZE(2), 0);
	MATHB(DPOVRD, ADDC, IMM(393615378), DPOVRD, SIZE(8), WITH(IFB));
	MATHB(DPOVRD, ADDC, DPOVRD, DPOVRD, SIZE(8), 0);
	MATHB(DPOVRD, ADDC, VSEQINSZ, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, ADDC, VSEQOUTSZ, DPOVRD, SIZE(4), 0);
	MATHB(DPOVRD, ADDC, ABD, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, ADDC, OFIFO, DPOVRD, SIZE(2), WITH(STL));
	MATHB(DPOVRD, ADDC, ONE, DPOVRD, SIZE(2), 0);
	MATHB(DPOVRD, ADDC, ZERO, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, ADDC, MATH0, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, ADDC, MATH1, DPOVRD, SIZE(1), 0);
	MATHB(SEQINSZ, ADDC, MATH2, DPOVRD, SIZE(1), 0);
	MATHB(SEQINSZ, ADDC, MATH3, DPOVRD, SIZE(8), 0);
	MATHB(SEQINSZ, ADDC, IMM(393615378), DPOVRD, SIZE(8), WITH(IFB));
	MATHB(SEQINSZ, ADDC, DPOVRD, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, ADDC, VSEQINSZ, DPOVRD, SIZE(4), 0);
	MATHB(SEQINSZ, ADDC, VSEQOUTSZ, DPOVRD, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, ADDC, ABD, DPOVRD, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, ADDC, OFIFO, DPOVRD, SIZE(8), 0);
	MATHB(SEQINSZ, ADDC, ONE, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, ADDC, ZERO, DPOVRD, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, ADDC, MATH0, DPOVRD, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADDC, MATH1, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADDC, MATH2, DPOVRD, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADDC, MATH3, DPOVRD, SIZE(8), 0);
	MATHB(SEQOUTSZ, ADDC, IMM(393615378), DPOVRD, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, ADDC, DPOVRD, DPOVRD, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADDC, VSEQINSZ, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADDC, VSEQOUTSZ, DPOVRD, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, ADDC, ABD, DPOVRD, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, ADDC, OFIFO, DPOVRD, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADDC, ONE, DPOVRD, SIZE(2), 0);
	MATHB(SEQOUTSZ, ADDC, ZERO, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, ADDC, MATH0, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, ADDC, MATH1, DPOVRD, SIZE(8), 0);
	MATHB(VSEQINSZ, ADDC, MATH2, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, ADDC, MATH3, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, ADDC, IMM(393615378), DPOVRD, SIZE(2), 0);
	MATHB(VSEQINSZ, ADDC, DPOVRD, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, ADDC, VSEQINSZ, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, ADDC, VSEQOUTSZ, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, ADDC, ABD, DPOVRD, SIZE(1), 0);
	MATHB(VSEQINSZ, ADDC, OFIFO, DPOVRD, SIZE(4), WITH(STL));
	MATHB(VSEQINSZ, ADDC, ONE, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, ADDC, ZERO, DPOVRD, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADDC, MATH0, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, ADDC, MATH1, DPOVRD, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, ADDC, MATH2, DPOVRD, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADDC, MATH3, DPOVRD, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADDC, IMM(393615378), DPOVRD, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADDC, DPOVRD, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, ADDC, VSEQINSZ, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADDC, VSEQOUTSZ, DPOVRD, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, ADDC, ABD, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADDC, OFIFO, DPOVRD, SIZE(2), 0);
	MATHB(VSEQOUTSZ, ADDC, ONE, DPOVRD, SIZE(8), 0);
	MATHB(VSEQOUTSZ, ADDC, ZERO, DPOVRD, SIZE(2), 0);
	MATHB(ZERO, ADDC, MATH0, DPOVRD, SIZE(1), 0);
	MATHB(ZERO, ADDC, MATH1, DPOVRD, SIZE(8), 0);
	MATHB(ZERO, ADDC, MATH2, DPOVRD, SIZE(2), 0);
	MATHB(ZERO, ADDC, MATH3, DPOVRD, SIZE(1), 0);
	MATHB(ZERO, ADDC, IMM(393615378), DPOVRD, SIZE(8), WITH(IFB));
	MATHB(ZERO, ADDC, DPOVRD, DPOVRD, SIZE(8), WITH(STL));
	MATHB(ZERO, ADDC, VSEQINSZ, DPOVRD, SIZE(2), WITH(STL));
	MATHB(ZERO, ADDC, VSEQOUTSZ, DPOVRD, SIZE(4), 0);
	MATHB(ZERO, ADDC, ABD, DPOVRD, SIZE(1), WITH(STL));
	MATHB(ZERO, ADDC, OFIFO, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, ADDC, ONE, DPOVRD, SIZE(1), 0);
	MATHB(ZERO, ADDC, ZERO, DPOVRD, SIZE(1), WITH(STL));
	MATHB(ONE, ADDC, MATH0, DPOVRD, SIZE(4), 0);
	MATHB(ONE, ADDC, MATH1, DPOVRD, SIZE(2), 0);
	MATHB(ONE, ADDC, MATH2, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, ADDC, MATH3, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(ONE, ADDC, IMM(393615378), DPOVRD, SIZE(4), 0);
	MATHB(ONE, ADDC, DPOVRD, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, ADDC, VSEQINSZ, DPOVRD, SIZE(8), 0);
	MATHB(ONE, ADDC, VSEQOUTSZ, DPOVRD, SIZE(4), 0);
	MATHB(ONE, ADDC, ABD, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, ADDC, OFIFO, DPOVRD, SIZE(4), 0);
	MATHB(ONE, ADDC, ONE, DPOVRD, SIZE(8), 0);
	MATHB(ONE, ADDC, ZERO, DPOVRD, SIZE(1), 0);
	/* ADDC operation: SEQINSZ Destination register */
	MATHB(MATH0, ADDC, MATH0, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH0, ADDC, MATH1, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(MATH0, ADDC, MATH2, SEQINSZ, SIZE(2), 0);
	MATHB(MATH0, ADDC, MATH3, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH0, ADDC, IMM(393615378), SEQINSZ, SIZE(4), WITH(STL));
	MATHB(MATH0, ADDC, DPOVRD, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, ADDC, VSEQINSZ, SEQINSZ, SIZE(2), 0);
	MATHB(MATH0, ADDC, VSEQOUTSZ, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, ADDC, ABD, SEQINSZ, SIZE(4), 0);
	MATHB(MATH0, ADDC, OFIFO, SEQINSZ, SIZE(1), 0);
	MATHB(MATH0, ADDC, ONE, SEQINSZ, SIZE(4), 0);
	MATHB(MATH0, ADDC, ZERO, SEQINSZ, SIZE(8), 0);
	MATHB(MATH1, ADDC, MATH0, SEQINSZ, SIZE(1), 0);
	MATHB(MATH1, ADDC, MATH1, SEQINSZ, SIZE(2), 0);
	MATHB(MATH1, ADDC, MATH2, SEQINSZ, SIZE(2), 0);
	MATHB(MATH1, ADDC, MATH3, SEQINSZ, SIZE(1), 0);
	MATHB(MATH1, ADDC, IMM(393615378), SEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH1, ADDC, DPOVRD, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(MATH1, ADDC, VSEQINSZ, SEQINSZ, SIZE(4), 0);
	MATHB(MATH1, ADDC, VSEQOUTSZ, SEQINSZ, SIZE(1), 0);
	MATHB(MATH1, ADDC, ABD, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH1, ADDC, OFIFO, SEQINSZ, SIZE(1), 0);
	MATHB(MATH1, ADDC, ONE, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(MATH1, ADDC, ZERO, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(MATH2, ADDC, MATH0, SEQINSZ, SIZE(4), 0);
	MATHB(MATH2, ADDC, MATH1, SEQINSZ, SIZE(1), 0);
	MATHB(MATH2, ADDC, MATH2, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH2, ADDC, MATH3, SEQINSZ, SIZE(4), 0);
	MATHB(MATH2, ADDC, IMM(393615378), SEQINSZ, SIZE(2), 0);
	MATHB(MATH2, ADDC, DPOVRD, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, ADDC, VSEQINSZ, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, ADDC, VSEQOUTSZ, SEQINSZ, SIZE(4), 0);
	MATHB(MATH2, ADDC, ABD, SEQINSZ, SIZE(8), 0);
	MATHB(MATH2, ADDC, OFIFO, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(MATH2, ADDC, ONE, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, ADDC, ZERO, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH3, ADDC, MATH0, SEQINSZ, SIZE(8), 0);
	MATHB(MATH3, ADDC, MATH1, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(MATH3, ADDC, MATH2, SEQINSZ, SIZE(4), 0);
	MATHB(MATH3, ADDC, MATH3, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH3, ADDC, IMM(393615378), SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, ADDC, DPOVRD, SEQINSZ, SIZE(8), 0);
	MATHB(MATH3, ADDC, VSEQINSZ, SEQINSZ, SIZE(4), 0);
	MATHB(MATH3, ADDC, VSEQOUTSZ, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(MATH3, ADDC, ABD, SEQINSZ, SIZE(8), 0);
	MATHB(MATH3, ADDC, OFIFO, SEQINSZ, SIZE(2), 0);
	MATHB(MATH3, ADDC, ONE, SEQINSZ, SIZE(2), 0);
	MATHB(MATH3, ADDC, ZERO, SEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), ADDC, MATH0, SEQINSZ, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), ADDC, MATH1, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), ADDC, MATH2, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), ADDC, MATH3, SEQINSZ, SIZE(4), 0);
	MATHB(IMM(275128321), ADDC, IMM(393615378), SEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), ADDC, DPOVRD, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(IMM(0x19261959fedcba01), ADDC, VSEQINSZ, SEQINSZ, SIZE(8),
	      WITH(NFU));
	MATHB(IMM(275128321), ADDC, VSEQOUTSZ, SEQINSZ, SIZE(2), 0);
	MATHB(IMM(0x19261959fedcba01), ADDC, ABD, SEQINSZ, SIZE(8),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), ADDC, OFIFO, SEQINSZ, SIZE(8), WITH(IFB | STL));
	MATHB(IMM(275128321), ADDC, ONE, SEQINSZ, SIZE(8),
	      WITH(IFB | NFU | STL));
	MATHB(IMM(0x19261959fedcba01), ADDC, ZERO, SEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, ADDC, MATH0, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, ADDC, MATH1, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, ADDC, MATH2, SEQINSZ, SIZE(4), 0);
	MATHB(DPOVRD, ADDC, MATH3, SEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, ADDC, IMM(393615378), SEQINSZ, SIZE(1), WITH(STL));
	MATHB(DPOVRD, ADDC, DPOVRD, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, ADDC, VSEQINSZ, SEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, ADDC, VSEQOUTSZ, SEQINSZ, SIZE(4), 0);
	MATHB(DPOVRD, ADDC, ABD, SEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, ADDC, OFIFO, SEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, ADDC, ONE, SEQINSZ, SIZE(4), 0);
	MATHB(DPOVRD, ADDC, ZERO, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, ADDC, MATH0, SEQINSZ, SIZE(4), 0);
	MATHB(SEQINSZ, ADDC, MATH1, SEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, ADDC, MATH2, SEQINSZ, SIZE(8), 0);
	MATHB(SEQINSZ, ADDC, MATH3, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(SEQINSZ, ADDC, IMM(393615378), SEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, ADDC, DPOVRD, SEQINSZ, SIZE(1), 0);
	MATHB(SEQINSZ, ADDC, VSEQINSZ, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, ADDC, VSEQOUTSZ, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, ADDC, ABD, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, ADDC, OFIFO, SEQINSZ, SIZE(1), 0);
	MATHB(SEQINSZ, ADDC, ONE, SEQINSZ, SIZE(8), 0);
	MATHB(SEQINSZ, ADDC, ZERO, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADDC, MATH0, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADDC, MATH1, SEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, ADDC, MATH2, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(SEQOUTSZ, ADDC, MATH3, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADDC, IMM(393615378), SEQINSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADDC, DPOVRD, SEQINSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADDC, VSEQINSZ, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, ADDC, VSEQOUTSZ, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, ADDC, ABD, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADDC, OFIFO, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, ADDC, ONE, SEQINSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADDC, ZERO, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, ADDC, MATH0, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, ADDC, MATH1, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, ADDC, MATH2, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, ADDC, MATH3, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, ADDC, IMM(393615378), SEQINSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, ADDC, DPOVRD, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, ADDC, VSEQINSZ, SEQINSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, ADDC, VSEQOUTSZ, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, ADDC, ABD, SEQINSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, ADDC, OFIFO, SEQINSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, ADDC, ONE, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, ADDC, ZERO, SEQINSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADDC, MATH0, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADDC, MATH1, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, ADDC, MATH2, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, ADDC, MATH3, SEQINSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADDC, IMM(393615378), SEQINSZ, SIZE(8), WITH(IFB));
	MATHB(VSEQOUTSZ, ADDC, DPOVRD, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, ADDC, VSEQINSZ, SEQINSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADDC, VSEQOUTSZ, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, ADDC, ABD, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, ADDC, OFIFO, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, ADDC, ONE, SEQINSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADDC, ZERO, SEQINSZ, SIZE(1), 0);
	MATHB(ZERO, ADDC, MATH0, SEQINSZ, SIZE(8), 0);
	MATHB(ZERO, ADDC, MATH1, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(ZERO, ADDC, MATH2, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(ZERO, ADDC, MATH3, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(ZERO, ADDC, IMM(393615378), SEQINSZ, SIZE(2), 0);
	MATHB(ZERO, ADDC, DPOVRD, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(ZERO, ADDC, VSEQINSZ, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(ZERO, ADDC, VSEQOUTSZ, SEQINSZ, SIZE(1), 0);
	MATHB(ZERO, ADDC, ABD, SEQINSZ, SIZE(8), 0);
	MATHB(ZERO, ADDC, OFIFO, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(ZERO, ADDC, ONE, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(ZERO, ADDC, ZERO, SEQINSZ, SIZE(8), 0);
	MATHB(ONE, ADDC, MATH0, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, ADDC, MATH1, SEQINSZ, SIZE(4), 0);
	MATHB(ONE, ADDC, MATH2, SEQINSZ, SIZE(1), 0);
	MATHB(ONE, ADDC, MATH3, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, ADDC, IMM(0x19261959fedcba01), SEQINSZ, SIZE(8), 0);
	MATHB(ONE, ADDC, DPOVRD, SEQINSZ, SIZE(4), 0);
	MATHB(ONE, ADDC, VSEQINSZ, SEQINSZ, SIZE(8), 0);
	MATHB(ONE, ADDC, VSEQOUTSZ, SEQINSZ, SIZE(2), 0);
	MATHB(ONE, ADDC, ABD, SEQINSZ, SIZE(4), 0);
	MATHB(ONE, ADDC, OFIFO, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(ONE, ADDC, ONE, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, ADDC, ZERO, SEQINSZ, SIZE(1), 0);
	/* ADDC operation: SEQOUTSZ Destination register */
	MATHB(MATH0, ADDC, MATH0, SEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(MATH0, ADDC, MATH1, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH0, ADDC, MATH2, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(MATH0, ADDC, MATH3, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH0, ADDC, IMM(393615378), SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH0, ADDC, DPOVRD, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, ADDC, VSEQINSZ, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH0, ADDC, VSEQOUTSZ, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH0, ADDC, ABD, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(MATH0, ADDC, OFIFO, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, ADDC, ONE, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(MATH0, ADDC, ZERO, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(MATH1, ADDC, MATH0, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH1, ADDC, MATH1, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, ADDC, MATH2, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, ADDC, MATH3, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, ADDC, IMM(393615378), SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH1, ADDC, DPOVRD, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, ADDC, VSEQINSZ, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH1, ADDC, VSEQOUTSZ, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(MATH1, ADDC, ABD, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH1, ADDC, OFIFO, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH1, ADDC, ONE, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, ADDC, ZERO, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH2, ADDC, MATH0, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, ADDC, MATH1, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, ADDC, MATH2, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH2, ADDC, MATH3, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(MATH2, ADDC, IMM(393615378), SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(MATH2, ADDC, DPOVRD, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, ADDC, VSEQINSZ, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH2, ADDC, VSEQOUTSZ, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, ADDC, ABD, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, ADDC, OFIFO, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, ADDC, ONE, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, ADDC, ZERO, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH3, ADDC, MATH0, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, ADDC, MATH1, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, ADDC, MATH2, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH3, ADDC, MATH3, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH3, ADDC, IMM(0x19261959fedcba01), SEQOUTSZ, SIZE(8),
	      WITH(NFU | STL));
	MATHB(MATH3, ADDC, DPOVRD, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH3, ADDC, VSEQINSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH3, ADDC, VSEQOUTSZ, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, ADDC, ABD, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, ADDC, OFIFO, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH3, ADDC, ONE, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, ADDC, ZERO, SEQOUTSZ, SIZE(8), 0);
	MATHB(IMM(275128321), ADDC, MATH0, SEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), ADDC, MATH1, SEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(275128321), ADDC, MATH2, SEQOUTSZ, SIZE(8),
	      WITH(IFB | NFU | STL));
	MATHB(IMM(275128321), ADDC, MATH3, SEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), ADDC, IMM(393615378), SEQOUTSZ, SIZE(1), 0);
	MATHB(IMM(275128321), ADDC, DPOVRD, SEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(275128321), ADDC, VSEQINSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(275128321), ADDC, VSEQOUTSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(275128321), ADDC, ABD, SEQOUTSZ, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), ADDC, OFIFO, SEQOUTSZ, SIZE(1), 0);
	MATHB(IMM(275128321), ADDC, ONE, SEQOUTSZ, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), ADDC, ZERO, SEQOUTSZ, SIZE(4), 0);
	MATHB(DPOVRD, ADDC, MATH0, SEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, ADDC, MATH1, SEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, ADDC, MATH2, SEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, ADDC, MATH3, SEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, ADDC, IMM(393615378), SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, ADDC, DPOVRD, SEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, ADDC, VSEQINSZ, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(DPOVRD, ADDC, VSEQOUTSZ, SEQOUTSZ, SIZE(4), 0);
	MATHB(DPOVRD, ADDC, ABD, SEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, ADDC, OFIFO, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, ADDC, ONE, SEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, ADDC, ZERO, SEQOUTSZ, SIZE(4), 0);
	MATHB(SEQINSZ, ADDC, MATH0, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, ADDC, MATH1, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, ADDC, MATH2, SEQOUTSZ, SIZE(8), 0);
	MATHB(SEQINSZ, ADDC, MATH3, SEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, ADDC, IMM(393615378), SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, ADDC, DPOVRD, SEQOUTSZ, SIZE(4), 0);
	MATHB(SEQINSZ, ADDC, VSEQINSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQINSZ, ADDC, VSEQOUTSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(SEQINSZ, ADDC, ABD, SEQOUTSZ, SIZE(4), 0);
	MATHB(SEQINSZ, ADDC, OFIFO, SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, ADDC, ONE, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, ADDC, ZERO, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADDC, MATH0, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, ADDC, MATH1, SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, ADDC, MATH2, SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, ADDC, MATH3, SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, ADDC, IMM(393615378), SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, ADDC, DPOVRD, SEQOUTSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADDC, VSEQINSZ, SEQOUTSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADDC, VSEQOUTSZ, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, ADDC, ABD, SEQOUTSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, ADDC, OFIFO, SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADDC, ONE, SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADDC, ZERO, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, ADDC, MATH0, SEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, ADDC, MATH1, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(VSEQINSZ, ADDC, MATH2, SEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, ADDC, MATH3, SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, ADDC, IMM(393615378), SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, ADDC, DPOVRD, SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, ADDC, VSEQINSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, ADDC, VSEQOUTSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, ADDC, ABD, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, ADDC, OFIFO, SEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, ADDC, ONE, SEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, ADDC, ZERO, SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADDC, MATH0, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, ADDC, MATH1, SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADDC, MATH2, SEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, ADDC, MATH3, SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADDC, IMM(393615378), SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADDC, DPOVRD, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, ADDC, VSEQINSZ, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, ADDC, VSEQOUTSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, ADDC, ABD, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADDC, OFIFO, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, ADDC, ONE, SEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, ADDC, ZERO, SEQOUTSZ, SIZE(4), 0);
	MATHB(ZERO, ADDC, MATH0, SEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, ADDC, MATH1, SEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, ADDC, MATH2, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, ADDC, MATH3, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(ZERO, ADDC, IMM(393615378), SEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, ADDC, DPOVRD, SEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, ADDC, VSEQINSZ, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(ZERO, ADDC, VSEQOUTSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(ZERO, ADDC, ABD, SEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, ADDC, OFIFO, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(ZERO, ADDC, ONE, SEQOUTSZ, SIZE(8), 0);
	MATHB(ZERO, ADDC, ZERO, SEQOUTSZ, SIZE(2), 0);
	MATHB(ONE, ADDC, MATH0, SEQOUTSZ, SIZE(8), 0);
	MATHB(ONE, ADDC, MATH1, SEQOUTSZ, SIZE(8), 0);
	MATHB(ONE, ADDC, MATH2, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(ONE, ADDC, MATH3, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(ONE, ADDC, IMM(393615378), SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, ADDC, DPOVRD, SEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(ONE, ADDC, VSEQINSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(ONE, ADDC, VSEQOUTSZ, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, ADDC, ABD, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(ONE, ADDC, OFIFO, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(ONE, ADDC, ONE, SEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, ADDC, ZERO, SEQOUTSZ, SIZE(2), 0);
	/* ADDC operation: VSEQINSZ Destination register */
	MATHB(MATH0, ADDC, MATH0, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(MATH0, ADDC, MATH1, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH0, ADDC, MATH2, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(MATH0, ADDC, MATH3, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, ADDC, IMM(0x19261959fedcba01), VSEQINSZ, SIZE(8),
	      WITH(STL));
	MATHB(MATH0, ADDC, DPOVRD, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH0, ADDC, VSEQINSZ, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH0, ADDC, VSEQOUTSZ, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(MATH0, ADDC, ABD, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH0, ADDC, OFIFO, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH0, ADDC, ONE, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(MATH0, ADDC, ZERO, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH1, ADDC, MATH0, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH1, ADDC, MATH1, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH1, ADDC, MATH2, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH1, ADDC, MATH3, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH1, ADDC, IMM(393615378), VSEQINSZ, SIZE(4), 0);
	MATHB(MATH1, ADDC, DPOVRD, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(MATH1, ADDC, VSEQINSZ, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH1, ADDC, VSEQOUTSZ, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH1, ADDC, ABD, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH1, ADDC, OFIFO, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH1, ADDC, ONE, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH1, ADDC, ZERO, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH2, ADDC, MATH0, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH2, ADDC, MATH1, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH2, ADDC, MATH2, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH2, ADDC, MATH3, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH2, ADDC, IMM(393615378), VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH2, ADDC, DPOVRD, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH2, ADDC, VSEQINSZ, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH2, ADDC, VSEQOUTSZ, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH2, ADDC, ABD, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH2, ADDC, OFIFO, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH2, ADDC, ONE, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH2, ADDC, ZERO, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH3, ADDC, MATH0, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH3, ADDC, MATH1, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH3, ADDC, MATH2, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH3, ADDC, MATH3, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, ADDC, IMM(393615378), VSEQINSZ, SIZE(8), WITH(IFB | STL));
	MATHB(MATH3, ADDC, DPOVRD, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH3, ADDC, VSEQINSZ, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, ADDC, VSEQOUTSZ, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, ADDC, ABD, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH3, ADDC, OFIFO, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH3, ADDC, ONE, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH3, ADDC, ZERO, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(275128321), ADDC, MATH0, VSEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), ADDC, MATH1, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), ADDC, MATH2, VSEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), ADDC, MATH3, VSEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), ADDC, IMM(393615378), VSEQINSZ, SIZE(2),
	      WITH(STL));
	MATHB(IMM(275128321), ADDC, DPOVRD, VSEQINSZ, SIZE(4), 0);
	MATHB(IMM(275128321), ADDC, VSEQINSZ, VSEQINSZ, SIZE(4), 0);
	MATHB(IMM(275128321), ADDC, VSEQOUTSZ, VSEQINSZ, SIZE(4),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), ADDC, ABD, VSEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), ADDC, OFIFO, VSEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), ADDC, ONE, VSEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), ADDC, ZERO, VSEQINSZ, SIZE(8), WITH(IFB));
	MATHB(DPOVRD, ADDC, MATH0, VSEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, ADDC, MATH1, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(DPOVRD, ADDC, MATH2, VSEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, ADDC, MATH3, VSEQINSZ, SIZE(4), 0);
	MATHB(DPOVRD, ADDC, IMM(393615378), VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, ADDC, DPOVRD, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(DPOVRD, ADDC, VSEQINSZ, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(DPOVRD, ADDC, VSEQOUTSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(DPOVRD, ADDC, ABD, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(DPOVRD, ADDC, OFIFO, VSEQINSZ, SIZE(4), 0);
	MATHB(DPOVRD, ADDC, ONE, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, ADDC, ZERO, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQINSZ, ADDC, MATH0, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQINSZ, ADDC, MATH1, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, ADDC, MATH2, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQINSZ, ADDC, MATH3, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, ADDC, IMM(393615378), VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, ADDC, DPOVRD, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, ADDC, VSEQINSZ, VSEQINSZ, SIZE(4), 0);
	MATHB(SEQINSZ, ADDC, VSEQOUTSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(SEQINSZ, ADDC, ABD, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, ADDC, OFIFO, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, ADDC, ONE, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, ADDC, ZERO, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADDC, MATH0, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, ADDC, MATH1, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, ADDC, MATH2, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, ADDC, MATH3, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, ADDC, IMM(393615378), VSEQINSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, ADDC, DPOVRD, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, ADDC, VSEQINSZ, VSEQINSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADDC, VSEQOUTSZ, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, ADDC, ABD, VSEQINSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADDC, OFIFO, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, ADDC, ONE, VSEQINSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADDC, ZERO, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, ADDC, MATH0, VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, ADDC, MATH1, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, ADDC, MATH2, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, ADDC, MATH3, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, ADDC, IMM(0x19261959fedcba01), VSEQINSZ, SIZE(8),
	      WITH(STL));
	MATHB(VSEQINSZ, ADDC, DPOVRD, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, ADDC, VSEQINSZ, VSEQINSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, ADDC, VSEQOUTSZ, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQINSZ, ADDC, ABD, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, ADDC, OFIFO, VSEQINSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, ADDC, ONE, VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, ADDC, ZERO, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADDC, MATH0, VSEQINSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, ADDC, MATH1, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADDC, MATH2, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, ADDC, MATH3, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, ADDC, IMM(393615378), VSEQINSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADDC, DPOVRD, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADDC, VSEQINSZ, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADDC, VSEQOUTSZ, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, ADDC, ABD, VSEQINSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADDC, OFIFO, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, ADDC, ONE, VSEQINSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADDC, ZERO, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(ZERO, ADDC, MATH0, VSEQINSZ, SIZE(2), 0);
	MATHB(ZERO, ADDC, MATH1, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(ZERO, ADDC, MATH2, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(ZERO, ADDC, MATH3, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(ZERO, ADDC, IMM(393615378), VSEQINSZ, SIZE(4), 0);
	MATHB(ZERO, ADDC, DPOVRD, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(ZERO, ADDC, VSEQINSZ, VSEQINSZ, SIZE(4), 0);
	MATHB(ZERO, ADDC, VSEQOUTSZ, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, ADDC, ABD, VSEQINSZ, SIZE(2), 0);
	MATHB(ZERO, ADDC, OFIFO, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(ZERO, ADDC, ONE, VSEQINSZ, SIZE(1), 0);
	MATHB(ZERO, ADDC, ZERO, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(ONE, ADDC, MATH0, VSEQINSZ, SIZE(4), 0);
	MATHB(ONE, ADDC, MATH1, VSEQINSZ, SIZE(2), 0);
	MATHB(ONE, ADDC, MATH2, VSEQINSZ, SIZE(8), 0);
	MATHB(ONE, ADDC, MATH3, VSEQINSZ, SIZE(2), 0);
	MATHB(ONE, ADDC, IMM(393615378), VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(ONE, ADDC, DPOVRD, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(ONE, ADDC, VSEQINSZ, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(ONE, ADDC, VSEQOUTSZ, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(ONE, ADDC, ABD, VSEQINSZ, SIZE(4), 0);
	MATHB(ONE, ADDC, OFIFO, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(ONE, ADDC, ONE, VSEQINSZ, SIZE(4), 0);
	MATHB(ONE, ADDC, ZERO, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH0, ADDC, MATH0, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, ADDC, MATH1, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(MATH0, ADDC, MATH2, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH0, ADDC, MATH3, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH0, ADDC, IMM(393615378), VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH0, ADDC, DPOVRD, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH0, ADDC, VSEQINSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, ADDC, VSEQOUTSZ, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH0, ADDC, ABD, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH0, ADDC, OFIFO, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH0, ADDC, ONE, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(MATH0, ADDC, ZERO, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(MATH1, ADDC, MATH0, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(MATH1, ADDC, MATH1, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH1, ADDC, MATH2, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, ADDC, MATH3, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH1, ADDC, IMM(393615378), VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH1, ADDC, DPOVRD, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH1, ADDC, VSEQINSZ, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH1, ADDC, VSEQOUTSZ, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH1, ADDC, ABD, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH1, ADDC, OFIFO, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(MATH1, ADDC, ONE, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, ADDC, ZERO, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(MATH2, ADDC, MATH0, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, ADDC, MATH1, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH2, ADDC, MATH2, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH2, ADDC, MATH3, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH2, ADDC, IMM(393615378), VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(MATH2, ADDC, DPOVRD, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, ADDC, VSEQINSZ, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH2, ADDC, VSEQOUTSZ, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, ADDC, ABD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, ADDC, OFIFO, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH2, ADDC, ONE, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, ADDC, ZERO, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH3, ADDC, MATH0, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH3, ADDC, MATH1, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH3, ADDC, MATH2, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, ADDC, MATH3, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH3, ADDC, IMM(393615378), VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, ADDC, DPOVRD, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH3, ADDC, VSEQINSZ, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH3, ADDC, VSEQOUTSZ, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, ADDC, ABD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH3, ADDC, OFIFO, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(MATH3, ADDC, ONE, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, ADDC, ZERO, VSEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(275128321), ADDC, MATH0, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), ADDC, MATH1, VSEQOUTSZ, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), ADDC, MATH2, VSEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), ADDC, MATH3, VSEQOUTSZ, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), ADDC, IMM(393615378), VSEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(275128321), ADDC, DPOVRD, VSEQOUTSZ, SIZE(1), 0);
	MATHB(IMM(275128321), ADDC, VSEQINSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(275128321), ADDC, VSEQOUTSZ, VSEQOUTSZ, SIZE(8),
	      WITH(IFB | NFU | STL));
	MATHB(IMM(275128321), ADDC, ABD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(0x19261959fedcba01), ADDC, OFIFO, VSEQOUTSZ, SIZE(8), 0);
	MATHB(IMM(275128321), ADDC, ONE, VSEQOUTSZ, SIZE(8), WITH(IFB | STL));
	MATHB(IMM(275128321), ADDC, ZERO, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(DPOVRD, ADDC, MATH0, VSEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, ADDC, MATH1, VSEQOUTSZ, SIZE(4), 0);
	MATHB(DPOVRD, ADDC, MATH2, VSEQOUTSZ, SIZE(4), 0);
	MATHB(DPOVRD, ADDC, MATH3, VSEQOUTSZ, SIZE(4), 0);
	MATHB(DPOVRD, ADDC, IMM(393615378), VSEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, ADDC, DPOVRD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, ADDC, VSEQINSZ, VSEQOUTSZ, SIZE(4), 0);
	MATHB(DPOVRD, ADDC, VSEQOUTSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, ADDC, ABD, VSEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, ADDC, OFIFO, VSEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, ADDC, ONE, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(DPOVRD, ADDC, ZERO, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, ADDC, MATH0, VSEQOUTSZ, SIZE(8), 0);
	MATHB(SEQINSZ, ADDC, MATH1, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, ADDC, MATH2, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, ADDC, MATH3, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQINSZ, ADDC, IMM(393615378), VSEQOUTSZ, SIZE(2),
	      WITH(NFU | STL));
	MATHB(SEQINSZ, ADDC, DPOVRD, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, ADDC, VSEQINSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQINSZ, ADDC, VSEQOUTSZ, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQINSZ, ADDC, ABD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQINSZ, ADDC, OFIFO, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQINSZ, ADDC, ONE, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQINSZ, ADDC, ZERO, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADDC, MATH0, VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, ADDC, MATH1, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, ADDC, MATH2, VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, ADDC, MATH3, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, ADDC, IMM(393615378), VSEQOUTSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADDC, DPOVRD, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADDC, VSEQINSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, ADDC, VSEQOUTSZ, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADDC, ABD, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, ADDC, OFIFO, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADDC, ONE, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADDC, ZERO, VSEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, ADDC, MATH0, VSEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, ADDC, MATH1, VSEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, ADDC, MATH2, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, ADDC, MATH3, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, ADDC, IMM(393615378), VSEQOUTSZ, SIZE(8),
	      WITH(IFB | STL));
	MATHB(VSEQINSZ, ADDC, DPOVRD, VSEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, ADDC, VSEQINSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, ADDC, VSEQOUTSZ, VSEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, ADDC, ABD, VSEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQINSZ, ADDC, OFIFO, VSEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, ADDC, ONE, VSEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, ADDC, ZERO, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, ADDC, MATH0, VSEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, ADDC, MATH1, VSEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, ADDC, MATH2, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, ADDC, MATH3, VSEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, ADDC, IMM(393615378), VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, ADDC, DPOVRD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADDC, VSEQINSZ, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, ADDC, VSEQOUTSZ, VSEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, ADDC, ABD, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, ADDC, OFIFO, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, ADDC, ONE, VSEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, ADDC, ZERO, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, ADDC, MATH0, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(ZERO, ADDC, MATH1, VSEQOUTSZ, SIZE(8), 0);
	MATHB(ZERO, ADDC, MATH2, VSEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, ADDC, MATH3, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, ADDC, IMM(393615378), VSEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, ADDC, DPOVRD, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, ADDC, VSEQINSZ, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, ADDC, VSEQOUTSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, ADDC, ABD, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, ADDC, OFIFO, VSEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, ADDC, ONE, VSEQOUTSZ, SIZE(8), 0);
	MATHB(ZERO, ADDC, ZERO, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, ADDC, MATH0, VSEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, ADDC, MATH1, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(ONE, ADDC, MATH2, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(ONE, ADDC, MATH3, VSEQOUTSZ, SIZE(8), 0);
	MATHB(ONE, ADDC, IMM(393615378), VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, ADDC, DPOVRD, VSEQOUTSZ, SIZE(8), 0);
	MATHB(ONE, ADDC, VSEQINSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(ONE, ADDC, VSEQOUTSZ, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, ADDC, ABD, VSEQOUTSZ, SIZE(8), 0);
	MATHB(ONE, ADDC, OFIFO, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(ONE, ADDC, ONE, VSEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, ADDC, ZERO, VSEQOUTSZ, SIZE(1), 0);
	/* ADDC operation: NONE Destination register */
	MATHB(MATH0, ADDC, MATH0, NONE, SIZE(2), 0);
	MATHB(MATH0, ADDC, MATH1, NONE, SIZE(4), WITH(NFU));
	MATHB(MATH0, ADDC, MATH2, NONE, SIZE(8), 0);
	MATHB(MATH0, ADDC, MATH3, NONE, SIZE(8), 0);
	MATHB(MATH0, ADDC, IMM(0x19261959fedcba01), NONE, SIZE(8), WITH(STL));
	MATHB(MATH0, ADDC, DPOVRD, NONE, SIZE(1), 0);
	MATHB(MATH0, ADDC, VSEQINSZ, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, ADDC, VSEQOUTSZ, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, ADDC, ABD, NONE, SIZE(8), 0);
	MATHB(MATH0, ADDC, OFIFO, NONE, SIZE(1), WITH(NFU));
	MATHB(MATH0, ADDC, ONE, NONE, SIZE(2), 0);
	MATHB(MATH0, ADDC, ZERO, NONE, SIZE(8), 0);
	MATHB(MATH1, ADDC, MATH0, NONE, SIZE(1), WITH(STL));
	MATHB(MATH1, ADDC, MATH1, NONE, SIZE(2), 0);
	MATHB(MATH1, ADDC, MATH2, NONE, SIZE(2), WITH(NFU));
	MATHB(MATH1, ADDC, MATH3, NONE, SIZE(1), WITH(NFU));
	MATHB(MATH1, ADDC, IMM(393615378), NONE, SIZE(4), 0);
	MATHB(MATH1, ADDC, DPOVRD, NONE, SIZE(4), 0);
	MATHB(MATH1, ADDC, VSEQINSZ, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, ADDC, VSEQOUTSZ, NONE, SIZE(2), 0);
	MATHB(MATH1, ADDC, ABD, NONE, SIZE(8), WITH(STL));
	MATHB(MATH1, ADDC, OFIFO, NONE, SIZE(1), WITH(NFU));
	MATHB(MATH1, ADDC, ONE, NONE, SIZE(1), 0);
	MATHB(MATH1, ADDC, ZERO, NONE, SIZE(4), WITH(NFU));
	MATHB(MATH2, ADDC, MATH0, NONE, SIZE(2), WITH(STL));
	MATHB(MATH2, ADDC, MATH1, NONE, SIZE(4), 0);
	MATHB(MATH2, ADDC, MATH2, NONE, SIZE(2), WITH(NFU));
	MATHB(MATH2, ADDC, MATH3, NONE, SIZE(2), WITH(NFU));
	MATHB(MATH2, ADDC, IMM(393615378), NONE, SIZE(2), 0);
	MATHB(MATH2, ADDC, DPOVRD, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, ADDC, VSEQINSZ, NONE, SIZE(8), 0);
	MATHB(MATH2, ADDC, VSEQOUTSZ, NONE, SIZE(1), 0);
	MATHB(MATH2, ADDC, ABD, NONE, SIZE(4), 0);
	MATHB(MATH2, ADDC, OFIFO, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, ADDC, ONE, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, ADDC, ZERO, NONE, SIZE(2), 0);
	MATHB(MATH3, ADDC, MATH0, NONE, SIZE(8), WITH(NFU));
	MATHB(MATH3, ADDC, MATH1, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, ADDC, MATH2, NONE, SIZE(4), 0);
	MATHB(MATH3, ADDC, MATH3, NONE, SIZE(8), WITH(STL));
	MATHB(MATH3, ADDC, IMM(393615378), NONE, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, ADDC, DPOVRD, NONE, SIZE(2), 0);
	MATHB(MATH3, ADDC, VSEQINSZ, NONE, SIZE(8), WITH(NFU));
	MATHB(MATH3, ADDC, VSEQOUTSZ, NONE, SIZE(4), WITH(STL));
	MATHB(MATH3, ADDC, ABD, NONE, SIZE(2), WITH(STL));
	MATHB(MATH3, ADDC, OFIFO, NONE, SIZE(1), 0);
	MATHB(MATH3, ADDC, ONE, NONE, SIZE(8), 0);
	MATHB(MATH3, ADDC, ZERO, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(IMM(275128321), ADDC, MATH0, NONE, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), ADDC, MATH1, NONE, SIZE(8), WITH(IFB | NFU));
	MATHB(IMM(275128321), ADDC, MATH2, NONE, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), ADDC, MATH3, NONE, SIZE(2), WITH(STL));
	MATHB(IMM(275128321), ADDC, IMM(393615378), NONE, SIZE(1), 0);
	MATHB(IMM(275128321), ADDC, DPOVRD, NONE, SIZE(2), 0);
	MATHB(IMM(275128321), ADDC, VSEQINSZ, NONE, SIZE(2), WITH(NFU));
	MATHB(IMM(275128321), ADDC, VSEQOUTSZ, NONE, SIZE(2), 0);
	MATHB(IMM(275128321), ADDC, ABD, NONE, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), ADDC, OFIFO, NONE, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), ADDC, ONE, NONE, SIZE(1), 0);
	MATHB(IMM(275128321), ADDC, ZERO, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, ADDC, MATH0, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, ADDC, MATH1, NONE, SIZE(2), WITH(STL));
	MATHB(DPOVRD, ADDC, MATH2, NONE, SIZE(8), 0);
	MATHB(DPOVRD, ADDC, MATH3, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, ADDC, IMM(393615378), NONE, SIZE(2), 0);
	MATHB(DPOVRD, ADDC, DPOVRD, NONE, SIZE(8), WITH(STL));
	MATHB(DPOVRD, ADDC, VSEQINSZ, NONE, SIZE(1), 0);
	MATHB(DPOVRD, ADDC, VSEQOUTSZ, NONE, SIZE(2), WITH(STL));
	MATHB(DPOVRD, ADDC, ABD, NONE, SIZE(2), 0);
	MATHB(DPOVRD, ADDC, OFIFO, NONE, SIZE(8), 0);
	MATHB(DPOVRD, ADDC, ONE, NONE, SIZE(8), 0);
	MATHB(DPOVRD, ADDC, ZERO, NONE, SIZE(4), 0);
	MATHB(SEQINSZ, ADDC, MATH0, NONE, SIZE(4), 0);
	MATHB(SEQINSZ, ADDC, MATH1, NONE, SIZE(2), 0);
	MATHB(SEQINSZ, ADDC, MATH2, NONE, SIZE(4), 0);
	MATHB(SEQINSZ, ADDC, MATH3, NONE, SIZE(1), 0);
	MATHB(SEQINSZ, ADDC, IMM(393615378), NONE, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, ADDC, DPOVRD, NONE, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, ADDC, VSEQINSZ, NONE, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, ADDC, VSEQOUTSZ, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(SEQINSZ, ADDC, ABD, NONE, SIZE(2), 0);
	MATHB(SEQINSZ, ADDC, OFIFO, NONE, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, ADDC, ONE, NONE, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, ADDC, ZERO, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADDC, MATH0, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADDC, MATH1, NONE, SIZE(4), 0);
	MATHB(SEQOUTSZ, ADDC, MATH2, NONE, SIZE(2), 0);
	MATHB(SEQOUTSZ, ADDC, MATH3, NONE, SIZE(8), 0);
	MATHB(SEQOUTSZ, ADDC, IMM(393615378), NONE, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADDC, DPOVRD, NONE, SIZE(2), 0);
	MATHB(SEQOUTSZ, ADDC, VSEQINSZ, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADDC, VSEQOUTSZ, NONE, SIZE(1), 0);
	MATHB(SEQOUTSZ, ADDC, ABD, NONE, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, ADDC, OFIFO, NONE, SIZE(8), 0);
	MATHB(SEQOUTSZ, ADDC, ONE, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, ADDC, ZERO, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, ADDC, MATH0, NONE, SIZE(4), 0);
	MATHB(VSEQINSZ, ADDC, MATH1, NONE, SIZE(8), 0);
	MATHB(VSEQINSZ, ADDC, MATH2, NONE, SIZE(8), 0);
	MATHB(VSEQINSZ, ADDC, MATH3, NONE, SIZE(4), 0);
	MATHB(VSEQINSZ, ADDC, IMM(393615378), NONE, SIZE(2), 0);
	MATHB(VSEQINSZ, ADDC, DPOVRD, NONE, SIZE(4), WITH(STL));
	MATHB(VSEQINSZ, ADDC, VSEQINSZ, NONE, SIZE(2), 0);
	MATHB(VSEQINSZ, ADDC, VSEQOUTSZ, NONE, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, ADDC, ABD, NONE, SIZE(1), 0);
	MATHB(VSEQINSZ, ADDC, OFIFO, NONE, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, ADDC, ONE, NONE, SIZE(2), 0);
	MATHB(VSEQINSZ, ADDC, ZERO, NONE, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, ADDC, MATH0, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADDC, MATH1, NONE, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, ADDC, MATH2, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADDC, MATH3, NONE, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, ADDC, IMM(393615378), NONE, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, ADDC, DPOVRD, NONE, SIZE(4), 0);
	MATHB(VSEQOUTSZ, ADDC, VSEQINSZ, NONE, SIZE(8), 0);
	MATHB(VSEQOUTSZ, ADDC, VSEQOUTSZ, NONE, SIZE(2), 0);
	MATHB(VSEQOUTSZ, ADDC, ABD, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADDC, OFIFO, NONE, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, ADDC, ONE, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, ADDC, ZERO, NONE, SIZE(4), 0);
	MATHB(ZERO, ADDC, MATH0, NONE, SIZE(1), WITH(STL));
	MATHB(ZERO, ADDC, MATH1, NONE, SIZE(4), WITH(STL));
	MATHB(ZERO, ADDC, MATH2, NONE, SIZE(2), WITH(STL));
	MATHB(ZERO, ADDC, MATH3, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, ADDC, IMM(0x19261959fedcba01), NONE, SIZE(8), 0);
	MATHB(ZERO, ADDC, DPOVRD, NONE, SIZE(4), 0);
	MATHB(ZERO, ADDC, VSEQINSZ, NONE, SIZE(8), WITH(STL));
	MATHB(ZERO, ADDC, VSEQOUTSZ, NONE, SIZE(8), 0);
	MATHB(ZERO, ADDC, ABD, NONE, SIZE(2), 0);
	MATHB(ZERO, ADDC, OFIFO, NONE, SIZE(1), 0);
	MATHB(ZERO, ADDC, ONE, NONE, SIZE(8), 0);
	MATHB(ZERO, ADDC, ZERO, NONE, SIZE(1), WITH(STL));
	MATHB(ONE, ADDC, MATH0, NONE, SIZE(8), 0);
	MATHB(ONE, ADDC, MATH1, NONE, SIZE(2), 0);
	MATHB(ONE, ADDC, MATH2, NONE, SIZE(2), 0);
	MATHB(ONE, ADDC, MATH3, NONE, SIZE(2), 0);
	MATHB(ONE, ADDC, IMM(0x19261959fedcba01), NONE, SIZE(8),
	      WITH(NFU | STL));
	MATHB(ONE, ADDC, DPOVRD, NONE, SIZE(4), 0);
	MATHB(ONE, ADDC, VSEQINSZ, NONE, SIZE(4), 0);
	MATHB(ONE, ADDC, VSEQOUTSZ, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, ADDC, ABD, NONE, SIZE(4), WITH(STL));
	MATHB(ONE, ADDC, OFIFO, NONE, SIZE(2), 0);
	MATHB(ONE, ADDC, ONE, NONE, SIZE(4), WITH(STL));
	MATHB(ONE, ADDC, ZERO, NONE, SIZE(1), 0);
	/*SUBB Operation: MATH0 Destination register */
	MATHB(MATH0, SUBB, MATH0, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, SUBB, MATH1, MATH0, SIZE(1), 0);
	MATHB(MATH0, SUBB, MATH2, MATH0, SIZE(2), WITH(STL));
	MATHB(MATH0, SUBB, MATH3, MATH0, SIZE(8), 0);
	MATHB(MATH0, SUBB, IMM(393615378), MATH0, SIZE(4), 0);
	MATHB(MATH0, SUBB, DPOVRD, MATH0, SIZE(4), WITH(STL));
	MATHB(MATH0, SUBB, VSEQINSZ, MATH0, SIZE(8), WITH(STL));
	MATHB(MATH0, SUBB, VSEQOUTSZ, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, SUBB, ABD, MATH0, SIZE(8), 0);
	MATHB(MATH0, SUBB, OFIFO, MATH0, SIZE(4), WITH(NFU));
	MATHB(MATH0, SUBB, ONE, MATH0, SIZE(2), 0);
	MATHB(MATH0, SUBB, ZERO, MATH0, SIZE(8), 0);
	MATHB(MATH1, SUBB, MATH0, MATH0, SIZE(1), 0);
	MATHB(MATH1, SUBB, MATH1, MATH0, SIZE(4), 0);
	MATHB(MATH1, SUBB, MATH2, MATH0, SIZE(2), 0);
	MATHB(MATH1, SUBB, MATH3, MATH0, SIZE(4), 0);
	MATHB(MATH1, SUBB, IMM(393615378), MATH0, SIZE(1), 0);
	MATHB(MATH1, SUBB, DPOVRD, MATH0, SIZE(1), 0);
	MATHB(MATH1, SUBB, VSEQINSZ, MATH0, SIZE(8), 0);
	MATHB(MATH1, SUBB, VSEQOUTSZ, MATH0, SIZE(8), 0);
	MATHB(MATH1, SUBB, ABD, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, SUBB, OFIFO, MATH0, SIZE(4), 0);
	MATHB(MATH1, SUBB, ONE, MATH0, SIZE(8), 0);
	MATHB(MATH1, SUBB, ZERO, MATH0, SIZE(1), WITH(NFU));
	MATHB(MATH2, SUBB, MATH0, MATH0, SIZE(8), WITH(STL));
	MATHB(MATH2, SUBB, MATH1, MATH0, SIZE(1), 0);
	MATHB(MATH2, SUBB, MATH2, MATH0, SIZE(8), 0);
	MATHB(MATH2, SUBB, MATH3, MATH0, SIZE(1), WITH(NFU));
	MATHB(MATH2, SUBB, IMM(393615378), MATH0, SIZE(4), 0);
	MATHB(MATH2, SUBB, DPOVRD, MATH0, SIZE(1), WITH(NFU));
	MATHB(MATH2, SUBB, VSEQINSZ, MATH0, SIZE(4), 0);
	MATHB(MATH2, SUBB, VSEQOUTSZ, MATH0, SIZE(2), 0);
	MATHB(MATH2, SUBB, ABD, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, SUBB, OFIFO, MATH0, SIZE(1), 0);
	MATHB(MATH2, SUBB, ONE, MATH0, SIZE(2), 0);
	MATHB(MATH2, SUBB, ZERO, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, SUBB, MATH0, MATH0, SIZE(4), 0);
	MATHB(MATH3, SUBB, MATH1, MATH0, SIZE(1), 0);
	MATHB(MATH3, SUBB, MATH2, MATH0, SIZE(4), 0);
	MATHB(MATH3, SUBB, MATH3, MATH0, SIZE(2), 0);
	MATHB(MATH3, SUBB, IMM(0x19261959fedcba01), MATH0, SIZE(8),
	      WITH(NFU | STL));
	MATHB(MATH3, SUBB, DPOVRD, MATH0, SIZE(1), 0);
	MATHB(MATH3, SUBB, VSEQINSZ, MATH0, SIZE(1), WITH(STL));
	MATHB(MATH3, SUBB, VSEQOUTSZ, MATH0, SIZE(4), 0);
	MATHB(MATH3, SUBB, ABD, MATH0, SIZE(2), 0);
	MATHB(MATH3, SUBB, OFIFO, MATH0, SIZE(8), WITH(NFU | STL));
	MATHB(MATH3, SUBB, ONE, MATH0, SIZE(1), 0);
	MATHB(MATH3, SUBB, ZERO, MATH0, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, MATH0, MATH0, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), SUBB, MATH1, MATH0, SIZE(2), 0);
	MATHB(IMM(0x19261959fedcba01), SUBB, MATH2, MATH0, SIZE(8), 0);
	MATHB(IMM(0x19261959fedcba01), SUBB, MATH3, MATH0, SIZE(8), 0);
	MATHB(IMM(275128321), SUBB, IMM(393615378), MATH0, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, DPOVRD, MATH0, SIZE(2), 0);
	MATHB(IMM(275128321), SUBB, VSEQINSZ, MATH0, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, VSEQOUTSZ, MATH0, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, ABD, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(0x19261959fedcba01), SUBB, OFIFO, MATH0, SIZE(8), 0);
	MATHB(IMM(275128321), SUBB, ONE, MATH0, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, ZERO, MATH0, SIZE(4), 0);
	MATHB(DPOVRD, SUBB, MATH0, MATH0, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, MATH1, MATH0, SIZE(1), WITH(STL));
	MATHB(DPOVRD, SUBB, MATH2, MATH0, SIZE(1), WITH(NFU));
	MATHB(DPOVRD, SUBB, MATH3, MATH0, SIZE(1), WITH(STL));
	MATHB(DPOVRD, SUBB, IMM(0x19261959fedcba01), MATH0, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, DPOVRD, MATH0, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, VSEQINSZ, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, VSEQOUTSZ, MATH0, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, ABD, MATH0, SIZE(2), WITH(STL));
	MATHB(DPOVRD, SUBB, OFIFO, MATH0, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, ONE, MATH0, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, ZERO, MATH0, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, SUBB, MATH0, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, MATH1, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, MATH2, MATH0, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, SUBB, MATH3, MATH0, SIZE(8), 0);
	MATHB(SEQINSZ, SUBB, IMM(393615378), MATH0, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, SUBB, DPOVRD, MATH0, SIZE(4), 0);
	MATHB(SEQINSZ, SUBB, VSEQINSZ, MATH0, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, VSEQOUTSZ, MATH0, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, SUBB, ABD, MATH0, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, OFIFO, MATH0, SIZE(4), 0);
	MATHB(SEQINSZ, SUBB, ONE, MATH0, SIZE(4), 0);
	MATHB(SEQINSZ, SUBB, ZERO, MATH0, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, MATH0, MATH0, SIZE(2), 0);
	MATHB(SEQOUTSZ, SUBB, MATH1, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, MATH2, MATH0, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, MATH3, MATH0, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, SUBB, IMM(393615378), MATH0, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, DPOVRD, MATH0, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, VSEQINSZ, MATH0, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, VSEQOUTSZ, MATH0, SIZE(2), 0);
	MATHB(SEQOUTSZ, SUBB, ABD, MATH0, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, SUBB, OFIFO, MATH0, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, ONE, MATH0, SIZE(2), 0);
	MATHB(SEQOUTSZ, SUBB, ZERO, MATH0, SIZE(8), 0);
	MATHB(VSEQINSZ, SUBB, MATH0, MATH0, SIZE(4), 0);
	MATHB(VSEQINSZ, SUBB, MATH1, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, MATH2, MATH0, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, SUBB, MATH3, MATH0, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, IMM(0x19261959fedcba01), MATH0, SIZE(8), 0);
	MATHB(VSEQINSZ, SUBB, DPOVRD, MATH0, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, VSEQINSZ, MATH0, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, VSEQOUTSZ, MATH0, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, ABD, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, OFIFO, MATH0, SIZE(8), 0);
	MATHB(VSEQINSZ, SUBB, ONE, MATH0, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, SUBB, ZERO, MATH0, SIZE(1), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH0, MATH0, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH1, MATH0, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, MATH2, MATH0, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, MATH3, MATH0, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, IMM(393615378), MATH0, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, DPOVRD, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, VSEQINSZ, MATH0, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, VSEQOUTSZ, MATH0, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, ABD, MATH0, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, OFIFO, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, ONE, MATH0, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, ZERO, MATH0, SIZE(1), WITH(NFU));
	MATHB(ZERO, SUBB, MATH0, MATH0, SIZE(4), 0);
	MATHB(ZERO, SUBB, MATH1, MATH0, SIZE(2), 0);
	MATHB(ZERO, SUBB, MATH2, MATH0, SIZE(2), 0);
	MATHB(ZERO, SUBB, MATH3, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, SUBB, IMM(393615378), MATH0, SIZE(1), WITH(NFU));
	MATHB(ZERO, SUBB, DPOVRD, MATH0, SIZE(4), 0);
	MATHB(ZERO, SUBB, VSEQINSZ, MATH0, SIZE(2), 0);
	MATHB(ZERO, SUBB, VSEQOUTSZ, MATH0, SIZE(2), WITH(NFU));
	MATHB(ZERO, SUBB, ABD, MATH0, SIZE(8), WITH(STL));
	MATHB(ZERO, SUBB, OFIFO, MATH0, SIZE(4), 0);
	MATHB(ZERO, SUBB, ONE, MATH0, SIZE(8), 0);
	MATHB(ZERO, SUBB, ZERO, MATH0, SIZE(2), WITH(NFU));
	MATHB(ONE, SUBB, MATH0, MATH0, SIZE(4), WITH(NFU));
	MATHB(ONE, SUBB, MATH1, MATH0, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, SUBB, MATH2, MATH0, SIZE(1), WITH(STL));
	MATHB(ONE, SUBB, MATH3, MATH0, SIZE(1), WITH(NFU));
	MATHB(ONE, SUBB, IMM(393615378), MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, SUBB, DPOVRD, MATH0, SIZE(8), 0);
	MATHB(ONE, SUBB, VSEQINSZ, MATH0, SIZE(8), 0);
	MATHB(ONE, SUBB, VSEQOUTSZ, MATH0, SIZE(2), 0);
	MATHB(ONE, SUBB, ABD, MATH0, SIZE(8), WITH(STL));
	MATHB(ONE, SUBB, OFIFO, MATH0, SIZE(4), 0);
	MATHB(ONE, SUBB, ONE, MATH0, SIZE(4), 0);
	MATHB(ONE, SUBB, ZERO, MATH0, SIZE(2), WITH(NFU | STL));
	/*SUBB Operation: MATH1 Destination register */
	MATHB(MATH0, SUBB, MATH0, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, SUBB, MATH1, MATH1, SIZE(4), WITH(NFU));
	MATHB(MATH0, SUBB, MATH2, MATH1, SIZE(4), WITH(NFU));
	MATHB(MATH0, SUBB, MATH3, MATH1, SIZE(8), 0);
	MATHB(MATH0, SUBB, IMM(393615378), MATH1, SIZE(8), WITH(IFB));
	MATHB(MATH0, SUBB, DPOVRD, MATH1, SIZE(4), WITH(STL));
	MATHB(MATH0, SUBB, VSEQINSZ, MATH1, SIZE(2), WITH(STL));
	MATHB(MATH0, SUBB, VSEQOUTSZ, MATH1, SIZE(8), 0);
	MATHB(MATH0, SUBB, ABD, MATH1, SIZE(8), WITH(STL));
	MATHB(MATH0, SUBB, OFIFO, MATH1, SIZE(1), 0);
	MATHB(MATH0, SUBB, ONE, MATH1, SIZE(8), 0);
	MATHB(MATH0, SUBB, ZERO, MATH1, SIZE(8), WITH(NFU));
	MATHB(MATH1, SUBB, MATH0, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(MATH1, SUBB, MATH1, MATH1, SIZE(1), 0);
	MATHB(MATH1, SUBB, MATH2, MATH1, SIZE(8), 0);
	MATHB(MATH1, SUBB, MATH3, MATH1, SIZE(4), 0);
	MATHB(MATH1, SUBB, IMM(393615378), MATH1, SIZE(4), WITH(STL));
	MATHB(MATH1, SUBB, DPOVRD, MATH1, SIZE(4), WITH(NFU));
	MATHB(MATH1, SUBB, VSEQINSZ, MATH1, SIZE(1), 0);
	MATHB(MATH1, SUBB, VSEQOUTSZ, MATH1, SIZE(2), 0);
	MATHB(MATH1, SUBB, ABD, MATH1, SIZE(4), 0);
	MATHB(MATH1, SUBB, OFIFO, MATH1, SIZE(4), 0);
	MATHB(MATH1, SUBB, ONE, MATH1, SIZE(2), 0);
	MATHB(MATH1, SUBB, ZERO, MATH1, SIZE(1), WITH(NFU));
	MATHB(MATH2, SUBB, MATH0, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, SUBB, MATH1, MATH1, SIZE(2), 0);
	MATHB(MATH2, SUBB, MATH2, MATH1, SIZE(2), 0);
	MATHB(MATH2, SUBB, MATH3, MATH1, SIZE(1), 0);
	MATHB(MATH2, SUBB, IMM(393615378), MATH1, SIZE(2), 0);
	MATHB(MATH2, SUBB, DPOVRD, MATH1, SIZE(8), WITH(STL));
	MATHB(MATH2, SUBB, VSEQINSZ, MATH1, SIZE(1), WITH(STL));
	MATHB(MATH2, SUBB, VSEQOUTSZ, MATH1, SIZE(2), 0);
	MATHB(MATH2, SUBB, ABD, MATH1, SIZE(1), 0);
	MATHB(MATH2, SUBB, OFIFO, MATH1, SIZE(8), 0);
	MATHB(MATH2, SUBB, ONE, MATH1, SIZE(2), 0);
	MATHB(MATH2, SUBB, ZERO, MATH1, SIZE(8), 0);
	MATHB(MATH3, SUBB, MATH0, MATH1, SIZE(2), 0);
	MATHB(MATH3, SUBB, MATH1, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, SUBB, MATH2, MATH1, SIZE(4), 0);
	MATHB(MATH3, SUBB, MATH3, MATH1, SIZE(2), 0);
	MATHB(MATH3, SUBB, IMM(393615378), MATH1, SIZE(1), 0);
	MATHB(MATH3, SUBB, DPOVRD, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, SUBB, VSEQINSZ, MATH1, SIZE(2), 0);
	MATHB(MATH3, SUBB, VSEQOUTSZ, MATH1, SIZE(2), WITH(NFU));
	MATHB(MATH3, SUBB, ABD, MATH1, SIZE(2), WITH(STL));
	MATHB(MATH3, SUBB, OFIFO, MATH1, SIZE(2), 0);
	MATHB(MATH3, SUBB, ONE, MATH1, SIZE(1), WITH(STL));
	MATHB(MATH3, SUBB, ZERO, MATH1, SIZE(8), 0);
	MATHB(IMM(275128321), SUBB, MATH0, MATH1, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, MATH1, MATH1, SIZE(1), 0);
	MATHB(IMM(0x19261959fedcba01), SUBB, MATH2, MATH1, SIZE(8), WITH(STL));
	MATHB(IMM(275128321), SUBB, MATH3, MATH1, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), SUBB, IMM(393615378), MATH1, SIZE(1),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, DPOVRD, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(0x19261959fedcba01), SUBB, VSEQINSZ, MATH1, SIZE(8), 0);
	MATHB(IMM(0x19261959fedcba01), SUBB, VSEQOUTSZ, MATH1, SIZE(8),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, ABD, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, OFIFO, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, ONE, MATH1, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, ZERO, MATH1, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, MATH0, MATH1, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, MATH1, MATH1, SIZE(4), WITH(STL));
	MATHB(DPOVRD, SUBB, MATH2, MATH1, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, MATH3, MATH1, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, IMM(393615378), MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, DPOVRD, MATH1, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, VSEQINSZ, MATH1, SIZE(1), WITH(NFU));
	MATHB(DPOVRD, SUBB, VSEQOUTSZ, MATH1, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, ABD, MATH1, SIZE(4), 0);
	MATHB(DPOVRD, SUBB, OFIFO, MATH1, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, ONE, MATH1, SIZE(4), 0);
	MATHB(DPOVRD, SUBB, ZERO, MATH1, SIZE(4), 0);
	MATHB(SEQINSZ, SUBB, MATH0, MATH1, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, SUBB, MATH1, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, MATH2, MATH1, SIZE(8), 0);
	MATHB(SEQINSZ, SUBB, MATH3, MATH1, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, IMM(393615378), MATH1, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, SUBB, DPOVRD, MATH1, SIZE(8), 0);
	MATHB(SEQINSZ, SUBB, VSEQINSZ, MATH1, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, SUBB, VSEQOUTSZ, MATH1, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, ABD, MATH1, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, OFIFO, MATH1, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, ONE, MATH1, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, SUBB, ZERO, MATH1, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, MATH0, MATH1, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, MATH1, MATH1, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, MATH2, MATH1, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, MATH3, MATH1, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, SUBB, IMM(393615378), MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, DPOVRD, MATH1, SIZE(2), 0);
	MATHB(SEQOUTSZ, SUBB, VSEQINSZ, MATH1, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, VSEQOUTSZ, MATH1, SIZE(2), 0);
	MATHB(SEQOUTSZ, SUBB, ABD, MATH1, SIZE(4), 0);
	MATHB(SEQOUTSZ, SUBB, OFIFO, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, ONE, MATH1, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, ZERO, MATH1, SIZE(8), 0);
	MATHB(VSEQINSZ, SUBB, MATH0, MATH1, SIZE(8), 0);
	MATHB(VSEQINSZ, SUBB, MATH1, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, MATH2, MATH1, SIZE(4), WITH(STL));
	MATHB(VSEQINSZ, SUBB, MATH3, MATH1, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, IMM(393615378), MATH1, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, DPOVRD, MATH1, SIZE(8), 0);
	MATHB(VSEQINSZ, SUBB, VSEQINSZ, MATH1, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, SUBB, VSEQOUTSZ, MATH1, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, SUBB, ABD, MATH1, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, OFIFO, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, ONE, MATH1, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, SUBB, ZERO, MATH1, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH0, MATH1, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH1, MATH1, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH2, MATH1, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, MATH3, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, IMM(393615378), MATH1, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, DPOVRD, MATH1, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, VSEQINSZ, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, VSEQOUTSZ, MATH1, SIZE(1), 0);
	MATHB(VSEQOUTSZ, SUBB, ABD, MATH1, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, OFIFO, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, ONE, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, ZERO, MATH1, SIZE(2), 0);
	MATHB(ZERO, SUBB, MATH0, MATH1, SIZE(4), WITH(STL));
	MATHB(ZERO, SUBB, MATH1, MATH1, SIZE(1), WITH(NFU));
	MATHB(ZERO, SUBB, MATH2, MATH1, SIZE(4), 0);
	MATHB(ZERO, SUBB, MATH3, MATH1, SIZE(2), 0);
	MATHB(ZERO, SUBB, IMM(393615378), MATH1, SIZE(8), WITH(IFB | STL));
	MATHB(ZERO, SUBB, DPOVRD, MATH1, SIZE(8), 0);
	MATHB(ZERO, SUBB, VSEQINSZ, MATH1, SIZE(2), 0);
	MATHB(ZERO, SUBB, VSEQOUTSZ, MATH1, SIZE(1), 0);
	MATHB(ZERO, SUBB, ABD, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, SUBB, OFIFO, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, SUBB, ONE, MATH1, SIZE(1), 0);
	MATHB(ZERO, SUBB, ZERO, MATH1, SIZE(8), WITH(STL));
	MATHB(ONE, SUBB, MATH0, MATH1, SIZE(2), WITH(STL));
	MATHB(ONE, SUBB, MATH1, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, SUBB, MATH2, MATH1, SIZE(2), 0);
	MATHB(ONE, SUBB, MATH3, MATH1, SIZE(2), 0);
	MATHB(ONE, SUBB, IMM(393615378), MATH1, SIZE(8), WITH(IFB));
	MATHB(ONE, SUBB, DPOVRD, MATH1, SIZE(2), WITH(NFU));
	MATHB(ONE, SUBB, VSEQINSZ, MATH1, SIZE(2), WITH(STL));
	MATHB(ONE, SUBB, VSEQOUTSZ, MATH1, SIZE(4), WITH(STL));
	MATHB(ONE, SUBB, ABD, MATH1, SIZE(8), 0);
	MATHB(ONE, SUBB, OFIFO, MATH1, SIZE(1), WITH(STL));
	MATHB(ONE, SUBB, ONE, MATH1, SIZE(4), WITH(NFU));
	MATHB(ONE, SUBB, ZERO, MATH1, SIZE(2), 0);
	/*SUBB Operation: MATH2 Destination register */
	MATHB(MATH0, SUBB, MATH0, MATH2, SIZE(4), 0);
	MATHB(MATH0, SUBB, MATH1, MATH2, SIZE(2), WITH(NFU));
	MATHB(MATH0, SUBB, MATH2, MATH2, SIZE(1), 0);
	MATHB(MATH0, SUBB, MATH3, MATH2, SIZE(8), 0);
	MATHB(MATH0, SUBB, IMM(393615378), MATH2, SIZE(4), WITH(NFU));
	MATHB(MATH0, SUBB, DPOVRD, MATH2, SIZE(8), 0);
	MATHB(MATH0, SUBB, VSEQINSZ, MATH2, SIZE(4), 0);
	MATHB(MATH0, SUBB, VSEQOUTSZ, MATH2, SIZE(2), 0);
	MATHB(MATH0, SUBB, ABD, MATH2, SIZE(8), 0);
	MATHB(MATH0, SUBB, OFIFO, MATH2, SIZE(4), WITH(STL));
	MATHB(MATH0, SUBB, ONE, MATH2, SIZE(8), WITH(STL));
	MATHB(MATH0, SUBB, ZERO, MATH2, SIZE(8), WITH(NFU));
	MATHB(MATH1, SUBB, MATH0, MATH2, SIZE(8), 0);
	MATHB(MATH1, SUBB, MATH1, MATH2, SIZE(1), WITH(STL));
	MATHB(MATH1, SUBB, MATH2, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, SUBB, MATH3, MATH2, SIZE(8), WITH(NFU));
	MATHB(MATH1, SUBB, IMM(393615378), MATH2, SIZE(8),
	      WITH(IFB | NFU | STL));
	MATHB(MATH1, SUBB, DPOVRD, MATH2, SIZE(1), 0);
	MATHB(MATH1, SUBB, VSEQINSZ, MATH2, SIZE(1), WITH(NFU | STL));
	MATHB(MATH1, SUBB, VSEQOUTSZ, MATH2, SIZE(1), 0);
	MATHB(MATH1, SUBB, ABD, MATH2, SIZE(8), WITH(STL));
	MATHB(MATH1, SUBB, OFIFO, MATH2, SIZE(4), 0);
	MATHB(MATH1, SUBB, ONE, MATH2, SIZE(8), 0);
	MATHB(MATH1, SUBB, ZERO, MATH2, SIZE(8), 0);
	MATHB(MATH2, SUBB, MATH0, MATH2, SIZE(8), WITH(STL));
	MATHB(MATH2, SUBB, MATH1, MATH2, SIZE(2), WITH(NFU));
	MATHB(MATH2, SUBB, MATH2, MATH2, SIZE(4), 0);
	MATHB(MATH2, SUBB, MATH3, MATH2, SIZE(2), WITH(NFU));
	MATHB(MATH2, SUBB, IMM(393615378), MATH2, SIZE(4), 0);
	MATHB(MATH2, SUBB, DPOVRD, MATH2, SIZE(1), WITH(NFU));
	MATHB(MATH2, SUBB, VSEQINSZ, MATH2, SIZE(4), 0);
	MATHB(MATH2, SUBB, VSEQOUTSZ, MATH2, SIZE(4), 0);
	MATHB(MATH2, SUBB, ABD, MATH2, SIZE(2), 0);
	MATHB(MATH2, SUBB, OFIFO, MATH2, SIZE(8), 0);
	MATHB(MATH2, SUBB, ONE, MATH2, SIZE(4), WITH(STL));
	MATHB(MATH2, SUBB, ZERO, MATH2, SIZE(2), WITH(STL));
	MATHB(MATH3, SUBB, MATH0, MATH2, SIZE(4), WITH(STL));
	MATHB(MATH3, SUBB, MATH1, MATH2, SIZE(4), 0);
	MATHB(MATH3, SUBB, MATH2, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(MATH3, SUBB, MATH3, MATH2, SIZE(2), WITH(STL));
	MATHB(MATH3, SUBB, IMM(393615378), MATH2, SIZE(2), 0);
	MATHB(MATH3, SUBB, DPOVRD, MATH2, SIZE(2), 0);
	MATHB(MATH3, SUBB, VSEQINSZ, MATH2, SIZE(2), WITH(NFU));
	MATHB(MATH3, SUBB, VSEQOUTSZ, MATH2, SIZE(1), 0);
	MATHB(MATH3, SUBB, ABD, MATH2, SIZE(8), 0);
	MATHB(MATH3, SUBB, OFIFO, MATH2, SIZE(1), 0);
	MATHB(MATH3, SUBB, ONE, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, SUBB, ZERO, MATH2, SIZE(8), 0);
	MATHB(IMM(275128321), SUBB, MATH0, MATH2, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, MATH1, MATH2, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), SUBB, MATH2, MATH2, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), SUBB, MATH3, MATH2, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), SUBB, IMM(393615378), MATH2, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, DPOVRD, MATH2, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, VSEQINSZ, MATH2, SIZE(8),
	      WITH(IFB | NFU | STL));
	MATHB(IMM(275128321), SUBB, VSEQOUTSZ, MATH2, SIZE(2), WITH(NFU));
	MATHB(IMM(275128321), SUBB, ABD, MATH2, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, OFIFO, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, ONE, MATH2, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), SUBB, ZERO, MATH2, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, SUBB, MATH0, MATH2, SIZE(4), 0);
	MATHB(DPOVRD, SUBB, MATH1, MATH2, SIZE(1), WITH(STL));
	MATHB(DPOVRD, SUBB, MATH2, MATH2, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, MATH3, MATH2, SIZE(4), 0);
	MATHB(DPOVRD, SUBB, IMM(393615378), MATH2, SIZE(1), WITH(STL));
	MATHB(DPOVRD, SUBB, DPOVRD, MATH2, SIZE(4), 0);
	MATHB(DPOVRD, SUBB, VSEQINSZ, MATH2, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, VSEQOUTSZ, MATH2, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, ABD, MATH2, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, OFIFO, MATH2, SIZE(4), 0);
	MATHB(DPOVRD, SUBB, ONE, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, ZERO, MATH2, SIZE(4), 0);
	MATHB(SEQINSZ, SUBB, MATH0, MATH2, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, MATH1, MATH2, SIZE(4), 0);
	MATHB(SEQINSZ, SUBB, MATH2, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, MATH3, MATH2, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, SUBB, IMM(393615378), MATH2, SIZE(4), 0);
	MATHB(SEQINSZ, SUBB, DPOVRD, MATH2, SIZE(8), 0);
	MATHB(SEQINSZ, SUBB, VSEQINSZ, MATH2, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, SUBB, VSEQOUTSZ, MATH2, SIZE(8), 0);
	MATHB(SEQINSZ, SUBB, ABD, MATH2, SIZE(4), 0);
	MATHB(SEQINSZ, SUBB, OFIFO, MATH2, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, ONE, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, ZERO, MATH2, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, SUBB, MATH0, MATH2, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, MATH1, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, MATH2, MATH2, SIZE(2), 0);
	MATHB(SEQOUTSZ, SUBB, MATH3, MATH2, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, IMM(393615378), MATH2, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, DPOVRD, MATH2, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, VSEQINSZ, MATH2, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, VSEQOUTSZ, MATH2, SIZE(2), 0);
	MATHB(SEQOUTSZ, SUBB, ABD, MATH2, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, SUBB, OFIFO, MATH2, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, ONE, MATH2, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, ZERO, MATH2, SIZE(4), 0);
	MATHB(VSEQINSZ, SUBB, MATH0, MATH2, SIZE(4), 0);
	MATHB(VSEQINSZ, SUBB, MATH1, MATH2, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, MATH2, MATH2, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, SUBB, MATH3, MATH2, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, SUBB, IMM(393615378), MATH2, SIZE(4), 0);
	MATHB(VSEQINSZ, SUBB, DPOVRD, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, VSEQINSZ, MATH2, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, SUBB, VSEQOUTSZ, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, ABD, MATH2, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, OFIFO, MATH2, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, SUBB, ONE, MATH2, SIZE(4), 0);
	MATHB(VSEQINSZ, SUBB, ZERO, MATH2, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH0, MATH2, SIZE(1), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH1, MATH2, SIZE(1), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH2, MATH2, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, MATH3, MATH2, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, IMM(393615378), MATH2, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, DPOVRD, MATH2, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, VSEQINSZ, MATH2, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, VSEQOUTSZ, MATH2, SIZE(1), 0);
	MATHB(VSEQOUTSZ, SUBB, ABD, MATH2, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, OFIFO, MATH2, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, ONE, MATH2, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, ZERO, MATH2, SIZE(4), 0);
	MATHB(ZERO, SUBB, MATH0, MATH2, SIZE(8), 0);
	MATHB(ZERO, SUBB, MATH1, MATH2, SIZE(1), WITH(NFU));
	MATHB(ZERO, SUBB, MATH2, MATH2, SIZE(1), WITH(STL));
	MATHB(ZERO, SUBB, MATH3, MATH2, SIZE(2), WITH(NFU));
	MATHB(ZERO, SUBB, IMM(393615378), MATH2, SIZE(2), 0);
	MATHB(ZERO, SUBB, DPOVRD, MATH2, SIZE(2), 0);
	MATHB(ZERO, SUBB, VSEQINSZ, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, SUBB, VSEQOUTSZ, MATH2, SIZE(4), 0);
	MATHB(ZERO, SUBB, ABD, MATH2, SIZE(1), 0);
	MATHB(ZERO, SUBB, OFIFO, MATH2, SIZE(8), 0);
	MATHB(ZERO, SUBB, ONE, MATH2, SIZE(1), 0);
	MATHB(ZERO, SUBB, ZERO, MATH2, SIZE(2), 0);
	MATHB(ONE, SUBB, MATH0, MATH2, SIZE(4), WITH(NFU));
	MATHB(ONE, SUBB, MATH1, MATH2, SIZE(2), 0);
	MATHB(ONE, SUBB, MATH2, MATH2, SIZE(2), WITH(STL));
	MATHB(ONE, SUBB, MATH3, MATH2, SIZE(8), 0);
	MATHB(ONE, SUBB, IMM(393615378), MATH2, SIZE(2), WITH(NFU));
	MATHB(ONE, SUBB, DPOVRD, MATH2, SIZE(2), WITH(STL));
	MATHB(ONE, SUBB, VSEQINSZ, MATH2, SIZE(1), 0);
	MATHB(ONE, SUBB, VSEQOUTSZ, MATH2, SIZE(1), 0);
	MATHB(ONE, SUBB, ABD, MATH2, SIZE(2), 0);
	MATHB(ONE, SUBB, OFIFO, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, SUBB, ONE, MATH2, SIZE(8), WITH(NFU));
	MATHB(ONE, SUBB, ZERO, MATH2, SIZE(1), 0);
	/*SUBB Operation: MATH3 Destination register */
	MATHB(MATH0, SUBB, MATH0, MATH3, SIZE(4), WITH(NFU));
	MATHB(MATH0, SUBB, MATH1, MATH3, SIZE(4), 0);
	MATHB(MATH0, SUBB, MATH2, MATH3, SIZE(1), 0);
	MATHB(MATH0, SUBB, MATH3, MATH3, SIZE(2), WITH(STL));
	MATHB(MATH0, SUBB, IMM(393615378), MATH3, SIZE(4), WITH(STL));
	MATHB(MATH0, SUBB, DPOVRD, MATH3, SIZE(8), 0);
	MATHB(MATH0, SUBB, VSEQINSZ, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, SUBB, VSEQOUTSZ, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, SUBB, ABD, MATH3, SIZE(8), 0);
	MATHB(MATH0, SUBB, OFIFO, MATH3, SIZE(4), 0);
	MATHB(MATH0, SUBB, ONE, MATH3, SIZE(2), WITH(NFU));
	MATHB(MATH0, SUBB, ZERO, MATH3, SIZE(1), WITH(STL));
	MATHB(MATH1, SUBB, MATH0, MATH3, SIZE(2), 0);
	MATHB(MATH1, SUBB, MATH1, MATH3, SIZE(2), WITH(NFU));
	MATHB(MATH1, SUBB, MATH2, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, SUBB, MATH3, MATH3, SIZE(2), 0);
	MATHB(MATH1, SUBB, IMM(0x19261959fedcba01), MATH3, SIZE(8), 0);
	MATHB(MATH1, SUBB, DPOVRD, MATH3, SIZE(2), WITH(NFU));
	MATHB(MATH1, SUBB, VSEQINSZ, MATH3, SIZE(4), 0);
	MATHB(MATH1, SUBB, VSEQOUTSZ, MATH3, SIZE(2), 0);
	MATHB(MATH1, SUBB, ABD, MATH3, SIZE(2), 0);
	MATHB(MATH1, SUBB, OFIFO, MATH3, SIZE(2), WITH(NFU));
	MATHB(MATH1, SUBB, ONE, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(MATH1, SUBB, ZERO, MATH3, SIZE(1), 0);
	MATHB(MATH2, SUBB, MATH0, MATH3, SIZE(1), 0);
	MATHB(MATH2, SUBB, MATH1, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, SUBB, MATH2, MATH3, SIZE(4), 0);
	MATHB(MATH2, SUBB, MATH3, MATH3, SIZE(1), WITH(STL));
	MATHB(MATH2, SUBB, IMM(393615378), MATH3, SIZE(8), WITH(IFB));
	MATHB(MATH2, SUBB, DPOVRD, MATH3, SIZE(8), 0);
	MATHB(MATH2, SUBB, VSEQINSZ, MATH3, SIZE(8), 0);
	MATHB(MATH2, SUBB, VSEQOUTSZ, MATH3, SIZE(1), 0);
	MATHB(MATH2, SUBB, ABD, MATH3, SIZE(2), 0);
	MATHB(MATH2, SUBB, OFIFO, MATH3, SIZE(8), WITH(STL));
	MATHB(MATH2, SUBB, ONE, MATH3, SIZE(8), 0);
	MATHB(MATH2, SUBB, ZERO, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, SUBB, MATH0, MATH3, SIZE(8), WITH(NFU));
	MATHB(MATH3, SUBB, MATH1, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, SUBB, MATH2, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, SUBB, MATH3, MATH3, SIZE(4), 0);
	MATHB(MATH3, SUBB, IMM(393615378), MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, SUBB, DPOVRD, MATH3, SIZE(8), 0);
	MATHB(MATH3, SUBB, VSEQINSZ, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, SUBB, VSEQOUTSZ, MATH3, SIZE(4), 0);
	MATHB(MATH3, SUBB, ABD, MATH3, SIZE(8), 0);
	MATHB(MATH3, SUBB, OFIFO, MATH3, SIZE(8), 0);
	MATHB(MATH3, SUBB, ONE, MATH3, SIZE(1), 0);
	MATHB(MATH3, SUBB, ZERO, MATH3, SIZE(8), WITH(STL));
	MATHB(IMM(0x19261959fedcba01), SUBB, MATH0, MATH3, SIZE(8),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, MATH1, MATH3, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), SUBB, MATH2, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, MATH3, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, IMM(393615378), MATH3, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, DPOVRD, MATH3, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), SUBB, VSEQINSZ, MATH3, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, VSEQOUTSZ, MATH3, SIZE(2), 0);
	MATHB(IMM(275128321), SUBB, ABD, MATH3, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, OFIFO, MATH3, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, ONE, MATH3, SIZE(4), 0);
	MATHB(IMM(0x19261959fedcba01), SUBB, ZERO, MATH3, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, MATH0, MATH3, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, SUBB, MATH1, MATH3, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, MATH2, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, MATH3, MATH3, SIZE(4), 0);
	MATHB(DPOVRD, SUBB, IMM(393615378), MATH3, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, DPOVRD, MATH3, SIZE(1), WITH(NFU));
	MATHB(DPOVRD, SUBB, VSEQINSZ, MATH3, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, VSEQOUTSZ, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, ABD, MATH3, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, OFIFO, MATH3, SIZE(2), WITH(STL));
	MATHB(DPOVRD, SUBB, ONE, MATH3, SIZE(4), 0);
	MATHB(DPOVRD, SUBB, ZERO, MATH3, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, MATH0, MATH3, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, MATH1, MATH3, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, MATH2, MATH3, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, SUBB, MATH3, MATH3, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, IMM(0x19261959fedcba01), MATH3, SIZE(8),
	      WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, DPOVRD, MATH3, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, VSEQINSZ, MATH3, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, SUBB, VSEQOUTSZ, MATH3, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, SUBB, ABD, MATH3, SIZE(8), 0);
	MATHB(SEQINSZ, SUBB, OFIFO, MATH3, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, SUBB, ONE, MATH3, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, SUBB, ZERO, MATH3, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, MATH0, MATH3, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, MATH1, MATH3, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, SUBB, MATH2, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, MATH3, MATH3, SIZE(4), 0);
	MATHB(SEQOUTSZ, SUBB, IMM(393615378), MATH3, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, DPOVRD, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, VSEQINSZ, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, VSEQOUTSZ, MATH3, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, ABD, MATH3, SIZE(2), 0);
	MATHB(SEQOUTSZ, SUBB, OFIFO, MATH3, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, ONE, MATH3, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, SUBB, ZERO, MATH3, SIZE(4), 0);
	MATHB(VSEQINSZ, SUBB, MATH0, MATH3, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, MATH1, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, MATH2, MATH3, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, MATH3, MATH3, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, IMM(393615378), MATH3, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, SUBB, DPOVRD, MATH3, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, VSEQINSZ, MATH3, SIZE(8), 0);
	MATHB(VSEQINSZ, SUBB, VSEQOUTSZ, MATH3, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, SUBB, ABD, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, OFIFO, MATH3, SIZE(4), 0);
	MATHB(VSEQINSZ, SUBB, ONE, MATH3, SIZE(4), 0);
	MATHB(VSEQINSZ, SUBB, ZERO, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, MATH0, MATH3, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, MATH1, MATH3, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, MATH2, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, MATH3, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, IMM(393615378), MATH3, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, DPOVRD, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, VSEQINSZ, MATH3, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, VSEQOUTSZ, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, ABD, MATH3, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, OFIFO, MATH3, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, ONE, MATH3, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, ZERO, MATH3, SIZE(2), 0);
	MATHB(ZERO, SUBB, MATH0, MATH3, SIZE(2), 0);
	MATHB(ZERO, SUBB, MATH1, MATH3, SIZE(2), 0);
	MATHB(ZERO, SUBB, MATH2, MATH3, SIZE(8), 0);
	MATHB(ZERO, SUBB, MATH3, MATH3, SIZE(8), WITH(STL));
	MATHB(ZERO, SUBB, IMM(393615378), MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, SUBB, DPOVRD, MATH3, SIZE(8), WITH(NFU));
	MATHB(ZERO, SUBB, VSEQINSZ, MATH3, SIZE(2), 0);
	MATHB(ZERO, SUBB, VSEQOUTSZ, MATH3, SIZE(4), 0);
	MATHB(ZERO, SUBB, ABD, MATH3, SIZE(1), 0);
	MATHB(ZERO, SUBB, OFIFO, MATH3, SIZE(8), 0);
	MATHB(ZERO, SUBB, ONE, MATH3, SIZE(8), 0);
	MATHB(ZERO, SUBB, ZERO, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, SUBB, MATH0, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, SUBB, MATH1, MATH3, SIZE(2), WITH(NFU));
	MATHB(ONE, SUBB, MATH2, MATH3, SIZE(2), WITH(STL));
	MATHB(ONE, SUBB, MATH3, MATH3, SIZE(8), 0);
	MATHB(ONE, SUBB, IMM(393615378), MATH3, SIZE(8), WITH(IFB | STL));
	MATHB(ONE, SUBB, DPOVRD, MATH3, SIZE(4), 0);
	MATHB(ONE, SUBB, VSEQINSZ, MATH3, SIZE(1), WITH(NFU));
	MATHB(ONE, SUBB, VSEQOUTSZ, MATH3, SIZE(1), WITH(STL));
	MATHB(ONE, SUBB, ABD, MATH3, SIZE(4), WITH(NFU));
	MATHB(ONE, SUBB, OFIFO, MATH3, SIZE(4), 0);
	MATHB(ONE, SUBB, ONE, MATH3, SIZE(2), 0);
	MATHB(ONE, SUBB, ZERO, MATH3, SIZE(8), 0);
	/*SUBB Operation: DPOVRD Destination register */
	MATHB(MATH0, SUBB, MATH0, DPOVRD, SIZE(1), 0);
	MATHB(MATH0, SUBB, MATH1, DPOVRD, SIZE(8), 0);
	MATHB(MATH0, SUBB, MATH2, DPOVRD, SIZE(1), 0);
	MATHB(MATH0, SUBB, MATH3, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(MATH0, SUBB, IMM(393615378), DPOVRD, SIZE(1), 0);
	MATHB(MATH0, SUBB, DPOVRD, DPOVRD, SIZE(1), 0);
	MATHB(MATH0, SUBB, VSEQINSZ, DPOVRD, SIZE(4), 0);
	MATHB(MATH0, SUBB, VSEQOUTSZ, DPOVRD, SIZE(1), 0);
	MATHB(MATH0, SUBB, ABD, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, SUBB, OFIFO, DPOVRD, SIZE(1), 0);
	MATHB(MATH0, SUBB, ONE, DPOVRD, SIZE(8), 0);
	MATHB(MATH0, SUBB, ZERO, DPOVRD, SIZE(2), 0);
	MATHB(MATH1, SUBB, MATH0, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(MATH1, SUBB, MATH1, DPOVRD, SIZE(2), 0);
	MATHB(MATH1, SUBB, MATH2, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(MATH1, SUBB, MATH3, DPOVRD, SIZE(1), 0);
	MATHB(MATH1, SUBB, IMM(393615378), DPOVRD, SIZE(2), 0);
	MATHB(MATH1, SUBB, DPOVRD, DPOVRD, SIZE(4), 0);
	MATHB(MATH1, SUBB, VSEQINSZ, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(MATH1, SUBB, VSEQOUTSZ, DPOVRD, SIZE(1), 0);
	MATHB(MATH1, SUBB, ABD, DPOVRD, SIZE(2), 0);
	MATHB(MATH1, SUBB, OFIFO, DPOVRD, SIZE(8), 0);
	MATHB(MATH1, SUBB, ONE, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(MATH1, SUBB, ZERO, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, SUBB, MATH0, DPOVRD, SIZE(8), 0);
	MATHB(MATH2, SUBB, MATH1, DPOVRD, SIZE(2), WITH(STL));
	MATHB(MATH2, SUBB, MATH2, DPOVRD, SIZE(1), 0);
	MATHB(MATH2, SUBB, MATH3, DPOVRD, SIZE(1), 0);
	MATHB(MATH2, SUBB, IMM(393615378), DPOVRD, SIZE(1), 0);
	MATHB(MATH2, SUBB, DPOVRD, DPOVRD, SIZE(4), 0);
	MATHB(MATH2, SUBB, VSEQINSZ, DPOVRD, SIZE(2), 0);
	MATHB(MATH2, SUBB, VSEQOUTSZ, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(MATH2, SUBB, ABD, DPOVRD, SIZE(2), 0);
	MATHB(MATH2, SUBB, OFIFO, DPOVRD, SIZE(1), 0);
	MATHB(MATH2, SUBB, ONE, DPOVRD, SIZE(4), WITH(STL));
	MATHB(MATH2, SUBB, ZERO, DPOVRD, SIZE(4), 0);
	MATHB(MATH3, SUBB, MATH0, DPOVRD, SIZE(8), 0);
	MATHB(MATH3, SUBB, MATH1, DPOVRD, SIZE(8), 0);
	MATHB(MATH3, SUBB, MATH2, DPOVRD, SIZE(1), WITH(STL));
	MATHB(MATH3, SUBB, MATH3, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(MATH3, SUBB, IMM(393615378), DPOVRD, SIZE(2), 0);
	MATHB(MATH3, SUBB, DPOVRD, DPOVRD, SIZE(4), 0);
	MATHB(MATH3, SUBB, VSEQINSZ, DPOVRD, SIZE(2), 0);
	MATHB(MATH3, SUBB, VSEQOUTSZ, DPOVRD, SIZE(2), WITH(STL));
	MATHB(MATH3, SUBB, ABD, DPOVRD, SIZE(8), 0);
	MATHB(MATH3, SUBB, OFIFO, DPOVRD, SIZE(2), 0);
	MATHB(MATH3, SUBB, ONE, DPOVRD, SIZE(2), 0);
	MATHB(MATH3, SUBB, ZERO, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, MATH0, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), SUBB, MATH1, DPOVRD, SIZE(2), 0);
	MATHB(IMM(275128321), SUBB, MATH2, DPOVRD, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), SUBB, MATH3, DPOVRD, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, IMM(393615378), DPOVRD, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, DPOVRD, DPOVRD, SIZE(2), 0);
	MATHB(IMM(275128321), SUBB, VSEQINSZ, DPOVRD, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, VSEQOUTSZ, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), SUBB, ABD, DPOVRD, SIZE(2), 0);
	MATHB(IMM(275128321), SUBB, OFIFO, DPOVRD, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), SUBB, ONE, DPOVRD, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, ZERO, DPOVRD, SIZE(2), WITH(STL));
	MATHB(DPOVRD, SUBB, MATH0, DPOVRD, SIZE(8), WITH(STL));
	MATHB(DPOVRD, SUBB, MATH1, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, SUBB, MATH2, DPOVRD, SIZE(4), WITH(STL));
	MATHB(DPOVRD, SUBB, MATH3, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, SUBB, IMM(393615378), DPOVRD, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, DPOVRD, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, SUBB, VSEQINSZ, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, VSEQOUTSZ, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, SUBB, ABD, DPOVRD, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, OFIFO, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(DPOVRD, SUBB, ONE, DPOVRD, SIZE(8), WITH(STL));
	MATHB(DPOVRD, SUBB, ZERO, DPOVRD, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, MATH0, DPOVRD, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, MATH1, DPOVRD, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, MATH2, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, SUBB, MATH3, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, IMM(393615378), DPOVRD, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, SUBB, DPOVRD, DPOVRD, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, VSEQINSZ, DPOVRD, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, VSEQOUTSZ, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, SUBB, ABD, DPOVRD, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, OFIFO, DPOVRD, SIZE(4), 0);
	MATHB(SEQINSZ, SUBB, ONE, DPOVRD, SIZE(8), 0);
	MATHB(SEQINSZ, SUBB, ZERO, DPOVRD, SIZE(4), 0);
	MATHB(SEQOUTSZ, SUBB, MATH0, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, SUBB, MATH1, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, MATH2, DPOVRD, SIZE(4), 0);
	MATHB(SEQOUTSZ, SUBB, MATH3, DPOVRD, SIZE(4), 0);
	MATHB(SEQOUTSZ, SUBB, IMM(393615378), DPOVRD, SIZE(8), WITH(IFB | STL));
	MATHB(SEQOUTSZ, SUBB, DPOVRD, DPOVRD, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, VSEQINSZ, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, SUBB, VSEQOUTSZ, DPOVRD, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, ABD, DPOVRD, SIZE(2), 0);
	MATHB(SEQOUTSZ, SUBB, OFIFO, DPOVRD, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, ONE, DPOVRD, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, ZERO, DPOVRD, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, SUBB, MATH0, DPOVRD, SIZE(4), 0);
	MATHB(VSEQINSZ, SUBB, MATH1, DPOVRD, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, SUBB, MATH2, DPOVRD, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, MATH3, DPOVRD, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, IMM(0x19261959fedcba01), DPOVRD, SIZE(8),
	      WITH(NFU));
	MATHB(VSEQINSZ, SUBB, DPOVRD, DPOVRD, SIZE(8), 0);
	MATHB(VSEQINSZ, SUBB, VSEQINSZ, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, VSEQOUTSZ, DPOVRD, SIZE(4), 0);
	MATHB(VSEQINSZ, SUBB, ABD, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, SUBB, OFIFO, DPOVRD, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, ONE, DPOVRD, SIZE(4), 0);
	MATHB(VSEQINSZ, SUBB, ZERO, DPOVRD, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH0, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, MATH1, DPOVRD, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH2, DPOVRD, SIZE(1), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH3, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, IMM(393615378), DPOVRD, SIZE(1), 0);
	MATHB(VSEQOUTSZ, SUBB, DPOVRD, DPOVRD, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, VSEQINSZ, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, VSEQOUTSZ, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, ABD, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, OFIFO, DPOVRD, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, ONE, DPOVRD, SIZE(1), 0);
	MATHB(VSEQOUTSZ, SUBB, ZERO, DPOVRD, SIZE(1), 0);
	MATHB(ZERO, SUBB, MATH0, DPOVRD, SIZE(1), 0);
	MATHB(ZERO, SUBB, MATH1, DPOVRD, SIZE(2), 0);
	MATHB(ZERO, SUBB, MATH2, DPOVRD, SIZE(1), WITH(STL));
	MATHB(ZERO, SUBB, MATH3, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(ZERO, SUBB, IMM(393615378), DPOVRD, SIZE(8), WITH(IFB));
	MATHB(ZERO, SUBB, DPOVRD, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, SUBB, VSEQINSZ, DPOVRD, SIZE(1), 0);
	MATHB(ZERO, SUBB, VSEQOUTSZ, DPOVRD, SIZE(8), WITH(STL));
	MATHB(ZERO, SUBB, ABD, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, SUBB, OFIFO, DPOVRD, SIZE(8), 0);
	MATHB(ZERO, SUBB, ONE, DPOVRD, SIZE(1), 0);
	MATHB(ZERO, SUBB, ZERO, DPOVRD, SIZE(1), WITH(STL));
	MATHB(ONE, SUBB, MATH0, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(ONE, SUBB, MATH1, DPOVRD, SIZE(4), WITH(STL));
	MATHB(ONE, SUBB, MATH2, DPOVRD, SIZE(1), 0);
	MATHB(ONE, SUBB, MATH3, DPOVRD, SIZE(2), 0);
	MATHB(ONE, SUBB, IMM(0x19261959fedcba01), DPOVRD, SIZE(8), 0);
	MATHB(ONE, SUBB, DPOVRD, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(ONE, SUBB, VSEQINSZ, DPOVRD, SIZE(8), 0);
	MATHB(ONE, SUBB, VSEQOUTSZ, DPOVRD, SIZE(4), 0);
	MATHB(ONE, SUBB, ABD, DPOVRD, SIZE(2), 0);
	MATHB(ONE, SUBB, OFIFO, DPOVRD, SIZE(4), 0);
	MATHB(ONE, SUBB, ONE, DPOVRD, SIZE(8), WITH(STL));
	MATHB(ONE, SUBB, ZERO, DPOVRD, SIZE(4), WITH(NFU));
	/*SUBB Operation: SEQINSZ Destination register */
	MATHB(MATH0, SUBB, MATH0, SEQINSZ, SIZE(4), 0);
	MATHB(MATH0, SUBB, MATH1, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, SUBB, MATH2, SEQINSZ, SIZE(8), 0);
	MATHB(MATH0, SUBB, MATH3, SEQINSZ, SIZE(8), 0);
	MATHB(MATH0, SUBB, IMM(393615378), SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH0, SUBB, DPOVRD, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(MATH0, SUBB, VSEQINSZ, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, SUBB, VSEQOUTSZ, SEQINSZ, SIZE(4), 0);
	MATHB(MATH0, SUBB, ABD, SEQINSZ, SIZE(4), 0);
	MATHB(MATH0, SUBB, OFIFO, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH0, SUBB, ONE, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH0, SUBB, ZERO, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH1, SUBB, MATH0, SEQINSZ, SIZE(8), 0);
	MATHB(MATH1, SUBB, MATH1, SEQINSZ, SIZE(4), 0);
	MATHB(MATH1, SUBB, MATH2, SEQINSZ, SIZE(1), 0);
	MATHB(MATH1, SUBB, MATH3, SEQINSZ, SIZE(4), 0);
	MATHB(MATH1, SUBB, IMM(393615378), SEQINSZ, SIZE(8), WITH(IFB));
	MATHB(MATH1, SUBB, DPOVRD, SEQINSZ, SIZE(4), 0);
	MATHB(MATH1, SUBB, VSEQINSZ, SEQINSZ, SIZE(8), 0);
	MATHB(MATH1, SUBB, VSEQOUTSZ, SEQINSZ, SIZE(8), 0);
	MATHB(MATH1, SUBB, ABD, SEQINSZ, SIZE(1), 0);
	MATHB(MATH1, SUBB, OFIFO, SEQINSZ, SIZE(8), 0);
	MATHB(MATH1, SUBB, ONE, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(MATH1, SUBB, ZERO, SEQINSZ, SIZE(1), 0);
	MATHB(MATH2, SUBB, MATH0, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, SUBB, MATH1, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH2, SUBB, MATH2, SEQINSZ, SIZE(2), 0);
	MATHB(MATH2, SUBB, MATH3, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH2, SUBB, IMM(393615378), SEQINSZ, SIZE(8), WITH(IFB | NFU));
	MATHB(MATH2, SUBB, DPOVRD, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(MATH2, SUBB, VSEQINSZ, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH2, SUBB, VSEQOUTSZ, SEQINSZ, SIZE(2), 0);
	MATHB(MATH2, SUBB, ABD, SEQINSZ, SIZE(1), 0);
	MATHB(MATH2, SUBB, OFIFO, SEQINSZ, SIZE(2), 0);
	MATHB(MATH2, SUBB, ONE, SEQINSZ, SIZE(4), 0);
	MATHB(MATH2, SUBB, ZERO, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, SUBB, MATH0, SEQINSZ, SIZE(4), 0);
	MATHB(MATH3, SUBB, MATH1, SEQINSZ, SIZE(2), 0);
	MATHB(MATH3, SUBB, MATH2, SEQINSZ, SIZE(8), 0);
	MATHB(MATH3, SUBB, MATH3, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH3, SUBB, IMM(393615378), SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, SUBB, DPOVRD, SEQINSZ, SIZE(2), 0);
	MATHB(MATH3, SUBB, VSEQINSZ, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH3, SUBB, VSEQOUTSZ, SEQINSZ, SIZE(4), 0);
	MATHB(MATH3, SUBB, ABD, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH3, SUBB, OFIFO, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(MATH3, SUBB, ONE, SEQINSZ, SIZE(2), 0);
	MATHB(MATH3, SUBB, ZERO, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(IMM(275128321), SUBB, MATH0, SEQINSZ, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), SUBB, MATH1, SEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), SUBB, MATH2, SEQINSZ, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, MATH3, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, IMM(393615378), SEQINSZ, SIZE(4),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, DPOVRD, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), SUBB, VSEQINSZ, SEQINSZ, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, VSEQOUTSZ, SEQINSZ, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, ABD, SEQINSZ, SIZE(8),
	      WITH(IFB | NFU | STL));
	MATHB(IMM(275128321), SUBB, OFIFO, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, ONE, SEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), SUBB, ZERO, SEQINSZ, SIZE(8),
	      WITH(IFB | NFU | STL));
	MATHB(DPOVRD, SUBB, MATH0, SEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, MATH1, SEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, MATH2, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, SUBB, MATH3, SEQINSZ, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, IMM(0x19261959fedcba01), SEQINSZ, SIZE(8),
	      WITH(STL));
	MATHB(DPOVRD, SUBB, DPOVRD, SEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, VSEQINSZ, SEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, VSEQOUTSZ, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, ABD, SEQINSZ, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, OFIFO, SEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, ONE, SEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, ZERO, SEQINSZ, SIZE(8), 0);
	MATHB(SEQINSZ, SUBB, MATH0, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, MATH1, SEQINSZ, SIZE(4), 0);
	MATHB(SEQINSZ, SUBB, MATH2, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, MATH3, SEQINSZ, SIZE(4), 0);
	MATHB(SEQINSZ, SUBB, IMM(393615378), SEQINSZ, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, DPOVRD, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, VSEQINSZ, SEQINSZ, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, VSEQOUTSZ, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, ABD, SEQINSZ, SIZE(8), 0);
	MATHB(SEQINSZ, SUBB, OFIFO, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, SUBB, ONE, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, ZERO, SEQINSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, SUBB, MATH0, SEQINSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, SUBB, MATH1, SEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, MATH2, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, MATH3, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, IMM(393615378), SEQINSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, SUBB, DPOVRD, SEQINSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, VSEQINSZ, SEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, VSEQOUTSZ, SEQINSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, SUBB, ABD, SEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, OFIFO, SEQINSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, SUBB, ONE, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, ZERO, SEQINSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, SUBB, MATH0, SEQINSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, SUBB, MATH1, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, MATH2, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, SUBB, MATH3, SEQINSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, IMM(393615378), SEQINSZ, SIZE(2),
	      WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, DPOVRD, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, VSEQINSZ, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, SUBB, VSEQOUTSZ, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, ABD, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, OFIFO, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, ONE, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, ZERO, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, MATH0, SEQINSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH1, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH2, SEQINSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH3, SEQINSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, IMM(393615378), SEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, DPOVRD, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, VSEQINSZ, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, VSEQOUTSZ, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, ABD, SEQINSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, OFIFO, SEQINSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, ONE, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, ZERO, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(ZERO, SUBB, MATH0, SEQINSZ, SIZE(8), 0);
	MATHB(ZERO, SUBB, MATH1, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, SUBB, MATH2, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, SUBB, MATH3, SEQINSZ, SIZE(2), 0);
	MATHB(ZERO, SUBB, IMM(393615378), SEQINSZ, SIZE(2), 0);
	MATHB(ZERO, SUBB, DPOVRD, SEQINSZ, SIZE(2), 0);
	MATHB(ZERO, SUBB, VSEQINSZ, SEQINSZ, SIZE(1), 0);
	MATHB(ZERO, SUBB, VSEQOUTSZ, SEQINSZ, SIZE(8), 0);
	MATHB(ZERO, SUBB, ABD, SEQINSZ, SIZE(4), 0);
	MATHB(ZERO, SUBB, OFIFO, SEQINSZ, SIZE(2), 0);
	MATHB(ZERO, SUBB, ONE, SEQINSZ, SIZE(2), 0);
	MATHB(ZERO, SUBB, ZERO, SEQINSZ, SIZE(1), 0);
	MATHB(ONE, SUBB, MATH0, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, SUBB, MATH1, SEQINSZ, SIZE(4), 0);
	MATHB(ONE, SUBB, MATH2, SEQINSZ, SIZE(8), 0);
	MATHB(ONE, SUBB, MATH3, SEQINSZ, SIZE(8), 0);
	MATHB(ONE, SUBB, IMM(393615378), SEQINSZ, SIZE(2), 0);
	MATHB(ONE, SUBB, DPOVRD, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(ONE, SUBB, VSEQINSZ, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, SUBB, VSEQOUTSZ, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(ONE, SUBB, ABD, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(ONE, SUBB, OFIFO, SEQINSZ, SIZE(2), 0);
	MATHB(ONE, SUBB, ONE, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(ONE, SUBB, ZERO, SEQINSZ, SIZE(4), 0);
	/*SUBB Operation: SEQOUTSZ Destination register */
	MATHB(MATH0, SUBB, MATH0, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH0, SUBB, MATH1, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH0, SUBB, MATH2, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH0, SUBB, MATH3, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH0, SUBB, IMM(393615378), SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH0, SUBB, DPOVRD, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH0, SUBB, VSEQINSZ, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH0, SUBB, VSEQOUTSZ, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH0, SUBB, ABD, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH0, SUBB, OFIFO, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH0, SUBB, ONE, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH0, SUBB, ZERO, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, SUBB, MATH0, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH1, SUBB, MATH1, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, SUBB, MATH2, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH1, SUBB, MATH3, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH1, SUBB, IMM(393615378), SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(MATH1, SUBB, DPOVRD, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, SUBB, VSEQINSZ, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, SUBB, VSEQOUTSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH1, SUBB, ABD, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, SUBB, OFIFO, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH1, SUBB, ONE, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(MATH1, SUBB, ZERO, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, SUBB, MATH0, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH2, SUBB, MATH1, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(MATH2, SUBB, MATH2, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, SUBB, MATH3, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH2, SUBB, IMM(393615378), SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH2, SUBB, DPOVRD, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH2, SUBB, VSEQINSZ, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH2, SUBB, VSEQOUTSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, SUBB, ABD, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(MATH2, SUBB, OFIFO, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH2, SUBB, ONE, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH2, SUBB, ZERO, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, SUBB, MATH0, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH3, SUBB, MATH1, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH3, SUBB, MATH2, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, SUBB, MATH3, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, SUBB, IMM(393615378), SEQOUTSZ, SIZE(8),
	      WITH(IFB | NFU | STL));
	MATHB(MATH3, SUBB, DPOVRD, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH3, SUBB, VSEQINSZ, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(MATH3, SUBB, VSEQOUTSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH3, SUBB, ABD, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, SUBB, OFIFO, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, SUBB, ONE, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, SUBB, ZERO, SEQOUTSZ, SIZE(8), 0);
	MATHB(IMM(275128321), SUBB, MATH0, SEQOUTSZ, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, MATH1, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), SUBB, MATH2, SEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(275128321), SUBB, MATH3, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), SUBB, IMM(393615378), SEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, DPOVRD, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, VSEQINSZ, SEQOUTSZ, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, VSEQOUTSZ, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), SUBB, ABD, SEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, OFIFO, SEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, ONE, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), SUBB, ZERO, SEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, MATH0, SEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, MATH1, SEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, MATH2, SEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, MATH3, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, IMM(393615378), SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, SUBB, DPOVRD, SEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, VSEQINSZ, SEQOUTSZ, SIZE(4), 0);
	MATHB(DPOVRD, SUBB, VSEQOUTSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, ABD, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, OFIFO, SEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(DPOVRD, SUBB, ONE, SEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, ZERO, SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, MATH0, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, SUBB, MATH1, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, MATH2, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, SUBB, MATH3, SEQOUTSZ, SIZE(4), 0);
	MATHB(SEQINSZ, SUBB, IMM(393615378), SEQOUTSZ, SIZE(8),
	      WITH(IFB | STL));
	MATHB(SEQINSZ, SUBB, DPOVRD, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, SUBB, VSEQINSZ, SEQOUTSZ, SIZE(4), 0);
	MATHB(SEQINSZ, SUBB, VSEQOUTSZ, SEQOUTSZ, SIZE(4), 0);
	MATHB(SEQINSZ, SUBB, ABD, SEQOUTSZ, SIZE(8), 0);
	MATHB(SEQINSZ, SUBB, OFIFO, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, SUBB, ONE, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, SUBB, ZERO, SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, MATH0, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, MATH1, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, MATH2, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, MATH3, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, IMM(393615378), SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, SUBB, DPOVRD, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(SEQOUTSZ, SUBB, VSEQINSZ, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, SUBB, VSEQOUTSZ, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, SUBB, ABD, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, OFIFO, SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, ONE, SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, ZERO, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, SUBB, MATH0, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, SUBB, MATH1, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, MATH2, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, MATH3, SEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, SUBB, IMM(0x19261959fedcba01), SEQOUTSZ, SIZE(8),
	      WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, DPOVRD, SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, SUBB, VSEQINSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, SUBB, VSEQOUTSZ, SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, SUBB, ABD, SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, OFIFO, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, ONE, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, ZERO, SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH0, SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH1, SEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH2, SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH3, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, IMM(0x19261959fedcba01), SEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, DPOVRD, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, VSEQINSZ, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, VSEQOUTSZ, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, ABD, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, OFIFO, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, ONE, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, ZERO, SEQOUTSZ, SIZE(8), 0);
	MATHB(ZERO, SUBB, MATH0, SEQOUTSZ, SIZE(4), 0);
	MATHB(ZERO, SUBB, MATH1, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(ZERO, SUBB, MATH2, SEQOUTSZ, SIZE(4), 0);
	MATHB(ZERO, SUBB, MATH3, SEQOUTSZ, SIZE(4), 0);
	MATHB(ZERO, SUBB, IMM(393615378), SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, SUBB, DPOVRD, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, SUBB, VSEQINSZ, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, SUBB, VSEQOUTSZ, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(ZERO, SUBB, ABD, SEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, SUBB, OFIFO, SEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(ZERO, SUBB, ONE, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(ZERO, SUBB, ZERO, SEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, SUBB, MATH0, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, SUBB, MATH1, SEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, SUBB, MATH2, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(ONE, SUBB, MATH3, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(ONE, SUBB, IMM(393615378), SEQOUTSZ, SIZE(8),
	      WITH(IFB | NFU | STL));
	MATHB(ONE, SUBB, DPOVRD, SEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, SUBB, VSEQINSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(ONE, SUBB, VSEQOUTSZ, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, SUBB, ABD, SEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, SUBB, OFIFO, SEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, SUBB, ONE, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(ONE, SUBB, ZERO, SEQOUTSZ, SIZE(8), 0);
	/*SUBB Operation: VSEQINSZ Destination register */
	MATHB(MATH0, SUBB, MATH0, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(MATH0, SUBB, MATH1, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH0, SUBB, MATH2, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, SUBB, MATH3, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH0, SUBB, IMM(393615378), VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH0, SUBB, DPOVRD, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, SUBB, VSEQINSZ, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH0, SUBB, VSEQOUTSZ, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH0, SUBB, ABD, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH0, SUBB, OFIFO, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH0, SUBB, ONE, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH0, SUBB, ZERO, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH1, SUBB, MATH0, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(MATH1, SUBB, MATH1, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH1, SUBB, MATH2, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(MATH1, SUBB, MATH3, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(MATH1, SUBB, IMM(393615378), VSEQINSZ, SIZE(2), 0);
	MATHB(MATH1, SUBB, DPOVRD, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH1, SUBB, VSEQINSZ, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH1, SUBB, VSEQOUTSZ, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, SUBB, ABD, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH1, SUBB, OFIFO, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH1, SUBB, ONE, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH1, SUBB, ZERO, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH2, SUBB, MATH0, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH2, SUBB, MATH1, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH2, SUBB, MATH2, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH2, SUBB, MATH3, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(MATH2, SUBB, IMM(393615378), VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH2, SUBB, DPOVRD, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH2, SUBB, VSEQINSZ, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH2, SUBB, VSEQOUTSZ, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH2, SUBB, ABD, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH2, SUBB, OFIFO, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH2, SUBB, ONE, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH2, SUBB, ZERO, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH3, SUBB, MATH0, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH3, SUBB, MATH1, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(MATH3, SUBB, MATH2, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH3, SUBB, MATH3, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH3, SUBB, IMM(393615378), VSEQINSZ, SIZE(1), 0);
	MATHB(MATH3, SUBB, DPOVRD, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH3, SUBB, VSEQINSZ, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, SUBB, VSEQOUTSZ, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH3, SUBB, ABD, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH3, SUBB, OFIFO, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(MATH3, SUBB, ONE, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH3, SUBB, ZERO, VSEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), SUBB, MATH0, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, MATH1, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, MATH2, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), SUBB, MATH3, VSEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, IMM(393615378), VSEQINSZ, SIZE(4),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, DPOVRD, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(0x19261959fedcba01), SUBB, VSEQINSZ, VSEQINSZ, SIZE(8),
	      WITH(NFU));
	MATHB(IMM(275128321), SUBB, VSEQOUTSZ, VSEQINSZ, SIZE(1),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, ABD, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, OFIFO, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, ONE, VSEQINSZ, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, ZERO, VSEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, MATH0, VSEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, MATH1, VSEQINSZ, SIZE(4), 0);
	MATHB(DPOVRD, SUBB, MATH2, VSEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, MATH3, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(DPOVRD, SUBB, IMM(393615378), VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(DPOVRD, SUBB, DPOVRD, VSEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, VSEQINSZ, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, SUBB, VSEQOUTSZ, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(DPOVRD, SUBB, ABD, VSEQINSZ, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, OFIFO, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, SUBB, ONE, VSEQINSZ, SIZE(4), 0);
	MATHB(DPOVRD, SUBB, ZERO, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, MATH0, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, MATH1, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, MATH2, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, SUBB, MATH3, VSEQINSZ, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, IMM(393615378), VSEQINSZ, SIZE(8), WITH(IFB));
	MATHB(SEQINSZ, SUBB, DPOVRD, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, VSEQINSZ, VSEQINSZ, SIZE(4), 0);
	MATHB(SEQINSZ, SUBB, VSEQOUTSZ, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, ABD, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, SUBB, OFIFO, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, ONE, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, SUBB, ZERO, VSEQINSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, MATH0, VSEQINSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, MATH1, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, MATH2, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, MATH3, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, IMM(393615378), VSEQINSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, SUBB, DPOVRD, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, VSEQINSZ, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, VSEQOUTSZ, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, ABD, VSEQINSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, OFIFO, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, ONE, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(SEQOUTSZ, SUBB, ZERO, VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, MATH0, VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, MATH1, VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, MATH2, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, MATH3, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, IMM(393615378), VSEQINSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, SUBB, DPOVRD, VSEQINSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, SUBB, VSEQINSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, VSEQOUTSZ, VSEQINSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, SUBB, ABD, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, OFIFO, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(VSEQINSZ, SUBB, ONE, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, ZERO, VSEQINSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH0, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, MATH1, VSEQINSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH2, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, MATH3, VSEQINSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, IMM(393615378), VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, DPOVRD, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, SUBB, VSEQINSZ, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, VSEQOUTSZ, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, ABD, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, OFIFO, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, SUBB, ONE, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, SUBB, ZERO, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(ZERO, SUBB, MATH0, VSEQINSZ, SIZE(4), 0);
	MATHB(ZERO, SUBB, MATH1, VSEQINSZ, SIZE(2), 0);
	MATHB(ZERO, SUBB, MATH2, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(ZERO, SUBB, MATH3, VSEQINSZ, SIZE(1), 0);
	MATHB(ZERO, SUBB, IMM(393615378), VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, SUBB, DPOVRD, VSEQINSZ, SIZE(1), 0);
	MATHB(ZERO, SUBB, VSEQINSZ, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, SUBB, VSEQOUTSZ, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(ZERO, SUBB, ABD, VSEQINSZ, SIZE(8), 0);
	MATHB(ZERO, SUBB, OFIFO, VSEQINSZ, SIZE(1), 0);
	MATHB(ZERO, SUBB, ONE, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(ZERO, SUBB, ZERO, VSEQINSZ, SIZE(8), 0);
	MATHB(ONE, SUBB, MATH0, VSEQINSZ, SIZE(8), 0);
	MATHB(ONE, SUBB, MATH1, VSEQINSZ, SIZE(1), 0);
	MATHB(ONE, SUBB, MATH2, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, SUBB, MATH3, VSEQINSZ, SIZE(4), 0);
	MATHB(ONE, SUBB, IMM(393615378), VSEQINSZ, SIZE(8), WITH(IFB));
	MATHB(ONE, SUBB, DPOVRD, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(ONE, SUBB, VSEQINSZ, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(ONE, SUBB, VSEQOUTSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(ONE, SUBB, ABD, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, SUBB, OFIFO, VSEQINSZ, SIZE(1), 0);
	MATHB(ONE, SUBB, ONE, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, SUBB, ZERO, VSEQINSZ, SIZE(2), 0);
	/*SUBB Operation: VSEQOUTSZ Destination register */
	MATHB(MATH0, SUBB, MATH0, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH0, SUBB, MATH1, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH0, SUBB, MATH2, VSEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, SUBB, MATH3, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH0, SUBB, IMM(393615378), VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(MATH0, SUBB, DPOVRD, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH0, SUBB, VSEQINSZ, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH0, SUBB, VSEQOUTSZ, VSEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, SUBB, ABD, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH0, SUBB, OFIFO, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH0, SUBB, ONE, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, SUBB, ZERO, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(MATH1, SUBB, MATH0, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH1, SUBB, MATH1, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(MATH1, SUBB, MATH2, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, SUBB, MATH3, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH1, SUBB, IMM(393615378), VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, SUBB, DPOVRD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, SUBB, VSEQINSZ, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH1, SUBB, VSEQOUTSZ, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH1, SUBB, ABD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, SUBB, OFIFO, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH1, SUBB, ONE, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH1, SUBB, ZERO, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, SUBB, MATH0, VSEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, SUBB, MATH1, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH2, SUBB, MATH2, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH2, SUBB, MATH3, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, SUBB, IMM(393615378), VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(MATH2, SUBB, DPOVRD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH2, SUBB, VSEQINSZ, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, SUBB, VSEQOUTSZ, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, SUBB, ABD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, SUBB, OFIFO, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH2, SUBB, ONE, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH2, SUBB, ZERO, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH3, SUBB, MATH0, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, SUBB, MATH1, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH3, SUBB, MATH2, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, SUBB, MATH3, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH3, SUBB, IMM(393615378), VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, SUBB, DPOVRD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, SUBB, VSEQINSZ, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH3, SUBB, VSEQOUTSZ, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(MATH3, SUBB, ABD, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH3, SUBB, OFIFO, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH3, SUBB, ONE, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH3, SUBB, ZERO, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, MATH0, VSEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(0x19261959fedcba01), SUBB, MATH1, VSEQOUTSZ, SIZE(8), 0);
	MATHB(IMM(0x19261959fedcba01), SUBB, MATH2, VSEQOUTSZ, SIZE(8), 0);
	MATHB(IMM(275128321), SUBB, MATH3, VSEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(275128321), SUBB, IMM(393615378), VSEQOUTSZ, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, DPOVRD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(275128321), SUBB, VSEQINSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(275128321), SUBB, VSEQOUTSZ, VSEQOUTSZ, SIZE(1), 0);
	MATHB(IMM(0x19261959fedcba01), SUBB, ABD, VSEQOUTSZ, SIZE(8), 0);
	MATHB(IMM(0x19261959fedcba01), SUBB, OFIFO, VSEQOUTSZ, SIZE(8),
	      WITH(NFU));
	MATHB(IMM(275128321), SUBB, ONE, VSEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, ZERO, VSEQOUTSZ, SIZE(8), WITH(IFB | STL));
	MATHB(DPOVRD, SUBB, MATH0, VSEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, MATH1, VSEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, MATH2, VSEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, MATH3, VSEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, IMM(393615378), VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(DPOVRD, SUBB, DPOVRD, VSEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, VSEQINSZ, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, SUBB, VSEQOUTSZ, VSEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, ABD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, OFIFO, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(DPOVRD, SUBB, ONE, VSEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, ZERO, VSEQOUTSZ, SIZE(8), 0);
	MATHB(SEQINSZ, SUBB, MATH0, VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, MATH1, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQINSZ, SUBB, MATH2, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, SUBB, MATH3, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQINSZ, SUBB, IMM(393615378), VSEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, DPOVRD, VSEQOUTSZ, SIZE(8), 0);
	MATHB(SEQINSZ, SUBB, VSEQINSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, VSEQOUTSZ, VSEQOUTSZ, SIZE(8), 0);
	MATHB(SEQINSZ, SUBB, ABD, VSEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, OFIFO, VSEQOUTSZ, SIZE(8), 0);
	MATHB(SEQINSZ, SUBB, ONE, VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, ZERO, VSEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, MATH0, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, MATH1, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, MATH2, VSEQOUTSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, MATH3, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, IMM(393615378), VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, SUBB, DPOVRD, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, VSEQINSZ, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, SUBB, VSEQOUTSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, SUBB, ABD, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, OFIFO, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, SUBB, ONE, VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, SUBB, ZERO, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, SUBB, MATH0, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, SUBB, MATH1, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, MATH2, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, MATH3, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, SUBB, IMM(393615378), VSEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, DPOVRD, VSEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, VSEQINSZ, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, SUBB, VSEQOUTSZ, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, ABD, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, SUBB, OFIFO, VSEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, SUBB, ONE, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, ZERO, VSEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH0, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, MATH1, VSEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH2, VSEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH3, VSEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, IMM(0x19261959fedcba01), VSEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, DPOVRD, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, VSEQINSZ, VSEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, SUBB, VSEQOUTSZ, VSEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, ABD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, OFIFO, VSEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, ONE, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, ZERO, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(ZERO, SUBB, MATH0, VSEQOUTSZ, SIZE(8), 0);
	MATHB(ZERO, SUBB, MATH1, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(ZERO, SUBB, MATH2, VSEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, SUBB, MATH3, VSEQOUTSZ, SIZE(4), 0);
	MATHB(ZERO, SUBB, IMM(393615378), VSEQOUTSZ, SIZE(4), 0);
	MATHB(ZERO, SUBB, DPOVRD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, SUBB, VSEQINSZ, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, SUBB, VSEQOUTSZ, VSEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, SUBB, ABD, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(ZERO, SUBB, OFIFO, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, SUBB, ONE, VSEQOUTSZ, SIZE(4), 0);
	MATHB(ZERO, SUBB, ZERO, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, SUBB, MATH0, VSEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, SUBB, MATH1, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, SUBB, MATH2, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, SUBB, MATH3, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, SUBB, IMM(393615378), VSEQOUTSZ, SIZE(2), 0);
	MATHB(ONE, SUBB, DPOVRD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, SUBB, VSEQINSZ, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, SUBB, VSEQOUTSZ, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, SUBB, ABD, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(ONE, SUBB, OFIFO, VSEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, SUBB, ONE, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, SUBB, ZERO, VSEQOUTSZ, SIZE(2), WITH(NFU));
	/*SUBB Operation: NONE Destination register */
	MATHB(MATH0, SUBB, MATH0, NONE, SIZE(2), 0);
	MATHB(MATH0, SUBB, MATH1, NONE, SIZE(2), 0);
	MATHB(MATH0, SUBB, MATH2, NONE, SIZE(1), WITH(STL));
	MATHB(MATH0, SUBB, MATH3, NONE, SIZE(4), 0);
	MATHB(MATH0, SUBB, IMM(393615378), NONE, SIZE(4), WITH(NFU));
	MATHB(MATH0, SUBB, DPOVRD, NONE, SIZE(4), 0);
	MATHB(MATH0, SUBB, VSEQINSZ, NONE, SIZE(1), 0);
	MATHB(MATH0, SUBB, VSEQOUTSZ, NONE, SIZE(1), 0);
	MATHB(MATH0, SUBB, ABD, NONE, SIZE(8), 0);
	MATHB(MATH0, SUBB, OFIFO, NONE, SIZE(1), WITH(STL));
	MATHB(MATH0, SUBB, ONE, NONE, SIZE(8), 0);
	MATHB(MATH0, SUBB, ZERO, NONE, SIZE(8), WITH(STL));
	MATHB(MATH1, SUBB, MATH0, NONE, SIZE(8), 0);
	MATHB(MATH1, SUBB, MATH1, NONE, SIZE(8), 0);
	MATHB(MATH1, SUBB, MATH2, NONE, SIZE(4), WITH(STL));
	MATHB(MATH1, SUBB, MATH3, NONE, SIZE(8), 0);
	MATHB(MATH1, SUBB, IMM(0x19261959fedcba01), NONE, SIZE(8), 0);
	MATHB(MATH1, SUBB, DPOVRD, NONE, SIZE(8), 0);
	MATHB(MATH1, SUBB, VSEQINSZ, NONE, SIZE(2), WITH(NFU));
	MATHB(MATH1, SUBB, VSEQOUTSZ, NONE, SIZE(2), WITH(STL));
	MATHB(MATH1, SUBB, ABD, NONE, SIZE(4), 0);
	MATHB(MATH1, SUBB, OFIFO, NONE, SIZE(1), WITH(STL));
	MATHB(MATH1, SUBB, ONE, NONE, SIZE(4), 0);
	MATHB(MATH1, SUBB, ZERO, NONE, SIZE(2), 0);
	MATHB(MATH2, SUBB, MATH0, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, SUBB, MATH1, NONE, SIZE(1), WITH(STL));
	MATHB(MATH2, SUBB, MATH2, NONE, SIZE(1), 0);
	MATHB(MATH2, SUBB, MATH3, NONE, SIZE(1), 0);
	MATHB(MATH2, SUBB, IMM(393615378), NONE, SIZE(4), 0);
	MATHB(MATH2, SUBB, DPOVRD, NONE, SIZE(1), WITH(STL));
	MATHB(MATH2, SUBB, VSEQINSZ, NONE, SIZE(1), 0);
	MATHB(MATH2, SUBB, VSEQOUTSZ, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, SUBB, ABD, NONE, SIZE(4), 0);
	MATHB(MATH2, SUBB, OFIFO, NONE, SIZE(8), 0);
	MATHB(MATH2, SUBB, ONE, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, SUBB, ZERO, NONE, SIZE(1), WITH(STL));
	MATHB(MATH3, SUBB, MATH0, NONE, SIZE(4), 0);
	MATHB(MATH3, SUBB, MATH1, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, SUBB, MATH2, NONE, SIZE(2), 0);
	MATHB(MATH3, SUBB, MATH3, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, SUBB, IMM(393615378), NONE, SIZE(4), WITH(NFU));
	MATHB(MATH3, SUBB, DPOVRD, NONE, SIZE(1), 0);
	MATHB(MATH3, SUBB, VSEQINSZ, NONE, SIZE(8), 0);
	MATHB(MATH3, SUBB, VSEQOUTSZ, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, SUBB, ABD, NONE, SIZE(8), WITH(STL));
	MATHB(MATH3, SUBB, OFIFO, NONE, SIZE(1), WITH(NFU));
	MATHB(MATH3, SUBB, ONE, NONE, SIZE(4), WITH(NFU));
	MATHB(MATH3, SUBB, ZERO, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(0x19261959fedcba01), SUBB, MATH0, NONE, SIZE(8), 0);
	MATHB(IMM(275128321), SUBB, MATH1, NONE, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), SUBB, MATH2, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, MATH3, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, IMM(393615378), NONE, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), SUBB, DPOVRD, NONE, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, VSEQINSZ, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, VSEQOUTSZ, NONE, SIZE(2), 0);
	MATHB(IMM(0x19261959fedcba01), SUBB, ABD, NONE, SIZE(8), 0);
	MATHB(IMM(275128321), SUBB, OFIFO, NONE, SIZE(4), 0);
	MATHB(IMM(0x19261959fedcba01), SUBB, ONE, NONE, SIZE(8), 0);
	MATHB(IMM(275128321), SUBB, ZERO, NONE, SIZE(1), WITH(STL));
	MATHB(DPOVRD, SUBB, MATH0, NONE, SIZE(1), WITH(STL));
	MATHB(DPOVRD, SUBB, MATH1, NONE, SIZE(4), 0);
	MATHB(DPOVRD, SUBB, MATH2, NONE, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, MATH3, NONE, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, IMM(0x19261959fedcba01), NONE, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, SUBB, DPOVRD, NONE, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, SUBB, VSEQINSZ, NONE, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, VSEQOUTSZ, NONE, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, ABD, NONE, SIZE(4), 0);
	MATHB(DPOVRD, SUBB, OFIFO, NONE, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, ONE, NONE, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, ZERO, NONE, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, MATH0, NONE, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, MATH1, NONE, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, MATH2, NONE, SIZE(8), 0);
	MATHB(SEQINSZ, SUBB, MATH3, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, IMM(393615378), NONE, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, DPOVRD, NONE, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, VSEQINSZ, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, VSEQOUTSZ, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, ABD, NONE, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, OFIFO, NONE, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, SUBB, ONE, NONE, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, ZERO, NONE, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, SUBB, MATH0, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, MATH1, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, MATH2, NONE, SIZE(2), 0);
	MATHB(SEQOUTSZ, SUBB, MATH3, NONE, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, IMM(393615378), NONE, SIZE(4), 0);
	MATHB(SEQOUTSZ, SUBB, DPOVRD, NONE, SIZE(4), 0);
	MATHB(SEQOUTSZ, SUBB, VSEQINSZ, NONE, SIZE(2), 0);
	MATHB(SEQOUTSZ, SUBB, VSEQOUTSZ, NONE, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, ABD, NONE, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, OFIFO, NONE, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, ONE, NONE, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, ZERO, NONE, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, MATH0, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, MATH1, NONE, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, SUBB, MATH2, NONE, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, MATH3, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, IMM(0x19261959fedcba01), NONE, SIZE(8),
	      WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, DPOVRD, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, VSEQINSZ, NONE, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, SUBB, VSEQOUTSZ, NONE, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, SUBB, ABD, NONE, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, OFIFO, NONE, SIZE(8), 0);
	MATHB(VSEQINSZ, SUBB, ONE, NONE, SIZE(8), 0);
	MATHB(VSEQINSZ, SUBB, ZERO, NONE, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, MATH0, NONE, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH1, NONE, SIZE(1), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH2, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, MATH3, NONE, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, IMM(393615378), NONE, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, DPOVRD, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, VSEQINSZ, NONE, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, VSEQOUTSZ, NONE, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, ABD, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, OFIFO, NONE, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, ONE, NONE, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, ZERO, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, SUBB, MATH0, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, SUBB, MATH1, NONE, SIZE(8), 0);
	MATHB(ZERO, SUBB, MATH2, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, SUBB, MATH3, NONE, SIZE(4), 0);
	MATHB(ZERO, SUBB, IMM(393615378), NONE, SIZE(4), WITH(STL));
	MATHB(ZERO, SUBB, DPOVRD, NONE, SIZE(4), 0);
	MATHB(ZERO, SUBB, VSEQINSZ, NONE, SIZE(2), WITH(NFU));
	MATHB(ZERO, SUBB, VSEQOUTSZ, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, SUBB, ABD, NONE, SIZE(4), 0);
	MATHB(ZERO, SUBB, OFIFO, NONE, SIZE(1), 0);
	MATHB(ZERO, SUBB, ONE, NONE, SIZE(1), 0);
	MATHB(ZERO, SUBB, ZERO, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, SUBB, MATH0, NONE, SIZE(8), 0);
	MATHB(ONE, SUBB, MATH1, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, SUBB, MATH2, NONE, SIZE(8), 0);
	MATHB(ONE, SUBB, MATH3, NONE, SIZE(1), 0);
	MATHB(ONE, SUBB, IMM(0x19261959fedcba01), NONE, SIZE(8),
	      WITH(NFU | STL));
	MATHB(ONE, SUBB, DPOVRD, NONE, SIZE(4), 0);
	MATHB(ONE, SUBB, VSEQINSZ, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, SUBB, VSEQOUTSZ, NONE, SIZE(1), 0);
	MATHB(ONE, SUBB, ABD, NONE, SIZE(8), 0);
	MATHB(ONE, SUBB, OFIFO, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, SUBB, ONE, NONE, SIZE(4), WITH(STL));
	MATHB(ONE, SUBB, ZERO, NONE, SIZE(8), 0);
	/*SUBB Operation: MATH0 Destination register */
	MATHB(MATH0, SUBB, MATH0, MATH0, SIZE(2), WITH(STL));
	MATHB(MATH0, SUBB, MATH1, MATH0, SIZE(1), 0);
	MATHB(MATH0, SUBB, MATH2, MATH0, SIZE(4), WITH(NFU));
	MATHB(MATH0, SUBB, MATH3, MATH0, SIZE(1), 0);
	MATHB(MATH0, SUBB, IMM(393615378), MATH0, SIZE(4), WITH(NFU));
	MATHB(MATH0, SUBB, DPOVRD, MATH0, SIZE(8), WITH(STL));
	MATHB(MATH0, SUBB, VSEQINSZ, MATH0, SIZE(8), 0);
	MATHB(MATH0, SUBB, VSEQOUTSZ, MATH0, SIZE(2), 0);
	MATHB(MATH0, SUBB, ABD, MATH0, SIZE(8), WITH(STL));
	MATHB(MATH0, SUBB, OFIFO, MATH0, SIZE(8), 0);
	MATHB(MATH0, SUBB, ONE, MATH0, SIZE(1), 0);
	MATHB(MATH0, SUBB, ZERO, MATH0, SIZE(2), 0);
	MATHB(MATH1, SUBB, MATH0, MATH0, SIZE(1), WITH(STL));
	MATHB(MATH1, SUBB, MATH1, MATH0, SIZE(2), WITH(STL));
	MATHB(MATH1, SUBB, MATH2, MATH0, SIZE(4), WITH(NFU));
	MATHB(MATH1, SUBB, MATH3, MATH0, SIZE(8), 0);
	MATHB(MATH1, SUBB, IMM(393615378), MATH0, SIZE(4), WITH(NFU));
	MATHB(MATH1, SUBB, DPOVRD, MATH0, SIZE(2), 0);
	MATHB(MATH1, SUBB, VSEQINSZ, MATH0, SIZE(2), 0);
	MATHB(MATH1, SUBB, VSEQOUTSZ, MATH0, SIZE(1), 0);
	MATHB(MATH1, SUBB, ABD, MATH0, SIZE(8), 0);
	MATHB(MATH1, SUBB, OFIFO, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, SUBB, ONE, MATH0, SIZE(4), 0);
	MATHB(MATH1, SUBB, ZERO, MATH0, SIZE(1), 0);
	MATHB(MATH2, SUBB, MATH0, MATH0, SIZE(2), 0);
	MATHB(MATH2, SUBB, MATH1, MATH0, SIZE(2), WITH(NFU));
	MATHB(MATH2, SUBB, MATH2, MATH0, SIZE(8), 0);
	MATHB(MATH2, SUBB, MATH3, MATH0, SIZE(8), WITH(STL));
	MATHB(MATH2, SUBB, IMM(393615378), MATH0, SIZE(2), 0);
	MATHB(MATH2, SUBB, DPOVRD, MATH0, SIZE(2), 0);
	MATHB(MATH2, SUBB, VSEQINSZ, MATH0, SIZE(2), 0);
	MATHB(MATH2, SUBB, VSEQOUTSZ, MATH0, SIZE(4), 0);
	MATHB(MATH2, SUBB, ABD, MATH0, SIZE(2), 0);
	MATHB(MATH2, SUBB, OFIFO, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, SUBB, ONE, MATH0, SIZE(2), 0);
	MATHB(MATH2, SUBB, ZERO, MATH0, SIZE(8), WITH(STL));
	MATHB(MATH3, SUBB, MATH0, MATH0, SIZE(8), 0);
	MATHB(MATH3, SUBB, MATH1, MATH0, SIZE(2), 0);
	MATHB(MATH3, SUBB, MATH2, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, SUBB, MATH3, MATH0, SIZE(4), WITH(STL));
	MATHB(MATH3, SUBB, IMM(393615378), MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, SUBB, DPOVRD, MATH0, SIZE(2), 0);
	MATHB(MATH3, SUBB, VSEQINSZ, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, SUBB, VSEQOUTSZ, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, SUBB, ABD, MATH0, SIZE(1), WITH(STL));
	MATHB(MATH3, SUBB, OFIFO, MATH0, SIZE(4), WITH(NFU));
	MATHB(MATH3, SUBB, ONE, MATH0, SIZE(8), WITH(NFU | STL));
	MATHB(MATH3, SUBB, ZERO, MATH0, SIZE(2), 0);
	MATHB(IMM(275128321), SUBB, MATH0, MATH0, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), SUBB, MATH1, MATH0, SIZE(2), 0);
	MATHB(IMM(275128321), SUBB, MATH2, MATH0, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, MATH3, MATH0, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), SUBB, IMM(393615378), MATH0, SIZE(2),
	      WITH(NFU | STL));
	MATHB(IMM(0x19261959fedcba01), SUBB, DPOVRD, MATH0, SIZE(8), WITH(STL));
	MATHB(IMM(275128321), SUBB, VSEQINSZ, MATH0, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, VSEQOUTSZ, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, ABD, MATH0, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, OFIFO, MATH0, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), SUBB, ONE, MATH0, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, ZERO, MATH0, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, MATH0, MATH0, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, MATH1, MATH0, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, MATH2, MATH0, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, SUBB, MATH3, MATH0, SIZE(4), 0);
	MATHB(DPOVRD, SUBB, IMM(393615378), MATH0, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, SUBB, DPOVRD, MATH0, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, VSEQINSZ, MATH0, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, SUBB, VSEQOUTSZ, MATH0, SIZE(1), WITH(NFU));
	MATHB(DPOVRD, SUBB, ABD, MATH0, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, OFIFO, MATH0, SIZE(4), 0);
	MATHB(DPOVRD, SUBB, ONE, MATH0, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, ZERO, MATH0, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, SUBB, MATH0, MATH0, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, SUBB, MATH1, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, MATH2, MATH0, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, SUBB, MATH3, MATH0, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, IMM(393615378), MATH0, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, SUBB, DPOVRD, MATH0, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, VSEQINSZ, MATH0, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, VSEQOUTSZ, MATH0, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, SUBB, ABD, MATH0, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, OFIFO, MATH0, SIZE(8), 0);
	MATHB(SEQINSZ, SUBB, ONE, MATH0, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, ZERO, MATH0, SIZE(4), 0);
	MATHB(SEQOUTSZ, SUBB, MATH0, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, MATH1, MATH0, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, MATH2, MATH0, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, SUBB, MATH3, MATH0, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, IMM(393615378), MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, DPOVRD, MATH0, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, SUBB, VSEQINSZ, MATH0, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, VSEQOUTSZ, MATH0, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, ABD, MATH0, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, OFIFO, MATH0, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, SUBB, ONE, MATH0, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, ZERO, MATH0, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, MATH0, MATH0, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, SUBB, MATH1, MATH0, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, MATH2, MATH0, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, MATH3, MATH0, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, SUBB, IMM(393615378), MATH0, SIZE(4), 0);
	MATHB(VSEQINSZ, SUBB, DPOVRD, MATH0, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, VSEQINSZ, MATH0, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, VSEQOUTSZ, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, ABD, MATH0, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, OFIFO, MATH0, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, ONE, MATH0, SIZE(8), 0);
	MATHB(VSEQINSZ, SUBB, ZERO, MATH0, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH0, MATH0, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, MATH1, MATH0, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, MATH2, MATH0, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, MATH3, MATH0, SIZE(1), 0);
	MATHB(VSEQOUTSZ, SUBB, IMM(0x19261959fedcba01), MATH0, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, DPOVRD, MATH0, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, VSEQINSZ, MATH0, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, VSEQOUTSZ, MATH0, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, ABD, MATH0, SIZE(1), 0);
	MATHB(VSEQOUTSZ, SUBB, OFIFO, MATH0, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, ONE, MATH0, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, ZERO, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, SUBB, MATH0, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, SUBB, MATH1, MATH0, SIZE(4), WITH(NFU));
	MATHB(ZERO, SUBB, MATH2, MATH0, SIZE(2), 0);
	MATHB(ZERO, SUBB, MATH3, MATH0, SIZE(1), 0);
	MATHB(ZERO, SUBB, IMM(393615378), MATH0, SIZE(2), 0);
	MATHB(ZERO, SUBB, DPOVRD, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, SUBB, VSEQINSZ, MATH0, SIZE(2), 0);
	MATHB(ZERO, SUBB, VSEQOUTSZ, MATH0, SIZE(4), 0);
	MATHB(ZERO, SUBB, ABD, MATH0, SIZE(4), 0);
	MATHB(ZERO, SUBB, OFIFO, MATH0, SIZE(1), 0);
	MATHB(ZERO, SUBB, ONE, MATH0, SIZE(2), 0);
	MATHB(ZERO, SUBB, ZERO, MATH0, SIZE(4), 0);
	MATHB(ONE, SUBB, MATH0, MATH0, SIZE(8), WITH(STL));
	MATHB(ONE, SUBB, MATH1, MATH0, SIZE(4), 0);
	MATHB(ONE, SUBB, MATH2, MATH0, SIZE(8), 0);
	MATHB(ONE, SUBB, MATH3, MATH0, SIZE(4), 0);
	MATHB(ONE, SUBB, IMM(393615378), MATH0, SIZE(8), WITH(IFB));
	MATHB(ONE, SUBB, DPOVRD, MATH0, SIZE(4), WITH(NFU));
	MATHB(ONE, SUBB, VSEQINSZ, MATH0, SIZE(4), 0);
	MATHB(ONE, SUBB, VSEQOUTSZ, MATH0, SIZE(4), 0);
	MATHB(ONE, SUBB, ABD, MATH0, SIZE(2), 0);
	MATHB(ONE, SUBB, OFIFO, MATH0, SIZE(8), 0);
	MATHB(ONE, SUBB, ONE, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, SUBB, ZERO, MATH0, SIZE(4), 0);
	/*SUBB Operation: MATH1 Destination register */
	MATHB(MATH0, SUBB, MATH0, MATH1, SIZE(2), 0);
	MATHB(MATH0, SUBB, MATH1, MATH1, SIZE(8), 0);
	MATHB(MATH0, SUBB, MATH2, MATH1, SIZE(2), 0);
	MATHB(MATH0, SUBB, MATH3, MATH1, SIZE(1), 0);
	MATHB(MATH0, SUBB, IMM(0x19261959fedcba01), MATH1, SIZE(8), WITH(NFU));
	MATHB(MATH0, SUBB, DPOVRD, MATH1, SIZE(4), 0);
	MATHB(MATH0, SUBB, VSEQINSZ, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, SUBB, VSEQOUTSZ, MATH1, SIZE(2), 0);
	MATHB(MATH0, SUBB, ABD, MATH1, SIZE(1), WITH(NFU));
	MATHB(MATH0, SUBB, OFIFO, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(MATH0, SUBB, ONE, MATH1, SIZE(1), 0);
	MATHB(MATH0, SUBB, ZERO, MATH1, SIZE(4), 0);
	MATHB(MATH1, SUBB, MATH0, MATH1, SIZE(1), 0);
	MATHB(MATH1, SUBB, MATH1, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, SUBB, MATH2, MATH1, SIZE(1), 0);
	MATHB(MATH1, SUBB, MATH3, MATH1, SIZE(1), 0);
	MATHB(MATH1, SUBB, IMM(393615378), MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(MATH1, SUBB, DPOVRD, MATH1, SIZE(2), 0);
	MATHB(MATH1, SUBB, VSEQINSZ, MATH1, SIZE(4), WITH(NFU));
	MATHB(MATH1, SUBB, VSEQOUTSZ, MATH1, SIZE(8), WITH(NFU));
	MATHB(MATH1, SUBB, ABD, MATH1, SIZE(1), 0);
	MATHB(MATH1, SUBB, OFIFO, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, SUBB, ONE, MATH1, SIZE(2), 0);
	MATHB(MATH1, SUBB, ZERO, MATH1, SIZE(4), WITH(STL));
	MATHB(MATH2, SUBB, MATH0, MATH1, SIZE(4), 0);
	MATHB(MATH2, SUBB, MATH1, MATH1, SIZE(1), 0);
	MATHB(MATH2, SUBB, MATH2, MATH1, SIZE(8), 0);
	MATHB(MATH2, SUBB, MATH3, MATH1, SIZE(2), 0);
	MATHB(MATH2, SUBB, IMM(393615378), MATH1, SIZE(1), WITH(STL));
	MATHB(MATH2, SUBB, DPOVRD, MATH1, SIZE(1), 0);
	MATHB(MATH2, SUBB, VSEQINSZ, MATH1, SIZE(4), 0);
	MATHB(MATH2, SUBB, VSEQOUTSZ, MATH1, SIZE(4), 0);
	MATHB(MATH2, SUBB, ABD, MATH1, SIZE(2), 0);
	MATHB(MATH2, SUBB, OFIFO, MATH1, SIZE(2), WITH(NFU));
	MATHB(MATH2, SUBB, ONE, MATH1, SIZE(4), 0);
	MATHB(MATH2, SUBB, ZERO, MATH1, SIZE(1), 0);
	MATHB(MATH3, SUBB, MATH0, MATH1, SIZE(2), 0);
	MATHB(MATH3, SUBB, MATH1, MATH1, SIZE(2), 0);
	MATHB(MATH3, SUBB, MATH2, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, SUBB, MATH3, MATH1, SIZE(4), 0);
	MATHB(MATH3, SUBB, IMM(393615378), MATH1, SIZE(4), WITH(STL));
	MATHB(MATH3, SUBB, DPOVRD, MATH1, SIZE(8), WITH(STL));
	MATHB(MATH3, SUBB, VSEQINSZ, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, SUBB, VSEQOUTSZ, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(MATH3, SUBB, ABD, MATH1, SIZE(2), 0);
	MATHB(MATH3, SUBB, OFIFO, MATH1, SIZE(4), 0);
	MATHB(MATH3, SUBB, ONE, MATH1, SIZE(4), 0);
	MATHB(MATH3, SUBB, ZERO, MATH1, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, MATH0, MATH1, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, MATH1, MATH1, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), SUBB, MATH2, MATH1, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), SUBB, MATH3, MATH1, SIZE(2), 0);
	MATHB(IMM(275128321), SUBB, IMM(393615378), MATH1, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, DPOVRD, MATH1, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, VSEQINSZ, MATH1, SIZE(2), 0);
	MATHB(IMM(275128321), SUBB, VSEQOUTSZ, MATH1, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, ABD, MATH1, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, OFIFO, MATH1, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, ONE, MATH1, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, ZERO, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, MATH0, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, MATH1, MATH1, SIZE(1), WITH(STL));
	MATHB(DPOVRD, SUBB, MATH2, MATH1, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, MATH3, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, IMM(393615378), MATH1, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, SUBB, DPOVRD, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, VSEQINSZ, MATH1, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, VSEQOUTSZ, MATH1, SIZE(8), WITH(STL));
	MATHB(DPOVRD, SUBB, ABD, MATH1, SIZE(1), WITH(NFU));
	MATHB(DPOVRD, SUBB, OFIFO, MATH1, SIZE(4), 0);
	MATHB(DPOVRD, SUBB, ONE, MATH1, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, ZERO, MATH1, SIZE(4), 0);
	MATHB(SEQINSZ, SUBB, MATH0, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, MATH1, MATH1, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, MATH2, MATH1, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, MATH3, MATH1, SIZE(4), 0);
	MATHB(SEQINSZ, SUBB, IMM(393615378), MATH1, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, DPOVRD, MATH1, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, SUBB, VSEQINSZ, MATH1, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, SUBB, VSEQOUTSZ, MATH1, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, SUBB, ABD, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, OFIFO, MATH1, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, ONE, MATH1, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, ZERO, MATH1, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, MATH0, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, MATH1, MATH1, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, MATH2, MATH1, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, MATH3, MATH1, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, SUBB, IMM(393615378), MATH1, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, DPOVRD, MATH1, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, VSEQINSZ, MATH1, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, VSEQOUTSZ, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, ABD, MATH1, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, OFIFO, MATH1, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, ONE, MATH1, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, SUBB, ZERO, MATH1, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, MATH0, MATH1, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, MATH1, MATH1, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, SUBB, MATH2, MATH1, SIZE(8), 0);
	MATHB(VSEQINSZ, SUBB, MATH3, MATH1, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, SUBB, IMM(393615378), MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, DPOVRD, MATH1, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, VSEQINSZ, MATH1, SIZE(8), 0);
	MATHB(VSEQINSZ, SUBB, VSEQOUTSZ, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, ABD, MATH1, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, SUBB, OFIFO, MATH1, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, SUBB, ONE, MATH1, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, ZERO, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, MATH0, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, MATH1, MATH1, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH2, MATH1, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH3, MATH1, SIZE(1), 0);
	MATHB(VSEQOUTSZ, SUBB, IMM(393615378), MATH1, SIZE(8), WITH(IFB));
	MATHB(VSEQOUTSZ, SUBB, DPOVRD, MATH1, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, VSEQINSZ, MATH1, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, VSEQOUTSZ, MATH1, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, ABD, MATH1, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, OFIFO, MATH1, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, ONE, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, ZERO, MATH1, SIZE(1), 0);
	MATHB(ZERO, SUBB, MATH0, MATH1, SIZE(1), 0);
	MATHB(ZERO, SUBB, MATH1, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, SUBB, MATH2, MATH1, SIZE(4), 0);
	MATHB(ZERO, SUBB, MATH3, MATH1, SIZE(2), 0);
	MATHB(ZERO, SUBB, IMM(393615378), MATH1, SIZE(8), WITH(IFB));
	MATHB(ZERO, SUBB, DPOVRD, MATH1, SIZE(4), 0);
	MATHB(ZERO, SUBB, VSEQINSZ, MATH1, SIZE(8), WITH(NFU));
	MATHB(ZERO, SUBB, VSEQOUTSZ, MATH1, SIZE(4), 0);
	MATHB(ZERO, SUBB, ABD, MATH1, SIZE(4), WITH(NFU));
	MATHB(ZERO, SUBB, OFIFO, MATH1, SIZE(1), WITH(STL));
	MATHB(ZERO, SUBB, ONE, MATH1, SIZE(2), 0);
	MATHB(ZERO, SUBB, ZERO, MATH1, SIZE(4), WITH(STL));
	MATHB(ONE, SUBB, MATH0, MATH1, SIZE(8), 0);
	MATHB(ONE, SUBB, MATH1, MATH1, SIZE(1), 0);
	MATHB(ONE, SUBB, MATH2, MATH1, SIZE(1), WITH(NFU));
	MATHB(ONE, SUBB, MATH3, MATH1, SIZE(2), WITH(NFU));
	MATHB(ONE, SUBB, IMM(393615378), MATH1, SIZE(1), 0);
	MATHB(ONE, SUBB, DPOVRD, MATH1, SIZE(8), 0);
	MATHB(ONE, SUBB, VSEQINSZ, MATH1, SIZE(8), WITH(NFU));
	MATHB(ONE, SUBB, VSEQOUTSZ, MATH1, SIZE(2), 0);
	MATHB(ONE, SUBB, ABD, MATH1, SIZE(4), 0);
	MATHB(ONE, SUBB, OFIFO, MATH1, SIZE(4), 0);
	MATHB(ONE, SUBB, ONE, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, SUBB, ZERO, MATH1, SIZE(8), 0);
	/*SUBB Operation: MATH2 Destination register */
	MATHB(MATH0, SUBB, MATH0, MATH2, SIZE(4), WITH(STL));
	MATHB(MATH0, SUBB, MATH1, MATH2, SIZE(2), 0);
	MATHB(MATH0, SUBB, MATH2, MATH2, SIZE(2), WITH(NFU));
	MATHB(MATH0, SUBB, MATH3, MATH2, SIZE(2), 0);
	MATHB(MATH0, SUBB, IMM(0x19261959fedcba01), MATH2, SIZE(8), 0);
	MATHB(MATH0, SUBB, DPOVRD, MATH2, SIZE(1), WITH(NFU));
	MATHB(MATH0, SUBB, VSEQINSZ, MATH2, SIZE(4), 0);
	MATHB(MATH0, SUBB, VSEQOUTSZ, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, SUBB, ABD, MATH2, SIZE(8), WITH(NFU));
	MATHB(MATH0, SUBB, OFIFO, MATH2, SIZE(4), WITH(STL));
	MATHB(MATH0, SUBB, ONE, MATH2, SIZE(2), 0);
	MATHB(MATH0, SUBB, ZERO, MATH2, SIZE(8), 0);
	MATHB(MATH1, SUBB, MATH0, MATH2, SIZE(4), 0);
	MATHB(MATH1, SUBB, MATH1, MATH2, SIZE(8), WITH(STL));
	MATHB(MATH1, SUBB, MATH2, MATH2, SIZE(1), WITH(NFU));
	MATHB(MATH1, SUBB, MATH3, MATH2, SIZE(4), WITH(STL));
	MATHB(MATH1, SUBB, IMM(0x19261959fedcba01), MATH2, SIZE(8), 0);
	MATHB(MATH1, SUBB, DPOVRD, MATH2, SIZE(1), WITH(STL));
	MATHB(MATH1, SUBB, VSEQINSZ, MATH2, SIZE(8), WITH(NFU));
	MATHB(MATH1, SUBB, VSEQOUTSZ, MATH2, SIZE(4), WITH(STL));
	MATHB(MATH1, SUBB, ABD, MATH2, SIZE(4), 0);
	MATHB(MATH1, SUBB, OFIFO, MATH2, SIZE(4), 0);
	MATHB(MATH1, SUBB, ONE, MATH2, SIZE(1), 0);
	MATHB(MATH1, SUBB, ZERO, MATH2, SIZE(8), WITH(STL));
	MATHB(MATH2, SUBB, MATH0, MATH2, SIZE(8), 0);
	MATHB(MATH2, SUBB, MATH1, MATH2, SIZE(8), 0);
	MATHB(MATH2, SUBB, MATH2, MATH2, SIZE(1), 0);
	MATHB(MATH2, SUBB, MATH3, MATH2, SIZE(4), WITH(STL));
	MATHB(MATH2, SUBB, IMM(393615378), MATH2, SIZE(2), 0);
	MATHB(MATH2, SUBB, DPOVRD, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, SUBB, VSEQINSZ, MATH2, SIZE(2), 0);
	MATHB(MATH2, SUBB, VSEQOUTSZ, MATH2, SIZE(4), 0);
	MATHB(MATH2, SUBB, ABD, MATH2, SIZE(1), 0);
	MATHB(MATH2, SUBB, OFIFO, MATH2, SIZE(1), 0);
	MATHB(MATH2, SUBB, ONE, MATH2, SIZE(8), WITH(NFU));
	MATHB(MATH2, SUBB, ZERO, MATH2, SIZE(8), WITH(STL));
	MATHB(MATH3, SUBB, MATH0, MATH2, SIZE(2), 0);
	MATHB(MATH3, SUBB, MATH1, MATH2, SIZE(8), WITH(STL));
	MATHB(MATH3, SUBB, MATH2, MATH2, SIZE(1), 0);
	MATHB(MATH3, SUBB, MATH3, MATH2, SIZE(4), 0);
	MATHB(MATH3, SUBB, IMM(393615378), MATH2, SIZE(2), 0);
	MATHB(MATH3, SUBB, DPOVRD, MATH2, SIZE(1), WITH(STL));
	MATHB(MATH3, SUBB, VSEQINSZ, MATH2, SIZE(8), 0);
	MATHB(MATH3, SUBB, VSEQOUTSZ, MATH2, SIZE(1), 0);
	MATHB(MATH3, SUBB, ABD, MATH2, SIZE(8), 0);
	MATHB(MATH3, SUBB, OFIFO, MATH2, SIZE(8), WITH(STL));
	MATHB(MATH3, SUBB, ONE, MATH2, SIZE(2), WITH(NFU));
	MATHB(MATH3, SUBB, ZERO, MATH2, SIZE(4), 0);
	MATHB(IMM(0x19261959fedcba01), SUBB, MATH0, MATH2, SIZE(8), WITH(STL));
	MATHB(IMM(275128321), SUBB, MATH1, MATH2, SIZE(8), WITH(IFB));
	MATHB(IMM(0x19261959fedcba01), SUBB, MATH2, MATH2, SIZE(8), 0);
	MATHB(IMM(275128321), SUBB, MATH3, MATH2, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, IMM(393615378), MATH2, SIZE(2), WITH(STL));
	MATHB(IMM(0x19261959fedcba01), SUBB, DPOVRD, MATH2, SIZE(8), 0);
	MATHB(IMM(0x19261959fedcba01), SUBB, VSEQINSZ, MATH2, SIZE(8),
	      WITH(STL));
	MATHB(IMM(275128321), SUBB, VSEQOUTSZ, MATH2, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), SUBB, ABD, MATH2, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, OFIFO, MATH2, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, ONE, MATH2, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), SUBB, ZERO, MATH2, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, MATH0, MATH2, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, MATH1, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, MATH2, MATH2, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, SUBB, MATH3, MATH2, SIZE(4), 0);
	MATHB(DPOVRD, SUBB, IMM(393615378), MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, DPOVRD, MATH2, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, VSEQINSZ, MATH2, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, VSEQOUTSZ, MATH2, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, SUBB, ABD, MATH2, SIZE(4), 0);
	MATHB(DPOVRD, SUBB, OFIFO, MATH2, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, ONE, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, ZERO, MATH2, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, MATH0, MATH2, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, MATH1, MATH2, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, MATH2, MATH2, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, MATH3, MATH2, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, SUBB, IMM(393615378), MATH2, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, SUBB, DPOVRD, MATH2, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, SUBB, VSEQINSZ, MATH2, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, SUBB, VSEQOUTSZ, MATH2, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, ABD, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, OFIFO, MATH2, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, SUBB, ONE, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, ZERO, MATH2, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, MATH0, MATH2, SIZE(4), 0);
	MATHB(SEQOUTSZ, SUBB, MATH1, MATH2, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, MATH2, MATH2, SIZE(2), 0);
	MATHB(SEQOUTSZ, SUBB, MATH3, MATH2, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, SUBB, IMM(0x19261959fedcba01), MATH2, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, DPOVRD, MATH2, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, VSEQINSZ, MATH2, SIZE(2), 0);
	MATHB(SEQOUTSZ, SUBB, VSEQOUTSZ, MATH2, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, ABD, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, OFIFO, MATH2, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, ONE, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, ZERO, MATH2, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, SUBB, MATH0, MATH2, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, MATH1, MATH2, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, SUBB, MATH2, MATH2, SIZE(8), 0);
	MATHB(VSEQINSZ, SUBB, MATH3, MATH2, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, SUBB, IMM(393615378), MATH2, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, SUBB, DPOVRD, MATH2, SIZE(8), 0);
	MATHB(VSEQINSZ, SUBB, VSEQINSZ, MATH2, SIZE(4), 0);
	MATHB(VSEQINSZ, SUBB, VSEQOUTSZ, MATH2, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, SUBB, ABD, MATH2, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, OFIFO, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, ONE, MATH2, SIZE(4), 0);
	MATHB(VSEQINSZ, SUBB, ZERO, MATH2, SIZE(1), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH0, MATH2, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, MATH1, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, MATH2, MATH2, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, MATH3, MATH2, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, IMM(393615378), MATH2, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, DPOVRD, MATH2, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, VSEQINSZ, MATH2, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, VSEQOUTSZ, MATH2, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, ABD, MATH2, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, OFIFO, MATH2, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, ONE, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, ZERO, MATH2, SIZE(4), WITH(STL));
	MATHB(ZERO, SUBB, MATH0, MATH2, SIZE(4), 0);
	MATHB(ZERO, SUBB, MATH1, MATH2, SIZE(2), 0);
	MATHB(ZERO, SUBB, MATH2, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, SUBB, MATH3, MATH2, SIZE(1), WITH(STL));
	MATHB(ZERO, SUBB, IMM(0x19261959fedcba01), MATH2, SIZE(8), WITH(STL));
	MATHB(ZERO, SUBB, DPOVRD, MATH2, SIZE(1), WITH(NFU));
	MATHB(ZERO, SUBB, VSEQINSZ, MATH2, SIZE(1), WITH(NFU));
	MATHB(ZERO, SUBB, VSEQOUTSZ, MATH2, SIZE(1), 0);
	MATHB(ZERO, SUBB, ABD, MATH2, SIZE(8), WITH(NFU));
	MATHB(ZERO, SUBB, OFIFO, MATH2, SIZE(4), WITH(STL));
	MATHB(ZERO, SUBB, ONE, MATH2, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, SUBB, ZERO, MATH2, SIZE(8), WITH(STL));
	MATHB(ONE, SUBB, MATH0, MATH2, SIZE(8), WITH(STL));
	MATHB(ONE, SUBB, MATH1, MATH2, SIZE(8), 0);
	MATHB(ONE, SUBB, MATH2, MATH2, SIZE(8), 0);
	MATHB(ONE, SUBB, MATH3, MATH2, SIZE(4), 0);
	MATHB(ONE, SUBB, IMM(393615378), MATH2, SIZE(1), WITH(NFU));
	MATHB(ONE, SUBB, DPOVRD, MATH2, SIZE(2), 0);
	MATHB(ONE, SUBB, VSEQINSZ, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, SUBB, VSEQOUTSZ, MATH2, SIZE(1), 0);
	MATHB(ONE, SUBB, ABD, MATH2, SIZE(4), WITH(NFU));
	MATHB(ONE, SUBB, OFIFO, MATH2, SIZE(8), 0);
	MATHB(ONE, SUBB, ONE, MATH2, SIZE(2), WITH(NFU));
	MATHB(ONE, SUBB, ZERO, MATH2, SIZE(1), 0);
	/*SUBB Operation: MATH3 Destination register */
	MATHB(MATH0, SUBB, MATH0, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, SUBB, MATH1, MATH3, SIZE(4), 0);
	MATHB(MATH0, SUBB, MATH2, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, SUBB, MATH3, MATH3, SIZE(2), 0);
	MATHB(MATH0, SUBB, IMM(393615378), MATH3, SIZE(1), WITH(STL));
	MATHB(MATH0, SUBB, DPOVRD, MATH3, SIZE(1), 0);
	MATHB(MATH0, SUBB, VSEQINSZ, MATH3, SIZE(8), WITH(NFU));
	MATHB(MATH0, SUBB, VSEQOUTSZ, MATH3, SIZE(8), 0);
	MATHB(MATH0, SUBB, ABD, MATH3, SIZE(4), 0);
	MATHB(MATH0, SUBB, OFIFO, MATH3, SIZE(4), 0);
	MATHB(MATH0, SUBB, ONE, MATH3, SIZE(2), WITH(NFU));
	MATHB(MATH0, SUBB, ZERO, MATH3, SIZE(1), WITH(NFU));
	MATHB(MATH1, SUBB, MATH0, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(MATH1, SUBB, MATH1, MATH3, SIZE(2), WITH(STL));
	MATHB(MATH1, SUBB, MATH2, MATH3, SIZE(2), 0);
	MATHB(MATH1, SUBB, MATH3, MATH3, SIZE(4), 0);
	MATHB(MATH1, SUBB, IMM(393615378), MATH3, SIZE(2), 0);
	MATHB(MATH1, SUBB, DPOVRD, MATH3, SIZE(2), 0);
	MATHB(MATH1, SUBB, VSEQINSZ, MATH3, SIZE(1), 0);
	MATHB(MATH1, SUBB, VSEQOUTSZ, MATH3, SIZE(2), 0);
	MATHB(MATH1, SUBB, ABD, MATH3, SIZE(8), 0);
	MATHB(MATH1, SUBB, OFIFO, MATH3, SIZE(8), WITH(NFU));
	MATHB(MATH1, SUBB, ONE, MATH3, SIZE(8), 0);
	MATHB(MATH1, SUBB, ZERO, MATH3, SIZE(4), WITH(STL));
	MATHB(MATH2, SUBB, MATH0, MATH3, SIZE(4), 0);
	MATHB(MATH2, SUBB, MATH1, MATH3, SIZE(1), WITH(NFU));
	MATHB(MATH2, SUBB, MATH2, MATH3, SIZE(1), WITH(NFU));
	MATHB(MATH2, SUBB, MATH3, MATH3, SIZE(2), 0);
	MATHB(MATH2, SUBB, IMM(393615378), MATH3, SIZE(4), 0);
	MATHB(MATH2, SUBB, DPOVRD, MATH3, SIZE(1), 0);
	MATHB(MATH2, SUBB, VSEQINSZ, MATH3, SIZE(8), 0);
	MATHB(MATH2, SUBB, VSEQOUTSZ, MATH3, SIZE(2), WITH(NFU));
	MATHB(MATH2, SUBB, ABD, MATH3, SIZE(2), 0);
	MATHB(MATH2, SUBB, OFIFO, MATH3, SIZE(8), 0);
	MATHB(MATH2, SUBB, ONE, MATH3, SIZE(4), 0);
	MATHB(MATH2, SUBB, ZERO, MATH3, SIZE(4), WITH(NFU));
	MATHB(MATH3, SUBB, MATH0, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, SUBB, MATH1, MATH3, SIZE(4), WITH(STL));
	MATHB(MATH3, SUBB, MATH2, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, SUBB, MATH3, MATH3, SIZE(1), 0);
	MATHB(MATH3, SUBB, IMM(393615378), MATH3, SIZE(1), 0);
	MATHB(MATH3, SUBB, DPOVRD, MATH3, SIZE(4), 0);
	MATHB(MATH3, SUBB, VSEQINSZ, MATH3, SIZE(1), 0);
	MATHB(MATH3, SUBB, VSEQOUTSZ, MATH3, SIZE(4), 0);
	MATHB(MATH3, SUBB, ABD, MATH3, SIZE(1), WITH(STL));
	MATHB(MATH3, SUBB, OFIFO, MATH3, SIZE(1), 0);
	MATHB(MATH3, SUBB, ONE, MATH3, SIZE(8), 0);
	MATHB(MATH3, SUBB, ZERO, MATH3, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), SUBB, MATH0, MATH3, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, MATH1, MATH3, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), SUBB, MATH2, MATH3, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), SUBB, MATH3, MATH3, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, IMM(393615378), MATH3, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, DPOVRD, MATH3, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, VSEQINSZ, MATH3, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), SUBB, VSEQOUTSZ, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, ABD, MATH3, SIZE(2), WITH(NFU));
	MATHB(IMM(275128321), SUBB, OFIFO, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, ONE, MATH3, SIZE(8), WITH(IFB));
	MATHB(IMM(0x19261959fedcba01), SUBB, ZERO, MATH3, SIZE(8),
	      WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, MATH0, MATH3, SIZE(8), WITH(STL));
	MATHB(DPOVRD, SUBB, MATH1, MATH3, SIZE(1), WITH(NFU));
	MATHB(DPOVRD, SUBB, MATH2, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, MATH3, MATH3, SIZE(4), 0);
	MATHB(DPOVRD, SUBB, IMM(393615378), MATH3, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, SUBB, DPOVRD, MATH3, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, VSEQINSZ, MATH3, SIZE(1), WITH(STL));
	MATHB(DPOVRD, SUBB, VSEQOUTSZ, MATH3, SIZE(4), 0);
	MATHB(DPOVRD, SUBB, ABD, MATH3, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, SUBB, OFIFO, MATH3, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, ONE, MATH3, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, ZERO, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, MATH0, MATH3, SIZE(4), 0);
	MATHB(SEQINSZ, SUBB, MATH1, MATH3, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, MATH2, MATH3, SIZE(4), 0);
	MATHB(SEQINSZ, SUBB, MATH3, MATH3, SIZE(8), 0);
	MATHB(SEQINSZ, SUBB, IMM(393615378), MATH3, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, DPOVRD, MATH3, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, VSEQINSZ, MATH3, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, SUBB, VSEQOUTSZ, MATH3, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, SUBB, ABD, MATH3, SIZE(4), 0);
	MATHB(SEQINSZ, SUBB, OFIFO, MATH3, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, SUBB, ONE, MATH3, SIZE(8), 0);
	MATHB(SEQINSZ, SUBB, ZERO, MATH3, SIZE(4), 0);
	MATHB(SEQOUTSZ, SUBB, MATH0, MATH3, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, MATH1, MATH3, SIZE(2), 0);
	MATHB(SEQOUTSZ, SUBB, MATH2, MATH3, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, MATH3, MATH3, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, IMM(393615378), MATH3, SIZE(2), 0);
	MATHB(SEQOUTSZ, SUBB, DPOVRD, MATH3, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, VSEQINSZ, MATH3, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, VSEQOUTSZ, MATH3, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, ABD, MATH3, SIZE(4), 0);
	MATHB(SEQOUTSZ, SUBB, OFIFO, MATH3, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, SUBB, ONE, MATH3, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, ZERO, MATH3, SIZE(4), WITH(STL));
	MATHB(VSEQINSZ, SUBB, MATH0, MATH3, SIZE(8), 0);
	MATHB(VSEQINSZ, SUBB, MATH1, MATH3, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, SUBB, MATH2, MATH3, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, MATH3, MATH3, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, SUBB, IMM(393615378), MATH3, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, DPOVRD, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, VSEQINSZ, MATH3, SIZE(4), 0);
	MATHB(VSEQINSZ, SUBB, VSEQOUTSZ, MATH3, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, SUBB, ABD, MATH3, SIZE(4), WITH(STL));
	MATHB(VSEQINSZ, SUBB, OFIFO, MATH3, SIZE(4), 0);
	MATHB(VSEQINSZ, SUBB, ONE, MATH3, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, SUBB, ZERO, MATH3, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH0, MATH3, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, MATH1, MATH3, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH2, MATH3, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH3, MATH3, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, IMM(393615378), MATH3, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, DPOVRD, MATH3, SIZE(1), 0);
	MATHB(VSEQOUTSZ, SUBB, VSEQINSZ, MATH3, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, VSEQOUTSZ, MATH3, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, ABD, MATH3, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, OFIFO, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, ONE, MATH3, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, ZERO, MATH3, SIZE(2), WITH(NFU));
	MATHB(ZERO, SUBB, MATH0, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, SUBB, MATH1, MATH3, SIZE(2), 0);
	MATHB(ZERO, SUBB, MATH2, MATH3, SIZE(1), 0);
	MATHB(ZERO, SUBB, MATH3, MATH3, SIZE(8), 0);
	MATHB(ZERO, SUBB, IMM(393615378), MATH3, SIZE(2), 0);
	MATHB(ZERO, SUBB, DPOVRD, MATH3, SIZE(8), WITH(NFU));
	MATHB(ZERO, SUBB, VSEQINSZ, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, SUBB, VSEQOUTSZ, MATH3, SIZE(1), 0);
	MATHB(ZERO, SUBB, ABD, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, SUBB, OFIFO, MATH3, SIZE(8), WITH(STL));
	MATHB(ZERO, SUBB, ONE, MATH3, SIZE(1), 0);
	MATHB(ZERO, SUBB, ZERO, MATH3, SIZE(4), 0);
	MATHB(ONE, SUBB, MATH0, MATH3, SIZE(4), 0);
	MATHB(ONE, SUBB, MATH1, MATH3, SIZE(8), 0);
	MATHB(ONE, SUBB, MATH2, MATH3, SIZE(1), 0);
	MATHB(ONE, SUBB, MATH3, MATH3, SIZE(8), WITH(NFU));
	MATHB(ONE, SUBB, IMM(393615378), MATH3, SIZE(4), 0);
	MATHB(ONE, SUBB, DPOVRD, MATH3, SIZE(1), 0);
	MATHB(ONE, SUBB, VSEQINSZ, MATH3, SIZE(1), 0);
	MATHB(ONE, SUBB, VSEQOUTSZ, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, SUBB, ABD, MATH3, SIZE(1), WITH(STL));
	MATHB(ONE, SUBB, OFIFO, MATH3, SIZE(8), 0);
	MATHB(ONE, SUBB, ONE, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, SUBB, ZERO, MATH3, SIZE(2), WITH(STL));
	/*SUBB Operation: DPOVRD Destination register */
	MATHB(MATH0, SUBB, MATH0, DPOVRD, SIZE(8), 0);
	MATHB(MATH0, SUBB, MATH1, DPOVRD, SIZE(4), 0);
	MATHB(MATH0, SUBB, MATH2, DPOVRD, SIZE(4), 0);
	MATHB(MATH0, SUBB, MATH3, DPOVRD, SIZE(1), 0);
	MATHB(MATH0, SUBB, IMM(393615378), DPOVRD, SIZE(1), 0);
	MATHB(MATH0, SUBB, DPOVRD, DPOVRD, SIZE(8), 0);
	MATHB(MATH0, SUBB, VSEQINSZ, DPOVRD, SIZE(8), 0);
	MATHB(MATH0, SUBB, VSEQOUTSZ, DPOVRD, SIZE(4), 0);
	MATHB(MATH0, SUBB, ABD, DPOVRD, SIZE(4), 0);
	MATHB(MATH0, SUBB, OFIFO, DPOVRD, SIZE(4), 0);
	MATHB(MATH0, SUBB, ONE, DPOVRD, SIZE(4), 0);
	MATHB(MATH0, SUBB, ZERO, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(MATH1, SUBB, MATH0, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, SUBB, MATH1, DPOVRD, SIZE(8), 0);
	MATHB(MATH1, SUBB, MATH2, DPOVRD, SIZE(4), 0);
	MATHB(MATH1, SUBB, MATH3, DPOVRD, SIZE(2), 0);
	MATHB(MATH1, SUBB, IMM(393615378), DPOVRD, SIZE(2), 0);
	MATHB(MATH1, SUBB, DPOVRD, DPOVRD, SIZE(2), 0);
	MATHB(MATH1, SUBB, VSEQINSZ, DPOVRD, SIZE(1), WITH(STL));
	MATHB(MATH1, SUBB, VSEQOUTSZ, DPOVRD, SIZE(2), 0);
	MATHB(MATH1, SUBB, ABD, DPOVRD, SIZE(8), 0);
	MATHB(MATH1, SUBB, OFIFO, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(MATH1, SUBB, ONE, DPOVRD, SIZE(4), 0);
	MATHB(MATH1, SUBB, ZERO, DPOVRD, SIZE(8), 0);
	MATHB(MATH2, SUBB, MATH0, DPOVRD, SIZE(1), 0);
	MATHB(MATH2, SUBB, MATH1, DPOVRD, SIZE(8), WITH(STL));
	MATHB(MATH2, SUBB, MATH2, DPOVRD, SIZE(8), 0);
	MATHB(MATH2, SUBB, MATH3, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, SUBB, IMM(393615378), DPOVRD, SIZE(8), WITH(IFB));
	MATHB(MATH2, SUBB, DPOVRD, DPOVRD, SIZE(2), WITH(STL));
	MATHB(MATH2, SUBB, VSEQINSZ, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(MATH2, SUBB, VSEQOUTSZ, DPOVRD, SIZE(8), WITH(STL));
	MATHB(MATH2, SUBB, ABD, DPOVRD, SIZE(4), WITH(STL));
	MATHB(MATH2, SUBB, OFIFO, DPOVRD, SIZE(8), 0);
	MATHB(MATH2, SUBB, ONE, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, SUBB, ZERO, DPOVRD, SIZE(8), 0);
	MATHB(MATH3, SUBB, MATH0, DPOVRD, SIZE(8), 0);
	MATHB(MATH3, SUBB, MATH1, DPOVRD, SIZE(1), 0);
	MATHB(MATH3, SUBB, MATH2, DPOVRD, SIZE(1), 0);
	MATHB(MATH3, SUBB, MATH3, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(MATH3, SUBB, IMM(393615378), DPOVRD, SIZE(1), 0);
	MATHB(MATH3, SUBB, DPOVRD, DPOVRD, SIZE(2), WITH(STL));
	MATHB(MATH3, SUBB, VSEQINSZ, DPOVRD, SIZE(4), 0);
	MATHB(MATH3, SUBB, VSEQOUTSZ, DPOVRD, SIZE(4), 0);
	MATHB(MATH3, SUBB, ABD, DPOVRD, SIZE(1), 0);
	MATHB(MATH3, SUBB, OFIFO, DPOVRD, SIZE(1), 0);
	MATHB(MATH3, SUBB, ONE, DPOVRD, SIZE(1), 0);
	MATHB(MATH3, SUBB, ZERO, DPOVRD, SIZE(8), 0);
	MATHB(IMM(275128321), SUBB, MATH0, DPOVRD, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), SUBB, MATH1, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, MATH2, DPOVRD, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, MATH3, DPOVRD, SIZE(8), WITH(IFB | STL));
	MATHB(IMM(275128321), SUBB, IMM(393615378), DPOVRD, SIZE(2), 0);
	MATHB(IMM(275128321), SUBB, DPOVRD, DPOVRD, SIZE(2), WITH(STL));
	MATHB(IMM(0x19261959fedcba01), SUBB, VSEQINSZ, DPOVRD, SIZE(8),
	      WITH(NFU));
	MATHB(IMM(275128321), SUBB, VSEQOUTSZ, DPOVRD, SIZE(2),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, ABD, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, OFIFO, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), SUBB, ONE, DPOVRD, SIZE(4), 0);
	MATHB(IMM(0x19261959fedcba01), SUBB, ZERO, DPOVRD, SIZE(8),
	      WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, MATH0, DPOVRD, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, MATH1, DPOVRD, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, MATH2, DPOVRD, SIZE(4), 0);
	MATHB(DPOVRD, SUBB, MATH3, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(DPOVRD, SUBB, IMM(393615378), DPOVRD, SIZE(4), 0);
	MATHB(DPOVRD, SUBB, DPOVRD, DPOVRD, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, VSEQINSZ, DPOVRD, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, VSEQOUTSZ, DPOVRD, SIZE(2), WITH(STL));
	MATHB(DPOVRD, SUBB, ABD, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, OFIFO, DPOVRD, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, ONE, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, SUBB, ZERO, DPOVRD, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, MATH0, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, MATH1, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, MATH2, DPOVRD, SIZE(4), 0);
	MATHB(SEQINSZ, SUBB, MATH3, DPOVRD, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, IMM(393615378), DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, DPOVRD, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, VSEQINSZ, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, VSEQOUTSZ, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, SUBB, ABD, DPOVRD, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, OFIFO, DPOVRD, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, ONE, DPOVRD, SIZE(8), 0);
	MATHB(SEQINSZ, SUBB, ZERO, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, MATH0, DPOVRD, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, MATH1, DPOVRD, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, MATH2, DPOVRD, SIZE(4), 0);
	MATHB(SEQOUTSZ, SUBB, MATH3, DPOVRD, SIZE(2), 0);
	MATHB(SEQOUTSZ, SUBB, IMM(393615378), DPOVRD, SIZE(4), 0);
	MATHB(SEQOUTSZ, SUBB, DPOVRD, DPOVRD, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, VSEQINSZ, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(SEQOUTSZ, SUBB, VSEQOUTSZ, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, SUBB, ABD, DPOVRD, SIZE(2), 0);
	MATHB(SEQOUTSZ, SUBB, OFIFO, DPOVRD, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, ONE, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, ZERO, DPOVRD, SIZE(8), 0);
	MATHB(VSEQINSZ, SUBB, MATH0, DPOVRD, SIZE(8), 0);
	MATHB(VSEQINSZ, SUBB, MATH1, DPOVRD, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, MATH2, DPOVRD, SIZE(4), 0);
	MATHB(VSEQINSZ, SUBB, MATH3, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, IMM(393615378), DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, DPOVRD, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, VSEQINSZ, DPOVRD, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, SUBB, VSEQOUTSZ, DPOVRD, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, ABD, DPOVRD, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, OFIFO, DPOVRD, SIZE(8), 0);
	MATHB(VSEQINSZ, SUBB, ONE, DPOVRD, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, ZERO, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, MATH0, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, MATH1, DPOVRD, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, MATH2, DPOVRD, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH3, DPOVRD, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, IMM(393615378), DPOVRD, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, DPOVRD, DPOVRD, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, VSEQINSZ, DPOVRD, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, VSEQOUTSZ, DPOVRD, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, ABD, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, OFIFO, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, ONE, DPOVRD, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, ZERO, DPOVRD, SIZE(2), 0);
	MATHB(ZERO, SUBB, MATH0, DPOVRD, SIZE(1), 0);
	MATHB(ZERO, SUBB, MATH1, DPOVRD, SIZE(8), 0);
	MATHB(ZERO, SUBB, MATH2, DPOVRD, SIZE(1), 0);
	MATHB(ZERO, SUBB, MATH3, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, SUBB, IMM(393615378), DPOVRD, SIZE(2), 0);
	MATHB(ZERO, SUBB, DPOVRD, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, SUBB, VSEQINSZ, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(ZERO, SUBB, VSEQOUTSZ, DPOVRD, SIZE(2), 0);
	MATHB(ZERO, SUBB, ABD, DPOVRD, SIZE(8), 0);
	MATHB(ZERO, SUBB, OFIFO, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(ZERO, SUBB, ONE, DPOVRD, SIZE(4), 0);
	MATHB(ZERO, SUBB, ZERO, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(ONE, SUBB, MATH0, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(ONE, SUBB, MATH1, DPOVRD, SIZE(8), WITH(STL));
	MATHB(ONE, SUBB, MATH2, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, SUBB, MATH3, DPOVRD, SIZE(1), 0);
	MATHB(ONE, SUBB, IMM(393615378), DPOVRD, SIZE(4), 0);
	MATHB(ONE, SUBB, DPOVRD, DPOVRD, SIZE(4), WITH(STL));
	MATHB(ONE, SUBB, VSEQINSZ, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, SUBB, VSEQOUTSZ, DPOVRD, SIZE(2), 0);
	MATHB(ONE, SUBB, ABD, DPOVRD, SIZE(8), 0);
	MATHB(ONE, SUBB, OFIFO, DPOVRD, SIZE(1), WITH(STL));
	MATHB(ONE, SUBB, ONE, DPOVRD, SIZE(8), WITH(STL));
	MATHB(ONE, SUBB, ZERO, DPOVRD, SIZE(1), WITH(STL));
	/*SUBB Operation: SEQINSZ Destination register */
	MATHB(MATH0, SUBB, MATH0, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH0, SUBB, MATH1, SEQINSZ, SIZE(4), 0);
	MATHB(MATH0, SUBB, MATH2, SEQINSZ, SIZE(1), 0);
	MATHB(MATH0, SUBB, MATH3, SEQINSZ, SIZE(4), 0);
	MATHB(MATH0, SUBB, IMM(393615378), SEQINSZ, SIZE(1), 0);
	MATHB(MATH0, SUBB, DPOVRD, SEQINSZ, SIZE(1), 0);
	MATHB(MATH0, SUBB, VSEQINSZ, SEQINSZ, SIZE(2), 0);
	MATHB(MATH0, SUBB, VSEQOUTSZ, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH0, SUBB, ABD, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH0, SUBB, OFIFO, SEQINSZ, SIZE(2), 0);
	MATHB(MATH0, SUBB, ONE, SEQINSZ, SIZE(2), 0);
	MATHB(MATH0, SUBB, ZERO, SEQINSZ, SIZE(4), 0);
	MATHB(MATH1, SUBB, MATH0, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(MATH1, SUBB, MATH1, SEQINSZ, SIZE(1), 0);
	MATHB(MATH1, SUBB, MATH2, SEQINSZ, SIZE(2), 0);
	MATHB(MATH1, SUBB, MATH3, SEQINSZ, SIZE(1), 0);
	MATHB(MATH1, SUBB, IMM(393615378), SEQINSZ, SIZE(4), 0);
	MATHB(MATH1, SUBB, DPOVRD, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(MATH1, SUBB, VSEQINSZ, SEQINSZ, SIZE(2), 0);
	MATHB(MATH1, SUBB, VSEQOUTSZ, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH1, SUBB, ABD, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, SUBB, OFIFO, SEQINSZ, SIZE(2), 0);
	MATHB(MATH1, SUBB, ONE, SEQINSZ, SIZE(1), 0);
	MATHB(MATH1, SUBB, ZERO, SEQINSZ, SIZE(4), 0);
	MATHB(MATH2, SUBB, MATH0, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH2, SUBB, MATH1, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, SUBB, MATH2, SEQINSZ, SIZE(8), 0);
	MATHB(MATH2, SUBB, MATH3, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(MATH2, SUBB, IMM(393615378), SEQINSZ, SIZE(8),
	      WITH(IFB | NFU | STL));
	MATHB(MATH2, SUBB, DPOVRD, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(MATH2, SUBB, VSEQINSZ, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, SUBB, VSEQOUTSZ, SEQINSZ, SIZE(1), 0);
	MATHB(MATH2, SUBB, ABD, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(MATH2, SUBB, OFIFO, SEQINSZ, SIZE(1), 0);
	MATHB(MATH2, SUBB, ONE, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH2, SUBB, ZERO, SEQINSZ, SIZE(4), 0);
	MATHB(MATH3, SUBB, MATH0, SEQINSZ, SIZE(1), 0);
	MATHB(MATH3, SUBB, MATH1, SEQINSZ, SIZE(8), 0);
	MATHB(MATH3, SUBB, MATH2, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, SUBB, MATH3, SEQINSZ, SIZE(2), 0);
	MATHB(MATH3, SUBB, IMM(393615378), SEQINSZ, SIZE(8), WITH(IFB));
	MATHB(MATH3, SUBB, DPOVRD, SEQINSZ, SIZE(8), 0);
	MATHB(MATH3, SUBB, VSEQINSZ, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH3, SUBB, VSEQOUTSZ, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH3, SUBB, ABD, SEQINSZ, SIZE(1), 0);
	MATHB(MATH3, SUBB, OFIFO, SEQINSZ, SIZE(8), 0);
	MATHB(MATH3, SUBB, ONE, SEQINSZ, SIZE(4), 0);
	MATHB(MATH3, SUBB, ZERO, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, MATH0, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(0x19261959fedcba01), SUBB, MATH1, SEQINSZ, SIZE(8),
	      WITH(NFU));
	MATHB(IMM(275128321), SUBB, MATH2, SEQINSZ, SIZE(8), WITH(IFB | STL));
	MATHB(IMM(275128321), SUBB, MATH3, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, IMM(393615378), SEQINSZ, SIZE(2),
	      WITH(STL));
	MATHB(IMM(275128321), SUBB, DPOVRD, SEQINSZ, SIZE(2), 0);
	MATHB(IMM(0x19261959fedcba01), SUBB, VSEQINSZ, SEQINSZ, SIZE(8), 0);
	MATHB(IMM(275128321), SUBB, VSEQOUTSZ, SEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, ABD, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), SUBB, OFIFO, SEQINSZ, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), SUBB, ONE, SEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), SUBB, ZERO, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(DPOVRD, SUBB, MATH0, SEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, MATH1, SEQINSZ, SIZE(4), 0);
	MATHB(DPOVRD, SUBB, MATH2, SEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, MATH3, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, IMM(393615378), SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, SUBB, DPOVRD, SEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, VSEQINSZ, SEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, VSEQOUTSZ, SEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, ABD, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, OFIFO, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, ONE, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, ZERO, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, SUBB, MATH0, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, SUBB, MATH1, SEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, MATH2, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, MATH3, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, IMM(393615378), SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, SUBB, DPOVRD, SEQINSZ, SIZE(8), 0);
	MATHB(SEQINSZ, SUBB, VSEQINSZ, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, SUBB, VSEQOUTSZ, SEQINSZ, SIZE(4), 0);
	MATHB(SEQINSZ, SUBB, ABD, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, SUBB, OFIFO, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, SUBB, ONE, SEQINSZ, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, ZERO, SEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, MATH0, SEQINSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, MATH1, SEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, MATH2, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, MATH3, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, IMM(393615378), SEQINSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, SUBB, DPOVRD, SEQINSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, VSEQINSZ, SEQINSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, SUBB, VSEQOUTSZ, SEQINSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, SUBB, ABD, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, OFIFO, SEQINSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, SUBB, ONE, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, ZERO, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, SUBB, MATH0, SEQINSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, SUBB, MATH1, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, MATH2, SEQINSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, MATH3, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, SUBB, IMM(393615378), SEQINSZ, SIZE(2),
	      WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, DPOVRD, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, SUBB, VSEQINSZ, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, VSEQOUTSZ, SEQINSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, SUBB, ABD, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, OFIFO, SEQINSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, ONE, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, SUBB, ZERO, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH0, SEQINSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH1, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH2, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, MATH3, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, IMM(393615378), SEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, DPOVRD, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, VSEQINSZ, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, VSEQOUTSZ, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, ABD, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, OFIFO, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, ONE, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, ZERO, SEQINSZ, SIZE(2), 0);
	MATHB(ZERO, SUBB, MATH0, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(ZERO, SUBB, MATH1, SEQINSZ, SIZE(4), 0);
	MATHB(ZERO, SUBB, MATH2, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, SUBB, MATH3, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(ZERO, SUBB, IMM(393615378), SEQINSZ, SIZE(8), WITH(IFB | NFU));
	MATHB(ZERO, SUBB, DPOVRD, SEQINSZ, SIZE(2), 0);
	MATHB(ZERO, SUBB, VSEQINSZ, SEQINSZ, SIZE(8), 0);
	MATHB(ZERO, SUBB, VSEQOUTSZ, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, SUBB, ABD, SEQINSZ, SIZE(1), 0);
	MATHB(ZERO, SUBB, OFIFO, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(ZERO, SUBB, ONE, SEQINSZ, SIZE(1), 0);
	MATHB(ZERO, SUBB, ZERO, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(ONE, SUBB, MATH0, SEQINSZ, SIZE(2), 0);
	MATHB(ONE, SUBB, MATH1, SEQINSZ, SIZE(4), 0);
	MATHB(ONE, SUBB, MATH2, SEQINSZ, SIZE(2), 0);
	MATHB(ONE, SUBB, MATH3, SEQINSZ, SIZE(4), 0);
	MATHB(ONE, SUBB, IMM(393615378), SEQINSZ, SIZE(2), 0);
	MATHB(ONE, SUBB, DPOVRD, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(ONE, SUBB, VSEQINSZ, SEQINSZ, SIZE(4), 0);
	MATHB(ONE, SUBB, VSEQOUTSZ, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, SUBB, ABD, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(ONE, SUBB, OFIFO, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, SUBB, ONE, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, SUBB, ZERO, SEQINSZ, SIZE(8), WITH(NFU));
	/*SUBB Operation: SEQOUTSZ Destination register */
	MATHB(MATH0, SUBB, MATH0, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, SUBB, MATH1, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, SUBB, MATH2, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH0, SUBB, MATH3, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH0, SUBB, IMM(393615378), SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH0, SUBB, DPOVRD, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, SUBB, VSEQINSZ, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(MATH0, SUBB, VSEQOUTSZ, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, SUBB, ABD, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH0, SUBB, OFIFO, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH0, SUBB, ONE, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(MATH0, SUBB, ZERO, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH1, SUBB, MATH0, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH1, SUBB, MATH1, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH1, SUBB, MATH2, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH1, SUBB, MATH3, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, SUBB, IMM(393615378), SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH1, SUBB, DPOVRD, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH1, SUBB, VSEQINSZ, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH1, SUBB, VSEQOUTSZ, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH1, SUBB, ABD, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH1, SUBB, OFIFO, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH1, SUBB, ONE, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH1, SUBB, ZERO, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, SUBB, MATH0, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, SUBB, MATH1, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH2, SUBB, MATH2, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(MATH2, SUBB, MATH3, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH2, SUBB, IMM(393615378), SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH2, SUBB, DPOVRD, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, SUBB, VSEQINSZ, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH2, SUBB, VSEQOUTSZ, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH2, SUBB, ABD, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, SUBB, OFIFO, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(MATH2, SUBB, ONE, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH2, SUBB, ZERO, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, SUBB, MATH0, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH3, SUBB, MATH1, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH3, SUBB, MATH2, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(MATH3, SUBB, MATH3, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH3, SUBB, IMM(393615378), SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, SUBB, DPOVRD, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH3, SUBB, VSEQINSZ, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(MATH3, SUBB, VSEQOUTSZ, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, SUBB, ABD, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH3, SUBB, OFIFO, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, SUBB, ONE, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, SUBB, ZERO, SEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(IMM(275128321), SUBB, MATH0, SEQOUTSZ, SIZE(8), WITH(IFB | STL));
	MATHB(IMM(0x19261959fedcba01), SUBB, MATH1, SEQOUTSZ, SIZE(8),
	      WITH(NFU));
	MATHB(IMM(275128321), SUBB, MATH2, SEQOUTSZ, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, MATH3, SEQOUTSZ, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, IMM(393615378), SEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, DPOVRD, SEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(275128321), SUBB, VSEQINSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(275128321), SUBB, VSEQOUTSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(275128321), SUBB, ABD, SEQOUTSZ, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, OFIFO, SEQOUTSZ, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, ONE, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), SUBB, ZERO, SEQOUTSZ, SIZE(4), 0);
	MATHB(DPOVRD, SUBB, MATH0, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, MATH1, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(DPOVRD, SUBB, MATH2, SEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, MATH3, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, IMM(393615378), SEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, DPOVRD, SEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, VSEQINSZ, SEQOUTSZ, SIZE(4), 0);
	MATHB(DPOVRD, SUBB, VSEQOUTSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, ABD, SEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, OFIFO, SEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, ONE, SEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, ZERO, SEQOUTSZ, SIZE(8), 0);
	MATHB(SEQINSZ, SUBB, MATH0, SEQOUTSZ, SIZE(8), 0);
	MATHB(SEQINSZ, SUBB, MATH1, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, SUBB, MATH2, SEQOUTSZ, SIZE(8), 0);
	MATHB(SEQINSZ, SUBB, MATH3, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, IMM(0x19261959fedcba01), SEQOUTSZ, SIZE(8), 0);
	MATHB(SEQINSZ, SUBB, DPOVRD, SEQOUTSZ, SIZE(4), 0);
	MATHB(SEQINSZ, SUBB, VSEQINSZ, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, VSEQOUTSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(SEQINSZ, SUBB, ABD, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, OFIFO, SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, ONE, SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, ZERO, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, MATH0, SEQOUTSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, SUBB, MATH1, SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, MATH2, SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, SUBB, MATH3, SEQOUTSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, IMM(393615378), SEQOUTSZ, SIZE(8), WITH(IFB));
	MATHB(SEQOUTSZ, SUBB, DPOVRD, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, VSEQINSZ, SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, VSEQOUTSZ, SEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, ABD, SEQOUTSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, OFIFO, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, ONE, SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, SUBB, ZERO, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, SUBB, MATH0, SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, MATH1, SEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, SUBB, MATH2, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(VSEQINSZ, SUBB, MATH3, SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, SUBB, IMM(393615378), SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, DPOVRD, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, VSEQINSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, VSEQOUTSZ, SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, SUBB, ABD, SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, OFIFO, SEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, ONE, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, SUBB, ZERO, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, MATH0, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, MATH1, SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH2, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, MATH3, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, IMM(393615378), SEQOUTSZ, SIZE(1),
	      WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, DPOVRD, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, VSEQINSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, VSEQOUTSZ, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, ABD, SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, SUBB, OFIFO, SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, ONE, SEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, ZERO, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(ZERO, SUBB, MATH0, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, SUBB, MATH1, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(ZERO, SUBB, MATH2, SEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, SUBB, MATH3, SEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, SUBB, IMM(0x19261959fedcba01), SEQOUTSZ, SIZE(8), 0);
	MATHB(ZERO, SUBB, DPOVRD, SEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, SUBB, VSEQINSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(ZERO, SUBB, VSEQOUTSZ, SEQOUTSZ, SIZE(4), 0);
	MATHB(ZERO, SUBB, ABD, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(ZERO, SUBB, OFIFO, SEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, SUBB, ONE, SEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, SUBB, ZERO, SEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, SUBB, MATH0, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(ONE, SUBB, MATH1, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(ONE, SUBB, MATH2, SEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, SUBB, MATH3, SEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, SUBB, IMM(393615378), SEQOUTSZ, SIZE(8), WITH(IFB | STL));
	MATHB(ONE, SUBB, DPOVRD, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, SUBB, VSEQINSZ, SEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, SUBB, VSEQOUTSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(ONE, SUBB, ABD, SEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, SUBB, OFIFO, SEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, SUBB, ONE, SEQOUTSZ, SIZE(2), 0);
	MATHB(ONE, SUBB, ZERO, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	/*SUBB Operation: VSEQINSZ Destination register */
	MATHB(MATH0, SUBB, MATH0, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH0, SUBB, MATH1, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH0, SUBB, MATH2, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH0, SUBB, MATH3, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH0, SUBB, IMM(393615378), VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH0, SUBB, DPOVRD, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH0, SUBB, VSEQINSZ, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH0, SUBB, VSEQOUTSZ, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH0, SUBB, ABD, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH0, SUBB, OFIFO, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, SUBB, ONE, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH0, SUBB, ZERO, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH1, SUBB, MATH0, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH1, SUBB, MATH1, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH1, SUBB, MATH2, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH1, SUBB, MATH3, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, SUBB, IMM(393615378), VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH1, SUBB, DPOVRD, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(MATH1, SUBB, VSEQINSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH1, SUBB, VSEQOUTSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH1, SUBB, ABD, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH1, SUBB, OFIFO, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH1, SUBB, ONE, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH1, SUBB, ZERO, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH2, SUBB, MATH0, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, SUBB, MATH1, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH2, SUBB, MATH2, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH2, SUBB, MATH3, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH2, SUBB, IMM(393615378), VSEQINSZ, SIZE(8),
	      WITH(IFB | NFU | STL));
	MATHB(MATH2, SUBB, DPOVRD, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH2, SUBB, VSEQINSZ, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH2, SUBB, VSEQOUTSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH2, SUBB, ABD, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH2, SUBB, OFIFO, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH2, SUBB, ONE, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH2, SUBB, ZERO, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(MATH3, SUBB, MATH0, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH3, SUBB, MATH1, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH3, SUBB, MATH2, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH3, SUBB, MATH3, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH3, SUBB, IMM(393615378), VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH3, SUBB, DPOVRD, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH3, SUBB, VSEQINSZ, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(MATH3, SUBB, VSEQOUTSZ, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH3, SUBB, ABD, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH3, SUBB, OFIFO, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH3, SUBB, ONE, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(MATH3, SUBB, ZERO, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, MATH0, VSEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), SUBB, MATH1, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), SUBB, MATH2, VSEQINSZ, SIZE(8), WITH(IFB));
	MATHB(IMM(0x19261959fedcba01), SUBB, MATH3, VSEQINSZ, SIZE(8), 0);
	MATHB(IMM(275128321), SUBB, IMM(393615378), VSEQINSZ, SIZE(2),
	      WITH(STL));
	MATHB(IMM(0x19261959fedcba01), SUBB, DPOVRD, VSEQINSZ, SIZE(8),
	      WITH(NFU));
	MATHB(IMM(275128321), SUBB, VSEQINSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, VSEQOUTSZ, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), SUBB, ABD, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(IMM(275128321), SUBB, OFIFO, VSEQINSZ, SIZE(8), WITH(IFB | NFU));
	MATHB(IMM(275128321), SUBB, ONE, VSEQINSZ, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, ZERO, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(DPOVRD, SUBB, MATH0, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, MATH1, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(DPOVRD, SUBB, MATH2, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(DPOVRD, SUBB, MATH3, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, SUBB, IMM(393615378), VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, DPOVRD, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, SUBB, VSEQINSZ, VSEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, VSEQOUTSZ, VSEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, ABD, VSEQINSZ, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, OFIFO, VSEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, ONE, VSEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, ZERO, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQINSZ, SUBB, MATH0, VSEQINSZ, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, MATH1, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQINSZ, SUBB, MATH2, VSEQINSZ, SIZE(4), 0);
	MATHB(SEQINSZ, SUBB, MATH3, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, IMM(393615378), VSEQINSZ, SIZE(4), 0);
	MATHB(SEQINSZ, SUBB, DPOVRD, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, VSEQINSZ, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, SUBB, VSEQOUTSZ, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, ABD, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, OFIFO, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, SUBB, ONE, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, ZERO, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, MATH0, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, SUBB, MATH1, VSEQINSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, SUBB, MATH2, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, MATH3, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, IMM(393615378), VSEQINSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, SUBB, DPOVRD, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, VSEQINSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, VSEQOUTSZ, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(SEQOUTSZ, SUBB, ABD, VSEQINSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, SUBB, OFIFO, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, SUBB, ONE, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, SUBB, ZERO, VSEQINSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, SUBB, MATH0, VSEQINSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, SUBB, MATH1, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, MATH2, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, MATH3, VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, IMM(393615378), VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, DPOVRD, VSEQINSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, SUBB, VSEQINSZ, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, SUBB, VSEQOUTSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, ABD, VSEQINSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, SUBB, OFIFO, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(VSEQINSZ, SUBB, ONE, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, ZERO, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, MATH0, VSEQINSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH1, VSEQINSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH2, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, MATH3, VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, IMM(393615378), VSEQINSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, DPOVRD, VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, VSEQINSZ, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, VSEQOUTSZ, VSEQINSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, ABD, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, OFIFO, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, ONE, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, SUBB, ZERO, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, SUBB, MATH0, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, SUBB, MATH1, VSEQINSZ, SIZE(4), 0);
	MATHB(ZERO, SUBB, MATH2, VSEQINSZ, SIZE(8), 0);
	MATHB(ZERO, SUBB, MATH3, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, SUBB, IMM(393615378), VSEQINSZ, SIZE(4), 0);
	MATHB(ZERO, SUBB, DPOVRD, VSEQINSZ, SIZE(8), 0);
	MATHB(ZERO, SUBB, VSEQINSZ, VSEQINSZ, SIZE(2), 0);
	MATHB(ZERO, SUBB, VSEQOUTSZ, VSEQINSZ, SIZE(8), 0);
	MATHB(ZERO, SUBB, ABD, VSEQINSZ, SIZE(2), 0);
	MATHB(ZERO, SUBB, OFIFO, VSEQINSZ, SIZE(4), 0);
	MATHB(ZERO, SUBB, ONE, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(ZERO, SUBB, ZERO, VSEQINSZ, SIZE(1), 0);
	MATHB(ONE, SUBB, MATH0, VSEQINSZ, SIZE(2), 0);
	MATHB(ONE, SUBB, MATH1, VSEQINSZ, SIZE(1), 0);
	MATHB(ONE, SUBB, MATH2, VSEQINSZ, SIZE(1), 0);
	MATHB(ONE, SUBB, MATH3, VSEQINSZ, SIZE(2), 0);
	MATHB(ONE, SUBB, IMM(393615378), VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, SUBB, DPOVRD, VSEQINSZ, SIZE(8), 0);
	MATHB(ONE, SUBB, VSEQINSZ, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(ONE, SUBB, VSEQOUTSZ, VSEQINSZ, SIZE(2), 0);
	MATHB(ONE, SUBB, ABD, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(ONE, SUBB, OFIFO, VSEQINSZ, SIZE(2), 0);
	MATHB(ONE, SUBB, ONE, VSEQINSZ, SIZE(8), 0);
	MATHB(ONE, SUBB, ZERO, VSEQINSZ, SIZE(4), 0);
	/*SUBB Operation: VSEQOUTSZ Destination register */
	MATHB(MATH0, SUBB, MATH0, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(MATH0, SUBB, MATH1, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH0, SUBB, MATH2, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH0, SUBB, MATH3, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH0, SUBB, IMM(393615378), VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH0, SUBB, DPOVRD, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH0, SUBB, VSEQINSZ, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(MATH0, SUBB, VSEQOUTSZ, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH0, SUBB, ABD, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(MATH0, SUBB, OFIFO, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, SUBB, ONE, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(MATH0, SUBB, ZERO, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH1, SUBB, MATH0, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, SUBB, MATH1, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH1, SUBB, MATH2, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, SUBB, MATH3, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, SUBB, IMM(0x19261959fedcba01), VSEQOUTSZ, SIZE(8),
	      WITH(NFU));
	MATHB(MATH1, SUBB, DPOVRD, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH1, SUBB, VSEQINSZ, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH1, SUBB, VSEQOUTSZ, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH1, SUBB, ABD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, SUBB, OFIFO, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(MATH1, SUBB, ONE, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(MATH1, SUBB, ZERO, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, SUBB, MATH0, VSEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, SUBB, MATH1, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, SUBB, MATH2, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, SUBB, MATH3, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, SUBB, IMM(393615378), VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, SUBB, DPOVRD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, SUBB, VSEQINSZ, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, SUBB, VSEQOUTSZ, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, SUBB, ABD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH2, SUBB, OFIFO, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH2, SUBB, ONE, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH2, SUBB, ZERO, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, SUBB, MATH0, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, SUBB, MATH1, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, SUBB, MATH2, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(MATH3, SUBB, MATH3, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, SUBB, IMM(393615378), VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, SUBB, DPOVRD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH3, SUBB, VSEQINSZ, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, SUBB, VSEQOUTSZ, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH3, SUBB, ABD, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, SUBB, OFIFO, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH3, SUBB, ONE, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH3, SUBB, ZERO, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), SUBB, MATH0, VSEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(275128321), SUBB, MATH1, VSEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, MATH2, VSEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, MATH3, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), SUBB, IMM(393615378), VSEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(275128321), SUBB, DPOVRD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(275128321), SUBB, VSEQINSZ, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(IMM(0x19261959fedcba01), SUBB, VSEQOUTSZ, VSEQOUTSZ, SIZE(8), 0);
	MATHB(IMM(275128321), SUBB, ABD, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), SUBB, OFIFO, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), SUBB, ONE, VSEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(275128321), SUBB, ZERO, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(DPOVRD, SUBB, MATH0, VSEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, MATH1, VSEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, SUBB, MATH2, VSEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, MATH3, VSEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, IMM(0x19261959fedcba01), VSEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, DPOVRD, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, VSEQINSZ, VSEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, VSEQOUTSZ, VSEQOUTSZ, SIZE(4), 0);
	MATHB(DPOVRD, SUBB, ABD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(DPOVRD, SUBB, OFIFO, VSEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, ONE, VSEQOUTSZ, SIZE(4), 0);
	MATHB(DPOVRD, SUBB, ZERO, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, SUBB, MATH0, VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, MATH1, VSEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, MATH2, VSEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, MATH3, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, SUBB, IMM(393615378), VSEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, DPOVRD, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, SUBB, VSEQINSZ, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, VSEQOUTSZ, VSEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, ABD, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, SUBB, OFIFO, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, ONE, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, ZERO, VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, SUBB, MATH0, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, MATH1, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, SUBB, MATH2, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, SUBB, MATH3, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, SUBB, IMM(393615378), VSEQOUTSZ, SIZE(2),
	      WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, DPOVRD, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, VSEQINSZ, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(SEQOUTSZ, SUBB, VSEQOUTSZ, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, ABD, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, SUBB, OFIFO, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, ONE, VSEQOUTSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, ZERO, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(VSEQINSZ, SUBB, MATH0, VSEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, MATH1, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, MATH2, VSEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, MATH3, VSEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, SUBB, IMM(393615378), VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, SUBB, DPOVRD, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, SUBB, VSEQINSZ, VSEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, SUBB, VSEQOUTSZ, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, SUBB, ABD, VSEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, SUBB, OFIFO, VSEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, ONE, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, SUBB, ZERO, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, MATH0, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, MATH1, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, MATH2, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, MATH3, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, SUBB, IMM(393615378), VSEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, DPOVRD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, VSEQINSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, VSEQOUTSZ, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, SUBB, ABD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, SUBB, OFIFO, VSEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, SUBB, ONE, VSEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, ZERO, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, SUBB, MATH0, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, SUBB, MATH1, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, SUBB, MATH2, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, SUBB, MATH3, VSEQOUTSZ, SIZE(4), 0);
	MATHB(ZERO, SUBB, IMM(393615378), VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(ZERO, SUBB, DPOVRD, VSEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, SUBB, VSEQINSZ, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(ZERO, SUBB, VSEQOUTSZ, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, SUBB, ABD, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, SUBB, OFIFO, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(ZERO, SUBB, ONE, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, SUBB, ZERO, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(ONE, SUBB, MATH0, VSEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, SUBB, MATH1, VSEQOUTSZ, SIZE(8), 0);
	MATHB(ONE, SUBB, MATH2, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, SUBB, MATH3, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(ONE, SUBB, IMM(393615378), VSEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, SUBB, DPOVRD, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(ONE, SUBB, VSEQINSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(ONE, SUBB, VSEQOUTSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(ONE, SUBB, ABD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, SUBB, OFIFO, VSEQOUTSZ, SIZE(2), 0);
	MATHB(ONE, SUBB, ONE, VSEQOUTSZ, SIZE(8), 0);
	MATHB(ONE, SUBB, ZERO, VSEQOUTSZ, SIZE(8), WITH(STL));
	/*SUBB Operation: NONE Destination register */
	MATHB(MATH0, SUBB, MATH0, NONE, SIZE(4), 0);
	MATHB(MATH0, SUBB, MATH1, NONE, SIZE(1), 0);
	MATHB(MATH0, SUBB, MATH2, NONE, SIZE(1), WITH(NFU));
	MATHB(MATH0, SUBB, MATH3, NONE, SIZE(2), 0);
	MATHB(MATH0, SUBB, IMM(393615378), NONE, SIZE(2), 0);
	MATHB(MATH0, SUBB, DPOVRD, NONE, SIZE(1), 0);
	MATHB(MATH0, SUBB, VSEQINSZ, NONE, SIZE(4), 0);
	MATHB(MATH0, SUBB, VSEQOUTSZ, NONE, SIZE(2), 0);
	MATHB(MATH0, SUBB, ABD, NONE, SIZE(1), 0);
	MATHB(MATH0, SUBB, OFIFO, NONE, SIZE(4), 0);
	MATHB(MATH0, SUBB, ONE, NONE, SIZE(2), 0);
	MATHB(MATH0, SUBB, ZERO, NONE, SIZE(8), WITH(STL));
	MATHB(MATH1, SUBB, MATH0, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(MATH1, SUBB, MATH1, NONE, SIZE(2), WITH(NFU));
	MATHB(MATH1, SUBB, MATH2, NONE, SIZE(8), 0);
	MATHB(MATH1, SUBB, MATH3, NONE, SIZE(4), 0);
	MATHB(MATH1, SUBB, IMM(393615378), NONE, SIZE(4), WITH(NFU));
	MATHB(MATH1, SUBB, DPOVRD, NONE, SIZE(2), 0);
	MATHB(MATH1, SUBB, VSEQINSZ, NONE, SIZE(1), 0);
	MATHB(MATH1, SUBB, VSEQOUTSZ, NONE, SIZE(8), WITH(STL));
	MATHB(MATH1, SUBB, ABD, NONE, SIZE(1), 0);
	MATHB(MATH1, SUBB, OFIFO, NONE, SIZE(1), 0);
	MATHB(MATH1, SUBB, ONE, NONE, SIZE(8), 0);
	MATHB(MATH1, SUBB, ZERO, NONE, SIZE(2), 0);
	MATHB(MATH2, SUBB, MATH0, NONE, SIZE(2), 0);
	MATHB(MATH2, SUBB, MATH1, NONE, SIZE(8), 0);
	MATHB(MATH2, SUBB, MATH2, NONE, SIZE(2), WITH(NFU));
	MATHB(MATH2, SUBB, MATH3, NONE, SIZE(4), WITH(STL));
	MATHB(MATH2, SUBB, IMM(393615378), NONE, SIZE(4), 0);
	MATHB(MATH2, SUBB, DPOVRD, NONE, SIZE(2), 0);
	MATHB(MATH2, SUBB, VSEQINSZ, NONE, SIZE(1), 0);
	MATHB(MATH2, SUBB, VSEQOUTSZ, NONE, SIZE(4), WITH(NFU));
	MATHB(MATH2, SUBB, ABD, NONE, SIZE(8), 0);
	MATHB(MATH2, SUBB, OFIFO, NONE, SIZE(8), 0);
	MATHB(MATH2, SUBB, ONE, NONE, SIZE(1), WITH(STL));
	MATHB(MATH2, SUBB, ZERO, NONE, SIZE(8), 0);
	MATHB(MATH3, SUBB, MATH0, NONE, SIZE(1), WITH(NFU));
	MATHB(MATH3, SUBB, MATH1, NONE, SIZE(2), 0);
	MATHB(MATH3, SUBB, MATH2, NONE, SIZE(2), 0);
	MATHB(MATH3, SUBB, MATH3, NONE, SIZE(1), 0);
	MATHB(MATH3, SUBB, IMM(0x19261959fedcba01), NONE, SIZE(8), 0);
	MATHB(MATH3, SUBB, DPOVRD, NONE, SIZE(8), 0);
	MATHB(MATH3, SUBB, VSEQINSZ, NONE, SIZE(1), 0);
	MATHB(MATH3, SUBB, VSEQOUTSZ, NONE, SIZE(1), 0);
	MATHB(MATH3, SUBB, ABD, NONE, SIZE(4), 0);
	MATHB(MATH3, SUBB, OFIFO, NONE, SIZE(1), 0);
	MATHB(MATH3, SUBB, ONE, NONE, SIZE(4), 0);
	MATHB(MATH3, SUBB, ZERO, NONE, SIZE(8), WITH(NFU));
	MATHB(IMM(275128321), SUBB, MATH0, NONE, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), SUBB, MATH1, NONE, SIZE(4), 0);
	MATHB(IMM(0x19261959fedcba01), SUBB, MATH2, NONE, SIZE(8), 0);
	MATHB(IMM(275128321), SUBB, MATH3, NONE, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, IMM(393615378), NONE, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, DPOVRD, NONE, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), SUBB, VSEQINSZ, NONE, SIZE(2), 0);
	MATHB(IMM(275128321), SUBB, VSEQOUTSZ, NONE, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, ABD, NONE, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), SUBB, OFIFO, NONE, SIZE(1), 0);
	MATHB(IMM(275128321), SUBB, ONE, NONE, SIZE(4), 0);
	MATHB(IMM(275128321), SUBB, ZERO, NONE, SIZE(1), 0);
	MATHB(DPOVRD, SUBB, MATH0, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, MATH1, NONE, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, SUBB, MATH2, NONE, SIZE(4), 0);
	MATHB(DPOVRD, SUBB, MATH3, NONE, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, IMM(393615378), NONE, SIZE(4), WITH(STL));
	MATHB(DPOVRD, SUBB, DPOVRD, NONE, SIZE(4), 0);
	MATHB(DPOVRD, SUBB, VSEQINSZ, NONE, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, VSEQOUTSZ, NONE, SIZE(1), WITH(NFU));
	MATHB(DPOVRD, SUBB, ABD, NONE, SIZE(8), 0);
	MATHB(DPOVRD, SUBB, OFIFO, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, SUBB, ONE, NONE, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, SUBB, ZERO, NONE, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, SUBB, MATH0, NONE, SIZE(8), 0);
	MATHB(SEQINSZ, SUBB, MATH1, NONE, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, SUBB, MATH2, NONE, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, SUBB, MATH3, NONE, SIZE(4), 0);
	MATHB(SEQINSZ, SUBB, IMM(393615378), NONE, SIZE(1), 0);
	MATHB(SEQINSZ, SUBB, DPOVRD, NONE, SIZE(8), 0);
	MATHB(SEQINSZ, SUBB, VSEQINSZ, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, SUBB, VSEQOUTSZ, NONE, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, SUBB, ABD, NONE, SIZE(2), 0);
	MATHB(SEQINSZ, SUBB, OFIFO, NONE, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, SUBB, ONE, NONE, SIZE(4), 0);
	MATHB(SEQINSZ, SUBB, ZERO, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, MATH0, NONE, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, MATH1, NONE, SIZE(4), 0);
	MATHB(SEQOUTSZ, SUBB, MATH2, NONE, SIZE(4), 0);
	MATHB(SEQOUTSZ, SUBB, MATH3, NONE, SIZE(4), 0);
	MATHB(SEQOUTSZ, SUBB, IMM(393615378), NONE, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, DPOVRD, NONE, SIZE(4), 0);
	MATHB(SEQOUTSZ, SUBB, VSEQINSZ, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, SUBB, VSEQOUTSZ, NONE, SIZE(1), 0);
	MATHB(SEQOUTSZ, SUBB, ABD, NONE, SIZE(8), 0);
	MATHB(SEQOUTSZ, SUBB, OFIFO, NONE, SIZE(4), 0);
	MATHB(SEQOUTSZ, SUBB, ONE, NONE, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, SUBB, ZERO, NONE, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, MATH0, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, MATH1, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, SUBB, MATH2, NONE, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, MATH3, NONE, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, IMM(393615378), NONE, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, DPOVRD, NONE, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, VSEQINSZ, NONE, SIZE(1), 0);
	MATHB(VSEQINSZ, SUBB, VSEQOUTSZ, NONE, SIZE(2), 0);
	MATHB(VSEQINSZ, SUBB, ABD, NONE, SIZE(4), 0);
	MATHB(VSEQINSZ, SUBB, OFIFO, NONE, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, SUBB, ONE, NONE, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, SUBB, ZERO, NONE, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH0, NONE, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH1, NONE, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, MATH2, NONE, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, MATH3, NONE, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, IMM(393615378), NONE, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, DPOVRD, NONE, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, VSEQINSZ, NONE, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, VSEQOUTSZ, NONE, SIZE(1), 0);
	MATHB(VSEQOUTSZ, SUBB, ABD, NONE, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, SUBB, OFIFO, NONE, SIZE(8), 0);
	MATHB(VSEQOUTSZ, SUBB, ONE, NONE, SIZE(2), 0);
	MATHB(VSEQOUTSZ, SUBB, ZERO, NONE, SIZE(4), 0);
	MATHB(ZERO, SUBB, MATH0, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, SUBB, MATH1, NONE, SIZE(4), WITH(NFU));
	MATHB(ZERO, SUBB, MATH2, NONE, SIZE(1), WITH(NFU));
	MATHB(ZERO, SUBB, MATH3, NONE, SIZE(4), WITH(STL));
	MATHB(ZERO, SUBB, IMM(393615378), NONE, SIZE(4), WITH(NFU));
	MATHB(ZERO, SUBB, DPOVRD, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, SUBB, VSEQINSZ, NONE, SIZE(2), WITH(NFU));
	MATHB(ZERO, SUBB, VSEQOUTSZ, NONE, SIZE(1), 0);
	MATHB(ZERO, SUBB, ABD, NONE, SIZE(4), 0);
	MATHB(ZERO, SUBB, OFIFO, NONE, SIZE(8), 0);
	MATHB(ZERO, SUBB, ONE, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, SUBB, ZERO, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, SUBB, MATH0, NONE, SIZE(8), WITH(NFU));
	MATHB(ONE, SUBB, MATH1, NONE, SIZE(8), 0);
	MATHB(ONE, SUBB, MATH2, NONE, SIZE(2), 0);
	MATHB(ONE, SUBB, MATH3, NONE, SIZE(1), 0);
	MATHB(ONE, SUBB, IMM(393615378), NONE, SIZE(1), 0);
	MATHB(ONE, SUBB, DPOVRD, NONE, SIZE(2), WITH(NFU));
	MATHB(ONE, SUBB, VSEQINSZ, NONE, SIZE(4), 0);
	MATHB(ONE, SUBB, VSEQOUTSZ, NONE, SIZE(1), 0);
	MATHB(ONE, SUBB, ABD, NONE, SIZE(2), WITH(NFU));
	MATHB(ONE, SUBB, OFIFO, NONE, SIZE(4), 0);
	MATHB(ONE, SUBB, ONE, NONE, SIZE(8), 0);
	MATHB(ONE, SUBB, ZERO, NONE, SIZE(8), 0);
	/*OR Operation: MATH0 Destination register */
	MATHB(MATH0, OR, MATH0, MATH0, SIZE(8), 0);
	MATHB(MATH0, OR, MATH1, MATH0, SIZE(2), 0);
	MATHB(MATH0, OR, MATH2, MATH0, SIZE(1), 0);
	MATHB(MATH0, OR, MATH3, MATH0, SIZE(1), WITH(STL));
	MATHB(MATH0, OR, IMM(393615378), MATH0, SIZE(2), 0);
	MATHB(MATH0, OR, DPOVRD, MATH0, SIZE(1), 0);
	MATHB(MATH0, OR, VSEQINSZ, MATH0, SIZE(4), WITH(STL));
	MATHB(MATH0, OR, VSEQOUTSZ, MATH0, SIZE(2), 0);
	MATHB(MATH0, OR, ABD, MATH0, SIZE(2), WITH(NFU));
	MATHB(MATH0, OR, OFIFO, MATH0, SIZE(4), WITH(STL));
	MATHB(MATH0, OR, ONE, MATH0, SIZE(8), 0);
	MATHB(MATH0, OR, ZERO, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, OR, MATH0, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, OR, MATH1, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, OR, MATH2, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, OR, MATH3, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, OR, IMM(393615378), MATH0, SIZE(2), WITH(STL));
	MATHB(MATH1, OR, DPOVRD, MATH0, SIZE(1), 0);
	MATHB(MATH1, OR, VSEQINSZ, MATH0, SIZE(8), WITH(NFU | STL));
	MATHB(MATH1, OR, VSEQOUTSZ, MATH0, SIZE(2), 0);
	MATHB(MATH1, OR, ABD, MATH0, SIZE(2), WITH(NFU));
	MATHB(MATH1, OR, OFIFO, MATH0, SIZE(8), 0);
	MATHB(MATH1, OR, ONE, MATH0, SIZE(2), 0);
	MATHB(MATH1, OR, ZERO, MATH0, SIZE(1), 0);
	MATHB(MATH2, OR, MATH0, MATH0, SIZE(4), 0);
	MATHB(MATH2, OR, MATH1, MATH0, SIZE(2), 0);
	MATHB(MATH2, OR, MATH2, MATH0, SIZE(1), 0);
	MATHB(MATH2, OR, MATH3, MATH0, SIZE(4), 0);
	MATHB(MATH2, OR, IMM(393615378), MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, OR, DPOVRD, MATH0, SIZE(2), 0);
	MATHB(MATH2, OR, VSEQINSZ, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, OR, VSEQOUTSZ, MATH0, SIZE(2), 0);
	MATHB(MATH2, OR, ABD, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, OR, OFIFO, MATH0, SIZE(8), 0);
	MATHB(MATH2, OR, ONE, MATH0, SIZE(1), WITH(NFU));
	MATHB(MATH2, OR, ZERO, MATH0, SIZE(4), 0);
	MATHB(MATH3, OR, MATH0, MATH0, SIZE(4), 0);
	MATHB(MATH3, OR, MATH1, MATH0, SIZE(2), 0);
	MATHB(MATH3, OR, MATH2, MATH0, SIZE(1), 0);
	MATHB(MATH3, OR, MATH3, MATH0, SIZE(2), WITH(NFU));
	MATHB(MATH3, OR, IMM(393615378), MATH0, SIZE(8), WITH(IFB | STL));
	MATHB(MATH3, OR, DPOVRD, MATH0, SIZE(4), 0);
	MATHB(MATH3, OR, VSEQINSZ, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, OR, VSEQOUTSZ, MATH0, SIZE(4), 0);
	MATHB(MATH3, OR, ABD, MATH0, SIZE(8), 0);
	MATHB(MATH3, OR, OFIFO, MATH0, SIZE(8), WITH(STL));
	MATHB(MATH3, OR, ONE, MATH0, SIZE(4), 0);
	MATHB(MATH3, OR, ZERO, MATH0, SIZE(1), 0);
	MATHB(IMM(275128321), OR, MATH0, MATH0, SIZE(2), WITH(STL));
	MATHB(IMM(0x19261959fedcba01), OR, MATH1, MATH0, SIZE(8), 0);
	MATHB(IMM(275128321), OR, MATH2, MATH0, SIZE(2), 0);
	MATHB(IMM(275128321), OR, MATH3, MATH0, SIZE(2), WITH(STL));
	MATHB(IMM(275128321), OR, IMM(393615378), MATH0, SIZE(2), 0);
	MATHB(IMM(275128321), OR, DPOVRD, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(0x19261959fedcba01), OR, VSEQINSZ, MATH0, SIZE(8), 0);
	MATHB(IMM(275128321), OR, VSEQOUTSZ, MATH0, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), OR, ABD, MATH0, SIZE(2), WITH(STL));
	MATHB(IMM(275128321), OR, OFIFO, MATH0, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), OR, ONE, MATH0, SIZE(2), WITH(NFU));
	MATHB(IMM(275128321), OR, ZERO, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, OR, MATH0, MATH0, SIZE(1), 0);
	MATHB(DPOVRD, OR, MATH1, MATH0, SIZE(2), 0);
	MATHB(DPOVRD, OR, MATH2, MATH0, SIZE(2), WITH(STL));
	MATHB(DPOVRD, OR, MATH3, MATH0, SIZE(1), WITH(NFU));
	MATHB(DPOVRD, OR, IMM(393615378), MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, OR, DPOVRD, MATH0, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, OR, VSEQINSZ, MATH0, SIZE(8), 0);
	MATHB(DPOVRD, OR, VSEQOUTSZ, MATH0, SIZE(4), 0);
	MATHB(DPOVRD, OR, ABD, MATH0, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, OR, OFIFO, MATH0, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, OR, ONE, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, OR, ZERO, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, OR, MATH0, MATH0, SIZE(1), 0);
	MATHB(SEQINSZ, OR, MATH1, MATH0, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, OR, MATH2, MATH0, SIZE(8), 0);
	MATHB(SEQINSZ, OR, MATH3, MATH0, SIZE(2), 0);
	MATHB(SEQINSZ, OR, IMM(393615378), MATH0, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, OR, DPOVRD, MATH0, SIZE(2), 0);
	MATHB(SEQINSZ, OR, VSEQINSZ, MATH0, SIZE(4), 0);
	MATHB(SEQINSZ, OR, VSEQOUTSZ, MATH0, SIZE(8), 0);
	MATHB(SEQINSZ, OR, ABD, MATH0, SIZE(4), 0);
	MATHB(SEQINSZ, OR, OFIFO, MATH0, SIZE(1), 0);
	MATHB(SEQINSZ, OR, ONE, MATH0, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, OR, ZERO, MATH0, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, OR, MATH0, MATH0, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, OR, MATH1, MATH0, SIZE(2), 0);
	MATHB(SEQOUTSZ, OR, MATH2, MATH0, SIZE(1), 0);
	MATHB(SEQOUTSZ, OR, MATH3, MATH0, SIZE(4), 0);
	MATHB(SEQOUTSZ, OR, IMM(393615378), MATH0, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, OR, DPOVRD, MATH0, SIZE(2), 0);
	MATHB(SEQOUTSZ, OR, VSEQINSZ, MATH0, SIZE(8), 0);
	MATHB(SEQOUTSZ, OR, VSEQOUTSZ, MATH0, SIZE(1), 0);
	MATHB(SEQOUTSZ, OR, ABD, MATH0, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, OR, OFIFO, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, OR, ONE, MATH0, SIZE(2), 0);
	MATHB(SEQOUTSZ, OR, ZERO, MATH0, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, OR, MATH0, MATH0, SIZE(1), 0);
	MATHB(VSEQINSZ, OR, MATH1, MATH0, SIZE(1), 0);
	MATHB(VSEQINSZ, OR, MATH2, MATH0, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, OR, MATH3, MATH0, SIZE(4), 0);
	MATHB(VSEQINSZ, OR, IMM(393615378), MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQINSZ, OR, DPOVRD, MATH0, SIZE(1), 0);
	MATHB(VSEQINSZ, OR, VSEQINSZ, MATH0, SIZE(2), 0);
	MATHB(VSEQINSZ, OR, VSEQOUTSZ, MATH0, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, OR, ABD, MATH0, SIZE(1), 0);
	MATHB(VSEQINSZ, OR, OFIFO, MATH0, SIZE(4), 0);
	MATHB(VSEQINSZ, OR, ONE, MATH0, SIZE(8), 0);
	MATHB(VSEQINSZ, OR, ZERO, MATH0, SIZE(2), 0);
	MATHB(VSEQOUTSZ, OR, MATH0, MATH0, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, OR, MATH1, MATH0, SIZE(1), 0);
	MATHB(VSEQOUTSZ, OR, MATH2, MATH0, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, OR, MATH3, MATH0, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, OR, IMM(393615378), MATH0, SIZE(2), 0);
	MATHB(VSEQOUTSZ, OR, DPOVRD, MATH0, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, OR, VSEQINSZ, MATH0, SIZE(8), 0);
	MATHB(VSEQOUTSZ, OR, VSEQOUTSZ, MATH0, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, OR, ABD, MATH0, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, OR, OFIFO, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, OR, ONE, MATH0, SIZE(4), 0);
	MATHB(VSEQOUTSZ, OR, ZERO, MATH0, SIZE(2), 0);
	MATHB(ZERO, OR, MATH0, MATH0, SIZE(4), WITH(STL));
	MATHB(ZERO, OR, MATH1, MATH0, SIZE(8), WITH(NFU));
	MATHB(ZERO, OR, MATH2, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, OR, MATH3, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, OR, IMM(393615378), MATH0, SIZE(8), WITH(IFB | NFU | STL));
	MATHB(ZERO, OR, DPOVRD, MATH0, SIZE(2), 0);
	MATHB(ZERO, OR, VSEQINSZ, MATH0, SIZE(2), 0);
	MATHB(ZERO, OR, VSEQOUTSZ, MATH0, SIZE(1), 0);
	MATHB(ZERO, OR, ABD, MATH0, SIZE(4), 0);
	MATHB(ZERO, OR, OFIFO, MATH0, SIZE(2), 0);
	MATHB(ZERO, OR, ONE, MATH0, SIZE(8), 0);
	MATHB(ZERO, OR, ZERO, MATH0, SIZE(8), WITH(STL));
	MATHB(ONE, OR, MATH0, MATH0, SIZE(4), 0);
	MATHB(ONE, OR, MATH1, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, OR, MATH2, MATH0, SIZE(4), 0);
	MATHB(ONE, OR, MATH3, MATH0, SIZE(2), 0);
	MATHB(ONE, OR, IMM(393615378), MATH0, SIZE(2), WITH(STL));
	MATHB(ONE, OR, DPOVRD, MATH0, SIZE(8), WITH(STL));
	MATHB(ONE, OR, VSEQINSZ, MATH0, SIZE(1), WITH(NFU));
	MATHB(ONE, OR, VSEQOUTSZ, MATH0, SIZE(1), 0);
	MATHB(ONE, OR, ABD, MATH0, SIZE(4), 0);
	MATHB(ONE, OR, OFIFO, MATH0, SIZE(4), WITH(STL));
	MATHB(ONE, OR, ONE, MATH0, SIZE(1), 0);
	MATHB(ONE, OR, ZERO, MATH0, SIZE(4), WITH(STL));
	/*OR Operation: MATH1 Destination register */
	MATHB(MATH0, OR, MATH0, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, OR, MATH1, MATH1, SIZE(8), 0);
	MATHB(MATH0, OR, MATH2, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, OR, MATH3, MATH1, SIZE(8), WITH(STL));
	MATHB(MATH0, OR, IMM(393615378), MATH1, SIZE(2), WITH(NFU));
	MATHB(MATH0, OR, DPOVRD, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, OR, VSEQINSZ, MATH1, SIZE(1), 0);
	MATHB(MATH0, OR, VSEQOUTSZ, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, OR, ABD, MATH1, SIZE(8), 0);
	MATHB(MATH0, OR, OFIFO, MATH1, SIZE(4), 0);
	MATHB(MATH0, OR, ONE, MATH1, SIZE(2), 0);
	MATHB(MATH0, OR, ZERO, MATH1, SIZE(1), 0);
	MATHB(MATH1, OR, MATH0, MATH1, SIZE(4), WITH(NFU));
	MATHB(MATH1, OR, MATH1, MATH1, SIZE(4), 0);
	MATHB(MATH1, OR, MATH2, MATH1, SIZE(8), 0);
	MATHB(MATH1, OR, MATH3, MATH1, SIZE(1), WITH(STL));
	MATHB(MATH1, OR, IMM(393615378), MATH1, SIZE(1), WITH(NFU));
	MATHB(MATH1, OR, DPOVRD, MATH1, SIZE(8), 0);
	MATHB(MATH1, OR, VSEQINSZ, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, OR, VSEQOUTSZ, MATH1, SIZE(4), 0);
	MATHB(MATH1, OR, ABD, MATH1, SIZE(4), 0);
	MATHB(MATH1, OR, OFIFO, MATH1, SIZE(1), 0);
	MATHB(MATH1, OR, ONE, MATH1, SIZE(4), 0);
	MATHB(MATH1, OR, ZERO, MATH1, SIZE(8), WITH(STL));
	MATHB(MATH2, OR, MATH0, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, OR, MATH1, MATH1, SIZE(8), 0);
	MATHB(MATH2, OR, MATH2, MATH1, SIZE(1), 0);
	MATHB(MATH2, OR, MATH3, MATH1, SIZE(1), 0);
	MATHB(MATH2, OR, IMM(393615378), MATH1, SIZE(1), 0);
	MATHB(MATH2, OR, DPOVRD, MATH1, SIZE(4), WITH(STL));
	MATHB(MATH2, OR, VSEQINSZ, MATH1, SIZE(2), 0);
	MATHB(MATH2, OR, VSEQOUTSZ, MATH1, SIZE(1), 0);
	MATHB(MATH2, OR, ABD, MATH1, SIZE(8), 0);
	MATHB(MATH2, OR, OFIFO, MATH1, SIZE(8), 0);
	MATHB(MATH2, OR, ONE, MATH1, SIZE(1), 0);
	MATHB(MATH2, OR, ZERO, MATH1, SIZE(8), 0);
	MATHB(MATH3, OR, MATH0, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, OR, MATH1, MATH1, SIZE(2), 0);
	MATHB(MATH3, OR, MATH2, MATH1, SIZE(1), 0);
	MATHB(MATH3, OR, MATH3, MATH1, SIZE(1), 0);
	MATHB(MATH3, OR, IMM(393615378), MATH1, SIZE(4), 0);
	MATHB(MATH3, OR, DPOVRD, MATH1, SIZE(8), WITH(STL));
	MATHB(MATH3, OR, VSEQINSZ, MATH1, SIZE(1), 0);
	MATHB(MATH3, OR, VSEQOUTSZ, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, OR, ABD, MATH1, SIZE(2), WITH(STL));
	MATHB(MATH3, OR, OFIFO, MATH1, SIZE(1), WITH(STL));
	MATHB(MATH3, OR, ONE, MATH1, SIZE(1), 0);
	MATHB(MATH3, OR, ZERO, MATH1, SIZE(8), WITH(NFU));
	MATHB(IMM(275128321), OR, MATH0, MATH1, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), OR, MATH1, MATH1, SIZE(8), WITH(IFB));
	MATHB(IMM(0x19261959fedcba01), OR, MATH2, MATH1, SIZE(8), 0);
	MATHB(IMM(275128321), OR, MATH3, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), OR, IMM(393615378), MATH1, SIZE(2),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), OR, DPOVRD, MATH1, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), OR, VSEQINSZ, MATH1, SIZE(8), WITH(IFB | NFU));
	MATHB(IMM(275128321), OR, VSEQOUTSZ, MATH1, SIZE(1), 0);
	MATHB(IMM(275128321), OR, ABD, MATH1, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), OR, OFIFO, MATH1, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), OR, ONE, MATH1, SIZE(4), 0);
	MATHB(IMM(275128321), OR, ZERO, MATH1, SIZE(8), WITH(IFB));
	MATHB(DPOVRD, OR, MATH0, MATH1, SIZE(2), 0);
	MATHB(DPOVRD, OR, MATH1, MATH1, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, OR, MATH2, MATH1, SIZE(4), 0);
	MATHB(DPOVRD, OR, MATH3, MATH1, SIZE(8), WITH(STL));
	MATHB(DPOVRD, OR, IMM(393615378), MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, OR, DPOVRD, MATH1, SIZE(1), 0);
	MATHB(DPOVRD, OR, VSEQINSZ, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, OR, VSEQOUTSZ, MATH1, SIZE(1), 0);
	MATHB(DPOVRD, OR, ABD, MATH1, SIZE(8), 0);
	MATHB(DPOVRD, OR, OFIFO, MATH1, SIZE(1), WITH(STL));
	MATHB(DPOVRD, OR, ONE, MATH1, SIZE(2), 0);
	MATHB(DPOVRD, OR, ZERO, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, OR, MATH0, MATH1, SIZE(8), 0);
	MATHB(SEQINSZ, OR, MATH1, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, OR, MATH2, MATH1, SIZE(4), 0);
	MATHB(SEQINSZ, OR, MATH3, MATH1, SIZE(2), 0);
	MATHB(SEQINSZ, OR, IMM(393615378), MATH1, SIZE(1), 0);
	MATHB(SEQINSZ, OR, DPOVRD, MATH1, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, OR, VSEQINSZ, MATH1, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, OR, VSEQOUTSZ, MATH1, SIZE(4), 0);
	MATHB(SEQINSZ, OR, ABD, MATH1, SIZE(2), 0);
	MATHB(SEQINSZ, OR, OFIFO, MATH1, SIZE(2), 0);
	MATHB(SEQINSZ, OR, ONE, MATH1, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, OR, ZERO, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, OR, MATH0, MATH1, SIZE(8), WITH(NFU));
	MATHB(SEQOUTSZ, OR, MATH1, MATH1, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, OR, MATH2, MATH1, SIZE(2), 0);
	MATHB(SEQOUTSZ, OR, MATH3, MATH1, SIZE(4), 0);
	MATHB(SEQOUTSZ, OR, IMM(393615378), MATH1, SIZE(4), 0);
	MATHB(SEQOUTSZ, OR, DPOVRD, MATH1, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, OR, VSEQINSZ, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, OR, VSEQOUTSZ, MATH1, SIZE(8), 0);
	MATHB(SEQOUTSZ, OR, ABD, MATH1, SIZE(2), 0);
	MATHB(SEQOUTSZ, OR, OFIFO, MATH1, SIZE(8), 0);
	MATHB(SEQOUTSZ, OR, ONE, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(SEQOUTSZ, OR, ZERO, MATH1, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, OR, MATH0, MATH1, SIZE(1), 0);
	MATHB(VSEQINSZ, OR, MATH1, MATH1, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, OR, MATH2, MATH1, SIZE(4), 0);
	MATHB(VSEQINSZ, OR, MATH3, MATH1, SIZE(4), 0);
	MATHB(VSEQINSZ, OR, IMM(0x19261959fedcba01), MATH1, SIZE(8), 0);
	MATHB(VSEQINSZ, OR, DPOVRD, MATH1, SIZE(4), 0);
	MATHB(VSEQINSZ, OR, VSEQINSZ, MATH1, SIZE(4), 0);
	MATHB(VSEQINSZ, OR, VSEQOUTSZ, MATH1, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, OR, ABD, MATH1, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, OR, OFIFO, MATH1, SIZE(8), 0);
	MATHB(VSEQINSZ, OR, ONE, MATH1, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, OR, ZERO, MATH1, SIZE(1), 0);
	MATHB(VSEQOUTSZ, OR, MATH0, MATH1, SIZE(1), 0);
	MATHB(VSEQOUTSZ, OR, MATH1, MATH1, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, OR, MATH2, MATH1, SIZE(4), 0);
	MATHB(VSEQOUTSZ, OR, MATH3, MATH1, SIZE(2), 0);
	MATHB(VSEQOUTSZ, OR, IMM(393615378), MATH1, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, OR, DPOVRD, MATH1, SIZE(8), 0);
	MATHB(VSEQOUTSZ, OR, VSEQINSZ, MATH1, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, OR, VSEQOUTSZ, MATH1, SIZE(1), 0);
	MATHB(VSEQOUTSZ, OR, ABD, MATH1, SIZE(1), 0);
	MATHB(VSEQOUTSZ, OR, OFIFO, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, OR, ONE, MATH1, SIZE(1), 0);
	MATHB(VSEQOUTSZ, OR, ZERO, MATH1, SIZE(1), WITH(STL));
	MATHB(ZERO, OR, MATH0, MATH1, SIZE(4), WITH(NFU));
	MATHB(ZERO, OR, MATH1, MATH1, SIZE(4), 0);
	MATHB(ZERO, OR, MATH2, MATH1, SIZE(4), WITH(NFU));
	MATHB(ZERO, OR, MATH3, MATH1, SIZE(4), 0);
	MATHB(ZERO, OR, IMM(393615378), MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, OR, DPOVRD, MATH1, SIZE(8), 0);
	MATHB(ZERO, OR, VSEQINSZ, MATH1, SIZE(8), 0);
	MATHB(ZERO, OR, VSEQOUTSZ, MATH1, SIZE(4), WITH(NFU));
	MATHB(ZERO, OR, ABD, MATH1, SIZE(1), WITH(STL));
	MATHB(ZERO, OR, OFIFO, MATH1, SIZE(4), 0);
	MATHB(ZERO, OR, ONE, MATH1, SIZE(8), 0);
	MATHB(ZERO, OR, ZERO, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, OR, MATH0, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, OR, MATH1, MATH1, SIZE(4), 0);
	MATHB(ONE, OR, MATH2, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, OR, MATH3, MATH1, SIZE(8), 0);
	MATHB(ONE, OR, IMM(393615378), MATH1, SIZE(1), 0);
	MATHB(ONE, OR, DPOVRD, MATH1, SIZE(4), WITH(STL));
	MATHB(ONE, OR, VSEQINSZ, MATH1, SIZE(4), 0);
	MATHB(ONE, OR, VSEQOUTSZ, MATH1, SIZE(1), 0);
	MATHB(ONE, OR, ABD, MATH1, SIZE(4), WITH(NFU));
	MATHB(ONE, OR, OFIFO, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, OR, ONE, MATH1, SIZE(1), 0);
	MATHB(ONE, OR, ZERO, MATH1, SIZE(2), WITH(NFU));
	/*OR Operation: MATH2 Destination register */
	MATHB(MATH0, OR, MATH0, MATH2, SIZE(8), 0);
	MATHB(MATH0, OR, MATH1, MATH2, SIZE(4), 0);
	MATHB(MATH0, OR, MATH2, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, OR, MATH3, MATH2, SIZE(4), WITH(NFU));
	MATHB(MATH0, OR, IMM(0x19261959fedcba01), MATH2, SIZE(8), 0);
	MATHB(MATH0, OR, DPOVRD, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, OR, VSEQINSZ, MATH2, SIZE(1), WITH(STL));
	MATHB(MATH0, OR, VSEQOUTSZ, MATH2, SIZE(4), 0);
	MATHB(MATH0, OR, ABD, MATH2, SIZE(4), 0);
	MATHB(MATH0, OR, OFIFO, MATH2, SIZE(4), 0);
	MATHB(MATH0, OR, ONE, MATH2, SIZE(8), WITH(NFU));
	MATHB(MATH0, OR, ZERO, MATH2, SIZE(1), 0);
	MATHB(MATH1, OR, MATH0, MATH2, SIZE(2), WITH(NFU));
	MATHB(MATH1, OR, MATH1, MATH2, SIZE(1), 0);
	MATHB(MATH1, OR, MATH2, MATH2, SIZE(2), WITH(NFU));
	MATHB(MATH1, OR, MATH3, MATH2, SIZE(4), 0);
	MATHB(MATH1, OR, IMM(0x19261959fedcba01), MATH2, SIZE(8), WITH(STL));
	MATHB(MATH1, OR, DPOVRD, MATH2, SIZE(1), WITH(STL));
	MATHB(MATH1, OR, VSEQINSZ, MATH2, SIZE(1), 0);
	MATHB(MATH1, OR, VSEQOUTSZ, MATH2, SIZE(1), WITH(STL));
	MATHB(MATH1, OR, ABD, MATH2, SIZE(4), 0);
	MATHB(MATH1, OR, OFIFO, MATH2, SIZE(2), WITH(NFU));
	MATHB(MATH1, OR, ONE, MATH2, SIZE(4), 0);
	MATHB(MATH1, OR, ZERO, MATH2, SIZE(2), WITH(NFU));
	MATHB(MATH2, OR, MATH0, MATH2, SIZE(4), 0);
	MATHB(MATH2, OR, MATH1, MATH2, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, OR, MATH2, MATH2, SIZE(8), 0);
	MATHB(MATH2, OR, MATH3, MATH2, SIZE(8), 0);
	MATHB(MATH2, OR, IMM(0x19261959fedcba01), MATH2, SIZE(8), 0);
	MATHB(MATH2, OR, DPOVRD, MATH2, SIZE(4), 0);
	MATHB(MATH2, OR, VSEQINSZ, MATH2, SIZE(1), 0);
	MATHB(MATH2, OR, VSEQOUTSZ, MATH2, SIZE(4), WITH(NFU));
	MATHB(MATH2, OR, ABD, MATH2, SIZE(8), 0);
	MATHB(MATH2, OR, OFIFO, MATH2, SIZE(8), 0);
	MATHB(MATH2, OR, ONE, MATH2, SIZE(4), 0);
	MATHB(MATH2, OR, ZERO, MATH2, SIZE(8), 0);
	MATHB(MATH3, OR, MATH0, MATH2, SIZE(1), WITH(NFU));
	MATHB(MATH3, OR, MATH1, MATH2, SIZE(4), 0);
	MATHB(MATH3, OR, MATH2, MATH2, SIZE(1), 0);
	MATHB(MATH3, OR, MATH3, MATH2, SIZE(4), 0);
	MATHB(MATH3, OR, IMM(393615378), MATH2, SIZE(8), WITH(IFB));
	MATHB(MATH3, OR, DPOVRD, MATH2, SIZE(8), 0);
	MATHB(MATH3, OR, VSEQINSZ, MATH2, SIZE(8), 0);
	MATHB(MATH3, OR, VSEQOUTSZ, MATH2, SIZE(2), 0);
	MATHB(MATH3, OR, ABD, MATH2, SIZE(1), 0);
	MATHB(MATH3, OR, OFIFO, MATH2, SIZE(1), 0);
	MATHB(MATH3, OR, ONE, MATH2, SIZE(1), 0);
	MATHB(MATH3, OR, ZERO, MATH2, SIZE(2), WITH(STL));
	MATHB(IMM(275128321), OR, MATH0, MATH2, SIZE(1), 0);
	MATHB(IMM(275128321), OR, MATH1, MATH2, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), OR, MATH2, MATH2, SIZE(4), 0);
	MATHB(IMM(275128321), OR, MATH3, MATH2, SIZE(1), 0);
	MATHB(IMM(275128321), OR, IMM(393615378), MATH2, SIZE(2), 0);
	MATHB(IMM(275128321), OR, DPOVRD, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), OR, VSEQINSZ, MATH2, SIZE(8), WITH(IFB));
	MATHB(IMM(0x19261959fedcba01), OR, VSEQOUTSZ, MATH2, SIZE(8), 0);
	MATHB(IMM(275128321), OR, ABD, MATH2, SIZE(4), 0);
	MATHB(IMM(275128321), OR, OFIFO, MATH2, SIZE(1), 0);
	MATHB(IMM(275128321), OR, ONE, MATH2, SIZE(2), 0);
	MATHB(IMM(0x19261959fedcba01), OR, ZERO, MATH2, SIZE(8), WITH(STL));
	MATHB(DPOVRD, OR, MATH0, MATH2, SIZE(8), WITH(STL));
	MATHB(DPOVRD, OR, MATH1, MATH2, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, OR, MATH2, MATH2, SIZE(2), 0);
	MATHB(DPOVRD, OR, MATH3, MATH2, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, OR, IMM(393615378), MATH2, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, OR, DPOVRD, MATH2, SIZE(1), 0);
	MATHB(DPOVRD, OR, VSEQINSZ, MATH2, SIZE(2), 0);
	MATHB(DPOVRD, OR, VSEQOUTSZ, MATH2, SIZE(2), 0);
	MATHB(DPOVRD, OR, ABD, MATH2, SIZE(4), 0);
	MATHB(DPOVRD, OR, OFIFO, MATH2, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, OR, ONE, MATH2, SIZE(8), 0);
	MATHB(DPOVRD, OR, ZERO, MATH2, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, OR, MATH0, MATH2, SIZE(2), 0);
	MATHB(SEQINSZ, OR, MATH1, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, OR, MATH2, MATH2, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, OR, MATH3, MATH2, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, OR, IMM(393615378), MATH2, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, OR, DPOVRD, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, OR, VSEQINSZ, MATH2, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, OR, VSEQOUTSZ, MATH2, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, OR, ABD, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, OR, OFIFO, MATH2, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, OR, ONE, MATH2, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, OR, ZERO, MATH2, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, OR, MATH0, MATH2, SIZE(4), 0);
	MATHB(SEQOUTSZ, OR, MATH1, MATH2, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, OR, MATH2, MATH2, SIZE(4), 0);
	MATHB(SEQOUTSZ, OR, MATH3, MATH2, SIZE(8), 0);
	MATHB(SEQOUTSZ, OR, IMM(393615378), MATH2, SIZE(8), WITH(IFB | NFU));
	MATHB(SEQOUTSZ, OR, DPOVRD, MATH2, SIZE(8), WITH(NFU));
	MATHB(SEQOUTSZ, OR, VSEQINSZ, MATH2, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, OR, VSEQOUTSZ, MATH2, SIZE(8), 0);
	MATHB(SEQOUTSZ, OR, ABD, MATH2, SIZE(4), 0);
	MATHB(SEQOUTSZ, OR, OFIFO, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, OR, ONE, MATH2, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, OR, ZERO, MATH2, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, OR, MATH0, MATH2, SIZE(2), 0);
	MATHB(VSEQINSZ, OR, MATH1, MATH2, SIZE(8), 0);
	MATHB(VSEQINSZ, OR, MATH2, MATH2, SIZE(8), 0);
	MATHB(VSEQINSZ, OR, MATH3, MATH2, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, OR, IMM(393615378), MATH2, SIZE(1), 0);
	MATHB(VSEQINSZ, OR, DPOVRD, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, OR, VSEQINSZ, MATH2, SIZE(4), 0);
	MATHB(VSEQINSZ, OR, VSEQOUTSZ, MATH2, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, OR, ABD, MATH2, SIZE(4), WITH(STL));
	MATHB(VSEQINSZ, OR, OFIFO, MATH2, SIZE(2), 0);
	MATHB(VSEQINSZ, OR, ONE, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, OR, ZERO, MATH2, SIZE(2), 0);
	MATHB(VSEQOUTSZ, OR, MATH0, MATH2, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, OR, MATH1, MATH2, SIZE(1), 0);
	MATHB(VSEQOUTSZ, OR, MATH2, MATH2, SIZE(8), 0);
	MATHB(VSEQOUTSZ, OR, MATH3, MATH2, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, OR, IMM(393615378), MATH2, SIZE(4), 0);
	MATHB(VSEQOUTSZ, OR, DPOVRD, MATH2, SIZE(2), 0);
	MATHB(VSEQOUTSZ, OR, VSEQINSZ, MATH2, SIZE(2), 0);
	MATHB(VSEQOUTSZ, OR, VSEQOUTSZ, MATH2, SIZE(4), 0);
	MATHB(VSEQOUTSZ, OR, ABD, MATH2, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, OR, OFIFO, MATH2, SIZE(8), 0);
	MATHB(VSEQOUTSZ, OR, ONE, MATH2, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, OR, ZERO, MATH2, SIZE(2), WITH(NFU));
	MATHB(ZERO, OR, MATH0, MATH2, SIZE(1), 0);
	MATHB(ZERO, OR, MATH1, MATH2, SIZE(8), 0);
	MATHB(ZERO, OR, MATH2, MATH2, SIZE(1), 0);
	MATHB(ZERO, OR, MATH3, MATH2, SIZE(2), 0);
	MATHB(ZERO, OR, IMM(393615378), MATH2, SIZE(1), WITH(NFU));
	MATHB(ZERO, OR, DPOVRD, MATH2, SIZE(8), WITH(NFU));
	MATHB(ZERO, OR, VSEQINSZ, MATH2, SIZE(8), 0);
	MATHB(ZERO, OR, VSEQOUTSZ, MATH2, SIZE(8), 0);
	MATHB(ZERO, OR, ABD, MATH2, SIZE(8), 0);
	MATHB(ZERO, OR, OFIFO, MATH2, SIZE(1), WITH(STL));
	MATHB(ZERO, OR, ONE, MATH2, SIZE(1), 0);
	MATHB(ZERO, OR, ZERO, MATH2, SIZE(1), 0);
	MATHB(ONE, OR, MATH0, MATH2, SIZE(4), 0);
	MATHB(ONE, OR, MATH1, MATH2, SIZE(1), 0);
	MATHB(ONE, OR, MATH2, MATH2, SIZE(2), WITH(NFU));
	MATHB(ONE, OR, MATH3, MATH2, SIZE(1), WITH(NFU));
	MATHB(ONE, OR, IMM(0x19261959fedcba01), MATH2, SIZE(8), 0);
	MATHB(ONE, OR, DPOVRD, MATH2, SIZE(8), 0);
	MATHB(ONE, OR, VSEQINSZ, MATH2, SIZE(2), 0);
	MATHB(ONE, OR, VSEQOUTSZ, MATH2, SIZE(8), 0);
	MATHB(ONE, OR, ABD, MATH2, SIZE(1), 0);
	MATHB(ONE, OR, OFIFO, MATH2, SIZE(2), 0);
	MATHB(ONE, OR, ONE, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, OR, ZERO, MATH2, SIZE(4), WITH(NFU));
	/*OR Operation: MATH3 Destination register */
	MATHB(MATH0, OR, MATH0, MATH3, SIZE(1), 0);
	MATHB(MATH0, OR, MATH1, MATH3, SIZE(2), 0);
	MATHB(MATH0, OR, MATH2, MATH3, SIZE(4), WITH(STL));
	MATHB(MATH0, OR, MATH3, MATH3, SIZE(2), 0);
	MATHB(MATH0, OR, IMM(0x19261959fedcba01), MATH3, SIZE(8),
	      WITH(NFU | STL));
	MATHB(MATH0, OR, DPOVRD, MATH3, SIZE(8), 0);
	MATHB(MATH0, OR, VSEQINSZ, MATH3, SIZE(2), 0);
	MATHB(MATH0, OR, VSEQOUTSZ, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, OR, ABD, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, OR, OFIFO, MATH3, SIZE(1), WITH(NFU));
	MATHB(MATH0, OR, ONE, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, OR, ZERO, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, OR, MATH0, MATH3, SIZE(2), 0);
	MATHB(MATH1, OR, MATH1, MATH3, SIZE(8), 0);
	MATHB(MATH1, OR, MATH2, MATH3, SIZE(8), 0);
	MATHB(MATH1, OR, MATH3, MATH3, SIZE(1), 0);
	MATHB(MATH1, OR, IMM(393615378), MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, OR, DPOVRD, MATH3, SIZE(1), WITH(STL));
	MATHB(MATH1, OR, VSEQINSZ, MATH3, SIZE(4), 0);
	MATHB(MATH1, OR, VSEQOUTSZ, MATH3, SIZE(1), 0);
	MATHB(MATH1, OR, ABD, MATH3, SIZE(4), 0);
	MATHB(MATH1, OR, OFIFO, MATH3, SIZE(4), WITH(NFU));
	MATHB(MATH1, OR, ONE, MATH3, SIZE(2), 0);
	MATHB(MATH1, OR, ZERO, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, OR, MATH0, MATH3, SIZE(2), 0);
	MATHB(MATH2, OR, MATH1, MATH3, SIZE(2), 0);
	MATHB(MATH2, OR, MATH2, MATH3, SIZE(4), 0);
	MATHB(MATH2, OR, MATH3, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, OR, IMM(393615378), MATH3, SIZE(8), WITH(IFB | STL));
	MATHB(MATH2, OR, DPOVRD, MATH3, SIZE(2), 0);
	MATHB(MATH2, OR, VSEQINSZ, MATH3, SIZE(1), WITH(STL));
	MATHB(MATH2, OR, VSEQOUTSZ, MATH3, SIZE(2), 0);
	MATHB(MATH2, OR, ABD, MATH3, SIZE(4), WITH(STL));
	MATHB(MATH2, OR, OFIFO, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, OR, ONE, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, OR, ZERO, MATH3, SIZE(1), 0);
	MATHB(MATH3, OR, MATH0, MATH3, SIZE(8), 0);
	MATHB(MATH3, OR, MATH1, MATH3, SIZE(2), WITH(STL));
	MATHB(MATH3, OR, MATH2, MATH3, SIZE(4), 0);
	MATHB(MATH3, OR, MATH3, MATH3, SIZE(1), 0);
	MATHB(MATH3, OR, IMM(393615378), MATH3, SIZE(2), WITH(STL));
	MATHB(MATH3, OR, DPOVRD, MATH3, SIZE(8), 0);
	MATHB(MATH3, OR, VSEQINSZ, MATH3, SIZE(2), 0);
	MATHB(MATH3, OR, VSEQOUTSZ, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, OR, ABD, MATH3, SIZE(4), WITH(NFU));
	MATHB(MATH3, OR, OFIFO, MATH3, SIZE(2), WITH(NFU));
	MATHB(MATH3, OR, ONE, MATH3, SIZE(8), 0);
	MATHB(MATH3, OR, ZERO, MATH3, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), OR, MATH0, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), OR, MATH1, MATH3, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), OR, MATH2, MATH3, SIZE(2), 0);
	MATHB(IMM(275128321), OR, MATH3, MATH3, SIZE(2), 0);
	MATHB(IMM(275128321), OR, IMM(393615378), MATH3, SIZE(1), 0);
	MATHB(IMM(275128321), OR, DPOVRD, MATH3, SIZE(2), WITH(STL));
	MATHB(IMM(275128321), OR, VSEQINSZ, MATH3, SIZE(4), 0);
	MATHB(IMM(275128321), OR, VSEQOUTSZ, MATH3, SIZE(2), 0);
	MATHB(IMM(0x19261959fedcba01), OR, ABD, MATH3, SIZE(8), 0);
	MATHB(IMM(275128321), OR, OFIFO, MATH3, SIZE(1), 0);
	MATHB(IMM(275128321), OR, ONE, MATH3, SIZE(2), 0);
	MATHB(IMM(275128321), OR, ZERO, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, OR, MATH0, MATH3, SIZE(1), 0);
	MATHB(DPOVRD, OR, MATH1, MATH3, SIZE(8), 0);
	MATHB(DPOVRD, OR, MATH2, MATH3, SIZE(8), 0);
	MATHB(DPOVRD, OR, MATH3, MATH3, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, OR, IMM(0x19261959fedcba01), MATH3, SIZE(8), 0);
	MATHB(DPOVRD, OR, DPOVRD, MATH3, SIZE(1), 0);
	MATHB(DPOVRD, OR, VSEQINSZ, MATH3, SIZE(2), WITH(STL));
	MATHB(DPOVRD, OR, VSEQOUTSZ, MATH3, SIZE(8), WITH(STL));
	MATHB(DPOVRD, OR, ABD, MATH3, SIZE(8), 0);
	MATHB(DPOVRD, OR, OFIFO, MATH3, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, OR, ONE, MATH3, SIZE(8), 0);
	MATHB(DPOVRD, OR, ZERO, MATH3, SIZE(1), 0);
	MATHB(SEQINSZ, OR, MATH0, MATH3, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, OR, MATH1, MATH3, SIZE(8), 0);
	MATHB(SEQINSZ, OR, MATH2, MATH3, SIZE(1), 0);
	MATHB(SEQINSZ, OR, MATH3, MATH3, SIZE(8), 0);
	MATHB(SEQINSZ, OR, IMM(393615378), MATH3, SIZE(4), 0);
	MATHB(SEQINSZ, OR, DPOVRD, MATH3, SIZE(2), 0);
	MATHB(SEQINSZ, OR, VSEQINSZ, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(SEQINSZ, OR, VSEQOUTSZ, MATH3, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, OR, ABD, MATH3, SIZE(1), 0);
	MATHB(SEQINSZ, OR, OFIFO, MATH3, SIZE(1), 0);
	MATHB(SEQINSZ, OR, ONE, MATH3, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, OR, ZERO, MATH3, SIZE(1), 0);
	MATHB(SEQOUTSZ, OR, MATH0, MATH3, SIZE(1), 0);
	MATHB(SEQOUTSZ, OR, MATH1, MATH3, SIZE(8), 0);
	MATHB(SEQOUTSZ, OR, MATH2, MATH3, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, OR, MATH3, MATH3, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, OR, IMM(393615378), MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, OR, DPOVRD, MATH3, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, OR, VSEQINSZ, MATH3, SIZE(4), 0);
	MATHB(SEQOUTSZ, OR, VSEQOUTSZ, MATH3, SIZE(1), 0);
	MATHB(SEQOUTSZ, OR, ABD, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, OR, OFIFO, MATH3, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, OR, ONE, MATH3, SIZE(4), 0);
	MATHB(SEQOUTSZ, OR, ZERO, MATH3, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, OR, MATH0, MATH3, SIZE(4), 0);
	MATHB(VSEQINSZ, OR, MATH1, MATH3, SIZE(8), 0);
	MATHB(VSEQINSZ, OR, MATH2, MATH3, SIZE(4), 0);
	MATHB(VSEQINSZ, OR, MATH3, MATH3, SIZE(1), 0);
	MATHB(VSEQINSZ, OR, IMM(393615378), MATH3, SIZE(2), 0);
	MATHB(VSEQINSZ, OR, DPOVRD, MATH3, SIZE(2), 0);
	MATHB(VSEQINSZ, OR, VSEQINSZ, MATH3, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, OR, VSEQOUTSZ, MATH3, SIZE(2), 0);
	MATHB(VSEQINSZ, OR, ABD, MATH3, SIZE(2), 0);
	MATHB(VSEQINSZ, OR, OFIFO, MATH3, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, OR, ONE, MATH3, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, OR, ZERO, MATH3, SIZE(4), 0);
	MATHB(VSEQOUTSZ, OR, MATH0, MATH3, SIZE(1), 0);
	MATHB(VSEQOUTSZ, OR, MATH1, MATH3, SIZE(2), 0);
	MATHB(VSEQOUTSZ, OR, MATH2, MATH3, SIZE(4), 0);
	MATHB(VSEQOUTSZ, OR, MATH3, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, OR, IMM(393615378), MATH3, SIZE(1), 0);
	MATHB(VSEQOUTSZ, OR, DPOVRD, MATH3, SIZE(2), 0);
	MATHB(VSEQOUTSZ, OR, VSEQINSZ, MATH3, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, OR, VSEQOUTSZ, MATH3, SIZE(1), 0);
	MATHB(VSEQOUTSZ, OR, ABD, MATH3, SIZE(8), 0);
	MATHB(VSEQOUTSZ, OR, OFIFO, MATH3, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, OR, ONE, MATH3, SIZE(8), 0);
	MATHB(VSEQOUTSZ, OR, ZERO, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, OR, MATH0, MATH3, SIZE(1), 0);
	MATHB(ZERO, OR, MATH1, MATH3, SIZE(8), 0);
	MATHB(ZERO, OR, MATH2, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, OR, MATH3, MATH3, SIZE(1), WITH(STL));
	MATHB(ZERO, OR, IMM(0x19261959fedcba01), MATH3, SIZE(8), WITH(NFU));
	MATHB(ZERO, OR, DPOVRD, MATH3, SIZE(1), 0);
	MATHB(ZERO, OR, VSEQINSZ, MATH3, SIZE(1), WITH(STL));
	MATHB(ZERO, OR, VSEQOUTSZ, MATH3, SIZE(4), WITH(STL));
	MATHB(ZERO, OR, ABD, MATH3, SIZE(2), 0);
	MATHB(ZERO, OR, OFIFO, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, OR, ONE, MATH3, SIZE(1), 0);
	MATHB(ZERO, OR, ZERO, MATH3, SIZE(1), 0);
	MATHB(ONE, OR, MATH0, MATH3, SIZE(4), 0);
	MATHB(ONE, OR, MATH1, MATH3, SIZE(4), WITH(NFU));
	MATHB(ONE, OR, MATH2, MATH3, SIZE(4), WITH(STL));
	MATHB(ONE, OR, MATH3, MATH3, SIZE(8), 0);
	MATHB(ONE, OR, IMM(393615378), MATH3, SIZE(2), WITH(NFU));
	MATHB(ONE, OR, DPOVRD, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, OR, VSEQINSZ, MATH3, SIZE(8), WITH(STL));
	MATHB(ONE, OR, VSEQOUTSZ, MATH3, SIZE(8), 0);
	MATHB(ONE, OR, ABD, MATH3, SIZE(4), WITH(NFU));
	MATHB(ONE, OR, OFIFO, MATH3, SIZE(1), 0);
	MATHB(ONE, OR, ONE, MATH3, SIZE(8), 0);
	MATHB(ONE, OR, ZERO, MATH3, SIZE(1), 0);
	/*OR Operation: DPOVRD Destination register */
	MATHB(MATH0, OR, MATH0, DPOVRD, SIZE(8), 0);
	MATHB(MATH0, OR, MATH1, DPOVRD, SIZE(4), 0);
	MATHB(MATH0, OR, MATH2, DPOVRD, SIZE(4), 0);
	MATHB(MATH0, OR, MATH3, DPOVRD, SIZE(2), 0);
	MATHB(MATH0, OR, IMM(393615378), DPOVRD, SIZE(8), WITH(IFB));
	MATHB(MATH0, OR, DPOVRD, DPOVRD, SIZE(4), 0);
	MATHB(MATH0, OR, VSEQINSZ, DPOVRD, SIZE(4), 0);
	MATHB(MATH0, OR, VSEQOUTSZ, DPOVRD, SIZE(8), 0);
	MATHB(MATH0, OR, ABD, DPOVRD, SIZE(4), 0);
	MATHB(MATH0, OR, OFIFO, DPOVRD, SIZE(4), 0);
	MATHB(MATH0, OR, ONE, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(MATH0, OR, ZERO, DPOVRD, SIZE(2), 0);
	MATHB(MATH1, OR, MATH0, DPOVRD, SIZE(8), 0);
	MATHB(MATH1, OR, MATH1, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(MATH1, OR, MATH2, DPOVRD, SIZE(4), WITH(STL));
	MATHB(MATH1, OR, MATH3, DPOVRD, SIZE(4), 0);
	MATHB(MATH1, OR, IMM(393615378), DPOVRD, SIZE(1), 0);
	MATHB(MATH1, OR, DPOVRD, DPOVRD, SIZE(2), 0);
	MATHB(MATH1, OR, VSEQINSZ, DPOVRD, SIZE(8), WITH(STL));
	MATHB(MATH1, OR, VSEQOUTSZ, DPOVRD, SIZE(1), 0);
	MATHB(MATH1, OR, ABD, DPOVRD, SIZE(4), 0);
	MATHB(MATH1, OR, OFIFO, DPOVRD, SIZE(8), WITH(STL));
	MATHB(MATH1, OR, ONE, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(MATH1, OR, ZERO, DPOVRD, SIZE(4), 0);
	MATHB(MATH2, OR, MATH0, DPOVRD, SIZE(4), 0);
	MATHB(MATH2, OR, MATH1, DPOVRD, SIZE(2), 0);
	MATHB(MATH2, OR, MATH2, DPOVRD, SIZE(4), WITH(STL));
	MATHB(MATH2, OR, MATH3, DPOVRD, SIZE(2), 0);
	MATHB(MATH2, OR, IMM(393615378), DPOVRD, SIZE(4), WITH(STL));
	MATHB(MATH2, OR, DPOVRD, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(MATH2, OR, VSEQINSZ, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(MATH2, OR, VSEQOUTSZ, DPOVRD, SIZE(2), 0);
	MATHB(MATH2, OR, ABD, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, OR, OFIFO, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(MATH2, OR, ONE, DPOVRD, SIZE(1), 0);
	MATHB(MATH2, OR, ZERO, DPOVRD, SIZE(8), 0);
	MATHB(MATH3, OR, MATH0, DPOVRD, SIZE(1), WITH(STL));
	MATHB(MATH3, OR, MATH1, DPOVRD, SIZE(1), 0);
	MATHB(MATH3, OR, MATH2, DPOVRD, SIZE(8), 0);
	MATHB(MATH3, OR, MATH3, DPOVRD, SIZE(8), WITH(STL));
	MATHB(MATH3, OR, IMM(0x19261959fedcba01), DPOVRD, SIZE(8), 0);
	MATHB(MATH3, OR, DPOVRD, DPOVRD, SIZE(2), 0);
	MATHB(MATH3, OR, VSEQINSZ, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(MATH3, OR, VSEQOUTSZ, DPOVRD, SIZE(1), WITH(STL));
	MATHB(MATH3, OR, ABD, DPOVRD, SIZE(1), 0);
	MATHB(MATH3, OR, OFIFO, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(MATH3, OR, ONE, DPOVRD, SIZE(8), 0);
	MATHB(MATH3, OR, ZERO, DPOVRD, SIZE(1), 0);
	MATHB(IMM(275128321), OR, MATH0, DPOVRD, SIZE(2), WITH(STL));
	MATHB(IMM(275128321), OR, MATH1, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(IMM(275128321), OR, MATH2, DPOVRD, SIZE(2), 0);
	MATHB(IMM(275128321), OR, MATH3, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), OR, IMM(393615378), DPOVRD, SIZE(1), 0);
	MATHB(IMM(0x19261959fedcba01), OR, DPOVRD, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(IMM(275128321), OR, VSEQINSZ, DPOVRD, SIZE(4), 0);
	MATHB(IMM(275128321), OR, VSEQOUTSZ, DPOVRD, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), OR, ABD, DPOVRD, SIZE(1), 0);
	MATHB(IMM(0x19261959fedcba01), OR, OFIFO, DPOVRD, SIZE(8), 0);
	MATHB(IMM(275128321), OR, ONE, DPOVRD, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), OR, ZERO, DPOVRD, SIZE(1), 0);
	MATHB(DPOVRD, OR, MATH0, DPOVRD, SIZE(8), WITH(STL));
	MATHB(DPOVRD, OR, MATH1, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, OR, MATH2, DPOVRD, SIZE(2), 0);
	MATHB(DPOVRD, OR, MATH3, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, OR, IMM(393615378), DPOVRD, SIZE(4), 0);
	MATHB(DPOVRD, OR, DPOVRD, DPOVRD, SIZE(8), WITH(STL));
	MATHB(DPOVRD, OR, VSEQINSZ, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, OR, VSEQOUTSZ, DPOVRD, SIZE(1), WITH(STL));
	MATHB(DPOVRD, OR, ABD, DPOVRD, SIZE(2), WITH(STL));
	MATHB(DPOVRD, OR, OFIFO, DPOVRD, SIZE(1), 0);
	MATHB(DPOVRD, OR, ONE, DPOVRD, SIZE(8), 0);
	MATHB(DPOVRD, OR, ZERO, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, OR, MATH0, DPOVRD, SIZE(2), 0);
	MATHB(SEQINSZ, OR, MATH1, DPOVRD, SIZE(1), 0);
	MATHB(SEQINSZ, OR, MATH2, DPOVRD, SIZE(1), 0);
	MATHB(SEQINSZ, OR, MATH3, DPOVRD, SIZE(1), 0);
	MATHB(SEQINSZ, OR, IMM(393615378), DPOVRD, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, OR, DPOVRD, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, OR, VSEQINSZ, DPOVRD, SIZE(2), 0);
	MATHB(SEQINSZ, OR, VSEQOUTSZ, DPOVRD, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, OR, ABD, DPOVRD, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, OR, OFIFO, DPOVRD, SIZE(2), 0);
	MATHB(SEQINSZ, OR, ONE, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, OR, ZERO, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, OR, MATH0, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, OR, MATH1, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(SEQOUTSZ, OR, MATH2, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, OR, MATH3, DPOVRD, SIZE(2), 0);
	MATHB(SEQOUTSZ, OR, IMM(393615378), DPOVRD, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, OR, DPOVRD, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, OR, VSEQINSZ, DPOVRD, SIZE(2), 0);
	MATHB(SEQOUTSZ, OR, VSEQOUTSZ, DPOVRD, SIZE(8), 0);
	MATHB(SEQOUTSZ, OR, ABD, DPOVRD, SIZE(4), 0);
	MATHB(SEQOUTSZ, OR, OFIFO, DPOVRD, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, OR, ONE, DPOVRD, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, OR, ZERO, DPOVRD, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, OR, MATH0, DPOVRD, SIZE(4), 0);
	MATHB(VSEQINSZ, OR, MATH1, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, OR, MATH2, DPOVRD, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, OR, MATH3, DPOVRD, SIZE(2), 0);
	MATHB(VSEQINSZ, OR, IMM(393615378), DPOVRD, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, OR, DPOVRD, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, OR, VSEQINSZ, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, OR, VSEQOUTSZ, DPOVRD, SIZE(2), 0);
	MATHB(VSEQINSZ, OR, ABD, DPOVRD, SIZE(8), 0);
	MATHB(VSEQINSZ, OR, OFIFO, DPOVRD, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, OR, ONE, DPOVRD, SIZE(8), 0);
	MATHB(VSEQINSZ, OR, ZERO, DPOVRD, SIZE(8), 0);
	MATHB(VSEQOUTSZ, OR, MATH0, DPOVRD, SIZE(4), 0);
	MATHB(VSEQOUTSZ, OR, MATH1, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, OR, MATH2, DPOVRD, SIZE(8), 0);
	MATHB(VSEQOUTSZ, OR, MATH3, DPOVRD, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, OR, IMM(393615378), DPOVRD, SIZE(4), 0);
	MATHB(VSEQOUTSZ, OR, DPOVRD, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, OR, VSEQINSZ, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, OR, VSEQOUTSZ, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, OR, ABD, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, OR, OFIFO, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, OR, ONE, DPOVRD, SIZE(4), 0);
	MATHB(VSEQOUTSZ, OR, ZERO, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, OR, MATH0, DPOVRD, SIZE(4), WITH(STL));
	MATHB(ZERO, OR, MATH1, DPOVRD, SIZE(1), WITH(STL));
	MATHB(ZERO, OR, MATH2, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(ZERO, OR, MATH3, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, OR, IMM(393615378), DPOVRD, SIZE(2), 0);
	MATHB(ZERO, OR, DPOVRD, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, OR, VSEQINSZ, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(ZERO, OR, VSEQOUTSZ, DPOVRD, SIZE(1), 0);
	MATHB(ZERO, OR, ABD, DPOVRD, SIZE(4), 0);
	MATHB(ZERO, OR, OFIFO, DPOVRD, SIZE(8), 0);
	MATHB(ZERO, OR, ONE, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(ZERO, OR, ZERO, DPOVRD, SIZE(1), 0);
	MATHB(ONE, OR, MATH0, DPOVRD, SIZE(1), 0);
	MATHB(ONE, OR, MATH1, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, OR, MATH2, DPOVRD, SIZE(1), 0);
	MATHB(ONE, OR, MATH3, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, OR, IMM(393615378), DPOVRD, SIZE(1), WITH(NFU));
	MATHB(ONE, OR, DPOVRD, DPOVRD, SIZE(1), 0);
	MATHB(ONE, OR, VSEQINSZ, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, OR, VSEQOUTSZ, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, OR, ABD, DPOVRD, SIZE(8), 0);
	MATHB(ONE, OR, OFIFO, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(ONE, OR, ONE, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, OR, ZERO, DPOVRD, SIZE(1), 0);
	/*OR Operation: SEQINSZ Destination register */
	MATHB(MATH0, OR, MATH0, SEQINSZ, SIZE(4), 0);
	MATHB(MATH0, OR, MATH1, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH0, OR, MATH2, SEQINSZ, SIZE(4), 0);
	MATHB(MATH0, OR, MATH3, SEQINSZ, SIZE(4), 0);
	MATHB(MATH0, OR, IMM(393615378), SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(MATH0, OR, DPOVRD, SEQINSZ, SIZE(8), 0);
	MATHB(MATH0, OR, VSEQINSZ, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(MATH0, OR, VSEQOUTSZ, SEQINSZ, SIZE(1), 0);
	MATHB(MATH0, OR, ABD, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH0, OR, OFIFO, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(MATH0, OR, ONE, SEQINSZ, SIZE(8), 0);
	MATHB(MATH0, OR, ZERO, SEQINSZ, SIZE(1), 0);
	MATHB(MATH1, OR, MATH0, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(MATH1, OR, MATH1, SEQINSZ, SIZE(8), 0);
	MATHB(MATH1, OR, MATH2, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH1, OR, MATH3, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH1, OR, IMM(393615378), SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH1, OR, DPOVRD, SEQINSZ, SIZE(8), 0);
	MATHB(MATH1, OR, VSEQINSZ, SEQINSZ, SIZE(1), 0);
	MATHB(MATH1, OR, VSEQOUTSZ, SEQINSZ, SIZE(8), 0);
	MATHB(MATH1, OR, ABD, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH1, OR, OFIFO, SEQINSZ, SIZE(4), 0);
	MATHB(MATH1, OR, ONE, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(MATH1, OR, ZERO, SEQINSZ, SIZE(4), 0);
	MATHB(MATH2, OR, MATH0, SEQINSZ, SIZE(2), 0);
	MATHB(MATH2, OR, MATH1, SEQINSZ, SIZE(4), 0);
	MATHB(MATH2, OR, MATH2, SEQINSZ, SIZE(2), 0);
	MATHB(MATH2, OR, MATH3, SEQINSZ, SIZE(4), 0);
	MATHB(MATH2, OR, IMM(393615378), SEQINSZ, SIZE(8), WITH(IFB));
	MATHB(MATH2, OR, DPOVRD, SEQINSZ, SIZE(2), 0);
	MATHB(MATH2, OR, VSEQINSZ, SEQINSZ, SIZE(4), 0);
	MATHB(MATH2, OR, VSEQOUTSZ, SEQINSZ, SIZE(8), 0);
	MATHB(MATH2, OR, ABD, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(MATH2, OR, OFIFO, SEQINSZ, SIZE(8), 0);
	MATHB(MATH2, OR, ONE, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, OR, ZERO, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(MATH3, OR, MATH0, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH3, OR, MATH1, SEQINSZ, SIZE(2), 0);
	MATHB(MATH3, OR, MATH2, SEQINSZ, SIZE(8), 0);
	MATHB(MATH3, OR, MATH3, SEQINSZ, SIZE(2), 0);
	MATHB(MATH3, OR, IMM(393615378), SEQINSZ, SIZE(1), 0);
	MATHB(MATH3, OR, DPOVRD, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH3, OR, VSEQINSZ, SEQINSZ, SIZE(1), 0);
	MATHB(MATH3, OR, VSEQOUTSZ, SEQINSZ, SIZE(4), 0);
	MATHB(MATH3, OR, ABD, SEQINSZ, SIZE(1), 0);
	MATHB(MATH3, OR, OFIFO, SEQINSZ, SIZE(2), 0);
	MATHB(MATH3, OR, ONE, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(MATH3, OR, ZERO, SEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), OR, MATH0, SEQINSZ, SIZE(1), 0);
	MATHB(IMM(0x19261959fedcba01), OR, MATH1, SEQINSZ, SIZE(8),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), OR, MATH2, SEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), OR, MATH3, SEQINSZ, SIZE(4), 0);
	MATHB(IMM(275128321), OR, IMM(393615378), SEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), OR, DPOVRD, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), OR, VSEQINSZ, SEQINSZ, SIZE(8), WITH(IFB | STL));
	MATHB(IMM(275128321), OR, VSEQOUTSZ, SEQINSZ, SIZE(4), 0);
	MATHB(IMM(275128321), OR, ABD, SEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), OR, OFIFO, SEQINSZ, SIZE(8),
	      WITH(IFB | NFU | STL));
	MATHB(IMM(275128321), OR, ONE, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(IMM(0x19261959fedcba01), OR, ZERO, SEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, OR, MATH0, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, OR, MATH1, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(DPOVRD, OR, MATH2, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(DPOVRD, OR, MATH3, SEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, OR, IMM(393615378), SEQINSZ, SIZE(8), WITH(IFB));
	MATHB(DPOVRD, OR, DPOVRD, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, OR, VSEQINSZ, SEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, OR, VSEQOUTSZ, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(DPOVRD, OR, ABD, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(DPOVRD, OR, OFIFO, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, OR, ONE, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, OR, ZERO, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, OR, MATH0, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, OR, MATH1, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, OR, MATH2, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, OR, MATH3, SEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, OR, IMM(393615378), SEQINSZ, SIZE(8), WITH(IFB));
	MATHB(SEQINSZ, OR, DPOVRD, SEQINSZ, SIZE(4), 0);
	MATHB(SEQINSZ, OR, VSEQINSZ, SEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, OR, VSEQOUTSZ, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, OR, ABD, SEQINSZ, SIZE(8), 0);
	MATHB(SEQINSZ, OR, OFIFO, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, OR, ONE, SEQINSZ, SIZE(8), 0);
	MATHB(SEQINSZ, OR, ZERO, SEQINSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, OR, MATH0, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, OR, MATH1, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, OR, MATH2, SEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, OR, MATH3, SEQINSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, OR, IMM(393615378), SEQINSZ, SIZE(8), WITH(IFB));
	MATHB(SEQOUTSZ, OR, DPOVRD, SEQINSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, OR, VSEQINSZ, SEQINSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, OR, VSEQOUTSZ, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, OR, ABD, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, OR, OFIFO, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, OR, ONE, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, OR, ZERO, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(VSEQINSZ, OR, MATH0, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, OR, MATH1, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, OR, MATH2, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, OR, MATH3, SEQINSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, OR, IMM(393615378), SEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, OR, DPOVRD, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, OR, VSEQINSZ, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, OR, VSEQOUTSZ, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, OR, ABD, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(VSEQINSZ, OR, OFIFO, SEQINSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, OR, ONE, SEQINSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, OR, ZERO, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, OR, MATH0, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, OR, MATH1, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, OR, MATH2, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, OR, MATH3, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, OR, IMM(393615378), SEQINSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, OR, DPOVRD, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, OR, VSEQINSZ, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, OR, VSEQOUTSZ, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, OR, ABD, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, OR, OFIFO, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, OR, ONE, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, OR, ZERO, SEQINSZ, SIZE(2), 0);
	MATHB(ZERO, OR, MATH0, SEQINSZ, SIZE(1), 0);
	MATHB(ZERO, OR, MATH1, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(ZERO, OR, MATH2, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, OR, MATH3, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(ZERO, OR, IMM(393615378), SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(ZERO, OR, DPOVRD, SEQINSZ, SIZE(2), 0);
	MATHB(ZERO, OR, VSEQINSZ, SEQINSZ, SIZE(2), 0);
	MATHB(ZERO, OR, VSEQOUTSZ, SEQINSZ, SIZE(8), 0);
	MATHB(ZERO, OR, ABD, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(ZERO, OR, OFIFO, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(ZERO, OR, ONE, SEQINSZ, SIZE(2), 0);
	MATHB(ZERO, OR, ZERO, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, OR, MATH0, SEQINSZ, SIZE(1), 0);
	MATHB(ONE, OR, MATH1, SEQINSZ, SIZE(1), 0);
	MATHB(ONE, OR, MATH2, SEQINSZ, SIZE(4), 0);
	MATHB(ONE, OR, MATH3, SEQINSZ, SIZE(8), 0);
	MATHB(ONE, OR, IMM(0x19261959fedcba01), SEQINSZ, SIZE(8), WITH(STL));
	MATHB(ONE, OR, DPOVRD, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(ONE, OR, VSEQINSZ, SEQINSZ, SIZE(2), 0);
	MATHB(ONE, OR, VSEQOUTSZ, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, OR, ABD, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(ONE, OR, OFIFO, SEQINSZ, SIZE(8), 0);
	MATHB(ONE, OR, ONE, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(ONE, OR, ZERO, SEQINSZ, SIZE(1), WITH(NFU | STL));
	/*OR Operation: SEQOUTSZ Destination register */
	MATHB(MATH0, OR, MATH0, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH0, OR, MATH1, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, OR, MATH2, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH0, OR, MATH3, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH0, OR, IMM(393615378), SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH0, OR, DPOVRD, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, OR, VSEQINSZ, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, OR, VSEQOUTSZ, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH0, OR, ABD, SEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(MATH0, OR, OFIFO, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, OR, ONE, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH0, OR, ZERO, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH1, OR, MATH0, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH1, OR, MATH1, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH1, OR, MATH2, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH1, OR, MATH3, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, OR, IMM(393615378), SEQOUTSZ, SIZE(8), WITH(IFB));
	MATHB(MATH1, OR, DPOVRD, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH1, OR, VSEQINSZ, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(MATH1, OR, VSEQOUTSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH1, OR, ABD, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH1, OR, OFIFO, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, OR, ONE, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(MATH1, OR, ZERO, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, OR, MATH0, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, OR, MATH1, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH2, OR, MATH2, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH2, OR, MATH3, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH2, OR, IMM(393615378), SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH2, OR, DPOVRD, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, OR, VSEQINSZ, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, OR, VSEQOUTSZ, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH2, OR, ABD, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, OR, OFIFO, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH2, OR, ONE, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, OR, ZERO, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH3, OR, MATH0, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, OR, MATH1, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH3, OR, MATH2, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH3, OR, MATH3, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH3, OR, IMM(0x19261959fedcba01), SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(MATH3, OR, DPOVRD, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, OR, VSEQINSZ, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH3, OR, VSEQOUTSZ, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, OR, ABD, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH3, OR, OFIFO, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, OR, ONE, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH3, OR, ZERO, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), OR, MATH0, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), OR, MATH1, SEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), OR, MATH2, SEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(275128321), OR, MATH3, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), OR, IMM(393615378), SEQOUTSZ, SIZE(4),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), OR, DPOVRD, SEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(275128321), OR, VSEQINSZ, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(IMM(275128321), OR, VSEQOUTSZ, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), OR, ABD, SEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), OR, OFIFO, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(IMM(0x19261959fedcba01), OR, ONE, SEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(IMM(275128321), OR, ZERO, SEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, OR, MATH0, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, OR, MATH1, SEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(DPOVRD, OR, MATH2, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, OR, MATH3, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(DPOVRD, OR, IMM(393615378), SEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, OR, DPOVRD, SEQOUTSZ, SIZE(4), 0);
	MATHB(DPOVRD, OR, VSEQINSZ, SEQOUTSZ, SIZE(4), 0);
	MATHB(DPOVRD, OR, VSEQOUTSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, OR, ABD, SEQOUTSZ, SIZE(4), 0);
	MATHB(DPOVRD, OR, OFIFO, SEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, OR, ONE, SEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(DPOVRD, OR, ZERO, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, OR, MATH0, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, OR, MATH1, SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, OR, MATH2, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, OR, MATH3, SEQOUTSZ, SIZE(8), 0);
	MATHB(SEQINSZ, OR, IMM(0x19261959fedcba01), SEQOUTSZ, SIZE(8),
	      WITH(NFU));
	MATHB(SEQINSZ, OR, DPOVRD, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, OR, VSEQINSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQINSZ, OR, VSEQOUTSZ, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, OR, ABD, SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, OR, OFIFO, SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQINSZ, OR, ONE, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, OR, ZERO, SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, OR, MATH0, SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, OR, MATH1, SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, OR, MATH2, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, OR, MATH3, SEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, OR, IMM(393615378), SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, OR, DPOVRD, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, OR, VSEQINSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, OR, VSEQOUTSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, OR, ABD, SEQOUTSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, OR, OFIFO, SEQOUTSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, OR, ONE, SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, OR, ZERO, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, OR, MATH0, SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, OR, MATH1, SEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, OR, MATH2, SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, OR, MATH3, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, OR, IMM(393615378), SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, OR, DPOVRD, SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, OR, VSEQINSZ, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, OR, VSEQOUTSZ, SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, OR, ABD, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, OR, OFIFO, SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, OR, ONE, SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, OR, ZERO, SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, OR, MATH0, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, OR, MATH1, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, OR, MATH2, SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, OR, MATH3, SEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, OR, IMM(393615378), SEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, OR, DPOVRD, SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, OR, VSEQINSZ, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, OR, VSEQOUTSZ, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, OR, ABD, SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, OR, OFIFO, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, OR, ONE, SEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, OR, ZERO, SEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, OR, MATH0, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, OR, MATH1, SEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, OR, MATH2, SEQOUTSZ, SIZE(8), 0);
	MATHB(ZERO, OR, MATH3, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(ZERO, OR, IMM(393615378), SEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, OR, DPOVRD, SEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, OR, VSEQINSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, OR, VSEQOUTSZ, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(ZERO, OR, ABD, SEQOUTSZ, SIZE(4), 0);
	MATHB(ZERO, OR, OFIFO, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(ZERO, OR, ONE, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, OR, ZERO, SEQOUTSZ, SIZE(2), 0);
	MATHB(ONE, OR, MATH0, SEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, OR, MATH1, SEQOUTSZ, SIZE(2), 0);
	MATHB(ONE, OR, MATH2, SEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, OR, MATH3, SEQOUTSZ, SIZE(2), 0);
	MATHB(ONE, OR, IMM(393615378), SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(ONE, OR, DPOVRD, SEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, OR, VSEQINSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(ONE, OR, VSEQOUTSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(ONE, OR, ABD, SEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, OR, OFIFO, SEQOUTSZ, SIZE(8), 0);
	MATHB(ONE, OR, ONE, SEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, OR, ZERO, SEQOUTSZ, SIZE(1), WITH(STL));
	/*OR Operation: VSEQINSZ Destination register */
	MATHB(MATH0, OR, MATH0, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH0, OR, MATH1, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH0, OR, MATH2, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH0, OR, MATH3, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH0, OR, IMM(393615378), VSEQINSZ, SIZE(8),
	      WITH(IFB | NFU | STL));
	MATHB(MATH0, OR, DPOVRD, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH0, OR, VSEQINSZ, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, OR, VSEQOUTSZ, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, OR, ABD, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH0, OR, OFIFO, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH0, OR, ONE, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(MATH0, OR, ZERO, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH1, OR, MATH0, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH1, OR, MATH1, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH1, OR, MATH2, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(MATH1, OR, MATH3, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH1, OR, IMM(393615378), VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH1, OR, DPOVRD, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH1, OR, VSEQINSZ, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH1, OR, VSEQOUTSZ, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH1, OR, ABD, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH1, OR, OFIFO, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH1, OR, ONE, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH1, OR, ZERO, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH2, OR, MATH0, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(MATH2, OR, MATH1, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH2, OR, MATH2, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH2, OR, MATH3, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH2, OR, IMM(393615378), VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, OR, DPOVRD, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, OR, VSEQINSZ, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH2, OR, VSEQOUTSZ, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH2, OR, ABD, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH2, OR, OFIFO, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH2, OR, ONE, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH2, OR, ZERO, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH3, OR, MATH0, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH3, OR, MATH1, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH3, OR, MATH2, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH3, OR, MATH3, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH3, OR, IMM(393615378), VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH3, OR, DPOVRD, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(MATH3, OR, VSEQINSZ, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH3, OR, VSEQOUTSZ, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(MATH3, OR, ABD, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH3, OR, OFIFO, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH3, OR, ONE, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH3, OR, ZERO, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(275128321), OR, MATH0, VSEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), OR, MATH1, VSEQINSZ, SIZE(8), WITH(IFB | STL));
	MATHB(IMM(0x19261959fedcba01), OR, MATH2, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(IMM(0x19261959fedcba01), OR, MATH3, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(IMM(275128321), OR, IMM(393615378), VSEQINSZ, SIZE(4), 0);
	MATHB(IMM(275128321), OR, DPOVRD, VSEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), OR, VSEQINSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), OR, VSEQOUTSZ, VSEQINSZ, SIZE(4), 0);
	MATHB(IMM(275128321), OR, ABD, VSEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), OR, OFIFO, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), OR, ONE, VSEQINSZ, SIZE(4), 0);
	MATHB(IMM(275128321), OR, ZERO, VSEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, OR, MATH0, VSEQINSZ, SIZE(4), 0);
	MATHB(DPOVRD, OR, MATH1, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, OR, MATH2, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, OR, MATH3, VSEQINSZ, SIZE(4), 0);
	MATHB(DPOVRD, OR, IMM(393615378), VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, OR, DPOVRD, VSEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, OR, VSEQINSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(DPOVRD, OR, VSEQOUTSZ, VSEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, OR, ABD, VSEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, OR, OFIFO, VSEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, OR, ONE, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(DPOVRD, OR, ZERO, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, OR, MATH0, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, OR, MATH1, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, OR, MATH2, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, OR, MATH3, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, OR, IMM(393615378), VSEQINSZ, SIZE(4), 0);
	MATHB(SEQINSZ, OR, DPOVRD, VSEQINSZ, SIZE(4), 0);
	MATHB(SEQINSZ, OR, VSEQINSZ, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, OR, VSEQOUTSZ, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, OR, ABD, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, OR, OFIFO, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, OR, ONE, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQINSZ, OR, ZERO, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, OR, MATH0, VSEQINSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, OR, MATH1, VSEQINSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, OR, MATH2, VSEQINSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, OR, MATH3, VSEQINSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, OR, IMM(393615378), VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, OR, DPOVRD, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, OR, VSEQINSZ, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, OR, VSEQOUTSZ, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, OR, ABD, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, OR, OFIFO, VSEQINSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, OR, ONE, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, OR, ZERO, VSEQINSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, OR, MATH0, VSEQINSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, OR, MATH1, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, OR, MATH2, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, OR, MATH3, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, OR, IMM(393615378), VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, OR, DPOVRD, VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, OR, VSEQINSZ, VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, OR, VSEQOUTSZ, VSEQINSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, OR, ABD, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, OR, OFIFO, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQINSZ, OR, ONE, VSEQINSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, OR, ZERO, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, OR, MATH0, VSEQINSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, OR, MATH1, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, OR, MATH2, VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, OR, MATH3, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, OR, IMM(393615378), VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, OR, DPOVRD, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, OR, VSEQINSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, OR, VSEQOUTSZ, VSEQINSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, OR, ABD, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, OR, OFIFO, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, OR, ONE, VSEQINSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, OR, ZERO, VSEQINSZ, SIZE(8), 0);
	MATHB(ZERO, OR, MATH0, VSEQINSZ, SIZE(4), 0);
	MATHB(ZERO, OR, MATH1, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(ZERO, OR, MATH2, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, OR, MATH3, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(ZERO, OR, IMM(393615378), VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(ZERO, OR, DPOVRD, VSEQINSZ, SIZE(2), 0);
	MATHB(ZERO, OR, VSEQINSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(ZERO, OR, VSEQOUTSZ, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(ZERO, OR, ABD, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, OR, OFIFO, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(ZERO, OR, ONE, VSEQINSZ, SIZE(4), 0);
	MATHB(ZERO, OR, ZERO, VSEQINSZ, SIZE(2), 0);
	MATHB(ONE, OR, MATH0, VSEQINSZ, SIZE(2), 0);
	MATHB(ONE, OR, MATH1, VSEQINSZ, SIZE(4), 0);
	MATHB(ONE, OR, MATH2, VSEQINSZ, SIZE(4), 0);
	MATHB(ONE, OR, MATH3, VSEQINSZ, SIZE(4), 0);
	MATHB(ONE, OR, IMM(393615378), VSEQINSZ, SIZE(4), 0);
	MATHB(ONE, OR, DPOVRD, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, OR, VSEQINSZ, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(ONE, OR, VSEQOUTSZ, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, OR, ABD, VSEQINSZ, SIZE(2), 0);
	MATHB(ONE, OR, OFIFO, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(ONE, OR, ONE, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(ONE, OR, ZERO, VSEQINSZ, SIZE(4), 0);
	/*OR Operation: VSEQOUTSZ Destination register */
	MATHB(MATH0, OR, MATH0, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, OR, MATH1, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(MATH0, OR, MATH2, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(MATH0, OR, MATH3, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH0, OR, IMM(393615378), VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, OR, DPOVRD, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH0, OR, VSEQINSZ, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(MATH0, OR, VSEQOUTSZ, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH0, OR, ABD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, OR, OFIFO, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, OR, ONE, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH0, OR, ZERO, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(MATH1, OR, MATH0, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(MATH1, OR, MATH1, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH1, OR, MATH2, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, OR, MATH3, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, OR, IMM(393615378), VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH1, OR, DPOVRD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH1, OR, VSEQINSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH1, OR, VSEQOUTSZ, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH1, OR, ABD, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH1, OR, OFIFO, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, OR, ONE, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH1, OR, ZERO, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(MATH2, OR, MATH0, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, OR, MATH1, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, OR, MATH2, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH2, OR, MATH3, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, OR, IMM(393615378), VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH2, OR, DPOVRD, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(MATH2, OR, VSEQINSZ, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, OR, VSEQOUTSZ, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, OR, ABD, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, OR, OFIFO, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, OR, ONE, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH2, OR, ZERO, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH3, OR, MATH0, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH3, OR, MATH1, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH3, OR, MATH2, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH3, OR, MATH3, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH3, OR, IMM(393615378), VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, OR, DPOVRD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH3, OR, VSEQINSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH3, OR, VSEQOUTSZ, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH3, OR, ABD, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, OR, OFIFO, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, OR, ONE, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, OR, ZERO, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(IMM(275128321), OR, MATH0, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), OR, MATH1, VSEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), OR, MATH2, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), OR, MATH3, VSEQOUTSZ, SIZE(8), WITH(IFB | STL));
	MATHB(IMM(275128321), OR, IMM(393615378), VSEQOUTSZ, SIZE(2),
	      WITH(NFU));
	MATHB(IMM(275128321), OR, DPOVRD, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(IMM(275128321), OR, VSEQINSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(275128321), OR, VSEQOUTSZ, VSEQOUTSZ, SIZE(2),
	      WITH(NFU | STL));
	MATHB(IMM(0x19261959fedcba01), OR, ABD, VSEQOUTSZ, SIZE(8), 0);
	MATHB(IMM(275128321), OR, OFIFO, VSEQOUTSZ, SIZE(8), WITH(IFB));
	MATHB(IMM(0x19261959fedcba01), OR, ONE, VSEQOUTSZ, SIZE(8), 0);
	MATHB(IMM(275128321), OR, ZERO, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, OR, MATH0, VSEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, OR, MATH1, VSEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, OR, MATH2, VSEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, OR, MATH3, VSEQOUTSZ, SIZE(4), 0);
	MATHB(DPOVRD, OR, IMM(393615378), VSEQOUTSZ, SIZE(8), WITH(IFB));
	MATHB(DPOVRD, OR, DPOVRD, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(DPOVRD, OR, VSEQINSZ, VSEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, OR, VSEQOUTSZ, VSEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, OR, ABD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, OR, OFIFO, VSEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, OR, ONE, VSEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, OR, ZERO, VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQINSZ, OR, MATH0, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, OR, MATH1, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, OR, MATH2, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQINSZ, OR, MATH3, VSEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, OR, IMM(393615378), VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQINSZ, OR, DPOVRD, VSEQOUTSZ, SIZE(8), 0);
	MATHB(SEQINSZ, OR, VSEQINSZ, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, OR, VSEQOUTSZ, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQINSZ, OR, ABD, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, OR, OFIFO, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, OR, ONE, VSEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, OR, ZERO, VSEQOUTSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, OR, MATH0, VSEQOUTSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, OR, MATH1, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, OR, MATH2, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, OR, MATH3, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(SEQOUTSZ, OR, IMM(393615378), VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, OR, DPOVRD, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, OR, VSEQINSZ, VSEQOUTSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, OR, VSEQOUTSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, OR, ABD, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, OR, OFIFO, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, OR, ONE, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, OR, ZERO, VSEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, OR, MATH0, VSEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, OR, MATH1, VSEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, OR, MATH2, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, OR, MATH3, VSEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, OR, IMM(393615378), VSEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, OR, DPOVRD, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, OR, VSEQINSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, OR, VSEQOUTSZ, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, OR, ABD, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, OR, OFIFO, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, OR, ONE, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, OR, ZERO, VSEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, OR, MATH0, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, OR, MATH1, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, OR, MATH2, VSEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, OR, MATH3, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, OR, IMM(393615378), VSEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, OR, DPOVRD, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, OR, VSEQINSZ, VSEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, OR, VSEQOUTSZ, VSEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, OR, ABD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, OR, OFIFO, VSEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, OR, ONE, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, OR, ZERO, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, OR, MATH0, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, OR, MATH1, VSEQOUTSZ, SIZE(4), 0);
	MATHB(ZERO, OR, MATH2, VSEQOUTSZ, SIZE(4), 0);
	MATHB(ZERO, OR, MATH3, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(ZERO, OR, IMM(393615378), VSEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, OR, DPOVRD, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(ZERO, OR, VSEQINSZ, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, OR, VSEQOUTSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, OR, ABD, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(ZERO, OR, OFIFO, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(ZERO, OR, ONE, VSEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, OR, ZERO, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(ONE, OR, MATH0, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(ONE, OR, MATH1, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(ONE, OR, MATH2, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, OR, MATH3, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, OR, IMM(393615378), VSEQOUTSZ, SIZE(2), 0);
	MATHB(ONE, OR, DPOVRD, VSEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, OR, VSEQINSZ, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, OR, VSEQOUTSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(ONE, OR, ABD, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, OR, OFIFO, VSEQOUTSZ, SIZE(8), 0);
	MATHB(ONE, OR, ONE, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(ONE, OR, ZERO, VSEQOUTSZ, SIZE(8), WITH(STL));
	/*OR Operation: NONE Destination register */
	MATHB(MATH0, OR, MATH0, NONE, SIZE(2), WITH(NFU));
	MATHB(MATH0, OR, MATH1, NONE, SIZE(4), WITH(STL));
	MATHB(MATH0, OR, MATH2, NONE, SIZE(4), WITH(NFU));
	MATHB(MATH0, OR, MATH3, NONE, SIZE(4), 0);
	MATHB(MATH0, OR, IMM(393615378), NONE, SIZE(1), WITH(NFU));
	MATHB(MATH0, OR, DPOVRD, NONE, SIZE(2), WITH(NFU));
	MATHB(MATH0, OR, VSEQINSZ, NONE, SIZE(8), 0);
	MATHB(MATH0, OR, VSEQOUTSZ, NONE, SIZE(8), WITH(STL));
	MATHB(MATH0, OR, ABD, NONE, SIZE(1), WITH(STL));
	MATHB(MATH0, OR, OFIFO, NONE, SIZE(8), WITH(NFU));
	MATHB(MATH0, OR, ONE, NONE, SIZE(2), WITH(NFU));
	MATHB(MATH0, OR, ZERO, NONE, SIZE(2), 0);
	MATHB(MATH1, OR, MATH0, NONE, SIZE(8), WITH(STL));
	MATHB(MATH1, OR, MATH1, NONE, SIZE(4), 0);
	MATHB(MATH1, OR, MATH2, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, OR, MATH3, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(MATH1, OR, IMM(0x19261959fedcba01), NONE, SIZE(8), 0);
	MATHB(MATH1, OR, DPOVRD, NONE, SIZE(4), 0);
	MATHB(MATH1, OR, VSEQINSZ, NONE, SIZE(2), 0);
	MATHB(MATH1, OR, VSEQOUTSZ, NONE, SIZE(2), WITH(STL));
	MATHB(MATH1, OR, ABD, NONE, SIZE(4), 0);
	MATHB(MATH1, OR, OFIFO, NONE, SIZE(8), 0);
	MATHB(MATH1, OR, ONE, NONE, SIZE(2), 0);
	MATHB(MATH1, OR, ZERO, NONE, SIZE(4), WITH(NFU));
	MATHB(MATH2, OR, MATH0, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, OR, MATH1, NONE, SIZE(4), 0);
	MATHB(MATH2, OR, MATH2, NONE, SIZE(4), WITH(STL));
	MATHB(MATH2, OR, MATH3, NONE, SIZE(1), 0);
	MATHB(MATH2, OR, IMM(393615378), NONE, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, OR, DPOVRD, NONE, SIZE(8), 0);
	MATHB(MATH2, OR, VSEQINSZ, NONE, SIZE(2), WITH(NFU));
	MATHB(MATH2, OR, VSEQOUTSZ, NONE, SIZE(2), WITH(NFU));
	MATHB(MATH2, OR, ABD, NONE, SIZE(8), 0);
	MATHB(MATH2, OR, OFIFO, NONE, SIZE(8), 0);
	MATHB(MATH2, OR, ONE, NONE, SIZE(2), 0);
	MATHB(MATH2, OR, ZERO, NONE, SIZE(1), 0);
	MATHB(MATH3, OR, MATH0, NONE, SIZE(2), 0);
	MATHB(MATH3, OR, MATH1, NONE, SIZE(8), WITH(NFU));
	MATHB(MATH3, OR, MATH2, NONE, SIZE(1), WITH(STL));
	MATHB(MATH3, OR, MATH3, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(MATH3, OR, IMM(393615378), NONE, SIZE(2), WITH(NFU));
	MATHB(MATH3, OR, DPOVRD, NONE, SIZE(1), WITH(STL));
	MATHB(MATH3, OR, VSEQINSZ, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(MATH3, OR, VSEQOUTSZ, NONE, SIZE(4), 0);
	MATHB(MATH3, OR, ABD, NONE, SIZE(2), 0);
	MATHB(MATH3, OR, OFIFO, NONE, SIZE(2), 0);
	MATHB(MATH3, OR, ONE, NONE, SIZE(2), 0);
	MATHB(MATH3, OR, ZERO, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), OR, MATH0, NONE, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), OR, MATH1, NONE, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), OR, MATH2, NONE, SIZE(8), WITH(IFB));
	MATHB(IMM(0x19261959fedcba01), OR, MATH3, NONE, SIZE(8), 0);
	MATHB(IMM(275128321), OR, IMM(393615378), NONE, SIZE(1), 0);
	MATHB(IMM(275128321), OR, DPOVRD, NONE, SIZE(1), 0);
	MATHB(IMM(275128321), OR, VSEQINSZ, NONE, SIZE(4), 0);
	MATHB(IMM(275128321), OR, VSEQOUTSZ, NONE, SIZE(2), 0);
	MATHB(IMM(275128321), OR, ABD, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(275128321), OR, OFIFO, NONE, SIZE(2), 0);
	MATHB(IMM(275128321), OR, ONE, NONE, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), OR, ZERO, NONE, SIZE(1), 0);
	MATHB(DPOVRD, OR, MATH0, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, OR, MATH1, NONE, SIZE(2), WITH(STL));
	MATHB(DPOVRD, OR, MATH2, NONE, SIZE(4), WITH(STL));
	MATHB(DPOVRD, OR, MATH3, NONE, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, OR, IMM(393615378), NONE, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, OR, DPOVRD, NONE, SIZE(8), 0);
	MATHB(DPOVRD, OR, VSEQINSZ, NONE, SIZE(4), 0);
	MATHB(DPOVRD, OR, VSEQOUTSZ, NONE, SIZE(2), WITH(STL));
	MATHB(DPOVRD, OR, ABD, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(DPOVRD, OR, OFIFO, NONE, SIZE(2), 0);
	MATHB(DPOVRD, OR, ONE, NONE, SIZE(4), 0);
	MATHB(DPOVRD, OR, ZERO, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, OR, MATH0, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, OR, MATH1, NONE, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, OR, MATH2, NONE, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, OR, MATH3, NONE, SIZE(4), 0);
	MATHB(SEQINSZ, OR, IMM(393615378), NONE, SIZE(1), 0);
	MATHB(SEQINSZ, OR, DPOVRD, NONE, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, OR, VSEQINSZ, NONE, SIZE(4), 0);
	MATHB(SEQINSZ, OR, VSEQOUTSZ, NONE, SIZE(1), 0);
	MATHB(SEQINSZ, OR, ABD, NONE, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, OR, OFIFO, NONE, SIZE(1), 0);
	MATHB(SEQINSZ, OR, ONE, NONE, SIZE(1), 0);
	MATHB(SEQINSZ, OR, ZERO, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, OR, MATH0, NONE, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, OR, MATH1, NONE, SIZE(2), 0);
	MATHB(SEQOUTSZ, OR, MATH2, NONE, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, OR, MATH3, NONE, SIZE(2), 0);
	MATHB(SEQOUTSZ, OR, IMM(393615378), NONE, SIZE(1), 0);
	MATHB(SEQOUTSZ, OR, DPOVRD, NONE, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, OR, VSEQINSZ, NONE, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, OR, VSEQOUTSZ, NONE, SIZE(8), 0);
	MATHB(SEQOUTSZ, OR, ABD, NONE, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, OR, OFIFO, NONE, SIZE(4), 0);
	MATHB(SEQOUTSZ, OR, ONE, NONE, SIZE(4), 0);
	MATHB(SEQOUTSZ, OR, ZERO, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, OR, MATH0, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQINSZ, OR, MATH1, NONE, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, OR, MATH2, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQINSZ, OR, MATH3, NONE, SIZE(1), 0);
	MATHB(VSEQINSZ, OR, IMM(393615378), NONE, SIZE(1), 0);
	MATHB(VSEQINSZ, OR, DPOVRD, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, OR, VSEQINSZ, NONE, SIZE(8), 0);
	MATHB(VSEQINSZ, OR, VSEQOUTSZ, NONE, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, OR, ABD, NONE, SIZE(4), 0);
	MATHB(VSEQINSZ, OR, OFIFO, NONE, SIZE(2), 0);
	MATHB(VSEQINSZ, OR, ONE, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, OR, ZERO, NONE, SIZE(1), 0);
	MATHB(VSEQOUTSZ, OR, MATH0, NONE, SIZE(8), 0);
	MATHB(VSEQOUTSZ, OR, MATH1, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, OR, MATH2, NONE, SIZE(2), 0);
	MATHB(VSEQOUTSZ, OR, MATH3, NONE, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, OR, IMM(393615378), NONE, SIZE(8), WITH(IFB));
	MATHB(VSEQOUTSZ, OR, DPOVRD, NONE, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, OR, VSEQINSZ, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, OR, VSEQOUTSZ, NONE, SIZE(8), 0);
	MATHB(VSEQOUTSZ, OR, ABD, NONE, SIZE(1), 0);
	MATHB(VSEQOUTSZ, OR, OFIFO, NONE, SIZE(4), 0);
	MATHB(VSEQOUTSZ, OR, ONE, NONE, SIZE(1), 0);
	MATHB(VSEQOUTSZ, OR, ZERO, NONE, SIZE(4), 0);
	MATHB(ZERO, OR, MATH0, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, OR, MATH1, NONE, SIZE(8), 0);
	MATHB(ZERO, OR, MATH2, NONE, SIZE(2), 0);
	MATHB(ZERO, OR, MATH3, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, OR, IMM(393615378), NONE, SIZE(4), 0);
	MATHB(ZERO, OR, DPOVRD, NONE, SIZE(1), 0);
	MATHB(ZERO, OR, VSEQINSZ, NONE, SIZE(1), WITH(NFU));
	MATHB(ZERO, OR, VSEQOUTSZ, NONE, SIZE(4), 0);
	MATHB(ZERO, OR, ABD, NONE, SIZE(4), WITH(STL));
	MATHB(ZERO, OR, OFIFO, NONE, SIZE(8), WITH(NFU));
	MATHB(ZERO, OR, ONE, NONE, SIZE(4), 0);
	MATHB(ZERO, OR, ZERO, NONE, SIZE(2), 0);
	MATHB(ONE, OR, MATH0, NONE, SIZE(2), 0);
	MATHB(ONE, OR, MATH1, NONE, SIZE(2), WITH(STL));
	MATHB(ONE, OR, MATH2, NONE, SIZE(1), 0);
	MATHB(ONE, OR, MATH3, NONE, SIZE(1), 0);
	MATHB(ONE, OR, IMM(393615378), NONE, SIZE(4), 0);
	MATHB(ONE, OR, DPOVRD, NONE, SIZE(2), 0);
	MATHB(ONE, OR, VSEQINSZ, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, OR, VSEQOUTSZ, NONE, SIZE(8), WITH(NFU));
	MATHB(ONE, OR, ABD, NONE, SIZE(8), 0);
	MATHB(ONE, OR, OFIFO, NONE, SIZE(4), WITH(NFU));
	MATHB(ONE, OR, ONE, NONE, SIZE(1), 0);
	MATHB(ONE, OR, ZERO, NONE, SIZE(8), WITH(NFU));
	/*AND Operation: MATH0 Destination register */
	MATHB(MATH0, AND, MATH0, MATH0, SIZE(2), 0);
	MATHB(MATH0, AND, MATH1, MATH0, SIZE(4), WITH(STL));
	MATHB(MATH0, AND, MATH2, MATH0, SIZE(4), WITH(STL));
	MATHB(MATH0, AND, MATH3, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(MATH0, AND, IMM(393615378), MATH0, SIZE(2), WITH(NFU));
	MATHB(MATH0, AND, DPOVRD, MATH0, SIZE(2), WITH(STL));
	MATHB(MATH0, AND, VSEQINSZ, MATH0, SIZE(8), 0);
	MATHB(MATH0, AND, VSEQOUTSZ, MATH0, SIZE(2), 0);
	MATHB(MATH0, AND, ABD, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, AND, OFIFO, MATH0, SIZE(8), WITH(NFU));
	MATHB(MATH0, AND, ONE, MATH0, SIZE(1), 0);
	MATHB(MATH0, AND, ZERO, MATH0, SIZE(4), 0);
	MATHB(MATH1, AND, MATH0, MATH0, SIZE(1), WITH(STL));
	MATHB(MATH1, AND, MATH1, MATH0, SIZE(8), 0);
	MATHB(MATH1, AND, MATH2, MATH0, SIZE(8), WITH(NFU | STL));
	MATHB(MATH1, AND, MATH3, MATH0, SIZE(4), 0);
	MATHB(MATH1, AND, IMM(393615378), MATH0, SIZE(4), 0);
	MATHB(MATH1, AND, DPOVRD, MATH0, SIZE(8), WITH(NFU));
	MATHB(MATH1, AND, VSEQINSZ, MATH0, SIZE(1), 0);
	MATHB(MATH1, AND, VSEQOUTSZ, MATH0, SIZE(2), 0);
	MATHB(MATH1, AND, ABD, MATH0, SIZE(2), 0);
	MATHB(MATH1, AND, OFIFO, MATH0, SIZE(2), WITH(STL));
	MATHB(MATH1, AND, ONE, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, AND, ZERO, MATH0, SIZE(8), 0);
	MATHB(MATH2, AND, MATH0, MATH0, SIZE(1), 0);
	MATHB(MATH2, AND, MATH1, MATH0, SIZE(4), WITH(NFU));
	MATHB(MATH2, AND, MATH2, MATH0, SIZE(8), WITH(STL));
	MATHB(MATH2, AND, MATH3, MATH0, SIZE(8), WITH(STL));
	MATHB(MATH2, AND, IMM(393615378), MATH0, SIZE(1), WITH(STL));
	MATHB(MATH2, AND, DPOVRD, MATH0, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, AND, VSEQINSZ, MATH0, SIZE(2), 0);
	MATHB(MATH2, AND, VSEQOUTSZ, MATH0, SIZE(1), 0);
	MATHB(MATH2, AND, ABD, MATH0, SIZE(4), 0);
	MATHB(MATH2, AND, OFIFO, MATH0, SIZE(1), 0);
	MATHB(MATH2, AND, ONE, MATH0, SIZE(2), 0);
	MATHB(MATH2, AND, ZERO, MATH0, SIZE(4), 0);
	MATHB(MATH3, AND, MATH0, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, AND, MATH1, MATH0, SIZE(4), WITH(NFU));
	MATHB(MATH3, AND, MATH2, MATH0, SIZE(8), WITH(NFU | STL));
	MATHB(MATH3, AND, MATH3, MATH0, SIZE(8), 0);
	MATHB(MATH3, AND, IMM(0x19261959fedcba01), MATH0, SIZE(8), 0);
	MATHB(MATH3, AND, DPOVRD, MATH0, SIZE(1), 0);
	MATHB(MATH3, AND, VSEQINSZ, MATH0, SIZE(4), 0);
	MATHB(MATH3, AND, VSEQOUTSZ, MATH0, SIZE(8), 0);
	MATHB(MATH3, AND, ABD, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, AND, OFIFO, MATH0, SIZE(4), 0);
	MATHB(MATH3, AND, ONE, MATH0, SIZE(4), 0);
	MATHB(MATH3, AND, ZERO, MATH0, SIZE(8), WITH(NFU | STL));
	MATHB(IMM(275128321), AND, MATH0, MATH0, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), AND, MATH1, MATH0, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), AND, MATH2, MATH0, SIZE(2), WITH(NFU));
	MATHB(IMM(275128321), AND, MATH3, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(275128321), AND, IMM(393615378), MATH0, SIZE(2), 0);
	MATHB(IMM(275128321), AND, DPOVRD, MATH0, SIZE(1), 0);
	MATHB(IMM(0x19261959fedcba01), AND, VSEQINSZ, MATH0, SIZE(8),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), AND, VSEQOUTSZ, MATH0, SIZE(2), 0);
	MATHB(IMM(275128321), AND, ABD, MATH0, SIZE(1), 0);
	MATHB(IMM(275128321), AND, OFIFO, MATH0, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), AND, ONE, MATH0, SIZE(4), 0);
	MATHB(IMM(275128321), AND, ZERO, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, AND, MATH0, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, AND, MATH1, MATH0, SIZE(4), 0);
	MATHB(DPOVRD, AND, MATH2, MATH0, SIZE(8), WITH(STL));
	MATHB(DPOVRD, AND, MATH3, MATH0, SIZE(2), 0);
	MATHB(DPOVRD, AND, IMM(0x19261959fedcba01), MATH0, SIZE(8), 0);
	MATHB(DPOVRD, AND, DPOVRD, MATH0, SIZE(2), WITH(STL));
	MATHB(DPOVRD, AND, VSEQINSZ, MATH0, SIZE(8), 0);
	MATHB(DPOVRD, AND, VSEQOUTSZ, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, AND, ABD, MATH0, SIZE(1), 0);
	MATHB(DPOVRD, AND, OFIFO, MATH0, SIZE(2), 0);
	MATHB(DPOVRD, AND, ONE, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, AND, ZERO, MATH0, SIZE(4), 0);
	MATHB(SEQINSZ, AND, MATH0, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(SEQINSZ, AND, MATH1, MATH0, SIZE(1), 0);
	MATHB(SEQINSZ, AND, MATH2, MATH0, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, AND, MATH3, MATH0, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, AND, IMM(393615378), MATH0, SIZE(1), 0);
	MATHB(SEQINSZ, AND, DPOVRD, MATH0, SIZE(2), 0);
	MATHB(SEQINSZ, AND, VSEQINSZ, MATH0, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, AND, VSEQOUTSZ, MATH0, SIZE(1), 0);
	MATHB(SEQINSZ, AND, ABD, MATH0, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, AND, OFIFO, MATH0, SIZE(1), 0);
	MATHB(SEQINSZ, AND, ONE, MATH0, SIZE(1), 0);
	MATHB(SEQINSZ, AND, ZERO, MATH0, SIZE(8), WITH(NFU | STL));
	MATHB(SEQOUTSZ, AND, MATH0, MATH0, SIZE(2), 0);
	MATHB(SEQOUTSZ, AND, MATH1, MATH0, SIZE(8), WITH(NFU));
	MATHB(SEQOUTSZ, AND, MATH2, MATH0, SIZE(8), WITH(NFU));
	MATHB(SEQOUTSZ, AND, MATH3, MATH0, SIZE(4), 0);
	MATHB(SEQOUTSZ, AND, IMM(393615378), MATH0, SIZE(2), 0);
	MATHB(SEQOUTSZ, AND, DPOVRD, MATH0, SIZE(4), 0);
	MATHB(SEQOUTSZ, AND, VSEQINSZ, MATH0, SIZE(1), 0);
	MATHB(SEQOUTSZ, AND, VSEQOUTSZ, MATH0, SIZE(8), WITH(NFU));
	MATHB(SEQOUTSZ, AND, ABD, MATH0, SIZE(4), 0);
	MATHB(SEQOUTSZ, AND, OFIFO, MATH0, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, AND, ONE, MATH0, SIZE(8), WITH(NFU));
	MATHB(SEQOUTSZ, AND, ZERO, MATH0, SIZE(1), 0);
	MATHB(VSEQINSZ, AND, MATH0, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, AND, MATH1, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQINSZ, AND, MATH2, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, AND, MATH3, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, AND, IMM(393615378), MATH0, SIZE(1), 0);
	MATHB(VSEQINSZ, AND, DPOVRD, MATH0, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, AND, VSEQINSZ, MATH0, SIZE(2), 0);
	MATHB(VSEQINSZ, AND, VSEQOUTSZ, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, AND, ABD, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQINSZ, AND, OFIFO, MATH0, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, AND, ONE, MATH0, SIZE(8), 0);
	MATHB(VSEQINSZ, AND, ZERO, MATH0, SIZE(4), 0);
	MATHB(VSEQOUTSZ, AND, MATH0, MATH0, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, AND, MATH1, MATH0, SIZE(2), 0);
	MATHB(VSEQOUTSZ, AND, MATH2, MATH0, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, AND, MATH3, MATH0, SIZE(2), 0);
	MATHB(VSEQOUTSZ, AND, IMM(393615378), MATH0, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, AND, DPOVRD, MATH0, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, AND, VSEQINSZ, MATH0, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, AND, VSEQOUTSZ, MATH0, SIZE(4), 0);
	MATHB(VSEQOUTSZ, AND, ABD, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, AND, OFIFO, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, AND, ONE, MATH0, SIZE(8), 0);
	MATHB(VSEQOUTSZ, AND, ZERO, MATH0, SIZE(4), 0);
	MATHB(ZERO, AND, MATH0, MATH0, SIZE(1), 0);
	MATHB(ZERO, AND, MATH1, MATH0, SIZE(4), WITH(NFU));
	MATHB(ZERO, AND, MATH2, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, AND, MATH3, MATH0, SIZE(4), WITH(NFU));
	MATHB(ZERO, AND, IMM(393615378), MATH0, SIZE(4), 0);
	MATHB(ZERO, AND, DPOVRD, MATH0, SIZE(1), 0);
	MATHB(ZERO, AND, VSEQINSZ, MATH0, SIZE(8), 0);
	MATHB(ZERO, AND, VSEQOUTSZ, MATH0, SIZE(4), 0);
	MATHB(ZERO, AND, ABD, MATH0, SIZE(4), WITH(NFU));
	MATHB(ZERO, AND, OFIFO, MATH0, SIZE(2), 0);
	MATHB(ZERO, AND, ONE, MATH0, SIZE(2), 0);
	MATHB(ZERO, AND, ZERO, MATH0, SIZE(2), WITH(NFU));
	MATHB(ONE, AND, MATH0, MATH0, SIZE(8), 0);
	MATHB(ONE, AND, MATH1, MATH0, SIZE(1), 0);
	MATHB(ONE, AND, MATH2, MATH0, SIZE(2), 0);
	MATHB(ONE, AND, MATH3, MATH0, SIZE(2), WITH(STL));
	MATHB(ONE, AND, IMM(393615378), MATH0, SIZE(8), WITH(IFB));
	MATHB(ONE, AND, DPOVRD, MATH0, SIZE(1), WITH(STL));
	MATHB(ONE, AND, VSEQINSZ, MATH0, SIZE(1), WITH(STL));
	MATHB(ONE, AND, VSEQOUTSZ, MATH0, SIZE(1), 0);
	MATHB(ONE, AND, ABD, MATH0, SIZE(4), 0);
	MATHB(ONE, AND, OFIFO, MATH0, SIZE(4), 0);
	MATHB(ONE, AND, ONE, MATH0, SIZE(2), WITH(NFU));
	MATHB(ONE, AND, ZERO, MATH0, SIZE(4), 0);
	/*AND Operation: MATH1 Destination register */
	MATHB(MATH0, AND, MATH0, MATH1, SIZE(1), WITH(STL));
	MATHB(MATH0, AND, MATH1, MATH1, SIZE(8), 0);
	MATHB(MATH0, AND, MATH2, MATH1, SIZE(4), WITH(STL));
	MATHB(MATH0, AND, MATH3, MATH1, SIZE(2), 0);
	MATHB(MATH0, AND, IMM(393615378), MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(MATH0, AND, DPOVRD, MATH1, SIZE(8), 0);
	MATHB(MATH0, AND, VSEQINSZ, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, AND, VSEQOUTSZ, MATH1, SIZE(8), WITH(NFU));
	MATHB(MATH0, AND, ABD, MATH1, SIZE(2), 0);
	MATHB(MATH0, AND, OFIFO, MATH1, SIZE(4), 0);
	MATHB(MATH0, AND, ONE, MATH1, SIZE(8), 0);
	MATHB(MATH0, AND, ZERO, MATH1, SIZE(2), 0);
	MATHB(MATH1, AND, MATH0, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(MATH1, AND, MATH1, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(MATH1, AND, MATH2, MATH1, SIZE(2), WITH(NFU));
	MATHB(MATH1, AND, MATH3, MATH1, SIZE(2), 0);
	MATHB(MATH1, AND, IMM(393615378), MATH1, SIZE(4), WITH(STL));
	MATHB(MATH1, AND, DPOVRD, MATH1, SIZE(1), 0);
	MATHB(MATH1, AND, VSEQINSZ, MATH1, SIZE(4), 0);
	MATHB(MATH1, AND, VSEQOUTSZ, MATH1, SIZE(1), 0);
	MATHB(MATH1, AND, ABD, MATH1, SIZE(4), 0);
	MATHB(MATH1, AND, OFIFO, MATH1, SIZE(4), WITH(STL));
	MATHB(MATH1, AND, ONE, MATH1, SIZE(1), WITH(STL));
	MATHB(MATH1, AND, ZERO, MATH1, SIZE(4), WITH(NFU));
	MATHB(MATH2, AND, MATH0, MATH1, SIZE(8), 0);
	MATHB(MATH2, AND, MATH1, MATH1, SIZE(8), 0);
	MATHB(MATH2, AND, MATH2, MATH1, SIZE(1), 0);
	MATHB(MATH2, AND, MATH3, MATH1, SIZE(1), WITH(STL));
	MATHB(MATH2, AND, IMM(393615378), MATH1, SIZE(4), WITH(NFU));
	MATHB(MATH2, AND, DPOVRD, MATH1, SIZE(8), WITH(NFU));
	MATHB(MATH2, AND, VSEQINSZ, MATH1, SIZE(1), WITH(NFU));
	MATHB(MATH2, AND, VSEQOUTSZ, MATH1, SIZE(4), 0);
	MATHB(MATH2, AND, ABD, MATH1, SIZE(4), WITH(NFU));
	MATHB(MATH2, AND, OFIFO, MATH1, SIZE(8), 0);
	MATHB(MATH2, AND, ONE, MATH1, SIZE(1), WITH(NFU));
	MATHB(MATH2, AND, ZERO, MATH1, SIZE(2), 0);
	MATHB(MATH3, AND, MATH0, MATH1, SIZE(8), 0);
	MATHB(MATH3, AND, MATH1, MATH1, SIZE(8), WITH(NFU));
	MATHB(MATH3, AND, MATH2, MATH1, SIZE(8), 0);
	MATHB(MATH3, AND, MATH3, MATH1, SIZE(2), 0);
	MATHB(MATH3, AND, IMM(393615378), MATH1, SIZE(8), WITH(IFB));
	MATHB(MATH3, AND, DPOVRD, MATH1, SIZE(2), 0);
	MATHB(MATH3, AND, VSEQINSZ, MATH1, SIZE(8), WITH(NFU));
	MATHB(MATH3, AND, VSEQOUTSZ, MATH1, SIZE(2), WITH(STL));
	MATHB(MATH3, AND, ABD, MATH1, SIZE(2), 0);
	MATHB(MATH3, AND, OFIFO, MATH1, SIZE(2), WITH(STL));
	MATHB(MATH3, AND, ONE, MATH1, SIZE(8), 0);
	MATHB(MATH3, AND, ZERO, MATH1, SIZE(2), 0);
	MATHB(IMM(275128321), AND, MATH0, MATH1, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), AND, MATH1, MATH1, SIZE(4), 0);
	MATHB(IMM(275128321), AND, MATH2, MATH1, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), AND, MATH3, MATH1, SIZE(2), WITH(NFU));
	MATHB(IMM(275128321), AND, IMM(393615378), MATH1, SIZE(4), 0);
	MATHB(IMM(275128321), AND, DPOVRD, MATH1, SIZE(2), 0);
	MATHB(IMM(275128321), AND, VSEQINSZ, MATH1, SIZE(1), 0);
	MATHB(IMM(275128321), AND, VSEQOUTSZ, MATH1, SIZE(2), 0);
	MATHB(IMM(0x19261959fedcba01), AND, ABD, MATH1, SIZE(8), 0);
	MATHB(IMM(275128321), AND, OFIFO, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(275128321), AND, ONE, MATH1, SIZE(2), WITH(STL));
	MATHB(IMM(0x19261959fedcba01), AND, ZERO, MATH1, SIZE(8), 0);
	MATHB(DPOVRD, AND, MATH0, MATH1, SIZE(4), 0);
	MATHB(DPOVRD, AND, MATH1, MATH1, SIZE(1), WITH(STL));
	MATHB(DPOVRD, AND, MATH2, MATH1, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, AND, MATH3, MATH1, SIZE(1), 0);
	MATHB(DPOVRD, AND, IMM(0x19261959fedcba01), MATH1, SIZE(8), 0);
	MATHB(DPOVRD, AND, DPOVRD, MATH1, SIZE(1), 0);
	MATHB(DPOVRD, AND, VSEQINSZ, MATH1, SIZE(4), 0);
	MATHB(DPOVRD, AND, VSEQOUTSZ, MATH1, SIZE(4), 0);
	MATHB(DPOVRD, AND, ABD, MATH1, SIZE(1), WITH(STL));
	MATHB(DPOVRD, AND, OFIFO, MATH1, SIZE(4), 0);
	MATHB(DPOVRD, AND, ONE, MATH1, SIZE(8), 0);
	MATHB(DPOVRD, AND, ZERO, MATH1, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, AND, MATH0, MATH1, SIZE(8), 0);
	MATHB(SEQINSZ, AND, MATH1, MATH1, SIZE(8), 0);
	MATHB(SEQINSZ, AND, MATH2, MATH1, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, AND, MATH3, MATH1, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, AND, IMM(393615378), MATH1, SIZE(4), 0);
	MATHB(SEQINSZ, AND, DPOVRD, MATH1, SIZE(1), 0);
	MATHB(SEQINSZ, AND, VSEQINSZ, MATH1, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, AND, VSEQOUTSZ, MATH1, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, AND, ABD, MATH1, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, AND, OFIFO, MATH1, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, AND, ONE, MATH1, SIZE(2), 0);
	MATHB(SEQINSZ, AND, ZERO, MATH1, SIZE(4), 0);
	MATHB(SEQOUTSZ, AND, MATH0, MATH1, SIZE(4), 0);
	MATHB(SEQOUTSZ, AND, MATH1, MATH1, SIZE(4), 0);
	MATHB(SEQOUTSZ, AND, MATH2, MATH1, SIZE(4), 0);
	MATHB(SEQOUTSZ, AND, MATH3, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, AND, IMM(393615378), MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, AND, DPOVRD, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, AND, VSEQINSZ, MATH1, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, AND, VSEQOUTSZ, MATH1, SIZE(2), 0);
	MATHB(SEQOUTSZ, AND, ABD, MATH1, SIZE(2), 0);
	MATHB(SEQOUTSZ, AND, OFIFO, MATH1, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, AND, ONE, MATH1, SIZE(8), 0);
	MATHB(SEQOUTSZ, AND, ZERO, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, AND, MATH0, MATH1, SIZE(8), 0);
	MATHB(VSEQINSZ, AND, MATH1, MATH1, SIZE(2), 0);
	MATHB(VSEQINSZ, AND, MATH2, MATH1, SIZE(1), 0);
	MATHB(VSEQINSZ, AND, MATH3, MATH1, SIZE(4), 0);
	MATHB(VSEQINSZ, AND, IMM(393615378), MATH1, SIZE(8), WITH(IFB));
	MATHB(VSEQINSZ, AND, DPOVRD, MATH1, SIZE(8), 0);
	MATHB(VSEQINSZ, AND, VSEQINSZ, MATH1, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, AND, VSEQOUTSZ, MATH1, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, AND, ABD, MATH1, SIZE(1), 0);
	MATHB(VSEQINSZ, AND, OFIFO, MATH1, SIZE(8), 0);
	MATHB(VSEQINSZ, AND, ONE, MATH1, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, AND, ZERO, MATH1, SIZE(2), 0);
	MATHB(VSEQOUTSZ, AND, MATH0, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, AND, MATH1, MATH1, SIZE(4), 0);
	MATHB(VSEQOUTSZ, AND, MATH2, MATH1, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, AND, MATH3, MATH1, SIZE(1), 0);
	MATHB(VSEQOUTSZ, AND, IMM(393615378), MATH1, SIZE(8), WITH(IFB));
	MATHB(VSEQOUTSZ, AND, DPOVRD, MATH1, SIZE(1), 0);
	MATHB(VSEQOUTSZ, AND, VSEQINSZ, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, AND, VSEQOUTSZ, MATH1, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, AND, ABD, MATH1, SIZE(1), 0);
	MATHB(VSEQOUTSZ, AND, OFIFO, MATH1, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, AND, ONE, MATH1, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, AND, ZERO, MATH1, SIZE(2), 0);
	MATHB(ZERO, AND, MATH0, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, AND, MATH1, MATH1, SIZE(4), 0);
	MATHB(ZERO, AND, MATH2, MATH1, SIZE(8), WITH(NFU));
	MATHB(ZERO, AND, MATH3, MATH1, SIZE(4), 0);
	MATHB(ZERO, AND, IMM(393615378), MATH1, SIZE(2), 0);
	MATHB(ZERO, AND, DPOVRD, MATH1, SIZE(4), 0);
	MATHB(ZERO, AND, VSEQINSZ, MATH1, SIZE(4), 0);
	MATHB(ZERO, AND, VSEQOUTSZ, MATH1, SIZE(2), WITH(NFU));
	MATHB(ZERO, AND, ABD, MATH1, SIZE(1), 0);
	MATHB(ZERO, AND, OFIFO, MATH1, SIZE(1), 0);
	MATHB(ZERO, AND, ONE, MATH1, SIZE(8), WITH(NFU));
	MATHB(ZERO, AND, ZERO, MATH1, SIZE(2), 0);
	MATHB(ONE, AND, MATH0, MATH1, SIZE(4), 0);
	MATHB(ONE, AND, MATH1, MATH1, SIZE(8), 0);
	MATHB(ONE, AND, MATH2, MATH1, SIZE(4), WITH(STL));
	MATHB(ONE, AND, MATH3, MATH1, SIZE(4), WITH(STL));
	MATHB(ONE, AND, IMM(393615378), MATH1, SIZE(8), WITH(IFB | STL));
	MATHB(ONE, AND, DPOVRD, MATH1, SIZE(8), 0);
	MATHB(ONE, AND, VSEQINSZ, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, AND, VSEQOUTSZ, MATH1, SIZE(2), 0);
	MATHB(ONE, AND, ABD, MATH1, SIZE(2), WITH(STL));
	MATHB(ONE, AND, OFIFO, MATH1, SIZE(4), 0);
	MATHB(ONE, AND, ONE, MATH1, SIZE(2), 0);
	MATHB(ONE, AND, ZERO, MATH1, SIZE(4), 0);
	/*AND Operation: MATH2 Destination register */
	MATHB(MATH0, AND, MATH0, MATH2, SIZE(8), 0);
	MATHB(MATH0, AND, MATH1, MATH2, SIZE(8), WITH(NFU));
	MATHB(MATH0, AND, MATH2, MATH2, SIZE(1), WITH(NFU));
	MATHB(MATH0, AND, MATH3, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(MATH0, AND, IMM(393615378), MATH2, SIZE(4), 0);
	MATHB(MATH0, AND, DPOVRD, MATH2, SIZE(4), WITH(NFU));
	MATHB(MATH0, AND, VSEQINSZ, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, AND, VSEQOUTSZ, MATH2, SIZE(1), 0);
	MATHB(MATH0, AND, ABD, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(MATH0, AND, OFIFO, MATH2, SIZE(1), 0);
	MATHB(MATH0, AND, ONE, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, AND, ZERO, MATH2, SIZE(2), 0);
	MATHB(MATH1, AND, MATH0, MATH2, SIZE(1), 0);
	MATHB(MATH1, AND, MATH1, MATH2, SIZE(4), 0);
	MATHB(MATH1, AND, MATH2, MATH2, SIZE(2), WITH(NFU));
	MATHB(MATH1, AND, MATH3, MATH2, SIZE(2), WITH(NFU));
	MATHB(MATH1, AND, IMM(393615378), MATH2, SIZE(4), 0);
	MATHB(MATH1, AND, DPOVRD, MATH2, SIZE(1), WITH(NFU));
	MATHB(MATH1, AND, VSEQINSZ, MATH2, SIZE(2), 0);
	MATHB(MATH1, AND, VSEQOUTSZ, MATH2, SIZE(4), WITH(STL));
	MATHB(MATH1, AND, ABD, MATH2, SIZE(1), 0);
	MATHB(MATH1, AND, OFIFO, MATH2, SIZE(8), 0);
	MATHB(MATH1, AND, ONE, MATH2, SIZE(4), WITH(STL));
	MATHB(MATH1, AND, ZERO, MATH2, SIZE(2), 0);
	MATHB(MATH2, AND, MATH0, MATH2, SIZE(2), 0);
	MATHB(MATH2, AND, MATH1, MATH2, SIZE(4), WITH(STL));
	MATHB(MATH2, AND, MATH2, MATH2, SIZE(8), 0);
	MATHB(MATH2, AND, MATH3, MATH2, SIZE(1), 0);
	MATHB(MATH2, AND, IMM(393615378), MATH2, SIZE(8), WITH(IFB));
	MATHB(MATH2, AND, DPOVRD, MATH2, SIZE(4), WITH(STL));
	MATHB(MATH2, AND, VSEQINSZ, MATH2, SIZE(2), WITH(STL));
	MATHB(MATH2, AND, VSEQOUTSZ, MATH2, SIZE(1), 0);
	MATHB(MATH2, AND, ABD, MATH2, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, AND, OFIFO, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, AND, ONE, MATH2, SIZE(2), 0);
	MATHB(MATH2, AND, ZERO, MATH2, SIZE(2), 0);
	MATHB(MATH3, AND, MATH0, MATH2, SIZE(2), 0);
	MATHB(MATH3, AND, MATH1, MATH2, SIZE(4), 0);
	MATHB(MATH3, AND, MATH2, MATH2, SIZE(1), 0);
	MATHB(MATH3, AND, MATH3, MATH2, SIZE(8), 0);
	MATHB(MATH3, AND, IMM(393615378), MATH2, SIZE(2), 0);
	MATHB(MATH3, AND, DPOVRD, MATH2, SIZE(1), 0);
	MATHB(MATH3, AND, VSEQINSZ, MATH2, SIZE(8), 0);
	MATHB(MATH3, AND, VSEQOUTSZ, MATH2, SIZE(8), 0);
	MATHB(MATH3, AND, ABD, MATH2, SIZE(1), 0);
	MATHB(MATH3, AND, OFIFO, MATH2, SIZE(4), 0);
	MATHB(MATH3, AND, ONE, MATH2, SIZE(2), 0);
	MATHB(MATH3, AND, ZERO, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(0x19261959fedcba01), AND, MATH0, MATH2, SIZE(8), WITH(STL));
	MATHB(IMM(275128321), AND, MATH1, MATH2, SIZE(2), WITH(NFU));
	MATHB(IMM(275128321), AND, MATH2, MATH2, SIZE(4), WITH(STL));
	MATHB(IMM(0x19261959fedcba01), AND, MATH3, MATH2, SIZE(8), WITH(NFU));
	MATHB(IMM(275128321), AND, IMM(393615378), MATH2, SIZE(4), 0);
	MATHB(IMM(0x19261959fedcba01), AND, DPOVRD, MATH2, SIZE(8),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), AND, VSEQINSZ, MATH2, SIZE(2), 0);
	MATHB(IMM(275128321), AND, VSEQOUTSZ, MATH2, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), AND, ABD, MATH2, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), AND, OFIFO, MATH2, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), AND, ONE, MATH2, SIZE(4), 0);
	MATHB(IMM(275128321), AND, ZERO, MATH2, SIZE(1), 0);
	MATHB(DPOVRD, AND, MATH0, MATH2, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, AND, MATH1, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, AND, MATH2, MATH2, SIZE(8), WITH(STL));
	MATHB(DPOVRD, AND, MATH3, MATH2, SIZE(1), 0);
	MATHB(DPOVRD, AND, IMM(393615378), MATH2, SIZE(2), WITH(STL));
	MATHB(DPOVRD, AND, DPOVRD, MATH2, SIZE(2), 0);
	MATHB(DPOVRD, AND, VSEQINSZ, MATH2, SIZE(2), 0);
	MATHB(DPOVRD, AND, VSEQOUTSZ, MATH2, SIZE(1), WITH(STL));
	MATHB(DPOVRD, AND, ABD, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, AND, OFIFO, MATH2, SIZE(2), 0);
	MATHB(DPOVRD, AND, ONE, MATH2, SIZE(2), 0);
	MATHB(DPOVRD, AND, ZERO, MATH2, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, AND, MATH0, MATH2, SIZE(1), 0);
	MATHB(SEQINSZ, AND, MATH1, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, AND, MATH2, MATH2, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, AND, MATH3, MATH2, SIZE(1), 0);
	MATHB(SEQINSZ, AND, IMM(393615378), MATH2, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, AND, DPOVRD, MATH2, SIZE(1), 0);
	MATHB(SEQINSZ, AND, VSEQINSZ, MATH2, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, AND, VSEQOUTSZ, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, AND, ABD, MATH2, SIZE(2), 0);
	MATHB(SEQINSZ, AND, OFIFO, MATH2, SIZE(8), 0);
	MATHB(SEQINSZ, AND, ONE, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, AND, ZERO, MATH2, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, AND, MATH0, MATH2, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, AND, MATH1, MATH2, SIZE(1), 0);
	MATHB(SEQOUTSZ, AND, MATH2, MATH2, SIZE(2), 0);
	MATHB(SEQOUTSZ, AND, MATH3, MATH2, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, AND, IMM(393615378), MATH2, SIZE(8), WITH(IFB));
	MATHB(SEQOUTSZ, AND, DPOVRD, MATH2, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, AND, VSEQINSZ, MATH2, SIZE(2), 0);
	MATHB(SEQOUTSZ, AND, VSEQOUTSZ, MATH2, SIZE(4), 0);
	MATHB(SEQOUTSZ, AND, ABD, MATH2, SIZE(8), 0);
	MATHB(SEQOUTSZ, AND, OFIFO, MATH2, SIZE(2), 0);
	MATHB(SEQOUTSZ, AND, ONE, MATH2, SIZE(8), 0);
	MATHB(SEQOUTSZ, AND, ZERO, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, AND, MATH0, MATH2, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, AND, MATH1, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, AND, MATH2, MATH2, SIZE(1), 0);
	MATHB(VSEQINSZ, AND, MATH3, MATH2, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, AND, IMM(393615378), MATH2, SIZE(4), 0);
	MATHB(VSEQINSZ, AND, DPOVRD, MATH2, SIZE(1), 0);
	MATHB(VSEQINSZ, AND, VSEQINSZ, MATH2, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, AND, VSEQOUTSZ, MATH2, SIZE(1), 0);
	MATHB(VSEQINSZ, AND, ABD, MATH2, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, AND, OFIFO, MATH2, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, AND, ONE, MATH2, SIZE(8), 0);
	MATHB(VSEQINSZ, AND, ZERO, MATH2, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, AND, MATH0, MATH2, SIZE(2), 0);
	MATHB(VSEQOUTSZ, AND, MATH1, MATH2, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, AND, MATH2, MATH2, SIZE(8), 0);
	MATHB(VSEQOUTSZ, AND, MATH3, MATH2, SIZE(1), 0);
	MATHB(VSEQOUTSZ, AND, IMM(393615378), MATH2, SIZE(4), 0);
	MATHB(VSEQOUTSZ, AND, DPOVRD, MATH2, SIZE(1), 0);
	MATHB(VSEQOUTSZ, AND, VSEQINSZ, MATH2, SIZE(1), 0);
	MATHB(VSEQOUTSZ, AND, VSEQOUTSZ, MATH2, SIZE(2), 0);
	MATHB(VSEQOUTSZ, AND, ABD, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, AND, OFIFO, MATH2, SIZE(4), 0);
	MATHB(VSEQOUTSZ, AND, ONE, MATH2, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, AND, ZERO, MATH2, SIZE(1), 0);
	MATHB(ZERO, AND, MATH0, MATH2, SIZE(2), 0);
	MATHB(ZERO, AND, MATH1, MATH2, SIZE(4), WITH(STL));
	MATHB(ZERO, AND, MATH2, MATH2, SIZE(2), 0);
	MATHB(ZERO, AND, MATH3, MATH2, SIZE(1), 0);
	MATHB(ZERO, AND, IMM(393615378), MATH2, SIZE(2), 0);
	MATHB(ZERO, AND, DPOVRD, MATH2, SIZE(2), 0);
	MATHB(ZERO, AND, VSEQINSZ, MATH2, SIZE(1), 0);
	MATHB(ZERO, AND, VSEQOUTSZ, MATH2, SIZE(4), 0);
	MATHB(ZERO, AND, ABD, MATH2, SIZE(1), 0);
	MATHB(ZERO, AND, OFIFO, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, AND, ONE, MATH2, SIZE(2), WITH(STL));
	MATHB(ZERO, AND, ZERO, MATH2, SIZE(8), 0);
	MATHB(ONE, AND, MATH0, MATH2, SIZE(4), 0);
	MATHB(ONE, AND, MATH1, MATH2, SIZE(1), 0);
	MATHB(ONE, AND, MATH2, MATH2, SIZE(2), WITH(NFU));
	MATHB(ONE, AND, MATH3, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, AND, IMM(393615378), MATH2, SIZE(4), WITH(NFU));
	MATHB(ONE, AND, DPOVRD, MATH2, SIZE(2), 0);
	MATHB(ONE, AND, VSEQINSZ, MATH2, SIZE(8), 0);
	MATHB(ONE, AND, VSEQOUTSZ, MATH2, SIZE(8), WITH(STL));
	MATHB(ONE, AND, ABD, MATH2, SIZE(4), 0);
	MATHB(ONE, AND, OFIFO, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, AND, ONE, MATH2, SIZE(8), 0);
	MATHB(ONE, AND, ZERO, MATH2, SIZE(2), 0);
	/*AND Operation: MATH3 Destination register */
	MATHB(MATH0, AND, MATH0, MATH3, SIZE(8), 0);
	MATHB(MATH0, AND, MATH1, MATH3, SIZE(2), 0);
	MATHB(MATH0, AND, MATH2, MATH3, SIZE(4), 0);
	MATHB(MATH0, AND, MATH3, MATH3, SIZE(4), WITH(STL));
	MATHB(MATH0, AND, IMM(393615378), MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, AND, DPOVRD, MATH3, SIZE(1), 0);
	MATHB(MATH0, AND, VSEQINSZ, MATH3, SIZE(8), 0);
	MATHB(MATH0, AND, VSEQOUTSZ, MATH3, SIZE(8), WITH(STL));
	MATHB(MATH0, AND, ABD, MATH3, SIZE(4), 0);
	MATHB(MATH0, AND, OFIFO, MATH3, SIZE(4), 0);
	MATHB(MATH0, AND, ONE, MATH3, SIZE(4), 0);
	MATHB(MATH0, AND, ZERO, MATH3, SIZE(4), 0);
	MATHB(MATH1, AND, MATH0, MATH3, SIZE(2), 0);
	MATHB(MATH1, AND, MATH1, MATH3, SIZE(1), 0);
	MATHB(MATH1, AND, MATH2, MATH3, SIZE(4), 0);
	MATHB(MATH1, AND, MATH3, MATH3, SIZE(4), 0);
	MATHB(MATH1, AND, IMM(393615378), MATH3, SIZE(2), WITH(NFU));
	MATHB(MATH1, AND, DPOVRD, MATH3, SIZE(1), WITH(NFU));
	MATHB(MATH1, AND, VSEQINSZ, MATH3, SIZE(8), WITH(STL));
	MATHB(MATH1, AND, VSEQOUTSZ, MATH3, SIZE(8), WITH(NFU));
	MATHB(MATH1, AND, ABD, MATH3, SIZE(1), 0);
	MATHB(MATH1, AND, OFIFO, MATH3, SIZE(1), 0);
	MATHB(MATH1, AND, ONE, MATH3, SIZE(2), WITH(NFU));
	MATHB(MATH1, AND, ZERO, MATH3, SIZE(8), WITH(STL));
	MATHB(MATH2, AND, MATH0, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, AND, MATH1, MATH3, SIZE(2), 0);
	MATHB(MATH2, AND, MATH2, MATH3, SIZE(4), 0);
	MATHB(MATH2, AND, MATH3, MATH3, SIZE(8), 0);
	MATHB(MATH2, AND, IMM(393615378), MATH3, SIZE(4), 0);
	MATHB(MATH2, AND, DPOVRD, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, AND, VSEQINSZ, MATH3, SIZE(8), WITH(STL));
	MATHB(MATH2, AND, VSEQOUTSZ, MATH3, SIZE(1), 0);
	MATHB(MATH2, AND, ABD, MATH3, SIZE(8), 0);
	MATHB(MATH2, AND, OFIFO, MATH3, SIZE(2), WITH(NFU));
	MATHB(MATH2, AND, ONE, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, AND, ZERO, MATH3, SIZE(2), WITH(STL));
	MATHB(MATH3, AND, MATH0, MATH3, SIZE(8), 0);
	MATHB(MATH3, AND, MATH1, MATH3, SIZE(1), WITH(NFU));
	MATHB(MATH3, AND, MATH2, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, AND, MATH3, MATH3, SIZE(4), 0);
	MATHB(MATH3, AND, IMM(393615378), MATH3, SIZE(1), 0);
	MATHB(MATH3, AND, DPOVRD, MATH3, SIZE(1), WITH(STL));
	MATHB(MATH3, AND, VSEQINSZ, MATH3, SIZE(2), 0);
	MATHB(MATH3, AND, VSEQOUTSZ, MATH3, SIZE(2), WITH(NFU));
	MATHB(MATH3, AND, ABD, MATH3, SIZE(4), 0);
	MATHB(MATH3, AND, OFIFO, MATH3, SIZE(4), WITH(STL));
	MATHB(MATH3, AND, ONE, MATH3, SIZE(1), 0);
	MATHB(MATH3, AND, ZERO, MATH3, SIZE(1), 0);
	MATHB(IMM(275128321), AND, MATH0, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), AND, MATH1, MATH3, SIZE(2), 0);
	MATHB(IMM(275128321), AND, MATH2, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(275128321), AND, MATH3, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), AND, IMM(393615378), MATH3, SIZE(2), 0);
	MATHB(IMM(275128321), AND, DPOVRD, MATH3, SIZE(1), 0);
	MATHB(IMM(0x19261959fedcba01), AND, VSEQINSZ, MATH3, SIZE(8), 0);
	MATHB(IMM(275128321), AND, VSEQOUTSZ, MATH3, SIZE(2), WITH(NFU));
	MATHB(IMM(0x19261959fedcba01), AND, ABD, MATH3, SIZE(8), 0);
	MATHB(IMM(0x19261959fedcba01), AND, OFIFO, MATH3, SIZE(8), 0);
	MATHB(IMM(275128321), AND, ONE, MATH3, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), AND, ZERO, MATH3, SIZE(1), 0);
	MATHB(DPOVRD, AND, MATH0, MATH3, SIZE(8), 0);
	MATHB(DPOVRD, AND, MATH1, MATH3, SIZE(8), 0);
	MATHB(DPOVRD, AND, MATH2, MATH3, SIZE(8), WITH(STL));
	MATHB(DPOVRD, AND, MATH3, MATH3, SIZE(1), 0);
	MATHB(DPOVRD, AND, IMM(393615378), MATH3, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, AND, DPOVRD, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, AND, VSEQINSZ, MATH3, SIZE(4), 0);
	MATHB(DPOVRD, AND, VSEQOUTSZ, MATH3, SIZE(8), 0);
	MATHB(DPOVRD, AND, ABD, MATH3, SIZE(4), 0);
	MATHB(DPOVRD, AND, OFIFO, MATH3, SIZE(8), 0);
	MATHB(DPOVRD, AND, ONE, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(DPOVRD, AND, ZERO, MATH3, SIZE(8), 0);
	MATHB(SEQINSZ, AND, MATH0, MATH3, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, AND, MATH1, MATH3, SIZE(4), 0);
	MATHB(SEQINSZ, AND, MATH2, MATH3, SIZE(8), 0);
	MATHB(SEQINSZ, AND, MATH3, MATH3, SIZE(4), 0);
	MATHB(SEQINSZ, AND, IMM(393615378), MATH3, SIZE(8), WITH(IFB));
	MATHB(SEQINSZ, AND, DPOVRD, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(SEQINSZ, AND, VSEQINSZ, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, AND, VSEQOUTSZ, MATH3, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, AND, ABD, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, AND, OFIFO, MATH3, SIZE(2), 0);
	MATHB(SEQINSZ, AND, ONE, MATH3, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, AND, ZERO, MATH3, SIZE(2), 0);
	MATHB(SEQOUTSZ, AND, MATH0, MATH3, SIZE(8), 0);
	MATHB(SEQOUTSZ, AND, MATH1, MATH3, SIZE(1), 0);
	MATHB(SEQOUTSZ, AND, MATH2, MATH3, SIZE(1), 0);
	MATHB(SEQOUTSZ, AND, MATH3, MATH3, SIZE(8), 0);
	MATHB(SEQOUTSZ, AND, IMM(393615378), MATH3, SIZE(1), 0);
	MATHB(SEQOUTSZ, AND, DPOVRD, MATH3, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, AND, VSEQINSZ, MATH3, SIZE(2), 0);
	MATHB(SEQOUTSZ, AND, VSEQOUTSZ, MATH3, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, AND, ABD, MATH3, SIZE(4), 0);
	MATHB(SEQOUTSZ, AND, OFIFO, MATH3, SIZE(1), 0);
	MATHB(SEQOUTSZ, AND, ONE, MATH3, SIZE(2), 0);
	MATHB(SEQOUTSZ, AND, ZERO, MATH3, SIZE(4), 0);
	MATHB(VSEQINSZ, AND, MATH0, MATH3, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, AND, MATH1, MATH3, SIZE(1), 0);
	MATHB(VSEQINSZ, AND, MATH2, MATH3, SIZE(4), 0);
	MATHB(VSEQINSZ, AND, MATH3, MATH3, SIZE(4), 0);
	MATHB(VSEQINSZ, AND, IMM(393615378), MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, AND, DPOVRD, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, AND, VSEQINSZ, MATH3, SIZE(1), 0);
	MATHB(VSEQINSZ, AND, VSEQOUTSZ, MATH3, SIZE(8), 0);
	MATHB(VSEQINSZ, AND, ABD, MATH3, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, AND, OFIFO, MATH3, SIZE(4), 0);
	MATHB(VSEQINSZ, AND, ONE, MATH3, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, AND, ZERO, MATH3, SIZE(8), 0);
	MATHB(VSEQOUTSZ, AND, MATH0, MATH3, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, AND, MATH1, MATH3, SIZE(8), 0);
	MATHB(VSEQOUTSZ, AND, MATH2, MATH3, SIZE(1), 0);
	MATHB(VSEQOUTSZ, AND, MATH3, MATH3, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, AND, IMM(393615378), MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, AND, DPOVRD, MATH3, SIZE(4), 0);
	MATHB(VSEQOUTSZ, AND, VSEQINSZ, MATH3, SIZE(4), 0);
	MATHB(VSEQOUTSZ, AND, VSEQOUTSZ, MATH3, SIZE(8), 0);
	MATHB(VSEQOUTSZ, AND, ABD, MATH3, SIZE(4), 0);
	MATHB(VSEQOUTSZ, AND, OFIFO, MATH3, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, AND, ONE, MATH3, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, AND, ZERO, MATH3, SIZE(8), 0);
	MATHB(ZERO, AND, MATH0, MATH3, SIZE(8), 0);
	MATHB(ZERO, AND, MATH1, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, AND, MATH2, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, AND, MATH3, MATH3, SIZE(8), 0);
	MATHB(ZERO, AND, IMM(393615378), MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, AND, DPOVRD, MATH3, SIZE(8), 0);
	MATHB(ZERO, AND, VSEQINSZ, MATH3, SIZE(2), 0);
	MATHB(ZERO, AND, VSEQOUTSZ, MATH3, SIZE(4), WITH(STL));
	MATHB(ZERO, AND, ABD, MATH3, SIZE(8), WITH(STL));
	MATHB(ZERO, AND, OFIFO, MATH3, SIZE(8), 0);
	MATHB(ZERO, AND, ONE, MATH3, SIZE(8), 0);
	MATHB(ZERO, AND, ZERO, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, AND, MATH0, MATH3, SIZE(8), WITH(NFU));
	MATHB(ONE, AND, MATH1, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, AND, MATH2, MATH3, SIZE(1), WITH(STL));
	MATHB(ONE, AND, MATH3, MATH3, SIZE(1), 0);
	MATHB(ONE, AND, IMM(393615378), MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, AND, DPOVRD, MATH3, SIZE(2), 0);
	MATHB(ONE, AND, VSEQINSZ, MATH3, SIZE(8), 0);
	MATHB(ONE, AND, VSEQOUTSZ, MATH3, SIZE(2), WITH(STL));
	MATHB(ONE, AND, ABD, MATH3, SIZE(4), WITH(STL));
	MATHB(ONE, AND, OFIFO, MATH3, SIZE(8), 0);
	MATHB(ONE, AND, ONE, MATH3, SIZE(4), 0);
	MATHB(ONE, AND, ZERO, MATH3, SIZE(4), 0);
	/*AND Operation: DPOVRD Destination register */
	MATHB(MATH0, AND, MATH0, DPOVRD, SIZE(4), 0);
	MATHB(MATH0, AND, MATH1, DPOVRD, SIZE(4), 0);
	MATHB(MATH0, AND, MATH2, DPOVRD, SIZE(8), 0);
	MATHB(MATH0, AND, MATH3, DPOVRD, SIZE(8), 0);
	MATHB(MATH0, AND, IMM(393615378), DPOVRD, SIZE(4), 0);
	MATHB(MATH0, AND, DPOVRD, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(MATH0, AND, VSEQINSZ, DPOVRD, SIZE(2), 0);
	MATHB(MATH0, AND, VSEQOUTSZ, DPOVRD, SIZE(4), 0);
	MATHB(MATH0, AND, ABD, DPOVRD, SIZE(1), 0);
	MATHB(MATH0, AND, OFIFO, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, AND, ONE, DPOVRD, SIZE(4), WITH(STL));
	MATHB(MATH0, AND, ZERO, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(MATH1, AND, MATH0, DPOVRD, SIZE(2), 0);
	MATHB(MATH1, AND, MATH1, DPOVRD, SIZE(1), 0);
	MATHB(MATH1, AND, MATH2, DPOVRD, SIZE(2), WITH(STL));
	MATHB(MATH1, AND, MATH3, DPOVRD, SIZE(2), 0);
	MATHB(MATH1, AND, IMM(393615378), DPOVRD, SIZE(1), 0);
	MATHB(MATH1, AND, DPOVRD, DPOVRD, SIZE(4), 0);
	MATHB(MATH1, AND, VSEQINSZ, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(MATH1, AND, VSEQOUTSZ, DPOVRD, SIZE(1), 0);
	MATHB(MATH1, AND, ABD, DPOVRD, SIZE(4), 0);
	MATHB(MATH1, AND, OFIFO, DPOVRD, SIZE(2), 0);
	MATHB(MATH1, AND, ONE, DPOVRD, SIZE(4), 0);
	MATHB(MATH1, AND, ZERO, DPOVRD, SIZE(1), 0);
	MATHB(MATH2, AND, MATH0, DPOVRD, SIZE(1), 0);
	MATHB(MATH2, AND, MATH1, DPOVRD, SIZE(2), 0);
	MATHB(MATH2, AND, MATH2, DPOVRD, SIZE(2), WITH(STL));
	MATHB(MATH2, AND, MATH3, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, AND, IMM(393615378), DPOVRD, SIZE(2), 0);
	MATHB(MATH2, AND, DPOVRD, DPOVRD, SIZE(8), 0);
	MATHB(MATH2, AND, VSEQINSZ, DPOVRD, SIZE(1), 0);
	MATHB(MATH2, AND, VSEQOUTSZ, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, AND, ABD, DPOVRD, SIZE(2), 0);
	MATHB(MATH2, AND, OFIFO, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, AND, ONE, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(MATH2, AND, ZERO, DPOVRD, SIZE(4), 0);
	MATHB(MATH3, AND, MATH0, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(MATH3, AND, MATH1, DPOVRD, SIZE(4), 0);
	MATHB(MATH3, AND, MATH2, DPOVRD, SIZE(1), 0);
	MATHB(MATH3, AND, MATH3, DPOVRD, SIZE(4), 0);
	MATHB(MATH3, AND, IMM(393615378), DPOVRD, SIZE(8), WITH(IFB | NFU));
	MATHB(MATH3, AND, DPOVRD, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(MATH3, AND, VSEQINSZ, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, AND, VSEQOUTSZ, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, AND, ABD, DPOVRD, SIZE(2), WITH(STL));
	MATHB(MATH3, AND, OFIFO, DPOVRD, SIZE(4), 0);
	MATHB(MATH3, AND, ONE, DPOVRD, SIZE(1), 0);
	MATHB(MATH3, AND, ZERO, DPOVRD, SIZE(1), 0);
	MATHB(IMM(275128321), AND, MATH0, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(275128321), AND, MATH1, DPOVRD, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), AND, MATH2, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(275128321), AND, MATH3, DPOVRD, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), AND, IMM(393615378), DPOVRD, SIZE(2), WITH(NFU));
	MATHB(IMM(0x19261959fedcba01), AND, DPOVRD, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(IMM(275128321), AND, VSEQINSZ, DPOVRD, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), AND, VSEQOUTSZ, DPOVRD, SIZE(1), 0);
	MATHB(IMM(275128321), AND, ABD, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), AND, OFIFO, DPOVRD, SIZE(1), 0);
	MATHB(IMM(275128321), AND, ONE, DPOVRD, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), AND, ZERO, DPOVRD, SIZE(2), 0);
	MATHB(DPOVRD, AND, MATH0, DPOVRD, SIZE(8), WITH(STL));
	MATHB(DPOVRD, AND, MATH1, DPOVRD, SIZE(1), 0);
	MATHB(DPOVRD, AND, MATH2, DPOVRD, SIZE(2), WITH(STL));
	MATHB(DPOVRD, AND, MATH3, DPOVRD, SIZE(8), WITH(STL));
	MATHB(DPOVRD, AND, IMM(393615378), DPOVRD, SIZE(4), 0);
	MATHB(DPOVRD, AND, DPOVRD, DPOVRD, SIZE(1), 0);
	MATHB(DPOVRD, AND, VSEQINSZ, DPOVRD, SIZE(2), WITH(STL));
	MATHB(DPOVRD, AND, VSEQOUTSZ, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(DPOVRD, AND, ABD, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, AND, OFIFO, DPOVRD, SIZE(8), WITH(STL));
	MATHB(DPOVRD, AND, ONE, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, AND, ZERO, DPOVRD, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, AND, MATH0, DPOVRD, SIZE(1), 0);
	MATHB(SEQINSZ, AND, MATH1, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, AND, MATH2, DPOVRD, SIZE(1), 0);
	MATHB(SEQINSZ, AND, MATH3, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(SEQINSZ, AND, IMM(393615378), DPOVRD, SIZE(4), 0);
	MATHB(SEQINSZ, AND, DPOVRD, DPOVRD, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, AND, VSEQINSZ, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, AND, VSEQOUTSZ, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, AND, ABD, DPOVRD, SIZE(8), 0);
	MATHB(SEQINSZ, AND, OFIFO, DPOVRD, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, AND, ONE, DPOVRD, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, AND, ZERO, DPOVRD, SIZE(8), 0);
	MATHB(SEQOUTSZ, AND, MATH0, DPOVRD, SIZE(1), 0);
	MATHB(SEQOUTSZ, AND, MATH1, DPOVRD, SIZE(2), 0);
	MATHB(SEQOUTSZ, AND, MATH2, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, AND, MATH3, DPOVRD, SIZE(4), 0);
	MATHB(SEQOUTSZ, AND, IMM(393615378), DPOVRD, SIZE(4), 0);
	MATHB(SEQOUTSZ, AND, DPOVRD, DPOVRD, SIZE(4), 0);
	MATHB(SEQOUTSZ, AND, VSEQINSZ, DPOVRD, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, AND, VSEQOUTSZ, DPOVRD, SIZE(1), 0);
	MATHB(SEQOUTSZ, AND, ABD, DPOVRD, SIZE(2), 0);
	MATHB(SEQOUTSZ, AND, OFIFO, DPOVRD, SIZE(8), 0);
	MATHB(SEQOUTSZ, AND, ONE, DPOVRD, SIZE(4), 0);
	MATHB(SEQOUTSZ, AND, ZERO, DPOVRD, SIZE(1), 0);
	MATHB(VSEQINSZ, AND, MATH0, DPOVRD, SIZE(2), 0);
	MATHB(VSEQINSZ, AND, MATH1, DPOVRD, SIZE(2), 0);
	MATHB(VSEQINSZ, AND, MATH2, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, AND, MATH3, DPOVRD, SIZE(8), 0);
	MATHB(VSEQINSZ, AND, IMM(393615378), DPOVRD, SIZE(1), 0);
	MATHB(VSEQINSZ, AND, DPOVRD, DPOVRD, SIZE(8), 0);
	MATHB(VSEQINSZ, AND, VSEQINSZ, DPOVRD, SIZE(8), 0);
	MATHB(VSEQINSZ, AND, VSEQOUTSZ, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, AND, ABD, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, AND, OFIFO, DPOVRD, SIZE(1), 0);
	MATHB(VSEQINSZ, AND, ONE, DPOVRD, SIZE(2), 0);
	MATHB(VSEQINSZ, AND, ZERO, DPOVRD, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, AND, MATH0, DPOVRD, SIZE(1), 0);
	MATHB(VSEQOUTSZ, AND, MATH1, DPOVRD, SIZE(4), 0);
	MATHB(VSEQOUTSZ, AND, MATH2, DPOVRD, SIZE(4), 0);
	MATHB(VSEQOUTSZ, AND, MATH3, DPOVRD, SIZE(1), 0);
	MATHB(VSEQOUTSZ, AND, IMM(393615378), DPOVRD, SIZE(2), 0);
	MATHB(VSEQOUTSZ, AND, DPOVRD, DPOVRD, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, AND, VSEQINSZ, DPOVRD, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, AND, VSEQOUTSZ, DPOVRD, SIZE(1), 0);
	MATHB(VSEQOUTSZ, AND, ABD, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, AND, OFIFO, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, AND, ONE, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, AND, ZERO, DPOVRD, SIZE(2), WITH(STL));
	MATHB(ZERO, AND, MATH0, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(ZERO, AND, MATH1, DPOVRD, SIZE(4), 0);
	MATHB(ZERO, AND, MATH2, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, AND, MATH3, DPOVRD, SIZE(2), 0);
	MATHB(ZERO, AND, IMM(393615378), DPOVRD, SIZE(2), 0);
	MATHB(ZERO, AND, DPOVRD, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(ZERO, AND, VSEQINSZ, DPOVRD, SIZE(8), 0);
	MATHB(ZERO, AND, VSEQOUTSZ, DPOVRD, SIZE(2), 0);
	MATHB(ZERO, AND, ABD, DPOVRD, SIZE(2), 0);
	MATHB(ZERO, AND, OFIFO, DPOVRD, SIZE(1), 0);
	MATHB(ZERO, AND, ONE, DPOVRD, SIZE(1), WITH(STL));
	MATHB(ZERO, AND, ZERO, DPOVRD, SIZE(2), 0);
	MATHB(ONE, AND, MATH0, DPOVRD, SIZE(1), 0);
	MATHB(ONE, AND, MATH1, DPOVRD, SIZE(4), 0);
	MATHB(ONE, AND, MATH2, DPOVRD, SIZE(1), 0);
	MATHB(ONE, AND, MATH3, DPOVRD, SIZE(1), 0);
	MATHB(ONE, AND, IMM(393615378), DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, AND, DPOVRD, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, AND, VSEQINSZ, DPOVRD, SIZE(8), 0);
	MATHB(ONE, AND, VSEQOUTSZ, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, AND, ABD, DPOVRD, SIZE(8), WITH(STL));
	MATHB(ONE, AND, OFIFO, DPOVRD, SIZE(8), 0);
	MATHB(ONE, AND, ONE, DPOVRD, SIZE(1), 0);
	MATHB(ONE, AND, ZERO, DPOVRD, SIZE(4), WITH(NFU | STL));
	/*AND Operation: SEQINSZ Destination register */
	MATHB(MATH0, AND, MATH0, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(MATH0, AND, MATH1, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH0, AND, MATH2, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH0, AND, MATH3, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH0, AND, IMM(393615378), SEQINSZ, SIZE(8), WITH(IFB));
	MATHB(MATH0, AND, DPOVRD, SEQINSZ, SIZE(2), 0);
	MATHB(MATH0, AND, VSEQINSZ, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH0, AND, VSEQOUTSZ, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, AND, ABD, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, AND, OFIFO, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH0, AND, ONE, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(MATH0, AND, ZERO, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH1, AND, MATH0, SEQINSZ, SIZE(2), 0);
	MATHB(MATH1, AND, MATH1, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH1, AND, MATH2, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH1, AND, MATH3, SEQINSZ, SIZE(1), 0);
	MATHB(MATH1, AND, IMM(393615378), SEQINSZ, SIZE(4), 0);
	MATHB(MATH1, AND, DPOVRD, SEQINSZ, SIZE(4), 0);
	MATHB(MATH1, AND, VSEQINSZ, SEQINSZ, SIZE(1), 0);
	MATHB(MATH1, AND, VSEQOUTSZ, SEQINSZ, SIZE(8), 0);
	MATHB(MATH1, AND, ABD, SEQINSZ, SIZE(1), 0);
	MATHB(MATH1, AND, OFIFO, SEQINSZ, SIZE(1), 0);
	MATHB(MATH1, AND, ONE, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(MATH1, AND, ZERO, SEQINSZ, SIZE(2), 0);
	MATHB(MATH2, AND, MATH0, SEQINSZ, SIZE(2), 0);
	MATHB(MATH2, AND, MATH1, SEQINSZ, SIZE(8), 0);
	MATHB(MATH2, AND, MATH2, SEQINSZ, SIZE(8), 0);
	MATHB(MATH2, AND, MATH3, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH2, AND, IMM(393615378), SEQINSZ, SIZE(8), WITH(IFB | STL));
	MATHB(MATH2, AND, DPOVRD, SEQINSZ, SIZE(1), 0);
	MATHB(MATH2, AND, VSEQINSZ, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(MATH2, AND, VSEQOUTSZ, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, AND, ABD, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH2, AND, OFIFO, SEQINSZ, SIZE(2), 0);
	MATHB(MATH2, AND, ONE, SEQINSZ, SIZE(2), 0);
	MATHB(MATH2, AND, ZERO, SEQINSZ, SIZE(8), 0);
	MATHB(MATH3, AND, MATH0, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(MATH3, AND, MATH1, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH3, AND, MATH2, SEQINSZ, SIZE(4), 0);
	MATHB(MATH3, AND, MATH3, SEQINSZ, SIZE(2), 0);
	MATHB(MATH3, AND, IMM(393615378), SEQINSZ, SIZE(2), 0);
	MATHB(MATH3, AND, DPOVRD, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, AND, VSEQINSZ, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH3, AND, VSEQOUTSZ, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH3, AND, ABD, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(MATH3, AND, OFIFO, SEQINSZ, SIZE(8), 0);
	MATHB(MATH3, AND, ONE, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(MATH3, AND, ZERO, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), AND, MATH0, SEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), AND, MATH1, SEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), AND, MATH2, SEQINSZ, SIZE(4), 0);
	MATHB(IMM(275128321), AND, MATH3, SEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), AND, IMM(393615378), SEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), AND, DPOVRD, SEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), AND, VSEQINSZ, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(275128321), AND, VSEQOUTSZ, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), AND, ABD, SEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), AND, OFIFO, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), AND, ONE, SEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), AND, ZERO, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, AND, MATH0, SEQINSZ, SIZE(4), 0);
	MATHB(DPOVRD, AND, MATH1, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(DPOVRD, AND, MATH2, SEQINSZ, SIZE(4), 0);
	MATHB(DPOVRD, AND, MATH3, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, AND, IMM(393615378), SEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, AND, DPOVRD, SEQINSZ, SIZE(4), 0);
	MATHB(DPOVRD, AND, VSEQINSZ, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, AND, VSEQOUTSZ, SEQINSZ, SIZE(1), 0);
	MATHB(DPOVRD, AND, ABD, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, AND, OFIFO, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(DPOVRD, AND, ONE, SEQINSZ, SIZE(1), 0);
	MATHB(DPOVRD, AND, ZERO, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, AND, MATH0, SEQINSZ, SIZE(1), 0);
	MATHB(SEQINSZ, AND, MATH1, SEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, AND, MATH2, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, AND, MATH3, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, AND, IMM(393615378), SEQINSZ, SIZE(8), WITH(IFB));
	MATHB(SEQINSZ, AND, DPOVRD, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, AND, VSEQINSZ, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, AND, VSEQOUTSZ, SEQINSZ, SIZE(4), 0);
	MATHB(SEQINSZ, AND, ABD, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, AND, OFIFO, SEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, AND, ONE, SEQINSZ, SIZE(1), 0);
	MATHB(SEQINSZ, AND, ZERO, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, AND, MATH0, SEQINSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, AND, MATH1, SEQINSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, AND, MATH2, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, AND, MATH3, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, AND, IMM(393615378), SEQINSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, AND, DPOVRD, SEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, AND, VSEQINSZ, SEQINSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, AND, VSEQOUTSZ, SEQINSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, AND, ABD, SEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, AND, OFIFO, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, AND, ONE, SEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, AND, ZERO, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQINSZ, AND, MATH0, SEQINSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, AND, MATH1, SEQINSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, AND, MATH2, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, AND, MATH3, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, AND, IMM(393615378), SEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, AND, DPOVRD, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, AND, VSEQINSZ, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, AND, VSEQOUTSZ, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, AND, ABD, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, AND, OFIFO, SEQINSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, AND, ONE, SEQINSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, AND, ZERO, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, AND, MATH0, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, AND, MATH1, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, AND, MATH2, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, AND, MATH3, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, AND, IMM(393615378), SEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, AND, DPOVRD, SEQINSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, AND, VSEQINSZ, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, AND, VSEQOUTSZ, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, AND, ABD, SEQINSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, AND, OFIFO, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, AND, ONE, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, AND, ZERO, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(ZERO, AND, MATH0, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(ZERO, AND, MATH1, SEQINSZ, SIZE(4), 0);
	MATHB(ZERO, AND, MATH2, SEQINSZ, SIZE(4), 0);
	MATHB(ZERO, AND, MATH3, SEQINSZ, SIZE(1), 0);
	MATHB(ZERO, AND, IMM(0x19261959fedcba01), SEQINSZ, SIZE(8), 0);
	MATHB(ZERO, AND, DPOVRD, SEQINSZ, SIZE(1), 0);
	MATHB(ZERO, AND, VSEQINSZ, SEQINSZ, SIZE(8), 0);
	MATHB(ZERO, AND, VSEQOUTSZ, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(ZERO, AND, ABD, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, AND, OFIFO, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(ZERO, AND, ONE, SEQINSZ, SIZE(8), 0);
	MATHB(ZERO, AND, ZERO, SEQINSZ, SIZE(4), 0);
	MATHB(ONE, AND, MATH0, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(ONE, AND, MATH1, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(ONE, AND, MATH2, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(ONE, AND, MATH3, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(ONE, AND, IMM(393615378), SEQINSZ, SIZE(8), WITH(IFB | STL));
	MATHB(ONE, AND, DPOVRD, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(ONE, AND, VSEQINSZ, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, AND, VSEQOUTSZ, SEQINSZ, SIZE(4), 0);
	MATHB(ONE, AND, ABD, SEQINSZ, SIZE(8), 0);
	MATHB(ONE, AND, OFIFO, SEQINSZ, SIZE(2), 0);
	MATHB(ONE, AND, ONE, SEQINSZ, SIZE(1), 0);
	MATHB(ONE, AND, ZERO, SEQINSZ, SIZE(8), WITH(NFU | STL));
	/*AND Operation: SEQOUTSZ Destination register */
	MATHB(MATH0, AND, MATH0, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH0, AND, MATH1, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH0, AND, MATH2, SEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(MATH0, AND, MATH3, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH0, AND, IMM(393615378), SEQOUTSZ, SIZE(8), WITH(IFB));
	MATHB(MATH0, AND, DPOVRD, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH0, AND, VSEQINSZ, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(MATH0, AND, VSEQOUTSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, AND, ABD, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(MATH0, AND, OFIFO, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH0, AND, ONE, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(MATH0, AND, ZERO, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH1, AND, MATH0, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, AND, MATH1, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, AND, MATH2, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH1, AND, MATH3, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH1, AND, IMM(393615378), SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH1, AND, DPOVRD, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, AND, VSEQINSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH1, AND, VSEQOUTSZ, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH1, AND, ABD, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH1, AND, OFIFO, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH1, AND, ONE, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH1, AND, ZERO, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, AND, MATH0, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, AND, MATH1, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH2, AND, MATH2, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH2, AND, MATH3, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, AND, IMM(0x19261959fedcba01), SEQOUTSZ, SIZE(8),
	      WITH(STL));
	MATHB(MATH2, AND, DPOVRD, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH2, AND, VSEQINSZ, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, AND, VSEQOUTSZ, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH2, AND, ABD, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(MATH2, AND, OFIFO, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(MATH2, AND, ONE, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH2, AND, ZERO, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH3, AND, MATH0, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, AND, MATH1, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, AND, MATH2, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, AND, MATH3, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, AND, IMM(393615378), SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, AND, DPOVRD, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH3, AND, VSEQINSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH3, AND, VSEQOUTSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH3, AND, ABD, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH3, AND, OFIFO, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH3, AND, ONE, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, AND, ZERO, SEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), AND, MATH0, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), AND, MATH1, SEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), AND, MATH2, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), AND, MATH3, SEQOUTSZ, SIZE(8),
	      WITH(IFB | NFU | STL));
	MATHB(IMM(275128321), AND, IMM(393615378), SEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(275128321), AND, DPOVRD, SEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), AND, VSEQINSZ, SEQOUTSZ, SIZE(8), WITH(IFB));
	MATHB(IMM(0x19261959fedcba01), AND, VSEQOUTSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(IMM(275128321), AND, ABD, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(IMM(275128321), AND, OFIFO, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), AND, ONE, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(IMM(0x19261959fedcba01), AND, ZERO, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, AND, MATH0, SEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, AND, MATH1, SEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, AND, MATH2, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, AND, MATH3, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, AND, IMM(393615378), SEQOUTSZ, SIZE(4), 0);
	MATHB(DPOVRD, AND, DPOVRD, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, AND, VSEQINSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, AND, VSEQOUTSZ, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(DPOVRD, AND, ABD, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, AND, OFIFO, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, AND, ONE, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, AND, ZERO, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, AND, MATH0, SEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, AND, MATH1, SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, AND, MATH2, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, AND, MATH3, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, AND, IMM(393615378), SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, AND, DPOVRD, SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQINSZ, AND, VSEQINSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQINSZ, AND, VSEQOUTSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(SEQINSZ, AND, ABD, SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQINSZ, AND, OFIFO, SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQINSZ, AND, ONE, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, AND, ZERO, SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, AND, MATH0, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, AND, MATH1, SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, AND, MATH2, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, AND, MATH3, SEQOUTSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, AND, IMM(393615378), SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, AND, DPOVRD, SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, AND, VSEQINSZ, SEQOUTSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, AND, VSEQOUTSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, AND, ABD, SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, AND, OFIFO, SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, AND, ONE, SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, AND, ZERO, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, AND, MATH0, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, AND, MATH1, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, AND, MATH2, SEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, AND, MATH3, SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, AND, IMM(393615378), SEQOUTSZ, SIZE(2),
	      WITH(NFU | STL));
	MATHB(VSEQINSZ, AND, DPOVRD, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, AND, VSEQINSZ, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, AND, VSEQOUTSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, AND, ABD, SEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, AND, OFIFO, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, AND, ONE, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, AND, ZERO, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, AND, MATH0, SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, AND, MATH1, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, AND, MATH2, SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, AND, MATH3, SEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, AND, IMM(393615378), SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, AND, DPOVRD, SEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, AND, VSEQINSZ, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, AND, VSEQOUTSZ, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, AND, ABD, SEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, AND, OFIFO, SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, AND, ONE, SEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, AND, ZERO, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(ZERO, AND, MATH0, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(ZERO, AND, MATH1, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(ZERO, AND, MATH2, SEQOUTSZ, SIZE(8), 0);
	MATHB(ZERO, AND, MATH3, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(ZERO, AND, IMM(393615378), SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(ZERO, AND, DPOVRD, SEQOUTSZ, SIZE(4), 0);
	MATHB(ZERO, AND, VSEQINSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, AND, VSEQOUTSZ, SEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, AND, ABD, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(ZERO, AND, OFIFO, SEQOUTSZ, SIZE(8), 0);
	MATHB(ZERO, AND, ONE, SEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, AND, ZERO, SEQOUTSZ, SIZE(8), 0);
	MATHB(ONE, AND, MATH0, SEQOUTSZ, SIZE(8), 0);
	MATHB(ONE, AND, MATH1, SEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, AND, MATH2, SEQOUTSZ, SIZE(8), 0);
	MATHB(ONE, AND, MATH3, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(ONE, AND, IMM(393615378), SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, AND, DPOVRD, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(ONE, AND, VSEQINSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(ONE, AND, VSEQOUTSZ, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(ONE, AND, ABD, SEQOUTSZ, SIZE(2), 0);
	MATHB(ONE, AND, OFIFO, SEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, AND, ONE, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, AND, ZERO, SEQOUTSZ, SIZE(4), WITH(STL));
	/*AND Operation: VSEQINSZ Destination register */
	MATHB(MATH0, AND, MATH0, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH0, AND, MATH1, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH0, AND, MATH2, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH0, AND, MATH3, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH0, AND, IMM(393615378), VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH0, AND, DPOVRD, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(MATH0, AND, VSEQINSZ, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, AND, VSEQOUTSZ, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH0, AND, ABD, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH0, AND, OFIFO, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, AND, ONE, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH0, AND, ZERO, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH1, AND, MATH0, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH1, AND, MATH1, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH1, AND, MATH2, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH1, AND, MATH3, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH1, AND, IMM(393615378), VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH1, AND, DPOVRD, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH1, AND, VSEQINSZ, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH1, AND, VSEQOUTSZ, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(MATH1, AND, ABD, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH1, AND, OFIFO, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH1, AND, ONE, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH1, AND, ZERO, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH2, AND, MATH0, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, AND, MATH1, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, AND, MATH2, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH2, AND, MATH3, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH2, AND, IMM(393615378), VSEQINSZ, SIZE(8), WITH(IFB | STL));
	MATHB(MATH2, AND, DPOVRD, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH2, AND, VSEQINSZ, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(MATH2, AND, VSEQOUTSZ, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH2, AND, ABD, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH2, AND, OFIFO, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH2, AND, ONE, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH2, AND, ZERO, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH3, AND, MATH0, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(MATH3, AND, MATH1, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH3, AND, MATH2, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH3, AND, MATH3, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, AND, IMM(393615378), VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH3, AND, DPOVRD, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH3, AND, VSEQINSZ, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(MATH3, AND, VSEQOUTSZ, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(MATH3, AND, ABD, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH3, AND, OFIFO, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, AND, ONE, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH3, AND, ZERO, VSEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), AND, MATH0, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(275128321), AND, MATH1, VSEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), AND, MATH2, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(275128321), AND, MATH3, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), AND, IMM(393615378), VSEQINSZ, SIZE(2),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), AND, DPOVRD, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(275128321), AND, VSEQINSZ, VSEQINSZ, SIZE(4), 0);
	MATHB(IMM(275128321), AND, VSEQOUTSZ, VSEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), AND, ABD, VSEQINSZ, SIZE(4), 0);
	MATHB(IMM(275128321), AND, OFIFO, VSEQINSZ, SIZE(4), 0);
	MATHB(IMM(0x19261959fedcba01), AND, ONE, VSEQINSZ, SIZE(8), 0);
	MATHB(IMM(0x19261959fedcba01), AND, ZERO, VSEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, AND, MATH0, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, AND, MATH1, VSEQINSZ, SIZE(4), 0);
	MATHB(DPOVRD, AND, MATH2, VSEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, AND, MATH3, VSEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, AND, IMM(393615378), VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, AND, DPOVRD, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, AND, VSEQINSZ, VSEQINSZ, SIZE(4), 0);
	MATHB(DPOVRD, AND, VSEQOUTSZ, VSEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, AND, ABD, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(DPOVRD, AND, OFIFO, VSEQINSZ, SIZE(1), 0);
	MATHB(DPOVRD, AND, ONE, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, AND, ZERO, VSEQINSZ, SIZE(4), 0);
	MATHB(SEQINSZ, AND, MATH0, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, AND, MATH1, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, AND, MATH2, VSEQINSZ, SIZE(1), 0);
	MATHB(SEQINSZ, AND, MATH3, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, AND, IMM(393615378), VSEQINSZ, SIZE(1), 0);
	MATHB(SEQINSZ, AND, DPOVRD, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, AND, VSEQINSZ, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, AND, VSEQOUTSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(SEQINSZ, AND, ABD, VSEQINSZ, SIZE(4), 0);
	MATHB(SEQINSZ, AND, OFIFO, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, AND, ONE, VSEQINSZ, SIZE(4), 0);
	MATHB(SEQINSZ, AND, ZERO, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, AND, MATH0, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, AND, MATH1, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, AND, MATH2, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, AND, MATH3, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(SEQOUTSZ, AND, IMM(393615378), VSEQINSZ, SIZE(2),
	      WITH(NFU | STL));
	MATHB(SEQOUTSZ, AND, DPOVRD, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, AND, VSEQINSZ, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, AND, VSEQOUTSZ, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, AND, ABD, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, AND, OFIFO, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, AND, ONE, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, AND, ZERO, VSEQINSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, AND, MATH0, VSEQINSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, AND, MATH1, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, AND, MATH2, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, AND, MATH3, VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, AND, IMM(393615378), VSEQINSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, AND, DPOVRD, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, AND, VSEQINSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, AND, VSEQOUTSZ, VSEQINSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, AND, ABD, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, AND, OFIFO, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, AND, ONE, VSEQINSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, AND, ZERO, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, AND, MATH0, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, AND, MATH1, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, AND, MATH2, VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, AND, MATH3, VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, AND, IMM(393615378), VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, AND, DPOVRD, VSEQINSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, AND, VSEQINSZ, VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, AND, VSEQOUTSZ, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, AND, ABD, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, AND, OFIFO, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, AND, ONE, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, AND, ZERO, VSEQINSZ, SIZE(1), 0);
	MATHB(ZERO, AND, MATH0, VSEQINSZ, SIZE(4), 0);
	MATHB(ZERO, AND, MATH1, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(ZERO, AND, MATH2, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(ZERO, AND, MATH3, VSEQINSZ, SIZE(2), 0);
	MATHB(ZERO, AND, IMM(393615378), VSEQINSZ, SIZE(8), WITH(IFB));
	MATHB(ZERO, AND, DPOVRD, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, AND, VSEQINSZ, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(ZERO, AND, VSEQOUTSZ, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(ZERO, AND, ABD, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(ZERO, AND, OFIFO, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(ZERO, AND, ONE, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(ZERO, AND, ZERO, VSEQINSZ, SIZE(4), 0);
	MATHB(ONE, AND, MATH0, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, AND, MATH1, VSEQINSZ, SIZE(8), 0);
	MATHB(ONE, AND, MATH2, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(ONE, AND, MATH3, VSEQINSZ, SIZE(8), 0);
	MATHB(ONE, AND, IMM(393615378), VSEQINSZ, SIZE(1), 0);
	MATHB(ONE, AND, DPOVRD, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(ONE, AND, VSEQINSZ, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, AND, VSEQOUTSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(ONE, AND, ABD, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(ONE, AND, OFIFO, VSEQINSZ, SIZE(4), 0);
	MATHB(ONE, AND, ONE, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(ONE, AND, ZERO, VSEQINSZ, SIZE(8), WITH(STL));
	/*AND Operation: VSEQOUTSZ Destination register */
	MATHB(MATH0, AND, MATH0, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(MATH0, AND, MATH1, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH0, AND, MATH2, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH0, AND, MATH3, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH0, AND, IMM(393615378), VSEQOUTSZ, SIZE(8), WITH(IFB));
	MATHB(MATH0, AND, DPOVRD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH0, AND, VSEQINSZ, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(MATH0, AND, VSEQOUTSZ, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH0, AND, ABD, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH0, AND, OFIFO, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH0, AND, ONE, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH0, AND, ZERO, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, AND, MATH0, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH1, AND, MATH1, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH1, AND, MATH2, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(MATH1, AND, MATH3, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, AND, IMM(393615378), VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, AND, DPOVRD, VSEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH1, AND, VSEQINSZ, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(MATH1, AND, VSEQOUTSZ, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, AND, ABD, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH1, AND, OFIFO, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH1, AND, ONE, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, AND, ZERO, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, AND, MATH0, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, AND, MATH1, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(MATH2, AND, MATH2, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(MATH2, AND, MATH3, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, AND, IMM(393615378), VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, AND, DPOVRD, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH2, AND, VSEQINSZ, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH2, AND, VSEQOUTSZ, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH2, AND, ABD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH2, AND, OFIFO, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH2, AND, ONE, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH2, AND, ZERO, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH3, AND, MATH0, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, AND, MATH1, VSEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, AND, MATH2, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, AND, MATH3, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH3, AND, IMM(393615378), VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, AND, DPOVRD, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH3, AND, VSEQINSZ, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, AND, VSEQOUTSZ, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, AND, ABD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH3, AND, OFIFO, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH3, AND, ONE, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, AND, ZERO, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(IMM(275128321), AND, MATH0, VSEQOUTSZ, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), AND, MATH1, VSEQOUTSZ, SIZE(1), 0);
	MATHB(IMM(275128321), AND, MATH2, VSEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(0x19261959fedcba01), AND, MATH3, VSEQOUTSZ, SIZE(8),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), AND, IMM(393615378), VSEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), AND, DPOVRD, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), AND, VSEQINSZ, VSEQOUTSZ, SIZE(1), 0);
	MATHB(IMM(275128321), AND, VSEQOUTSZ, VSEQOUTSZ, SIZE(4),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), AND, ABD, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(IMM(275128321), AND, OFIFO, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), AND, ONE, VSEQOUTSZ, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), AND, ZERO, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, AND, MATH0, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(DPOVRD, AND, MATH1, VSEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, AND, MATH2, VSEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, AND, MATH3, VSEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, AND, IMM(393615378), VSEQOUTSZ, SIZE(4), 0);
	MATHB(DPOVRD, AND, DPOVRD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, AND, VSEQINSZ, VSEQOUTSZ, SIZE(4), 0);
	MATHB(DPOVRD, AND, VSEQOUTSZ, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, AND, ABD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, AND, OFIFO, VSEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, AND, ONE, VSEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, AND, ZERO, VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQINSZ, AND, MATH0, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, AND, MATH1, VSEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, AND, MATH2, VSEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, AND, MATH3, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, AND, IMM(0x19261959fedcba01), VSEQOUTSZ, SIZE(8), 0);
	MATHB(SEQINSZ, AND, DPOVRD, VSEQOUTSZ, SIZE(8), 0);
	MATHB(SEQINSZ, AND, VSEQINSZ, VSEQOUTSZ, SIZE(8), 0);
	MATHB(SEQINSZ, AND, VSEQOUTSZ, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, AND, ABD, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, AND, OFIFO, VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQINSZ, AND, ONE, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, AND, ZERO, VSEQOUTSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, AND, MATH0, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, AND, MATH1, VSEQOUTSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, AND, MATH2, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, AND, MATH3, VSEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, AND, IMM(393615378), VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, AND, DPOVRD, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, AND, VSEQINSZ, VSEQOUTSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, AND, VSEQOUTSZ, VSEQOUTSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, AND, ABD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, AND, OFIFO, VSEQOUTSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, AND, ONE, VSEQOUTSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, AND, ZERO, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, AND, MATH0, VSEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, AND, MATH1, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, AND, MATH2, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, AND, MATH3, VSEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, AND, IMM(393615378), VSEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, AND, DPOVRD, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, AND, VSEQINSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, AND, VSEQOUTSZ, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, AND, ABD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, AND, OFIFO, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, AND, ONE, VSEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, AND, ZERO, VSEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, AND, MATH0, VSEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, AND, MATH1, VSEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, AND, MATH2, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, AND, MATH3, VSEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, AND, IMM(393615378), VSEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, AND, DPOVRD, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, AND, VSEQINSZ, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, AND, VSEQOUTSZ, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, AND, ABD, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, AND, OFIFO, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, AND, ONE, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, AND, ZERO, VSEQOUTSZ, SIZE(4), 0);
	MATHB(ZERO, AND, MATH0, VSEQOUTSZ, SIZE(4), 0);
	MATHB(ZERO, AND, MATH1, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, AND, MATH2, VSEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, AND, MATH3, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(ZERO, AND, IMM(393615378), VSEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, AND, DPOVRD, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, AND, VSEQINSZ, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, AND, VSEQOUTSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, AND, ABD, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(ZERO, AND, OFIFO, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, AND, ONE, VSEQOUTSZ, SIZE(4), 0);
	MATHB(ZERO, AND, ZERO, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, AND, MATH0, VSEQOUTSZ, SIZE(2), 0);
	MATHB(ONE, AND, MATH1, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, AND, MATH2, VSEQOUTSZ, SIZE(8), 0);
	MATHB(ONE, AND, MATH3, VSEQOUTSZ, SIZE(8), 0);
	MATHB(ONE, AND, IMM(393615378), VSEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, AND, DPOVRD, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(ONE, AND, VSEQINSZ, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, AND, VSEQOUTSZ, VSEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, AND, ABD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(ONE, AND, OFIFO, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(ONE, AND, ONE, VSEQOUTSZ, SIZE(2), 0);
	MATHB(ONE, AND, ZERO, VSEQOUTSZ, SIZE(1), 0);
	/*AND Operation: NONE Destination register */
	MATHB(MATH0, AND, MATH0, NONE, SIZE(2), 0);
	MATHB(MATH0, AND, MATH1, NONE, SIZE(8), WITH(STL));
	MATHB(MATH0, AND, MATH2, NONE, SIZE(2), 0);
	MATHB(MATH0, AND, MATH3, NONE, SIZE(2), 0);
	MATHB(MATH0, AND, IMM(393615378), NONE, SIZE(2), WITH(NFU | STL));
	MATHB(MATH0, AND, DPOVRD, NONE, SIZE(2), 0);
	MATHB(MATH0, AND, VSEQINSZ, NONE, SIZE(1), 0);
	MATHB(MATH0, AND, VSEQOUTSZ, NONE, SIZE(2), WITH(STL));
	MATHB(MATH0, AND, ABD, NONE, SIZE(1), 0);
	MATHB(MATH0, AND, OFIFO, NONE, SIZE(4), 0);
	MATHB(MATH0, AND, ONE, NONE, SIZE(4), WITH(NFU));
	MATHB(MATH0, AND, ZERO, NONE, SIZE(4), 0);
	MATHB(MATH1, AND, MATH0, NONE, SIZE(2), 0);
	MATHB(MATH1, AND, MATH1, NONE, SIZE(2), WITH(NFU));
	MATHB(MATH1, AND, MATH2, NONE, SIZE(4), 0);
	MATHB(MATH1, AND, MATH3, NONE, SIZE(2), 0);
	MATHB(MATH1, AND, IMM(393615378), NONE, SIZE(4), 0);
	MATHB(MATH1, AND, DPOVRD, NONE, SIZE(1), 0);
	MATHB(MATH1, AND, VSEQINSZ, NONE, SIZE(8), 0);
	MATHB(MATH1, AND, VSEQOUTSZ, NONE, SIZE(8), 0);
	MATHB(MATH1, AND, ABD, NONE, SIZE(8), 0);
	MATHB(MATH1, AND, OFIFO, NONE, SIZE(4), 0);
	MATHB(MATH1, AND, ONE, NONE, SIZE(8), 0);
	MATHB(MATH1, AND, ZERO, NONE, SIZE(1), 0);
	MATHB(MATH2, AND, MATH0, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, AND, MATH1, NONE, SIZE(8), 0);
	MATHB(MATH2, AND, MATH2, NONE, SIZE(4), 0);
	MATHB(MATH2, AND, MATH3, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, AND, IMM(393615378), NONE, SIZE(8), WITH(IFB));
	MATHB(MATH2, AND, DPOVRD, NONE, SIZE(1), WITH(NFU));
	MATHB(MATH2, AND, VSEQINSZ, NONE, SIZE(2), 0);
	MATHB(MATH2, AND, VSEQOUTSZ, NONE, SIZE(1), 0);
	MATHB(MATH2, AND, ABD, NONE, SIZE(4), 0);
	MATHB(MATH2, AND, OFIFO, NONE, SIZE(2), 0);
	MATHB(MATH2, AND, ONE, NONE, SIZE(4), 0);
	MATHB(MATH2, AND, ZERO, NONE, SIZE(4), 0);
	MATHB(MATH3, AND, MATH0, NONE, SIZE(8), 0);
	MATHB(MATH3, AND, MATH1, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(MATH3, AND, MATH2, NONE, SIZE(2), 0);
	MATHB(MATH3, AND, MATH3, NONE, SIZE(8), WITH(NFU));
	MATHB(MATH3, AND, IMM(393615378), NONE, SIZE(8), WITH(IFB));
	MATHB(MATH3, AND, DPOVRD, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, AND, VSEQINSZ, NONE, SIZE(1), WITH(NFU));
	MATHB(MATH3, AND, VSEQOUTSZ, NONE, SIZE(8), 0);
	MATHB(MATH3, AND, ABD, NONE, SIZE(8), 0);
	MATHB(MATH3, AND, OFIFO, NONE, SIZE(1), 0);
	MATHB(MATH3, AND, ONE, NONE, SIZE(1), 0);
	MATHB(MATH3, AND, ZERO, NONE, SIZE(8), 0);
	MATHB(IMM(275128321), AND, MATH0, NONE, SIZE(2), 0);
	MATHB(IMM(275128321), AND, MATH1, NONE, SIZE(1), 0);
	MATHB(IMM(275128321), AND, MATH2, NONE, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), AND, MATH3, NONE, SIZE(4), 0);
	MATHB(IMM(275128321), AND, IMM(393615378), NONE, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), AND, DPOVRD, NONE, SIZE(8),
	      WITH(IFB | NFU | STL));
	MATHB(IMM(0x19261959fedcba01), AND, VSEQINSZ, NONE, SIZE(8), WITH(STL));
	MATHB(IMM(275128321), AND, VSEQOUTSZ, NONE, SIZE(1), 0);
	MATHB(IMM(275128321), AND, ABD, NONE, SIZE(2), 0);
	MATHB(IMM(275128321), AND, OFIFO, NONE, SIZE(1), 0);
	MATHB(IMM(275128321), AND, ONE, NONE, SIZE(4), 0);
	MATHB(IMM(275128321), AND, ZERO, NONE, SIZE(2), WITH(STL));
	MATHB(DPOVRD, AND, MATH0, NONE, SIZE(4), 0);
	MATHB(DPOVRD, AND, MATH1, NONE, SIZE(4), 0);
	MATHB(DPOVRD, AND, MATH2, NONE, SIZE(8), WITH(STL));
	MATHB(DPOVRD, AND, MATH3, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, AND, IMM(393615378), NONE, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, AND, DPOVRD, NONE, SIZE(2), 0);
	MATHB(DPOVRD, AND, VSEQINSZ, NONE, SIZE(2), 0);
	MATHB(DPOVRD, AND, VSEQOUTSZ, NONE, SIZE(8), 0);
	MATHB(DPOVRD, AND, ABD, NONE, SIZE(4), 0);
	MATHB(DPOVRD, AND, OFIFO, NONE, SIZE(8), 0);
	MATHB(DPOVRD, AND, ONE, NONE, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, AND, ZERO, NONE, SIZE(4), 0);
	MATHB(SEQINSZ, AND, MATH0, NONE, SIZE(4), 0);
	MATHB(SEQINSZ, AND, MATH1, NONE, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, AND, MATH2, NONE, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, AND, MATH3, NONE, SIZE(8), 0);
	MATHB(SEQINSZ, AND, IMM(393615378), NONE, SIZE(4), 0);
	MATHB(SEQINSZ, AND, DPOVRD, NONE, SIZE(8), 0);
	MATHB(SEQINSZ, AND, VSEQINSZ, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, AND, VSEQOUTSZ, NONE, SIZE(8), 0);
	MATHB(SEQINSZ, AND, ABD, NONE, SIZE(8), 0);
	MATHB(SEQINSZ, AND, OFIFO, NONE, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, AND, ONE, NONE, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, AND, ZERO, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, AND, MATH0, NONE, SIZE(4), 0);
	MATHB(SEQOUTSZ, AND, MATH1, NONE, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, AND, MATH2, NONE, SIZE(8), 0);
	MATHB(SEQOUTSZ, AND, MATH3, NONE, SIZE(8), 0);
	MATHB(SEQOUTSZ, AND, IMM(393615378), NONE, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, AND, DPOVRD, NONE, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, AND, VSEQINSZ, NONE, SIZE(4), 0);
	MATHB(SEQOUTSZ, AND, VSEQOUTSZ, NONE, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, AND, ABD, NONE, SIZE(8), 0);
	MATHB(SEQOUTSZ, AND, OFIFO, NONE, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, AND, ONE, NONE, SIZE(2), 0);
	MATHB(SEQOUTSZ, AND, ZERO, NONE, SIZE(8), 0);
	MATHB(VSEQINSZ, AND, MATH0, NONE, SIZE(1), 0);
	MATHB(VSEQINSZ, AND, MATH1, NONE, SIZE(4), 0);
	MATHB(VSEQINSZ, AND, MATH2, NONE, SIZE(4), 0);
	MATHB(VSEQINSZ, AND, MATH3, NONE, SIZE(2), 0);
	MATHB(VSEQINSZ, AND, IMM(393615378), NONE, SIZE(4), 0);
	MATHB(VSEQINSZ, AND, DPOVRD, NONE, SIZE(8), 0);
	MATHB(VSEQINSZ, AND, VSEQINSZ, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, AND, VSEQOUTSZ, NONE, SIZE(4), 0);
	MATHB(VSEQINSZ, AND, ABD, NONE, SIZE(1), 0);
	MATHB(VSEQINSZ, AND, OFIFO, NONE, SIZE(4), 0);
	MATHB(VSEQINSZ, AND, ONE, NONE, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, AND, ZERO, NONE, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, AND, MATH0, NONE, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, AND, MATH1, NONE, SIZE(4), 0);
	MATHB(VSEQOUTSZ, AND, MATH2, NONE, SIZE(1), 0);
	MATHB(VSEQOUTSZ, AND, MATH3, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, AND, IMM(393615378), NONE, SIZE(4), 0);
	MATHB(VSEQOUTSZ, AND, DPOVRD, NONE, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, AND, VSEQINSZ, NONE, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, AND, VSEQOUTSZ, NONE, SIZE(8), 0);
	MATHB(VSEQOUTSZ, AND, ABD, NONE, SIZE(8), 0);
	MATHB(VSEQOUTSZ, AND, OFIFO, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, AND, ONE, NONE, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, AND, ZERO, NONE, SIZE(2), WITH(STL));
	MATHB(ZERO, AND, MATH0, NONE, SIZE(8), 0);
	MATHB(ZERO, AND, MATH1, NONE, SIZE(2), 0);
	MATHB(ZERO, AND, MATH2, NONE, SIZE(2), 0);
	MATHB(ZERO, AND, MATH3, NONE, SIZE(1), 0);
	MATHB(ZERO, AND, IMM(393615378), NONE, SIZE(1), WITH(STL));
	MATHB(ZERO, AND, DPOVRD, NONE, SIZE(4), 0);
	MATHB(ZERO, AND, VSEQINSZ, NONE, SIZE(8), 0);
	MATHB(ZERO, AND, VSEQOUTSZ, NONE, SIZE(2), 0);
	MATHB(ZERO, AND, ABD, NONE, SIZE(2), WITH(STL));
	MATHB(ZERO, AND, OFIFO, NONE, SIZE(4), 0);
	MATHB(ZERO, AND, ONE, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, AND, ZERO, NONE, SIZE(2), 0);
	MATHB(ONE, AND, MATH0, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, AND, MATH1, NONE, SIZE(2), 0);
	MATHB(ONE, AND, MATH2, NONE, SIZE(2), 0);
	MATHB(ONE, AND, MATH3, NONE, SIZE(8), 0);
	MATHB(ONE, AND, IMM(393615378), NONE, SIZE(2), WITH(STL));
	MATHB(ONE, AND, DPOVRD, NONE, SIZE(1), 0);
	MATHB(ONE, AND, VSEQINSZ, NONE, SIZE(8), 0);
	MATHB(ONE, AND, VSEQOUTSZ, NONE, SIZE(1), WITH(NFU));
	MATHB(ONE, AND, ABD, NONE, SIZE(2), WITH(STL));
	MATHB(ONE, AND, OFIFO, NONE, SIZE(1), WITH(STL));
	MATHB(ONE, AND, ONE, NONE, SIZE(8), 0);
	MATHB(ONE, AND, ZERO, NONE, SIZE(4), WITH(NFU));
	/*XOR Operation: MATH0 Destination register */
	MATHB(MATH0, XOR, MATH0, MATH0, SIZE(2), WITH(STL));
	MATHB(MATH0, XOR, MATH1, MATH0, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, XOR, MATH2, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, XOR, MATH3, MATH0, SIZE(1), WITH(STL));
	MATHB(MATH0, XOR, IMM(393615378), MATH0, SIZE(4), WITH(STL));
	MATHB(MATH0, XOR, DPOVRD, MATH0, SIZE(1), WITH(STL));
	MATHB(MATH0, XOR, VSEQINSZ, MATH0, SIZE(4), 0);
	MATHB(MATH0, XOR, VSEQOUTSZ, MATH0, SIZE(8), WITH(STL));
	MATHB(MATH0, XOR, ABD, MATH0, SIZE(8), 0);
	MATHB(MATH0, XOR, OFIFO, MATH0, SIZE(1), WITH(STL));
	MATHB(MATH0, XOR, ONE, MATH0, SIZE(4), 0);
	MATHB(MATH0, XOR, ZERO, MATH0, SIZE(2), WITH(STL));
	MATHB(MATH1, XOR, MATH0, MATH0, SIZE(1), 0);
	MATHB(MATH1, XOR, MATH1, MATH0, SIZE(2), 0);
	MATHB(MATH1, XOR, MATH2, MATH0, SIZE(2), 0);
	MATHB(MATH1, XOR, MATH3, MATH0, SIZE(4), 0);
	MATHB(MATH1, XOR, IMM(393615378), MATH0, SIZE(1), WITH(NFU));
	MATHB(MATH1, XOR, DPOVRD, MATH0, SIZE(4), 0);
	MATHB(MATH1, XOR, VSEQINSZ, MATH0, SIZE(4), 0);
	MATHB(MATH1, XOR, VSEQOUTSZ, MATH0, SIZE(8), 0);
	MATHB(MATH1, XOR, ABD, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, XOR, OFIFO, MATH0, SIZE(1), WITH(STL));
	MATHB(MATH1, XOR, ONE, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, XOR, ZERO, MATH0, SIZE(4), 0);
	MATHB(MATH2, XOR, MATH0, MATH0, SIZE(2), WITH(NFU));
	MATHB(MATH2, XOR, MATH1, MATH0, SIZE(4), 0);
	MATHB(MATH2, XOR, MATH2, MATH0, SIZE(2), 0);
	MATHB(MATH2, XOR, MATH3, MATH0, SIZE(2), 0);
	MATHB(MATH2, XOR, IMM(0x19261959fedcba01), MATH0, SIZE(8), 0);
	MATHB(MATH2, XOR, DPOVRD, MATH0, SIZE(8), 0);
	MATHB(MATH2, XOR, VSEQINSZ, MATH0, SIZE(4), 0);
	MATHB(MATH2, XOR, VSEQOUTSZ, MATH0, SIZE(4), 0);
	MATHB(MATH2, XOR, ABD, MATH0, SIZE(1), 0);
	MATHB(MATH2, XOR, OFIFO, MATH0, SIZE(2), 0);
	MATHB(MATH2, XOR, ONE, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, XOR, ZERO, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, XOR, MATH0, MATH0, SIZE(8), 0);
	MATHB(MATH3, XOR, MATH1, MATH0, SIZE(8), WITH(STL));
	MATHB(MATH3, XOR, MATH2, MATH0, SIZE(2), WITH(NFU));
	MATHB(MATH3, XOR, MATH3, MATH0, SIZE(4), 0);
	MATHB(MATH3, XOR, IMM(393615378), MATH0, SIZE(4), 0);
	MATHB(MATH3, XOR, DPOVRD, MATH0, SIZE(4), 0);
	MATHB(MATH3, XOR, VSEQINSZ, MATH0, SIZE(1), 0);
	MATHB(MATH3, XOR, VSEQOUTSZ, MATH0, SIZE(2), 0);
	MATHB(MATH3, XOR, ABD, MATH0, SIZE(2), 0);
	MATHB(MATH3, XOR, OFIFO, MATH0, SIZE(4), 0);
	MATHB(MATH3, XOR, ONE, MATH0, SIZE(8), 0);
	MATHB(MATH3, XOR, ZERO, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(275128321), XOR, MATH0, MATH0, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), XOR, MATH1, MATH0, SIZE(1), 0);
	MATHB(IMM(275128321), XOR, MATH2, MATH0, SIZE(1), WITH(NFU));
	MATHB(IMM(0x19261959fedcba01), XOR, MATH3, MATH0, SIZE(8), 0);
	MATHB(IMM(275128321), XOR, IMM(393615378), MATH0, SIZE(1), 0);
	MATHB(IMM(275128321), XOR, DPOVRD, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(275128321), XOR, VSEQINSZ, MATH0, SIZE(1), 0);
	MATHB(IMM(275128321), XOR, VSEQOUTSZ, MATH0, SIZE(1), 0);
	MATHB(IMM(0x19261959fedcba01), XOR, ABD, MATH0, SIZE(8), WITH(NFU));
	MATHB(IMM(275128321), XOR, OFIFO, MATH0, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), XOR, ONE, MATH0, SIZE(8), WITH(IFB | STL));
	MATHB(IMM(275128321), XOR, ZERO, MATH0, SIZE(2), 0);
	MATHB(DPOVRD, XOR, MATH0, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, XOR, MATH1, MATH0, SIZE(2), 0);
	MATHB(DPOVRD, XOR, MATH2, MATH0, SIZE(8), 0);
	MATHB(DPOVRD, XOR, MATH3, MATH0, SIZE(4), 0);
	MATHB(DPOVRD, XOR, IMM(393615378), MATH0, SIZE(2), WITH(STL));
	MATHB(DPOVRD, XOR, DPOVRD, MATH0, SIZE(2), WITH(STL));
	MATHB(DPOVRD, XOR, VSEQINSZ, MATH0, SIZE(8), 0);
	MATHB(DPOVRD, XOR, VSEQOUTSZ, MATH0, SIZE(2), 0);
	MATHB(DPOVRD, XOR, ABD, MATH0, SIZE(8), WITH(STL));
	MATHB(DPOVRD, XOR, OFIFO, MATH0, SIZE(4), WITH(STL));
	MATHB(DPOVRD, XOR, ONE, MATH0, SIZE(8), 0);
	MATHB(DPOVRD, XOR, ZERO, MATH0, SIZE(8), 0);
	MATHB(SEQINSZ, XOR, MATH0, MATH0, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, XOR, MATH1, MATH0, SIZE(4), 0);
	MATHB(SEQINSZ, XOR, MATH2, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, XOR, MATH3, MATH0, SIZE(8), 0);
	MATHB(SEQINSZ, XOR, IMM(393615378), MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, XOR, DPOVRD, MATH0, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, XOR, VSEQINSZ, MATH0, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, XOR, VSEQOUTSZ, MATH0, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, XOR, ABD, MATH0, SIZE(8), 0);
	MATHB(SEQINSZ, XOR, OFIFO, MATH0, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, XOR, ONE, MATH0, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, XOR, ZERO, MATH0, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, XOR, MATH0, MATH0, SIZE(4), 0);
	MATHB(SEQOUTSZ, XOR, MATH1, MATH0, SIZE(2), 0);
	MATHB(SEQOUTSZ, XOR, MATH2, MATH0, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, XOR, MATH3, MATH0, SIZE(2), 0);
	MATHB(SEQOUTSZ, XOR, IMM(393615378), MATH0, SIZE(8), WITH(IFB));
	MATHB(SEQOUTSZ, XOR, DPOVRD, MATH0, SIZE(8), 0);
	MATHB(SEQOUTSZ, XOR, VSEQINSZ, MATH0, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, XOR, VSEQOUTSZ, MATH0, SIZE(4), 0);
	MATHB(SEQOUTSZ, XOR, ABD, MATH0, SIZE(1), 0);
	MATHB(SEQOUTSZ, XOR, OFIFO, MATH0, SIZE(1), 0);
	MATHB(SEQOUTSZ, XOR, ONE, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, XOR, ZERO, MATH0, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, XOR, MATH0, MATH0, SIZE(1), 0);
	MATHB(VSEQINSZ, XOR, MATH1, MATH0, SIZE(4), 0);
	MATHB(VSEQINSZ, XOR, MATH2, MATH0, SIZE(4), 0);
	MATHB(VSEQINSZ, XOR, MATH3, MATH0, SIZE(8), 0);
	MATHB(VSEQINSZ, XOR, IMM(393615378), MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, XOR, DPOVRD, MATH0, SIZE(8), 0);
	MATHB(VSEQINSZ, XOR, VSEQINSZ, MATH0, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, XOR, VSEQOUTSZ, MATH0, SIZE(8), 0);
	MATHB(VSEQINSZ, XOR, ABD, MATH0, SIZE(1), 0);
	MATHB(VSEQINSZ, XOR, OFIFO, MATH0, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, XOR, ONE, MATH0, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, XOR, ZERO, MATH0, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, XOR, MATH0, MATH0, SIZE(8), 0);
	MATHB(VSEQOUTSZ, XOR, MATH1, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, XOR, MATH2, MATH0, SIZE(2), 0);
	MATHB(VSEQOUTSZ, XOR, MATH3, MATH0, SIZE(8), 0);
	MATHB(VSEQOUTSZ, XOR, IMM(393615378), MATH0, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, XOR, DPOVRD, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, XOR, VSEQINSZ, MATH0, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, XOR, VSEQOUTSZ, MATH0, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, XOR, ABD, MATH0, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, XOR, OFIFO, MATH0, SIZE(4), 0);
	MATHB(VSEQOUTSZ, XOR, ONE, MATH0, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, XOR, ZERO, MATH0, SIZE(2), WITH(STL));
	MATHB(ZERO, XOR, MATH0, MATH0, SIZE(2), WITH(NFU));
	MATHB(ZERO, XOR, MATH1, MATH0, SIZE(2), 0);
	MATHB(ZERO, XOR, MATH2, MATH0, SIZE(1), 0);
	MATHB(ZERO, XOR, MATH3, MATH0, SIZE(1), 0);
	MATHB(ZERO, XOR, IMM(393615378), MATH0, SIZE(4), 0);
	MATHB(ZERO, XOR, DPOVRD, MATH0, SIZE(4), WITH(STL));
	MATHB(ZERO, XOR, VSEQINSZ, MATH0, SIZE(4), 0);
	MATHB(ZERO, XOR, VSEQOUTSZ, MATH0, SIZE(1), 0);
	MATHB(ZERO, XOR, ABD, MATH0, SIZE(2), 0);
	MATHB(ZERO, XOR, OFIFO, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, XOR, ONE, MATH0, SIZE(4), 0);
	MATHB(ZERO, XOR, ZERO, MATH0, SIZE(2), WITH(NFU));
	MATHB(ONE, XOR, MATH0, MATH0, SIZE(8), WITH(NFU));
	MATHB(ONE, XOR, MATH1, MATH0, SIZE(1), 0);
	MATHB(ONE, XOR, MATH2, MATH0, SIZE(2), 0);
	MATHB(ONE, XOR, MATH3, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, XOR, IMM(393615378), MATH0, SIZE(8), WITH(IFB | NFU | STL));
	MATHB(ONE, XOR, DPOVRD, MATH0, SIZE(1), 0);
	MATHB(ONE, XOR, VSEQINSZ, MATH0, SIZE(1), 0);
	MATHB(ONE, XOR, VSEQOUTSZ, MATH0, SIZE(2), 0);
	MATHB(ONE, XOR, ABD, MATH0, SIZE(4), WITH(STL));
	MATHB(ONE, XOR, OFIFO, MATH0, SIZE(1), 0);
	MATHB(ONE, XOR, ONE, MATH0, SIZE(4), WITH(NFU));
	MATHB(ONE, XOR, ZERO, MATH0, SIZE(4), 0);
	/*XOR Operation: MATH1 Destination register */
	MATHB(MATH0, XOR, MATH0, MATH1, SIZE(8), 0);
	MATHB(MATH0, XOR, MATH1, MATH1, SIZE(1), 0);
	MATHB(MATH0, XOR, MATH2, MATH1, SIZE(4), 0);
	MATHB(MATH0, XOR, MATH3, MATH1, SIZE(2), 0);
	MATHB(MATH0, XOR, IMM(393615378), MATH1, SIZE(4), 0);
	MATHB(MATH0, XOR, DPOVRD, MATH1, SIZE(4), 0);
	MATHB(MATH0, XOR, VSEQINSZ, MATH1, SIZE(8), WITH(STL));
	MATHB(MATH0, XOR, VSEQOUTSZ, MATH1, SIZE(2), WITH(NFU));
	MATHB(MATH0, XOR, ABD, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, XOR, OFIFO, MATH1, SIZE(1), WITH(STL));
	MATHB(MATH0, XOR, ONE, MATH1, SIZE(1), 0);
	MATHB(MATH0, XOR, ZERO, MATH1, SIZE(2), 0);
	MATHB(MATH1, XOR, MATH0, MATH1, SIZE(4), 0);
	MATHB(MATH1, XOR, MATH1, MATH1, SIZE(1), WITH(STL));
	MATHB(MATH1, XOR, MATH2, MATH1, SIZE(2), WITH(NFU));
	MATHB(MATH1, XOR, MATH3, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, XOR, IMM(393615378), MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, XOR, DPOVRD, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, XOR, VSEQINSZ, MATH1, SIZE(2), 0);
	MATHB(MATH1, XOR, VSEQOUTSZ, MATH1, SIZE(4), 0);
	MATHB(MATH1, XOR, ABD, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, XOR, OFIFO, MATH1, SIZE(1), WITH(NFU));
	MATHB(MATH1, XOR, ONE, MATH1, SIZE(4), WITH(NFU));
	MATHB(MATH1, XOR, ZERO, MATH1, SIZE(8), 0);
	MATHB(MATH2, XOR, MATH0, MATH1, SIZE(4), 0);
	MATHB(MATH2, XOR, MATH1, MATH1, SIZE(4), 0);
	MATHB(MATH2, XOR, MATH2, MATH1, SIZE(4), 0);
	MATHB(MATH2, XOR, MATH3, MATH1, SIZE(4), 0);
	MATHB(MATH2, XOR, IMM(393615378), MATH1, SIZE(2), WITH(STL));
	MATHB(MATH2, XOR, DPOVRD, MATH1, SIZE(4), 0);
	MATHB(MATH2, XOR, VSEQINSZ, MATH1, SIZE(8), WITH(STL));
	MATHB(MATH2, XOR, VSEQOUTSZ, MATH1, SIZE(8), WITH(NFU));
	MATHB(MATH2, XOR, ABD, MATH1, SIZE(1), 0);
	MATHB(MATH2, XOR, OFIFO, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, XOR, ONE, MATH1, SIZE(2), 0);
	MATHB(MATH2, XOR, ZERO, MATH1, SIZE(1), 0);
	MATHB(MATH3, XOR, MATH0, MATH1, SIZE(4), WITH(NFU));
	MATHB(MATH3, XOR, MATH1, MATH1, SIZE(2), 0);
	MATHB(MATH3, XOR, MATH2, MATH1, SIZE(8), WITH(STL));
	MATHB(MATH3, XOR, MATH3, MATH1, SIZE(4), 0);
	MATHB(MATH3, XOR, IMM(393615378), MATH1, SIZE(4), WITH(NFU));
	MATHB(MATH3, XOR, DPOVRD, MATH1, SIZE(4), 0);
	MATHB(MATH3, XOR, VSEQINSZ, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, XOR, VSEQOUTSZ, MATH1, SIZE(1), WITH(NFU));
	MATHB(MATH3, XOR, ABD, MATH1, SIZE(1), WITH(STL));
	MATHB(MATH3, XOR, OFIFO, MATH1, SIZE(1), 0);
	MATHB(MATH3, XOR, ONE, MATH1, SIZE(2), 0);
	MATHB(MATH3, XOR, ZERO, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(275128321), XOR, MATH0, MATH1, SIZE(2), 0);
	MATHB(IMM(275128321), XOR, MATH1, MATH1, SIZE(2), 0);
	MATHB(IMM(275128321), XOR, MATH2, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(0x19261959fedcba01), XOR, MATH3, MATH1, SIZE(8), 0);
	MATHB(IMM(275128321), XOR, IMM(393615378), MATH1, SIZE(2), WITH(STL));
	MATHB(IMM(275128321), XOR, DPOVRD, MATH1, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), XOR, VSEQINSZ, MATH1, SIZE(2), 0);
	MATHB(IMM(275128321), XOR, VSEQOUTSZ, MATH1, SIZE(8), WITH(IFB | NFU));
	MATHB(IMM(275128321), XOR, ABD, MATH1, SIZE(2), 0);
	MATHB(IMM(275128321), XOR, OFIFO, MATH1, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), XOR, ONE, MATH1, SIZE(2), 0);
	MATHB(IMM(275128321), XOR, ZERO, MATH1, SIZE(1), 0);
	MATHB(DPOVRD, XOR, MATH0, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, XOR, MATH1, MATH1, SIZE(8), 0);
	MATHB(DPOVRD, XOR, MATH2, MATH1, SIZE(1), 0);
	MATHB(DPOVRD, XOR, MATH3, MATH1, SIZE(1), 0);
	MATHB(DPOVRD, XOR, IMM(393615378), MATH1, SIZE(1), 0);
	MATHB(DPOVRD, XOR, DPOVRD, MATH1, SIZE(4), 0);
	MATHB(DPOVRD, XOR, VSEQINSZ, MATH1, SIZE(4), 0);
	MATHB(DPOVRD, XOR, VSEQOUTSZ, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, XOR, ABD, MATH1, SIZE(2), WITH(STL));
	MATHB(DPOVRD, XOR, OFIFO, MATH1, SIZE(4), 0);
	MATHB(DPOVRD, XOR, ONE, MATH1, SIZE(8), 0);
	MATHB(DPOVRD, XOR, ZERO, MATH1, SIZE(1), 0);
	MATHB(SEQINSZ, XOR, MATH0, MATH1, SIZE(2), 0);
	MATHB(SEQINSZ, XOR, MATH1, MATH1, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, XOR, MATH2, MATH1, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, XOR, MATH3, MATH1, SIZE(4), 0);
	MATHB(SEQINSZ, XOR, IMM(0x19261959fedcba01), MATH1, SIZE(8), 0);
	MATHB(SEQINSZ, XOR, DPOVRD, MATH1, SIZE(2), 0);
	MATHB(SEQINSZ, XOR, VSEQINSZ, MATH1, SIZE(8), 0);
	MATHB(SEQINSZ, XOR, VSEQOUTSZ, MATH1, SIZE(8), 0);
	MATHB(SEQINSZ, XOR, ABD, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, XOR, OFIFO, MATH1, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, XOR, ONE, MATH1, SIZE(4), 0);
	MATHB(SEQINSZ, XOR, ZERO, MATH1, SIZE(2), 0);
	MATHB(SEQOUTSZ, XOR, MATH0, MATH1, SIZE(1), 0);
	MATHB(SEQOUTSZ, XOR, MATH1, MATH1, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, XOR, MATH2, MATH1, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, XOR, MATH3, MATH1, SIZE(8), 0);
	MATHB(SEQOUTSZ, XOR, IMM(393615378), MATH1, SIZE(1), 0);
	MATHB(SEQOUTSZ, XOR, DPOVRD, MATH1, SIZE(4), 0);
	MATHB(SEQOUTSZ, XOR, VSEQINSZ, MATH1, SIZE(1), 0);
	MATHB(SEQOUTSZ, XOR, VSEQOUTSZ, MATH1, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, XOR, ABD, MATH1, SIZE(4), 0);
	MATHB(SEQOUTSZ, XOR, OFIFO, MATH1, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, XOR, ONE, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, XOR, ZERO, MATH1, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, XOR, MATH0, MATH1, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, XOR, MATH1, MATH1, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, XOR, MATH2, MATH1, SIZE(2), 0);
	MATHB(VSEQINSZ, XOR, MATH3, MATH1, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, XOR, IMM(393615378), MATH1, SIZE(2), 0);
	MATHB(VSEQINSZ, XOR, DPOVRD, MATH1, SIZE(1), 0);
	MATHB(VSEQINSZ, XOR, VSEQINSZ, MATH1, SIZE(1), 0);
	MATHB(VSEQINSZ, XOR, VSEQOUTSZ, MATH1, SIZE(4), 0);
	MATHB(VSEQINSZ, XOR, ABD, MATH1, SIZE(1), 0);
	MATHB(VSEQINSZ, XOR, OFIFO, MATH1, SIZE(2), 0);
	MATHB(VSEQINSZ, XOR, ONE, MATH1, SIZE(2), 0);
	MATHB(VSEQINSZ, XOR, ZERO, MATH1, SIZE(1), 0);
	MATHB(VSEQOUTSZ, XOR, MATH0, MATH1, SIZE(8), 0);
	MATHB(VSEQOUTSZ, XOR, MATH1, MATH1, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, XOR, MATH2, MATH1, SIZE(4), 0);
	MATHB(VSEQOUTSZ, XOR, MATH3, MATH1, SIZE(8), 0);
	MATHB(VSEQOUTSZ, XOR, IMM(393615378), MATH1, SIZE(1), 0);
	MATHB(VSEQOUTSZ, XOR, DPOVRD, MATH1, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, XOR, VSEQINSZ, MATH1, SIZE(2), 0);
	MATHB(VSEQOUTSZ, XOR, VSEQOUTSZ, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, XOR, ABD, MATH1, SIZE(4), 0);
	MATHB(VSEQOUTSZ, XOR, OFIFO, MATH1, SIZE(4), 0);
	MATHB(VSEQOUTSZ, XOR, ONE, MATH1, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, XOR, ZERO, MATH1, SIZE(8), 0);
	MATHB(ZERO, XOR, MATH0, MATH1, SIZE(4), 0);
	MATHB(ZERO, XOR, MATH1, MATH1, SIZE(4), WITH(NFU));
	MATHB(ZERO, XOR, MATH2, MATH1, SIZE(8), 0);
	MATHB(ZERO, XOR, MATH3, MATH1, SIZE(8), 0);
	MATHB(ZERO, XOR, IMM(393615378), MATH1, SIZE(8), WITH(IFB | STL));
	MATHB(ZERO, XOR, DPOVRD, MATH1, SIZE(8), 0);
	MATHB(ZERO, XOR, VSEQINSZ, MATH1, SIZE(4), WITH(STL));
	MATHB(ZERO, XOR, VSEQOUTSZ, MATH1, SIZE(4), 0);
	MATHB(ZERO, XOR, ABD, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, XOR, OFIFO, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, XOR, ONE, MATH1, SIZE(4), WITH(STL));
	MATHB(ZERO, XOR, ZERO, MATH1, SIZE(8), WITH(NFU));
	MATHB(ONE, XOR, MATH0, MATH1, SIZE(8), 0);
	MATHB(ONE, XOR, MATH1, MATH1, SIZE(1), 0);
	MATHB(ONE, XOR, MATH2, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, XOR, MATH3, MATH1, SIZE(4), 0);
	MATHB(ONE, XOR, IMM(0x19261959fedcba01), MATH1, SIZE(8), WITH(STL));
	MATHB(ONE, XOR, DPOVRD, MATH1, SIZE(2), WITH(STL));
	MATHB(ONE, XOR, VSEQINSZ, MATH1, SIZE(4), 0);
	MATHB(ONE, XOR, VSEQOUTSZ, MATH1, SIZE(8), WITH(STL));
	MATHB(ONE, XOR, ABD, MATH1, SIZE(8), 0);
	MATHB(ONE, XOR, OFIFO, MATH1, SIZE(8), 0);
	MATHB(ONE, XOR, ONE, MATH1, SIZE(4), 0);
	MATHB(ONE, XOR, ZERO, MATH1, SIZE(8), 0);
	/*XOR Operation: MATH2 Destination register */
	MATHB(MATH0, XOR, MATH0, MATH2, SIZE(2), 0);
	MATHB(MATH0, XOR, MATH1, MATH2, SIZE(8), 0);
	MATHB(MATH0, XOR, MATH2, MATH2, SIZE(8), 0);
	MATHB(MATH0, XOR, MATH3, MATH2, SIZE(8), WITH(STL));
	MATHB(MATH0, XOR, IMM(0x19261959fedcba01), MATH2, SIZE(8),
	      WITH(NFU | STL));
	MATHB(MATH0, XOR, DPOVRD, MATH2, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, XOR, VSEQINSZ, MATH2, SIZE(4), WITH(NFU));
	MATHB(MATH0, XOR, VSEQOUTSZ, MATH2, SIZE(2), 0);
	MATHB(MATH0, XOR, ABD, MATH2, SIZE(8), WITH(STL));
	MATHB(MATH0, XOR, OFIFO, MATH2, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, XOR, ONE, MATH2, SIZE(4), 0);
	MATHB(MATH0, XOR, ZERO, MATH2, SIZE(8), 0);
	MATHB(MATH1, XOR, MATH0, MATH2, SIZE(2), 0);
	MATHB(MATH1, XOR, MATH1, MATH2, SIZE(8), WITH(STL));
	MATHB(MATH1, XOR, MATH2, MATH2, SIZE(4), 0);
	MATHB(MATH1, XOR, MATH3, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, XOR, IMM(393615378), MATH2, SIZE(4), 0);
	MATHB(MATH1, XOR, DPOVRD, MATH2, SIZE(8), 0);
	MATHB(MATH1, XOR, VSEQINSZ, MATH2, SIZE(4), 0);
	MATHB(MATH1, XOR, VSEQOUTSZ, MATH2, SIZE(1), 0);
	MATHB(MATH1, XOR, ABD, MATH2, SIZE(1), WITH(NFU));
	MATHB(MATH1, XOR, OFIFO, MATH2, SIZE(1), WITH(NFU));
	MATHB(MATH1, XOR, ONE, MATH2, SIZE(1), WITH(NFU));
	MATHB(MATH1, XOR, ZERO, MATH2, SIZE(8), WITH(STL));
	MATHB(MATH2, XOR, MATH0, MATH2, SIZE(1), WITH(STL));
	MATHB(MATH2, XOR, MATH1, MATH2, SIZE(2), 0);
	MATHB(MATH2, XOR, MATH2, MATH2, SIZE(1), WITH(NFU));
	MATHB(MATH2, XOR, MATH3, MATH2, SIZE(8), 0);
	MATHB(MATH2, XOR, IMM(393615378), MATH2, SIZE(4), 0);
	MATHB(MATH2, XOR, DPOVRD, MATH2, SIZE(8), 0);
	MATHB(MATH2, XOR, VSEQINSZ, MATH2, SIZE(8), 0);
	MATHB(MATH2, XOR, VSEQOUTSZ, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, XOR, ABD, MATH2, SIZE(8), 0);
	MATHB(MATH2, XOR, OFIFO, MATH2, SIZE(8), 0);
	MATHB(MATH2, XOR, ONE, MATH2, SIZE(8), 0);
	MATHB(MATH2, XOR, ZERO, MATH2, SIZE(8), 0);
	MATHB(MATH3, XOR, MATH0, MATH2, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, XOR, MATH1, MATH2, SIZE(4), 0);
	MATHB(MATH3, XOR, MATH2, MATH2, SIZE(1), WITH(STL));
	MATHB(MATH3, XOR, MATH3, MATH2, SIZE(1), 0);
	MATHB(MATH3, XOR, IMM(0x19261959fedcba01), MATH2, SIZE(8), 0);
	MATHB(MATH3, XOR, DPOVRD, MATH2, SIZE(8), WITH(STL));
	MATHB(MATH3, XOR, VSEQINSZ, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, XOR, VSEQOUTSZ, MATH2, SIZE(2), 0);
	MATHB(MATH3, XOR, ABD, MATH2, SIZE(8), WITH(NFU));
	MATHB(MATH3, XOR, OFIFO, MATH2, SIZE(2), WITH(STL));
	MATHB(MATH3, XOR, ONE, MATH2, SIZE(8), WITH(STL));
	MATHB(MATH3, XOR, ZERO, MATH2, SIZE(2), WITH(STL));
	MATHB(IMM(0x19261959fedcba01), XOR, MATH0, MATH2, SIZE(8), 0);
	MATHB(IMM(275128321), XOR, MATH1, MATH2, SIZE(1), 0);
	MATHB(IMM(0x19261959fedcba01), XOR, MATH2, MATH2, SIZE(8), 0);
	MATHB(IMM(275128321), XOR, MATH3, MATH2, SIZE(4), 0);
	MATHB(IMM(275128321), XOR, IMM(393615378), MATH2, SIZE(4), 0);
	MATHB(IMM(275128321), XOR, DPOVRD, MATH2, SIZE(2), 0);
	MATHB(IMM(275128321), XOR, VSEQINSZ, MATH2, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), XOR, VSEQOUTSZ, MATH2, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), XOR, ABD, MATH2, SIZE(4), 0);
	MATHB(IMM(275128321), XOR, OFIFO, MATH2, SIZE(4), 0);
	MATHB(IMM(275128321), XOR, ONE, MATH2, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), XOR, ZERO, MATH2, SIZE(8), WITH(IFB));
	MATHB(DPOVRD, XOR, MATH0, MATH2, SIZE(2), 0);
	MATHB(DPOVRD, XOR, MATH1, MATH2, SIZE(1), 0);
	MATHB(DPOVRD, XOR, MATH2, MATH2, SIZE(2), 0);
	MATHB(DPOVRD, XOR, MATH3, MATH2, SIZE(1), 0);
	MATHB(DPOVRD, XOR, IMM(393615378), MATH2, SIZE(1), WITH(NFU));
	MATHB(DPOVRD, XOR, DPOVRD, MATH2, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, XOR, VSEQINSZ, MATH2, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, XOR, VSEQOUTSZ, MATH2, SIZE(4), WITH(STL));
	MATHB(DPOVRD, XOR, ABD, MATH2, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, XOR, OFIFO, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, XOR, ONE, MATH2, SIZE(2), 0);
	MATHB(DPOVRD, XOR, ZERO, MATH2, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, XOR, MATH0, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, XOR, MATH1, MATH2, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, XOR, MATH2, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, XOR, MATH3, MATH2, SIZE(4), 0);
	MATHB(SEQINSZ, XOR, IMM(393615378), MATH2, SIZE(2), 0);
	MATHB(SEQINSZ, XOR, DPOVRD, MATH2, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, XOR, VSEQINSZ, MATH2, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, XOR, VSEQOUTSZ, MATH2, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, XOR, ABD, MATH2, SIZE(4), 0);
	MATHB(SEQINSZ, XOR, OFIFO, MATH2, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, XOR, ONE, MATH2, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, XOR, ZERO, MATH2, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, XOR, MATH0, MATH2, SIZE(2), 0);
	MATHB(SEQOUTSZ, XOR, MATH1, MATH2, SIZE(1), 0);
	MATHB(SEQOUTSZ, XOR, MATH2, MATH2, SIZE(4), 0);
	MATHB(SEQOUTSZ, XOR, MATH3, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, XOR, IMM(393615378), MATH2, SIZE(8), WITH(IFB));
	MATHB(SEQOUTSZ, XOR, DPOVRD, MATH2, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, XOR, VSEQINSZ, MATH2, SIZE(1), 0);
	MATHB(SEQOUTSZ, XOR, VSEQOUTSZ, MATH2, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, XOR, ABD, MATH2, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, XOR, OFIFO, MATH2, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, XOR, ONE, MATH2, SIZE(1), 0);
	MATHB(SEQOUTSZ, XOR, ZERO, MATH2, SIZE(2), 0);
	MATHB(VSEQINSZ, XOR, MATH0, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, XOR, MATH1, MATH2, SIZE(1), 0);
	MATHB(VSEQINSZ, XOR, MATH2, MATH2, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, XOR, MATH3, MATH2, SIZE(2), 0);
	MATHB(VSEQINSZ, XOR, IMM(393615378), MATH2, SIZE(2), 0);
	MATHB(VSEQINSZ, XOR, DPOVRD, MATH2, SIZE(1), 0);
	MATHB(VSEQINSZ, XOR, VSEQINSZ, MATH2, SIZE(1), 0);
	MATHB(VSEQINSZ, XOR, VSEQOUTSZ, MATH2, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, XOR, ABD, MATH2, SIZE(4), 0);
	MATHB(VSEQINSZ, XOR, OFIFO, MATH2, SIZE(2), 0);
	MATHB(VSEQINSZ, XOR, ONE, MATH2, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQINSZ, XOR, ZERO, MATH2, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, XOR, MATH0, MATH2, SIZE(8), 0);
	MATHB(VSEQOUTSZ, XOR, MATH1, MATH2, SIZE(8), 0);
	MATHB(VSEQOUTSZ, XOR, MATH2, MATH2, SIZE(8), 0);
	MATHB(VSEQOUTSZ, XOR, MATH3, MATH2, SIZE(1), 0);
	MATHB(VSEQOUTSZ, XOR, IMM(393615378), MATH2, SIZE(1), 0);
	MATHB(VSEQOUTSZ, XOR, DPOVRD, MATH2, SIZE(1), 0);
	MATHB(VSEQOUTSZ, XOR, VSEQINSZ, MATH2, SIZE(2), 0);
	MATHB(VSEQOUTSZ, XOR, VSEQOUTSZ, MATH2, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, XOR, ABD, MATH2, SIZE(8), 0);
	MATHB(VSEQOUTSZ, XOR, OFIFO, MATH2, SIZE(2), 0);
	MATHB(VSEQOUTSZ, XOR, ONE, MATH2, SIZE(2), 0);
	MATHB(VSEQOUTSZ, XOR, ZERO, MATH2, SIZE(4), 0);
	MATHB(ZERO, XOR, MATH0, MATH2, SIZE(4), 0);
	MATHB(ZERO, XOR, MATH1, MATH2, SIZE(1), 0);
	MATHB(ZERO, XOR, MATH2, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, XOR, MATH3, MATH2, SIZE(4), 0);
	MATHB(ZERO, XOR, IMM(393615378), MATH2, SIZE(2), 0);
	MATHB(ZERO, XOR, DPOVRD, MATH2, SIZE(2), 0);
	MATHB(ZERO, XOR, VSEQINSZ, MATH2, SIZE(4), WITH(STL));
	MATHB(ZERO, XOR, VSEQOUTSZ, MATH2, SIZE(2), 0);
	MATHB(ZERO, XOR, ABD, MATH2, SIZE(2), WITH(STL));
	MATHB(ZERO, XOR, OFIFO, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, XOR, ONE, MATH2, SIZE(1), 0);
	MATHB(ZERO, XOR, ZERO, MATH2, SIZE(8), 0);
	MATHB(ONE, XOR, MATH0, MATH2, SIZE(1), 0);
	MATHB(ONE, XOR, MATH1, MATH2, SIZE(2), WITH(STL));
	MATHB(ONE, XOR, MATH2, MATH2, SIZE(2), 0);
	MATHB(ONE, XOR, MATH3, MATH2, SIZE(2), WITH(NFU));
	MATHB(ONE, XOR, IMM(393615378), MATH2, SIZE(8), WITH(IFB));
	MATHB(ONE, XOR, DPOVRD, MATH2, SIZE(2), WITH(STL));
	MATHB(ONE, XOR, VSEQINSZ, MATH2, SIZE(2), 0);
	MATHB(ONE, XOR, VSEQOUTSZ, MATH2, SIZE(1), 0);
	MATHB(ONE, XOR, ABD, MATH2, SIZE(8), 0);
	MATHB(ONE, XOR, OFIFO, MATH2, SIZE(8), 0);
	MATHB(ONE, XOR, ONE, MATH2, SIZE(1), 0);
	MATHB(ONE, XOR, ZERO, MATH2, SIZE(1), WITH(STL));
	/*XOR Operation: MATH3 Destination register */
	MATHB(MATH0, XOR, MATH0, MATH3, SIZE(2), 0);
	MATHB(MATH0, XOR, MATH1, MATH3, SIZE(4), WITH(STL));
	MATHB(MATH0, XOR, MATH2, MATH3, SIZE(8), 0);
	MATHB(MATH0, XOR, MATH3, MATH3, SIZE(2), 0);
	MATHB(MATH0, XOR, IMM(393615378), MATH3, SIZE(4), 0);
	MATHB(MATH0, XOR, DPOVRD, MATH3, SIZE(2), 0);
	MATHB(MATH0, XOR, VSEQINSZ, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, XOR, VSEQOUTSZ, MATH3, SIZE(2), 0);
	MATHB(MATH0, XOR, ABD, MATH3, SIZE(4), WITH(NFU));
	MATHB(MATH0, XOR, OFIFO, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, XOR, ONE, MATH3, SIZE(4), 0);
	MATHB(MATH0, XOR, ZERO, MATH3, SIZE(1), 0);
	MATHB(MATH1, XOR, MATH0, MATH3, SIZE(1), 0);
	MATHB(MATH1, XOR, MATH1, MATH3, SIZE(4), WITH(NFU));
	MATHB(MATH1, XOR, MATH2, MATH3, SIZE(1), 0);
	MATHB(MATH1, XOR, MATH3, MATH3, SIZE(4), 0);
	MATHB(MATH1, XOR, IMM(0x19261959fedcba01), MATH3, SIZE(8), 0);
	MATHB(MATH1, XOR, DPOVRD, MATH3, SIZE(8), 0);
	MATHB(MATH1, XOR, VSEQINSZ, MATH3, SIZE(2), WITH(NFU));
	MATHB(MATH1, XOR, VSEQOUTSZ, MATH3, SIZE(4), 0);
	MATHB(MATH1, XOR, ABD, MATH3, SIZE(1), WITH(STL));
	MATHB(MATH1, XOR, OFIFO, MATH3, SIZE(2), 0);
	MATHB(MATH1, XOR, ONE, MATH3, SIZE(1), 0);
	MATHB(MATH1, XOR, ZERO, MATH3, SIZE(8), 0);
	MATHB(MATH2, XOR, MATH0, MATH3, SIZE(1), 0);
	MATHB(MATH2, XOR, MATH1, MATH3, SIZE(1), 0);
	MATHB(MATH2, XOR, MATH2, MATH3, SIZE(1), 0);
	MATHB(MATH2, XOR, MATH3, MATH3, SIZE(8), 0);
	MATHB(MATH2, XOR, IMM(393615378), MATH3, SIZE(4), 0);
	MATHB(MATH2, XOR, DPOVRD, MATH3, SIZE(4), WITH(STL));
	MATHB(MATH2, XOR, VSEQINSZ, MATH3, SIZE(4), 0);
	MATHB(MATH2, XOR, VSEQOUTSZ, MATH3, SIZE(8), 0);
	MATHB(MATH2, XOR, ABD, MATH3, SIZE(1), WITH(NFU));
	MATHB(MATH2, XOR, OFIFO, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, XOR, ONE, MATH3, SIZE(8), 0);
	MATHB(MATH2, XOR, ZERO, MATH3, SIZE(8), 0);
	MATHB(MATH3, XOR, MATH0, MATH3, SIZE(4), WITH(NFU));
	MATHB(MATH3, XOR, MATH1, MATH3, SIZE(1), 0);
	MATHB(MATH3, XOR, MATH2, MATH3, SIZE(8), WITH(NFU));
	MATHB(MATH3, XOR, MATH3, MATH3, SIZE(8), 0);
	MATHB(MATH3, XOR, IMM(393615378), MATH3, SIZE(4), 0);
	MATHB(MATH3, XOR, DPOVRD, MATH3, SIZE(2), WITH(NFU));
	MATHB(MATH3, XOR, VSEQINSZ, MATH3, SIZE(4), 0);
	MATHB(MATH3, XOR, VSEQOUTSZ, MATH3, SIZE(8), 0);
	MATHB(MATH3, XOR, ABD, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, XOR, OFIFO, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(MATH3, XOR, ONE, MATH3, SIZE(1), 0);
	MATHB(MATH3, XOR, ZERO, MATH3, SIZE(1), 0);
	MATHB(IMM(0x19261959fedcba01), XOR, MATH0, MATH3, SIZE(8), 0);
	MATHB(IMM(275128321), XOR, MATH1, MATH3, SIZE(1), 0);
	MATHB(IMM(0x19261959fedcba01), XOR, MATH2, MATH3, SIZE(8), 0);
	MATHB(IMM(275128321), XOR, MATH3, MATH3, SIZE(1), 0);
	MATHB(IMM(275128321), XOR, IMM(393615378), MATH3, SIZE(1), 0);
	MATHB(IMM(275128321), XOR, DPOVRD, MATH3, SIZE(4), 0);
	MATHB(IMM(275128321), XOR, VSEQINSZ, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(0x19261959fedcba01), XOR, VSEQOUTSZ, MATH3, SIZE(8),
	      WITH(NFU));
	MATHB(IMM(275128321), XOR, ABD, MATH3, SIZE(1), 0);
	MATHB(IMM(275128321), XOR, OFIFO, MATH3, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), XOR, ONE, MATH3, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), XOR, ZERO, MATH3, SIZE(8), WITH(IFB | STL));
	MATHB(DPOVRD, XOR, MATH0, MATH3, SIZE(4), 0);
	MATHB(DPOVRD, XOR, MATH1, MATH3, SIZE(1), WITH(STL));
	MATHB(DPOVRD, XOR, MATH2, MATH3, SIZE(1), 0);
	MATHB(DPOVRD, XOR, MATH3, MATH3, SIZE(8), 0);
	MATHB(DPOVRD, XOR, IMM(393615378), MATH3, SIZE(8),
	      WITH(IFB | NFU | STL));
	MATHB(DPOVRD, XOR, DPOVRD, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(DPOVRD, XOR, VSEQINSZ, MATH3, SIZE(4), 0);
	MATHB(DPOVRD, XOR, VSEQOUTSZ, MATH3, SIZE(1), 0);
	MATHB(DPOVRD, XOR, ABD, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, XOR, OFIFO, MATH3, SIZE(4), 0);
	MATHB(DPOVRD, XOR, ONE, MATH3, SIZE(1), 0);
	MATHB(DPOVRD, XOR, ZERO, MATH3, SIZE(1), 0);
	MATHB(SEQINSZ, XOR, MATH0, MATH3, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, XOR, MATH1, MATH3, SIZE(8), 0);
	MATHB(SEQINSZ, XOR, MATH2, MATH3, SIZE(2), 0);
	MATHB(SEQINSZ, XOR, MATH3, MATH3, SIZE(1), 0);
	MATHB(SEQINSZ, XOR, IMM(393615378), MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(SEQINSZ, XOR, DPOVRD, MATH3, SIZE(4), 0);
	MATHB(SEQINSZ, XOR, VSEQINSZ, MATH3, SIZE(2), 0);
	MATHB(SEQINSZ, XOR, VSEQOUTSZ, MATH3, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, XOR, ABD, MATH3, SIZE(2), 0);
	MATHB(SEQINSZ, XOR, OFIFO, MATH3, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, XOR, ONE, MATH3, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, XOR, ZERO, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(SEQOUTSZ, XOR, MATH0, MATH3, SIZE(8), 0);
	MATHB(SEQOUTSZ, XOR, MATH1, MATH3, SIZE(2), 0);
	MATHB(SEQOUTSZ, XOR, MATH2, MATH3, SIZE(2), 0);
	MATHB(SEQOUTSZ, XOR, MATH3, MATH3, SIZE(1), 0);
	MATHB(SEQOUTSZ, XOR, IMM(393615378), MATH3, SIZE(4), 0);
	MATHB(SEQOUTSZ, XOR, DPOVRD, MATH3, SIZE(2), 0);
	MATHB(SEQOUTSZ, XOR, VSEQINSZ, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, XOR, VSEQOUTSZ, MATH3, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, XOR, ABD, MATH3, SIZE(4), 0);
	MATHB(SEQOUTSZ, XOR, OFIFO, MATH3, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, XOR, ONE, MATH3, SIZE(8), 0);
	MATHB(SEQOUTSZ, XOR, ZERO, MATH3, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, XOR, MATH0, MATH3, SIZE(1), 0);
	MATHB(VSEQINSZ, XOR, MATH1, MATH3, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, XOR, MATH2, MATH3, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, XOR, MATH3, MATH3, SIZE(4), WITH(STL));
	MATHB(VSEQINSZ, XOR, IMM(393615378), MATH3, SIZE(2), 0);
	MATHB(VSEQINSZ, XOR, DPOVRD, MATH3, SIZE(2), 0);
	MATHB(VSEQINSZ, XOR, VSEQINSZ, MATH3, SIZE(1), 0);
	MATHB(VSEQINSZ, XOR, VSEQOUTSZ, MATH3, SIZE(4), 0);
	MATHB(VSEQINSZ, XOR, ABD, MATH3, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, XOR, OFIFO, MATH3, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, XOR, ONE, MATH3, SIZE(4), WITH(STL));
	MATHB(VSEQINSZ, XOR, ZERO, MATH3, SIZE(4), 0);
	MATHB(VSEQOUTSZ, XOR, MATH0, MATH3, SIZE(8), 0);
	MATHB(VSEQOUTSZ, XOR, MATH1, MATH3, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, XOR, MATH2, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, XOR, MATH3, MATH3, SIZE(4), 0);
	MATHB(VSEQOUTSZ, XOR, IMM(0x19261959fedcba01), MATH3, SIZE(8), 0);
	MATHB(VSEQOUTSZ, XOR, DPOVRD, MATH3, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, XOR, VSEQINSZ, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, XOR, VSEQOUTSZ, MATH3, SIZE(8), 0);
	MATHB(VSEQOUTSZ, XOR, ABD, MATH3, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, XOR, OFIFO, MATH3, SIZE(2), 0);
	MATHB(VSEQOUTSZ, XOR, ONE, MATH3, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, XOR, ZERO, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, XOR, MATH0, MATH3, SIZE(4), 0);
	MATHB(ZERO, XOR, MATH1, MATH3, SIZE(1), WITH(NFU));
	MATHB(ZERO, XOR, MATH2, MATH3, SIZE(1), 0);
	MATHB(ZERO, XOR, MATH3, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, XOR, IMM(393615378), MATH3, SIZE(8), WITH(IFB | STL));
	MATHB(ZERO, XOR, DPOVRD, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, XOR, VSEQINSZ, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, XOR, VSEQOUTSZ, MATH3, SIZE(1), 0);
	MATHB(ZERO, XOR, ABD, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, XOR, OFIFO, MATH3, SIZE(1), WITH(NFU));
	MATHB(ZERO, XOR, ONE, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, XOR, ZERO, MATH3, SIZE(4), WITH(STL));
	MATHB(ONE, XOR, MATH0, MATH3, SIZE(2), WITH(STL));
	MATHB(ONE, XOR, MATH1, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, XOR, MATH2, MATH3, SIZE(2), WITH(NFU));
	MATHB(ONE, XOR, MATH3, MATH3, SIZE(4), WITH(STL));
	MATHB(ONE, XOR, IMM(393615378), MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, XOR, DPOVRD, MATH3, SIZE(1), 0);
	MATHB(ONE, XOR, VSEQINSZ, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, XOR, VSEQOUTSZ, MATH3, SIZE(2), WITH(NFU));
	MATHB(ONE, XOR, ABD, MATH3, SIZE(8), WITH(NFU));
	MATHB(ONE, XOR, OFIFO, MATH3, SIZE(8), 0);
	MATHB(ONE, XOR, ONE, MATH3, SIZE(8), 0);
	MATHB(ONE, XOR, ZERO, MATH3, SIZE(1), WITH(NFU));
	/*XOR Operation: DPOVRD Destination register */
	MATHB(MATH0, XOR, MATH0, DPOVRD, SIZE(8), WITH(STL));
	MATHB(MATH0, XOR, MATH1, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(MATH0, XOR, MATH2, DPOVRD, SIZE(4), 0);
	MATHB(MATH0, XOR, MATH3, DPOVRD, SIZE(8), 0);
	MATHB(MATH0, XOR, IMM(393615378), DPOVRD, SIZE(1), WITH(NFU));
	MATHB(MATH0, XOR, DPOVRD, DPOVRD, SIZE(1), 0);
	MATHB(MATH0, XOR, VSEQINSZ, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, XOR, VSEQOUTSZ, DPOVRD, SIZE(4), WITH(STL));
	MATHB(MATH0, XOR, ABD, DPOVRD, SIZE(1), 0);
	MATHB(MATH0, XOR, OFIFO, DPOVRD, SIZE(8), 0);
	MATHB(MATH0, XOR, ONE, DPOVRD, SIZE(8), 0);
	MATHB(MATH0, XOR, ZERO, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(MATH1, XOR, MATH0, DPOVRD, SIZE(8), 0);
	MATHB(MATH1, XOR, MATH1, DPOVRD, SIZE(1), 0);
	MATHB(MATH1, XOR, MATH2, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(MATH1, XOR, MATH3, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(MATH1, XOR, IMM(393615378), DPOVRD, SIZE(4), 0);
	MATHB(MATH1, XOR, DPOVRD, DPOVRD, SIZE(1), 0);
	MATHB(MATH1, XOR, VSEQINSZ, DPOVRD, SIZE(4), 0);
	MATHB(MATH1, XOR, VSEQOUTSZ, DPOVRD, SIZE(2), 0);
	MATHB(MATH1, XOR, ABD, DPOVRD, SIZE(4), 0);
	MATHB(MATH1, XOR, OFIFO, DPOVRD, SIZE(8), WITH(STL));
	MATHB(MATH1, XOR, ONE, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(MATH1, XOR, ZERO, DPOVRD, SIZE(4), 0);
	MATHB(MATH2, XOR, MATH0, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(MATH2, XOR, MATH1, DPOVRD, SIZE(4), WITH(STL));
	MATHB(MATH2, XOR, MATH2, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(MATH2, XOR, MATH3, DPOVRD, SIZE(8), 0);
	MATHB(MATH2, XOR, IMM(393615378), DPOVRD, SIZE(2), 0);
	MATHB(MATH2, XOR, DPOVRD, DPOVRD, SIZE(8), 0);
	MATHB(MATH2, XOR, VSEQINSZ, DPOVRD, SIZE(2), 0);
	MATHB(MATH2, XOR, VSEQOUTSZ, DPOVRD, SIZE(2), 0);
	MATHB(MATH2, XOR, ABD, DPOVRD, SIZE(8), 0);
	MATHB(MATH2, XOR, OFIFO, DPOVRD, SIZE(2), WITH(STL));
	MATHB(MATH2, XOR, ONE, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, XOR, ZERO, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(MATH3, XOR, MATH0, DPOVRD, SIZE(1), 0);
	MATHB(MATH3, XOR, MATH1, DPOVRD, SIZE(4), WITH(STL));
	MATHB(MATH3, XOR, MATH2, DPOVRD, SIZE(8), 0);
	MATHB(MATH3, XOR, MATH3, DPOVRD, SIZE(1), 0);
	MATHB(MATH3, XOR, IMM(393615378), DPOVRD, SIZE(2), 0);
	MATHB(MATH3, XOR, DPOVRD, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(MATH3, XOR, VSEQINSZ, DPOVRD, SIZE(8), 0);
	MATHB(MATH3, XOR, VSEQOUTSZ, DPOVRD, SIZE(1), 0);
	MATHB(MATH3, XOR, ABD, DPOVRD, SIZE(2), 0);
	MATHB(MATH3, XOR, OFIFO, DPOVRD, SIZE(4), WITH(STL));
	MATHB(MATH3, XOR, ONE, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(MATH3, XOR, ZERO, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), XOR, MATH0, DPOVRD, SIZE(2), 0);
	MATHB(IMM(275128321), XOR, MATH1, DPOVRD, SIZE(2), WITH(STL));
	MATHB(IMM(275128321), XOR, MATH2, DPOVRD, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), XOR, MATH3, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(275128321), XOR, IMM(393615378), DPOVRD, SIZE(1),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), XOR, DPOVRD, DPOVRD, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), XOR, VSEQINSZ, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), XOR, VSEQOUTSZ, DPOVRD, SIZE(2), WITH(STL));
	MATHB(IMM(0x19261959fedcba01), XOR, ABD, DPOVRD, SIZE(8), 0);
	MATHB(IMM(0x19261959fedcba01), XOR, OFIFO, DPOVRD, SIZE(8), WITH(STL));
	MATHB(IMM(275128321), XOR, ONE, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(275128321), XOR, ZERO, DPOVRD, SIZE(1), 0);
	MATHB(DPOVRD, XOR, MATH0, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(DPOVRD, XOR, MATH1, DPOVRD, SIZE(4), 0);
	MATHB(DPOVRD, XOR, MATH2, DPOVRD, SIZE(8), 0);
	MATHB(DPOVRD, XOR, MATH3, DPOVRD, SIZE(1), WITH(STL));
	MATHB(DPOVRD, XOR, IMM(393615378), DPOVRD, SIZE(1), 0);
	MATHB(DPOVRD, XOR, DPOVRD, DPOVRD, SIZE(1), 0);
	MATHB(DPOVRD, XOR, VSEQINSZ, DPOVRD, SIZE(1), 0);
	MATHB(DPOVRD, XOR, VSEQOUTSZ, DPOVRD, SIZE(1), 0);
	MATHB(DPOVRD, XOR, ABD, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(DPOVRD, XOR, OFIFO, DPOVRD, SIZE(1), WITH(STL));
	MATHB(DPOVRD, XOR, ONE, DPOVRD, SIZE(1), 0);
	MATHB(DPOVRD, XOR, ZERO, DPOVRD, SIZE(2), 0);
	MATHB(SEQINSZ, XOR, MATH0, DPOVRD, SIZE(1), 0);
	MATHB(SEQINSZ, XOR, MATH1, DPOVRD, SIZE(2), 0);
	MATHB(SEQINSZ, XOR, MATH2, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, XOR, MATH3, DPOVRD, SIZE(8), 0);
	MATHB(SEQINSZ, XOR, IMM(393615378), DPOVRD, SIZE(8), WITH(IFB));
	MATHB(SEQINSZ, XOR, DPOVRD, DPOVRD, SIZE(4), 0);
	MATHB(SEQINSZ, XOR, VSEQINSZ, DPOVRD, SIZE(8), 0);
	MATHB(SEQINSZ, XOR, VSEQOUTSZ, DPOVRD, SIZE(2), 0);
	MATHB(SEQINSZ, XOR, ABD, DPOVRD, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, XOR, OFIFO, DPOVRD, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, XOR, ONE, DPOVRD, SIZE(2), 0);
	MATHB(SEQINSZ, XOR, ZERO, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, XOR, MATH0, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, XOR, MATH1, DPOVRD, SIZE(2), 0);
	MATHB(SEQOUTSZ, XOR, MATH2, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, XOR, MATH3, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, XOR, IMM(393615378), DPOVRD, SIZE(4), 0);
	MATHB(SEQOUTSZ, XOR, DPOVRD, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, XOR, VSEQINSZ, DPOVRD, SIZE(2), 0);
	MATHB(SEQOUTSZ, XOR, VSEQOUTSZ, DPOVRD, SIZE(1), 0);
	MATHB(SEQOUTSZ, XOR, ABD, DPOVRD, SIZE(8), 0);
	MATHB(SEQOUTSZ, XOR, OFIFO, DPOVRD, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, XOR, ONE, DPOVRD, SIZE(1), 0);
	MATHB(SEQOUTSZ, XOR, ZERO, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, XOR, MATH0, DPOVRD, SIZE(4), WITH(STL));
	MATHB(VSEQINSZ, XOR, MATH1, DPOVRD, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, XOR, MATH2, DPOVRD, SIZE(4), WITH(STL));
	MATHB(VSEQINSZ, XOR, MATH3, DPOVRD, SIZE(4), 0);
	MATHB(VSEQINSZ, XOR, IMM(393615378), DPOVRD, SIZE(1), 0);
	MATHB(VSEQINSZ, XOR, DPOVRD, DPOVRD, SIZE(2), 0);
	MATHB(VSEQINSZ, XOR, VSEQINSZ, DPOVRD, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, XOR, VSEQOUTSZ, DPOVRD, SIZE(1), 0);
	MATHB(VSEQINSZ, XOR, ABD, DPOVRD, SIZE(4), 0);
	MATHB(VSEQINSZ, XOR, OFIFO, DPOVRD, SIZE(1), 0);
	MATHB(VSEQINSZ, XOR, ONE, DPOVRD, SIZE(1), 0);
	MATHB(VSEQINSZ, XOR, ZERO, DPOVRD, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, XOR, MATH0, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, XOR, MATH1, DPOVRD, SIZE(8), 0);
	MATHB(VSEQOUTSZ, XOR, MATH2, DPOVRD, SIZE(2), 0);
	MATHB(VSEQOUTSZ, XOR, MATH3, DPOVRD, SIZE(1), 0);
	MATHB(VSEQOUTSZ, XOR, IMM(393615378), DPOVRD, SIZE(8), WITH(IFB));
	MATHB(VSEQOUTSZ, XOR, DPOVRD, DPOVRD, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, XOR, VSEQINSZ, DPOVRD, SIZE(1), 0);
	MATHB(VSEQOUTSZ, XOR, VSEQOUTSZ, DPOVRD, SIZE(1), 0);
	MATHB(VSEQOUTSZ, XOR, ABD, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, XOR, OFIFO, DPOVRD, SIZE(2), 0);
	MATHB(VSEQOUTSZ, XOR, ONE, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, XOR, ZERO, DPOVRD, SIZE(2), WITH(STL));
	MATHB(ZERO, XOR, MATH0, DPOVRD, SIZE(4), 0);
	MATHB(ZERO, XOR, MATH1, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(ZERO, XOR, MATH2, DPOVRD, SIZE(8), 0);
	MATHB(ZERO, XOR, MATH3, DPOVRD, SIZE(4), 0);
	MATHB(ZERO, XOR, IMM(393615378), DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, XOR, DPOVRD, DPOVRD, SIZE(8), 0);
	MATHB(ZERO, XOR, VSEQINSZ, DPOVRD, SIZE(1), 0);
	MATHB(ZERO, XOR, VSEQOUTSZ, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(ZERO, XOR, ABD, DPOVRD, SIZE(4), 0);
	MATHB(ZERO, XOR, OFIFO, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(ZERO, XOR, ONE, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, XOR, ZERO, DPOVRD, SIZE(2), 0);
	MATHB(ONE, XOR, MATH0, DPOVRD, SIZE(1), 0);
	MATHB(ONE, XOR, MATH1, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(ONE, XOR, MATH2, DPOVRD, SIZE(1), 0);
	MATHB(ONE, XOR, MATH3, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, XOR, IMM(393615378), DPOVRD, SIZE(2), WITH(NFU));
	MATHB(ONE, XOR, DPOVRD, DPOVRD, SIZE(1), 0);
	MATHB(ONE, XOR, VSEQINSZ, DPOVRD, SIZE(2), 0);
	MATHB(ONE, XOR, VSEQOUTSZ, DPOVRD, SIZE(1), 0);
	MATHB(ONE, XOR, ABD, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(ONE, XOR, OFIFO, DPOVRD, SIZE(1), 0);
	MATHB(ONE, XOR, ONE, DPOVRD, SIZE(1), 0);
	MATHB(ONE, XOR, ZERO, DPOVRD, SIZE(2), 0);
	/*XOR Operation: SEQINSZ Destination register */
	MATHB(MATH0, XOR, MATH0, SEQINSZ, SIZE(4), 0);
	MATHB(MATH0, XOR, MATH1, SEQINSZ, SIZE(4), 0);
	MATHB(MATH0, XOR, MATH2, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH0, XOR, MATH3, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH0, XOR, IMM(393615378), SEQINSZ, SIZE(2), 0);
	MATHB(MATH0, XOR, DPOVRD, SEQINSZ, SIZE(8), 0);
	MATHB(MATH0, XOR, VSEQINSZ, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, XOR, VSEQOUTSZ, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH0, XOR, ABD, SEQINSZ, SIZE(2), 0);
	MATHB(MATH0, XOR, OFIFO, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH0, XOR, ONE, SEQINSZ, SIZE(4), 0);
	MATHB(MATH0, XOR, ZERO, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, XOR, MATH0, SEQINSZ, SIZE(8), 0);
	MATHB(MATH1, XOR, MATH1, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH1, XOR, MATH2, SEQINSZ, SIZE(1), 0);
	MATHB(MATH1, XOR, MATH3, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(MATH1, XOR, IMM(393615378), SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, XOR, DPOVRD, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, XOR, VSEQINSZ, SEQINSZ, SIZE(2), 0);
	MATHB(MATH1, XOR, VSEQOUTSZ, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH1, XOR, ABD, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, XOR, OFIFO, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH1, XOR, ONE, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(MATH1, XOR, ZERO, SEQINSZ, SIZE(1), 0);
	MATHB(MATH2, XOR, MATH0, SEQINSZ, SIZE(1), 0);
	MATHB(MATH2, XOR, MATH1, SEQINSZ, SIZE(8), 0);
	MATHB(MATH2, XOR, MATH2, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH2, XOR, MATH3, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(MATH2, XOR, IMM(393615378), SEQINSZ, SIZE(4), 0);
	MATHB(MATH2, XOR, DPOVRD, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, XOR, VSEQINSZ, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(MATH2, XOR, VSEQOUTSZ, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, XOR, ABD, SEQINSZ, SIZE(2), 0);
	MATHB(MATH2, XOR, OFIFO, SEQINSZ, SIZE(8), 0);
	MATHB(MATH2, XOR, ONE, SEQINSZ, SIZE(4), 0);
	MATHB(MATH2, XOR, ZERO, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, XOR, MATH0, SEQINSZ, SIZE(8), 0);
	MATHB(MATH3, XOR, MATH1, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH3, XOR, MATH2, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(MATH3, XOR, MATH3, SEQINSZ, SIZE(2), 0);
	MATHB(MATH3, XOR, IMM(393615378), SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, XOR, DPOVRD, SEQINSZ, SIZE(2), 0);
	MATHB(MATH3, XOR, VSEQINSZ, SEQINSZ, SIZE(8), 0);
	MATHB(MATH3, XOR, VSEQOUTSZ, SEQINSZ, SIZE(1), 0);
	MATHB(MATH3, XOR, ABD, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(MATH3, XOR, OFIFO, SEQINSZ, SIZE(2), 0);
	MATHB(MATH3, XOR, ONE, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH3, XOR, ZERO, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), XOR, MATH0, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(IMM(275128321), XOR, MATH1, SEQINSZ, SIZE(4), 0);
	MATHB(IMM(275128321), XOR, MATH2, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(275128321), XOR, MATH3, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(275128321), XOR, IMM(393615378), SEQINSZ, SIZE(1),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), XOR, DPOVRD, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(275128321), XOR, VSEQINSZ, SEQINSZ, SIZE(4), 0);
	MATHB(IMM(275128321), XOR, VSEQOUTSZ, SEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), XOR, ABD, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), XOR, OFIFO, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(275128321), XOR, ONE, SEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), XOR, ZERO, SEQINSZ, SIZE(1), 0);
	MATHB(DPOVRD, XOR, MATH0, SEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, XOR, MATH1, SEQINSZ, SIZE(4), 0);
	MATHB(DPOVRD, XOR, MATH2, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, XOR, MATH3, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(DPOVRD, XOR, IMM(393615378), SEQINSZ, SIZE(2), WITH(STL));
	MATHB(DPOVRD, XOR, DPOVRD, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, XOR, VSEQINSZ, SEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, XOR, VSEQOUTSZ, SEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, XOR, ABD, SEQINSZ, SIZE(4), 0);
	MATHB(DPOVRD, XOR, OFIFO, SEQINSZ, SIZE(1), 0);
	MATHB(DPOVRD, XOR, ONE, SEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, XOR, ZERO, SEQINSZ, SIZE(8), 0);
	MATHB(SEQINSZ, XOR, MATH0, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, XOR, MATH1, SEQINSZ, SIZE(8), 0);
	MATHB(SEQINSZ, XOR, MATH2, SEQINSZ, SIZE(8), 0);
	MATHB(SEQINSZ, XOR, MATH3, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, XOR, IMM(393615378), SEQINSZ, SIZE(4), 0);
	MATHB(SEQINSZ, XOR, DPOVRD, SEQINSZ, SIZE(1), 0);
	MATHB(SEQINSZ, XOR, VSEQINSZ, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, XOR, VSEQOUTSZ, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, XOR, ABD, SEQINSZ, SIZE(4), 0);
	MATHB(SEQINSZ, XOR, OFIFO, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, XOR, ONE, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, XOR, ZERO, SEQINSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, XOR, MATH0, SEQINSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, XOR, MATH1, SEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, XOR, MATH2, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, XOR, MATH3, SEQINSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, XOR, IMM(393615378), SEQINSZ, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, XOR, DPOVRD, SEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, XOR, VSEQINSZ, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, XOR, VSEQOUTSZ, SEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, XOR, ABD, SEQINSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, XOR, OFIFO, SEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, XOR, ONE, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, XOR, ZERO, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, XOR, MATH0, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, XOR, MATH1, SEQINSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, XOR, MATH2, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, XOR, MATH3, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, XOR, IMM(393615378), SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, XOR, DPOVRD, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, XOR, VSEQINSZ, SEQINSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, XOR, VSEQOUTSZ, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, XOR, ABD, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, XOR, OFIFO, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, XOR, ONE, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, XOR, ZERO, SEQINSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, XOR, MATH0, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, XOR, MATH1, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, XOR, MATH2, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, XOR, MATH3, SEQINSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, XOR, IMM(393615378), SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, XOR, DPOVRD, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, XOR, VSEQINSZ, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, XOR, VSEQOUTSZ, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, XOR, ABD, SEQINSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, XOR, OFIFO, SEQINSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, XOR, ONE, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, XOR, ZERO, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(ZERO, XOR, MATH0, SEQINSZ, SIZE(2), 0);
	MATHB(ZERO, XOR, MATH1, SEQINSZ, SIZE(4), 0);
	MATHB(ZERO, XOR, MATH2, SEQINSZ, SIZE(1), 0);
	MATHB(ZERO, XOR, MATH3, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(ZERO, XOR, IMM(393615378), SEQINSZ, SIZE(1), 0);
	MATHB(ZERO, XOR, DPOVRD, SEQINSZ, SIZE(2), 0);
	MATHB(ZERO, XOR, VSEQINSZ, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, XOR, VSEQOUTSZ, SEQINSZ, SIZE(2), 0);
	MATHB(ZERO, XOR, ABD, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(ZERO, XOR, OFIFO, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, XOR, ONE, SEQINSZ, SIZE(1), 0);
	MATHB(ZERO, XOR, ZERO, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(ONE, XOR, MATH0, SEQINSZ, SIZE(1), 0);
	MATHB(ONE, XOR, MATH1, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(ONE, XOR, MATH2, SEQINSZ, SIZE(2), 0);
	MATHB(ONE, XOR, MATH3, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(ONE, XOR, IMM(393615378), SEQINSZ, SIZE(8), WITH(IFB | STL));
	MATHB(ONE, XOR, DPOVRD, SEQINSZ, SIZE(1), 0);
	MATHB(ONE, XOR, VSEQINSZ, SEQINSZ, SIZE(4), 0);
	MATHB(ONE, XOR, VSEQOUTSZ, SEQINSZ, SIZE(8), 0);
	MATHB(ONE, XOR, ABD, SEQINSZ, SIZE(1), 0);
	MATHB(ONE, XOR, OFIFO, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, XOR, ONE, SEQINSZ, SIZE(8), 0);
	MATHB(ONE, XOR, ZERO, SEQINSZ, SIZE(8), WITH(NFU));
	/*XOR Operation: SEQOUTSZ Destination register */
	MATHB(MATH0, XOR, MATH0, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH0, XOR, MATH1, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH0, XOR, MATH2, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH0, XOR, MATH3, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, XOR, IMM(393615378), SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, XOR, DPOVRD, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH0, XOR, VSEQINSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH0, XOR, VSEQOUTSZ, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH0, XOR, ABD, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH0, XOR, OFIFO, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, XOR, ONE, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, XOR, ZERO, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH1, XOR, MATH0, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH1, XOR, MATH1, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH1, XOR, MATH2, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, XOR, MATH3, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH1, XOR, IMM(393615378), SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, XOR, DPOVRD, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH1, XOR, VSEQINSZ, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(MATH1, XOR, VSEQOUTSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH1, XOR, ABD, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(MATH1, XOR, OFIFO, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(MATH1, XOR, ONE, SEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(MATH1, XOR, ZERO, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH2, XOR, MATH0, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, XOR, MATH1, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(MATH2, XOR, MATH2, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, XOR, MATH3, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, XOR, IMM(393615378), SEQOUTSZ, SIZE(8), WITH(IFB));
	MATHB(MATH2, XOR, DPOVRD, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, XOR, VSEQINSZ, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH2, XOR, VSEQOUTSZ, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, XOR, ABD, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH2, XOR, OFIFO, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, XOR, ONE, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, XOR, ZERO, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH3, XOR, MATH0, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, XOR, MATH1, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH3, XOR, MATH2, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH3, XOR, MATH3, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(MATH3, XOR, IMM(393615378), SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, XOR, DPOVRD, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH3, XOR, VSEQINSZ, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH3, XOR, VSEQOUTSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH3, XOR, ABD, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH3, XOR, OFIFO, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH3, XOR, ONE, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH3, XOR, ZERO, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(275128321), XOR, MATH0, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), XOR, MATH1, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(IMM(275128321), XOR, MATH2, SEQOUTSZ, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), XOR, MATH3, SEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), XOR, IMM(393615378), SEQOUTSZ, SIZE(1), 0);
	MATHB(IMM(275128321), XOR, DPOVRD, SEQOUTSZ, SIZE(1), 0);
	MATHB(IMM(275128321), XOR, VSEQINSZ, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(IMM(275128321), XOR, VSEQOUTSZ, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), XOR, ABD, SEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(275128321), XOR, OFIFO, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(IMM(275128321), XOR, ONE, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(IMM(275128321), XOR, ZERO, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(DPOVRD, XOR, MATH0, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, XOR, MATH1, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, XOR, MATH2, SEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, XOR, MATH3, SEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, XOR, IMM(393615378), SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, XOR, DPOVRD, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, XOR, VSEQINSZ, SEQOUTSZ, SIZE(4), 0);
	MATHB(DPOVRD, XOR, VSEQOUTSZ, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(DPOVRD, XOR, ABD, SEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, XOR, OFIFO, SEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, XOR, ONE, SEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, XOR, ZERO, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, XOR, MATH0, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, XOR, MATH1, SEQOUTSZ, SIZE(4), 0);
	MATHB(SEQINSZ, XOR, MATH2, SEQOUTSZ, SIZE(8), 0);
	MATHB(SEQINSZ, XOR, MATH3, SEQOUTSZ, SIZE(8), 0);
	MATHB(SEQINSZ, XOR, IMM(393615378), SEQOUTSZ, SIZE(4), 0);
	MATHB(SEQINSZ, XOR, DPOVRD, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, XOR, VSEQINSZ, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, XOR, VSEQOUTSZ, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(SEQINSZ, XOR, ABD, SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, XOR, OFIFO, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, XOR, ONE, SEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, XOR, ZERO, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, XOR, MATH0, SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, XOR, MATH1, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, XOR, MATH2, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, XOR, MATH3, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, XOR, IMM(393615378), SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, XOR, DPOVRD, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, XOR, VSEQINSZ, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, XOR, VSEQOUTSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, XOR, ABD, SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, XOR, OFIFO, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, XOR, ONE, SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, XOR, ZERO, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, XOR, MATH0, SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, XOR, MATH1, SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, XOR, MATH2, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, XOR, MATH3, SEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, XOR, IMM(393615378), SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, XOR, DPOVRD, SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, XOR, VSEQINSZ, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, XOR, VSEQOUTSZ, SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, XOR, ABD, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQINSZ, XOR, OFIFO, SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, XOR, ONE, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, XOR, ZERO, SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, XOR, MATH0, SEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, XOR, MATH1, SEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, XOR, MATH2, SEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, XOR, MATH3, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, XOR, IMM(393615378), SEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, XOR, DPOVRD, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, XOR, VSEQINSZ, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, XOR, VSEQOUTSZ, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, XOR, ABD, SEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, XOR, OFIFO, SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, XOR, ONE, SEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, XOR, ZERO, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(ZERO, XOR, MATH0, SEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, XOR, MATH1, SEQOUTSZ, SIZE(8), 0);
	MATHB(ZERO, XOR, MATH2, SEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, XOR, MATH3, SEQOUTSZ, SIZE(8), 0);
	MATHB(ZERO, XOR, IMM(393615378), SEQOUTSZ, SIZE(8), WITH(IFB));
	MATHB(ZERO, XOR, DPOVRD, SEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, XOR, VSEQINSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, XOR, VSEQOUTSZ, SEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, XOR, ABD, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(ZERO, XOR, OFIFO, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(ZERO, XOR, ONE, SEQOUTSZ, SIZE(8), 0);
	MATHB(ZERO, XOR, ZERO, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(ONE, XOR, MATH0, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(ONE, XOR, MATH1, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(ONE, XOR, MATH2, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(ONE, XOR, MATH3, SEQOUTSZ, SIZE(2), 0);
	MATHB(ONE, XOR, IMM(393615378), SEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, XOR, DPOVRD, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(ONE, XOR, VSEQINSZ, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, XOR, VSEQOUTSZ, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(ONE, XOR, ABD, SEQOUTSZ, SIZE(8), 0);
	MATHB(ONE, XOR, OFIFO, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, XOR, ONE, SEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, XOR, ZERO, SEQOUTSZ, SIZE(1), 0);
	/*XOR Operation: VSEQINSZ Destination register */
	MATHB(MATH0, XOR, MATH0, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH0, XOR, MATH1, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH0, XOR, MATH2, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH0, XOR, MATH3, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, XOR, IMM(393615378), VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH0, XOR, DPOVRD, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(MATH0, XOR, VSEQINSZ, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH0, XOR, VSEQOUTSZ, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH0, XOR, ABD, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH0, XOR, OFIFO, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, XOR, ONE, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(MATH0, XOR, ZERO, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH1, XOR, MATH0, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH1, XOR, MATH1, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH1, XOR, MATH2, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH1, XOR, MATH3, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH1, XOR, IMM(393615378), VSEQINSZ, SIZE(2), 0);
	MATHB(MATH1, XOR, DPOVRD, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH1, XOR, VSEQINSZ, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH1, XOR, VSEQOUTSZ, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(MATH1, XOR, ABD, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH1, XOR, OFIFO, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH1, XOR, ONE, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(MATH1, XOR, ZERO, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(MATH2, XOR, MATH0, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH2, XOR, MATH1, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH2, XOR, MATH2, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH2, XOR, MATH3, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, XOR, IMM(393615378), VSEQINSZ, SIZE(4), 0);
	MATHB(MATH2, XOR, DPOVRD, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH2, XOR, VSEQINSZ, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH2, XOR, VSEQOUTSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH2, XOR, ABD, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, XOR, OFIFO, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH2, XOR, ONE, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH2, XOR, ZERO, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, XOR, MATH0, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH3, XOR, MATH1, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH3, XOR, MATH2, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH3, XOR, MATH3, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH3, XOR, IMM(393615378), VSEQINSZ, SIZE(1), 0);
	MATHB(MATH3, XOR, DPOVRD, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, XOR, VSEQINSZ, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH3, XOR, VSEQOUTSZ, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, XOR, ABD, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH3, XOR, OFIFO, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(MATH3, XOR, ONE, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH3, XOR, ZERO, VSEQINSZ, SIZE(4), 0);
	MATHB(IMM(275128321), XOR, MATH0, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(275128321), XOR, MATH1, VSEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), XOR, MATH2, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), XOR, MATH3, VSEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), XOR, IMM(393615378), VSEQINSZ, SIZE(4), 0);
	MATHB(IMM(275128321), XOR, DPOVRD, VSEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), XOR, VSEQINSZ, VSEQINSZ, SIZE(8),
	      WITH(IFB | NFU));
	MATHB(IMM(275128321), XOR, VSEQOUTSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), XOR, ABD, VSEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), XOR, OFIFO, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), XOR, ONE, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(IMM(275128321), XOR, ZERO, VSEQINSZ, SIZE(1), 0);
	MATHB(DPOVRD, XOR, MATH0, VSEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, XOR, MATH1, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(DPOVRD, XOR, MATH2, VSEQINSZ, SIZE(1), 0);
	MATHB(DPOVRD, XOR, MATH3, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(DPOVRD, XOR, IMM(393615378), VSEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, XOR, DPOVRD, VSEQINSZ, SIZE(1), 0);
	MATHB(DPOVRD, XOR, VSEQINSZ, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, XOR, VSEQOUTSZ, VSEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, XOR, ABD, VSEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, XOR, OFIFO, VSEQINSZ, SIZE(4), 0);
	MATHB(DPOVRD, XOR, ONE, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(DPOVRD, XOR, ZERO, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQINSZ, XOR, MATH0, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, XOR, MATH1, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, XOR, MATH2, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, XOR, MATH3, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, XOR, IMM(393615378), VSEQINSZ, SIZE(1), 0);
	MATHB(SEQINSZ, XOR, DPOVRD, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, XOR, VSEQINSZ, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, XOR, VSEQOUTSZ, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, XOR, ABD, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, XOR, OFIFO, VSEQINSZ, SIZE(1), 0);
	MATHB(SEQINSZ, XOR, ONE, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, XOR, ZERO, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, XOR, MATH0, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, XOR, MATH1, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, XOR, MATH2, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, XOR, MATH3, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(SEQOUTSZ, XOR, IMM(0x19261959fedcba01), VSEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, XOR, DPOVRD, VSEQINSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, XOR, VSEQINSZ, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, XOR, VSEQOUTSZ, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, XOR, ABD, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, XOR, OFIFO, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, XOR, ONE, VSEQINSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, XOR, ZERO, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, XOR, MATH0, VSEQINSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, XOR, MATH1, VSEQINSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, XOR, MATH2, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, XOR, MATH3, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, XOR, IMM(393615378), VSEQINSZ, SIZE(8),
	      WITH(IFB | NFU | STL));
	MATHB(VSEQINSZ, XOR, DPOVRD, VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, XOR, VSEQINSZ, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, XOR, VSEQOUTSZ, VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, XOR, ABD, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, XOR, OFIFO, VSEQINSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, XOR, ONE, VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, XOR, ZERO, VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, XOR, MATH0, VSEQINSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, XOR, MATH1, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, XOR, MATH2, VSEQINSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, XOR, MATH3, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, XOR, IMM(393615378), VSEQINSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, XOR, DPOVRD, VSEQINSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, XOR, VSEQINSZ, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, XOR, VSEQOUTSZ, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, XOR, ABD, VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, XOR, OFIFO, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, XOR, ONE, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, XOR, ZERO, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(ZERO, XOR, MATH0, VSEQINSZ, SIZE(1), 0);
	MATHB(ZERO, XOR, MATH1, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, XOR, MATH2, VSEQINSZ, SIZE(2), 0);
	MATHB(ZERO, XOR, MATH3, VSEQINSZ, SIZE(8), 0);
	MATHB(ZERO, XOR, IMM(393615378), VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(ZERO, XOR, DPOVRD, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(ZERO, XOR, VSEQINSZ, VSEQINSZ, SIZE(2), 0);
	MATHB(ZERO, XOR, VSEQOUTSZ, VSEQINSZ, SIZE(4), 0);
	MATHB(ZERO, XOR, ABD, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, XOR, OFIFO, VSEQINSZ, SIZE(8), 0);
	MATHB(ZERO, XOR, ONE, VSEQINSZ, SIZE(8), 0);
	MATHB(ZERO, XOR, ZERO, VSEQINSZ, SIZE(4), 0);
	MATHB(ONE, XOR, MATH0, VSEQINSZ, SIZE(4), 0);
	MATHB(ONE, XOR, MATH1, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(ONE, XOR, MATH2, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(ONE, XOR, MATH3, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(ONE, XOR, IMM(0x19261959fedcba01), VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(ONE, XOR, DPOVRD, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(ONE, XOR, VSEQINSZ, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, XOR, VSEQOUTSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(ONE, XOR, ABD, VSEQINSZ, SIZE(1), 0);
	MATHB(ONE, XOR, OFIFO, VSEQINSZ, SIZE(4), 0);
	MATHB(ONE, XOR, ONE, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(ONE, XOR, ZERO, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	/*XOR Operation: VSEQOUTSZ Destination register */
	MATHB(MATH0, XOR, MATH0, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH0, XOR, MATH1, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH0, XOR, MATH2, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH0, XOR, MATH3, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, XOR, IMM(393615378), VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH0, XOR, DPOVRD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH0, XOR, VSEQINSZ, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, XOR, VSEQOUTSZ, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH0, XOR, ABD, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(MATH0, XOR, OFIFO, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH0, XOR, ONE, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH0, XOR, ZERO, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(MATH1, XOR, MATH0, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH1, XOR, MATH1, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH1, XOR, MATH2, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH1, XOR, MATH3, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH1, XOR, IMM(393615378), VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, XOR, DPOVRD, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH1, XOR, VSEQINSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH1, XOR, VSEQOUTSZ, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, XOR, ABD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, XOR, OFIFO, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH1, XOR, ONE, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, XOR, ZERO, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH2, XOR, MATH0, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, XOR, MATH1, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, XOR, MATH2, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(MATH2, XOR, MATH3, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH2, XOR, IMM(0x19261959fedcba01), VSEQOUTSZ, SIZE(8),
	      WITH(STL));
	MATHB(MATH2, XOR, DPOVRD, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, XOR, VSEQINSZ, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(MATH2, XOR, VSEQOUTSZ, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, XOR, ABD, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH2, XOR, OFIFO, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH2, XOR, ONE, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH2, XOR, ZERO, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, XOR, MATH0, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH3, XOR, MATH1, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, XOR, MATH2, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH3, XOR, MATH3, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH3, XOR, IMM(393615378), VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH3, XOR, DPOVRD, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(MATH3, XOR, VSEQINSZ, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH3, XOR, VSEQOUTSZ, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, XOR, ABD, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH3, XOR, OFIFO, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(MATH3, XOR, ONE, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH3, XOR, ZERO, VSEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), XOR, MATH0, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), XOR, MATH1, VSEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(275128321), XOR, MATH2, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), XOR, MATH3, VSEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), XOR, IMM(393615378), VSEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(275128321), XOR, DPOVRD, VSEQOUTSZ, SIZE(8), WITH(IFB | NFU));
	MATHB(IMM(275128321), XOR, VSEQINSZ, VSEQOUTSZ, SIZE(2),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), XOR, VSEQOUTSZ, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(IMM(275128321), XOR, ABD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), XOR, OFIFO, VSEQOUTSZ, SIZE(1), 0);
	MATHB(IMM(275128321), XOR, ONE, VSEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), XOR, ZERO, VSEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, XOR, MATH0, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, XOR, MATH1, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, XOR, MATH2, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(DPOVRD, XOR, MATH3, VSEQOUTSZ, SIZE(4), 0);
	MATHB(DPOVRD, XOR, IMM(393615378), VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(DPOVRD, XOR, DPOVRD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, XOR, VSEQINSZ, VSEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, XOR, VSEQOUTSZ, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(DPOVRD, XOR, ABD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(DPOVRD, XOR, OFIFO, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(DPOVRD, XOR, ONE, VSEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, XOR, ZERO, VSEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(SEQINSZ, XOR, MATH0, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, XOR, MATH1, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, XOR, MATH2, VSEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, XOR, MATH3, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQINSZ, XOR, IMM(393615378), VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQINSZ, XOR, DPOVRD, VSEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, XOR, VSEQINSZ, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, XOR, VSEQOUTSZ, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, XOR, ABD, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, XOR, OFIFO, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQINSZ, XOR, ONE, VSEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, XOR, ZERO, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, XOR, MATH0, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, XOR, MATH1, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, XOR, MATH2, VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, XOR, MATH3, VSEQOUTSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, XOR, IMM(393615378), VSEQOUTSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, XOR, DPOVRD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, XOR, VSEQINSZ, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, XOR, VSEQOUTSZ, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, XOR, ABD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, XOR, OFIFO, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQOUTSZ, XOR, ONE, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, XOR, ZERO, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, XOR, MATH0, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, XOR, MATH1, VSEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, XOR, MATH2, VSEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, XOR, MATH3, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(VSEQINSZ, XOR, IMM(393615378), VSEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, XOR, DPOVRD, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, XOR, VSEQINSZ, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(VSEQINSZ, XOR, VSEQOUTSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, XOR, ABD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, XOR, OFIFO, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, XOR, ONE, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, XOR, ZERO, VSEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, XOR, MATH0, VSEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, XOR, MATH1, VSEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, XOR, MATH2, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, XOR, MATH3, VSEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, XOR, IMM(0x19261959fedcba01), VSEQOUTSZ, SIZE(8),
	      WITH(STL));
	MATHB(VSEQOUTSZ, XOR, DPOVRD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, XOR, VSEQINSZ, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, XOR, VSEQOUTSZ, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, XOR, ABD, VSEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, XOR, OFIFO, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, XOR, ONE, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, XOR, ZERO, VSEQOUTSZ, SIZE(4), 0);
	MATHB(ZERO, XOR, MATH0, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, XOR, MATH1, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, XOR, MATH2, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(ZERO, XOR, MATH3, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(ZERO, XOR, IMM(393615378), VSEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, XOR, DPOVRD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, XOR, VSEQINSZ, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(ZERO, XOR, VSEQOUTSZ, VSEQOUTSZ, SIZE(8), 0);
	MATHB(ZERO, XOR, ABD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, XOR, OFIFO, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, XOR, ONE, VSEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, XOR, ZERO, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(ONE, XOR, MATH0, VSEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, XOR, MATH1, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, XOR, MATH2, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(ONE, XOR, MATH3, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, XOR, IMM(0x19261959fedcba01), VSEQOUTSZ, SIZE(8), 0);
	MATHB(ONE, XOR, DPOVRD, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, XOR, VSEQINSZ, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(ONE, XOR, VSEQOUTSZ, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(ONE, XOR, ABD, VSEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, XOR, OFIFO, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, XOR, ONE, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(ONE, XOR, ZERO, VSEQOUTSZ, SIZE(1), 0);
	/*XOR Operation: NONE Destination register */
	MATHB(MATH0, XOR, MATH0, NONE, SIZE(8), WITH(NFU));
	MATHB(MATH0, XOR, MATH1, NONE, SIZE(8), 0);
	MATHB(MATH0, XOR, MATH2, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, XOR, MATH3, NONE, SIZE(2), 0);
	MATHB(MATH0, XOR, IMM(393615378), NONE, SIZE(1), 0);
	MATHB(MATH0, XOR, DPOVRD, NONE, SIZE(2), 0);
	MATHB(MATH0, XOR, VSEQINSZ, NONE, SIZE(4), 0);
	MATHB(MATH0, XOR, VSEQOUTSZ, NONE, SIZE(4), 0);
	MATHB(MATH0, XOR, ABD, NONE, SIZE(2), 0);
	MATHB(MATH0, XOR, OFIFO, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, XOR, ONE, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, XOR, ZERO, NONE, SIZE(4), 0);
	MATHB(MATH1, XOR, MATH0, NONE, SIZE(8), 0);
	MATHB(MATH1, XOR, MATH1, NONE, SIZE(1), WITH(NFU));
	MATHB(MATH1, XOR, MATH2, NONE, SIZE(2), 0);
	MATHB(MATH1, XOR, MATH3, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, XOR, IMM(393615378), NONE, SIZE(1), WITH(NFU));
	MATHB(MATH1, XOR, DPOVRD, NONE, SIZE(8), 0);
	MATHB(MATH1, XOR, VSEQINSZ, NONE, SIZE(8), 0);
	MATHB(MATH1, XOR, VSEQOUTSZ, NONE, SIZE(4), WITH(NFU));
	MATHB(MATH1, XOR, ABD, NONE, SIZE(1), 0);
	MATHB(MATH1, XOR, OFIFO, NONE, SIZE(8), 0);
	MATHB(MATH1, XOR, ONE, NONE, SIZE(2), 0);
	MATHB(MATH1, XOR, ZERO, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, XOR, MATH0, NONE, SIZE(4), 0);
	MATHB(MATH2, XOR, MATH1, NONE, SIZE(8), WITH(STL));
	MATHB(MATH2, XOR, MATH2, NONE, SIZE(1), 0);
	MATHB(MATH2, XOR, MATH3, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, XOR, IMM(0x19261959fedcba01), NONE, SIZE(8), 0);
	MATHB(MATH2, XOR, DPOVRD, NONE, SIZE(1), 0);
	MATHB(MATH2, XOR, VSEQINSZ, NONE, SIZE(2), WITH(STL));
	MATHB(MATH2, XOR, VSEQOUTSZ, NONE, SIZE(4), 0);
	MATHB(MATH2, XOR, ABD, NONE, SIZE(4), WITH(STL));
	MATHB(MATH2, XOR, OFIFO, NONE, SIZE(1), 0);
	MATHB(MATH2, XOR, ONE, NONE, SIZE(4), 0);
	MATHB(MATH2, XOR, ZERO, NONE, SIZE(8), 0);
	MATHB(MATH3, XOR, MATH0, NONE, SIZE(1), 0);
	MATHB(MATH3, XOR, MATH1, NONE, SIZE(8), 0);
	MATHB(MATH3, XOR, MATH2, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, XOR, MATH3, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, XOR, IMM(393615378), NONE, SIZE(1), 0);
	MATHB(MATH3, XOR, DPOVRD, NONE, SIZE(2), 0);
	MATHB(MATH3, XOR, VSEQINSZ, NONE, SIZE(1), 0);
	MATHB(MATH3, XOR, VSEQOUTSZ, NONE, SIZE(1), WITH(NFU));
	MATHB(MATH3, XOR, ABD, NONE, SIZE(8), 0);
	MATHB(MATH3, XOR, OFIFO, NONE, SIZE(1), 0);
	MATHB(MATH3, XOR, ONE, NONE, SIZE(1), 0);
	MATHB(MATH3, XOR, ZERO, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(0x19261959fedcba01), XOR, MATH0, NONE, SIZE(8), 0);
	MATHB(IMM(275128321), XOR, MATH1, NONE, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), XOR, MATH2, NONE, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), XOR, MATH3, NONE, SIZE(2), 0);
	MATHB(IMM(275128321), XOR, IMM(393615378), NONE, SIZE(2), 0);
	MATHB(IMM(0x19261959fedcba01), XOR, DPOVRD, NONE, SIZE(8), 0);
	MATHB(IMM(0x19261959fedcba01), XOR, VSEQINSZ, NONE, SIZE(8), 0);
	MATHB(IMM(275128321), XOR, VSEQOUTSZ, NONE, SIZE(4), 0);
	MATHB(IMM(275128321), XOR, ABD, NONE, SIZE(4), 0);
	MATHB(IMM(275128321), XOR, OFIFO, NONE, SIZE(1), 0);
	MATHB(IMM(275128321), XOR, ONE, NONE, SIZE(1), 0);
	MATHB(IMM(275128321), XOR, ZERO, NONE, SIZE(4), 0);
	MATHB(DPOVRD, XOR, MATH0, NONE, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, XOR, MATH1, NONE, SIZE(4), 0);
	MATHB(DPOVRD, XOR, MATH2, NONE, SIZE(1), WITH(STL));
	MATHB(DPOVRD, XOR, MATH3, NONE, SIZE(4), 0);
	MATHB(DPOVRD, XOR, IMM(393615378), NONE, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, XOR, DPOVRD, NONE, SIZE(4), 0);
	MATHB(DPOVRD, XOR, VSEQINSZ, NONE, SIZE(2), WITH(STL));
	MATHB(DPOVRD, XOR, VSEQOUTSZ, NONE, SIZE(8), 0);
	MATHB(DPOVRD, XOR, ABD, NONE, SIZE(2), 0);
	MATHB(DPOVRD, XOR, OFIFO, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, XOR, ONE, NONE, SIZE(1), WITH(STL));
	MATHB(DPOVRD, XOR, ZERO, NONE, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, XOR, MATH0, NONE, SIZE(8), 0);
	MATHB(SEQINSZ, XOR, MATH1, NONE, SIZE(4), 0);
	MATHB(SEQINSZ, XOR, MATH2, NONE, SIZE(2), 0);
	MATHB(SEQINSZ, XOR, MATH3, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(SEQINSZ, XOR, IMM(393615378), NONE, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, XOR, DPOVRD, NONE, SIZE(2), 0);
	MATHB(SEQINSZ, XOR, VSEQINSZ, NONE, SIZE(4), 0);
	MATHB(SEQINSZ, XOR, VSEQOUTSZ, NONE, SIZE(4), 0);
	MATHB(SEQINSZ, XOR, ABD, NONE, SIZE(2), 0);
	MATHB(SEQINSZ, XOR, OFIFO, NONE, SIZE(1), 0);
	MATHB(SEQINSZ, XOR, ONE, NONE, SIZE(1), 0);
	MATHB(SEQINSZ, XOR, ZERO, NONE, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, XOR, MATH0, NONE, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, XOR, MATH1, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, XOR, MATH2, NONE, SIZE(4), 0);
	MATHB(SEQOUTSZ, XOR, MATH3, NONE, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, XOR, IMM(393615378), NONE, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, XOR, DPOVRD, NONE, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, XOR, VSEQINSZ, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, XOR, VSEQOUTSZ, NONE, SIZE(2), 0);
	MATHB(SEQOUTSZ, XOR, ABD, NONE, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, XOR, OFIFO, NONE, SIZE(8), WITH(NFU));
	MATHB(SEQOUTSZ, XOR, ONE, NONE, SIZE(4), 0);
	MATHB(SEQOUTSZ, XOR, ZERO, NONE, SIZE(2), 0);
	MATHB(VSEQINSZ, XOR, MATH0, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, XOR, MATH1, NONE, SIZE(4), WITH(STL));
	MATHB(VSEQINSZ, XOR, MATH2, NONE, SIZE(8), 0);
	MATHB(VSEQINSZ, XOR, MATH3, NONE, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, XOR, IMM(393615378), NONE, SIZE(8),
	      WITH(IFB | NFU | STL));
	MATHB(VSEQINSZ, XOR, DPOVRD, NONE, SIZE(1), 0);
	MATHB(VSEQINSZ, XOR, VSEQINSZ, NONE, SIZE(2), 0);
	MATHB(VSEQINSZ, XOR, VSEQOUTSZ, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, XOR, ABD, NONE, SIZE(2), 0);
	MATHB(VSEQINSZ, XOR, OFIFO, NONE, SIZE(2), 0);
	MATHB(VSEQINSZ, XOR, ONE, NONE, SIZE(8), 0);
	MATHB(VSEQINSZ, XOR, ZERO, NONE, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, XOR, MATH0, NONE, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, XOR, MATH1, NONE, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, XOR, MATH2, NONE, SIZE(2), 0);
	MATHB(VSEQOUTSZ, XOR, MATH3, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, XOR, IMM(393615378), NONE, SIZE(1), 0);
	MATHB(VSEQOUTSZ, XOR, DPOVRD, NONE, SIZE(4), 0);
	MATHB(VSEQOUTSZ, XOR, VSEQINSZ, NONE, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, XOR, VSEQOUTSZ, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, XOR, ABD, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, XOR, OFIFO, NONE, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, XOR, ONE, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, XOR, ZERO, NONE, SIZE(2), 0);
	MATHB(ZERO, XOR, MATH0, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, XOR, MATH1, NONE, SIZE(8), 0);
	MATHB(ZERO, XOR, MATH2, NONE, SIZE(4), 0);
	MATHB(ZERO, XOR, MATH3, NONE, SIZE(8), 0);
	MATHB(ZERO, XOR, IMM(0x19261959fedcba01), NONE, SIZE(8), 0);
	MATHB(ZERO, XOR, DPOVRD, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, XOR, VSEQINSZ, NONE, SIZE(1), 0);
	MATHB(ZERO, XOR, VSEQOUTSZ, NONE, SIZE(8), 0);
	MATHB(ZERO, XOR, ABD, NONE, SIZE(4), WITH(STL));
	MATHB(ZERO, XOR, OFIFO, NONE, SIZE(8), 0);
	MATHB(ZERO, XOR, ONE, NONE, SIZE(8), 0);
	MATHB(ZERO, XOR, ZERO, NONE, SIZE(8), 0);
	MATHB(ONE, XOR, MATH0, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, XOR, MATH1, NONE, SIZE(8), 0);
	MATHB(ONE, XOR, MATH2, NONE, SIZE(1), 0);
	MATHB(ONE, XOR, MATH3, NONE, SIZE(2), 0);
	MATHB(ONE, XOR, IMM(393615378), NONE, SIZE(4), 0);
	MATHB(ONE, XOR, DPOVRD, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, XOR, VSEQINSZ, NONE, SIZE(1), WITH(STL));
	MATHB(ONE, XOR, VSEQOUTSZ, NONE, SIZE(1), 0);
	MATHB(ONE, XOR, ABD, NONE, SIZE(2), WITH(NFU));
	MATHB(ONE, XOR, OFIFO, NONE, SIZE(1), 0);
	MATHB(ONE, XOR, ONE, NONE, SIZE(1), 0);
	MATHB(ONE, XOR, ZERO, NONE, SIZE(4), 0);
	/*LSHIFT Operation: MATH0 Destination register */
	MATHB(MATH0, LSHIFT, MATH0, MATH0, SIZE(1), WITH(STL));
	MATHB(MATH0, LSHIFT, MATH1, MATH0, SIZE(1), WITH(STL));
	MATHB(MATH0, LSHIFT, MATH2, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(MATH0, LSHIFT, MATH3, MATH0, SIZE(4), WITH(STL));
	MATHB(MATH0, LSHIFT, IMM(393615378), MATH0, SIZE(2), 0);
	MATHB(MATH0, LSHIFT, DPOVRD, MATH0, SIZE(1), WITH(STL));
	MATHB(MATH0, LSHIFT, VSEQINSZ, MATH0, SIZE(4), 0);
	MATHB(MATH0, LSHIFT, VSEQOUTSZ, MATH0, SIZE(4), 0);
	MATHB(MATH0, LSHIFT, ABD, MATH0, SIZE(2), WITH(NFU));
	MATHB(MATH0, LSHIFT, OFIFO, MATH0, SIZE(4), 0);
	MATHB(MATH0, LSHIFT, ONE, MATH0, SIZE(4), 0);
	MATHB(MATH0, LSHIFT, ZERO, MATH0, SIZE(2), 0);
	MATHB(MATH1, LSHIFT, MATH0, MATH0, SIZE(1), 0);
	MATHB(MATH1, LSHIFT, MATH1, MATH0, SIZE(2), 0);
	MATHB(MATH1, LSHIFT, MATH2, MATH0, SIZE(8), WITH(STL));
	MATHB(MATH1, LSHIFT, MATH3, MATH0, SIZE(4), 0);
	MATHB(MATH1, LSHIFT, IMM(393615378), MATH0, SIZE(1), 0);
	MATHB(MATH1, LSHIFT, DPOVRD, MATH0, SIZE(1), 0);
	MATHB(MATH1, LSHIFT, VSEQINSZ, MATH0, SIZE(4), 0);
	MATHB(MATH1, LSHIFT, VSEQOUTSZ, MATH0, SIZE(8), 0);
	MATHB(MATH1, LSHIFT, ABD, MATH0, SIZE(8), 0);
	MATHB(MATH1, LSHIFT, OFIFO, MATH0, SIZE(2), WITH(NFU));
	MATHB(MATH1, LSHIFT, ONE, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, LSHIFT, ZERO, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, LSHIFT, MATH0, MATH0, SIZE(2), 0);
	MATHB(MATH2, LSHIFT, MATH1, MATH0, SIZE(1), 0);
	MATHB(MATH2, LSHIFT, MATH2, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, LSHIFT, MATH3, MATH0, SIZE(4), WITH(NFU));
	MATHB(MATH2, LSHIFT, IMM(393615378), MATH0, SIZE(4), WITH(STL));
	MATHB(MATH2, LSHIFT, DPOVRD, MATH0, SIZE(8), 0);
	MATHB(MATH2, LSHIFT, VSEQINSZ, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, LSHIFT, VSEQOUTSZ, MATH0, SIZE(8), 0);
	MATHB(MATH2, LSHIFT, ABD, MATH0, SIZE(4), 0);
	MATHB(MATH2, LSHIFT, OFIFO, MATH0, SIZE(2), 0);
	MATHB(MATH2, LSHIFT, ONE, MATH0, SIZE(8), WITH(NFU));
	MATHB(MATH2, LSHIFT, ZERO, MATH0, SIZE(1), 0);
	MATHB(MATH3, LSHIFT, MATH0, MATH0, SIZE(2), 0);
	MATHB(MATH3, LSHIFT, MATH1, MATH0, SIZE(8), 0);
	MATHB(MATH3, LSHIFT, MATH2, MATH0, SIZE(4), WITH(STL));
	MATHB(MATH3, LSHIFT, MATH3, MATH0, SIZE(4), 0);
	MATHB(MATH3, LSHIFT, IMM(393615378), MATH0, SIZE(2), WITH(STL));
	MATHB(MATH3, LSHIFT, DPOVRD, MATH0, SIZE(2), WITH(STL));
	MATHB(MATH3, LSHIFT, VSEQINSZ, MATH0, SIZE(8), WITH(NFU));
	MATHB(MATH3, LSHIFT, VSEQOUTSZ, MATH0, SIZE(2), 0);
	MATHB(MATH3, LSHIFT, ABD, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, LSHIFT, OFIFO, MATH0, SIZE(1), 0);
	MATHB(MATH3, LSHIFT, ONE, MATH0, SIZE(1), 0);
	MATHB(MATH3, LSHIFT, ZERO, MATH0, SIZE(8), WITH(STL));
	MATHB(IMM(275128321), LSHIFT, MATH0, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), LSHIFT, MATH1, MATH0, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), LSHIFT, MATH2, MATH0, SIZE(1), 0);
	MATHB(IMM(275128321), LSHIFT, MATH3, MATH0, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), LSHIFT, IMM(393615378), MATH0, SIZE(4),
	      WITH(STL));
	MATHB(IMM(275128321), LSHIFT, DPOVRD, MATH0, SIZE(2), 0);
	MATHB(IMM(275128321), LSHIFT, VSEQINSZ, MATH0, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), LSHIFT, VSEQOUTSZ, MATH0, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), LSHIFT, ABD, MATH0, SIZE(4), 0);
	MATHB(IMM(275128321), LSHIFT, OFIFO, MATH0, SIZE(4), 0);
	MATHB(IMM(275128321), LSHIFT, ONE, MATH0, SIZE(2), WITH(NFU));
	MATHB(IMM(275128321), LSHIFT, ZERO, MATH0, SIZE(1), WITH(STL));
	MATHB(DPOVRD, LSHIFT, MATH0, MATH0, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, LSHIFT, MATH1, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, LSHIFT, MATH2, MATH0, SIZE(1), 0);
	MATHB(DPOVRD, LSHIFT, MATH3, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, LSHIFT, IMM(393615378), MATH0, SIZE(1), 0);
	MATHB(DPOVRD, LSHIFT, DPOVRD, MATH0, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, LSHIFT, VSEQINSZ, MATH0, SIZE(1), 0);
	MATHB(DPOVRD, LSHIFT, VSEQOUTSZ, MATH0, SIZE(4), WITH(STL));
	MATHB(DPOVRD, LSHIFT, ABD, MATH0, SIZE(4), 0);
	MATHB(DPOVRD, LSHIFT, OFIFO, MATH0, SIZE(1), 0);
	MATHB(DPOVRD, LSHIFT, ONE, MATH0, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, LSHIFT, ZERO, MATH0, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, LSHIFT, MATH0, MATH0, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, LSHIFT, MATH1, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, LSHIFT, MATH2, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, LSHIFT, MATH3, MATH0, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, LSHIFT, IMM(0x19261959fedcba01), MATH0, SIZE(8), 0);
	MATHB(SEQINSZ, LSHIFT, DPOVRD, MATH0, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, LSHIFT, VSEQINSZ, MATH0, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, LSHIFT, VSEQOUTSZ, MATH0, SIZE(2), 0);
	MATHB(SEQINSZ, LSHIFT, ABD, MATH0, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, LSHIFT, OFIFO, MATH0, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, LSHIFT, ONE, MATH0, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, LSHIFT, ZERO, MATH0, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, LSHIFT, MATH0, MATH0, SIZE(8), 0);
	MATHB(SEQOUTSZ, LSHIFT, MATH1, MATH0, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, LSHIFT, MATH2, MATH0, SIZE(8), 0);
	MATHB(SEQOUTSZ, LSHIFT, MATH3, MATH0, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, LSHIFT, IMM(393615378), MATH0, SIZE(4), 0);
	MATHB(SEQOUTSZ, LSHIFT, DPOVRD, MATH0, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, LSHIFT, VSEQINSZ, MATH0, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, LSHIFT, VSEQOUTSZ, MATH0, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, LSHIFT, ABD, MATH0, SIZE(2), 0);
	MATHB(SEQOUTSZ, LSHIFT, OFIFO, MATH0, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, LSHIFT, ONE, MATH0, SIZE(2), 0);
	MATHB(SEQOUTSZ, LSHIFT, ZERO, MATH0, SIZE(1), 0);
	MATHB(VSEQINSZ, LSHIFT, MATH0, MATH0, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, LSHIFT, MATH1, MATH0, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, LSHIFT, MATH2, MATH0, SIZE(2), 0);
	MATHB(VSEQINSZ, LSHIFT, MATH3, MATH0, SIZE(8), 0);
	MATHB(VSEQINSZ, LSHIFT, IMM(393615378), MATH0, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, LSHIFT, DPOVRD, MATH0, SIZE(1), 0);
	MATHB(VSEQINSZ, LSHIFT, VSEQINSZ, MATH0, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, LSHIFT, VSEQOUTSZ, MATH0, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, LSHIFT, ABD, MATH0, SIZE(2), 0);
	MATHB(VSEQINSZ, LSHIFT, OFIFO, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQINSZ, LSHIFT, ONE, MATH0, SIZE(8), 0);
	MATHB(VSEQINSZ, LSHIFT, ZERO, MATH0, SIZE(1), 0);
	MATHB(VSEQOUTSZ, LSHIFT, MATH0, MATH0, SIZE(2), 0);
	MATHB(VSEQOUTSZ, LSHIFT, MATH1, MATH0, SIZE(8), 0);
	MATHB(VSEQOUTSZ, LSHIFT, MATH2, MATH0, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, LSHIFT, MATH3, MATH0, SIZE(8), 0);
	MATHB(VSEQOUTSZ, LSHIFT, IMM(393615378), MATH0, SIZE(2), 0);
	MATHB(VSEQOUTSZ, LSHIFT, DPOVRD, MATH0, SIZE(4), 0);
	MATHB(VSEQOUTSZ, LSHIFT, VSEQINSZ, MATH0, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, LSHIFT, VSEQOUTSZ, MATH0, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, LSHIFT, ABD, MATH0, SIZE(2), 0);
	MATHB(VSEQOUTSZ, LSHIFT, OFIFO, MATH0, SIZE(4), 0);
	MATHB(VSEQOUTSZ, LSHIFT, ONE, MATH0, SIZE(1), 0);
	MATHB(VSEQOUTSZ, LSHIFT, ZERO, MATH0, SIZE(8), 0);
	MATHB(ZERO, LSHIFT, MATH0, MATH0, SIZE(2), 0);
	MATHB(ZERO, LSHIFT, MATH1, MATH0, SIZE(2), WITH(NFU));
	MATHB(ZERO, LSHIFT, MATH2, MATH0, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, LSHIFT, MATH3, MATH0, SIZE(1), 0);
	MATHB(ZERO, LSHIFT, IMM(393615378), MATH0, SIZE(4), 0);
	MATHB(ZERO, LSHIFT, DPOVRD, MATH0, SIZE(8), 0);
	MATHB(ZERO, LSHIFT, VSEQINSZ, MATH0, SIZE(1), 0);
	MATHB(ZERO, LSHIFT, VSEQOUTSZ, MATH0, SIZE(8), 0);
	MATHB(ZERO, LSHIFT, ABD, MATH0, SIZE(8), WITH(NFU));
	MATHB(ZERO, LSHIFT, OFIFO, MATH0, SIZE(4), WITH(NFU));
	MATHB(ZERO, LSHIFT, ONE, MATH0, SIZE(2), 0);
	MATHB(ZERO, LSHIFT, ZERO, MATH0, SIZE(1), 0);
	MATHB(ONE, LSHIFT, MATH0, MATH0, SIZE(8), WITH(STL));
	MATHB(ONE, LSHIFT, MATH1, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, LSHIFT, MATH2, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, LSHIFT, MATH3, MATH0, SIZE(4), 0);
	MATHB(ONE, LSHIFT, IMM(393615378), MATH0, SIZE(2), 0);
	MATHB(ONE, LSHIFT, DPOVRD, MATH0, SIZE(1), 0);
	MATHB(ONE, LSHIFT, VSEQINSZ, MATH0, SIZE(1), 0);
	MATHB(ONE, LSHIFT, VSEQOUTSZ, MATH0, SIZE(2), 0);
	MATHB(ONE, LSHIFT, ABD, MATH0, SIZE(4), WITH(NFU));
	MATHB(ONE, LSHIFT, OFIFO, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, LSHIFT, ONE, MATH0, SIZE(1), 0);
	MATHB(ONE, LSHIFT, ZERO, MATH0, SIZE(8), 0);
	/*LSHIFT Operation: MATH1 Destination register */
	MATHB(MATH0, LSHIFT, MATH0, MATH1, SIZE(4), 0);
	MATHB(MATH0, LSHIFT, MATH1, MATH1, SIZE(1), WITH(STL));
	MATHB(MATH0, LSHIFT, MATH2, MATH1, SIZE(1), WITH(NFU));
	MATHB(MATH0, LSHIFT, MATH3, MATH1, SIZE(8), 0);
	MATHB(MATH0, LSHIFT, IMM(393615378), MATH1, SIZE(8), WITH(IFB | STL));
	MATHB(MATH0, LSHIFT, DPOVRD, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, LSHIFT, VSEQINSZ, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, LSHIFT, VSEQOUTSZ, MATH1, SIZE(4), 0);
	MATHB(MATH0, LSHIFT, ABD, MATH1, SIZE(4), 0);
	MATHB(MATH0, LSHIFT, OFIFO, MATH1, SIZE(8), WITH(STL));
	MATHB(MATH0, LSHIFT, ONE, MATH1, SIZE(1), 0);
	MATHB(MATH0, LSHIFT, ZERO, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, LSHIFT, MATH0, MATH1, SIZE(1), 0);
	MATHB(MATH1, LSHIFT, MATH1, MATH1, SIZE(8), WITH(NFU));
	MATHB(MATH1, LSHIFT, MATH2, MATH1, SIZE(8), 0);
	MATHB(MATH1, LSHIFT, MATH3, MATH1, SIZE(8), 0);
	MATHB(MATH1, LSHIFT, IMM(393615378), MATH1, SIZE(1), WITH(STL));
	MATHB(MATH1, LSHIFT, DPOVRD, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(MATH1, LSHIFT, VSEQINSZ, MATH1, SIZE(4), 0);
	MATHB(MATH1, LSHIFT, VSEQOUTSZ, MATH1, SIZE(4), 0);
	MATHB(MATH1, LSHIFT, ABD, MATH1, SIZE(4), 0);
	MATHB(MATH1, LSHIFT, OFIFO, MATH1, SIZE(2), WITH(NFU));
	MATHB(MATH1, LSHIFT, ONE, MATH1, SIZE(4), WITH(NFU));
	MATHB(MATH1, LSHIFT, ZERO, MATH1, SIZE(1), WITH(STL));
	MATHB(MATH2, LSHIFT, MATH0, MATH1, SIZE(4), WITH(STL));
	MATHB(MATH2, LSHIFT, MATH1, MATH1, SIZE(8), 0);
	MATHB(MATH2, LSHIFT, MATH2, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, LSHIFT, MATH3, MATH1, SIZE(2), WITH(NFU));
	MATHB(MATH2, LSHIFT, IMM(393615378), MATH1, SIZE(1), 0);
	MATHB(MATH2, LSHIFT, DPOVRD, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, LSHIFT, VSEQINSZ, MATH1, SIZE(2), 0);
	MATHB(MATH2, LSHIFT, VSEQOUTSZ, MATH1, SIZE(4), 0);
	MATHB(MATH2, LSHIFT, ABD, MATH1, SIZE(2), 0);
	MATHB(MATH2, LSHIFT, OFIFO, MATH1, SIZE(4), 0);
	MATHB(MATH2, LSHIFT, ONE, MATH1, SIZE(4), WITH(STL));
	MATHB(MATH2, LSHIFT, ZERO, MATH1, SIZE(2), 0);
	MATHB(MATH3, LSHIFT, MATH0, MATH1, SIZE(2), WITH(NFU));
	MATHB(MATH3, LSHIFT, MATH1, MATH1, SIZE(8), WITH(NFU));
	MATHB(MATH3, LSHIFT, MATH2, MATH1, SIZE(1), WITH(STL));
	MATHB(MATH3, LSHIFT, MATH3, MATH1, SIZE(1), 0);
	MATHB(MATH3, LSHIFT, IMM(393615378), MATH1, SIZE(4), 0);
	MATHB(MATH3, LSHIFT, DPOVRD, MATH1, SIZE(4), 0);
	MATHB(MATH3, LSHIFT, VSEQINSZ, MATH1, SIZE(1), 0);
	MATHB(MATH3, LSHIFT, VSEQOUTSZ, MATH1, SIZE(2), WITH(NFU));
	MATHB(MATH3, LSHIFT, ABD, MATH1, SIZE(2), WITH(STL));
	MATHB(MATH3, LSHIFT, OFIFO, MATH1, SIZE(2), WITH(STL));
	MATHB(MATH3, LSHIFT, ONE, MATH1, SIZE(2), 0);
	MATHB(MATH3, LSHIFT, ZERO, MATH1, SIZE(1), 0);
	MATHB(IMM(275128321), LSHIFT, MATH0, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(275128321), LSHIFT, MATH1, MATH1, SIZE(4), 0);
	MATHB(IMM(275128321), LSHIFT, MATH2, MATH1, SIZE(2), 0);
	MATHB(IMM(275128321), LSHIFT, MATH3, MATH1, SIZE(2), WITH(NFU));
	MATHB(IMM(275128321), LSHIFT, IMM(393615378), MATH1, SIZE(1), 0);
	MATHB(IMM(0x19261959fedcba01), LSHIFT, DPOVRD, MATH1, SIZE(8), 0);
	MATHB(IMM(275128321), LSHIFT, VSEQINSZ, MATH1, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), LSHIFT, VSEQOUTSZ, MATH1, SIZE(2), WITH(NFU));
	MATHB(IMM(275128321), LSHIFT, ABD, MATH1, SIZE(2), WITH(NFU));
	MATHB(IMM(0x19261959fedcba01), LSHIFT, OFIFO, MATH1, SIZE(8), 0);
	MATHB(IMM(275128321), LSHIFT, ONE, MATH1, SIZE(1), 0);
	MATHB(IMM(275128321), LSHIFT, ZERO, MATH1, SIZE(2), 0);
	MATHB(DPOVRD, LSHIFT, MATH0, MATH1, SIZE(4), 0);
	MATHB(DPOVRD, LSHIFT, MATH1, MATH1, SIZE(2), 0);
	MATHB(DPOVRD, LSHIFT, MATH2, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, LSHIFT, MATH3, MATH1, SIZE(4), WITH(STL));
	MATHB(DPOVRD, LSHIFT, IMM(393615378), MATH1, SIZE(8), WITH(IFB));
	MATHB(DPOVRD, LSHIFT, DPOVRD, MATH1, SIZE(1), 0);
	MATHB(DPOVRD, LSHIFT, VSEQINSZ, MATH1, SIZE(4), WITH(STL));
	MATHB(DPOVRD, LSHIFT, VSEQOUTSZ, MATH1, SIZE(1), 0);
	MATHB(DPOVRD, LSHIFT, ABD, MATH1, SIZE(4), 0);
	MATHB(DPOVRD, LSHIFT, OFIFO, MATH1, SIZE(8), 0);
	MATHB(DPOVRD, LSHIFT, ONE, MATH1, SIZE(4), 0);
	MATHB(DPOVRD, LSHIFT, ZERO, MATH1, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, LSHIFT, MATH0, MATH1, SIZE(8), 0);
	MATHB(SEQINSZ, LSHIFT, MATH1, MATH1, SIZE(8), 0);
	MATHB(SEQINSZ, LSHIFT, MATH2, MATH1, SIZE(4), 0);
	MATHB(SEQINSZ, LSHIFT, MATH3, MATH1, SIZE(4), 0);
	MATHB(SEQINSZ, LSHIFT, IMM(393615378), MATH1, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, LSHIFT, DPOVRD, MATH1, SIZE(1), 0);
	MATHB(SEQINSZ, LSHIFT, VSEQINSZ, MATH1, SIZE(1), 0);
	MATHB(SEQINSZ, LSHIFT, VSEQOUTSZ, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, LSHIFT, ABD, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(SEQINSZ, LSHIFT, OFIFO, MATH1, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, LSHIFT, ONE, MATH1, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, LSHIFT, ZERO, MATH1, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, LSHIFT, MATH0, MATH1, SIZE(8), 0);
	MATHB(SEQOUTSZ, LSHIFT, MATH1, MATH1, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, LSHIFT, MATH2, MATH1, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, LSHIFT, MATH3, MATH1, SIZE(8), 0);
	MATHB(SEQOUTSZ, LSHIFT, IMM(393615378), MATH1, SIZE(1),
	      WITH(NFU | STL));
	MATHB(SEQOUTSZ, LSHIFT, DPOVRD, MATH1, SIZE(4), 0);
	MATHB(SEQOUTSZ, LSHIFT, VSEQINSZ, MATH1, SIZE(2), 0);
	MATHB(SEQOUTSZ, LSHIFT, VSEQOUTSZ, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, LSHIFT, ABD, MATH1, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, LSHIFT, OFIFO, MATH1, SIZE(8), 0);
	MATHB(SEQOUTSZ, LSHIFT, ONE, MATH1, SIZE(2), 0);
	MATHB(SEQOUTSZ, LSHIFT, ZERO, MATH1, SIZE(1), 0);
	MATHB(VSEQINSZ, LSHIFT, MATH0, MATH1, SIZE(4), 0);
	MATHB(VSEQINSZ, LSHIFT, MATH1, MATH1, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, LSHIFT, MATH2, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, LSHIFT, MATH3, MATH1, SIZE(4), 0);
	MATHB(VSEQINSZ, LSHIFT, IMM(393615378), MATH1, SIZE(2), 0);
	MATHB(VSEQINSZ, LSHIFT, DPOVRD, MATH1, SIZE(2), 0);
	MATHB(VSEQINSZ, LSHIFT, VSEQINSZ, MATH1, SIZE(1), 0);
	MATHB(VSEQINSZ, LSHIFT, VSEQOUTSZ, MATH1, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, LSHIFT, ABD, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, LSHIFT, OFIFO, MATH1, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, LSHIFT, ONE, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, LSHIFT, ZERO, MATH1, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, LSHIFT, MATH0, MATH1, SIZE(1), 0);
	MATHB(VSEQOUTSZ, LSHIFT, MATH1, MATH1, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, LSHIFT, MATH2, MATH1, SIZE(2), 0);
	MATHB(VSEQOUTSZ, LSHIFT, MATH3, MATH1, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, LSHIFT, IMM(393615378), MATH1, SIZE(4), 0);
	MATHB(VSEQOUTSZ, LSHIFT, DPOVRD, MATH1, SIZE(2), 0);
	MATHB(VSEQOUTSZ, LSHIFT, VSEQINSZ, MATH1, SIZE(1), 0);
	MATHB(VSEQOUTSZ, LSHIFT, VSEQOUTSZ, MATH1, SIZE(1), 0);
	MATHB(VSEQOUTSZ, LSHIFT, ABD, MATH1, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, LSHIFT, OFIFO, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, LSHIFT, ONE, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, LSHIFT, ZERO, MATH1, SIZE(1), 0);
	MATHB(ZERO, LSHIFT, MATH0, MATH1, SIZE(4), 0);
	MATHB(ZERO, LSHIFT, MATH1, MATH1, SIZE(4), 0);
	MATHB(ZERO, LSHIFT, MATH2, MATH1, SIZE(4), 0);
	MATHB(ZERO, LSHIFT, MATH3, MATH1, SIZE(1), WITH(STL));
	MATHB(ZERO, LSHIFT, IMM(393615378), MATH1, SIZE(4), 0);
	MATHB(ZERO, LSHIFT, DPOVRD, MATH1, SIZE(8), WITH(STL));
	MATHB(ZERO, LSHIFT, VSEQINSZ, MATH1, SIZE(4), 0);
	MATHB(ZERO, LSHIFT, VSEQOUTSZ, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, LSHIFT, ABD, MATH1, SIZE(2), WITH(NFU));
	MATHB(ZERO, LSHIFT, OFIFO, MATH1, SIZE(1), 0);
	MATHB(ZERO, LSHIFT, ONE, MATH1, SIZE(1), 0);
	MATHB(ZERO, LSHIFT, ZERO, MATH1, SIZE(1), WITH(STL));
	MATHB(ONE, LSHIFT, MATH0, MATH1, SIZE(2), 0);
	MATHB(ONE, LSHIFT, MATH1, MATH1, SIZE(8), 0);
	MATHB(ONE, LSHIFT, MATH2, MATH1, SIZE(8), 0);
	MATHB(ONE, LSHIFT, MATH3, MATH1, SIZE(1), 0);
	MATHB(ONE, LSHIFT, IMM(393615378), MATH1, SIZE(1), 0);
	MATHB(ONE, LSHIFT, DPOVRD, MATH1, SIZE(4), WITH(STL));
	MATHB(ONE, LSHIFT, VSEQINSZ, MATH1, SIZE(8), 0);
	MATHB(ONE, LSHIFT, VSEQOUTSZ, MATH1, SIZE(2), 0);
	MATHB(ONE, LSHIFT, ABD, MATH1, SIZE(8), 0);
	MATHB(ONE, LSHIFT, OFIFO, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, LSHIFT, ONE, MATH1, SIZE(8), WITH(NFU));
	MATHB(ONE, LSHIFT, ZERO, MATH1, SIZE(2), 0);
	/*LSHIFT Operation: MATH2 Destination register */
	MATHB(MATH0, LSHIFT, MATH0, MATH2, SIZE(2), WITH(STL));
	MATHB(MATH0, LSHIFT, MATH1, MATH2, SIZE(1), WITH(STL));
	MATHB(MATH0, LSHIFT, MATH2, MATH2, SIZE(4), 0);
	MATHB(MATH0, LSHIFT, MATH3, MATH2, SIZE(4), 0);
	MATHB(MATH0, LSHIFT, IMM(393615378), MATH2, SIZE(1), 0);
	MATHB(MATH0, LSHIFT, DPOVRD, MATH2, SIZE(2), 0);
	MATHB(MATH0, LSHIFT, VSEQINSZ, MATH2, SIZE(8), 0);
	MATHB(MATH0, LSHIFT, VSEQOUTSZ, MATH2, SIZE(8), WITH(STL));
	MATHB(MATH0, LSHIFT, ABD, MATH2, SIZE(8), WITH(NFU));
	MATHB(MATH0, LSHIFT, OFIFO, MATH2, SIZE(4), 0);
	MATHB(MATH0, LSHIFT, ONE, MATH2, SIZE(4), WITH(STL));
	MATHB(MATH0, LSHIFT, ZERO, MATH2, SIZE(4), 0);
	MATHB(MATH1, LSHIFT, MATH0, MATH2, SIZE(8), WITH(NFU));
	MATHB(MATH1, LSHIFT, MATH1, MATH2, SIZE(4), WITH(NFU));
	MATHB(MATH1, LSHIFT, MATH2, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, LSHIFT, MATH3, MATH2, SIZE(1), 0);
	MATHB(MATH1, LSHIFT, IMM(393615378), MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, LSHIFT, DPOVRD, MATH2, SIZE(1), 0);
	MATHB(MATH1, LSHIFT, VSEQINSZ, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, LSHIFT, VSEQOUTSZ, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(MATH1, LSHIFT, ABD, MATH2, SIZE(1), WITH(NFU | STL));
	MATHB(MATH1, LSHIFT, OFIFO, MATH2, SIZE(8), 0);
	MATHB(MATH1, LSHIFT, ONE, MATH2, SIZE(4), 0);
	MATHB(MATH1, LSHIFT, ZERO, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, LSHIFT, MATH0, MATH2, SIZE(8), 0);
	MATHB(MATH2, LSHIFT, MATH1, MATH2, SIZE(2), 0);
	MATHB(MATH2, LSHIFT, MATH2, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, LSHIFT, MATH3, MATH2, SIZE(8), WITH(STL));
	MATHB(MATH2, LSHIFT, IMM(393615378), MATH2, SIZE(1), 0);
	MATHB(MATH2, LSHIFT, DPOVRD, MATH2, SIZE(4), WITH(STL));
	MATHB(MATH2, LSHIFT, VSEQINSZ, MATH2, SIZE(8), WITH(NFU));
	MATHB(MATH2, LSHIFT, VSEQOUTSZ, MATH2, SIZE(8), WITH(NFU));
	MATHB(MATH2, LSHIFT, ABD, MATH2, SIZE(4), 0);
	MATHB(MATH2, LSHIFT, OFIFO, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, LSHIFT, ONE, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, LSHIFT, ZERO, MATH2, SIZE(2), WITH(NFU));
	MATHB(MATH3, LSHIFT, MATH0, MATH2, SIZE(4), WITH(NFU));
	MATHB(MATH3, LSHIFT, MATH1, MATH2, SIZE(2), 0);
	MATHB(MATH3, LSHIFT, MATH2, MATH2, SIZE(2), 0);
	MATHB(MATH3, LSHIFT, MATH3, MATH2, SIZE(1), 0);
	MATHB(MATH3, LSHIFT, IMM(393615378), MATH2, SIZE(8), WITH(IFB));
	MATHB(MATH3, LSHIFT, DPOVRD, MATH2, SIZE(2), 0);
	MATHB(MATH3, LSHIFT, VSEQINSZ, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(MATH3, LSHIFT, VSEQOUTSZ, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(MATH3, LSHIFT, ABD, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, LSHIFT, OFIFO, MATH2, SIZE(1), WITH(NFU));
	MATHB(MATH3, LSHIFT, ONE, MATH2, SIZE(8), 0);
	MATHB(MATH3, LSHIFT, ZERO, MATH2, SIZE(1), 0);
	MATHB(IMM(275128321), LSHIFT, MATH0, MATH2, SIZE(1), 0);
	MATHB(IMM(275128321), LSHIFT, MATH1, MATH2, SIZE(4), 0);
	MATHB(IMM(275128321), LSHIFT, MATH2, MATH2, SIZE(1), 0);
	MATHB(IMM(275128321), LSHIFT, MATH3, MATH2, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(275128321), LSHIFT, IMM(393615378), MATH2, SIZE(1), 0);
	MATHB(IMM(275128321), LSHIFT, DPOVRD, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(0x19261959fedcba01), LSHIFT, VSEQINSZ, MATH2, SIZE(8), 0);
	MATHB(IMM(275128321), LSHIFT, VSEQOUTSZ, MATH2, SIZE(2), 0);
	MATHB(IMM(275128321), LSHIFT, ABD, MATH2, SIZE(2), 0);
	MATHB(IMM(275128321), LSHIFT, OFIFO, MATH2, SIZE(1), WITH(STL));
	MATHB(IMM(0x19261959fedcba01), LSHIFT, ONE, MATH2, SIZE(8), 0);
	MATHB(IMM(275128321), LSHIFT, ZERO, MATH2, SIZE(1), 0);
	MATHB(DPOVRD, LSHIFT, MATH0, MATH2, SIZE(8), 0);
	MATHB(DPOVRD, LSHIFT, MATH1, MATH2, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, LSHIFT, MATH2, MATH2, SIZE(4), 0);
	MATHB(DPOVRD, LSHIFT, MATH3, MATH2, SIZE(8), 0);
	MATHB(DPOVRD, LSHIFT, IMM(393615378), MATH2, SIZE(2), 0);
	MATHB(DPOVRD, LSHIFT, DPOVRD, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, LSHIFT, VSEQINSZ, MATH2, SIZE(4), WITH(STL));
	MATHB(DPOVRD, LSHIFT, VSEQOUTSZ, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(DPOVRD, LSHIFT, ABD, MATH2, SIZE(1), 0);
	MATHB(DPOVRD, LSHIFT, OFIFO, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, LSHIFT, ONE, MATH2, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, LSHIFT, ZERO, MATH2, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, LSHIFT, MATH0, MATH2, SIZE(8), 0);
	MATHB(SEQINSZ, LSHIFT, MATH1, MATH2, SIZE(1), 0);
	MATHB(SEQINSZ, LSHIFT, MATH2, MATH2, SIZE(8), 0);
	MATHB(SEQINSZ, LSHIFT, MATH3, MATH2, SIZE(1), 0);
	MATHB(SEQINSZ, LSHIFT, IMM(393615378), MATH2, SIZE(1), 0);
	MATHB(SEQINSZ, LSHIFT, DPOVRD, MATH2, SIZE(4), 0);
	MATHB(SEQINSZ, LSHIFT, VSEQINSZ, MATH2, SIZE(1), 0);
	MATHB(SEQINSZ, LSHIFT, VSEQOUTSZ, MATH2, SIZE(1), 0);
	MATHB(SEQINSZ, LSHIFT, ABD, MATH2, SIZE(1), 0);
	MATHB(SEQINSZ, LSHIFT, OFIFO, MATH2, SIZE(8), 0);
	MATHB(SEQINSZ, LSHIFT, ONE, MATH2, SIZE(8), 0);
	MATHB(SEQINSZ, LSHIFT, ZERO, MATH2, SIZE(8), 0);
	MATHB(SEQOUTSZ, LSHIFT, MATH0, MATH2, SIZE(4), 0);
	MATHB(SEQOUTSZ, LSHIFT, MATH1, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, LSHIFT, MATH2, MATH2, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, LSHIFT, MATH3, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, LSHIFT, IMM(0x19261959fedcba01), MATH2, SIZE(8),
	      WITH(NFU | STL));
	MATHB(SEQOUTSZ, LSHIFT, DPOVRD, MATH2, SIZE(4), 0);
	MATHB(SEQOUTSZ, LSHIFT, VSEQINSZ, MATH2, SIZE(8), 0);
	MATHB(SEQOUTSZ, LSHIFT, VSEQOUTSZ, MATH2, SIZE(2), 0);
	MATHB(SEQOUTSZ, LSHIFT, ABD, MATH2, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, LSHIFT, OFIFO, MATH2, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, LSHIFT, ONE, MATH2, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, LSHIFT, ZERO, MATH2, SIZE(2), 0);
	MATHB(VSEQINSZ, LSHIFT, MATH0, MATH2, SIZE(2), 0);
	MATHB(VSEQINSZ, LSHIFT, MATH1, MATH2, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, LSHIFT, MATH2, MATH2, SIZE(1), 0);
	MATHB(VSEQINSZ, LSHIFT, MATH3, MATH2, SIZE(4), 0);
	MATHB(VSEQINSZ, LSHIFT, IMM(393615378), MATH2, SIZE(2), 0);
	MATHB(VSEQINSZ, LSHIFT, DPOVRD, MATH2, SIZE(2), 0);
	MATHB(VSEQINSZ, LSHIFT, VSEQINSZ, MATH2, SIZE(1), 0);
	MATHB(VSEQINSZ, LSHIFT, VSEQOUTSZ, MATH2, SIZE(4), 0);
	MATHB(VSEQINSZ, LSHIFT, ABD, MATH2, SIZE(8), 0);
	MATHB(VSEQINSZ, LSHIFT, OFIFO, MATH2, SIZE(2), 0);
	MATHB(VSEQINSZ, LSHIFT, ONE, MATH2, SIZE(8), 0);
	MATHB(VSEQINSZ, LSHIFT, ZERO, MATH2, SIZE(2), 0);
	MATHB(VSEQOUTSZ, LSHIFT, MATH0, MATH2, SIZE(8), 0);
	MATHB(VSEQOUTSZ, LSHIFT, MATH1, MATH2, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, LSHIFT, MATH2, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, LSHIFT, MATH3, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, LSHIFT, IMM(393615378), MATH2, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, LSHIFT, DPOVRD, MATH2, SIZE(1), 0);
	MATHB(VSEQOUTSZ, LSHIFT, VSEQINSZ, MATH2, SIZE(1), 0);
	MATHB(VSEQOUTSZ, LSHIFT, VSEQOUTSZ, MATH2, SIZE(4), 0);
	MATHB(VSEQOUTSZ, LSHIFT, ABD, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, LSHIFT, OFIFO, MATH2, SIZE(8), 0);
	MATHB(VSEQOUTSZ, LSHIFT, ONE, MATH2, SIZE(1), 0);
	MATHB(VSEQOUTSZ, LSHIFT, ZERO, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, LSHIFT, MATH0, MATH2, SIZE(8), 0);
	MATHB(ZERO, LSHIFT, MATH1, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, LSHIFT, MATH2, MATH2, SIZE(1), WITH(STL));
	MATHB(ZERO, LSHIFT, MATH3, MATH2, SIZE(2), 0);
	MATHB(ZERO, LSHIFT, IMM(393615378), MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, LSHIFT, DPOVRD, MATH2, SIZE(2), WITH(STL));
	MATHB(ZERO, LSHIFT, VSEQINSZ, MATH2, SIZE(4), 0);
	MATHB(ZERO, LSHIFT, VSEQOUTSZ, MATH2, SIZE(4), 0);
	MATHB(ZERO, LSHIFT, ABD, MATH2, SIZE(2), 0);
	MATHB(ZERO, LSHIFT, OFIFO, MATH2, SIZE(4), WITH(NFU));
	MATHB(ZERO, LSHIFT, ONE, MATH2, SIZE(4), 0);
	MATHB(ZERO, LSHIFT, ZERO, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, LSHIFT, MATH0, MATH2, SIZE(2), 0);
	MATHB(ONE, LSHIFT, MATH1, MATH2, SIZE(4), 0);
	MATHB(ONE, LSHIFT, MATH2, MATH2, SIZE(2), 0);
	MATHB(ONE, LSHIFT, MATH3, MATH2, SIZE(1), 0);
	MATHB(ONE, LSHIFT, IMM(393615378), MATH2, SIZE(2), 0);
	MATHB(ONE, LSHIFT, DPOVRD, MATH2, SIZE(8), 0);
	MATHB(ONE, LSHIFT, VSEQINSZ, MATH2, SIZE(2), WITH(NFU));
	MATHB(ONE, LSHIFT, VSEQOUTSZ, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, LSHIFT, ABD, MATH2, SIZE(2), 0);
	MATHB(ONE, LSHIFT, OFIFO, MATH2, SIZE(1), 0);
	MATHB(ONE, LSHIFT, ONE, MATH2, SIZE(2), WITH(STL));
	MATHB(ONE, LSHIFT, ZERO, MATH2, SIZE(8), WITH(NFU));
	/*LSHIFT Operation: MATH3 Destination register */
	MATHB(MATH0, LSHIFT, MATH0, MATH3, SIZE(1), 0);
	MATHB(MATH0, LSHIFT, MATH1, MATH3, SIZE(8), WITH(STL));
	MATHB(MATH0, LSHIFT, MATH2, MATH3, SIZE(4), 0);
	MATHB(MATH0, LSHIFT, MATH3, MATH3, SIZE(1), WITH(STL));
	MATHB(MATH0, LSHIFT, IMM(393615378), MATH3, SIZE(2), 0);
	MATHB(MATH0, LSHIFT, DPOVRD, MATH3, SIZE(4), 0);
	MATHB(MATH0, LSHIFT, VSEQINSZ, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(MATH0, LSHIFT, VSEQOUTSZ, MATH3, SIZE(8), 0);
	MATHB(MATH0, LSHIFT, ABD, MATH3, SIZE(1), 0);
	MATHB(MATH0, LSHIFT, OFIFO, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, LSHIFT, ONE, MATH3, SIZE(4), 0);
	MATHB(MATH0, LSHIFT, ZERO, MATH3, SIZE(2), 0);
	MATHB(MATH1, LSHIFT, MATH0, MATH3, SIZE(8), WITH(STL));
	MATHB(MATH1, LSHIFT, MATH1, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(MATH1, LSHIFT, MATH2, MATH3, SIZE(2), 0);
	MATHB(MATH1, LSHIFT, MATH3, MATH3, SIZE(4), WITH(NFU));
	MATHB(MATH1, LSHIFT, IMM(393615378), MATH3, SIZE(1), WITH(NFU));
	MATHB(MATH1, LSHIFT, DPOVRD, MATH3, SIZE(2), 0);
	MATHB(MATH1, LSHIFT, VSEQINSZ, MATH3, SIZE(4), 0);
	MATHB(MATH1, LSHIFT, VSEQOUTSZ, MATH3, SIZE(1), 0);
	MATHB(MATH1, LSHIFT, ABD, MATH3, SIZE(1), WITH(NFU));
	MATHB(MATH1, LSHIFT, OFIFO, MATH3, SIZE(2), 0);
	MATHB(MATH1, LSHIFT, ONE, MATH3, SIZE(8), WITH(NFU));
	MATHB(MATH1, LSHIFT, ZERO, MATH3, SIZE(1), 0);
	MATHB(MATH2, LSHIFT, MATH0, MATH3, SIZE(8), 0);
	MATHB(MATH2, LSHIFT, MATH1, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, LSHIFT, MATH2, MATH3, SIZE(1), 0);
	MATHB(MATH2, LSHIFT, MATH3, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, LSHIFT, IMM(393615378), MATH3, SIZE(2), 0);
	MATHB(MATH2, LSHIFT, DPOVRD, MATH3, SIZE(1), 0);
	MATHB(MATH2, LSHIFT, VSEQINSZ, MATH3, SIZE(1), 0);
	MATHB(MATH2, LSHIFT, VSEQOUTSZ, MATH3, SIZE(1), WITH(STL));
	MATHB(MATH2, LSHIFT, ABD, MATH3, SIZE(1), 0);
	MATHB(MATH2, LSHIFT, OFIFO, MATH3, SIZE(1), WITH(NFU));
	MATHB(MATH2, LSHIFT, ONE, MATH3, SIZE(4), 0);
	MATHB(MATH2, LSHIFT, ZERO, MATH3, SIZE(1), 0);
	MATHB(MATH3, LSHIFT, MATH0, MATH3, SIZE(1), WITH(NFU));
	MATHB(MATH3, LSHIFT, MATH1, MATH3, SIZE(4), WITH(STL));
	MATHB(MATH3, LSHIFT, MATH2, MATH3, SIZE(1), WITH(STL));
	MATHB(MATH3, LSHIFT, MATH3, MATH3, SIZE(1), 0);
	MATHB(MATH3, LSHIFT, IMM(393615378), MATH3, SIZE(1), WITH(NFU));
	MATHB(MATH3, LSHIFT, DPOVRD, MATH3, SIZE(2), WITH(NFU));
	MATHB(MATH3, LSHIFT, VSEQINSZ, MATH3, SIZE(4), WITH(NFU));
	MATHB(MATH3, LSHIFT, VSEQOUTSZ, MATH3, SIZE(1), 0);
	MATHB(MATH3, LSHIFT, ABD, MATH3, SIZE(1), WITH(NFU));
	MATHB(MATH3, LSHIFT, OFIFO, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, LSHIFT, ONE, MATH3, SIZE(4), 0);
	MATHB(MATH3, LSHIFT, ZERO, MATH3, SIZE(2), WITH(STL));
	MATHB(IMM(0x19261959fedcba01), LSHIFT, MATH0, MATH3, SIZE(8), 0);
	MATHB(IMM(275128321), LSHIFT, MATH1, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), LSHIFT, MATH2, MATH3, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), LSHIFT, MATH3, MATH3, SIZE(4), 0);
	MATHB(IMM(275128321), LSHIFT, IMM(393615378), MATH3, SIZE(4), 0);
	MATHB(IMM(275128321), LSHIFT, DPOVRD, MATH3, SIZE(2), WITH(STL));
	MATHB(IMM(275128321), LSHIFT, VSEQINSZ, MATH3, SIZE(1),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), LSHIFT, VSEQOUTSZ, MATH3, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), LSHIFT, ABD, MATH3, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), LSHIFT, OFIFO, MATH3, SIZE(4), 0);
	MATHB(IMM(275128321), LSHIFT, ONE, MATH3, SIZE(4), 0);
	MATHB(IMM(275128321), LSHIFT, ZERO, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, LSHIFT, MATH0, MATH3, SIZE(8), 0);
	MATHB(DPOVRD, LSHIFT, MATH1, MATH3, SIZE(8), 0);
	MATHB(DPOVRD, LSHIFT, MATH2, MATH3, SIZE(2), WITH(STL));
	MATHB(DPOVRD, LSHIFT, MATH3, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, LSHIFT, IMM(393615378), MATH3, SIZE(8),
	      WITH(IFB | NFU | STL));
	MATHB(DPOVRD, LSHIFT, DPOVRD, MATH3, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, LSHIFT, VSEQINSZ, MATH3, SIZE(1), 0);
	MATHB(DPOVRD, LSHIFT, VSEQOUTSZ, MATH3, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, LSHIFT, ABD, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, LSHIFT, OFIFO, MATH3, SIZE(4), WITH(STL));
	MATHB(DPOVRD, LSHIFT, ONE, MATH3, SIZE(8), 0);
	MATHB(DPOVRD, LSHIFT, ZERO, MATH3, SIZE(8), 0);
	MATHB(SEQINSZ, LSHIFT, MATH0, MATH3, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, LSHIFT, MATH1, MATH3, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, LSHIFT, MATH2, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, LSHIFT, MATH3, MATH3, SIZE(1), 0);
	MATHB(SEQINSZ, LSHIFT, IMM(393615378), MATH3, SIZE(2), 0);
	MATHB(SEQINSZ, LSHIFT, DPOVRD, MATH3, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, LSHIFT, VSEQINSZ, MATH3, SIZE(8), 0);
	MATHB(SEQINSZ, LSHIFT, VSEQOUTSZ, MATH3, SIZE(1), 0);
	MATHB(SEQINSZ, LSHIFT, ABD, MATH3, SIZE(1), 0);
	MATHB(SEQINSZ, LSHIFT, OFIFO, MATH3, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, LSHIFT, ONE, MATH3, SIZE(8), 0);
	MATHB(SEQINSZ, LSHIFT, ZERO, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(SEQOUTSZ, LSHIFT, MATH0, MATH3, SIZE(1), 0);
	MATHB(SEQOUTSZ, LSHIFT, MATH1, MATH3, SIZE(1), 0);
	MATHB(SEQOUTSZ, LSHIFT, MATH2, MATH3, SIZE(8), 0);
	MATHB(SEQOUTSZ, LSHIFT, MATH3, MATH3, SIZE(8), 0);
	MATHB(SEQOUTSZ, LSHIFT, IMM(393615378), MATH3, SIZE(2), 0);
	MATHB(SEQOUTSZ, LSHIFT, DPOVRD, MATH3, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, LSHIFT, VSEQINSZ, MATH3, SIZE(2), 0);
	MATHB(SEQOUTSZ, LSHIFT, VSEQOUTSZ, MATH3, SIZE(8), WITH(NFU));
	MATHB(SEQOUTSZ, LSHIFT, ABD, MATH3, SIZE(8), 0);
	MATHB(SEQOUTSZ, LSHIFT, OFIFO, MATH3, SIZE(4), 0);
	MATHB(SEQOUTSZ, LSHIFT, ONE, MATH3, SIZE(4), 0);
	MATHB(SEQOUTSZ, LSHIFT, ZERO, MATH3, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, LSHIFT, MATH0, MATH3, SIZE(4), 0);
	MATHB(VSEQINSZ, LSHIFT, MATH1, MATH3, SIZE(4), 0);
	MATHB(VSEQINSZ, LSHIFT, MATH2, MATH3, SIZE(4), WITH(STL));
	MATHB(VSEQINSZ, LSHIFT, MATH3, MATH3, SIZE(1), 0);
	MATHB(VSEQINSZ, LSHIFT, IMM(393615378), MATH3, SIZE(1), 0);
	MATHB(VSEQINSZ, LSHIFT, DPOVRD, MATH3, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, LSHIFT, VSEQINSZ, MATH3, SIZE(8), 0);
	MATHB(VSEQINSZ, LSHIFT, VSEQOUTSZ, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, LSHIFT, ABD, MATH3, SIZE(4), 0);
	MATHB(VSEQINSZ, LSHIFT, OFIFO, MATH3, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, LSHIFT, ONE, MATH3, SIZE(2), 0);
	MATHB(VSEQINSZ, LSHIFT, ZERO, MATH3, SIZE(1), 0);
	MATHB(VSEQOUTSZ, LSHIFT, MATH0, MATH3, SIZE(8), 0);
	MATHB(VSEQOUTSZ, LSHIFT, MATH1, MATH3, SIZE(8), 0);
	MATHB(VSEQOUTSZ, LSHIFT, MATH2, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, LSHIFT, MATH3, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, LSHIFT, IMM(0x19261959fedcba01), MATH3, SIZE(8), 0);
	MATHB(VSEQOUTSZ, LSHIFT, DPOVRD, MATH3, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, LSHIFT, VSEQINSZ, MATH3, SIZE(4), 0);
	MATHB(VSEQOUTSZ, LSHIFT, VSEQOUTSZ, MATH3, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, LSHIFT, ABD, MATH3, SIZE(1), 0);
	MATHB(VSEQOUTSZ, LSHIFT, OFIFO, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, LSHIFT, ONE, MATH3, SIZE(4), 0);
	MATHB(VSEQOUTSZ, LSHIFT, ZERO, MATH3, SIZE(1), WITH(STL));
	MATHB(ZERO, LSHIFT, MATH0, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, LSHIFT, MATH1, MATH3, SIZE(8), 0);
	MATHB(ZERO, LSHIFT, MATH2, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, LSHIFT, MATH3, MATH3, SIZE(8), 0);
	MATHB(ZERO, LSHIFT, IMM(393615378), MATH3, SIZE(4), 0);
	MATHB(ZERO, LSHIFT, DPOVRD, MATH3, SIZE(1), WITH(NFU));
	MATHB(ZERO, LSHIFT, VSEQINSZ, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, LSHIFT, VSEQOUTSZ, MATH3, SIZE(2), WITH(NFU));
	MATHB(ZERO, LSHIFT, ABD, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, LSHIFT, OFIFO, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, LSHIFT, ONE, MATH3, SIZE(8), 0);
	MATHB(ZERO, LSHIFT, ZERO, MATH3, SIZE(8), 0);
	MATHB(ONE, LSHIFT, MATH0, MATH3, SIZE(1), 0);
	MATHB(ONE, LSHIFT, MATH1, MATH3, SIZE(2), 0);
	MATHB(ONE, LSHIFT, MATH2, MATH3, SIZE(1), 0);
	MATHB(ONE, LSHIFT, MATH3, MATH3, SIZE(2), WITH(NFU));
	MATHB(ONE, LSHIFT, IMM(393615378), MATH3, SIZE(1), WITH(STL));
	MATHB(ONE, LSHIFT, DPOVRD, MATH3, SIZE(2), 0);
	MATHB(ONE, LSHIFT, VSEQINSZ, MATH3, SIZE(1), 0);
	MATHB(ONE, LSHIFT, VSEQOUTSZ, MATH3, SIZE(8), 0);
	MATHB(ONE, LSHIFT, ABD, MATH3, SIZE(4), WITH(NFU));
	MATHB(ONE, LSHIFT, OFIFO, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, LSHIFT, ONE, MATH3, SIZE(8), 0);
	MATHB(ONE, LSHIFT, ZERO, MATH3, SIZE(4), WITH(NFU | STL));
	/*LSHIFT Operation: DPOVRD Destination register */
	MATHB(MATH0, LSHIFT, MATH0, DPOVRD, SIZE(8), WITH(STL));
	MATHB(MATH0, LSHIFT, MATH1, DPOVRD, SIZE(4), 0);
	MATHB(MATH0, LSHIFT, MATH2, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(MATH0, LSHIFT, MATH3, DPOVRD, SIZE(4), WITH(STL));
	MATHB(MATH0, LSHIFT, IMM(393615378), DPOVRD, SIZE(1), WITH(STL));
	MATHB(MATH0, LSHIFT, DPOVRD, DPOVRD, SIZE(2), 0);
	MATHB(MATH0, LSHIFT, VSEQINSZ, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, LSHIFT, VSEQOUTSZ, DPOVRD, SIZE(1), WITH(STL));
	MATHB(MATH0, LSHIFT, ABD, DPOVRD, SIZE(2), 0);
	MATHB(MATH0, LSHIFT, OFIFO, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(MATH0, LSHIFT, ONE, DPOVRD, SIZE(4), 0);
	MATHB(MATH0, LSHIFT, ZERO, DPOVRD, SIZE(4), 0);
	MATHB(MATH1, LSHIFT, MATH0, DPOVRD, SIZE(1), WITH(STL));
	MATHB(MATH1, LSHIFT, MATH1, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(MATH1, LSHIFT, MATH2, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(MATH1, LSHIFT, MATH3, DPOVRD, SIZE(2), 0);
	MATHB(MATH1, LSHIFT, IMM(393615378), DPOVRD, SIZE(2), WITH(STL));
	MATHB(MATH1, LSHIFT, DPOVRD, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(MATH1, LSHIFT, VSEQINSZ, DPOVRD, SIZE(8), 0);
	MATHB(MATH1, LSHIFT, VSEQOUTSZ, DPOVRD, SIZE(1), 0);
	MATHB(MATH1, LSHIFT, ABD, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(MATH1, LSHIFT, OFIFO, DPOVRD, SIZE(4), 0);
	MATHB(MATH1, LSHIFT, ONE, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(MATH1, LSHIFT, ZERO, DPOVRD, SIZE(4), 0);
	MATHB(MATH2, LSHIFT, MATH0, DPOVRD, SIZE(1), 0);
	MATHB(MATH2, LSHIFT, MATH1, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(MATH2, LSHIFT, MATH2, DPOVRD, SIZE(8), 0);
	MATHB(MATH2, LSHIFT, MATH3, DPOVRD, SIZE(2), WITH(STL));
	MATHB(MATH2, LSHIFT, IMM(393615378), DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, LSHIFT, DPOVRD, DPOVRD, SIZE(1), 0);
	MATHB(MATH2, LSHIFT, VSEQINSZ, DPOVRD, SIZE(4), 0);
	MATHB(MATH2, LSHIFT, VSEQOUTSZ, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, LSHIFT, ABD, DPOVRD, SIZE(8), 0);
	MATHB(MATH2, LSHIFT, OFIFO, DPOVRD, SIZE(1), 0);
	MATHB(MATH2, LSHIFT, ONE, DPOVRD, SIZE(1), 0);
	MATHB(MATH2, LSHIFT, ZERO, DPOVRD, SIZE(2), 0);
	MATHB(MATH3, LSHIFT, MATH0, DPOVRD, SIZE(1), 0);
	MATHB(MATH3, LSHIFT, MATH1, DPOVRD, SIZE(1), 0);
	MATHB(MATH3, LSHIFT, MATH2, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, LSHIFT, MATH3, DPOVRD, SIZE(1), WITH(STL));
	MATHB(MATH3, LSHIFT, IMM(393615378), DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, LSHIFT, DPOVRD, DPOVRD, SIZE(8), WITH(STL));
	MATHB(MATH3, LSHIFT, VSEQINSZ, DPOVRD, SIZE(4), 0);
	MATHB(MATH3, LSHIFT, VSEQOUTSZ, DPOVRD, SIZE(2), 0);
	MATHB(MATH3, LSHIFT, ABD, DPOVRD, SIZE(2), 0);
	MATHB(MATH3, LSHIFT, OFIFO, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, LSHIFT, ONE, DPOVRD, SIZE(2), 0);
	MATHB(MATH3, LSHIFT, ZERO, DPOVRD, SIZE(8), 0);
	MATHB(IMM(275128321), LSHIFT, MATH0, DPOVRD, SIZE(2), 0);
	MATHB(IMM(275128321), LSHIFT, MATH1, DPOVRD, SIZE(4), 0);
	MATHB(IMM(275128321), LSHIFT, MATH2, DPOVRD, SIZE(1), 0);
	MATHB(IMM(275128321), LSHIFT, MATH3, DPOVRD, SIZE(4), 0);
	MATHB(IMM(275128321), LSHIFT, IMM(393615378), DPOVRD, SIZE(2), 0);
	MATHB(IMM(275128321), LSHIFT, DPOVRD, DPOVRD, SIZE(4), 0);
	MATHB(IMM(275128321), LSHIFT, VSEQINSZ, DPOVRD, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), LSHIFT, VSEQOUTSZ, DPOVRD, SIZE(4), 0);
	MATHB(IMM(0x19261959fedcba01), LSHIFT, ABD, DPOVRD, SIZE(8), WITH(STL));
	MATHB(IMM(0x19261959fedcba01), LSHIFT, OFIFO, DPOVRD, SIZE(8), 0);
	MATHB(IMM(275128321), LSHIFT, ONE, DPOVRD, SIZE(2), 0);
	MATHB(IMM(275128321), LSHIFT, ZERO, DPOVRD, SIZE(2), WITH(STL));
	MATHB(DPOVRD, LSHIFT, MATH0, DPOVRD, SIZE(2), 0);
	MATHB(DPOVRD, LSHIFT, MATH1, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, LSHIFT, MATH2, DPOVRD, SIZE(2), 0);
	MATHB(DPOVRD, LSHIFT, MATH3, DPOVRD, SIZE(4), 0);
	MATHB(DPOVRD, LSHIFT, IMM(393615378), DPOVRD, SIZE(4), 0);
	MATHB(DPOVRD, LSHIFT, DPOVRD, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, LSHIFT, VSEQINSZ, DPOVRD, SIZE(4), 0);
	MATHB(DPOVRD, LSHIFT, VSEQOUTSZ, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(DPOVRD, LSHIFT, ABD, DPOVRD, SIZE(2), WITH(STL));
	MATHB(DPOVRD, LSHIFT, OFIFO, DPOVRD, SIZE(8), 0);
	MATHB(DPOVRD, LSHIFT, ONE, DPOVRD, SIZE(1), 0);
	MATHB(DPOVRD, LSHIFT, ZERO, DPOVRD, SIZE(1), 0);
	MATHB(SEQINSZ, LSHIFT, MATH0, DPOVRD, SIZE(2), 0);
	MATHB(SEQINSZ, LSHIFT, MATH1, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(SEQINSZ, LSHIFT, MATH2, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, LSHIFT, MATH3, DPOVRD, SIZE(1), 0);
	MATHB(SEQINSZ, LSHIFT, IMM(393615378), DPOVRD, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, LSHIFT, DPOVRD, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, LSHIFT, VSEQINSZ, DPOVRD, SIZE(4), 0);
	MATHB(SEQINSZ, LSHIFT, VSEQOUTSZ, DPOVRD, SIZE(4), 0);
	MATHB(SEQINSZ, LSHIFT, ABD, DPOVRD, SIZE(1), 0);
	MATHB(SEQINSZ, LSHIFT, OFIFO, DPOVRD, SIZE(2), 0);
	MATHB(SEQINSZ, LSHIFT, ONE, DPOVRD, SIZE(4), 0);
	MATHB(SEQINSZ, LSHIFT, ZERO, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, LSHIFT, MATH0, DPOVRD, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, LSHIFT, MATH1, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, LSHIFT, MATH2, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(SEQOUTSZ, LSHIFT, MATH3, DPOVRD, SIZE(8), 0);
	MATHB(SEQOUTSZ, LSHIFT, IMM(393615378), DPOVRD, SIZE(4),
	      WITH(NFU | STL));
	MATHB(SEQOUTSZ, LSHIFT, DPOVRD, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, LSHIFT, VSEQINSZ, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, LSHIFT, VSEQOUTSZ, DPOVRD, SIZE(2), 0);
	MATHB(SEQOUTSZ, LSHIFT, ABD, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, LSHIFT, OFIFO, DPOVRD, SIZE(2), 0);
	MATHB(SEQOUTSZ, LSHIFT, ONE, DPOVRD, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, LSHIFT, ZERO, DPOVRD, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, LSHIFT, MATH0, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, LSHIFT, MATH1, DPOVRD, SIZE(2), 0);
	MATHB(VSEQINSZ, LSHIFT, MATH2, DPOVRD, SIZE(1), 0);
	MATHB(VSEQINSZ, LSHIFT, MATH3, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, LSHIFT, IMM(393615378), DPOVRD, SIZE(2),
	      WITH(NFU | STL));
	MATHB(VSEQINSZ, LSHIFT, DPOVRD, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, LSHIFT, VSEQINSZ, DPOVRD, SIZE(1), 0);
	MATHB(VSEQINSZ, LSHIFT, VSEQOUTSZ, DPOVRD, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, LSHIFT, ABD, DPOVRD, SIZE(4), 0);
	MATHB(VSEQINSZ, LSHIFT, OFIFO, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, LSHIFT, ONE, DPOVRD, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, LSHIFT, ZERO, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, LSHIFT, MATH0, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, LSHIFT, MATH1, DPOVRD, SIZE(2), 0);
	MATHB(VSEQOUTSZ, LSHIFT, MATH2, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, LSHIFT, MATH3, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, LSHIFT, IMM(393615378), DPOVRD, SIZE(2), 0);
	MATHB(VSEQOUTSZ, LSHIFT, DPOVRD, DPOVRD, SIZE(2), 0);
	MATHB(VSEQOUTSZ, LSHIFT, VSEQINSZ, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, LSHIFT, VSEQOUTSZ, DPOVRD, SIZE(1), 0);
	MATHB(VSEQOUTSZ, LSHIFT, ABD, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, LSHIFT, OFIFO, DPOVRD, SIZE(4), 0);
	MATHB(VSEQOUTSZ, LSHIFT, ONE, DPOVRD, SIZE(1), 0);
	MATHB(VSEQOUTSZ, LSHIFT, ZERO, DPOVRD, SIZE(2), 0);
	MATHB(ZERO, LSHIFT, MATH0, DPOVRD, SIZE(8), 0);
	MATHB(ZERO, LSHIFT, MATH1, DPOVRD, SIZE(2), 0);
	MATHB(ZERO, LSHIFT, MATH2, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, LSHIFT, MATH3, DPOVRD, SIZE(4), 0);
	MATHB(ZERO, LSHIFT, IMM(393615378), DPOVRD, SIZE(4), 0);
	MATHB(ZERO, LSHIFT, DPOVRD, DPOVRD, SIZE(4), 0);
	MATHB(ZERO, LSHIFT, VSEQINSZ, DPOVRD, SIZE(4), 0);
	MATHB(ZERO, LSHIFT, VSEQOUTSZ, DPOVRD, SIZE(2), 0);
	MATHB(ZERO, LSHIFT, ABD, DPOVRD, SIZE(8), 0);
	MATHB(ZERO, LSHIFT, OFIFO, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, LSHIFT, ONE, DPOVRD, SIZE(8), 0);
	MATHB(ZERO, LSHIFT, ZERO, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, LSHIFT, MATH0, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, LSHIFT, MATH1, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, LSHIFT, MATH2, DPOVRD, SIZE(8), 0);
	MATHB(ONE, LSHIFT, MATH3, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, LSHIFT, IMM(393615378), DPOVRD, SIZE(2), 0);
	MATHB(ONE, LSHIFT, DPOVRD, DPOVRD, SIZE(1), WITH(STL));
	MATHB(ONE, LSHIFT, VSEQINSZ, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(ONE, LSHIFT, VSEQOUTSZ, DPOVRD, SIZE(8), 0);
	MATHB(ONE, LSHIFT, ABD, DPOVRD, SIZE(4), 0);
	MATHB(ONE, LSHIFT, OFIFO, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, LSHIFT, ONE, DPOVRD, SIZE(4), 0);
	MATHB(ONE, LSHIFT, ZERO, DPOVRD, SIZE(4), 0);
	/*LSHIFT Operation: SEQINSZ Destination register */
	MATHB(MATH0, LSHIFT, MATH0, SEQINSZ, SIZE(2), 0);
	MATHB(MATH0, LSHIFT, MATH1, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(MATH0, LSHIFT, MATH2, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH0, LSHIFT, MATH3, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH0, LSHIFT, IMM(393615378), SEQINSZ, SIZE(2), 0);
	MATHB(MATH0, LSHIFT, DPOVRD, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(MATH0, LSHIFT, VSEQINSZ, SEQINSZ, SIZE(8), 0);
	MATHB(MATH0, LSHIFT, VSEQOUTSZ, SEQINSZ, SIZE(2), 0);
	MATHB(MATH0, LSHIFT, ABD, SEQINSZ, SIZE(2), 0);
	MATHB(MATH0, LSHIFT, OFIFO, SEQINSZ, SIZE(8), 0);
	MATHB(MATH0, LSHIFT, ONE, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH0, LSHIFT, ZERO, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH1, LSHIFT, MATH0, SEQINSZ, SIZE(8), 0);
	MATHB(MATH1, LSHIFT, MATH1, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH1, LSHIFT, MATH2, SEQINSZ, SIZE(1), 0);
	MATHB(MATH1, LSHIFT, MATH3, SEQINSZ, SIZE(2), 0);
	MATHB(MATH1, LSHIFT, IMM(393615378), SEQINSZ, SIZE(1), 0);
	MATHB(MATH1, LSHIFT, DPOVRD, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(MATH1, LSHIFT, VSEQINSZ, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(MATH1, LSHIFT, VSEQOUTSZ, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH1, LSHIFT, ABD, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(MATH1, LSHIFT, OFIFO, SEQINSZ, SIZE(4), 0);
	MATHB(MATH1, LSHIFT, ONE, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(MATH1, LSHIFT, ZERO, SEQINSZ, SIZE(1), 0);
	MATHB(MATH2, LSHIFT, MATH0, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, LSHIFT, MATH1, SEQINSZ, SIZE(4), 0);
	MATHB(MATH2, LSHIFT, MATH2, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH2, LSHIFT, MATH3, SEQINSZ, SIZE(2), 0);
	MATHB(MATH2, LSHIFT, IMM(393615378), SEQINSZ, SIZE(4), 0);
	MATHB(MATH2, LSHIFT, DPOVRD, SEQINSZ, SIZE(1), 0);
	MATHB(MATH2, LSHIFT, VSEQINSZ, SEQINSZ, SIZE(2), 0);
	MATHB(MATH2, LSHIFT, VSEQOUTSZ, SEQINSZ, SIZE(8), 0);
	MATHB(MATH2, LSHIFT, ABD, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, LSHIFT, OFIFO, SEQINSZ, SIZE(8), 0);
	MATHB(MATH2, LSHIFT, ONE, SEQINSZ, SIZE(1), 0);
	MATHB(MATH2, LSHIFT, ZERO, SEQINSZ, SIZE(4), 0);
	MATHB(MATH3, LSHIFT, MATH0, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(MATH3, LSHIFT, MATH1, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH3, LSHIFT, MATH2, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH3, LSHIFT, MATH3, SEQINSZ, SIZE(1), 0);
	MATHB(MATH3, LSHIFT, IMM(393615378), SEQINSZ, SIZE(1), 0);
	MATHB(MATH3, LSHIFT, DPOVRD, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(MATH3, LSHIFT, VSEQINSZ, SEQINSZ, SIZE(2), 0);
	MATHB(MATH3, LSHIFT, VSEQOUTSZ, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH3, LSHIFT, ABD, SEQINSZ, SIZE(2), 0);
	MATHB(MATH3, LSHIFT, OFIFO, SEQINSZ, SIZE(2), 0);
	MATHB(MATH3, LSHIFT, ONE, SEQINSZ, SIZE(1), 0);
	MATHB(MATH3, LSHIFT, ZERO, SEQINSZ, SIZE(8), 0);
	MATHB(IMM(275128321), LSHIFT, MATH0, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(275128321), LSHIFT, MATH1, SEQINSZ, SIZE(2), 0);
	MATHB(IMM(0x19261959fedcba01), LSHIFT, MATH2, SEQINSZ, SIZE(8), 0);
	MATHB(IMM(275128321), LSHIFT, MATH3, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), LSHIFT, IMM(393615378), SEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), LSHIFT, DPOVRD, SEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), LSHIFT, VSEQINSZ, SEQINSZ, SIZE(2), 0);
	MATHB(IMM(0x19261959fedcba01), LSHIFT, VSEQOUTSZ, SEQINSZ, SIZE(8), 0);
	MATHB(IMM(275128321), LSHIFT, ABD, SEQINSZ, SIZE(4), 0);
	MATHB(IMM(0x19261959fedcba01), LSHIFT, OFIFO, SEQINSZ, SIZE(8), 0);
	MATHB(IMM(275128321), LSHIFT, ONE, SEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), LSHIFT, ZERO, SEQINSZ, SIZE(4), 0);
	MATHB(DPOVRD, LSHIFT, MATH0, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(DPOVRD, LSHIFT, MATH1, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(DPOVRD, LSHIFT, MATH2, SEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, LSHIFT, MATH3, SEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, LSHIFT, IMM(393615378), SEQINSZ, SIZE(2),
	      WITH(NFU | STL));
	MATHB(DPOVRD, LSHIFT, DPOVRD, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(DPOVRD, LSHIFT, VSEQINSZ, SEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, LSHIFT, VSEQOUTSZ, SEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, LSHIFT, ABD, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, LSHIFT, OFIFO, SEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, LSHIFT, ONE, SEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, LSHIFT, ZERO, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, LSHIFT, MATH0, SEQINSZ, SIZE(1), 0);
	MATHB(SEQINSZ, LSHIFT, MATH1, SEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, LSHIFT, MATH2, SEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, LSHIFT, MATH3, SEQINSZ, SIZE(4), 0);
	MATHB(SEQINSZ, LSHIFT, IMM(393615378), SEQINSZ, SIZE(4), 0);
	MATHB(SEQINSZ, LSHIFT, DPOVRD, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, LSHIFT, VSEQINSZ, SEQINSZ, SIZE(1), 0);
	MATHB(SEQINSZ, LSHIFT, VSEQOUTSZ, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, LSHIFT, ABD, SEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, LSHIFT, OFIFO, SEQINSZ, SIZE(1), 0);
	MATHB(SEQINSZ, LSHIFT, ONE, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, LSHIFT, ZERO, SEQINSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, LSHIFT, MATH0, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, LSHIFT, MATH1, SEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, LSHIFT, MATH2, SEQINSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, LSHIFT, MATH3, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, LSHIFT, IMM(393615378), SEQINSZ, SIZE(8),
	      WITH(IFB | STL));
	MATHB(SEQOUTSZ, LSHIFT, DPOVRD, SEQINSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, LSHIFT, VSEQINSZ, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, LSHIFT, VSEQOUTSZ, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, LSHIFT, ABD, SEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, LSHIFT, OFIFO, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, LSHIFT, ONE, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, LSHIFT, ZERO, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, LSHIFT, MATH0, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, LSHIFT, MATH1, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, LSHIFT, MATH2, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, LSHIFT, MATH3, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, LSHIFT, IMM(393615378), SEQINSZ, SIZE(2),
	      WITH(NFU | STL));
	MATHB(VSEQINSZ, LSHIFT, DPOVRD, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, LSHIFT, VSEQINSZ, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, LSHIFT, VSEQOUTSZ, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, LSHIFT, ABD, SEQINSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, LSHIFT, OFIFO, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, LSHIFT, ONE, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, LSHIFT, ZERO, SEQINSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, LSHIFT, MATH0, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, LSHIFT, MATH1, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, LSHIFT, MATH2, SEQINSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, LSHIFT, MATH3, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, LSHIFT, IMM(393615378), SEQINSZ, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, LSHIFT, DPOVRD, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, LSHIFT, VSEQINSZ, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, LSHIFT, VSEQOUTSZ, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, LSHIFT, ABD, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, LSHIFT, OFIFO, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, LSHIFT, ONE, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, LSHIFT, ZERO, SEQINSZ, SIZE(4), 0);
	MATHB(ZERO, LSHIFT, MATH0, SEQINSZ, SIZE(4), 0);
	MATHB(ZERO, LSHIFT, MATH1, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, LSHIFT, MATH2, SEQINSZ, SIZE(2), 0);
	MATHB(ZERO, LSHIFT, MATH3, SEQINSZ, SIZE(4), 0);
	MATHB(ZERO, LSHIFT, IMM(0x19261959fedcba01), SEQINSZ, SIZE(8), 0);
	MATHB(ZERO, LSHIFT, DPOVRD, SEQINSZ, SIZE(2), 0);
	MATHB(ZERO, LSHIFT, VSEQINSZ, SEQINSZ, SIZE(8), 0);
	MATHB(ZERO, LSHIFT, VSEQOUTSZ, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(ZERO, LSHIFT, ABD, SEQINSZ, SIZE(4), 0);
	MATHB(ZERO, LSHIFT, OFIFO, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, LSHIFT, ONE, SEQINSZ, SIZE(1), 0);
	MATHB(ZERO, LSHIFT, ZERO, SEQINSZ, SIZE(2), 0);
	MATHB(ONE, LSHIFT, MATH0, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(ONE, LSHIFT, MATH1, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(ONE, LSHIFT, MATH2, SEQINSZ, SIZE(4), 0);
	MATHB(ONE, LSHIFT, MATH3, SEQINSZ, SIZE(2), 0);
	MATHB(ONE, LSHIFT, IMM(393615378), SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(ONE, LSHIFT, DPOVRD, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(ONE, LSHIFT, VSEQINSZ, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, LSHIFT, VSEQOUTSZ, SEQINSZ, SIZE(4), 0);
	MATHB(ONE, LSHIFT, ABD, SEQINSZ, SIZE(1), 0);
	MATHB(ONE, LSHIFT, OFIFO, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(ONE, LSHIFT, ONE, SEQINSZ, SIZE(1), 0);
	MATHB(ONE, LSHIFT, ZERO, SEQINSZ, SIZE(8), 0);
	/*LSHIFT Operation: SEQOUTSZ Destination register */
	MATHB(MATH0, LSHIFT, MATH0, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH0, LSHIFT, MATH1, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, LSHIFT, MATH2, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH0, LSHIFT, MATH3, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, LSHIFT, IMM(0x19261959fedcba01), SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH0, LSHIFT, DPOVRD, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, LSHIFT, VSEQINSZ, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH0, LSHIFT, VSEQOUTSZ, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH0, LSHIFT, ABD, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH0, LSHIFT, OFIFO, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, LSHIFT, ONE, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH0, LSHIFT, ZERO, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH1, LSHIFT, MATH0, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH1, LSHIFT, MATH1, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(MATH1, LSHIFT, MATH2, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(MATH1, LSHIFT, MATH3, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, LSHIFT, IMM(393615378), SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH1, LSHIFT, DPOVRD, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, LSHIFT, VSEQINSZ, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(MATH1, LSHIFT, VSEQOUTSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH1, LSHIFT, ABD, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH1, LSHIFT, OFIFO, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(MATH1, LSHIFT, ONE, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH1, LSHIFT, ZERO, SEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(MATH2, LSHIFT, MATH0, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, LSHIFT, MATH1, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, LSHIFT, MATH2, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, LSHIFT, MATH3, SEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(MATH2, LSHIFT, IMM(393615378), SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH2, LSHIFT, DPOVRD, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, LSHIFT, VSEQINSZ, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH2, LSHIFT, VSEQOUTSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, LSHIFT, ABD, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH2, LSHIFT, OFIFO, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, LSHIFT, ONE, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, LSHIFT, ZERO, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, LSHIFT, MATH0, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, LSHIFT, MATH1, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(MATH3, LSHIFT, MATH2, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, LSHIFT, MATH3, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, LSHIFT, IMM(393615378), SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH3, LSHIFT, DPOVRD, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH3, LSHIFT, VSEQINSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH3, LSHIFT, VSEQOUTSZ, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, LSHIFT, ABD, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH3, LSHIFT, OFIFO, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH3, LSHIFT, ONE, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH3, LSHIFT, ZERO, SEQOUTSZ, SIZE(1), 0);
	MATHB(IMM(275128321), LSHIFT, MATH0, SEQOUTSZ, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), LSHIFT, MATH1, SEQOUTSZ, SIZE(1), 0);
	MATHB(IMM(275128321), LSHIFT, MATH2, SEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(0x19261959fedcba01), LSHIFT, MATH3, SEQOUTSZ, SIZE(8),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), LSHIFT, IMM(393615378), SEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), LSHIFT, DPOVRD, SEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(275128321), LSHIFT, VSEQINSZ, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), LSHIFT, VSEQOUTSZ, SEQOUTSZ, SIZE(2),
	      WITH(NFU | STL));
	MATHB(IMM(0x19261959fedcba01), LSHIFT, ABD, SEQOUTSZ, SIZE(8),
	      WITH(NFU | STL));
	MATHB(IMM(0x19261959fedcba01), LSHIFT, OFIFO, SEQOUTSZ, SIZE(8), 0);
	MATHB(IMM(275128321), LSHIFT, ONE, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), LSHIFT, ZERO, SEQOUTSZ, SIZE(4), 0);
	MATHB(DPOVRD, LSHIFT, MATH0, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, LSHIFT, MATH1, SEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, LSHIFT, MATH2, SEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, LSHIFT, MATH3, SEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, LSHIFT, IMM(393615378), SEQOUTSZ, SIZE(8),
	      WITH(IFB | NFU));
	MATHB(DPOVRD, LSHIFT, DPOVRD, SEQOUTSZ, SIZE(4), 0);
	MATHB(DPOVRD, LSHIFT, VSEQINSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, LSHIFT, VSEQOUTSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, LSHIFT, ABD, SEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(DPOVRD, LSHIFT, OFIFO, SEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, LSHIFT, ONE, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, LSHIFT, ZERO, SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQINSZ, LSHIFT, MATH0, SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQINSZ, LSHIFT, MATH1, SEQOUTSZ, SIZE(8), 0);
	MATHB(SEQINSZ, LSHIFT, MATH2, SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQINSZ, LSHIFT, MATH3, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, LSHIFT, IMM(393615378), SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, LSHIFT, DPOVRD, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, LSHIFT, VSEQINSZ, SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, LSHIFT, VSEQOUTSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQINSZ, LSHIFT, ABD, SEQOUTSZ, SIZE(4), 0);
	MATHB(SEQINSZ, LSHIFT, OFIFO, SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, LSHIFT, ONE, SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQINSZ, LSHIFT, ZERO, SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, LSHIFT, MATH0, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, LSHIFT, MATH1, SEQOUTSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, LSHIFT, MATH2, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, LSHIFT, MATH3, SEQOUTSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, LSHIFT, IMM(0x19261959fedcba01), SEQOUTSZ, SIZE(8),
	      WITH(NFU | STL));
	MATHB(SEQOUTSZ, LSHIFT, DPOVRD, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, LSHIFT, VSEQINSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, LSHIFT, VSEQOUTSZ, SEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, LSHIFT, ABD, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, LSHIFT, OFIFO, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, LSHIFT, ONE, SEQOUTSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, LSHIFT, ZERO, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, LSHIFT, MATH0, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, LSHIFT, MATH1, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQINSZ, LSHIFT, MATH2, SEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, LSHIFT, MATH3, SEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, LSHIFT, IMM(393615378), SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, LSHIFT, DPOVRD, SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, LSHIFT, VSEQINSZ, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQINSZ, LSHIFT, VSEQOUTSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, LSHIFT, ABD, SEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, LSHIFT, OFIFO, SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, LSHIFT, ONE, SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, LSHIFT, ZERO, SEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, LSHIFT, MATH0, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, LSHIFT, MATH1, SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, LSHIFT, MATH2, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, LSHIFT, MATH3, SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, LSHIFT, IMM(393615378), SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, LSHIFT, DPOVRD, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, LSHIFT, VSEQINSZ, SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, LSHIFT, VSEQOUTSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, LSHIFT, ABD, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, LSHIFT, OFIFO, SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, LSHIFT, ONE, SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, LSHIFT, ZERO, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, LSHIFT, MATH0, SEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, LSHIFT, MATH1, SEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, LSHIFT, MATH2, SEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, LSHIFT, MATH3, SEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, LSHIFT, IMM(393615378), SEQOUTSZ, SIZE(8),
	      WITH(IFB | NFU | STL));
	MATHB(ZERO, LSHIFT, DPOVRD, SEQOUTSZ, SIZE(4), 0);
	MATHB(ZERO, LSHIFT, VSEQINSZ, SEQOUTSZ, SIZE(4), 0);
	MATHB(ZERO, LSHIFT, VSEQOUTSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(ZERO, LSHIFT, ABD, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(ZERO, LSHIFT, OFIFO, SEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, LSHIFT, ONE, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(ZERO, LSHIFT, ZERO, SEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, LSHIFT, MATH0, SEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, LSHIFT, MATH1, SEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, LSHIFT, MATH2, SEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, LSHIFT, MATH3, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(ONE, LSHIFT, IMM(393615378), SEQOUTSZ, SIZE(8), WITH(IFB));
	MATHB(ONE, LSHIFT, DPOVRD, SEQOUTSZ, SIZE(8), 0);
	MATHB(ONE, LSHIFT, VSEQINSZ, SEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, LSHIFT, VSEQOUTSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(ONE, LSHIFT, ABD, SEQOUTSZ, SIZE(8), 0);
	MATHB(ONE, LSHIFT, OFIFO, SEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, LSHIFT, ONE, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(ONE, LSHIFT, ZERO, SEQOUTSZ, SIZE(2), 0);
	/* LSHIFT Operation: VSEQINSZ Destination register */
	MATHB(MATH0, LSHIFT, MATH0, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH0, LSHIFT, MATH1, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(MATH0, LSHIFT, MATH2, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(MATH0, LSHIFT, MATH3, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH0, LSHIFT, IMM(393615378), VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH0, LSHIFT, DPOVRD, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH0, LSHIFT, VSEQINSZ, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH0, LSHIFT, VSEQOUTSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH0, LSHIFT, ABD, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH0, LSHIFT, OFIFO, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH0, LSHIFT, ONE, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH0, LSHIFT, ZERO, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH1, LSHIFT, MATH0, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH1, LSHIFT, MATH1, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH1, LSHIFT, MATH2, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(MATH1, LSHIFT, MATH3, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH1, LSHIFT, IMM(393615378), VSEQINSZ, SIZE(4), 0);
	MATHB(MATH1, LSHIFT, DPOVRD, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH1, LSHIFT, VSEQINSZ, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH1, LSHIFT, VSEQOUTSZ, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH1, LSHIFT, ABD, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH1, LSHIFT, OFIFO, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH1, LSHIFT, ONE, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH1, LSHIFT, ZERO, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH2, LSHIFT, MATH0, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH2, LSHIFT, MATH1, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH2, LSHIFT, MATH2, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH2, LSHIFT, MATH3, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, LSHIFT, IMM(393615378), VSEQINSZ, SIZE(2), 0);
	MATHB(MATH2, LSHIFT, DPOVRD, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH2, LSHIFT, VSEQINSZ, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, LSHIFT, VSEQOUTSZ, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH2, LSHIFT, ABD, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(MATH2, LSHIFT, OFIFO, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH2, LSHIFT, ONE, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH2, LSHIFT, ZERO, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH3, LSHIFT, MATH0, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH3, LSHIFT, MATH1, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH3, LSHIFT, MATH2, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH3, LSHIFT, MATH3, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH3, LSHIFT, IMM(393615378), VSEQINSZ, SIZE(8), WITH(IFB));
	MATHB(MATH3, LSHIFT, DPOVRD, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH3, LSHIFT, VSEQINSZ, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH3, LSHIFT, VSEQOUTSZ, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH3, LSHIFT, ABD, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH3, LSHIFT, OFIFO, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(MATH3, LSHIFT, ONE, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, LSHIFT, ZERO, VSEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), LSHIFT, MATH0, VSEQINSZ, SIZE(8),
	      WITH(IFB | NFU | STL));
	MATHB(IMM(275128321), LSHIFT, MATH1, VSEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), LSHIFT, MATH2, VSEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), LSHIFT, MATH3, VSEQINSZ, SIZE(2),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), LSHIFT, IMM(393615378), VSEQINSZ, SIZE(4),
	      WITH(STL));
	MATHB(IMM(275128321), LSHIFT, DPOVRD, VSEQINSZ, SIZE(4),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), LSHIFT, VSEQINSZ, VSEQINSZ, SIZE(4), 0);
	MATHB(IMM(0x19261959fedcba01), LSHIFT, VSEQOUTSZ, VSEQINSZ, SIZE(8), 0);
	MATHB(IMM(275128321), LSHIFT, ABD, VSEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), LSHIFT, OFIFO, VSEQINSZ, SIZE(4), 0);
	MATHB(IMM(275128321), LSHIFT, ONE, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), LSHIFT, ZERO, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(DPOVRD, LSHIFT, MATH0, VSEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, LSHIFT, MATH1, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, LSHIFT, MATH2, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(DPOVRD, LSHIFT, MATH3, VSEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, LSHIFT, IMM(393615378), VSEQINSZ, SIZE(8), WITH(IFB));
	MATHB(DPOVRD, LSHIFT, DPOVRD, VSEQINSZ, SIZE(1), 0);
	MATHB(DPOVRD, LSHIFT, VSEQINSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(DPOVRD, LSHIFT, VSEQOUTSZ, VSEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, LSHIFT, ABD, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(DPOVRD, LSHIFT, OFIFO, VSEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, LSHIFT, ONE, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, LSHIFT, ZERO, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, LSHIFT, MATH0, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, LSHIFT, MATH1, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, LSHIFT, MATH2, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, LSHIFT, MATH3, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQINSZ, LSHIFT, IMM(393615378), VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, LSHIFT, DPOVRD, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, LSHIFT, VSEQINSZ, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, LSHIFT, VSEQOUTSZ, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(SEQINSZ, LSHIFT, ABD, VSEQINSZ, SIZE(1), 0);
	MATHB(SEQINSZ, LSHIFT, OFIFO, VSEQINSZ, SIZE(1), 0);
	MATHB(SEQINSZ, LSHIFT, ONE, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, LSHIFT, ZERO, VSEQINSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, LSHIFT, MATH0, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, LSHIFT, MATH1, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, LSHIFT, MATH2, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, LSHIFT, MATH3, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(SEQOUTSZ, LSHIFT, IMM(0x19261959fedcba01), VSEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, LSHIFT, DPOVRD, VSEQINSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, LSHIFT, VSEQINSZ, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, LSHIFT, VSEQOUTSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, LSHIFT, ABD, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, LSHIFT, OFIFO, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, LSHIFT, ONE, VSEQINSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, LSHIFT, ZERO, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, LSHIFT, MATH0, VSEQINSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, LSHIFT, MATH1, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, LSHIFT, MATH2, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, LSHIFT, MATH3, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, LSHIFT, IMM(393615378), VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, LSHIFT, DPOVRD, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, LSHIFT, VSEQINSZ, VSEQINSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, LSHIFT, VSEQOUTSZ, VSEQINSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, LSHIFT, ABD, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(VSEQINSZ, LSHIFT, OFIFO, VSEQINSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, LSHIFT, ONE, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, LSHIFT, ZERO, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, LSHIFT, MATH0, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, LSHIFT, MATH1, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, LSHIFT, MATH2, VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, LSHIFT, MATH3, VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, LSHIFT, IMM(393615378), VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, LSHIFT, DPOVRD, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, LSHIFT, VSEQINSZ, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, LSHIFT, VSEQOUTSZ, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, LSHIFT, ABD, VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, LSHIFT, OFIFO, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, LSHIFT, ONE, VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, LSHIFT, ZERO, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(ZERO, LSHIFT, MATH0, VSEQINSZ, SIZE(8), 0);
	MATHB(ZERO, LSHIFT, MATH1, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(ZERO, LSHIFT, MATH2, VSEQINSZ, SIZE(8), 0);
	MATHB(ZERO, LSHIFT, MATH3, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(ZERO, LSHIFT, IMM(393615378), VSEQINSZ, SIZE(1), 0);
	MATHB(ZERO, LSHIFT, DPOVRD, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, LSHIFT, VSEQINSZ, VSEQINSZ, SIZE(2), 0);
	MATHB(ZERO, LSHIFT, VSEQOUTSZ, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, LSHIFT, ABD, VSEQINSZ, SIZE(2), 0);
	MATHB(ZERO, LSHIFT, OFIFO, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(ZERO, LSHIFT, ONE, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(ZERO, LSHIFT, ZERO, VSEQINSZ, SIZE(2), 0);
	MATHB(ONE, LSHIFT, MATH0, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(ONE, LSHIFT, MATH1, VSEQINSZ, SIZE(8), 0);
	MATHB(ONE, LSHIFT, MATH2, VSEQINSZ, SIZE(4), 0);
	MATHB(ONE, LSHIFT, MATH3, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(ONE, LSHIFT, IMM(393615378), VSEQINSZ, SIZE(1), 0);
	MATHB(ONE, LSHIFT, DPOVRD, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(ONE, LSHIFT, VSEQINSZ, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, LSHIFT, VSEQOUTSZ, VSEQINSZ, SIZE(8), 0);
	MATHB(ONE, LSHIFT, ABD, VSEQINSZ, SIZE(1), WITH(NFU));
	MATHB(ONE, LSHIFT, OFIFO, VSEQINSZ, SIZE(4), 0);
	MATHB(ONE, LSHIFT, ONE, VSEQINSZ, SIZE(1), 0);
	MATHB(ONE, LSHIFT, ZERO, VSEQINSZ, SIZE(4), WITH(STL));
	/* LSHIFT Operation: VSEQOUTSZ Destination register */
	MATHB(MATH0, LSHIFT, MATH0, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(MATH0, LSHIFT, MATH1, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH0, LSHIFT, MATH2, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH0, LSHIFT, MATH3, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH0, LSHIFT, IMM(393615378), VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, LSHIFT, DPOVRD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, LSHIFT, VSEQINSZ, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(MATH0, LSHIFT, VSEQOUTSZ, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH0, LSHIFT, ABD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH0, LSHIFT, OFIFO, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, LSHIFT, ONE, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(MATH0, LSHIFT, ZERO, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, LSHIFT, MATH0, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH1, LSHIFT, MATH1, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH1, LSHIFT, MATH2, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH1, LSHIFT, MATH3, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(MATH1, LSHIFT, IMM(393615378), VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH1, LSHIFT, DPOVRD, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH1, LSHIFT, VSEQINSZ, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(MATH1, LSHIFT, VSEQOUTSZ, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, LSHIFT, ABD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH1, LSHIFT, OFIFO, VSEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH1, LSHIFT, ONE, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH1, LSHIFT, ZERO, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH2, LSHIFT, MATH0, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(MATH2, LSHIFT, MATH1, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH2, LSHIFT, MATH2, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, LSHIFT, MATH3, VSEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, LSHIFT, IMM(393615378), VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH2, LSHIFT, DPOVRD, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH2, LSHIFT, VSEQINSZ, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(MATH2, LSHIFT, VSEQOUTSZ, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(MATH2, LSHIFT, ABD, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, LSHIFT, OFIFO, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH2, LSHIFT, ONE, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, LSHIFT, ZERO, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, LSHIFT, MATH0, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, LSHIFT, MATH1, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, LSHIFT, MATH2, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH3, LSHIFT, MATH3, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, LSHIFT, IMM(393615378), VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, LSHIFT, DPOVRD, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(MATH3, LSHIFT, VSEQINSZ, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, LSHIFT, VSEQOUTSZ, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, LSHIFT, ABD, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(MATH3, LSHIFT, OFIFO, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH3, LSHIFT, ONE, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, LSHIFT, ZERO, VSEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), LSHIFT, MATH0, VSEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(275128321), LSHIFT, MATH1, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), LSHIFT, MATH2, VSEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), LSHIFT, MATH3, VSEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(275128321), LSHIFT, IMM(393615378), VSEQOUTSZ, SIZE(1),
	      WITH(STL));
	MATHB(IMM(275128321), LSHIFT, DPOVRD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(275128321), LSHIFT, VSEQINSZ, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(IMM(0x19261959fedcba01), LSHIFT, VSEQOUTSZ, VSEQOUTSZ, SIZE(8),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), LSHIFT, ABD, VSEQOUTSZ, SIZE(1), 0);
	MATHB(IMM(275128321), LSHIFT, OFIFO, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), LSHIFT, ONE, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), LSHIFT, ZERO, VSEQOUTSZ, SIZE(4),
	      WITH(NFU | STL));
	MATHB(DPOVRD, LSHIFT, MATH0, VSEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, LSHIFT, MATH1, VSEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, LSHIFT, MATH2, VSEQOUTSZ, SIZE(4), 0);
	MATHB(DPOVRD, LSHIFT, MATH3, VSEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, LSHIFT, IMM(393615378), VSEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, LSHIFT, DPOVRD, VSEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, LSHIFT, VSEQINSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, LSHIFT, VSEQOUTSZ, VSEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, LSHIFT, ABD, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(DPOVRD, LSHIFT, OFIFO, VSEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, LSHIFT, ONE, VSEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, LSHIFT, ZERO, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQINSZ, LSHIFT, MATH0, VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQINSZ, LSHIFT, MATH1, VSEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(SEQINSZ, LSHIFT, MATH2, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, LSHIFT, MATH3, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, LSHIFT, IMM(393615378), VSEQOUTSZ, SIZE(2),
	      WITH(NFU | STL));
	MATHB(SEQINSZ, LSHIFT, DPOVRD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQINSZ, LSHIFT, VSEQINSZ, VSEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, LSHIFT, VSEQOUTSZ, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, LSHIFT, ABD, VSEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, LSHIFT, OFIFO, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, LSHIFT, ONE, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, LSHIFT, ZERO, VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, LSHIFT, MATH0, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, LSHIFT, MATH1, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, LSHIFT, MATH2, VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, LSHIFT, MATH3, VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, LSHIFT, IMM(393615378), VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, LSHIFT, DPOVRD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, LSHIFT, VSEQINSZ, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, LSHIFT, VSEQOUTSZ, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, LSHIFT, ABD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, LSHIFT, OFIFO, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(SEQOUTSZ, LSHIFT, ONE, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, LSHIFT, ZERO, VSEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, LSHIFT, MATH0, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, LSHIFT, MATH1, VSEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, LSHIFT, MATH2, VSEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, LSHIFT, MATH3, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, LSHIFT, IMM(393615378), VSEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, LSHIFT, DPOVRD, VSEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, LSHIFT, VSEQINSZ, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, LSHIFT, VSEQOUTSZ, VSEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, LSHIFT, ABD, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, LSHIFT, OFIFO, VSEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, LSHIFT, ONE, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, LSHIFT, ZERO, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, LSHIFT, MATH0, VSEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, LSHIFT, MATH1, VSEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, LSHIFT, MATH2, VSEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, LSHIFT, MATH3, VSEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, LSHIFT, IMM(393615378), VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, LSHIFT, DPOVRD, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, LSHIFT, VSEQINSZ, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, LSHIFT, VSEQOUTSZ, VSEQOUTSZ, SIZE(1),
	      WITH(NFU | STL));
	MATHB(VSEQOUTSZ, LSHIFT, ABD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, LSHIFT, OFIFO, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, LSHIFT, ONE, VSEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, LSHIFT, ZERO, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, LSHIFT, MATH0, VSEQOUTSZ, SIZE(8), 0);
	MATHB(ZERO, LSHIFT, MATH1, VSEQOUTSZ, SIZE(8), 0);
	MATHB(ZERO, LSHIFT, MATH2, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(ZERO, LSHIFT, MATH3, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, LSHIFT, IMM(0x19261959fedcba01), VSEQOUTSZ, SIZE(8), 0);
	MATHB(ZERO, LSHIFT, DPOVRD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, LSHIFT, VSEQINSZ, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, LSHIFT, VSEQOUTSZ, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(ZERO, LSHIFT, ABD, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, LSHIFT, OFIFO, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(ZERO, LSHIFT, ONE, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(ZERO, LSHIFT, ZERO, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(ONE, LSHIFT, MATH0, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, LSHIFT, MATH1, VSEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, LSHIFT, MATH2, VSEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, LSHIFT, MATH3, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, LSHIFT, IMM(393615378), VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(ONE, LSHIFT, DPOVRD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, LSHIFT, VSEQINSZ, VSEQOUTSZ, SIZE(8), 0);
	MATHB(ONE, LSHIFT, VSEQOUTSZ, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, LSHIFT, ABD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, LSHIFT, OFIFO, VSEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, LSHIFT, ONE, VSEQOUTSZ, SIZE(2), 0);
	MATHB(ONE, LSHIFT, ZERO, VSEQOUTSZ, SIZE(4), 0);
	/* LSHIFT Operation: NONE Destination register */
	MATHB(MATH0, LSHIFT, MATH0, NONE, SIZE(4), WITH(STL));
	MATHB(MATH0, LSHIFT, MATH1, NONE, SIZE(1), 0);
	MATHB(MATH0, LSHIFT, MATH2, NONE, SIZE(1), WITH(NFU));
	MATHB(MATH0, LSHIFT, MATH3, NONE, SIZE(4), WITH(NFU));
	MATHB(MATH0, LSHIFT, IMM(393615378), NONE, SIZE(1), 0);
	MATHB(MATH0, LSHIFT, DPOVRD, NONE, SIZE(1), 0);
	MATHB(MATH0, LSHIFT, VSEQINSZ, NONE, SIZE(1), 0);
	MATHB(MATH0, LSHIFT, VSEQOUTSZ, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, LSHIFT, ABD, NONE, SIZE(2), 0);
	MATHB(MATH0, LSHIFT, OFIFO, NONE, SIZE(2), 0);
	MATHB(MATH0, LSHIFT, ONE, NONE, SIZE(1), 0);
	MATHB(MATH0, LSHIFT, ZERO, NONE, SIZE(1), 0);
	MATHB(MATH1, LSHIFT, MATH0, NONE, SIZE(8), 0);
	MATHB(MATH1, LSHIFT, MATH1, NONE, SIZE(2), 0);
	MATHB(MATH1, LSHIFT, MATH2, NONE, SIZE(4), WITH(NFU));
	MATHB(MATH1, LSHIFT, MATH3, NONE, SIZE(1), 0);
	MATHB(MATH1, LSHIFT, IMM(393615378), NONE, SIZE(2), 0);
	MATHB(MATH1, LSHIFT, DPOVRD, NONE, SIZE(4), 0);
	MATHB(MATH1, LSHIFT, VSEQINSZ, NONE, SIZE(1), WITH(NFU));
	MATHB(MATH1, LSHIFT, VSEQOUTSZ, NONE, SIZE(1), WITH(STL));
	MATHB(MATH1, LSHIFT, ABD, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(MATH1, LSHIFT, OFIFO, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, LSHIFT, ONE, NONE, SIZE(1), 0);
	MATHB(MATH1, LSHIFT, ZERO, NONE, SIZE(4), WITH(NFU));
	MATHB(MATH2, LSHIFT, MATH0, NONE, SIZE(2), WITH(STL));
	MATHB(MATH2, LSHIFT, MATH1, NONE, SIZE(8), WITH(STL));
	MATHB(MATH2, LSHIFT, MATH2, NONE, SIZE(2), 0);
	MATHB(MATH2, LSHIFT, MATH3, NONE, SIZE(8), 0);
	MATHB(MATH2, LSHIFT, IMM(393615378), NONE, SIZE(4), WITH(STL));
	MATHB(MATH2, LSHIFT, DPOVRD, NONE, SIZE(1), 0);
	MATHB(MATH2, LSHIFT, VSEQINSZ, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, LSHIFT, VSEQOUTSZ, NONE, SIZE(8), 0);
	MATHB(MATH2, LSHIFT, ABD, NONE, SIZE(2), 0);
	MATHB(MATH2, LSHIFT, OFIFO, NONE, SIZE(4), 0);
	MATHB(MATH2, LSHIFT, ONE, NONE, SIZE(2), 0);
	MATHB(MATH2, LSHIFT, ZERO, NONE, SIZE(1), 0);
	MATHB(MATH3, LSHIFT, MATH0, NONE, SIZE(2), 0);
	MATHB(MATH3, LSHIFT, MATH1, NONE, SIZE(4), 0);
	MATHB(MATH3, LSHIFT, MATH2, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, LSHIFT, MATH3, NONE, SIZE(8), 0);
	MATHB(MATH3, LSHIFT, IMM(393615378), NONE, SIZE(2), WITH(NFU));
	MATHB(MATH3, LSHIFT, DPOVRD, NONE, SIZE(8), 0);
	MATHB(MATH3, LSHIFT, VSEQINSZ, NONE, SIZE(1), 0);
	MATHB(MATH3, LSHIFT, VSEQOUTSZ, NONE, SIZE(8), 0);
	MATHB(MATH3, LSHIFT, ABD, NONE, SIZE(8), WITH(NFU));
	MATHB(MATH3, LSHIFT, OFIFO, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, LSHIFT, ONE, NONE, SIZE(1), WITH(NFU));
	MATHB(MATH3, LSHIFT, ZERO, NONE, SIZE(4), 0);
	MATHB(IMM(275128321), LSHIFT, MATH0, NONE, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), LSHIFT, MATH1, NONE, SIZE(4), 0);
	MATHB(IMM(0x19261959fedcba01), LSHIFT, MATH2, NONE, SIZE(8), 0);
	MATHB(IMM(0x19261959fedcba01), LSHIFT, MATH3, NONE, SIZE(8), WITH(NFU));
	MATHB(IMM(275128321), LSHIFT, IMM(393615378), NONE, SIZE(1),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), LSHIFT, DPOVRD, NONE, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), LSHIFT, VSEQINSZ, NONE, SIZE(2), WITH(STL));
	MATHB(IMM(275128321), LSHIFT, VSEQOUTSZ, NONE, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), LSHIFT, ABD, NONE, SIZE(4), 0);
	MATHB(IMM(275128321), LSHIFT, OFIFO, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), LSHIFT, ONE, NONE, SIZE(2), WITH(NFU));
	MATHB(IMM(0x19261959fedcba01), LSHIFT, ZERO, NONE, SIZE(8),
	      WITH(NFU | STL));
	MATHB(DPOVRD, LSHIFT, MATH0, NONE, SIZE(4), 0);
	MATHB(DPOVRD, LSHIFT, MATH1, NONE, SIZE(2), WITH(STL));
	MATHB(DPOVRD, LSHIFT, MATH2, NONE, SIZE(8), 0);
	MATHB(DPOVRD, LSHIFT, MATH3, NONE, SIZE(2), 0);
	MATHB(DPOVRD, LSHIFT, IMM(393615378), NONE, SIZE(4), 0);
	MATHB(DPOVRD, LSHIFT, DPOVRD, NONE, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, LSHIFT, VSEQINSZ, NONE, SIZE(1), 0);
	MATHB(DPOVRD, LSHIFT, VSEQOUTSZ, NONE, SIZE(2), 0);
	MATHB(DPOVRD, LSHIFT, ABD, NONE, SIZE(4), 0);
	MATHB(DPOVRD, LSHIFT, OFIFO, NONE, SIZE(1), 0);
	MATHB(DPOVRD, LSHIFT, ONE, NONE, SIZE(2), 0);
	MATHB(DPOVRD, LSHIFT, ZERO, NONE, SIZE(8), 0);
	MATHB(SEQINSZ, LSHIFT, MATH0, NONE, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, LSHIFT, MATH1, NONE, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, LSHIFT, MATH2, NONE, SIZE(8), 0);
	MATHB(SEQINSZ, LSHIFT, MATH3, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, LSHIFT, IMM(393615378), NONE, SIZE(1), 0);
	MATHB(SEQINSZ, LSHIFT, DPOVRD, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, LSHIFT, VSEQINSZ, NONE, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, LSHIFT, VSEQOUTSZ, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(SEQINSZ, LSHIFT, ABD, NONE, SIZE(4), 0);
	MATHB(SEQINSZ, LSHIFT, OFIFO, NONE, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, LSHIFT, ONE, NONE, SIZE(1), 0);
	MATHB(SEQINSZ, LSHIFT, ZERO, NONE, SIZE(8), WITH(NFU));
	MATHB(SEQOUTSZ, LSHIFT, MATH0, NONE, SIZE(1), 0);
	MATHB(SEQOUTSZ, LSHIFT, MATH1, NONE, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, LSHIFT, MATH2, NONE, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, LSHIFT, MATH3, NONE, SIZE(8), 0);
	MATHB(SEQOUTSZ, LSHIFT, IMM(393615378), NONE, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, LSHIFT, DPOVRD, NONE, SIZE(8), 0);
	MATHB(SEQOUTSZ, LSHIFT, VSEQINSZ, NONE, SIZE(4), 0);
	MATHB(SEQOUTSZ, LSHIFT, VSEQOUTSZ, NONE, SIZE(4), 0);
	MATHB(SEQOUTSZ, LSHIFT, ABD, NONE, SIZE(8), 0);
	MATHB(SEQOUTSZ, LSHIFT, OFIFO, NONE, SIZE(4), 0);
	MATHB(SEQOUTSZ, LSHIFT, ONE, NONE, SIZE(8), 0);
	MATHB(SEQOUTSZ, LSHIFT, ZERO, NONE, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, LSHIFT, MATH0, NONE, SIZE(8), 0);
	MATHB(VSEQINSZ, LSHIFT, MATH1, NONE, SIZE(1), 0);
	MATHB(VSEQINSZ, LSHIFT, MATH2, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, LSHIFT, MATH3, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, LSHIFT, IMM(393615378), NONE, SIZE(8), WITH(IFB | STL));
	MATHB(VSEQINSZ, LSHIFT, DPOVRD, NONE, SIZE(2), 0);
	MATHB(VSEQINSZ, LSHIFT, VSEQINSZ, NONE, SIZE(2), 0);
	MATHB(VSEQINSZ, LSHIFT, VSEQOUTSZ, NONE, SIZE(2), 0);
	MATHB(VSEQINSZ, LSHIFT, ABD, NONE, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, LSHIFT, OFIFO, NONE, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, LSHIFT, ONE, NONE, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, LSHIFT, ZERO, NONE, SIZE(1), 0);
	MATHB(VSEQOUTSZ, LSHIFT, MATH0, NONE, SIZE(4), 0);
	MATHB(VSEQOUTSZ, LSHIFT, MATH1, NONE, SIZE(2), 0);
	MATHB(VSEQOUTSZ, LSHIFT, MATH2, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, LSHIFT, MATH3, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, LSHIFT, IMM(393615378), NONE, SIZE(4), 0);
	MATHB(VSEQOUTSZ, LSHIFT, DPOVRD, NONE, SIZE(2), 0);
	MATHB(VSEQOUTSZ, LSHIFT, VSEQINSZ, NONE, SIZE(8), 0);
	MATHB(VSEQOUTSZ, LSHIFT, VSEQOUTSZ, NONE, SIZE(2), 0);
	MATHB(VSEQOUTSZ, LSHIFT, ABD, NONE, SIZE(8), 0);
	MATHB(VSEQOUTSZ, LSHIFT, OFIFO, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, LSHIFT, ONE, NONE, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, LSHIFT, ZERO, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, LSHIFT, MATH0, NONE, SIZE(8), WITH(NFU));
	MATHB(ZERO, LSHIFT, MATH1, NONE, SIZE(1), 0);
	MATHB(ZERO, LSHIFT, MATH2, NONE, SIZE(8), 0);
	MATHB(ZERO, LSHIFT, MATH3, NONE, SIZE(2), WITH(STL));
	MATHB(ZERO, LSHIFT, IMM(393615378), NONE, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, LSHIFT, DPOVRD, NONE, SIZE(2), WITH(STL));
	MATHB(ZERO, LSHIFT, VSEQINSZ, NONE, SIZE(1), WITH(STL));
	MATHB(ZERO, LSHIFT, VSEQOUTSZ, NONE, SIZE(1), WITH(STL));
	MATHB(ZERO, LSHIFT, ABD, NONE, SIZE(2), WITH(STL));
	MATHB(ZERO, LSHIFT, OFIFO, NONE, SIZE(4), 0);
	MATHB(ZERO, LSHIFT, ONE, NONE, SIZE(4), WITH(NFU));
	MATHB(ZERO, LSHIFT, ZERO, NONE, SIZE(8), 0);
	MATHB(ONE, LSHIFT, MATH0, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, LSHIFT, MATH1, NONE, SIZE(2), WITH(NFU));
	MATHB(ONE, LSHIFT, MATH2, NONE, SIZE(1), 0);
	MATHB(ONE, LSHIFT, MATH3, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, LSHIFT, IMM(393615378), NONE, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, LSHIFT, DPOVRD, NONE, SIZE(4), WITH(STL));
	MATHB(ONE, LSHIFT, VSEQINSZ, NONE, SIZE(8), 0);
	MATHB(ONE, LSHIFT, VSEQOUTSZ, NONE, SIZE(4), WITH(NFU));
	MATHB(ONE, LSHIFT, ABD, NONE, SIZE(1), WITH(STL));
	MATHB(ONE, LSHIFT, OFIFO, NONE, SIZE(2), 0);
	MATHB(ONE, LSHIFT, ONE, NONE, SIZE(2), 0);
	MATHB(ONE, LSHIFT, ZERO, NONE, SIZE(1), 0);
	/* RSHIFT Operation: MATH0 Destination register */
	MATHB(MATH0, RSHIFT, MATH0, MATH0, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, RSHIFT, MATH1, MATH0, SIZE(4), 0);
	MATHB(MATH0, RSHIFT, MATH2, MATH0, SIZE(8), 0);
	MATHB(MATH0, RSHIFT, MATH3, MATH0, SIZE(2), 0);
	MATHB(MATH0, RSHIFT, IMM(393615378), MATH0, SIZE(4), 0);
	MATHB(MATH0, RSHIFT, DPOVRD, MATH0, SIZE(4), 0);
	MATHB(MATH0, RSHIFT, VSEQINSZ, MATH0, SIZE(2), 0);
	MATHB(MATH0, RSHIFT, VSEQOUTSZ, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(MATH0, RSHIFT, ABD, MATH0, SIZE(8), WITH(NFU));
	MATHB(MATH0, RSHIFT, OFIFO, MATH0, SIZE(8), 0);
	MATHB(MATH0, RSHIFT, ONE, MATH0, SIZE(8), 0);
	MATHB(MATH0, RSHIFT, ZERO, MATH0, SIZE(4), 0);
	MATHB(MATH1, RSHIFT, MATH0, MATH0, SIZE(2), 0);
	MATHB(MATH1, RSHIFT, MATH1, MATH0, SIZE(2), 0);
	MATHB(MATH1, RSHIFT, MATH2, MATH0, SIZE(8), 0);
	MATHB(MATH1, RSHIFT, MATH3, MATH0, SIZE(8), 0);
	MATHB(MATH1, RSHIFT, IMM(393615378), MATH0, SIZE(2), 0);
	MATHB(MATH1, RSHIFT, DPOVRD, MATH0, SIZE(4), WITH(NFU));
	MATHB(MATH1, RSHIFT, VSEQINSZ, MATH0, SIZE(1), 0);
	MATHB(MATH1, RSHIFT, VSEQOUTSZ, MATH0, SIZE(1), 0);
	MATHB(MATH1, RSHIFT, ABD, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(MATH1, RSHIFT, OFIFO, MATH0, SIZE(2), WITH(STL));
	MATHB(MATH1, RSHIFT, ONE, MATH0, SIZE(1), 0);
	MATHB(MATH1, RSHIFT, ZERO, MATH0, SIZE(4), WITH(STL));
	MATHB(MATH2, RSHIFT, MATH0, MATH0, SIZE(4), 0);
	MATHB(MATH2, RSHIFT, MATH1, MATH0, SIZE(4), WITH(NFU));
	MATHB(MATH2, RSHIFT, MATH2, MATH0, SIZE(1), WITH(STL));
	MATHB(MATH2, RSHIFT, MATH3, MATH0, SIZE(2), 0);
	MATHB(MATH2, RSHIFT, IMM(393615378), MATH0, SIZE(8), WITH(IFB | STL));
	MATHB(MATH2, RSHIFT, DPOVRD, MATH0, SIZE(2), 0);
	MATHB(MATH2, RSHIFT, VSEQINSZ, MATH0, SIZE(2), WITH(NFU));
	MATHB(MATH2, RSHIFT, VSEQOUTSZ, MATH0, SIZE(8), 0);
	MATHB(MATH2, RSHIFT, ABD, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, RSHIFT, OFIFO, MATH0, SIZE(8), 0);
	MATHB(MATH2, RSHIFT, ONE, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, RSHIFT, ZERO, MATH0, SIZE(1), 0);
	MATHB(MATH3, RSHIFT, MATH0, MATH0, SIZE(8), 0);
	MATHB(MATH3, RSHIFT, MATH1, MATH0, SIZE(4), 0);
	MATHB(MATH3, RSHIFT, MATH2, MATH0, SIZE(8), WITH(STL));
	MATHB(MATH3, RSHIFT, MATH3, MATH0, SIZE(4), 0);
	MATHB(MATH3, RSHIFT, IMM(393615378), MATH0, SIZE(2), 0);
	MATHB(MATH3, RSHIFT, DPOVRD, MATH0, SIZE(8), 0);
	MATHB(MATH3, RSHIFT, VSEQINSZ, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, RSHIFT, VSEQOUTSZ, MATH0, SIZE(1), WITH(NFU));
	MATHB(MATH3, RSHIFT, ABD, MATH0, SIZE(1), 0);
	MATHB(MATH3, RSHIFT, OFIFO, MATH0, SIZE(2), 0);
	MATHB(MATH3, RSHIFT, ONE, MATH0, SIZE(2), WITH(NFU));
	MATHB(MATH3, RSHIFT, ZERO, MATH0, SIZE(2), WITH(STL));
	MATHB(IMM(275128321), RSHIFT, MATH0, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(275128321), RSHIFT, MATH1, MATH0, SIZE(4), 0);
	MATHB(IMM(275128321), RSHIFT, MATH2, MATH0, SIZE(1), 0);
	MATHB(IMM(275128321), RSHIFT, MATH3, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(275128321), RSHIFT, IMM(393615378), MATH0, SIZE(2),
	      WITH(NFU));
	MATHB(IMM(275128321), RSHIFT, DPOVRD, MATH0, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), RSHIFT, VSEQINSZ, MATH0, SIZE(2), WITH(NFU));
	MATHB(IMM(275128321), RSHIFT, VSEQOUTSZ, MATH0, SIZE(4), 0);
	MATHB(IMM(275128321), RSHIFT, ABD, MATH0, SIZE(4), 0);
	MATHB(IMM(275128321), RSHIFT, OFIFO, MATH0, SIZE(1), 0);
	MATHB(IMM(275128321), RSHIFT, ONE, MATH0, SIZE(4), 0);
	MATHB(IMM(275128321), RSHIFT, ZERO, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, RSHIFT, MATH0, MATH0, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, RSHIFT, MATH1, MATH0, SIZE(1), 0);
	MATHB(DPOVRD, RSHIFT, MATH2, MATH0, SIZE(8), 0);
	MATHB(DPOVRD, RSHIFT, MATH3, MATH0, SIZE(2), 0);
	MATHB(DPOVRD, RSHIFT, IMM(0x19261959fedcba01), MATH0, SIZE(8), 0);
	MATHB(DPOVRD, RSHIFT, DPOVRD, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, RSHIFT, VSEQINSZ, MATH0, SIZE(4), 0);
	MATHB(DPOVRD, RSHIFT, VSEQOUTSZ, MATH0, SIZE(4), 0);
	MATHB(DPOVRD, RSHIFT, ABD, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, RSHIFT, OFIFO, MATH0, SIZE(8), 0);
	MATHB(DPOVRD, RSHIFT, ONE, MATH0, SIZE(1), WITH(STL));
	MATHB(DPOVRD, RSHIFT, ZERO, MATH0, SIZE(1), 0);
	MATHB(SEQINSZ, RSHIFT, MATH0, MATH0, SIZE(1), 0);
	MATHB(SEQINSZ, RSHIFT, MATH1, MATH0, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, RSHIFT, MATH2, MATH0, SIZE(1), 0);
	MATHB(SEQINSZ, RSHIFT, MATH3, MATH0, SIZE(8), 0);
	MATHB(SEQINSZ, RSHIFT, IMM(0x19261959fedcba01), MATH0, SIZE(8), 0);
	MATHB(SEQINSZ, RSHIFT, DPOVRD, MATH0, SIZE(2), 0);
	MATHB(SEQINSZ, RSHIFT, VSEQINSZ, MATH0, SIZE(1), 0);
	MATHB(SEQINSZ, RSHIFT, VSEQOUTSZ, MATH0, SIZE(1), 0);
	MATHB(SEQINSZ, RSHIFT, ABD, MATH0, SIZE(1), 0);
	MATHB(SEQINSZ, RSHIFT, OFIFO, MATH0, SIZE(8), 0);
	MATHB(SEQINSZ, RSHIFT, ONE, MATH0, SIZE(2), 0);
	MATHB(SEQINSZ, RSHIFT, ZERO, MATH0, SIZE(8), 0);
	MATHB(SEQOUTSZ, RSHIFT, MATH0, MATH0, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, RSHIFT, MATH1, MATH0, SIZE(1), 0);
	MATHB(SEQOUTSZ, RSHIFT, MATH2, MATH0, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, RSHIFT, MATH3, MATH0, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, RSHIFT, IMM(0x19261959fedcba01), MATH0, SIZE(8), 0);
	MATHB(SEQOUTSZ, RSHIFT, DPOVRD, MATH0, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, RSHIFT, VSEQINSZ, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, RSHIFT, VSEQOUTSZ, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, RSHIFT, ABD, MATH0, SIZE(8), 0);
	MATHB(SEQOUTSZ, RSHIFT, OFIFO, MATH0, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, RSHIFT, ONE, MATH0, SIZE(4), 0);
	MATHB(SEQOUTSZ, RSHIFT, ZERO, MATH0, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, RSHIFT, MATH0, MATH0, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, RSHIFT, MATH1, MATH0, SIZE(1), 0);
	MATHB(VSEQINSZ, RSHIFT, MATH2, MATH0, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, RSHIFT, MATH3, MATH0, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, RSHIFT, IMM(393615378), MATH0, SIZE(8), WITH(IFB));
	MATHB(VSEQINSZ, RSHIFT, DPOVRD, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, RSHIFT, VSEQINSZ, MATH0, SIZE(4), 0);
	MATHB(VSEQINSZ, RSHIFT, VSEQOUTSZ, MATH0, SIZE(1), 0);
	MATHB(VSEQINSZ, RSHIFT, ABD, MATH0, SIZE(8), 0);
	MATHB(VSEQINSZ, RSHIFT, OFIFO, MATH0, SIZE(2), 0);
	MATHB(VSEQINSZ, RSHIFT, ONE, MATH0, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, RSHIFT, ZERO, MATH0, SIZE(1), 0);
	MATHB(VSEQOUTSZ, RSHIFT, MATH0, MATH0, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, RSHIFT, MATH1, MATH0, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, RSHIFT, MATH2, MATH0, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, RSHIFT, MATH3, MATH0, SIZE(1), 0);
	MATHB(VSEQOUTSZ, RSHIFT, IMM(0x19261959fedcba01), MATH0, SIZE(8), 0);
	MATHB(VSEQOUTSZ, RSHIFT, DPOVRD, MATH0, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, RSHIFT, VSEQINSZ, MATH0, SIZE(2), 0);
	MATHB(VSEQOUTSZ, RSHIFT, VSEQOUTSZ, MATH0, SIZE(4), 0);
	MATHB(VSEQOUTSZ, RSHIFT, ABD, MATH0, SIZE(2), 0);
	MATHB(VSEQOUTSZ, RSHIFT, OFIFO, MATH0, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, RSHIFT, ONE, MATH0, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, RSHIFT, ZERO, MATH0, SIZE(2), WITH(NFU));
	MATHB(ZERO, RSHIFT, MATH0, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, RSHIFT, MATH1, MATH0, SIZE(4), 0);
	MATHB(ZERO, RSHIFT, MATH2, MATH0, SIZE(8), 0);
	MATHB(ZERO, RSHIFT, MATH3, MATH0, SIZE(1), WITH(NFU));
	MATHB(ZERO, RSHIFT, IMM(393615378), MATH0, SIZE(4), WITH(STL));
	MATHB(ZERO, RSHIFT, DPOVRD, MATH0, SIZE(2), 0);
	MATHB(ZERO, RSHIFT, VSEQINSZ, MATH0, SIZE(8), 0);
	MATHB(ZERO, RSHIFT, VSEQOUTSZ, MATH0, SIZE(4), 0);
	MATHB(ZERO, RSHIFT, ABD, MATH0, SIZE(1), 0);
	MATHB(ZERO, RSHIFT, OFIFO, MATH0, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, RSHIFT, ONE, MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, RSHIFT, ZERO, MATH0, SIZE(2), 0);
	MATHB(ONE, RSHIFT, MATH0, MATH0, SIZE(1), 0);
	MATHB(ONE, RSHIFT, MATH1, MATH0, SIZE(4), WITH(STL));
	MATHB(ONE, RSHIFT, MATH2, MATH0, SIZE(1), 0);
	MATHB(ONE, RSHIFT, MATH3, MATH0, SIZE(1), 0);
	MATHB(ONE, RSHIFT, IMM(393615378), MATH0, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, RSHIFT, DPOVRD, MATH0, SIZE(1), WITH(NFU));
	MATHB(ONE, RSHIFT, VSEQINSZ, MATH0, SIZE(4), 0);
	MATHB(ONE, RSHIFT, VSEQOUTSZ, MATH0, SIZE(8), WITH(STL));
	MATHB(ONE, RSHIFT, ABD, MATH0, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, RSHIFT, OFIFO, MATH0, SIZE(2), 0);
	MATHB(ONE, RSHIFT, ONE, MATH0, SIZE(4), 0);
	MATHB(ONE, RSHIFT, ZERO, MATH0, SIZE(4), 0);
	/* RSHIFT Operation: MATH1 Destination register */
	MATHB(MATH0, RSHIFT, MATH0, MATH1, SIZE(8), WITH(STL));
	MATHB(MATH0, RSHIFT, MATH1, MATH1, SIZE(1), WITH(STL));
	MATHB(MATH0, RSHIFT, MATH2, MATH1, SIZE(8), 0);
	MATHB(MATH0, RSHIFT, MATH3, MATH1, SIZE(8), 0);
	MATHB(MATH0, RSHIFT, IMM(393615378), MATH1, SIZE(8), WITH(IFB));
	MATHB(MATH0, RSHIFT, DPOVRD, MATH1, SIZE(2), 0);
	MATHB(MATH0, RSHIFT, VSEQINSZ, MATH1, SIZE(4), 0);
	MATHB(MATH0, RSHIFT, VSEQOUTSZ, MATH1, SIZE(4), 0);
	MATHB(MATH0, RSHIFT, ABD, MATH1, SIZE(8), 0);
	MATHB(MATH0, RSHIFT, OFIFO, MATH1, SIZE(2), 0);
	MATHB(MATH0, RSHIFT, ONE, MATH1, SIZE(1), 0);
	MATHB(MATH0, RSHIFT, ZERO, MATH1, SIZE(4), 0);
	MATHB(MATH1, RSHIFT, MATH0, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(MATH1, RSHIFT, MATH1, MATH1, SIZE(2), 0);
	MATHB(MATH1, RSHIFT, MATH2, MATH1, SIZE(1), 0);
	MATHB(MATH1, RSHIFT, MATH3, MATH1, SIZE(2), 0);
	MATHB(MATH1, RSHIFT, IMM(393615378), MATH1, SIZE(8), WITH(IFB));
	MATHB(MATH1, RSHIFT, DPOVRD, MATH1, SIZE(4), 0);
	MATHB(MATH1, RSHIFT, VSEQINSZ, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(MATH1, RSHIFT, VSEQOUTSZ, MATH1, SIZE(2), WITH(STL));
	MATHB(MATH1, RSHIFT, ABD, MATH1, SIZE(2), WITH(NFU));
	MATHB(MATH1, RSHIFT, OFIFO, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(MATH1, RSHIFT, ONE, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, RSHIFT, ZERO, MATH1, SIZE(1), WITH(NFU));
	MATHB(MATH2, RSHIFT, MATH0, MATH1, SIZE(1), 0);
	MATHB(MATH2, RSHIFT, MATH1, MATH1, SIZE(2), 0);
	MATHB(MATH2, RSHIFT, MATH2, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, RSHIFT, MATH3, MATH1, SIZE(8), 0);
	MATHB(MATH2, RSHIFT, IMM(393615378), MATH1, SIZE(8), WITH(IFB | NFU));
	MATHB(MATH2, RSHIFT, DPOVRD, MATH1, SIZE(1), WITH(STL));
	MATHB(MATH2, RSHIFT, VSEQINSZ, MATH1, SIZE(1), 0);
	MATHB(MATH2, RSHIFT, VSEQOUTSZ, MATH1, SIZE(8), 0);
	MATHB(MATH2, RSHIFT, ABD, MATH1, SIZE(2), WITH(NFU));
	MATHB(MATH2, RSHIFT, OFIFO, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, RSHIFT, ONE, MATH1, SIZE(1), 0);
	MATHB(MATH2, RSHIFT, ZERO, MATH1, SIZE(1), 0);
	MATHB(MATH3, RSHIFT, MATH0, MATH1, SIZE(4), 0);
	MATHB(MATH3, RSHIFT, MATH1, MATH1, SIZE(2), 0);
	MATHB(MATH3, RSHIFT, MATH2, MATH1, SIZE(2), WITH(NFU));
	MATHB(MATH3, RSHIFT, MATH3, MATH1, SIZE(2), 0);
	MATHB(MATH3, RSHIFT, IMM(393615378), MATH1, SIZE(1), WITH(NFU));
	MATHB(MATH3, RSHIFT, DPOVRD, MATH1, SIZE(2), 0);
	MATHB(MATH3, RSHIFT, VSEQINSZ, MATH1, SIZE(4), 0);
	MATHB(MATH3, RSHIFT, VSEQOUTSZ, MATH1, SIZE(2), 0);
	MATHB(MATH3, RSHIFT, ABD, MATH1, SIZE(4), 0);
	MATHB(MATH3, RSHIFT, OFIFO, MATH1, SIZE(2), WITH(STL));
	MATHB(MATH3, RSHIFT, ONE, MATH1, SIZE(1), 0);
	MATHB(MATH3, RSHIFT, ZERO, MATH1, SIZE(1), 0);
	MATHB(IMM(275128321), RSHIFT, MATH0, MATH1, SIZE(2), WITH(NFU));
	MATHB(IMM(275128321), RSHIFT, MATH1, MATH1, SIZE(2), 0);
	MATHB(IMM(275128321), RSHIFT, MATH2, MATH1, SIZE(2), WITH(NFU));
	MATHB(IMM(275128321), RSHIFT, MATH3, MATH1, SIZE(8), WITH(IFB | NFU));
	MATHB(IMM(275128321), RSHIFT, IMM(393615378), MATH1, SIZE(2),
	      WITH(NFU));
	MATHB(IMM(275128321), RSHIFT, DPOVRD, MATH1, SIZE(2), WITH(NFU));
	MATHB(IMM(275128321), RSHIFT, VSEQINSZ, MATH1, SIZE(1), 0);
	MATHB(IMM(275128321), RSHIFT, VSEQOUTSZ, MATH1, SIZE(1), 0);
	MATHB(IMM(275128321), RSHIFT, ABD, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(275128321), RSHIFT, OFIFO, MATH1, SIZE(4), 0);
	MATHB(IMM(275128321), RSHIFT, ONE, MATH1, SIZE(4), 0);
	MATHB(IMM(275128321), RSHIFT, ZERO, MATH1, SIZE(2), 0);
	MATHB(DPOVRD, RSHIFT, MATH0, MATH1, SIZE(1), WITH(STL));
	MATHB(DPOVRD, RSHIFT, MATH1, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, RSHIFT, MATH2, MATH1, SIZE(2), 0);
	MATHB(DPOVRD, RSHIFT, MATH3, MATH1, SIZE(8), 0);
	MATHB(DPOVRD, RSHIFT, IMM(393615378), MATH1, SIZE(1), 0);
	MATHB(DPOVRD, RSHIFT, DPOVRD, MATH1, SIZE(4), 0);
	MATHB(DPOVRD, RSHIFT, VSEQINSZ, MATH1, SIZE(2), WITH(STL));
	MATHB(DPOVRD, RSHIFT, VSEQOUTSZ, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, RSHIFT, ABD, MATH1, SIZE(2), 0);
	MATHB(DPOVRD, RSHIFT, OFIFO, MATH1, SIZE(1), 0);
	MATHB(DPOVRD, RSHIFT, ONE, MATH1, SIZE(1), 0);
	MATHB(DPOVRD, RSHIFT, ZERO, MATH1, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, RSHIFT, MATH0, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(SEQINSZ, RSHIFT, MATH1, MATH1, SIZE(1), 0);
	MATHB(SEQINSZ, RSHIFT, MATH2, MATH1, SIZE(1), 0);
	MATHB(SEQINSZ, RSHIFT, MATH3, MATH1, SIZE(2), 0);
	MATHB(SEQINSZ, RSHIFT, IMM(393615378), MATH1, SIZE(8), WITH(IFB));
	MATHB(SEQINSZ, RSHIFT, DPOVRD, MATH1, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, RSHIFT, VSEQINSZ, MATH1, SIZE(8), 0);
	MATHB(SEQINSZ, RSHIFT, VSEQOUTSZ, MATH1, SIZE(4), 0);
	MATHB(SEQINSZ, RSHIFT, ABD, MATH1, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, RSHIFT, OFIFO, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, RSHIFT, ONE, MATH1, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, RSHIFT, ZERO, MATH1, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, RSHIFT, MATH0, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, RSHIFT, MATH1, MATH1, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, RSHIFT, MATH2, MATH1, SIZE(1), 0);
	MATHB(SEQOUTSZ, RSHIFT, MATH3, MATH1, SIZE(1), 0);
	MATHB(SEQOUTSZ, RSHIFT, IMM(393615378), MATH1, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, RSHIFT, DPOVRD, MATH1, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, RSHIFT, VSEQINSZ, MATH1, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, RSHIFT, VSEQOUTSZ, MATH1, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, RSHIFT, ABD, MATH1, SIZE(1), 0);
	MATHB(SEQOUTSZ, RSHIFT, OFIFO, MATH1, SIZE(2), 0);
	MATHB(SEQOUTSZ, RSHIFT, ONE, MATH1, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, RSHIFT, ZERO, MATH1, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, RSHIFT, MATH0, MATH1, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, RSHIFT, MATH1, MATH1, SIZE(2), 0);
	MATHB(VSEQINSZ, RSHIFT, MATH2, MATH1, SIZE(2), 0);
	MATHB(VSEQINSZ, RSHIFT, MATH3, MATH1, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, RSHIFT, IMM(393615378), MATH1, SIZE(2), 0);
	MATHB(VSEQINSZ, RSHIFT, DPOVRD, MATH1, SIZE(4), 0);
	MATHB(VSEQINSZ, RSHIFT, VSEQINSZ, MATH1, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, RSHIFT, VSEQOUTSZ, MATH1, SIZE(4), WITH(STL));
	MATHB(VSEQINSZ, RSHIFT, ABD, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, RSHIFT, OFIFO, MATH1, SIZE(4), WITH(STL));
	MATHB(VSEQINSZ, RSHIFT, ONE, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, RSHIFT, ZERO, MATH1, SIZE(2), 0);
	MATHB(VSEQOUTSZ, RSHIFT, MATH0, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, RSHIFT, MATH1, MATH1, SIZE(4), 0);
	MATHB(VSEQOUTSZ, RSHIFT, MATH2, MATH1, SIZE(4), 0);
	MATHB(VSEQOUTSZ, RSHIFT, MATH3, MATH1, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, RSHIFT, IMM(393615378), MATH1, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, RSHIFT, DPOVRD, MATH1, SIZE(8), 0);
	MATHB(VSEQOUTSZ, RSHIFT, VSEQINSZ, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, RSHIFT, VSEQOUTSZ, MATH1, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, RSHIFT, ABD, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, RSHIFT, OFIFO, MATH1, SIZE(1), 0);
	MATHB(VSEQOUTSZ, RSHIFT, ONE, MATH1, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, RSHIFT, ZERO, MATH1, SIZE(2), 0);
	MATHB(ZERO, RSHIFT, MATH0, MATH1, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, RSHIFT, MATH1, MATH1, SIZE(2), 0);
	MATHB(ZERO, RSHIFT, MATH2, MATH1, SIZE(8), 0);
	MATHB(ZERO, RSHIFT, MATH3, MATH1, SIZE(8), WITH(NFU));
	MATHB(ZERO, RSHIFT, IMM(0x19261959fedcba01), MATH1, SIZE(8), 0);
	MATHB(ZERO, RSHIFT, DPOVRD, MATH1, SIZE(2), 0);
	MATHB(ZERO, RSHIFT, VSEQINSZ, MATH1, SIZE(4), 0);
	MATHB(ZERO, RSHIFT, VSEQOUTSZ, MATH1, SIZE(4), WITH(STL));
	MATHB(ZERO, RSHIFT, ABD, MATH1, SIZE(2), WITH(STL));
	MATHB(ZERO, RSHIFT, OFIFO, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, RSHIFT, ONE, MATH1, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, RSHIFT, ZERO, MATH1, SIZE(4), 0);
	MATHB(ONE, RSHIFT, MATH0, MATH1, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, RSHIFT, MATH1, MATH1, SIZE(8), 0);
	MATHB(ONE, RSHIFT, MATH2, MATH1, SIZE(2), 0);
	MATHB(ONE, RSHIFT, MATH3, MATH1, SIZE(2), 0);
	MATHB(ONE, RSHIFT, IMM(393615378), MATH1, SIZE(1), 0);
	MATHB(ONE, RSHIFT, DPOVRD, MATH1, SIZE(1), WITH(STL));
	MATHB(ONE, RSHIFT, VSEQINSZ, MATH1, SIZE(2), 0);
	MATHB(ONE, RSHIFT, VSEQOUTSZ, MATH1, SIZE(4), 0);
	MATHB(ONE, RSHIFT, ABD, MATH1, SIZE(8), 0);
	MATHB(ONE, RSHIFT, OFIFO, MATH1, SIZE(1), 0);
	MATHB(ONE, RSHIFT, ONE, MATH1, SIZE(4), 0);
	MATHB(ONE, RSHIFT, ZERO, MATH1, SIZE(4), WITH(STL));
	/* RSHIFT Operation: MATH2 Destination register */
	MATHB(MATH0, RSHIFT, MATH0, MATH2, SIZE(8), 0);
	MATHB(MATH0, RSHIFT, MATH1, MATH2, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, RSHIFT, MATH2, MATH2, SIZE(2), WITH(STL));
	MATHB(MATH0, RSHIFT, MATH3, MATH2, SIZE(8), 0);
	MATHB(MATH0, RSHIFT, IMM(393615378), MATH2, SIZE(4), 0);
	MATHB(MATH0, RSHIFT, DPOVRD, MATH2, SIZE(8), 0);
	MATHB(MATH0, RSHIFT, VSEQINSZ, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(MATH0, RSHIFT, VSEQOUTSZ, MATH2, SIZE(8), 0);
	MATHB(MATH0, RSHIFT, ABD, MATH2, SIZE(2), WITH(STL));
	MATHB(MATH0, RSHIFT, OFIFO, MATH2, SIZE(4), 0);
	MATHB(MATH0, RSHIFT, ONE, MATH2, SIZE(8), 0);
	MATHB(MATH0, RSHIFT, ZERO, MATH2, SIZE(2), WITH(NFU));
	MATHB(MATH1, RSHIFT, MATH0, MATH2, SIZE(1), WITH(NFU | STL));
	MATHB(MATH1, RSHIFT, MATH1, MATH2, SIZE(4), 0);
	MATHB(MATH1, RSHIFT, MATH2, MATH2, SIZE(4), 0);
	MATHB(MATH1, RSHIFT, MATH3, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, RSHIFT, IMM(393615378), MATH2, SIZE(1), WITH(NFU));
	MATHB(MATH1, RSHIFT, DPOVRD, MATH2, SIZE(8), 0);
	MATHB(MATH1, RSHIFT, VSEQINSZ, MATH2, SIZE(4), 0);
	MATHB(MATH1, RSHIFT, VSEQOUTSZ, MATH2, SIZE(2), 0);
	MATHB(MATH1, RSHIFT, ABD, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, RSHIFT, OFIFO, MATH2, SIZE(4), WITH(STL));
	MATHB(MATH1, RSHIFT, ONE, MATH2, SIZE(2), 0);
	MATHB(MATH1, RSHIFT, ZERO, MATH2, SIZE(8), WITH(STL));
	MATHB(MATH2, RSHIFT, MATH0, MATH2, SIZE(1), 0);
	MATHB(MATH2, RSHIFT, MATH1, MATH2, SIZE(8), 0);
	MATHB(MATH2, RSHIFT, MATH2, MATH2, SIZE(8), 0);
	MATHB(MATH2, RSHIFT, MATH3, MATH2, SIZE(1), 0);
	MATHB(MATH2, RSHIFT, IMM(393615378), MATH2, SIZE(2), 0);
	MATHB(MATH2, RSHIFT, DPOVRD, MATH2, SIZE(8), WITH(NFU));
	MATHB(MATH2, RSHIFT, VSEQINSZ, MATH2, SIZE(4), 0);
	MATHB(MATH2, RSHIFT, VSEQOUTSZ, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, RSHIFT, ABD, MATH2, SIZE(2), WITH(STL));
	MATHB(MATH2, RSHIFT, OFIFO, MATH2, SIZE(4), 0);
	MATHB(MATH2, RSHIFT, ONE, MATH2, SIZE(8), 0);
	MATHB(MATH2, RSHIFT, ZERO, MATH2, SIZE(2), WITH(STL));
	MATHB(MATH3, RSHIFT, MATH0, MATH2, SIZE(8), 0);
	MATHB(MATH3, RSHIFT, MATH1, MATH2, SIZE(8), 0);
	MATHB(MATH3, RSHIFT, MATH2, MATH2, SIZE(2), 0);
	MATHB(MATH3, RSHIFT, MATH3, MATH2, SIZE(8), 0);
	MATHB(MATH3, RSHIFT, IMM(393615378), MATH2, SIZE(4), 0);
	MATHB(MATH3, RSHIFT, DPOVRD, MATH2, SIZE(2), 0);
	MATHB(MATH3, RSHIFT, VSEQINSZ, MATH2, SIZE(1), WITH(NFU));
	MATHB(MATH3, RSHIFT, VSEQOUTSZ, MATH2, SIZE(2), WITH(NFU));
	MATHB(MATH3, RSHIFT, ABD, MATH2, SIZE(4), 0);
	MATHB(MATH3, RSHIFT, OFIFO, MATH2, SIZE(2), 0);
	MATHB(MATH3, RSHIFT, ONE, MATH2, SIZE(4), 0);
	MATHB(MATH3, RSHIFT, ZERO, MATH2, SIZE(8), 0);
	MATHB(IMM(275128321), RSHIFT, MATH0, MATH2, SIZE(4), 0);
	MATHB(IMM(0x19261959fedcba01), RSHIFT, MATH1, MATH2, SIZE(8), 0);
	MATHB(IMM(275128321), RSHIFT, MATH2, MATH2, SIZE(4), 0);
	MATHB(IMM(275128321), RSHIFT, MATH3, MATH2, SIZE(2), WITH(STL));
	MATHB(IMM(275128321), RSHIFT, IMM(393615378), MATH2, SIZE(4), 0);
	MATHB(IMM(275128321), RSHIFT, DPOVRD, MATH2, SIZE(1), 0);
	MATHB(IMM(275128321), RSHIFT, VSEQINSZ, MATH2, SIZE(2), 0);
	MATHB(IMM(275128321), RSHIFT, VSEQOUTSZ, MATH2, SIZE(4), 0);
	MATHB(IMM(275128321), RSHIFT, ABD, MATH2, SIZE(8), WITH(IFB | STL));
	MATHB(IMM(275128321), RSHIFT, OFIFO, MATH2, SIZE(2), 0);
	MATHB(IMM(275128321), RSHIFT, ONE, MATH2, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), RSHIFT, ZERO, MATH2, SIZE(4), 0);
	MATHB(DPOVRD, RSHIFT, MATH0, MATH2, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, RSHIFT, MATH1, MATH2, SIZE(2), 0);
	MATHB(DPOVRD, RSHIFT, MATH2, MATH2, SIZE(8), 0);
	MATHB(DPOVRD, RSHIFT, MATH3, MATH2, SIZE(1), WITH(STL));
	MATHB(DPOVRD, RSHIFT, IMM(393615378), MATH2, SIZE(8), WITH(IFB));
	MATHB(DPOVRD, RSHIFT, DPOVRD, MATH2, SIZE(4), 0);
	MATHB(DPOVRD, RSHIFT, VSEQINSZ, MATH2, SIZE(1), WITH(STL));
	MATHB(DPOVRD, RSHIFT, VSEQOUTSZ, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(DPOVRD, RSHIFT, ABD, MATH2, SIZE(8), 0);
	MATHB(DPOVRD, RSHIFT, OFIFO, MATH2, SIZE(8), 0);
	MATHB(DPOVRD, RSHIFT, ONE, MATH2, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, RSHIFT, ZERO, MATH2, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, RSHIFT, MATH0, MATH2, SIZE(1), 0);
	MATHB(SEQINSZ, RSHIFT, MATH1, MATH2, SIZE(4), 0);
	MATHB(SEQINSZ, RSHIFT, MATH2, MATH2, SIZE(8), 0);
	MATHB(SEQINSZ, RSHIFT, MATH3, MATH2, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, RSHIFT, IMM(393615378), MATH2, SIZE(2), 0);
	MATHB(SEQINSZ, RSHIFT, DPOVRD, MATH2, SIZE(4), 0);
	MATHB(SEQINSZ, RSHIFT, VSEQINSZ, MATH2, SIZE(1), WITH(NFU | STL));
	MATHB(SEQINSZ, RSHIFT, VSEQOUTSZ, MATH2, SIZE(4), 0);
	MATHB(SEQINSZ, RSHIFT, ABD, MATH2, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, RSHIFT, OFIFO, MATH2, SIZE(1), 0);
	MATHB(SEQINSZ, RSHIFT, ONE, MATH2, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, RSHIFT, ZERO, MATH2, SIZE(1), 0);
	MATHB(SEQOUTSZ, RSHIFT, MATH0, MATH2, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, RSHIFT, MATH1, MATH2, SIZE(1), 0);
	MATHB(SEQOUTSZ, RSHIFT, MATH2, MATH2, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, RSHIFT, MATH3, MATH2, SIZE(8), 0);
	MATHB(SEQOUTSZ, RSHIFT, IMM(393615378), MATH2, SIZE(8), WITH(IFB));
	MATHB(SEQOUTSZ, RSHIFT, DPOVRD, MATH2, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, RSHIFT, VSEQINSZ, MATH2, SIZE(4), 0);
	MATHB(SEQOUTSZ, RSHIFT, VSEQOUTSZ, MATH2, SIZE(8), WITH(NFU));
	MATHB(SEQOUTSZ, RSHIFT, ABD, MATH2, SIZE(4), 0);
	MATHB(SEQOUTSZ, RSHIFT, OFIFO, MATH2, SIZE(8), 0);
	MATHB(SEQOUTSZ, RSHIFT, ONE, MATH2, SIZE(8), 0);
	MATHB(SEQOUTSZ, RSHIFT, ZERO, MATH2, SIZE(2), 0);
	MATHB(VSEQINSZ, RSHIFT, MATH0, MATH2, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, RSHIFT, MATH1, MATH2, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, RSHIFT, MATH2, MATH2, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, RSHIFT, MATH3, MATH2, SIZE(1), 0);
	MATHB(VSEQINSZ, RSHIFT, IMM(393615378), MATH2, SIZE(8), WITH(IFB));
	MATHB(VSEQINSZ, RSHIFT, DPOVRD, MATH2, SIZE(8), 0);
	MATHB(VSEQINSZ, RSHIFT, VSEQINSZ, MATH2, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, RSHIFT, VSEQOUTSZ, MATH2, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, RSHIFT, ABD, MATH2, SIZE(8), 0);
	MATHB(VSEQINSZ, RSHIFT, OFIFO, MATH2, SIZE(8), 0);
	MATHB(VSEQINSZ, RSHIFT, ONE, MATH2, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, RSHIFT, ZERO, MATH2, SIZE(8), 0);
	MATHB(VSEQOUTSZ, RSHIFT, MATH0, MATH2, SIZE(2), 0);
	MATHB(VSEQOUTSZ, RSHIFT, MATH1, MATH2, SIZE(1), 0);
	MATHB(VSEQOUTSZ, RSHIFT, MATH2, MATH2, SIZE(2), 0);
	MATHB(VSEQOUTSZ, RSHIFT, MATH3, MATH2, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, RSHIFT, IMM(393615378), MATH2, SIZE(4),
	      WITH(NFU | STL));
	MATHB(VSEQOUTSZ, RSHIFT, DPOVRD, MATH2, SIZE(2), 0);
	MATHB(VSEQOUTSZ, RSHIFT, VSEQINSZ, MATH2, SIZE(4), 0);
	MATHB(VSEQOUTSZ, RSHIFT, VSEQOUTSZ, MATH2, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, RSHIFT, ABD, MATH2, SIZE(4), 0);
	MATHB(VSEQOUTSZ, RSHIFT, OFIFO, MATH2, SIZE(2), 0);
	MATHB(VSEQOUTSZ, RSHIFT, ONE, MATH2, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, RSHIFT, ZERO, MATH2, SIZE(2), WITH(NFU));
	MATHB(ZERO, RSHIFT, MATH0, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, RSHIFT, MATH1, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, RSHIFT, MATH2, MATH2, SIZE(2), WITH(STL));
	MATHB(ZERO, RSHIFT, MATH3, MATH2, SIZE(4), 0);
	MATHB(ZERO, RSHIFT, IMM(393615378), MATH2, SIZE(1), 0);
	MATHB(ZERO, RSHIFT, DPOVRD, MATH2, SIZE(1), WITH(STL));
	MATHB(ZERO, RSHIFT, VSEQINSZ, MATH2, SIZE(8), 0);
	MATHB(ZERO, RSHIFT, VSEQOUTSZ, MATH2, SIZE(4), 0);
	MATHB(ZERO, RSHIFT, ABD, MATH2, SIZE(8), 0);
	MATHB(ZERO, RSHIFT, OFIFO, MATH2, SIZE(8), 0);
	MATHB(ZERO, RSHIFT, ONE, MATH2, SIZE(2), WITH(NFU));
	MATHB(ZERO, RSHIFT, ZERO, MATH2, SIZE(1), WITH(STL));
	MATHB(ONE, RSHIFT, MATH0, MATH2, SIZE(8), 0);
	MATHB(ONE, RSHIFT, MATH1, MATH2, SIZE(8), WITH(STL));
	MATHB(ONE, RSHIFT, MATH2, MATH2, SIZE(8), 0);
	MATHB(ONE, RSHIFT, MATH3, MATH2, SIZE(1), 0);
	MATHB(ONE, RSHIFT, IMM(393615378), MATH2, SIZE(4), WITH(STL));
	MATHB(ONE, RSHIFT, DPOVRD, MATH2, SIZE(4), 0);
	MATHB(ONE, RSHIFT, VSEQINSZ, MATH2, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, RSHIFT, VSEQOUTSZ, MATH2, SIZE(8), 0);
	MATHB(ONE, RSHIFT, ABD, MATH2, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, RSHIFT, OFIFO, MATH2, SIZE(8), 0);
	MATHB(ONE, RSHIFT, ONE, MATH2, SIZE(4), 0);
	MATHB(ONE, RSHIFT, ZERO, MATH2, SIZE(4), 0);
	/* RSHIFT Operation: MATH3 Destination register */
	MATHB(MATH0, RSHIFT, MATH0, MATH3, SIZE(1), WITH(NFU));
	MATHB(MATH0, RSHIFT, MATH1, MATH3, SIZE(8), WITH(STL));
	MATHB(MATH0, RSHIFT, MATH2, MATH3, SIZE(1), WITH(NFU));
	MATHB(MATH0, RSHIFT, MATH3, MATH3, SIZE(4), 0);
	MATHB(MATH0, RSHIFT, IMM(393615378), MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(MATH0, RSHIFT, DPOVRD, MATH3, SIZE(8), 0);
	MATHB(MATH0, RSHIFT, VSEQINSZ, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, RSHIFT, VSEQOUTSZ, MATH3, SIZE(2), 0);
	MATHB(MATH0, RSHIFT, ABD, MATH3, SIZE(2), 0);
	MATHB(MATH0, RSHIFT, OFIFO, MATH3, SIZE(4), 0);
	MATHB(MATH0, RSHIFT, ONE, MATH3, SIZE(1), 0);
	MATHB(MATH0, RSHIFT, ZERO, MATH3, SIZE(1), WITH(STL));
	MATHB(MATH1, RSHIFT, MATH0, MATH3, SIZE(8), 0);
	MATHB(MATH1, RSHIFT, MATH1, MATH3, SIZE(1), 0);
	MATHB(MATH1, RSHIFT, MATH2, MATH3, SIZE(1), WITH(NFU));
	MATHB(MATH1, RSHIFT, MATH3, MATH3, SIZE(4), 0);
	MATHB(MATH1, RSHIFT, IMM(393615378), MATH3, SIZE(2), 0);
	MATHB(MATH1, RSHIFT, DPOVRD, MATH3, SIZE(2), 0);
	MATHB(MATH1, RSHIFT, VSEQINSZ, MATH3, SIZE(4), 0);
	MATHB(MATH1, RSHIFT, VSEQOUTSZ, MATH3, SIZE(8), 0);
	MATHB(MATH1, RSHIFT, ABD, MATH3, SIZE(2), 0);
	MATHB(MATH1, RSHIFT, OFIFO, MATH3, SIZE(1), 0);
	MATHB(MATH1, RSHIFT, ONE, MATH3, SIZE(8), 0);
	MATHB(MATH1, RSHIFT, ZERO, MATH3, SIZE(8), WITH(NFU));
	MATHB(MATH2, RSHIFT, MATH0, MATH3, SIZE(4), 0);
	MATHB(MATH2, RSHIFT, MATH1, MATH3, SIZE(2), 0);
	MATHB(MATH2, RSHIFT, MATH2, MATH3, SIZE(4), 0);
	MATHB(MATH2, RSHIFT, MATH3, MATH3, SIZE(1), WITH(STL));
	MATHB(MATH2, RSHIFT, IMM(393615378), MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, RSHIFT, DPOVRD, MATH3, SIZE(8), WITH(STL));
	MATHB(MATH2, RSHIFT, VSEQINSZ, MATH3, SIZE(1), WITH(NFU));
	MATHB(MATH2, RSHIFT, VSEQOUTSZ, MATH3, SIZE(4), WITH(NFU));
	MATHB(MATH2, RSHIFT, ABD, MATH3, SIZE(8), 0);
	MATHB(MATH2, RSHIFT, OFIFO, MATH3, SIZE(1), WITH(NFU));
	MATHB(MATH2, RSHIFT, ONE, MATH3, SIZE(1), 0);
	MATHB(MATH2, RSHIFT, ZERO, MATH3, SIZE(2), 0);
	MATHB(MATH3, RSHIFT, MATH0, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, RSHIFT, MATH1, MATH3, SIZE(8), WITH(STL));
	MATHB(MATH3, RSHIFT, MATH2, MATH3, SIZE(2), WITH(STL));
	MATHB(MATH3, RSHIFT, MATH3, MATH3, SIZE(8), 0);
	MATHB(MATH3, RSHIFT, IMM(393615378), MATH3, SIZE(1), WITH(NFU));
	MATHB(MATH3, RSHIFT, DPOVRD, MATH3, SIZE(1), WITH(NFU));
	MATHB(MATH3, RSHIFT, VSEQINSZ, MATH3, SIZE(4), WITH(STL));
	MATHB(MATH3, RSHIFT, VSEQOUTSZ, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, RSHIFT, ABD, MATH3, SIZE(1), 0);
	MATHB(MATH3, RSHIFT, OFIFO, MATH3, SIZE(4), 0);
	MATHB(MATH3, RSHIFT, ONE, MATH3, SIZE(2), 0);
	MATHB(MATH3, RSHIFT, ZERO, MATH3, SIZE(1), 0);
	MATHB(IMM(275128321), RSHIFT, MATH0, MATH3, SIZE(1), 0);
	MATHB(IMM(275128321), RSHIFT, MATH1, MATH3, SIZE(4), 0);
	MATHB(IMM(0x19261959fedcba01), RSHIFT, MATH2, MATH3, SIZE(8), 0);
	MATHB(IMM(275128321), RSHIFT, MATH3, MATH3, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), RSHIFT, IMM(393615378), MATH3, SIZE(4), 0);
	MATHB(IMM(275128321), RSHIFT, DPOVRD, MATH3, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), RSHIFT, VSEQINSZ, MATH3, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), RSHIFT, VSEQOUTSZ, MATH3, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), RSHIFT, ABD, MATH3, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), RSHIFT, OFIFO, MATH3, SIZE(2), 0);
	MATHB(IMM(275128321), RSHIFT, ONE, MATH3, SIZE(2), 0);
	MATHB(IMM(275128321), RSHIFT, ZERO, MATH3, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, RSHIFT, MATH0, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(DPOVRD, RSHIFT, MATH1, MATH3, SIZE(1), WITH(NFU));
	MATHB(DPOVRD, RSHIFT, MATH2, MATH3, SIZE(2), 0);
	MATHB(DPOVRD, RSHIFT, MATH3, MATH3, SIZE(2), WITH(STL));
	MATHB(DPOVRD, RSHIFT, IMM(393615378), MATH3, SIZE(8), WITH(IFB));
	MATHB(DPOVRD, RSHIFT, DPOVRD, MATH3, SIZE(2), WITH(STL));
	MATHB(DPOVRD, RSHIFT, VSEQINSZ, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, RSHIFT, VSEQOUTSZ, MATH3, SIZE(4), 0);
	MATHB(DPOVRD, RSHIFT, ABD, MATH3, SIZE(4), 0);
	MATHB(DPOVRD, RSHIFT, OFIFO, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, RSHIFT, ONE, MATH3, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, RSHIFT, ZERO, MATH3, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, RSHIFT, MATH0, MATH3, SIZE(8), 0);
	MATHB(SEQINSZ, RSHIFT, MATH1, MATH3, SIZE(8), 0);
	MATHB(SEQINSZ, RSHIFT, MATH2, MATH3, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, RSHIFT, MATH3, MATH3, SIZE(1), 0);
	MATHB(SEQINSZ, RSHIFT, IMM(393615378), MATH3, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, RSHIFT, DPOVRD, MATH3, SIZE(8), 0);
	MATHB(SEQINSZ, RSHIFT, VSEQINSZ, MATH3, SIZE(2), 0);
	MATHB(SEQINSZ, RSHIFT, VSEQOUTSZ, MATH3, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, RSHIFT, ABD, MATH3, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, RSHIFT, OFIFO, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, RSHIFT, ONE, MATH3, SIZE(4), 0);
	MATHB(SEQINSZ, RSHIFT, ZERO, MATH3, SIZE(4), 0);
	MATHB(SEQOUTSZ, RSHIFT, MATH0, MATH3, SIZE(8), 0);
	MATHB(SEQOUTSZ, RSHIFT, MATH1, MATH3, SIZE(4), 0);
	MATHB(SEQOUTSZ, RSHIFT, MATH2, MATH3, SIZE(4), 0);
	MATHB(SEQOUTSZ, RSHIFT, MATH3, MATH3, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, RSHIFT, IMM(393615378), MATH3, SIZE(4),
	      WITH(NFU | STL));
	MATHB(SEQOUTSZ, RSHIFT, DPOVRD, MATH3, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, RSHIFT, VSEQINSZ, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, RSHIFT, VSEQOUTSZ, MATH3, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, RSHIFT, ABD, MATH3, SIZE(4), 0);
	MATHB(SEQOUTSZ, RSHIFT, OFIFO, MATH3, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, RSHIFT, ONE, MATH3, SIZE(8), WITH(NFU));
	MATHB(SEQOUTSZ, RSHIFT, ZERO, MATH3, SIZE(4), 0);
	MATHB(VSEQINSZ, RSHIFT, MATH0, MATH3, SIZE(2), 0);
	MATHB(VSEQINSZ, RSHIFT, MATH1, MATH3, SIZE(4), 0);
	MATHB(VSEQINSZ, RSHIFT, MATH2, MATH3, SIZE(1), 0);
	MATHB(VSEQINSZ, RSHIFT, MATH3, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, RSHIFT, IMM(393615378), MATH3, SIZE(4), WITH(STL));
	MATHB(VSEQINSZ, RSHIFT, DPOVRD, MATH3, SIZE(1), 0);
	MATHB(VSEQINSZ, RSHIFT, VSEQINSZ, MATH3, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, RSHIFT, VSEQOUTSZ, MATH3, SIZE(1), 0);
	MATHB(VSEQINSZ, RSHIFT, ABD, MATH3, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, RSHIFT, OFIFO, MATH3, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, RSHIFT, ONE, MATH3, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, RSHIFT, ZERO, MATH3, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, RSHIFT, MATH0, MATH3, SIZE(8), 0);
	MATHB(VSEQOUTSZ, RSHIFT, MATH1, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, RSHIFT, MATH2, MATH3, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, RSHIFT, MATH3, MATH3, SIZE(1), 0);
	MATHB(VSEQOUTSZ, RSHIFT, IMM(393615378), MATH3, SIZE(2),
	      WITH(NFU | STL));
	MATHB(VSEQOUTSZ, RSHIFT, DPOVRD, MATH3, SIZE(4), 0);
	MATHB(VSEQOUTSZ, RSHIFT, VSEQINSZ, MATH3, SIZE(1), 0);
	MATHB(VSEQOUTSZ, RSHIFT, VSEQOUTSZ, MATH3, SIZE(8), WITH(STL));
	MATHB(VSEQOUTSZ, RSHIFT, ABD, MATH3, SIZE(2), 0);
	MATHB(VSEQOUTSZ, RSHIFT, OFIFO, MATH3, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, RSHIFT, ONE, MATH3, SIZE(8), 0);
	MATHB(VSEQOUTSZ, RSHIFT, ZERO, MATH3, SIZE(8), 0);
	MATHB(ZERO, RSHIFT, MATH0, MATH3, SIZE(4), 0);
	MATHB(ZERO, RSHIFT, MATH1, MATH3, SIZE(2), 0);
	MATHB(ZERO, RSHIFT, MATH2, MATH3, SIZE(8), 0);
	MATHB(ZERO, RSHIFT, MATH3, MATH3, SIZE(1), 0);
	MATHB(ZERO, RSHIFT, IMM(393615378), MATH3, SIZE(8), WITH(IFB | NFU));
	MATHB(ZERO, RSHIFT, DPOVRD, MATH3, SIZE(4), 0);
	MATHB(ZERO, RSHIFT, VSEQINSZ, MATH3, SIZE(2), WITH(NFU));
	MATHB(ZERO, RSHIFT, VSEQOUTSZ, MATH3, SIZE(8), 0);
	MATHB(ZERO, RSHIFT, ABD, MATH3, SIZE(8), 0);
	MATHB(ZERO, RSHIFT, OFIFO, MATH3, SIZE(2), WITH(STL));
	MATHB(ZERO, RSHIFT, ONE, MATH3, SIZE(8), WITH(NFU));
	MATHB(ZERO, RSHIFT, ZERO, MATH3, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, RSHIFT, MATH0, MATH3, SIZE(8), 0);
	MATHB(ONE, RSHIFT, MATH1, MATH3, SIZE(8), WITH(NFU));
	MATHB(ONE, RSHIFT, MATH2, MATH3, SIZE(2), 0);
	MATHB(ONE, RSHIFT, MATH3, MATH3, SIZE(2), 0);
	MATHB(ONE, RSHIFT, IMM(393615378), MATH3, SIZE(4), 0);
	MATHB(ONE, RSHIFT, DPOVRD, MATH3, SIZE(1), 0);
	MATHB(ONE, RSHIFT, VSEQINSZ, MATH3, SIZE(1), 0);
	MATHB(ONE, RSHIFT, VSEQOUTSZ, MATH3, SIZE(1), 0);
	MATHB(ONE, RSHIFT, ABD, MATH3, SIZE(8), 0);
	MATHB(ONE, RSHIFT, OFIFO, MATH3, SIZE(2), 0);
	MATHB(ONE, RSHIFT, ONE, MATH3, SIZE(4), 0);
	MATHB(ONE, RSHIFT, ZERO, MATH3, SIZE(2), 0);
	/* RSHIFT Operation: DPOVRD Destination register */
	MATHB(MATH0, RSHIFT, MATH0, DPOVRD, SIZE(2), 0);
	MATHB(MATH0, RSHIFT, MATH1, DPOVRD, SIZE(1), 0);
	MATHB(MATH0, RSHIFT, MATH2, DPOVRD, SIZE(8), 0);
	MATHB(MATH0, RSHIFT, MATH3, DPOVRD, SIZE(4), 0);
	MATHB(MATH0, RSHIFT, IMM(393615378), DPOVRD, SIZE(4), 0);
	MATHB(MATH0, RSHIFT, DPOVRD, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, RSHIFT, VSEQINSZ, DPOVRD, SIZE(4), 0);
	MATHB(MATH0, RSHIFT, VSEQOUTSZ, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(MATH0, RSHIFT, ABD, DPOVRD, SIZE(8), 0);
	MATHB(MATH0, RSHIFT, OFIFO, DPOVRD, SIZE(8), WITH(STL));
	MATHB(MATH0, RSHIFT, ONE, DPOVRD, SIZE(1), 0);
	MATHB(MATH0, RSHIFT, ZERO, DPOVRD, SIZE(1), WITH(NFU));
	MATHB(MATH1, RSHIFT, MATH0, DPOVRD, SIZE(4), 0);
	MATHB(MATH1, RSHIFT, MATH1, DPOVRD, SIZE(2), 0);
	MATHB(MATH1, RSHIFT, MATH2, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, RSHIFT, MATH3, DPOVRD, SIZE(8), 0);
	MATHB(MATH1, RSHIFT, IMM(393615378), DPOVRD, SIZE(1), WITH(STL));
	MATHB(MATH1, RSHIFT, DPOVRD, DPOVRD, SIZE(2), WITH(STL));
	MATHB(MATH1, RSHIFT, VSEQINSZ, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(MATH1, RSHIFT, VSEQOUTSZ, DPOVRD, SIZE(1), 0);
	MATHB(MATH1, RSHIFT, ABD, DPOVRD, SIZE(8), 0);
	MATHB(MATH1, RSHIFT, OFIFO, DPOVRD, SIZE(2), 0);
	MATHB(MATH1, RSHIFT, ONE, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(MATH1, RSHIFT, ZERO, DPOVRD, SIZE(2), 0);
	MATHB(MATH2, RSHIFT, MATH0, DPOVRD, SIZE(2), 0);
	MATHB(MATH2, RSHIFT, MATH1, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, RSHIFT, MATH2, DPOVRD, SIZE(1), 0);
	MATHB(MATH2, RSHIFT, MATH3, DPOVRD, SIZE(4), 0);
	MATHB(MATH2, RSHIFT, IMM(393615378), DPOVRD, SIZE(2), 0);
	MATHB(MATH2, RSHIFT, DPOVRD, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(MATH2, RSHIFT, VSEQINSZ, DPOVRD, SIZE(2), 0);
	MATHB(MATH2, RSHIFT, VSEQOUTSZ, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, RSHIFT, ABD, DPOVRD, SIZE(1), 0);
	MATHB(MATH2, RSHIFT, OFIFO, DPOVRD, SIZE(4), 0);
	MATHB(MATH2, RSHIFT, ONE, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, RSHIFT, ZERO, DPOVRD, SIZE(8), WITH(STL));
	MATHB(MATH3, RSHIFT, MATH0, DPOVRD, SIZE(4), 0);
	MATHB(MATH3, RSHIFT, MATH1, DPOVRD, SIZE(4), 0);
	MATHB(MATH3, RSHIFT, MATH2, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(MATH3, RSHIFT, MATH3, DPOVRD, SIZE(2), 0);
	MATHB(MATH3, RSHIFT, IMM(393615378), DPOVRD, SIZE(8), WITH(IFB));
	MATHB(MATH3, RSHIFT, DPOVRD, DPOVRD, SIZE(8), 0);
	MATHB(MATH3, RSHIFT, VSEQINSZ, DPOVRD, SIZE(2), 0);
	MATHB(MATH3, RSHIFT, VSEQOUTSZ, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, RSHIFT, ABD, DPOVRD, SIZE(4), 0);
	MATHB(MATH3, RSHIFT, OFIFO, DPOVRD, SIZE(8), 0);
	MATHB(MATH3, RSHIFT, ONE, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(MATH3, RSHIFT, ZERO, DPOVRD, SIZE(2), 0);
	MATHB(IMM(275128321), RSHIFT, MATH0, DPOVRD, SIZE(1), 0);
	MATHB(IMM(275128321), RSHIFT, MATH1, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(IMM(0x19261959fedcba01), RSHIFT, MATH2, DPOVRD, SIZE(8),
	      WITH(STL));
	MATHB(IMM(275128321), RSHIFT, MATH3, DPOVRD, SIZE(1), 0);
	MATHB(IMM(275128321), RSHIFT, IMM(393615378), DPOVRD, SIZE(4),
	      WITH(STL));
	MATHB(IMM(275128321), RSHIFT, DPOVRD, DPOVRD, SIZE(4), 0);
	MATHB(IMM(275128321), RSHIFT, VSEQINSZ, DPOVRD, SIZE(2), 0);
	MATHB(IMM(275128321), RSHIFT, VSEQOUTSZ, DPOVRD, SIZE(8), WITH(IFB));
	MATHB(IMM(0x19261959fedcba01), RSHIFT, ABD, DPOVRD, SIZE(8), WITH(STL));
	MATHB(IMM(275128321), RSHIFT, OFIFO, DPOVRD, SIZE(2), 0);
	MATHB(IMM(275128321), RSHIFT, ONE, DPOVRD, SIZE(4), 0);
	MATHB(IMM(275128321), RSHIFT, ZERO, DPOVRD, SIZE(8),
	      WITH(IFB | NFU | STL));
	MATHB(DPOVRD, RSHIFT, MATH0, DPOVRD, SIZE(8), WITH(STL));
	MATHB(DPOVRD, RSHIFT, MATH1, DPOVRD, SIZE(2), 0);
	MATHB(DPOVRD, RSHIFT, MATH2, DPOVRD, SIZE(1), 0);
	MATHB(DPOVRD, RSHIFT, MATH3, DPOVRD, SIZE(8), 0);
	MATHB(DPOVRD, RSHIFT, IMM(0x19261959fedcba01), DPOVRD, SIZE(8), 0);
	MATHB(DPOVRD, RSHIFT, DPOVRD, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, RSHIFT, VSEQINSZ, DPOVRD, SIZE(1), 0);
	MATHB(DPOVRD, RSHIFT, VSEQOUTSZ, DPOVRD, SIZE(2), 0);
	MATHB(DPOVRD, RSHIFT, ABD, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(DPOVRD, RSHIFT, OFIFO, DPOVRD, SIZE(8), WITH(STL));
	MATHB(DPOVRD, RSHIFT, ONE, DPOVRD, SIZE(8), 0);
	MATHB(DPOVRD, RSHIFT, ZERO, DPOVRD, SIZE(2), 0);
	MATHB(SEQINSZ, RSHIFT, MATH0, DPOVRD, SIZE(1), 0);
	MATHB(SEQINSZ, RSHIFT, MATH1, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, RSHIFT, MATH2, DPOVRD, SIZE(1), 0);
	MATHB(SEQINSZ, RSHIFT, MATH3, DPOVRD, SIZE(4), 0);
	MATHB(SEQINSZ, RSHIFT, IMM(393615378), DPOVRD, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, RSHIFT, DPOVRD, DPOVRD, SIZE(4), 0);
	MATHB(SEQINSZ, RSHIFT, VSEQINSZ, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(SEQINSZ, RSHIFT, VSEQOUTSZ, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(SEQINSZ, RSHIFT, ABD, DPOVRD, SIZE(8), 0);
	MATHB(SEQINSZ, RSHIFT, OFIFO, DPOVRD, SIZE(2), 0);
	MATHB(SEQINSZ, RSHIFT, ONE, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, RSHIFT, ZERO, DPOVRD, SIZE(2), 0);
	MATHB(SEQOUTSZ, RSHIFT, MATH0, DPOVRD, SIZE(8), 0);
	MATHB(SEQOUTSZ, RSHIFT, MATH1, DPOVRD, SIZE(8), 0);
	MATHB(SEQOUTSZ, RSHIFT, MATH2, DPOVRD, SIZE(4), 0);
	MATHB(SEQOUTSZ, RSHIFT, MATH3, DPOVRD, SIZE(8), 0);
	MATHB(SEQOUTSZ, RSHIFT, IMM(393615378), DPOVRD, SIZE(8), WITH(IFB));
	MATHB(SEQOUTSZ, RSHIFT, DPOVRD, DPOVRD, SIZE(8), 0);
	MATHB(SEQOUTSZ, RSHIFT, VSEQINSZ, DPOVRD, SIZE(8), 0);
	MATHB(SEQOUTSZ, RSHIFT, VSEQOUTSZ, DPOVRD, SIZE(8), 0);
	MATHB(SEQOUTSZ, RSHIFT, ABD, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(SEQOUTSZ, RSHIFT, OFIFO, DPOVRD, SIZE(2), 0);
	MATHB(SEQOUTSZ, RSHIFT, ONE, DPOVRD, SIZE(8), 0);
	MATHB(SEQOUTSZ, RSHIFT, ZERO, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, RSHIFT, MATH0, DPOVRD, SIZE(4), 0);
	MATHB(VSEQINSZ, RSHIFT, MATH1, DPOVRD, SIZE(1), 0);
	MATHB(VSEQINSZ, RSHIFT, MATH2, DPOVRD, SIZE(2), 0);
	MATHB(VSEQINSZ, RSHIFT, MATH3, DPOVRD, SIZE(8), 0);
	MATHB(VSEQINSZ, RSHIFT, IMM(393615378), DPOVRD, SIZE(2), 0);
	MATHB(VSEQINSZ, RSHIFT, DPOVRD, DPOVRD, SIZE(4), 0);
	MATHB(VSEQINSZ, RSHIFT, VSEQINSZ, DPOVRD, SIZE(1), 0);
	MATHB(VSEQINSZ, RSHIFT, VSEQOUTSZ, DPOVRD, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, RSHIFT, ABD, DPOVRD, SIZE(4), 0);
	MATHB(VSEQINSZ, RSHIFT, OFIFO, DPOVRD, SIZE(2), 0);
	MATHB(VSEQINSZ, RSHIFT, ONE, DPOVRD, SIZE(8), WITH(STL));
	MATHB(VSEQINSZ, RSHIFT, ZERO, DPOVRD, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, RSHIFT, MATH0, DPOVRD, SIZE(1), 0);
	MATHB(VSEQOUTSZ, RSHIFT, MATH1, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, RSHIFT, MATH2, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, RSHIFT, MATH3, DPOVRD, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, RSHIFT, IMM(393615378), DPOVRD, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, RSHIFT, DPOVRD, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, RSHIFT, VSEQINSZ, DPOVRD, SIZE(4), 0);
	MATHB(VSEQOUTSZ, RSHIFT, VSEQOUTSZ, DPOVRD, SIZE(2), 0);
	MATHB(VSEQOUTSZ, RSHIFT, ABD, DPOVRD, SIZE(8), 0);
	MATHB(VSEQOUTSZ, RSHIFT, OFIFO, DPOVRD, SIZE(8), 0);
	MATHB(VSEQOUTSZ, RSHIFT, ONE, DPOVRD, SIZE(2), 0);
	MATHB(VSEQOUTSZ, RSHIFT, ZERO, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, RSHIFT, MATH0, DPOVRD, SIZE(2), WITH(NFU));
	MATHB(ZERO, RSHIFT, MATH1, DPOVRD, SIZE(2), 0);
	MATHB(ZERO, RSHIFT, MATH2, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(ZERO, RSHIFT, MATH3, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(ZERO, RSHIFT, IMM(0x19261959fedcba01), DPOVRD, SIZE(8), 0);
	MATHB(ZERO, RSHIFT, DPOVRD, DPOVRD, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, RSHIFT, VSEQINSZ, DPOVRD, SIZE(2), WITH(STL));
	MATHB(ZERO, RSHIFT, VSEQOUTSZ, DPOVRD, SIZE(2), WITH(STL));
	MATHB(ZERO, RSHIFT, ABD, DPOVRD, SIZE(8), 0);
	MATHB(ZERO, RSHIFT, OFIFO, DPOVRD, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, RSHIFT, ONE, DPOVRD, SIZE(4), WITH(NFU));
	MATHB(ZERO, RSHIFT, ZERO, DPOVRD, SIZE(2), WITH(STL));
	MATHB(ONE, RSHIFT, MATH0, DPOVRD, SIZE(4), 0);
	MATHB(ONE, RSHIFT, MATH1, DPOVRD, SIZE(1), 0);
	MATHB(ONE, RSHIFT, MATH2, DPOVRD, SIZE(8), WITH(NFU));
	MATHB(ONE, RSHIFT, MATH3, DPOVRD, SIZE(4), 0);
	MATHB(ONE, RSHIFT, IMM(393615378), DPOVRD, SIZE(8), WITH(IFB));
	MATHB(ONE, RSHIFT, DPOVRD, DPOVRD, SIZE(4), 0);
	MATHB(ONE, RSHIFT, VSEQINSZ, DPOVRD, SIZE(4), 0);
	MATHB(ONE, RSHIFT, VSEQOUTSZ, DPOVRD, SIZE(1), WITH(STL));
	MATHB(ONE, RSHIFT, ABD, DPOVRD, SIZE(2), 0);
	MATHB(ONE, RSHIFT, OFIFO, DPOVRD, SIZE(4), 0);
	MATHB(ONE, RSHIFT, ONE, DPOVRD, SIZE(1), 0);
	MATHB(ONE, RSHIFT, ZERO, DPOVRD, SIZE(8), 0);
	/* RSHIFT Operation: SEQINSZ Destination register */
	MATHB(MATH0, RSHIFT, MATH0, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH0, RSHIFT, MATH1, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH0, RSHIFT, MATH2, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH0, RSHIFT, MATH3, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(MATH0, RSHIFT, IMM(393615378), SEQINSZ, SIZE(2), 0);
	MATHB(MATH0, RSHIFT, DPOVRD, SEQINSZ, SIZE(4), 0);
	MATHB(MATH0, RSHIFT, VSEQINSZ, SEQINSZ, SIZE(8), 0);
	MATHB(MATH0, RSHIFT, VSEQOUTSZ, SEQINSZ, SIZE(4), 0);
	MATHB(MATH0, RSHIFT, ABD, SEQINSZ, SIZE(2), 0);
	MATHB(MATH0, RSHIFT, OFIFO, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH0, RSHIFT, ONE, SEQINSZ, SIZE(8), 0);
	MATHB(MATH0, RSHIFT, ZERO, SEQINSZ, SIZE(1), 0);
	MATHB(MATH1, RSHIFT, MATH0, SEQINSZ, SIZE(8), 0);
	MATHB(MATH1, RSHIFT, MATH1, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH1, RSHIFT, MATH2, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH1, RSHIFT, MATH3, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH1, RSHIFT, IMM(393615378), SEQINSZ, SIZE(8), WITH(IFB));
	MATHB(MATH1, RSHIFT, DPOVRD, SEQINSZ, SIZE(8), 0);
	MATHB(MATH1, RSHIFT, VSEQINSZ, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(MATH1, RSHIFT, VSEQOUTSZ, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH1, RSHIFT, ABD, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH1, RSHIFT, OFIFO, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH1, RSHIFT, ONE, SEQINSZ, SIZE(4), 0);
	MATHB(MATH1, RSHIFT, ZERO, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH2, RSHIFT, MATH0, SEQINSZ, SIZE(8), 0);
	MATHB(MATH2, RSHIFT, MATH1, SEQINSZ, SIZE(1), 0);
	MATHB(MATH2, RSHIFT, MATH2, SEQINSZ, SIZE(4), 0);
	MATHB(MATH2, RSHIFT, MATH3, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(MATH2, RSHIFT, IMM(393615378), SEQINSZ, SIZE(8), WITH(IFB));
	MATHB(MATH2, RSHIFT, DPOVRD, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH2, RSHIFT, VSEQINSZ, SEQINSZ, SIZE(2), 0);
	MATHB(MATH2, RSHIFT, VSEQOUTSZ, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH2, RSHIFT, ABD, SEQINSZ, SIZE(2), 0);
	MATHB(MATH2, RSHIFT, OFIFO, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(MATH2, RSHIFT, ONE, SEQINSZ, SIZE(4), 0);
	MATHB(MATH2, RSHIFT, ZERO, SEQINSZ, SIZE(1), 0);
	MATHB(MATH3, RSHIFT, MATH0, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(MATH3, RSHIFT, MATH1, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH3, RSHIFT, MATH2, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, RSHIFT, MATH3, SEQINSZ, SIZE(1), 0);
	MATHB(MATH3, RSHIFT, IMM(393615378), SEQINSZ, SIZE(2), 0);
	MATHB(MATH3, RSHIFT, DPOVRD, SEQINSZ, SIZE(8), 0);
	MATHB(MATH3, RSHIFT, VSEQINSZ, SEQINSZ, SIZE(2), 0);
	MATHB(MATH3, RSHIFT, VSEQOUTSZ, SEQINSZ, SIZE(2), 0);
	MATHB(MATH3, RSHIFT, ABD, SEQINSZ, SIZE(4), WITH(STL));
	MATHB(MATH3, RSHIFT, OFIFO, SEQINSZ, SIZE(4), 0);
	MATHB(MATH3, RSHIFT, ONE, SEQINSZ, SIZE(2), 0);
	MATHB(MATH3, RSHIFT, ZERO, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(IMM(275128321), RSHIFT, MATH0, SEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), RSHIFT, MATH1, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(IMM(275128321), RSHIFT, MATH2, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), RSHIFT, MATH3, SEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), RSHIFT, IMM(393615378), SEQINSZ, SIZE(4),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), RSHIFT, DPOVRD, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(IMM(275128321), RSHIFT, VSEQINSZ, SEQINSZ, SIZE(4), 0);
	MATHB(IMM(275128321), RSHIFT, VSEQOUTSZ, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), RSHIFT, ABD, SEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), RSHIFT, OFIFO, SEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), RSHIFT, ONE, SEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), RSHIFT, ZERO, SEQINSZ, SIZE(1), 0);
	MATHB(DPOVRD, RSHIFT, MATH0, SEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, RSHIFT, MATH1, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(DPOVRD, RSHIFT, MATH2, SEQINSZ, SIZE(4), 0);
	MATHB(DPOVRD, RSHIFT, MATH3, SEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, RSHIFT, IMM(0x19261959fedcba01), SEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, RSHIFT, DPOVRD, SEQINSZ, SIZE(8), 0);
	MATHB(DPOVRD, RSHIFT, VSEQINSZ, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(DPOVRD, RSHIFT, VSEQOUTSZ, SEQINSZ, SIZE(1), 0);
	MATHB(DPOVRD, RSHIFT, ABD, SEQINSZ, SIZE(1), 0);
	MATHB(DPOVRD, RSHIFT, OFIFO, SEQINSZ, SIZE(1), 0);
	MATHB(DPOVRD, RSHIFT, ONE, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(DPOVRD, RSHIFT, ZERO, SEQINSZ, SIZE(4), 0);
	MATHB(SEQINSZ, RSHIFT, MATH0, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, RSHIFT, MATH1, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, RSHIFT, MATH2, SEQINSZ, SIZE(4), 0);
	MATHB(SEQINSZ, RSHIFT, MATH3, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, RSHIFT, IMM(0x19261959fedcba01), SEQINSZ, SIZE(8), 0);
	MATHB(SEQINSZ, RSHIFT, DPOVRD, SEQINSZ, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, RSHIFT, VSEQINSZ, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, RSHIFT, VSEQOUTSZ, SEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, RSHIFT, ABD, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, RSHIFT, OFIFO, SEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, RSHIFT, ONE, SEQINSZ, SIZE(8), 0);
	MATHB(SEQINSZ, RSHIFT, ZERO, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, RSHIFT, MATH0, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, RSHIFT, MATH1, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, RSHIFT, MATH2, SEQINSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, RSHIFT, MATH3, SEQINSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, RSHIFT, IMM(393615378), SEQINSZ, SIZE(8), WITH(IFB));
	MATHB(SEQOUTSZ, RSHIFT, DPOVRD, SEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, RSHIFT, VSEQINSZ, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, RSHIFT, VSEQOUTSZ, SEQINSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, RSHIFT, ABD, SEQINSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, RSHIFT, OFIFO, SEQINSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, RSHIFT, ONE, SEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, RSHIFT, ZERO, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, RSHIFT, MATH0, SEQINSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, RSHIFT, MATH1, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, RSHIFT, MATH2, SEQINSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, RSHIFT, MATH3, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, RSHIFT, IMM(393615378), SEQINSZ, SIZE(2),
	      WITH(NFU | STL));
	MATHB(VSEQINSZ, RSHIFT, DPOVRD, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, RSHIFT, VSEQINSZ, SEQINSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, RSHIFT, VSEQOUTSZ, SEQINSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, RSHIFT, ABD, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQINSZ, RSHIFT, OFIFO, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, RSHIFT, ONE, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, RSHIFT, ZERO, SEQINSZ, SIZE(1), WITH(STL));
	MATHB(VSEQOUTSZ, RSHIFT, MATH0, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, RSHIFT, MATH1, SEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, RSHIFT, MATH2, SEQINSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, RSHIFT, MATH3, SEQINSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, RSHIFT, IMM(393615378), SEQINSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, RSHIFT, DPOVRD, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, RSHIFT, VSEQINSZ, SEQINSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, RSHIFT, VSEQOUTSZ, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, RSHIFT, ABD, SEQINSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, RSHIFT, OFIFO, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, RSHIFT, ONE, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, RSHIFT, ZERO, SEQINSZ, SIZE(1), 0);
	MATHB(ZERO, RSHIFT, MATH0, SEQINSZ, SIZE(2), WITH(STL));
	MATHB(ZERO, RSHIFT, MATH1, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, RSHIFT, MATH2, SEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, RSHIFT, MATH3, SEQINSZ, SIZE(4), 0);
	MATHB(ZERO, RSHIFT, IMM(393615378), SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(ZERO, RSHIFT, DPOVRD, SEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, RSHIFT, VSEQINSZ, SEQINSZ, SIZE(8), 0);
	MATHB(ZERO, RSHIFT, VSEQOUTSZ, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(ZERO, RSHIFT, ABD, SEQINSZ, SIZE(1), WITH(NFU));
	MATHB(ZERO, RSHIFT, OFIFO, SEQINSZ, SIZE(8), 0);
	MATHB(ZERO, RSHIFT, ONE, SEQINSZ, SIZE(1), 0);
	MATHB(ZERO, RSHIFT, ZERO, SEQINSZ, SIZE(1), 0);
	MATHB(ONE, RSHIFT, MATH0, SEQINSZ, SIZE(2), 0);
	MATHB(ONE, RSHIFT, MATH1, SEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ONE, RSHIFT, MATH2, SEQINSZ, SIZE(2), 0);
	MATHB(ONE, RSHIFT, MATH3, SEQINSZ, SIZE(8), 0);
	MATHB(ONE, RSHIFT, IMM(393615378), SEQINSZ, SIZE(2), 0);
	MATHB(ONE, RSHIFT, DPOVRD, SEQINSZ, SIZE(2), WITH(NFU));
	MATHB(ONE, RSHIFT, VSEQINSZ, SEQINSZ, SIZE(2), 0);
	MATHB(ONE, RSHIFT, VSEQOUTSZ, SEQINSZ, SIZE(1), 0);
	MATHB(ONE, RSHIFT, ABD, SEQINSZ, SIZE(8), 0);
	MATHB(ONE, RSHIFT, OFIFO, SEQINSZ, SIZE(8), 0);
	MATHB(ONE, RSHIFT, ONE, SEQINSZ, SIZE(8), WITH(STL));
	MATHB(ONE, RSHIFT, ZERO, SEQINSZ, SIZE(4), WITH(STL));
	/* RSHIFT Operation: SEQOUTSZ Destination register */
	MATHB(MATH0, RSHIFT, MATH0, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH0, RSHIFT, MATH1, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, RSHIFT, MATH2, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, RSHIFT, MATH3, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH0, RSHIFT, IMM(393615378), SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH0, RSHIFT, DPOVRD, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, RSHIFT, VSEQINSZ, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH0, RSHIFT, VSEQOUTSZ, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH0, RSHIFT, ABD, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, RSHIFT, OFIFO, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH0, RSHIFT, ONE, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH0, RSHIFT, ZERO, SEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(MATH1, RSHIFT, MATH0, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH1, RSHIFT, MATH1, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH1, RSHIFT, MATH2, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, RSHIFT, MATH3, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH1, RSHIFT, IMM(393615378), SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH1, RSHIFT, DPOVRD, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH1, RSHIFT, VSEQINSZ, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH1, RSHIFT, VSEQOUTSZ, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH1, RSHIFT, ABD, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, RSHIFT, OFIFO, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH1, RSHIFT, ONE, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH1, RSHIFT, ZERO, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH2, RSHIFT, MATH0, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, RSHIFT, MATH1, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, RSHIFT, MATH2, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, RSHIFT, MATH3, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH2, RSHIFT, IMM(393615378), SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH2, RSHIFT, DPOVRD, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH2, RSHIFT, VSEQINSZ, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, RSHIFT, VSEQOUTSZ, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH2, RSHIFT, ABD, SEQOUTSZ, SIZE(2), 0);
	MATHB(MATH2, RSHIFT, OFIFO, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH2, RSHIFT, ONE, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH2, RSHIFT, ZERO, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH3, RSHIFT, MATH0, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH3, RSHIFT, MATH1, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, RSHIFT, MATH2, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, RSHIFT, MATH3, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(MATH3, RSHIFT, IMM(393615378), SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, RSHIFT, DPOVRD, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, RSHIFT, VSEQINSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(MATH3, RSHIFT, VSEQOUTSZ, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, RSHIFT, ABD, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, RSHIFT, OFIFO, SEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, RSHIFT, ONE, SEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, RSHIFT, ZERO, SEQOUTSZ, SIZE(2), 0);
	MATHB(IMM(275128321), RSHIFT, MATH0, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(IMM(275128321), RSHIFT, MATH1, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(IMM(0x19261959fedcba01), RSHIFT, MATH2, SEQOUTSZ, SIZE(8),
	      WITH(STL));
	MATHB(IMM(275128321), RSHIFT, MATH3, SEQOUTSZ, SIZE(2),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), RSHIFT, IMM(393615378), SEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), RSHIFT, DPOVRD, SEQOUTSZ, SIZE(1), 0);
	MATHB(IMM(275128321), RSHIFT, VSEQINSZ, SEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), RSHIFT, VSEQOUTSZ, SEQOUTSZ, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), RSHIFT, ABD, SEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), RSHIFT, OFIFO, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), RSHIFT, ONE, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), RSHIFT, ZERO, SEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, RSHIFT, MATH0, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(DPOVRD, RSHIFT, MATH1, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(DPOVRD, RSHIFT, MATH2, SEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, RSHIFT, MATH3, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, RSHIFT, IMM(393615378), SEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, RSHIFT, DPOVRD, SEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, RSHIFT, VSEQINSZ, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(DPOVRD, RSHIFT, VSEQOUTSZ, SEQOUTSZ, SIZE(1), 0);
	MATHB(DPOVRD, RSHIFT, ABD, SEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, RSHIFT, OFIFO, SEQOUTSZ, SIZE(4), 0);
	MATHB(DPOVRD, RSHIFT, ONE, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(DPOVRD, RSHIFT, ZERO, SEQOUTSZ, SIZE(4), 0);
	MATHB(SEQINSZ, RSHIFT, MATH0, SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, RSHIFT, MATH1, SEQOUTSZ, SIZE(8), 0);
	MATHB(SEQINSZ, RSHIFT, MATH2, SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQINSZ, RSHIFT, MATH3, SEQOUTSZ, SIZE(4), 0);
	MATHB(SEQINSZ, RSHIFT, IMM(393615378), SEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, RSHIFT, DPOVRD, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, RSHIFT, VSEQINSZ, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, RSHIFT, VSEQOUTSZ, SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQINSZ, RSHIFT, ABD, SEQOUTSZ, SIZE(4), 0);
	MATHB(SEQINSZ, RSHIFT, OFIFO, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, RSHIFT, ONE, SEQOUTSZ, SIZE(4), 0);
	MATHB(SEQINSZ, RSHIFT, ZERO, SEQOUTSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, RSHIFT, MATH0, SEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, RSHIFT, MATH1, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQOUTSZ, RSHIFT, MATH2, SEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, RSHIFT, MATH3, SEQOUTSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, RSHIFT, IMM(393615378), SEQOUTSZ, SIZE(4),
	      WITH(NFU | STL));
	MATHB(SEQOUTSZ, RSHIFT, DPOVRD, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQOUTSZ, RSHIFT, VSEQINSZ, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQOUTSZ, RSHIFT, VSEQOUTSZ, SEQOUTSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, RSHIFT, ABD, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, RSHIFT, OFIFO, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, RSHIFT, ONE, SEQOUTSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, RSHIFT, ZERO, SEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, RSHIFT, MATH0, SEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, RSHIFT, MATH1, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, RSHIFT, MATH2, SEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, RSHIFT, MATH3, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, RSHIFT, IMM(393615378), SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, RSHIFT, DPOVRD, SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, RSHIFT, VSEQINSZ, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(VSEQINSZ, RSHIFT, VSEQOUTSZ, SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, RSHIFT, ABD, SEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, RSHIFT, OFIFO, SEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, RSHIFT, ONE, SEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, RSHIFT, ZERO, SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, RSHIFT, MATH0, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, RSHIFT, MATH1, SEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, RSHIFT, MATH2, SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, RSHIFT, MATH3, SEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, RSHIFT, IMM(393615378), SEQOUTSZ, SIZE(4),
	      WITH(NFU | STL));
	MATHB(VSEQOUTSZ, RSHIFT, DPOVRD, SEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, RSHIFT, VSEQINSZ, SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, RSHIFT, VSEQOUTSZ, SEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, RSHIFT, ABD, SEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, RSHIFT, OFIFO, SEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, RSHIFT, ONE, SEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, RSHIFT, ZERO, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(ZERO, RSHIFT, MATH0, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(ZERO, RSHIFT, MATH1, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(ZERO, RSHIFT, MATH2, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(ZERO, RSHIFT, MATH3, SEQOUTSZ, SIZE(8), 0);
	MATHB(ZERO, RSHIFT, IMM(393615378), SEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, RSHIFT, DPOVRD, SEQOUTSZ, SIZE(8), 0);
	MATHB(ZERO, RSHIFT, VSEQINSZ, SEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, RSHIFT, VSEQOUTSZ, SEQOUTSZ, SIZE(8), 0);
	MATHB(ZERO, RSHIFT, ABD, SEQOUTSZ, SIZE(4), 0);
	MATHB(ZERO, RSHIFT, OFIFO, SEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(ZERO, RSHIFT, ONE, SEQOUTSZ, SIZE(1), 0);
	MATHB(ZERO, RSHIFT, ZERO, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(ONE, RSHIFT, MATH0, SEQOUTSZ, SIZE(2), 0);
	MATHB(ONE, RSHIFT, MATH1, SEQOUTSZ, SIZE(8), 0);
	MATHB(ONE, RSHIFT, MATH2, SEQOUTSZ, SIZE(2), 0);
	MATHB(ONE, RSHIFT, MATH3, SEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(ONE, RSHIFT, IMM(393615378), SEQOUTSZ, SIZE(2), 0);
	MATHB(ONE, RSHIFT, DPOVRD, SEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, RSHIFT, VSEQINSZ, SEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, RSHIFT, VSEQOUTSZ, SEQOUTSZ, SIZE(4), 0);
	MATHB(ONE, RSHIFT, ABD, SEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(ONE, RSHIFT, OFIFO, SEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(ONE, RSHIFT, ONE, SEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(ONE, RSHIFT, ZERO, SEQOUTSZ, SIZE(2), WITH(STL));
	/* RSHIFT Operation: VSEQINSZ Destination register */
	MATHB(MATH0, RSHIFT, MATH0, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH0, RSHIFT, MATH1, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH0, RSHIFT, MATH2, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH0, RSHIFT, MATH3, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH0, RSHIFT, IMM(393615378), VSEQINSZ, SIZE(4), 0);
	MATHB(MATH0, RSHIFT, DPOVRD, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH0, RSHIFT, VSEQINSZ, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(MATH0, RSHIFT, VSEQOUTSZ, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(MATH0, RSHIFT, ABD, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH0, RSHIFT, OFIFO, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(MATH0, RSHIFT, ONE, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH0, RSHIFT, ZERO, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(MATH1, RSHIFT, MATH0, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(MATH1, RSHIFT, MATH1, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH1, RSHIFT, MATH2, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH1, RSHIFT, MATH3, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, RSHIFT, IMM(393615378), VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(MATH1, RSHIFT, DPOVRD, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH1, RSHIFT, VSEQINSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH1, RSHIFT, VSEQOUTSZ, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH1, RSHIFT, ABD, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH1, RSHIFT, OFIFO, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH1, RSHIFT, ONE, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH1, RSHIFT, ZERO, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH2, RSHIFT, MATH0, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH2, RSHIFT, MATH1, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(MATH2, RSHIFT, MATH2, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH2, RSHIFT, MATH3, VSEQINSZ, SIZE(8), 0);
	MATHB(MATH2, RSHIFT, IMM(393615378), VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(MATH2, RSHIFT, DPOVRD, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(MATH2, RSHIFT, VSEQINSZ, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(MATH2, RSHIFT, VSEQOUTSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH2, RSHIFT, ABD, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH2, RSHIFT, OFIFO, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(MATH2, RSHIFT, ONE, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, RSHIFT, ZERO, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, RSHIFT, MATH0, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, RSHIFT, MATH1, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH3, RSHIFT, MATH2, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH3, RSHIFT, MATH3, VSEQINSZ, SIZE(1), 0);
	MATHB(MATH3, RSHIFT, IMM(0x19261959fedcba01), VSEQINSZ, SIZE(8),
	      WITH(NFU | STL));
	MATHB(MATH3, RSHIFT, DPOVRD, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, RSHIFT, VSEQINSZ, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(MATH3, RSHIFT, VSEQOUTSZ, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH3, RSHIFT, ABD, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, RSHIFT, OFIFO, VSEQINSZ, SIZE(2), 0);
	MATHB(MATH3, RSHIFT, ONE, VSEQINSZ, SIZE(4), 0);
	MATHB(MATH3, RSHIFT, ZERO, VSEQINSZ, SIZE(8), 0);
	MATHB(IMM(275128321), RSHIFT, MATH0, VSEQINSZ, SIZE(8), WITH(IFB));
	MATHB(IMM(0x19261959fedcba01), RSHIFT, MATH1, VSEQINSZ, SIZE(8),
	      WITH(NFU));
	MATHB(IMM(275128321), RSHIFT, MATH2, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(IMM(275128321), RSHIFT, MATH3, VSEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), RSHIFT, IMM(393615378), VSEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), RSHIFT, DPOVRD, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(IMM(0x19261959fedcba01), RSHIFT, VSEQINSZ, VSEQINSZ, SIZE(8), 0);
	MATHB(IMM(275128321), RSHIFT, VSEQOUTSZ, VSEQINSZ, SIZE(8), WITH(IFB));
	MATHB(IMM(275128321), RSHIFT, ABD, VSEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), RSHIFT, OFIFO, VSEQINSZ, SIZE(2), 0);
	MATHB(IMM(275128321), RSHIFT, ONE, VSEQINSZ, SIZE(1), 0);
	MATHB(IMM(275128321), RSHIFT, ZERO, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(DPOVRD, RSHIFT, MATH0, VSEQINSZ, SIZE(1), 0);
	MATHB(DPOVRD, RSHIFT, MATH1, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(DPOVRD, RSHIFT, MATH2, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, RSHIFT, MATH3, VSEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, RSHIFT, IMM(393615378), VSEQINSZ, SIZE(8),
	      WITH(IFB | STL));
	MATHB(DPOVRD, RSHIFT, DPOVRD, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(DPOVRD, RSHIFT, VSEQINSZ, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(DPOVRD, RSHIFT, VSEQOUTSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(DPOVRD, RSHIFT, ABD, VSEQINSZ, SIZE(1), 0);
	MATHB(DPOVRD, RSHIFT, OFIFO, VSEQINSZ, SIZE(1), 0);
	MATHB(DPOVRD, RSHIFT, ONE, VSEQINSZ, SIZE(2), 0);
	MATHB(DPOVRD, RSHIFT, ZERO, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(SEQINSZ, RSHIFT, MATH0, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, RSHIFT, MATH1, VSEQINSZ, SIZE(4), 0);
	MATHB(SEQINSZ, RSHIFT, MATH2, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, RSHIFT, MATH3, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, RSHIFT, IMM(393615378), VSEQINSZ, SIZE(4),
	      WITH(NFU | STL));
	MATHB(SEQINSZ, RSHIFT, DPOVRD, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, RSHIFT, VSEQINSZ, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(SEQINSZ, RSHIFT, VSEQOUTSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(SEQINSZ, RSHIFT, ABD, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, RSHIFT, OFIFO, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, RSHIFT, ONE, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQINSZ, RSHIFT, ZERO, VSEQINSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, RSHIFT, MATH0, VSEQINSZ, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, RSHIFT, MATH1, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(SEQOUTSZ, RSHIFT, MATH2, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, RSHIFT, MATH3, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, RSHIFT, IMM(393615378), VSEQINSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, RSHIFT, DPOVRD, VSEQINSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, RSHIFT, VSEQINSZ, VSEQINSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, RSHIFT, VSEQOUTSZ, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, RSHIFT, ABD, VSEQINSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, RSHIFT, OFIFO, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, RSHIFT, ONE, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQOUTSZ, RSHIFT, ZERO, VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, RSHIFT, MATH0, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, RSHIFT, MATH1, VSEQINSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, RSHIFT, MATH2, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, RSHIFT, MATH3, VSEQINSZ, SIZE(4), WITH(STL));
	MATHB(VSEQINSZ, RSHIFT, IMM(393615378), VSEQINSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, RSHIFT, DPOVRD, VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, RSHIFT, VSEQINSZ, VSEQINSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, RSHIFT, VSEQOUTSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, RSHIFT, ABD, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, RSHIFT, OFIFO, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, RSHIFT, ONE, VSEQINSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, RSHIFT, ZERO, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, RSHIFT, MATH0, VSEQINSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, RSHIFT, MATH1, VSEQINSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, RSHIFT, MATH2, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, RSHIFT, MATH3, VSEQINSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, RSHIFT, IMM(393615378), VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, RSHIFT, DPOVRD, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, RSHIFT, VSEQINSZ, VSEQINSZ, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, RSHIFT, VSEQOUTSZ, VSEQINSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, RSHIFT, ABD, VSEQINSZ, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, RSHIFT, OFIFO, VSEQINSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, RSHIFT, ONE, VSEQINSZ, SIZE(8), 0);
	MATHB(VSEQOUTSZ, RSHIFT, ZERO, VSEQINSZ, SIZE(2), WITH(NFU));
	MATHB(ZERO, RSHIFT, MATH0, VSEQINSZ, SIZE(4), 0);
	MATHB(ZERO, RSHIFT, MATH1, VSEQINSZ, SIZE(8), 0);
	MATHB(ZERO, RSHIFT, MATH2, VSEQINSZ, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, RSHIFT, MATH3, VSEQINSZ, SIZE(8), 0);
	MATHB(ZERO, RSHIFT, IMM(393615378), VSEQINSZ, SIZE(1), 0);
	MATHB(ZERO, RSHIFT, DPOVRD, VSEQINSZ, SIZE(8), 0);
	MATHB(ZERO, RSHIFT, VSEQINSZ, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(ZERO, RSHIFT, VSEQOUTSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(ZERO, RSHIFT, ABD, VSEQINSZ, SIZE(1), 0);
	MATHB(ZERO, RSHIFT, OFIFO, VSEQINSZ, SIZE(8), WITH(NFU));
	MATHB(ZERO, RSHIFT, ONE, VSEQINSZ, SIZE(8), 0);
	MATHB(ZERO, RSHIFT, ZERO, VSEQINSZ, SIZE(4), 0);
	MATHB(ONE, RSHIFT, MATH0, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(ONE, RSHIFT, MATH1, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(ONE, RSHIFT, MATH2, VSEQINSZ, SIZE(8), WITH(STL));
	MATHB(ONE, RSHIFT, MATH3, VSEQINSZ, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, RSHIFT, IMM(393615378), VSEQINSZ, SIZE(4), 0);
	MATHB(ONE, RSHIFT, DPOVRD, VSEQINSZ, SIZE(8), 0);
	MATHB(ONE, RSHIFT, VSEQINSZ, VSEQINSZ, SIZE(1), 0);
	MATHB(ONE, RSHIFT, VSEQOUTSZ, VSEQINSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ONE, RSHIFT, ABD, VSEQINSZ, SIZE(2), 0);
	MATHB(ONE, RSHIFT, OFIFO, VSEQINSZ, SIZE(8), 0);
	MATHB(ONE, RSHIFT, ONE, VSEQINSZ, SIZE(1), WITH(STL));
	MATHB(ONE, RSHIFT, ZERO, VSEQINSZ, SIZE(1), 0);
	/* RSHIFT Operation: VSEQOUTSZ Destination register */
	MATHB(MATH0, RSHIFT, MATH0, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, RSHIFT, MATH1, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH0, RSHIFT, MATH2, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH0, RSHIFT, MATH3, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, RSHIFT, IMM(393615378), VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH0, RSHIFT, DPOVRD, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH0, RSHIFT, VSEQINSZ, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH0, RSHIFT, VSEQOUTSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH0, RSHIFT, ABD, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(MATH0, RSHIFT, OFIFO, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(MATH0, RSHIFT, ONE, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH0, RSHIFT, ZERO, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(MATH1, RSHIFT, MATH0, VSEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH1, RSHIFT, MATH1, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH1, RSHIFT, MATH2, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(MATH1, RSHIFT, MATH3, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(MATH1, RSHIFT, IMM(393615378), VSEQOUTSZ, SIZE(4),
	      WITH(NFU | STL));
	MATHB(MATH1, RSHIFT, DPOVRD, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(MATH1, RSHIFT, VSEQINSZ, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, RSHIFT, VSEQOUTSZ, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH1, RSHIFT, ABD, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH1, RSHIFT, OFIFO, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH1, RSHIFT, ONE, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(MATH1, RSHIFT, ZERO, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH2, RSHIFT, MATH0, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, RSHIFT, MATH1, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH2, RSHIFT, MATH2, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH2, RSHIFT, MATH3, VSEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, RSHIFT, IMM(393615378), VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH2, RSHIFT, DPOVRD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH2, RSHIFT, VSEQINSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH2, RSHIFT, VSEQOUTSZ, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(MATH2, RSHIFT, ABD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH2, RSHIFT, OFIFO, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(MATH2, RSHIFT, ONE, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH2, RSHIFT, ZERO, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH3, RSHIFT, MATH0, VSEQOUTSZ, SIZE(1), 0);
	MATHB(MATH3, RSHIFT, MATH1, VSEQOUTSZ, SIZE(8), 0);
	MATHB(MATH3, RSHIFT, MATH2, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH3, RSHIFT, MATH3, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH3, RSHIFT, IMM(393615378), VSEQOUTSZ, SIZE(8), WITH(IFB));
	MATHB(MATH3, RSHIFT, DPOVRD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(MATH3, RSHIFT, VSEQINSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH3, RSHIFT, VSEQOUTSZ, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(MATH3, RSHIFT, ABD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(MATH3, RSHIFT, OFIFO, VSEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(MATH3, RSHIFT, ONE, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(MATH3, RSHIFT, ZERO, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(IMM(275128321), RSHIFT, MATH0, VSEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(0x19261959fedcba01), RSHIFT, MATH1, VSEQOUTSZ, SIZE(8),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), RSHIFT, MATH2, VSEQOUTSZ, SIZE(8), WITH(IFB));
	MATHB(IMM(0x19261959fedcba01), RSHIFT, MATH3, VSEQOUTSZ, SIZE(8), 0);
	MATHB(IMM(275128321), RSHIFT, IMM(393615378), VSEQOUTSZ, SIZE(4), 0);
	MATHB(IMM(275128321), RSHIFT, DPOVRD, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(IMM(275128321), RSHIFT, VSEQINSZ, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), RSHIFT, VSEQOUTSZ, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), RSHIFT, ABD, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(IMM(275128321), RSHIFT, OFIFO, VSEQOUTSZ, SIZE(1), 0);
	MATHB(IMM(275128321), RSHIFT, ONE, VSEQOUTSZ, SIZE(8), WITH(IFB | NFU));
	MATHB(IMM(275128321), RSHIFT, ZERO, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(DPOVRD, RSHIFT, MATH0, VSEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, RSHIFT, MATH1, VSEQOUTSZ, SIZE(4), 0);
	MATHB(DPOVRD, RSHIFT, MATH2, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, RSHIFT, MATH3, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(DPOVRD, RSHIFT, IMM(393615378), VSEQOUTSZ, SIZE(8), WITH(IFB));
	MATHB(DPOVRD, RSHIFT, DPOVRD, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(DPOVRD, RSHIFT, VSEQINSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, RSHIFT, VSEQOUTSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(DPOVRD, RSHIFT, ABD, VSEQOUTSZ, SIZE(8), 0);
	MATHB(DPOVRD, RSHIFT, OFIFO, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(DPOVRD, RSHIFT, ONE, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(DPOVRD, RSHIFT, ZERO, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, RSHIFT, MATH0, VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQINSZ, RSHIFT, MATH1, VSEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, RSHIFT, MATH2, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(SEQINSZ, RSHIFT, MATH3, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQINSZ, RSHIFT, IMM(393615378), VSEQOUTSZ, SIZE(8),
	      WITH(IFB | STL));
	MATHB(SEQINSZ, RSHIFT, DPOVRD, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(SEQINSZ, RSHIFT, VSEQINSZ, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, RSHIFT, VSEQOUTSZ, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQINSZ, RSHIFT, ABD, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(SEQINSZ, RSHIFT, OFIFO, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(SEQINSZ, RSHIFT, ONE, VSEQOUTSZ, SIZE(1), 0);
	MATHB(SEQINSZ, RSHIFT, ZERO, VSEQOUTSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, RSHIFT, MATH0, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(SEQOUTSZ, RSHIFT, MATH1, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(SEQOUTSZ, RSHIFT, MATH2, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(SEQOUTSZ, RSHIFT, MATH3, VSEQOUTSZ, SIZE(8), 0);
	MATHB(SEQOUTSZ, RSHIFT, IMM(393615378), VSEQOUTSZ, SIZE(2), 0);
	MATHB(SEQOUTSZ, RSHIFT, DPOVRD, VSEQOUTSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, RSHIFT, VSEQINSZ, VSEQOUTSZ, SIZE(1), 0);
	MATHB(SEQOUTSZ, RSHIFT, VSEQOUTSZ, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(SEQOUTSZ, RSHIFT, ABD, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, RSHIFT, OFIFO, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(SEQOUTSZ, RSHIFT, ONE, VSEQOUTSZ, SIZE(4), 0);
	MATHB(SEQOUTSZ, RSHIFT, ZERO, VSEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, RSHIFT, MATH0, VSEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQINSZ, RSHIFT, MATH1, VSEQOUTSZ, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, RSHIFT, MATH2, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(VSEQINSZ, RSHIFT, MATH3, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, RSHIFT, IMM(393615378), VSEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQINSZ, RSHIFT, DPOVRD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, RSHIFT, VSEQINSZ, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQINSZ, RSHIFT, VSEQOUTSZ, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQINSZ, RSHIFT, ABD, VSEQOUTSZ, SIZE(8), 0);
	MATHB(VSEQINSZ, RSHIFT, OFIFO, VSEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQINSZ, RSHIFT, ONE, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(VSEQINSZ, RSHIFT, ZERO, VSEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, RSHIFT, MATH0, VSEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, RSHIFT, MATH1, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, RSHIFT, MATH2, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(VSEQOUTSZ, RSHIFT, MATH3, VSEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, RSHIFT, IMM(0x19261959fedcba01), VSEQOUTSZ, SIZE(8),
	      0);
	MATHB(VSEQOUTSZ, RSHIFT, DPOVRD, VSEQOUTSZ, SIZE(1), WITH(NFU));
	MATHB(VSEQOUTSZ, RSHIFT, VSEQINSZ, VSEQOUTSZ, SIZE(1), 0);
	MATHB(VSEQOUTSZ, RSHIFT, VSEQOUTSZ, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, RSHIFT, ABD, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(VSEQOUTSZ, RSHIFT, OFIFO, VSEQOUTSZ, SIZE(2), 0);
	MATHB(VSEQOUTSZ, RSHIFT, ONE, VSEQOUTSZ, SIZE(4), 0);
	MATHB(VSEQOUTSZ, RSHIFT, ZERO, VSEQOUTSZ, SIZE(8), 0);
	MATHB(ZERO, RSHIFT, MATH0, VSEQOUTSZ, SIZE(4), WITH(NFU | STL));
	MATHB(ZERO, RSHIFT, MATH1, VSEQOUTSZ, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, RSHIFT, MATH2, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(ZERO, RSHIFT, MATH3, VSEQOUTSZ, SIZE(8), WITH(STL));
	MATHB(ZERO, RSHIFT, IMM(393615378), VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(ZERO, RSHIFT, DPOVRD, VSEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, RSHIFT, VSEQINSZ, VSEQOUTSZ, SIZE(2), WITH(NFU | STL));
	MATHB(ZERO, RSHIFT, VSEQOUTSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(ZERO, RSHIFT, ABD, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(ZERO, RSHIFT, OFIFO, VSEQOUTSZ, SIZE(4), 0);
	MATHB(ZERO, RSHIFT, ONE, VSEQOUTSZ, SIZE(4), 0);
	MATHB(ZERO, RSHIFT, ZERO, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(ONE, RSHIFT, MATH0, VSEQOUTSZ, SIZE(8), WITH(NFU));
	MATHB(ONE, RSHIFT, MATH1, VSEQOUTSZ, SIZE(2), 0);
	MATHB(ONE, RSHIFT, MATH2, VSEQOUTSZ, SIZE(1), 0);
	MATHB(ONE, RSHIFT, MATH3, VSEQOUTSZ, SIZE(8), WITH(NFU | STL));
	MATHB(ONE, RSHIFT, IMM(393615378), VSEQOUTSZ, SIZE(2), 0);
	MATHB(ONE, RSHIFT, DPOVRD, VSEQOUTSZ, SIZE(8), 0);
	MATHB(ONE, RSHIFT, VSEQINSZ, VSEQOUTSZ, SIZE(2), 0);
	MATHB(ONE, RSHIFT, VSEQOUTSZ, VSEQOUTSZ, SIZE(4), WITH(NFU));
	MATHB(ONE, RSHIFT, ABD, VSEQOUTSZ, SIZE(1), WITH(STL));
	MATHB(ONE, RSHIFT, OFIFO, VSEQOUTSZ, SIZE(2), WITH(NFU));
	MATHB(ONE, RSHIFT, ONE, VSEQOUTSZ, SIZE(4), WITH(STL));
	MATHB(ONE, RSHIFT, ZERO, VSEQOUTSZ, SIZE(1), 0);
	/* RSHIFT Operation: NONE Destination register */
	MATHB(MATH0, RSHIFT, MATH0, NONE, SIZE(8), WITH(NFU));
	MATHB(MATH0, RSHIFT, MATH1, NONE, SIZE(1), 0);
	MATHB(MATH0, RSHIFT, MATH2, NONE, SIZE(8), 0);
	MATHB(MATH0, RSHIFT, MATH3, NONE, SIZE(4), 0);
	MATHB(MATH0, RSHIFT, IMM(0x19261959fedcba01), NONE, SIZE(8), 0);
	MATHB(MATH0, RSHIFT, DPOVRD, NONE, SIZE(1), WITH(STL));
	MATHB(MATH0, RSHIFT, VSEQINSZ, NONE, SIZE(8), 0);
	MATHB(MATH0, RSHIFT, VSEQOUTSZ, NONE, SIZE(4), 0);
	MATHB(MATH0, RSHIFT, ABD, NONE, SIZE(4), 0);
	MATHB(MATH0, RSHIFT, OFIFO, NONE, SIZE(2), WITH(STL));
	MATHB(MATH0, RSHIFT, ONE, NONE, SIZE(4), 0);
	MATHB(MATH0, RSHIFT, ZERO, NONE, SIZE(4), WITH(NFU));
	MATHB(MATH1, RSHIFT, MATH0, NONE, SIZE(8), 0);
	MATHB(MATH1, RSHIFT, MATH1, NONE, SIZE(8), 0);
	MATHB(MATH1, RSHIFT, MATH2, NONE, SIZE(4), 0);
	MATHB(MATH1, RSHIFT, MATH3, NONE, SIZE(1), 0);
	MATHB(MATH1, RSHIFT, IMM(0x19261959fedcba01), NONE, SIZE(8), WITH(STL));
	MATHB(MATH1, RSHIFT, DPOVRD, NONE, SIZE(8), 0);
	MATHB(MATH1, RSHIFT, VSEQINSZ, NONE, SIZE(2), WITH(NFU));
	MATHB(MATH1, RSHIFT, VSEQOUTSZ, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(MATH1, RSHIFT, ABD, NONE, SIZE(4), WITH(STL));
	MATHB(MATH1, RSHIFT, OFIFO, NONE, SIZE(4), 0);
	MATHB(MATH1, RSHIFT, ONE, NONE, SIZE(1), 0);
	MATHB(MATH1, RSHIFT, ZERO, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(MATH2, RSHIFT, MATH0, NONE, SIZE(2), 0);
	MATHB(MATH2, RSHIFT, MATH1, NONE, SIZE(1), 0);
	MATHB(MATH2, RSHIFT, MATH2, NONE, SIZE(1), WITH(STL));
	MATHB(MATH2, RSHIFT, MATH3, NONE, SIZE(1), WITH(NFU));
	MATHB(MATH2, RSHIFT, IMM(393615378), NONE, SIZE(1), WITH(NFU));
	MATHB(MATH2, RSHIFT, DPOVRD, NONE, SIZE(8), 0);
	MATHB(MATH2, RSHIFT, VSEQINSZ, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(MATH2, RSHIFT, VSEQOUTSZ, NONE, SIZE(4), 0);
	MATHB(MATH2, RSHIFT, ABD, NONE, SIZE(8), 0);
	MATHB(MATH2, RSHIFT, OFIFO, NONE, SIZE(2), 0);
	MATHB(MATH2, RSHIFT, ONE, NONE, SIZE(2), 0);
	MATHB(MATH2, RSHIFT, ZERO, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, RSHIFT, MATH0, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, RSHIFT, MATH1, NONE, SIZE(4), 0);
	MATHB(MATH3, RSHIFT, MATH2, NONE, SIZE(8), 0);
	MATHB(MATH3, RSHIFT, MATH3, NONE, SIZE(1), 0);
	MATHB(MATH3, RSHIFT, IMM(393615378), NONE, SIZE(1), WITH(STL));
	MATHB(MATH3, RSHIFT, DPOVRD, NONE, SIZE(1), 0);
	MATHB(MATH3, RSHIFT, VSEQINSZ, NONE, SIZE(2), 0);
	MATHB(MATH3, RSHIFT, VSEQOUTSZ, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(MATH3, RSHIFT, ABD, NONE, SIZE(4), WITH(NFU));
	MATHB(MATH3, RSHIFT, OFIFO, NONE, SIZE(8), WITH(STL));
	MATHB(MATH3, RSHIFT, ONE, NONE, SIZE(2), 0);
	MATHB(MATH3, RSHIFT, ZERO, NONE, SIZE(2), 0);
	MATHB(IMM(0x19261959fedcba01), RSHIFT, MATH0, NONE, SIZE(8), 0);
	MATHB(IMM(275128321), RSHIFT, MATH1, NONE, SIZE(1), 0);
	MATHB(IMM(275128321), RSHIFT, MATH2, NONE, SIZE(4), 0);
	MATHB(IMM(275128321), RSHIFT, MATH3, NONE, SIZE(2), WITH(STL));
	MATHB(IMM(275128321), RSHIFT, IMM(393615378), NONE, SIZE(2),
	      WITH(NFU | STL));
	MATHB(IMM(275128321), RSHIFT, DPOVRD, NONE, SIZE(1), 0);
	MATHB(IMM(275128321), RSHIFT, VSEQINSZ, NONE, SIZE(1), WITH(STL));
	MATHB(IMM(275128321), RSHIFT, VSEQOUTSZ, NONE, SIZE(4), WITH(STL));
	MATHB(IMM(275128321), RSHIFT, ABD, NONE, SIZE(1), 0);
	MATHB(IMM(275128321), RSHIFT, OFIFO, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(IMM(275128321), RSHIFT, ONE, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(IMM(275128321), RSHIFT, ZERO, NONE, SIZE(4), 0);
	MATHB(DPOVRD, RSHIFT, MATH0, NONE, SIZE(1), 0);
	MATHB(DPOVRD, RSHIFT, MATH1, NONE, SIZE(8), 0);
	MATHB(DPOVRD, RSHIFT, MATH2, NONE, SIZE(2), 0);
	MATHB(DPOVRD, RSHIFT, MATH3, NONE, SIZE(4), 0);
	MATHB(DPOVRD, RSHIFT, IMM(393615378), NONE, SIZE(2), WITH(STL));
	MATHB(DPOVRD, RSHIFT, DPOVRD, NONE, SIZE(2), 0);
	MATHB(DPOVRD, RSHIFT, VSEQINSZ, NONE, SIZE(8), WITH(STL));
	MATHB(DPOVRD, RSHIFT, VSEQOUTSZ, NONE, SIZE(2), 0);
	MATHB(DPOVRD, RSHIFT, ABD, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(DPOVRD, RSHIFT, OFIFO, NONE, SIZE(8), WITH(STL));
	MATHB(DPOVRD, RSHIFT, ONE, NONE, SIZE(4), 0);
	MATHB(DPOVRD, RSHIFT, ZERO, NONE, SIZE(4), 0);
	MATHB(SEQINSZ, RSHIFT, MATH0, NONE, SIZE(8), 0);
	MATHB(SEQINSZ, RSHIFT, MATH1, NONE, SIZE(8), WITH(STL));
	MATHB(SEQINSZ, RSHIFT, MATH2, NONE, SIZE(2), WITH(NFU | STL));
	MATHB(SEQINSZ, RSHIFT, MATH3, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, RSHIFT, IMM(0x19261959fedcba01), NONE, SIZE(8), 0);
	MATHB(SEQINSZ, RSHIFT, DPOVRD, NONE, SIZE(2), 0);
	MATHB(SEQINSZ, RSHIFT, VSEQINSZ, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(SEQINSZ, RSHIFT, VSEQOUTSZ, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(SEQINSZ, RSHIFT, ABD, NONE, SIZE(1), WITH(NFU));
	MATHB(SEQINSZ, RSHIFT, OFIFO, NONE, SIZE(2), 0);
	MATHB(SEQINSZ, RSHIFT, ONE, NONE, SIZE(2), 0);
	MATHB(SEQINSZ, RSHIFT, ZERO, NONE, SIZE(8), 0);
	MATHB(SEQOUTSZ, RSHIFT, MATH0, NONE, SIZE(4), 0);
	MATHB(SEQOUTSZ, RSHIFT, MATH1, NONE, SIZE(8), 0);
	MATHB(SEQOUTSZ, RSHIFT, MATH2, NONE, SIZE(2), WITH(NFU));
	MATHB(SEQOUTSZ, RSHIFT, MATH3, NONE, SIZE(2), 0);
	MATHB(SEQOUTSZ, RSHIFT, IMM(393615378), NONE, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, RSHIFT, DPOVRD, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(SEQOUTSZ, RSHIFT, VSEQINSZ, NONE, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, RSHIFT, VSEQOUTSZ, NONE, SIZE(4), WITH(STL));
	MATHB(SEQOUTSZ, RSHIFT, ABD, NONE, SIZE(1), 0);
	MATHB(SEQOUTSZ, RSHIFT, OFIFO, NONE, SIZE(1), 0);
	MATHB(SEQOUTSZ, RSHIFT, ONE, NONE, SIZE(2), WITH(STL));
	MATHB(SEQOUTSZ, RSHIFT, ZERO, NONE, SIZE(2), 0);
	MATHB(VSEQINSZ, RSHIFT, MATH0, NONE, SIZE(4), 0);
	MATHB(VSEQINSZ, RSHIFT, MATH1, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(VSEQINSZ, RSHIFT, MATH2, NONE, SIZE(2), WITH(STL));
	MATHB(VSEQINSZ, RSHIFT, MATH3, NONE, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, RSHIFT, IMM(393615378), NONE, SIZE(2), 0);
	MATHB(VSEQINSZ, RSHIFT, DPOVRD, NONE, SIZE(2), 0);
	MATHB(VSEQINSZ, RSHIFT, VSEQINSZ, NONE, SIZE(2), 0);
	MATHB(VSEQINSZ, RSHIFT, VSEQOUTSZ, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(VSEQINSZ, RSHIFT, ABD, NONE, SIZE(8), 0);
	MATHB(VSEQINSZ, RSHIFT, OFIFO, NONE, SIZE(1), WITH(STL));
	MATHB(VSEQINSZ, RSHIFT, ONE, NONE, SIZE(1), 0);
	MATHB(VSEQINSZ, RSHIFT, ZERO, NONE, SIZE(8), 0);
	MATHB(VSEQOUTSZ, RSHIFT, MATH0, NONE, SIZE(4), WITH(NFU));
	MATHB(VSEQOUTSZ, RSHIFT, MATH1, NONE, SIZE(4), 0);
	MATHB(VSEQOUTSZ, RSHIFT, MATH2, NONE, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, RSHIFT, MATH3, NONE, SIZE(1), 0);
	MATHB(VSEQOUTSZ, RSHIFT, IMM(393615378), NONE, SIZE(2), WITH(STL));
	MATHB(VSEQOUTSZ, RSHIFT, DPOVRD, NONE, SIZE(8), WITH(NFU));
	MATHB(VSEQOUTSZ, RSHIFT, VSEQINSZ, NONE, SIZE(2), 0);
	MATHB(VSEQOUTSZ, RSHIFT, VSEQOUTSZ, NONE, SIZE(2), 0);
	MATHB(VSEQOUTSZ, RSHIFT, ABD, NONE, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, RSHIFT, OFIFO, NONE, SIZE(2), WITH(NFU));
	MATHB(VSEQOUTSZ, RSHIFT, ONE, NONE, SIZE(4), 0);
	MATHB(VSEQOUTSZ, RSHIFT, ZERO, NONE, SIZE(4), 0);
	MATHB(ZERO, RSHIFT, MATH0, NONE, SIZE(8), WITH(NFU));
	MATHB(ZERO, RSHIFT, MATH1, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, RSHIFT, MATH2, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, RSHIFT, MATH3, NONE, SIZE(1), WITH(NFU | STL));
	MATHB(ZERO, RSHIFT, IMM(393615378), NONE, SIZE(2), 0);
	MATHB(ZERO, RSHIFT, DPOVRD, NONE, SIZE(8), WITH(NFU | STL));
	MATHB(ZERO, RSHIFT, VSEQINSZ, NONE, SIZE(2), WITH(NFU));
	MATHB(ZERO, RSHIFT, VSEQOUTSZ, NONE, SIZE(2), 0);
	MATHB(ZERO, RSHIFT, ABD, NONE, SIZE(2), WITH(STL));
	MATHB(ZERO, RSHIFT, OFIFO, NONE, SIZE(8), WITH(STL));
	MATHB(ZERO, RSHIFT, ONE, NONE, SIZE(1), WITH(NFU));
	MATHB(ZERO, RSHIFT, ZERO, NONE, SIZE(1), WITH(NFU));
	MATHB(ONE, RSHIFT, MATH0, NONE, SIZE(1), WITH(STL));
	MATHB(ONE, RSHIFT, MATH1, NONE, SIZE(4), 0);
	MATHB(ONE, RSHIFT, MATH2, NONE, SIZE(2), 0);
	MATHB(ONE, RSHIFT, MATH3, NONE, SIZE(8), 0);
	MATHB(ONE, RSHIFT, IMM(393615378), NONE, SIZE(1), 0);
	MATHB(ONE, RSHIFT, DPOVRD, NONE, SIZE(8), WITH(NFU));
	MATHB(ONE, RSHIFT, VSEQINSZ, NONE, SIZE(4), WITH(NFU | STL));
	MATHB(ONE, RSHIFT, VSEQOUTSZ, NONE, SIZE(2), 0);
	MATHB(ONE, RSHIFT, ABD, NONE, SIZE(2), 0);
	MATHB(ONE, RSHIFT, OFIFO, NONE, SIZE(2), WITH(STL));
	MATHB(ONE, RSHIFT, ONE, NONE, SIZE(1), 0);
	MATHB(ONE, RSHIFT, ZERO, NONE, SIZE(4), 0);
	/* ZBYTE Operation */
	MATHU(MATH0, ZBYTE, MATH0, SIZE(8), 0);
	MATHU(MATH1, ZBYTE, MATH0, SIZE(8), 0);
	MATHU(MATH2, ZBYTE, MATH0, SIZE(8), 0);
	MATHU(MATH3, ZBYTE, MATH0, SIZE(8), 0);
	MATHU(MATH0, ZBYTE, MATH1, SIZE(8), 0);
	MATHU(MATH1, ZBYTE, MATH1, SIZE(8), 0);
	MATHU(MATH2, ZBYTE, MATH1, SIZE(8), 0);
	MATHU(MATH3, ZBYTE, MATH1, SIZE(8), 0);
	MATHU(MATH0, ZBYTE, MATH2, SIZE(8), 0);
	MATHU(MATH1, ZBYTE, MATH2, SIZE(8), 0);
	MATHU(MATH2, ZBYTE, MATH2, SIZE(8), 0);
	MATHU(MATH3, ZBYTE, MATH2, SIZE(8), 0);
	MATHU(MATH0, ZBYTE, MATH3, SIZE(8), 0);
	MATHU(MATH1, ZBYTE, MATH3, SIZE(8), 0);
	MATHU(MATH2, ZBYTE, MATH3, SIZE(8), 0);
	MATHU(MATH3, ZBYTE, MATH3, SIZE(8), 0);
	MATHU(MATH0, ZBYTE, DPOVRD, SIZE(8), 0);
	MATHU(MATH1, ZBYTE, DPOVRD, SIZE(8), 0);
	MATHU(MATH2, ZBYTE, DPOVRD, SIZE(8), 0);
	MATHU(MATH3, ZBYTE, DPOVRD, SIZE(8), 0);
	MATHU(MATH0, ZBYTE, SEQINSZ, SIZE(8), 0);
	MATHU(MATH1, ZBYTE, SEQINSZ, SIZE(8), 0);
	MATHU(MATH2, ZBYTE, SEQINSZ, SIZE(8), 0);
	MATHU(MATH3, ZBYTE, SEQINSZ, SIZE(8), 0);
	MATHU(MATH0, ZBYTE, SEQOUTSZ, SIZE(8), 0);
	MATHU(MATH1, ZBYTE, SEQOUTSZ, SIZE(8), 0);
	MATHU(MATH2, ZBYTE, SEQOUTSZ, SIZE(8), 0);
	MATHU(MATH3, ZBYTE, SEQOUTSZ, SIZE(8), 0);
	MATHU(MATH0, ZBYTE, VSEQINSZ, SIZE(8), 0);
	MATHU(MATH1, ZBYTE, VSEQINSZ, SIZE(8), 0);
	MATHU(MATH2, ZBYTE, VSEQINSZ, SIZE(8), 0);
	MATHU(MATH3, ZBYTE, VSEQINSZ, SIZE(8), 0);
	MATHU(MATH0, ZBYTE, VSEQOUTSZ, SIZE(8), 0);
	MATHU(MATH1, ZBYTE, VSEQOUTSZ, SIZE(8), 0);
	MATHU(MATH2, ZBYTE, VSEQOUTSZ, SIZE(8), 0);
	MATHU(MATH3, ZBYTE, VSEQOUTSZ, SIZE(8), 0);
	MATHU(MATH0, ZBYTE, NONE, SIZE(8), 0);
	MATHU(MATH1, ZBYTE, NONE, SIZE(8), 0);
	MATHU(MATH2, ZBYTE, NONE, SIZE(8), 0);
	MATHU(MATH3, ZBYTE, NONE, SIZE(8), 0);
	/* BSWAP Operation */
	MATHU(MATH0, BSWAP, MATH0, SIZE(8), 0);
	MATHU(MATH1, BSWAP, MATH0, SIZE(8), 0);
	MATHU(MATH2, BSWAP, MATH0, SIZE(8), 0);
	MATHU(MATH3, BSWAP, MATH0, SIZE(8), 0);
	MATHU(MATH0, BSWAP, MATH1, SIZE(8), 0);
	MATHU(MATH1, BSWAP, MATH1, SIZE(8), 0);
	MATHU(MATH2, BSWAP, MATH1, SIZE(8), 0);
	MATHU(MATH3, BSWAP, MATH1, SIZE(8), 0);
	MATHU(MATH0, BSWAP, MATH2, SIZE(8), 0);
	MATHU(MATH1, BSWAP, MATH2, SIZE(8), 0);
	MATHU(MATH2, BSWAP, MATH2, SIZE(8), 0);
	MATHU(MATH3, BSWAP, MATH2, SIZE(8), 0);
	MATHU(MATH0, BSWAP, MATH3, SIZE(8), 0);
	MATHU(MATH1, BSWAP, MATH3, SIZE(8), 0);
	MATHU(MATH2, BSWAP, MATH3, SIZE(8), 0);
	MATHU(MATH3, BSWAP, MATH3, SIZE(8), 0);
	MATHU(MATH0, BSWAP, DPOVRD, SIZE(8), 0);
	MATHU(MATH1, BSWAP, DPOVRD, SIZE(8), 0);
	MATHU(MATH2, BSWAP, DPOVRD, SIZE(8), 0);
	MATHU(MATH3, BSWAP, DPOVRD, SIZE(8), 0);
	MATHU(MATH0, BSWAP, SEQINSZ, SIZE(8), 0);
	MATHU(MATH1, BSWAP, SEQINSZ, SIZE(8), 0);
	MATHU(MATH2, BSWAP, SEQINSZ, SIZE(8), 0);
	MATHU(MATH3, BSWAP, SEQINSZ, SIZE(8), 0);
	MATHU(MATH0, BSWAP, SEQOUTSZ, SIZE(8), 0);
	MATHU(MATH1, BSWAP, SEQOUTSZ, SIZE(8), 0);
	MATHU(MATH2, BSWAP, SEQOUTSZ, SIZE(8), 0);
	MATHU(MATH3, BSWAP, SEQOUTSZ, SIZE(8), 0);
	MATHU(MATH0, BSWAP, VSEQINSZ, SIZE(8), 0);
	MATHU(MATH1, BSWAP, VSEQINSZ, SIZE(8), 0);
	MATHU(MATH2, BSWAP, VSEQINSZ, SIZE(8), 0);
	MATHU(MATH3, BSWAP, VSEQINSZ, SIZE(8), 0);
	MATHU(MATH0, BSWAP, VSEQOUTSZ, SIZE(8), 0);
	MATHU(MATH1, BSWAP, VSEQOUTSZ, SIZE(8), 0);
	MATHU(MATH2, BSWAP, VSEQOUTSZ, SIZE(8), 0);
	MATHU(MATH3, BSWAP, VSEQOUTSZ, SIZE(8), 0);
	MATHU(MATH0, BSWAP, NONE, SIZE(8), 0);
	MATHU(MATH1, BSWAP, NONE, SIZE(8), 0);
	MATHU(MATH2, BSWAP, NONE, SIZE(8), 0);
	MATHU(MATH3, BSWAP, NONE, SIZE(8), 0);
	/* SHLD Operation */
	MATHB(NONE, SHLD, MATH0, MATH0, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH1, MATH0, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH2, MATH0, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH3, MATH0, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH0, MATH1, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH1, MATH1, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH2, MATH1, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH3, MATH1, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH0, MATH2, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH1, MATH2, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH2, MATH2, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH3, MATH2, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH0, MATH3, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH1, MATH3, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH2, MATH3, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH3, MATH3, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH0, DPOVRD, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH1, DPOVRD, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH2, DPOVRD, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH3, DPOVRD, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH0, SEQINSZ, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH1, SEQINSZ, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH2, SEQINSZ, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH3, SEQINSZ, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH0, SEQOUTSZ, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH1, SEQOUTSZ, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH2, SEQOUTSZ, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH3, SEQOUTSZ, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH0, VSEQINSZ, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH1, VSEQINSZ, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH2, VSEQINSZ, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH3, VSEQINSZ, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH0, VSEQOUTSZ, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH1, VSEQOUTSZ, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH2, VSEQOUTSZ, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH3, VSEQOUTSZ, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH0, NONE, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH1, NONE, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH2, NONE, SIZE(8), 0);
	MATHB(NONE, SHLD, MATH3, NONE, SIZE(8), 0);
	MATHB(ZERO, ADD, JOBSRC, MATH0, SIZE(4), 0);
	MATHB(IMM(0x07), AND, JOBSRC, MATH0, SIZE(4), 0);

	size = PROGRAM_FINALIZE();
	return size;
}

uint32_t prg_buff[1000000];

int main(int argc, char **argv)
{
	int size;

	rta_set_sec_era(RTA_SEC_ERA_4);

	pr_debug("#MATH test #1\n");
	size = math_test(prg_buff);
	pr_debug("#size %d\n", size);
	print_prog(prg_buff, size);

	return 0;
}
